﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Common.FormatProviders
{
    /// <summary>
    /// Represents binary format provider.
    /// </summary>
    public interface IBinaryFormatProvider<T>
    {
        /// <summary>
        /// Imports the specified input.
        /// </summary>
        /// <param name="input">The input.</param>
        /// <returns>The document.</returns>
        T Import(byte[] input);

        /// <summary>
        /// Exports the specified document.
        /// </summary>
        /// <param name="document">The document.</param>
        /// <returns>The result byte array.</returns>
        byte[] Export(T document);
    }
}
