﻿namespace Telerik.Windows.Documents.Common.FormatProviders
{
    /// <summary>
    /// Represents interface for text base format provider.
    /// </summary>
    public interface ITextBasedFormatProvider<T>
    {
        /// <summary>
        /// Imports the specified input.
        /// </summary>
        /// <param name="input">The input.</param>
        /// <returns>The document.</returns>
        T Import(string input);

        /// <summary>
        /// Exports the specified document.
        /// </summary>
        /// <param name="document">The document.</param>
        /// <returns>The result string.</returns>
        string Export(T document);
    }
}
