﻿using Telerik.Windows.Documents.Common.Model.Data;
#if !SILVERLIGHT && !NETSTANDARD
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Parts;
using Telerik.Windows.Documents.Model.Drawing.Charts;
using Telerik.Windows.Documents.Model.Drawing.Shapes;
#endif
#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Spreadsheet.Theming;
#else
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Import
{
    internal interface IOpenXmlImportContext
    {
        DocumentTheme Theme { get; set; }

        ResourceManager Resources { get; }

        bool IsImportSuspended { get; }

        bool SupportCharts { get; }

        void BeginImport();

        void EndImport();

        IResource GetResourceByResourceKey(string resourceKey);

        void RegisterResource(string resourceKey, IResource resource);

#if !SILVERLIGHT && !NETSTANDARD
        ChartShape GetChartForChartPart(ChartPart chartPart);

        void RegisterChartPartForChart(ChartShape chartShape, ChartPart chartPart);

        FormulaChartData GetFormulaChartData(string formula);

        void RegisterSeriesGroupAwaitingAxisGroupName(ISupportAxes seriesGroup, int catAxisId, int valAxisId);

        void RegisterAxisGroup(AxisGroupName axisGroupName, int thisId, int otherId);

        void PairSeriesGroupsWithAxes();
#endif
    }
}
