using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core
{
    internal class MappedOpenXmlAttribute<T> : OpenXmlAttributeBase<T>
    {
        private readonly ValueMapper<string, T> mapper;

        public MappedOpenXmlAttribute(string name, OpenXmlNamespace ns, ValueMapper<string, T> mapper, bool isRequired = false)
            : base(name, ns, isRequired)
        {
            Guard.ThrowExceptionIfNull(mapper, "mapper");

            this.mapper = mapper;
            if (this.mapper.DefaultToValue != null)
            {
                this.DefaultValue = mapper.DefaultToValue.Value;
            }
        }

        public override string GetValueAsString()
        {
            return this.mapper.GetFromValue(this.Value);
        }

        public override void SetStringValue(IOpenXmlImportContext context, string value)
        {
            this.Value = this.mapper.GetToValue(value);
        }
    }
}