﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class AreaChartElement : ChartGroupWithAxesElementBase<AreaSeriesGroup>
    {
        private readonly OpenXmlChildElement<GroupingElement> grouping;

        public AreaChartElement(OpenXmlPartsManager partsManager) : base(partsManager)
        {
            this.grouping = this.RegisterChildElement<GroupingElement>(OpenXmlElementNames.GroupingElementName, OpenXmlUniquePoolIds.GroupingUniquePoolId);
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.AreaChartElementName;
            }
        }

        public GroupingElement GroupingElement
        {
            get
            {
                return this.grouping.Element;
            }
            set
            {
                this.grouping.Element = value;
            }
        }

        public void CopyPropertiesFrom()
        {
            this.CreateElement(this.grouping);
            this.GroupingElement.Value = this.SeriesGroup.Grouping;
        }

        public override void CopyPropertiesTo(IOpenXmlImportContext context, SeriesGroup seriesGroup)
        {
            base.CopyPropertiesTo(context, seriesGroup);

            AreaSeriesGroup areaSeriesGroup = seriesGroup as AreaSeriesGroup;

            if (this.GroupingElement != null)
            {
                areaSeriesGroup.Grouping = this.GroupingElement.Value;
                this.ReleaseElement(this.grouping);
            }
        }
    }
}
