﻿using Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class AxisPositionElement : ChartElementBase
    {
        private readonly ConvertedOpenXmlAttribute<AxisPosition> value;

        public AxisPositionElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.value = this.RegisterAttribute(new ConvertedOpenXmlAttribute<AxisPosition>("val", Converters.AxisPositionToStringConverter, isRequired: true));
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.AxisPositionElementName;
            }
        }

        public AxisPosition Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }
    }
}
