﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class BarDirectionElement : ChartElementBase
    {
        private readonly ConvertedOpenXmlAttribute<BarDirection> value;

        public BarDirectionElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.value = this.RegisterAttribute(new ConvertedOpenXmlAttribute<BarDirection>("val", Converters.BarDirectionToValueConverter, true));
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.BarDirectionElementName;
            }
        }

        public BarDirection Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }
    }
}
