﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class BarGroupingElement : ChartElementBase
    {
        private readonly ConvertedOpenXmlAttribute<SeriesGrouping> value;

        public BarGroupingElement(OpenXmlPartsManager partsManager) : base(partsManager)
        {
            this.value = this.RegisterAttribute(new ConvertedOpenXmlAttribute<SeriesGrouping>("val", Converters.BarGroupingToStringConverter, true));
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.GroupingElementName;
            }
        }

        public SeriesGrouping Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }
    }
}
