﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class ChartTextElement : TxElement
    {
        private readonly OpenXmlChildElement<RichTextElement> richElement;

        public ChartTextElement(OpenXmlPartsManager partsManager) 
            : base(partsManager)
        {
            this.richElement = this.RegisterChildElement<RichTextElement>(OpenXmlElementNames.RichTextElementName);
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.TxElementName;
            }
        }

        public RichTextElement RichTextElement
        {
            get
            {
                return this.richElement.Element;
            }
            set
            {
                this.richElement.Element = value;
            }
        }

        protected override void CopyPropertiesFromTextTitle(TextTitle title)
        {
            this.CreateElement(this.richElement);
            this.RichTextElement.CopyPropertiesFrom(title as TextTitle);
        }

        protected override Title CreateTextChartTitle(IOpenXmlImportContext context)
        {
            Title result = null;

            if(this.RichTextElement != null)
            {
                string text = this.RichTextElement.GetPlainText();
                result = new TextTitle(text);
            }

            return result;
        }
    }
}
