﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class DataPointElement : ChartElementBase
    {
        private readonly OpenXmlChildElement<ValueElement> value;
        private readonly IntOpenXmlAttribute index;

        public DataPointElement(OpenXmlPartsManager partsManager) : base(partsManager)
        {
            this.value = this.RegisterChildElement<ValueElement>(OpenXmlElementNames.ValueElementName, OpenXmlUniquePoolIds.ValueElementUniquePoolId);
            this.index = this.RegisterAttribute(new IntOpenXmlAttribute("idx", true));
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.DataPointElementName;
            }
        }

        public ValueElement ValueElement
        {
            get
            {
                return this.value.Element;
            }
            set
            {
                this.value.Element = value;
            }
        }

        public int Index
        {
            get
            {
                return this.index.Value;
            }
            set
            {
                this.index.Value = value;
            }
        }

        public void CopyPropertiesFrom(string value)
        {
            this.CreateElement(this.value);
            this.ValueElement.InnerText = value;
        }
    }
}
