﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class DoughnutChartElement : ChartGroupElementBase<DoughnutSeriesGroup>
    {
        private readonly OpenXmlChildElement<HoleSizeElement> holeSize;

        public DoughnutChartElement(OpenXmlPartsManager partsManager) : base(partsManager)
        {
            this.holeSize = this.RegisterChildElement<HoleSizeElement>(OpenXmlElementNames.HoleSizeElementName);
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.DoughnutChartElementName;
            }
        }

        public HoleSizeElement HoleSizeElement
        {
            get
            {
                return this.holeSize.Element;
            }
            set
            {
                this.holeSize.Element = value;
            }
        }

        public void CopyPropertiesFrom()
        {
            this.CreateElement(this.holeSize);
            this.HoleSizeElement.Value = this.SeriesGroup.HoleSizePercent;
        }

        public override void CopyPropertiesTo(IOpenXmlImportContext context, SeriesGroup seriesGroup)
        {
            base.CopyPropertiesTo(context, seriesGroup);

            DoughnutSeriesGroup doughnutSeriesGroup = seriesGroup as DoughnutSeriesGroup;

            if (this.HoleSizeElement != null)
            {
                doughnutSeriesGroup.HoleSizePercent = this.HoleSizeElement.Value;
                this.ReleaseElement(this.holeSize);
            }
        }
    }
}
