﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class LegendPositionElement : ChartElementBase
    {
        private readonly ConvertedOpenXmlAttribute<LegendPosition> value;

        public LegendPositionElement(OpenXmlPartsManager partsManager) : base(partsManager)
        {
            this.value = this.RegisterAttribute(new ConvertedOpenXmlAttribute<LegendPosition>("val", Converters.LegendPositionToStringConverter, true));
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.LegendPositionElementName;
            }
        }

        public LegendPosition Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }
    }
}
