﻿using System.Collections.Generic;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Export;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal abstract class LiteralsDataElementBase : ChartElementBase
    {
        public LiteralsDataElementBase(OpenXmlPartsManager partsManager) : base(partsManager)
        {
        }

        protected override IEnumerable<OpenXmlElementBase> EnumerateChildElements(IOpenXmlExportContext context)
        {
            int pointIndex = 0;

            foreach (string literal in this.EnumerateDataAsString())
            {
                DataPointElement dataPointElement = this.CreateElement<DataPointElement>(OpenXmlElementNames.DataPointElementName);
                dataPointElement.CopyPropertiesFrom(literal);
                dataPointElement.Index = pointIndex;
                pointIndex++;

                yield return dataPointElement;
            }
        }

        protected abstract IEnumerable<string> EnumerateDataAsString();
    }
}
