﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Export;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Common;
using Telerik.Windows.Documents.Model.Drawing.Shapes;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class MajorGridlinesElement : ChartElementBase
    {
        private readonly OpenXmlChildElement<ShapePropertiesElement> shapeProperties;

        public MajorGridlinesElement(OpenXmlPartsManager partsManager) : base(partsManager)
        {
            this.shapeProperties = this.RegisterChildElement<ShapePropertiesElement>(OpenXmlElementNames.ShapePropertiesElementName, OpenXmlUniquePoolIds.ChartShapePropertiesUniquePoolId);
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.MajorGridlinesElementName;
            }
        }

        public ShapePropertiesElement ShapePropertiesElement
        {
            get
            {
                return this.shapeProperties.Element;
            }
            set
            {
                this.shapeProperties.Element = value;
            }
        }

        public void CopyPropertiesFrom(IOpenXmlExportContext context, ChartLine majorGridlines)
        {
            this.CreateElement(this.shapeProperties);
            this.ShapePropertiesElement.CopyPropertiesFrom(context, majorGridlines);
        }

        public void CopyPropertiesTo(IOpenXmlImportContext context, ChartLine majorGridlines)
        {
            if(this.ShapePropertiesElement != null)
            {
                this.ShapePropertiesElement.CopyPropertiesTo(context, majorGridlines);
                this.ReleaseElement(this.shapeProperties);
            }
        }
    }
}
