﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal abstract class ReferenceDataElementBase : ChartElementBase
    {
        private readonly OpenXmlChildElement<FormulaElement> formula;

        public ReferenceDataElementBase(OpenXmlPartsManager partsManager) : base(partsManager)
        {
            this.formula = this.RegisterChildElement<FormulaElement>(OpenXmlElementNames.FormulaElementName, OpenXmlUniquePoolIds.FormulaElementUniquePoolId);
        }

        public FormulaElement FormulaElement
        {
            get
            {
                return this.formula.Element;
            }
            set
            {
                this.formula.Element = value;
            }
        }

        public void CopyPropertiesFrom(FormulaChartData formulaChartData)
        {
            this.CreateElement(this.formula);
            this.FormulaElement.InnerText = formulaChartData.Formula;
        }

        public FormulaChartData CreateFormulaChartData(IOpenXmlImportContext context)
        {
            string formula = this.FormulaElement.InnerText;

            return context.GetFormulaChartData(formula);
        }
    }
}
