﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class ScatterChartElement : ChartGroupWithAxesElementBase<ScatterSeriesGroup>
    {
        private readonly OpenXmlChildElement<ScatterStyleElement> scatterStyle;

        public ScatterChartElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.scatterStyle = this.RegisterChildElement<ScatterStyleElement>(OpenXmlElementNames.ScatterStyleElementName);
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.ScatterChartElementName;
            }
        }

        public ScatterStyleElement ScatterStyleElement
        {
            get
            {
                return this.scatterStyle.Element;
            }
        }

        public void CopyPropertiesFrom(ScatterSeriesGroup seriesGroup)
        {
            this.SeriesGroup = seriesGroup;

            this.CreateElement(this.scatterStyle);
            this.ScatterStyleElement.Value = seriesGroup.ScatterStyle;
        }
    }
}
