﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class ScatterStyleElement : ChartElementBase
    {
        private readonly ConvertedOpenXmlAttribute<ScatterStyle> value;

        public ScatterStyleElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.value = this.RegisterAttribute(new ConvertedOpenXmlAttribute<ScatterStyle>("val", Converters.ScatterStyleToStringConverter, ScatterStyle.Marker, true));
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.ScatterStyleElementName;
            }
        }

        public ScatterStyle Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }
    }
}
