﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class SeriesTextElement : TxElement
    {
        private readonly OpenXmlChildElement<ValueElement> value;

        public SeriesTextElement(OpenXmlPartsManager partsManager) 
            : base(partsManager)
        {
            this.value = this.RegisterChildElement<ValueElement>(OpenXmlElementNames.ValueElementName, OpenXmlUniquePoolIds.ValueElementUniquePoolId);
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.TxElementName;
            }
        }

        public ValueElement ValueElement
        {
            get
            {
                return this.value.Element;
            }
            set
            {
                this.value.Element = value;
            }
        }

        protected override void CopyPropertiesFromTextTitle(TextTitle title)
        {
            this.CreateElement(this.value);
            this.ValueElement.InnerText = title.Text;
        }

        protected override Title CreateTextChartTitle(IOpenXmlImportContext context)
        {
            Title result = null;

            if(this.ValueElement != null)
            {
                result = new TextTitle(this.ValueElement.InnerText);
                this.ReleaseElement(this.value);
            }

            return result;
        }
    }
}
