﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Export;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class StringLiteralsElement : LiteralsDataElementBase
    {
        private StringChartData data;

        public StringLiteralsElement(OpenXmlPartsManager partsManager) : base(partsManager)
        {
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.StringLiteralsElementName;
            }
        }

        protected override bool ShouldExport(IOpenXmlExportContext context)
        {
            return this.data != null;
        }

        public void CopyPropertiesFrom(StringChartData stringChartData)
        {
            this.data = stringChartData;
        }

        protected override IEnumerable<string> EnumerateDataAsString()
        {
            foreach(string dataPoint in this.data.StringLiterals)
            {
                yield return dataPoint;
            }
        }

        public IChartData CreateLiteralChartData()
        {
            List<string> strings = new List<string>();

            foreach (Core.IOpenXmlChildElement childElement in this.ChildElements)
            {
                OpenXmlElementBase element = childElement.GetElement();
                if (element.ElementName == OpenXmlElementNames.DataPointElementName)
                {
                    DataPointElement dataPointElement = element as DataPointElement;
                    strings.Add(dataPointElement.ValueElement.InnerText);
                }
            }

            return new StringChartData(strings);
        }
    }
}
