﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart
{
    internal class SymbolElement : ChartElementBase
    {
        private readonly ConvertedOpenXmlAttribute<MarkerStyle> value;

        public SymbolElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.value = this.RegisterAttribute(new ConvertedOpenXmlAttribute<MarkerStyle>("val", Converters.MarkerStyleToStringConverter, MarkerStyle.Auto, true));
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.SymbolElementName;
            }
        }

        public MarkerStyle Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }
    }
}
