﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Drawing
{
    internal class OneDimentionOffsetElement : OpenXmlElementBase
    {
        private readonly string elementName;
        private readonly OpenXmlNamespace ns;

        public OneDimentionOffsetElement(OpenXmlPartsManager partsManager, string elementName, OpenXmlNamespace ns)
            : base(partsManager)
        {
            Guard.ThrowExceptionIfNullOrEmpty(elementName, "elementName");
            Guard.ThrowExceptionIfNull(ns, "ns");

            this.elementName = elementName;
            this.ns = ns;
        }

        public override string ElementName
        {
            get
            {
                return this.elementName;
            }
        }

        public override OpenXmlNamespace Namespace
        {
            get
            {
                return this.ns;
            }
        }
    }
}
