﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.ContentTypes
{
    internal class DefaultElement : ContentTypeElementBase
    {
        private readonly OpenXmlAttribute<string> extension;
        private readonly OpenXmlAttribute<string> contentType;

        public DefaultElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.extension = this.RegisterAttribute<string>("Extension", true);
            this.contentType = this.RegisterAttribute<string>("ContentType", true);
        }

        public string Extension
        {
            get
            {
                return this.extension.Value;
            }
            set
            {
                this.extension.Value = value;
            }
        }

        public string ContentType
        {
            get
            {
                return this.contentType.Value;
            }
            set
            {
                this.contentType.Value = value;
            }
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.DefaultElementName;
            }
        }
    }
}