﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.ContentTypes
{
    internal class OverrideElement : ContentTypeElementBase
    {
        private readonly OpenXmlAttribute<string> partName;
        private readonly OpenXmlAttribute<string> contentType;

        public OverrideElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.partName = this.RegisterAttribute<string>("PartName", true);
            this.contentType = this.RegisterAttribute<string>("ContentType", true);
        }

        public string PartName
        {
            get
            {
                return this.partName.Value;
            }
            set
            {
                this.partName.Value = value;
            }
        }

        public string ContentType
        {
            get
            {
                return this.contentType.Value;
            }
            set
            {
                this.contentType.Value = value;
            }
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.OverrideElementName;
            }
        }
    }
}