﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Drawing
{
    internal class BlipElement : DrawingElementBase
    {
        private readonly OpenXmlAttribute<string> relationshipId;

        public BlipElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.relationshipId = this.RegisterAttribute<string>("embed", OpenXmlNamespaces.OfficeDocumentRelationshipsNamespace, true);
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.BlipElementName;
            }
        }

        public override System.Collections.Generic.IEnumerable<OpenXmlNamespace> Namespaces
        {
            get
            {
                yield return OpenXmlNamespaces.OfficeDocumentRelationshipsNamespace;
            }
        }

        public string RelationshipId
        {
            get
            {
                return this.relationshipId.Value;
            }
            set
            {
                this.relationshipId.Value = value;
            }
        }
    }
}
