﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Export;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Model.Drawing.Shapes;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Drawing
{
    internal class GraphicElement : DrawingElementBase
    {
        private readonly OpenXmlChildElement<GraphicDataElement> graphicData;

        public GraphicElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.graphicData = this.RegisterChildElement<GraphicDataElement>(OpenXmlElementNames.GraphicDataElementName);
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.GraphicElementName;
            }
        }

        public GraphicDataElement GraphicDataElement
        {
            get
            {
                return this.graphicData.Element;
            }
        }

        public void CopyPropertiesFrom(IOpenXmlExportContext context, ShapeBase shape)
        {
            this.CreateElement(this.graphicData);
            this.GraphicDataElement.CopyPropertiesFrom(context, shape);
        }

        public ShapeBase CreateShapeAndCopyPropertiesTo(IOpenXmlImportContext context)
        {
            ShapeBase result = null;

            if (this.GraphicDataElement != null)
            {
                result = this.GraphicDataElement.CreateShapeAndCopyPropertiesTo(context);
                this.ReleaseElement(this.graphicData);
            }

            return result;
        }
    }
}
