﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Export;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Drawing
{
    internal class PictureLockingElement : DrawingElementBase
    {
        private readonly IntOpenXmlAttribute noChangeAspect;

        public PictureLockingElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.noChangeAspect = this.RegisterAttribute(new IntOpenXmlAttribute("noChangeAspect"));
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.PictureLocksElementName;
            }
        }

        protected override bool ShouldExport(IOpenXmlExportContext context)
        {
            return this.NoChangeAspect == 1;
        }

        public int NoChangeAspect
        {
            get
            {
                return this.noChangeAspect.Value;
            }
            set
            {
                this.noChangeAspect.Value = value;
            }
        }
    }
}
