﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Export;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Model.Drawing.Shapes;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Drawing
{
    internal class PresetGeometryElement : DrawingElementBase
    {
        private readonly OpenXmlAttribute<string> presetShape;

        public PresetGeometryElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.presetShape = this.RegisterAttribute<string>("prst", true);
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.PresetGeometryElementName;
            }
        }

        public string PresetShape
        {
            get
            {
                return this.presetShape.Value;
            }
            set
            {
                this.presetShape.Value = value;
            }
        }

        public void CopyPropertiesFrom(IOpenXmlExportContext context, ShapeBase shape)
        {
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(shape, "shape");

            this.PresetShape = "rect";
        }

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1822:MarkMembersAsStatic")]
        public void CopyPropertiesTo(Import.IOpenXmlImportContext context, ShapeBase shape)
        {
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(shape, "shape");
        }
    }
}
