﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Drawing
{
    internal class RichTextRunElement : DrawingElementBase
    {
        private readonly OpenXmlChildElement<TextElement> text;

        public RichTextRunElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.text = this.RegisterChildElement<TextElement>(OpenXmlElementNames.TextElementName, OpenXmlUniquePoolIds.TextElementUniquePoolId);
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.RichTextRunElementName;
            }
        }

        public TextElement TextElement
        {
            get
            {
                return this.text.Element;
            }
            set
            {
                this.text.Element = value;
            }
        }

        public void CopyPropertiesFrom(string text)
        {
            this.CreateElement(this.text);
            this.TextElement.InnerText = text;
        }

        public string GetPlainText()
        {
            string result = string.Empty;

            if (this.TextElement != null)
            {
                result = this.TextElement.InnerText;
                this.ReleaseElement(this.text);
            }

            return result;
        }
    }
}
