﻿using System.Collections.Generic;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Export;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Theme
{
    internal class EffectStyleElement : ThemeElementBase
    {
        public EffectStyleElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.EffectStyleElementName;
            }
        }

        public override OpenXmlNamespace Namespace
        {
            get
            {
                return OpenXmlNamespaces.DrawingMLNamespace;
            }
        }

        protected override IEnumerable<OpenXmlElementBase> EnumerateChildElements(IOpenXmlExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            EffectContainerElement effectContainerElement = this.CreateElement<EffectContainerElement>(OpenXmlElementNames.EffectContainerElementName);

            yield return effectContainerElement;
        }
    }
}
