﻿using System.Collections.Generic;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Export;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Theme
{
    internal class EffectStyleListElement : ThemeElementBase
    {
        public EffectStyleListElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.EffectStyleListElementName;
            }
        }

        public override OpenXmlNamespace Namespace
        {
            get
            {
                return OpenXmlNamespaces.DrawingMLNamespace;
            }
        }

        protected override IEnumerable<OpenXmlElementBase> EnumerateChildElements(IOpenXmlExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            for (int i = 0; i < 3; i++)
            {
                EffectStyleElement effectStyleElement = this.CreateElement<EffectStyleElement>(OpenXmlElementNames.EffectStyleElementName);

                yield return effectStyleElement;
            }
        }
    }
}
