﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Spreadsheet.Theming;
#else
using Telerik.Documents.Common.Model;
#endif
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Theme
{
    internal abstract class FontElementBase : ThemeElementBase
    {
        private readonly OpenXmlAttribute<string> typeface;

        public FontElementBase(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.typeface = this.RegisterAttribute<string>("typeface", false);
        }

        public override OpenXmlNamespace Namespace
        {
            get
            {
                return OpenXmlNamespaces.DrawingMLNamespace;
            }
        }

        public string Typeface
        {
            get
            {
                return this.typeface.Value;
            }
            set
            {
                this.typeface.Value = value;
            }
        }

        public void SetFontName(ThemeFont themeFont)
        {
            this.Typeface = themeFont == null ? string.Empty : themeFont.FontFamily.Source;
        }

        public string GetFontName(IOpenXmlImportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            if (this.typeface.HasValue)
            {
                return this.Typeface;
            }

            return null;
        }
    }
}
