﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Theme
{
    internal class LuminanceModulationElement : ThemeElementBase
    {
        private readonly IntOpenXmlAttribute value;

        public LuminanceModulationElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.value = this.RegisterAttribute(new IntOpenXmlAttribute("val"));
        }

        public override OpenXmlNamespace Namespace
        {
            get
            {
                return OpenXmlNamespaces.DrawingMLNamespace;
            }
        }

        public int Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.LuminanceModulationElementName;
            }
        }
    }
}
