﻿#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Theme
{
    internal class RgbHexColorModelElement : ColorChoiceElementBase
    {
        private readonly ConvertedOpenXmlAttribute<Color> valueAttribute;

        public RgbHexColorModelElement(OpenXmlPartsManager partsManager)
            : base(partsManager)
        {
            this.valueAttribute = this.RegisterAttribute(
                new ConvertedOpenXmlAttribute<Color>("val", Converters.HexBinary3Converter, true));
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.RgbHexColorModelElementName;
            }
        }

        public void SetColor(Color color)
        {
            this.valueAttribute.Value = color;
        }

        public Color GetColor()
        {
            return this.valueAttribute.Value;
        }
    }
}
