﻿using System;
#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Theme
{
    internal class SystemColorElement : ColorChoiceElementBase
    {
        private readonly OpenXmlAttribute<string> value;
        private readonly ConvertedOpenXmlAttribute<Color> lastColorAttribute;

        public SystemColorElement(OpenXmlPartsManager partsMaanger)
            : base(partsMaanger)
        {
            this.value = this.RegisterAttribute<string>("val", true);
            this.lastColorAttribute = this.RegisterAttribute(
                new ConvertedOpenXmlAttribute<Color>("lastClr", Converters.HexBinary3Converter, false));
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.SystemColorElementName;
            }
        }


        public string Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }

        public Color GetColor(IOpenXmlImportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            if (this.lastColorAttribute.HasValue)
            {
                return this.lastColorAttribute.Value;
            }

            throw new ArgumentException("Cannot extract system color.");
        }
    }
}
