﻿namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model
{
    internal static class OpenXmlElementNames
    {
        public const string UnderlineElementName = "u";
        public const string DefaultElementName = "Default";
        public const string OverrideElementName = "Override";
        public const string TypesElementName = "Types";
        public const string RelationshipElementName = "Relationship";
        public const string RelationshipsElementName = "Relationships";
        public const string Accent1ElementName = "accent1";
        public const string Accent2ElementName = "accent2";
        public const string Accent3ElementName = "accent3";
        public const string Accent4ElementName = "accent4";
        public const string Accent5ElementName = "accent5";
        public const string Accent6ElementName = "accent6";
        public const string Dark1ElementName = "dk1";
        public const string Dark2ElementName = "dk2";
        public const string FollowedHyperlinkElementName = "folHlink";
        public const string HlinkElementName = "hlink";
        public const string Light1ElementName = "lt1";
        public const string Light2ElementName = "lt2";
        public const string FontSchemeElementName = "fontScheme";
        public const string MajorFontElementName = "majorFont";
        public const string MinorFontElementName = "minorFont";
        public const string LatinFontElementName = "latin";
        public const string EastAsianFontElementName = "ea";
        public const string ComplexScriptFontElementName = "cs";
        public const string FormatSchemeElementName = "fmtScheme";
        public const string BackgroundFillStyleListElementName = "bgFillStyleLst";
        public const string FillStyleListElementName = "fillStyleLst";
        public const string NoFillElementName = "noFill";
        public const string EffectStyleListElementName = "effectStyleLst";
        public const string EffectStyleElementName = "effectStyle";
        public const string EffectContainerElementName = "effectLst";
        public const string LineStyleListElementName = "lnStyleLst";
        public const string OutlineElementName = "ln";
        public const string SystemColorElementName = "sysClr";
        public const string ColorSchemeElementName = "clrScheme";
        public const string RgbHexColorModelElementName = "srgbClr";
        public const string ThemeElementName = "theme";
        public const string ThemeElementsElementName = "themeElements";
        public const string PictureElementName = "pic";
        public const string NonVisualPicturePropertiesElementName = "nvPicPr";
        public const string NonVisualDrawingPropertiesElementName = "cNvPr";
        public const string NonVisualPictureDrawingPropertiesElementName = "cNvPicPr";
        public const string GraphicFrame = "graphicFrame";
        public const string NonVisualGraphicFramePropertiesElementName = "nvGraphicFramePr";
        public const string NonVisualGraphicFrameDrawingPropertiesElementName = "cNvGraphicFramePr";
        public const string PictureLocksElementName = "picLocks";
        public const string PictureFillElementName = "blipFill";
        public const string BlipElementName = "blip";
        public const string FutureFeatureDataStorageAreaElementName = "extLst";
        public const string ExtentsElementName = "ext";
        public const string OffsetElementName = "off";
        public const string StretchElementName = "stretch";
        public const string FillRectElementName = "fillRect";
        public const string ShapePropertiesElementName = "spPr";
        public const string MarkerElementName = "marker";
        public const string TransformElementName = "xfrm";
        public const string PresetGeometryElementName = "prstGeom";
        public const string GraphicElementName = "graphic";
        public const string GraphicDataElementName = "graphicData";
        public const string BodyPropertiesElementName = "bodyPr";
        public const string ParagraphElementName = "p";
        public const string RichTextRunElementName = "r";
        public const string TextElementName = "t";
        public const string SolidFillElementName = "solidFill";
        public const string SchemeColorElementName = "schemeClr";
        public const string LuminanceModulationElementName = "lumMod";
        public const string LuminanceOffsetElementName = "lumOff";
        public const string TintElementName = "tint";

#if !SILVERLIGHT && !NETSTANDARD
        //Chart
        public const string ChartSpaceElmentName = "chartSpace";
        public const string ChartElementName = "chart";
        public const string ChartReferenceElementName = "chart";
        public const string PlotAreaElementName = "plotArea";
        public const string BarChartElementName = "barChart";
        public const string PieChartElementName = "pieChart";
        public const string DoughnutChartElementName = "doughnutChart";
        public const string LineChartElementName = "lineChart";
        public const string AreaChartElementName = "areaChart";
        public const string BarDirectionElementName = "barDir";
        public const string AxisIdElementName = "axId";
        public const string SeriesElementName = "ser";
        public const string SeriesValuesElementName = "val";
        public const string SeriesXValuesElementName = "xVal";
        public const string SeriesYValuesElementName = "yVal";
        public const string SeriesBubbleSizeElementName = "bubbleSize";
        public const string SmoothElementName = "smooth";
        public const string SeriesCategoriesElementName = "cat";
        public const string StringReferenceElementName = "strRef";
        public const string NumberReferenceElementName = "numRef";
        public const string StringLiteralsElementName = "strLit";
        public const string NumberLiteralsElementName = "numLit";
        public const string SeriesIndexElementName = "idx";
        public const string SeriesOrderElementName = "order";
        public const string DataPointElementName = "pt";
        public const string ValueElementName = "v";
        public const string CategoryAxisElementName = "catAx";
        public const string ValueAxisElementName = "valAx";
        public const string DateAxisElementName = "dateAx";
        public const string ScalingElementName = "scaling";
        public const string AxisPositionElementName = "axPos";
        public const string CrossesAxisElementName = "crossAx";
        public const string DeleteElementName = "delete";
        public const string GroupingElementName = "grouping";
        public const string OverlapElementName = "overlap";
        public const string RoundedCornersElementName = "roundedCorners";
        public const string TxElementName = "tx";
        public const string TitleElementName = "title";
        public const string RichTextElementName = "rich";
        public const string LegendElementName = "legend";
        public const string LegendPositionElementName = "legendPos";
        public const string HoleSizeElementName = "holeSize";
        public const string FormulaElementName = "f";
        public const string NumberFormatElementName = "numFmt";
        public const string OverlayElementName = "overlay";
        public const string MinAxisValueElementName = "min";
        public const string MaxAxisValueElementName = "max";
        public const string MajorGridlinesElementName = "majorGridlines";
        public const string ScatterChartElementName = "scatterChart";
        public const string BubbleChartElementName = "bubbleChart";
        public const string SymbolElementName = "symbol";
        public const string SizeElementName = "size";
        public const string ScatterStyleElementName = "scatterStyle";
#endif
    }
}
