﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Chart;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Parts
{
    internal class ChartPart : OpenXmlPartBase
    {
        private readonly ChartSpaceElement chartSpaceElement;

        public ChartPart(OpenXmlPartsManager partsManager, string name)
            : base(partsManager, name)
        {
            this.chartSpaceElement = new ChartSpaceElement(this.PartsManager, this);
        }

        public override string ContentType
        {
            get
            {
                return OpenXmlContentTypeNames.ChartContentType;
            }
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level7;
            }
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return this.chartSpaceElement;
            }
        }

        public override void Import(IOpenXmlReader reader, IOpenXmlImportContext context)
        {
            if (context.SupportCharts)
            {
                base.Import(reader, context);
            }
        }
    }
}
