﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Theme;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Parts
{
    internal class ThemePart : OpenXmlPartBase
    {
        private readonly ThemeElement theme;

        public ThemePart(OpenXmlPartsManager partsManager, string partName)
            : base(partsManager, partName)
        {
            this.theme = new ThemeElement(this.PartsManager, this);
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level3;
            }
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return this.theme;
            }
        }

        public override string ContentType
        {
            get
            {
                return OpenXmlContentTypeNames.ThemeContentType;
            }
        }
    }
}
