﻿using System;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Model.Types
{
    internal class AxisPositionToStringConverter : IStringConverter<AxisPosition>
    {
        public AxisPosition ConvertFromString(string value)
        {
            switch(value)
            {
                case "b":
                    return AxisPosition.Bottom;
                case "t":
                    return AxisPosition.Top;
                case "r":
                    return AxisPosition.Right;
                case "l":
                    return AxisPosition.Left;
                default:
                    throw new NotSupportedException();
            }
        }

        public string ConvertToString(AxisPosition value)
        {
            switch (value)
            {
                case AxisPosition.Bottom:
                    return "b";
                case AxisPosition.Top:
                    return "t";
                case AxisPosition.Right:
                    return "r";
                case AxisPosition.Left:
                    return "l";
                default:
                    throw new NotSupportedException();
            }
        }
    }
}
