﻿using System;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Model.Types
{
    internal class BarDirectionToStringConverter : IStringConverter<BarDirection>
    {
        public BarDirection ConvertFromString(string value)
        {
            switch (value)
            {
                case "col":
                    return BarDirection.Column;
                case "bar":
                    return BarDirection.Bar;
                default:
                    throw new NotSupportedException("This type of bar direction is not supported.");
            }
        }

        public string ConvertToString(BarDirection value)
        {
            switch (value)
            {
                case BarDirection.Column:
                    return "col";
                case BarDirection.Bar:
                    return "bar";
                default:
                    throw new NotSupportedException("This type of bar direction is not supported.");
            }
        }
    }
}
