﻿using System;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Model.Types
{
    internal class BarGroupingToStringConverter : IStringConverter<SeriesGrouping>
    {
        public SeriesGrouping ConvertFromString(string value)
        {
            switch (value)
            {
                case "standard":
                case "clustered":
                    return SeriesGrouping.Standard;
                case "stacked":
                    return SeriesGrouping.Stacked;
                case "percentStacked":
                    return SeriesGrouping.PercentStacked;
                default:
                    throw new NotSupportedException();
            }
        }

        public string ConvertToString(SeriesGrouping value)
        {
            switch (value)
            {
                case SeriesGrouping.Standard:
                    return "clustered";
                case SeriesGrouping.Stacked:
                    return "stacked";
                case SeriesGrouping.PercentStacked:
                    return "percentStacked";
                default:
                    throw new NotSupportedException();
            }
        }
    }
}
