﻿using System;
using System.Globalization;
using Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Utilities;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types
{
    internal class DefaultConverter<T> : IStringConverter<T>
    {
        T IStringConverter<T>.ConvertFromString(string value)
        {
            return (T)Convert.ChangeType(value, typeof(T), CultureInfo.InvariantCulture);
        }

        public string ConvertToString(T value)
        {
            if (object.ReferenceEquals(value, null))
            {
                return string.Empty;
            }

            string result = (string)Convert.ChangeType(value, typeof(string), CultureInfo.InvariantCulture);
            return IllegalXmlCharHelper.RemoveInvalidCharacters(result);
        }
    }
}
