#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Media;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types
{
    internal class HexBinary3ColorConverter : IStringConverter<Color>
    {
        public Color ConvertFromString(string hexString)
        {
            Color result = ColorsHelper.HexStringToColor(hexString);
            return result;
        }

        public string ConvertToString(Color color)
        {
            if (color.A == 255)
            {
                return string.Format("{0:X2}{1:X2}{2:X2}", color.R, color.G, color.B);
            }
            else
            {
                return string.Format("{0:X2}{1:X2}{2:X2}{3:X2}", color.A, color.R, color.G, color.B);
            }
        }
    }
}