﻿using System;
using System.Globalization;

namespace Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types
{
    internal class HexToTintConverter : IStringConverter<double>
    {
        public double ConvertFromString(string str)
        {
            byte byteValue = byte.Parse(str.Substring(0, 2), NumberStyles.HexNumber);

            double result = 1 - (byteValue / 255.0);
            result = Math.Round(result, 2);

            return result;
        }

        public string ConvertToString(double val)
        {
            byte byteValue = (byte)Math.Round((1 - val) * 255.0);

            return string.Format("{0:X2}", byteValue);
        }
    }
}
