﻿using System.Diagnostics;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Globalization;

namespace Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Model.Types
{
    internal class IntConverter : IStringConverter<int>
    {
        private static readonly OpenXmlCultureInfo cultureInfo = new OpenXmlCultureInfo(System.Globalization.CultureInfo.InvariantCulture);

        public int ConvertFromString(string value)
        {
            int result;
            if (int.TryParse(value, out result))
            {
                return result;
            }

            Debug.Assert(false, "The value is not in expected type.");

            double doubleResult;
            if (cultureInfo.TryParseDouble(value, out doubleResult))
            {
                return (int)doubleResult;
            }

            return default(int);
        }

        public string ConvertToString(int value)
        {
            return value.ToString();
        }
    }
}
