﻿using System;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Model.Types
{
    internal class LegendPositionToStringConverter : IStringConverter<LegendPosition>
    {
        public LegendPosition ConvertFromString(string value)
        {
            switch (value)
            {
                case "b":
                    return LegendPosition.Bottom;
                case "t":
                    return LegendPosition.Top;
                case "r":
                    return LegendPosition.Right;
                case "l":
                    return LegendPosition.Left;
                default:
                    throw new NotSupportedException();
            }
        }

        public string ConvertToString(LegendPosition value)
        {
            switch (value)
            {
                case LegendPosition.Bottom:
                    return "b";
                case LegendPosition.Top:
                    return "t";
                case LegendPosition.Right:
                    return "r";
                case LegendPosition.Left:
                    return "l";
                default:
                    throw new NotSupportedException();
            }
        }
    }
}
