﻿using System.Globalization;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Media;

namespace Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Model.Types
{
    internal class TwipToDipConverter : IStringConverter<double>
    {
        public double ConvertFromString(string value)
        {
            int twips;
            if (int.TryParse(value, NumberStyles.AllowLeadingSign, CultureInfo.InvariantCulture, out twips))
            {
                return Unit.TwipToDip(twips);
            }

            return 0;
        }

        public string ConvertToString(double value)
        {
            return Unit.DipToTwipI(value).ToString(CultureInfo.InvariantCulture);
        }
    }
}
