﻿using System.Text;

namespace Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Utilities
{
    internal static class IllegalXmlCharHelper
    {
        public static string RemoveInvalidCharacters(string text)
        {
            StringBuilder builder = null;

            for (int i = 0; i < text.Length; i++)
            {
                char character = text[i];
                bool isValidXmlCharacter = (0x20 <= character && character <= 0xFFFD) ||
                                           character == 9 ||
                                           character == 0xA ||
                                           character == 0xD;

                if (!isValidXmlCharacter && builder == null)
                {
                    builder = new StringBuilder(text.Substring(0, i));
                }

                if (builder != null && isValidXmlCharacter)
                {
                    builder.Append(character);
                }
            }

            if (builder == null)
            {
                return text;
            }
            else
            {
                return builder.ToString();
            }
        }
    }
}
