﻿using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Core
{
    /// <summary>
    /// Provides the base class from which the classes that represent named objects are derived
    /// </summary>
    public abstract class NamedObjectBase : INamedObject
    {
        private readonly string name;

        /// <summary>
        /// Initializes a new instance of the <see cref="NamedObjectBase" /> class.
        /// </summary>
        /// <param name="name">The name.</param>
        protected NamedObjectBase(string name)
        {
            Guard.ThrowExceptionIfNullOrEmpty(name, "name");

            this.name = name;
        }

        /// <summary>
        /// Gets the name value.
        /// </summary>
        /// <value>The name value.</value>
        public string Name
        {
            get
            {
                return this.name;
            }
        }
    }
}