﻿namespace Telerik.Windows.Documents.Model.Drawing.Charts
{
    /// <summary>
    /// Represents the possible types of chart. 
    /// </summary>
    public enum ChartType
    {
        /// <summary>
        /// Denotes the bar type of chart.
        /// </summary>
        Bar,

        /// <summary>
        /// Denotes the column type of chart.
        /// </summary>
        Column,

        /// <summary>
        /// Denotes the pie type of chart.
        /// </summary>
        Pie,

        /// <summary>
        /// Denotes the line type of chart.
        /// </summary>
        Line,

        /// <summary>
        /// Denotes the area type of chart.
        /// </summary>
        Area,

        /// <summary>
        /// Denotes the doughnut type of chart.
        /// </summary>
        Doughnut,

        /// <summary>
        /// Denotes the scatter type of chart.
        /// </summary>
        Scatter,

        /// <summary>
        /// Denotes the bubble type of chart.
        /// </summary>
        Bubble
    }
}