﻿using System;
using System.Collections.Generic;

namespace Telerik.Windows.Documents.Model.Drawing.Charts
{
    internal static class ChartTypeToAxesTypeMapper
    {
        private static readonly Dictionary<ChartType, AxesType> valuePairs = new Dictionary<ChartType, AxesType>();

        static ChartTypeToAxesTypeMapper()
        {
            valuePairs.Add(ChartType.Area, AxesType.CategoriesValues);
            valuePairs.Add(ChartType.Bar, AxesType.CategoriesValues);
            valuePairs.Add(ChartType.Column, AxesType.CategoriesValues);
            valuePairs.Add(ChartType.Doughnut, AxesType.CategoriesValues);
            valuePairs.Add(ChartType.Line, AxesType.CategoriesValues);
            valuePairs.Add(ChartType.Pie, AxesType.CategoriesValues);
            valuePairs.Add(ChartType.Scatter, AxesType.XValuesYValues);
            valuePairs.Add(ChartType.Bubble, AxesType.XValuesYValues);

#if DEBUG
            if (valuePairs.Keys.Count != Enum.GetValues(typeof(ChartType)).Length)
            {
                throw new NotImplementedException();
            }
#endif
        }

        internal static AxesType GetAxesType(ChartType seriesType)
        {
            return valuePairs[seriesType];
        }
    }
}
