﻿using System;

namespace Telerik.Windows.Documents.Model.Drawing.Charts
{
    /// <summary>
    /// Represents teh legend of the chart.
    /// </summary>
    public class Legend
    {
        private LegendPosition position;

        /// <summary>
        /// Initializes a new instance of the <see cref="Legend" /> class.
        /// </summary>
        public Legend()
        {
        }

        /// <summary>
        /// Gets or sets the value indicating where the legend will be positioned.
        /// </summary>
        public LegendPosition Position
        {
            get
            {
                return this.position;
            }
            set
            {
                if (this.position != value)
                {
                    this.position = value;
                    this.OnLegendChanged();
                }
            }
        }

        /// <summary>
        /// Creates a deep copy of the object.
        /// </summary>
        /// <returns>The deep copy of the object.</returns>
        public Legend Clone()
        {
            return new Legend()
            {
                Position = this.Position
            };
        }

        internal event EventHandler LegendChanged;

        internal void OnLegendChanged()
        {
            if (this.LegendChanged != null)
            {
                this.LegendChanged(this, EventArgs.Empty);
            }
        }
    }
}