﻿namespace Telerik.Windows.Documents.Model.Drawing.Charts
{
    /// <summary>
    /// Represents the possible marker styles.
    /// </summary>
    public enum MarkerStyle
    {
        /// <summary>
        /// Represents the automatic marker.
        /// </summary>
        Auto,

        /// <summary>
        /// Represents the circle marker.
        /// </summary>
        Circle,

        /// <summary>
        /// Represents the dash marker.
        /// </summary>
        Dash,

        /// <summary>
        /// Represents the diamond marker.
        /// </summary>
        Diamond,

        /// <summary>
        /// Represents the dot marker.
        /// </summary>
        Dot,

        /// <summary>
        /// Represents no marker.
        /// </summary>
        None,

        /// <summary>
        /// Represents the plus marker.
        /// </summary>
        Plus,

        /// <summary>
        /// Represents the square marker.
        /// </summary>
        Square,

        /// <summary>
        /// Represents the star marker.
        /// </summary>
        Star,

        /// <summary>
        /// Represents the triangle marker.
        /// </summary>
        Triangle,

        /// <summary>
        /// Represents the x marker.
        /// </summary>
        X,
    }
}
