﻿namespace Telerik.Windows.Documents.Model.Drawing.Charts
{
    /// <summary>
    /// Represents a series of type bubble.
    /// </summary>
    public class BubbleSeries : PointSeriesBase
    {
        private IChartData bubbleSizes;

        /// <summary>
        /// Gets the type of the series.
        /// </summary>
        public override SeriesType SeriesType
        {
            get
            {
                return SeriesType.Bubble;
            }
        }

        /// <summary>
        /// Gets or sets the data for the bubble size of the series.
        /// </summary>
        public IChartData BubbleSizes
        {
            get
            {
                return this.bubbleSizes;
            }
            set
            {
                if (this.bubbleSizes != value)
                {
                    this.bubbleSizes = value;
                    this.OnSeriesChanged();
                }
            }
        }

        internal override void CloneProperties(SeriesBase series)
        {
            base.CloneProperties(series);

            BubbleSeries bubbleSeries = (BubbleSeries)series;
            bubbleSeries.bubbleSizes = this.bubbleSizes.Clone();
        }
    }
}
