﻿namespace Telerik.Windows.Documents.Model.Drawing.Charts
{
    /// <summary>
    /// Represents the possible types of chart data.
    /// </summary>
    public enum ChartDataType
    {
        /// <summary>
        /// Represents the formula chart data type. This type of chart data holds a formula which refers to the actual data.
        /// </summary>
        Formula,

        /// <summary>
        /// Represents the numeric literals type. This type of chart data holds a series of numbers as data.
        /// </summary>
        NumericLiteral,

        /// <summary>
        /// Represents the string literals type. This type of chart data holds a series of strings as data.
        /// </summary>
        StringLiteral
    }
}