﻿using System;

namespace Telerik.Windows.Documents.Model.Drawing.Charts
{
    /// <summary>
    /// Represents a group of series of type doughnut.
    /// </summary>
    public class DoughnutSeriesGroup : PieSeriesGroup
    {
        private int holeSizePercent;

        /// <summary>
        /// Initializes a new instance of the <see cref="DoughnutSeriesGroup" /> class.
        /// </summary>
        public DoughnutSeriesGroup()
        {
        }

        /// <summary>
        /// Gets or sets the relative size of the hole of the doughnut as percent of the hole. The value is limited between 0 and 90.
        /// </summary>
        public int HoleSizePercent
        {
            get
            {
                return this.holeSizePercent;
            }
            set
            {
                if (this.holeSizePercent != value)
                {
                    if (value < 0 || 90 < value)
                    {
                        throw new ArgumentException("The HoleSizePercent must be between 0 and 90.");
                    }

                    this.holeSizePercent = value;
                    this.OnSeriesGroupChanged();
                }
            }
        }
    }
}
