﻿namespace Telerik.Windows.Documents.Model.Drawing.Charts
{
    /// <summary>
    /// Represents a group of series of type pie.
    /// </summary>
    public class PieSeriesGroup : SeriesGroup<PieSeries>
    {
        private const SeriesType pieSeriesType = SeriesType.Pie;

        /// <summary>
        /// Initializes a new instance of the <see cref="PieSeriesGroup" /> class.
        /// </summary>
        public PieSeriesGroup()
            : base(pieSeriesType)
        {

        }

        /// <summary>
        /// Gets the type of series this group holds.
        /// </summary>
        public override SeriesType SeriesType
        {
            get
            {
                return pieSeriesType;
            }
        }
    }
}