﻿namespace Telerik.Windows.Documents.Model.Drawing.Charts
{
    /// <summary>
    /// Represents the possible types of scatter styles.
    /// </summary>
    public enum ScatterStyle
    {
        /// <summary>
        /// Specifies the points on the scatter chart shall not be connected with straight lines and markers shall not be drawn.
        /// </summary>
        None,

        /// <summary>
        /// Specifies the points on the scatter chart shall be connected with straight lines but markers shall not be drawn.
        /// </summary>
        Line,

        /// <summary>
        /// Specifies the points on the scatter chart shall be connected with straight lines and markers shall be drawn.
        /// </summary>
        LineMarker,

        /// <summary>
        /// Specifies the points on the scatter chart shall not be connected with lines and markers shall be drawn.
        /// </summary>
        Marker,

        /// <summary>
        /// Specifies the the points on the scatter chart shall be connected with smoothed lines and markers shall not be drawn.
        /// </summary>
        Smooth,

        /// <summary>
        /// Specifies the the points on the scatter chart shall be connected with smoothed lines and markers shall be drawn.
        /// </summary>
        SmoothMarker
    }
}
