﻿namespace Telerik.Windows.Documents.Model.Drawing.Charts
{
    /// <summary>
    /// Represents the text chart title. This type of title holds a text literal to be used as title.
    /// </summary>
    public class TextTitle : Title
    {
        private readonly string text;

        /// <summary>
        /// Initializes a new instance of the <see cref="TextTitle" /> class.
        /// </summary>
        public TextTitle(string text)
        {
            this.text = text;
        }

        /// <summary>
        /// Gets the type of the title.
        /// </summary>
        public override TitleType TitleType
        {
            get
            {
                return TitleType.Text;
            }
        }

        /// <summary>
        /// Gets the text of the title.
        /// </summary>
        public string Text
        {
            get
            {
                return this.text;
            }
        }

        /// <summary>
        /// Creates a deep copy of the object.
        /// </summary>
        /// <returns>The deep copy of the object.</returns>
        public override Title Clone()
        {
            return new TextTitle(this.Text);
        }
    }
}
