﻿using System;
#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Model.Drawing.Theming;
#else
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Model.Drawing.Shapes
{
    /// <summary>
    /// Represents a line in the chart.
    /// </summary>
    public class ChartLine
    {
        /// <summary>
        /// Gets the outline properties of the line.
        /// </summary>
        public Outline Outline { get; private set; }

        internal ChartLine()
        {
            this.Outline = new Outline();
            this.Outline.ShapeOutlineChanged += this.Outline_ShapeOutlineChanged;
        }

        /// <summary>
        /// Creates a deep copy of the object.
        /// </summary>
        /// <returns>The deep copy of the object.</returns>
        public ChartLine Clone()
        {
            ChartLine result = new ChartLine();

            result.Outline.Fill = this.Outline.Fill;
            result.Outline.Width = this.Outline.Width;

            return result;
        }

        private void Outline_ShapeOutlineChanged(object sender, EventArgs e)
        {
            this.OnChartLineChanged();
        }

        internal event EventHandler ChartLineChanged;

        internal void OnChartLineChanged()
        {
            if (this.ChartLineChanged != null)
            {
                this.ChartLineChanged(this, EventArgs.Empty);
            }
        }
    }
}
