﻿#if (WPF || SILVERLIGHT) && !NETCORE
namespace Telerik.Windows.Documents.Spreadsheet.Theming
#else
namespace Telerik.Documents.Common.Model
#endif
{
    /// <summary>
    /// Defines the members of an object which is part of a theme.
    /// </summary>
    public interface IThemableObject<T>
    {
        /// <summary>
        /// Gets the value indicating if the instance is from a theme.
        /// </summary>
        /// <value>The value indicating if the instance is from a theme.</value>
        bool IsFromTheme { get; }

        /// <summary>
        /// Gets the local value.
        /// </summary>
        /// <value>The local value.</value>
        T LocalValue { get; }

        /// <summary>
        /// Gets the actual value.
        /// </summary>
        /// <param name="theme">The theme.</param>
        /// <returns>The actual value.</returns>
        T GetActualValue(DocumentTheme theme);
    }
}
