﻿#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif

#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Spreadsheet.Model;
#else
using Telerik.Documents.Common.Model;
#endif

#if (WPF || SILVERLIGHT) && !NETCORE
namespace Telerik.Windows.Documents.Model.Drawing.Theming
#else
namespace Telerik.Documents.Common.Model
#endif
{
    /// <summary>
    /// Represents a solid fill of an object.
    /// </summary>
    public class SolidFill : Fill
    {
        private readonly ThemableColor color;

        /// <summary>
        /// Represents the color of the fill.
        /// </summary>
        public ThemableColor Color
        {
            get
            {
                return this.color;
            }
        }

        internal override FillType ShapeFillType
        {
            get
            {
                return FillType.Solid;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SolidFill" /> class.
        /// </summary>
        public SolidFill(ThemableColor color)
        {
            this.color = color;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SolidFill" /> class.
        /// </summary>
        public SolidFill(Color color)
        {
            this.color = new ThemableColor(color);
        }

        /// <summary>
        /// Creates a deep copy of the object.
        /// </summary>
        /// <returns>The deep copy of the object.</returns>
        public override Fill Clone()
        {
            return new SolidFill(this.Color);
        }
    }
}
