﻿#if (WPF || SILVERLIGHT) && !NETCORE
namespace Telerik.Windows.Documents.Spreadsheet.Theming
#else
namespace Telerik.Documents.Common.Model
#endif
{
    /// <summary>
    /// Defines the types of theme colors.
    /// </summary>
    public enum ThemeColorType
    {
        /// <summary>
        /// Represents Background1 theme color type.
        /// </summary>
        Background1 = 0,

        /// <summary>
        /// Represents Text1 theme color type.
        /// </summary>
        Text1 = 1,

        /// <summary>
        /// Represents Background2 theme color type.
        /// </summary>
        Background2 = 2,

        /// <summary>
        /// Represents Text2 theme color type.
        /// </summary>
        Text2 = 3,

        /// <summary>
        /// Represents Accent1 theme color type.
        /// </summary>
        Accent1 = 4,

        /// <summary>
        /// Represents Accent2 theme color type.
        /// </summary>
        Accent2 = 5,

        /// <summary>
        /// Represents Accent3 theme color type.
        /// </summary>
        Accent3 = 6,

        /// <summary>
        /// Represents Accent4 theme color type.
        /// </summary>
        Accent4 = 7,

        /// <summary>
        /// Represents Accent5 theme color type.
        /// </summary>
        Accent5 = 8,

        /// <summary>
        /// Represents Accent6 theme color type.
        /// </summary>
        Accent6 = 9,

        /// <summary>
        /// Represents Hyperlink theme color type.
        /// </summary>
        Hyperlink = 10,

        /// <summary>
        /// Represents FollowedHyperlink theme color type.
        /// </summary>
        FollowedHyperlink = 11,

        // TODO: ThemeColorTypes mismatch! Check specification about Background and Text colors (page 2837, ECMA-376, 4th Edition)
        ////Dark1 = Text1,
        ////Dark2 = Text2,
        ////Light1 = Background1,
        ////Light2 = Background2,
    }
}