﻿using System.Security.Cryptography;

namespace Telerik.Windows.Documents.Common.Model.Protection
{
    internal class SHA1 : IProtectionAlgorithm
    {
        public const string Name = "SHA-1";

#if WPF
        private static readonly SHA1CryptoServiceProvider algorithm;
#else
        private static readonly SHA1Managed algorithm;
#endif

        static SHA1()
        {
#if WPF
            algorithm = new SHA1CryptoServiceProvider();
#else
            algorithm = new SHA1Managed();
#endif
        }

        public byte[] ComputeHash(byte[] buffer)
        {
            return algorithm.ComputeHash(buffer);
        }
    }
}
