﻿using System.Security.Cryptography;

namespace Telerik.Windows.Documents.Common.Model.Protection
{
    internal class SHA256 : IProtectionAlgorithm
    {
        public const string Name = "SHA-256";

#if WPF
        private static readonly SHA256CryptoServiceProvider algorithm;
#else
        private static readonly SHA256Managed algorithm;
#endif

        static SHA256()
        {
#if WPF
            algorithm = new SHA256CryptoServiceProvider();
#else
            algorithm = new SHA256Managed();
#endif
        }

        public byte[] ComputeHash(byte[] buffer)
        {
            return algorithm.ComputeHash(buffer);
        }
    }
}
