﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Data.StateMachine
{
    internal class Transition<TArgs>
    {
        private readonly Func<TArgs, bool> predicate;
        private readonly State<TArgs> fromState;
        private readonly State<TArgs> toState;

        public Transition(State<TArgs> stay, Func<TArgs, bool> predicate)
            : this(stay, stay, predicate)
        {
        }

        public Transition(State<TArgs> fromState, State<TArgs> toState, Func<TArgs, bool> predicate)
        {
            this.fromState = fromState;
            this.toState = toState;
            this.predicate = predicate;
        }

        public State<TArgs> ToState
        {
            get
            {
                return this.toState;
            }
        }

        public State<TArgs> FromState
        {
            get
            {
                return this.fromState;
            }
        }

        public Func<TArgs, bool> Predicate
        {
            get
            {
                return this.predicate;
            }
        }
    }
}
