﻿namespace Telerik.Windows.Documents.Core.Data
{
    internal static class Tuple
    {
        public static Tuple<T1, T2> Create<T1, T2>(T1 item1, T2 item2)
        {
            return new Tuple<T1, T2>(item1, item2);
        }
    }

    internal class Tuple<T1, T2>
    {
        private bool isEmpty;

        private T1 item1;
        private T2 item2;

        public T1 Item1
        {
            get
            {
                return this.item1;
            }
            set
            {
                this.item1 = value;
                this.isEmpty = false;
            }
        }

        public T2 Item2
        {
            get
            {
                return this.item2;
            }
            set
            {
                this.item2 = value;
                this.isEmpty = false;
            }
        }

        public Tuple()
        {
            this.item1 = default(T1);
            this.item2 = default(T2);

            this.isEmpty = true;
        }
        public Tuple(T1 item1, T2 item2)
        {
            this.item1 = item1;
            this.item2 = item2;
        }

        public bool IsEmpty()
        {
            return this.isEmpty;
        }
    }

    internal class Tuple<T1, T2, T3>
    {
        private readonly T1 item1;
        private readonly T2 item2;
        private readonly T3 item3;

        public T1 Item1
        {
            get
            {
                return this.item1;
            }
        }

        public T2 Item2
        {
            get
            {
                return this.item2;
            }
        }

        public T3 Item3
        {
            get
            {
                return this.item3;
            }
        }

        public Tuple()
        {
        }
        public Tuple(T1 item1, T2 item2, T3 item3)
        {
            this.item1 = item1;
            this.item2 = item2;
            this.item3 = item3;
        }
    }
}