﻿namespace Telerik.Documents.Core.Fonts
{
    /// <summary>
    /// Structure that describes the style of a font, such as Normal, Italic or Oblique.
    /// </summary>
    public struct FontStyle
    {
        private readonly int styleId;

        /// <summary>
        /// Initializes a new instance of <see cref="FontStyle"/> struct.
        /// </summary>
        /// <param name="styleId"></param>
        public FontStyle(int styleId)
        {
            this.styleId = styleId;
        }

        /// <inheritdoc/>
        public override int GetHashCode()
        {
            return this.styleId.GetHashCode();
        }

        /// <inheritdoc/>
        public override bool Equals(object obj)
        {
            if (obj == null || !(obj is FontStyle))
            {
                return false;
            }

            return this.Equals((FontStyle)obj);
        }

        private bool Equals(FontStyle other)
        {
            return this.styleId.Equals(other.styleId);
        }

        public static bool operator ==(FontStyle fs1, FontStyle fs2)
        {
            return fs1.Equals(fs2);
        }

        public static bool operator !=(FontStyle fs1, FontStyle fs2)
        {
            return !fs1.Equals(fs2);
        }
    }
}
