﻿namespace Telerik.Documents.Core.Fonts
{
    /// <summary>
    /// Contains predefined <see cref="FontStyle"/>s.
    /// </summary>
    public static class FontStyles
    {
        private static readonly FontStyle normal = new FontStyle(0);

        private static readonly FontStyle oblique = new FontStyle(1);

        private static readonly FontStyle italic = new FontStyle(2);

        /// <summary>
        /// Gets the normal <see cref="FontStyle"/>.
        /// </summary>
        public static FontStyle Normal
        {
            get
            {
                return FontStyles.normal;
            }
        }

        /// <summary>
        /// Gets the oblique <see cref="FontStyle"/>.
        /// </summary>
        public static FontStyle Oblique
        {
            get
            {
                return FontStyles.oblique;
            }
        }

        /// <summary>
        /// Gets the italic <see cref="FontStyle"/>.
        /// </summary>
        public static FontStyle Italic
        {
            get
            {
                return FontStyles.italic;
            }
        }
    }
}
