﻿namespace Telerik.Documents.Core.Fonts
{
    /// <summary>
    /// Structure describes the degree of thickness in a font characters.
    /// </summary>
    public struct FontWeight
    {
        private readonly int weight;

        /// <summary>
        /// Initializes a new instance of <see cref="FontWeight"/> struct.
        /// </summary>
        /// <param name="weight"></param>
        public FontWeight(int weight)
        {
            this.weight = weight;
        }

        internal int Weight
        {
            get
            {
                return this.weight;
            }
        }

        /// <inheritdoc/>
        public override int GetHashCode()
        {
            return this.weight.GetHashCode();
        }

        /// <inheritdoc/>
        public override bool Equals(object obj)
        {
            if (obj == null || !(obj is FontWeight))
            {
                return false;
            }

            return this.Equals((FontWeight)obj);
        }

        private bool Equals(FontWeight other)
        {
            return this.weight.Equals(other.weight);
        }

        public static bool operator ==(FontWeight fw1, FontWeight fw2)
        {
            return fw1.Equals(fw2);
        }

        public static bool operator !=(FontWeight fw1, FontWeight fw2)
        {
            return !fw1.Equals(fw2);
        }
    }
}
