﻿namespace Telerik.Documents.Core.Fonts
{
    /// <summary>
    /// Contains predefined <see cref="FontWeights"/>.
    /// </summary>
    public static class FontWeights
    {
        private static readonly FontWeight thin = new FontWeight(100);

        private static readonly FontWeight normal = new FontWeight(400);

        private static readonly FontWeight bold = new FontWeight(700);

        private static readonly FontWeight black = new FontWeight(900);

        private static readonly FontWeight heavy = new FontWeight(900);

        /// <summary>
        /// Gets the thin <see cref="FontWeight"/>.
        /// </summary>
        public static FontWeight Thin
        {
            get
            {
                return FontWeights.thin;
            }
        }

        /// <summary>
        /// Gets the normal <see cref="FontWeight"/>.
        /// </summary>
        public static FontWeight Normal
        {
            get
            {
                return FontWeights.normal;
            }
        }

        /// <summary>
        /// Gets the bold <see cref="FontWeight"/>.
        /// </summary>
        public static FontWeight Bold
        {
            get
            {
                return FontWeights.bold;
            }
        }
        /// <summary>
        /// Gets the black <see cref="FontWeight"/>.
        /// </summary>
        public static FontWeight Black
        {
            get
            {
                return FontWeights.black;
            }
        }

        /// <summary>
        /// Gets the heavy <see cref="FontWeight"/>.
        /// </summary>
        public static FontWeight Heavy
        {
            get
            {
                return FontWeights.heavy;
            }
        }
    }
}
