﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.ColorSpaces
{
    internal class YCbCr
    {
        public static void ToRgb(ref byte c1, ref byte c2, ref byte c3)
        {
            byte y = c1;
            byte cb = c2;
            byte cr = c3;

            double r = y + 1.402 * (cr - 128);
            double g = y - 0.3441363 * (cb - 128) - 0.71413636 * (cr - 128);
            double b = y + 1.772 * (cb - 128);

            c1 = r > 255 ? (byte)255 : r < 0 ? (byte)0 : (byte)r;
            c2 = g > 255 ? (byte)255 : g < 0 ? (byte)0 : (byte)g;
            c3 = b > 255 ? (byte)255 : b < 0 ? (byte)0 : (byte)b;
        }

        public static void FromRgb(ref byte c1, ref byte c2, ref byte c3)
        {
            byte r = c1;
            byte g = c2;
            byte b = c3;

            c1 = (byte)(0.299 * r + 0.587 * g + 0.114 * b);
            c2 = (byte)(-0.168736 * r - 0.331264 * g + 0.5 * b + 128);
            c3 = (byte)(0.5 * r - 0.4186876 * g - 0.08131241 * b + 128);
        }
    }
}
