﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.ColorSpaces
{
    internal class YCbCrK
    {
        public static void ToCmyk(ref byte c1, ref byte c2, ref byte c3, ref byte c4)
        {
            byte y = c1;
            byte cb = c2;
            byte cr = c3;
            byte k = c4;

            YCbCr.ToRgb(ref y, ref cb, ref cr);

            c1 = (byte)(255 - y);
            c2 = (byte)(255 - cb);
            c3 = (byte)(255 - cr);
            c4 = k;
        }

        public static void FromCmyk(ref byte c1, ref byte c2, ref byte c3, ref byte c4)
        {
            byte r = (byte)(255 - c1);
            byte g = (byte)(255 - c2);
            byte b = (byte)(255 - c3);
            byte k = c4; 

            YCbCr.FromRgb(ref r, ref g, ref b);

            c1 = r;
            c2 = g;
            c3 = b;
            c4 = k;
        }
    }
}
