﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Imaging.Jpeg.Tables;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.Decoder
{
    internal class BaselineDCTDecoder : ScanDecoder
    {
        public override void ResetDecoder(JpegDecoderBase decoder)
        {            
        }

        public override void DecodeBlock(JpegDecoder decoder, JpegComponent component, Block block)
        {
            int t = component.DcTable.Decode(decoder.Reader);

            int diff = t == 0 ? 0 : decoder.Reader.ReceiveAndExtend(t);
            block[0] = component.LastDCCoefficient + diff;
            component.UpdateLastDCCoefficient(block);

            int k = 1;

            while (k < Constants.BlockSize)
            {
                int rs = component.AcTable.Decode(decoder.Reader);

                int s = rs & 15;
                int r = rs >> 4;

                if (s == 0)
                {
                    if (r < 15)
                    {
                        break;
                    }

                    k += 16;
                    continue;
                }

                k += r;

                int z = ZigZagScan.ZigZagMap[k];
                block[z] = decoder.Reader.ReceiveAndExtend(s);

                k++;
            }
        }
    }
}
