﻿using Telerik.Windows.Documents.Core.Imaging.Jpeg.Tables;
using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.Decoder
{
    internal abstract class ScanDecoder
    {
        public static ScanDecoder GetDecoder(JpegEncodingType encodingType)
        {
            ScanDecoder scanDecoder = null;

            switch (encodingType)
            {
                case JpegEncodingType.BaselineDct:
                    scanDecoder = new BaselineDCTDecoder();
                    break;

                case JpegEncodingType.ProgressiveDct:
                    scanDecoder = new ProgressiveDCTDecoder();
                    break;
             
                case JpegEncodingType.NotSupported:
                default:
                    scanDecoder = new NotSupportedScanDecoder();
                    break;
            }

            return scanDecoder;
        }

        public abstract void ResetDecoder(JpegDecoderBase decoder);

        public abstract void DecodeBlock(JpegDecoder decoder, JpegComponent component, Block block);
    }
}
