﻿namespace Telerik.Windows.Documents.Core.Imaging.Jpeg
{
    /// <summary>
    /// Type of the JPEG encoding.
    /// </summary>
    public enum JpegEncodingType
    {
        /// <summary>
        /// Baseline DCT encoding.
        /// </summary>
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Dct")]
        BaselineDct,

        /// <summary>
        /// Progressive DCT encoding.
        /// </summary>
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Dct")]
        ProgressiveDct,

        /// <summary>
        /// Indicates that JPEG uses not-supported encoding type.
        /// </summary>
        NotSupported
    }
}
