﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Imaging.Jpeg.ColorSpaces;
using Telerik.Windows.Documents.Core.Imaging.Jpeg.Decoder;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.Markers
{
    internal class AdobeMarker : JpegMarker
    {
        /// <summary>
        /// Gets length of the marker segment.
        /// </summary>
        public override ushort Length
        {
            get
            {
                return 14;
            }
        }

        public override JpegMarkerType MarkerType
        {
            get
            {
                return JpegMarkerType.APP14;
            }
        }

        public override void InterpretMarker(JpegDecoderBase decoder)
        {
            decoder.Reader.Read16();
            byte[] txt = new byte[5];
            decoder.Reader.Read(txt, 5);
            decoder.Reader.Read16();
            decoder.Reader.Read16();
            decoder.Reader.Read16();
            decoder.ColorTransform = (JpegColorSpace)decoder.Reader.Read8();
        }
    }
}
