﻿using System;
using Telerik.Windows.Documents.Core.Imaging.Jpeg.Decoder;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.Markers
{
    internal class CommentMarker : JpegMarker
    {
        private ushort length = 0;

        public override ushort Length
        {
            get
            {
                return this.length;
            }
        }

        public override JpegMarkerType MarkerType
        {
            get
            {
                return JpegMarkerType.COM;
            }
        }

        public string Comment { get; set; }

        public override void InterpretMarker(JpegDecoderBase decoder)
        {
            Guard.ThrowExceptionIfNull(decoder, "decoder");

            this.length = decoder.Reader.Read16();
            byte[] content = new byte[this.length - 2];
            decoder.Reader.Read(content, content.Length);

            this.Comment = System.Text.Encoding.UTF8.GetString(content, 0, content.Length);
        }
    }
}
