﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Imaging.Jpeg.Decoder;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.Markers
{
    internal class DefineRestartIntervalMarker : JpegMarker
    {
        /// <summary>
        /// Gets length of the marker segment.
        /// </summary>
        public override ushort Length
        {
            get
            {
                return 4;
            }
        }

        public override JpegMarkerType MarkerType
        {
            get
            {
                return JpegMarkerType.DRI;
            }
        }

        public override void InterpretMarker(JpegDecoderBase decoder)
        {
            Guard.ThrowExceptionIfNull(decoder, "decoder");

            decoder.Reader.Read16();
            decoder.RestartInterval = decoder.Reader.Read16();

            if (decoder.RestartInterval > 0)
            {
                decoder.IsRestartIntervalDefined = true;
            }
        }
    }
}
