﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.Markers
{
    internal enum JpegMarkerType
    {
        /// <summary>
        /// JFIF application marker.
        /// </summary>
        APP0,

        /// <summary>
        /// Adobe application marker.
        /// </summary>
        APP14,

        /// <summary>
        /// Comment.
        /// </summary>
        COM,

        /// <summary>
        /// Define huffman table marker.
        /// </summary>
        DHT, 

        /// <summary>
        /// Define quantization table marker.
        /// </summary>
        DQT,

        /// <summary>
        /// Define restart interval.
        /// </summary>
        DRI, 

        /// <summary>
        /// End of image.
        /// </summary>
        EOI,

        /// <summary>
        /// Restart scan.
        /// </summary>
        RST,

        /// <summary>
        /// Start of frame.
        /// </summary>
        SOF,

        /// <summary>
        /// Start of image.
        /// </summary>
        SOI,

        /// <summary>
        /// Start of scan.
        /// </summary>
        SOS,

        /// <summary>
        /// Not supported.
        /// </summary>
        NotSupported
    }
}
