﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Imaging.Jpeg.Decoder;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.Markers
{
    internal class NotSupportedMarker : JpegMarker
    {
        private ushort length = 0;

        /// <summary>
        /// Gets length of the marker segment.
        /// </summary>
        public override ushort Length
        {
            get
            {
                return this.length;
            }
        }

        public override JpegMarkerType MarkerType
        {
            get
            {
                return JpegMarkerType.NotSupported;
            }
        }

        public override void InterpretMarker(JpegDecoderBase decoder)
        {
            this.length = JpegMarker.ReadLengthAndSkipData(decoder);
        }
    }
}
