﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.Tables
{
    /// <summary>
    /// Represents block of float values.
    /// </summary>
    internal class FloatBlock
    {
        private readonly float[] data;

        public FloatBlock()
        {
            this.data = new float[Constants.BlockSize];
        }

        public FloatBlock(Block intBlock)
        {
            this.data = new float[Constants.BlockSize];

            for (int i = 0; i < Constants.BlockSize; i++)
            {
                this.data[i] = intBlock[i];
            }
        }

        public float this[int index]
        {
            get
            {
                return this.data[index];
            }
            set
            {
                this.data[index] = value;
            }
        }

        public float this[int row, int column]
        {
            get
            {
                return this.data[Block.GetIndex(row, column)];
            }

            set
            {
                this.data[Block.GetIndex(row, column)] = value;
            }
        }

        public Block ToBlock()
        {
            Block block = new Block();

            for (int i = 0; i < Constants.BlockSize; i++)
            {
                block[i] = (int)Math.Round(this.data[i]);
            }

            return block;
        }

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < this.data.Length; i++)
            {
                sb.Append(this.data[i].ToString(System.Globalization.CultureInfo.InvariantCulture) + " ");
            }

            return sb.ToString();
        }
    }
}
