﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.Tables
{
    internal class JpegFrameComponent
    {
        #region Fields

        private readonly byte componentId;
        private readonly byte hSampleFactor;
        private readonly byte vSampleFactor;
        private readonly byte qTableId;

        #endregion

        
        #region Properties

        public byte QuantizationTableId
        {
            get
            {
                return this.qTableId;
            }
        }

        public byte VSampleFactor
        {
            get
            {
                return this.vSampleFactor;
            }
        }

        public byte HSampleFactor
        {
            get
            {
                return this.hSampleFactor;
            }
        }

        public byte ComponentId
        {
            get
            {
                return this.componentId;
            }
        }

        #endregion


        #region Constructors

        public JpegFrameComponent(byte componentId, byte hSampleFactor, byte vSampleFactor, byte qTableId)
        {
            this.componentId = componentId;
            this.hSampleFactor = hSampleFactor;
            this.vSampleFactor = vSampleFactor;
            this.qTableId = qTableId;
        }

        #endregion
    }
}
