﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Imaging.Jpeg.Decoder;
using Telerik.Windows.Documents.Core.Imaging.Jpeg.Encoder;

namespace Telerik.Windows.Documents.Core.Imaging.Jpeg.Tables
{
    /// <summary>
    /// Base class for the JPEG information structures.
    /// </summary>
    internal abstract class JpegTable
    {
        /// <summary>
        /// Gets length of the table.
        /// </summary>
        public abstract ushort Length
        {
            get;
        }

        /// <summary>
        /// Reads JPEG information structure.
        /// </summary>
        /// <param name="reader">JPEG reader.</param>
        public abstract void Read(IJpegReader reader);

        /// <summary>
        /// Writes JPEG information structure.
        /// </summary>
        /// <param name="writer">JPEG writer.</param>
        public abstract void Write(JpegWriter writer);
    }
}
