﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
#endif
using Telerik.Windows.Documents.Core.Imaging.Jpeg;
using Telerik.Windows.Documents.Core.Imaging.Jpeg.Decoder;

namespace Telerik.Windows.Documents.Core.Imaging
{
    internal class JpegImageSizeDecoder : ImageSizeDecoderBase
    {
        private static readonly string[] supportedExtensions = new string[] { "jpg", "jpeg" };

        protected override IEnumerable<string> SupportedExtensions
        {
            get
            {
                return supportedExtensions;
            }
        }

        protected override Size DecodeSizeInternal(Stream stream)
        {
            JpegHeadersDecoder decoder = new JpegHeadersDecoder(stream);
            return DecodeSizeCore(decoder);
        }

        protected override Size DecodeSizeInternal(byte[] bytes)
        {
            JpegHeadersDecoder decoder = new JpegHeadersDecoder(bytes);
            return DecodeSizeCore(decoder);
        }

        private static Size DecodeSizeCore(JpegHeadersDecoder decoder)
        {
            JpegImageInfo info;
            if (decoder.TryDecodeJpegImage(out info))
            {
                return new Size(info.Width, info.Height);
            }

            return DefaultNotDecodedImageSize;
        }
    }
}