﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Windows;

namespace Telerik.Windows.Documents.Core.Imaging
{
    internal class MetafileImageSizeDecoder : ImageSizeDecoderBase
    {
        private static readonly IEnumerable<string> supportedExtensions = new string[]
        {
            "emf", "wmf", "exif", "ico"
        };

        protected override IEnumerable<string> SupportedExtensions
        {
            get
            {
                return supportedExtensions;
            }
        }

        protected override Size DecodeSizeInternal(Stream stream)
        {
            return Decode(stream);
        }

        protected override Size DecodeSizeInternal(byte[] bytes)
        {
            using (Stream stream = new MemoryStream(bytes))
            {
                return Decode(stream);
            }
        }

        private static Size Decode(Stream stream)
        {
            try
            {
                using (System.Drawing.Image image = System.Drawing.Image.FromStream(stream))
                {
                    return new Size(image.Width, image.Height);
                }
            }
            catch (ArgumentException)
            {
                return DefaultNotDecodedImageSize;
            }
        }
    }
}