﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Windows;
using System.Windows.Media.Imaging;

namespace Telerik.Windows.Documents.Core.Imaging
{
    internal class TifImageSizeDecoder : ImageSizeDecoderBase
    {
        private static readonly IEnumerable<string> supportedExtensions = new string[]
        {
           "tif", "tiff"
        };

        protected override IEnumerable<string> SupportedExtensions
        {
            get
            {
                return supportedExtensions;
            }
        }

        protected override Size DecodeSizeInternal(Stream stream)
        {
            return Decode(stream);
        }

        protected override Size DecodeSizeInternal(byte[] bytes)
        {
            using (Stream stream = new MemoryStream(bytes))
            {
                return Decode(stream);
            }
        }

        private static Size Decode(Stream stream)
        {
            try
            {
                BitmapDecoder decoder = BitmapDecoder.Create(stream, BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.Default);
                BitmapFrame frame = decoder.Frames[0];

                return new Size(frame.PixelWidth, frame.PixelHeight);
            }
            catch (NotSupportedException)
            {
                return DefaultNotDecodedImageSize;
            }
        }
    }
}