namespace Telerik.Windows.Documents.Core.TextMeasurer
{
    /// <summary>
    /// Represents sub string position enum. This position is used when RTL text is measured.
    /// </summary>
    public enum SubStringPosition
    {
        /// <summary>
        /// Represents the default substring position.
        /// </summary>
        None,
        /// <summary>
        /// Represents position in start of string.
        /// </summary>
        Start,
        /// <summary>
        /// Represents position in middle of string.
        /// </summary>
        Middle,
        /// <summary>
        /// Represents position in end of string.
        /// </summary>
        End
    }
}