﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
#endif

namespace Telerik.Windows.Documents.Core.TextMeasurer
{
    /// <summary>
    /// Represents text measurement info class.
    /// </summary>
    public class TextMeasurementInfo
    {
        /// <summary>
        /// Gets empty text measurement info.
        /// </summary>
        /// <value>Empty text measurement info.</value>
        public static TextMeasurementInfo Empty
        {
            get
            {
                return new TextMeasurementInfo();
            }
        }

        /// <summary>
        /// Gets or sets the size.
        /// </summary>
        /// <value>The size.</value>
        public Size Size { get; set; }

        /// <summary>
        /// Gets or sets the baseline offset.
        /// </summary>
        /// <value>The baseline offset.</value>
        public double BaselineOffset { get; set; }
    }
}
