﻿using System;
using System.Runtime.Serialization;

namespace Telerik.Windows.Documents.Exceptions
{
    /// <summary>
    /// Represents not supported scan decoder exception.
    /// </summary> 
#if WPF
    [Serializable]
#endif

    [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "CCITT")]
    public class NotSupportedCCITTFaxDecodeFilterException : NotSupportedFeatureException
    {
        private const string DefaultMessage = "CCITTFaxDecode filter is not supported.";

        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedCCITTFaxDecodeFilterException" /> class.
        /// </summary>
        public NotSupportedCCITTFaxDecodeFilterException()
            : base(DefaultMessage)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedCCITTFaxDecodeFilterException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public NotSupportedCCITTFaxDecodeFilterException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedCCITTFaxDecodeFilterException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public NotSupportedCCITTFaxDecodeFilterException(string message, Exception cause)
            : base(message, cause)
        {
        }

#if WPF
        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedCCITTFaxDecodeFilterException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected NotSupportedCCITTFaxDecodeFilterException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
#endif
    }
}
