﻿using System;
using System.Linq;
using System.Runtime.Serialization;

namespace Telerik.Windows.Documents.Exceptions
{
    /// <summary>
    /// Represents a not supported feature exception.
    /// </summary> 
#if WPF
    [Serializable]
#endif
    public class NotSupportedFeatureException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedFeatureException" /> class.
        /// </summary>
        public NotSupportedFeatureException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedFeatureException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public NotSupportedFeatureException(string message) : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedFeatureException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public NotSupportedFeatureException(string message, Exception cause) : base(message, cause)
        {
        }

#if WPF
        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedFeatureException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected NotSupportedFeatureException(SerializationInfo info, StreamingContext context) : base(info, context)
        { 
        } 
#endif
    }
}
