﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace Telerik.Windows.Documents.Exceptions
{
    /// <summary>
    /// Represents not supported scan decoder exception.
    /// </summary> 
#if WPF
    [Serializable]
#endif
    public class NotSupportedScanDecoderException : NotSupportedFeatureException
    {
        private const string DefaultMessage = "The scan decoder is not supported.";

        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedScanDecoderException" /> class.
        /// </summary>
        public NotSupportedScanDecoderException()
            : base(DefaultMessage)
        { 
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedScanDecoderException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public NotSupportedScanDecoderException(string message)
            : base(message)
        {
        }
         
        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedScanDecoderException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public NotSupportedScanDecoderException(string message, Exception cause)
            : base(message, cause)
        {
        }

#if WPF
        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedScanDecoderException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected NotSupportedScanDecoderException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        { 
        } 
#endif
    }
}
