﻿namespace Telerik.Documents.Media
{
    /// <summary>
    /// Represents collection with predefined colors.
    /// </summary>
    public static class Colors
    {
        /// <summary>
        /// Gets the black color.
        /// </summary>
        /// <value>The black color.</value>
        public static Color Black
        {
            get
            {
                return Color.FromArgb(255, 0, 0, 0);
            }
        }

        /// <summary>
        /// Gets the blue color.
        /// </summary>
        /// <value>The blue color.</value>
        public static Color Blue
        {
            get
            {
                return Color.FromArgb(255, 0, 0, 255);
            }
        }

        /// <summary>
        /// Gets the brown color.
        /// </summary>
        /// <value>The brown color.</value>
        public static Color Brown
        {
            get
            {
                return Color.FromArgb(255, 165, 42, 42);
            }
        }

        /// <summary>
        /// Gets the cyan color.
        /// </summary>
        /// <value>The cyan color.</value>
        public static Color Cyan
        {
            get
            {
                return Color.FromArgb(255, 0, 255, 255);
            }
        }

        /// <summary>
        /// Gets the dark gray color.
        /// </summary>
        /// <value>The dark gray color.</value>
        public static Color DarkGray
        {
            get
            {
                return Color.FromArgb(255, 169, 169, 169);
            }
        }

        /// <summary>
        /// Gets the gray color.
        /// </summary>
        /// <value>The gray color.</value>
        public static Color Gray
        {
            get
            {
                return Color.FromArgb(255, 128, 128, 128);
            }
        }

        /// <summary>
        /// Gets the green color.
        /// </summary>
        /// <value>The green color.</value>
        public static Color Green
        {
            get
            {
                return Color.FromArgb(255, 0, 128, 0);
            }
        }

        /// <summary>
        /// Gets the light gray color.
        /// </summary>
        /// <value>The light gray color.</value>
        public static Color LightGray
        {
            get
            {
                return Color.FromArgb(255, 211, 211, 211);
            }
        }

        /// <summary>
        /// Gets the magenta color.
        /// </summary>
        /// <value>The magenta color.</value>
        public static Color Magenta
        {
            get
            {
                return Color.FromArgb(255, 255, 0, 255);
            }
        }

        /// <summary>
        /// Gets the orange color.
        /// </summary>
        /// <value>The orange color.</value>
        public static Color Orange
        {
            get
            {
                return Color.FromArgb(255, 255, 165, 0);
            }
        }

        /// <summary>
        /// Gets the purple color.
        /// </summary>
        /// <value>The purple color.</value>
        public static Color Purple
        {
            get
            {
                return Color.FromArgb(255, 128, 0, 128);
            }
        }

        /// <summary>
        /// Gets the red color.
        /// </summary>
        /// <value>The red color.</value>
        public static Color Red
        {
            get
            {
                return Color.FromArgb(255, 255, 0, 0);
            }
        }

        /// <summary>
        /// Gets the white color.
        /// </summary>
        /// <value>The white color.</value>
        public static Color White
        {
            get
            {
                return Color.FromArgb(255, 255, 255, 255);
            }
        }

        /// <summary>
        /// Gets the yellow color.
        /// </summary>
        /// <value>The yellow color.</value>
        public static Color Yellow
        {
            get
            {
                return Color.FromArgb(255, 255, 255, 0);
            }
        }

        /// <summary>
        /// Gets the violet color.
        /// </summary>
        /// <value>The violet color.</value>
        public static Color Violet
        {
            get
            {
                return Color.FromArgb(255, 238, 130, 238);
            }
        }

        /// <summary>
        /// Gets the blue violet color.
        /// </summary>
        /// <value>The blue violet color.</value>
        public static Color BlueViolet
        {
            get
            {
                return Color.FromArgb(255, 138, 43, 226);
            }
        }

        /// <summary>
        /// Gets the green yellow color.
        /// </summary>
        /// <value>The green yellow color.</value>
        public static Color GreenYellow
        {
            get
            {
                return Color.FromArgb(255, 173, 255, 47);
            }
        }

        /// <summary>
        /// Gets the azure color.
        /// </summary>
        /// <value>The azure color.</value>
        public static Color Azure
        {
            get
            {
                return Color.FromArgb(255, 240, 255, 255);
            }
        }

        /// <summary>
        /// Gets the aquamarine color.
        /// </summary>
        /// <value>The aquamarine color.</value>
        public static Color Aquamarine
        {
            get
            {
                return Color.FromArgb(255, 127, 255, 212);
            }
        }

        /// <summary>
        /// Gets the blanched almond color.
        /// </summary>
        /// <value>The blanched almond color.</value>
        public static Color BlanchedAlmond
        {
            get
            {
                return Color.FromArgb(255, 255, 235, 205);
            }
        }

        /// <summary>
        /// Gets the dark green color.
        /// </summary>
        /// <value>The dark green color.</value>
        public static Color DarkGreen
        {
            get
            {
                return Color.FromArgb(255, 0, 100, 0);
            }
        }

        /// <summary>
        /// Gets the dark cyan color.
        /// </summary>
        /// <value>The dark cyan color.</value>
        public static Color DarkCyan
        {
            get
            {
                return Color.FromArgb(255, 0, 139, 139);
            }
        }

        /// <summary>
        /// Gets the aqua color.
        /// </summary>
        /// <value>The aqua color.</value>
        public static Color Aqua
        {
            get
            {
                return Color.FromArgb(255, 0, 255, 255);
            }
        }

        /// <summary>
        /// Gets the pink color.
        /// </summary>
        /// <value>The pink color.</value>
        public static Color Pink
        {
            get
            {
                return Color.FromArgb(255, 255, 192, 203);
            }
        }

        /// <summary>
        /// Gets the chocolate color.
        /// </summary>
        /// <value>The chocolate color.</value>
        public static Color Chocolate
        {
            get
            {
                return Color.FromArgb(255, 210, 105, 30);
            }
        }

        /// <summary>
        /// Gets the plum color.
        /// </summary>
        /// <value>The plum color.</value>
        public static Color Plum
        {
            get
            {
                return Color.FromArgb(255, 221, 160, 221);
            }
        }

        /// <summary>
        /// Gets the lime color.
        /// </summary>
        /// <value>The lime color.</value>
        public static Color Lime
        {
            get
            {
                return Color.FromArgb(255, 0, 255, 0);
            }
        }

        /// <summary>
        /// Gets the light sky blue color.
        /// </summary>
        /// <value>The light sky blue color.</value>
        public static Color LightSkyBlue
        {
            get
            {
                return Color.FromArgb(255, 135, 206, 250);
            }
        }

        /// <summary>
        /// Gets the gold color.
        /// </summary>
        /// <value>The gold color.</value>
        public static Color Gold
        {
            get
            {
                return Color.FromArgb(255, 255, 215, 0);
            }
        }

        /// <summary>
        /// Gets the gainsboro color.
        /// </summary>
        /// <value>The gainsboro color.</value>
        public static Color Gainsboro
        {
            get
            {
                return Color.FromArgb(255, 220, 220, 220);
            }
        }

        /// <summary>
        /// Gets the firebrick color.
        /// </summary>
        /// <value>The firebrick color.</value>
        public static Color Firebrick
        {
            get
            {
                return Color.FromArgb(255, 178, 34, 34);
            }
        }

        /// <summary>
        /// Gets the transparent color.
        /// </summary>
        /// <value>The transparent color.</value>
        public static Color Transparent
        {
            get
            {
                return Color.FromArgb(0, 255, 255, 255);
            }
        }
    }
}
