﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Media
{
    /// <summary>
    /// Defines different unit types.
    /// </summary>
    public enum UnitType
    {
        /// <summary> Device independent pixel.</summary>
        Dip = 0,

        /// <summary> Point.</summary>
        Point = 1,

        /// <summary> Pica.</summary>
        Pica = 2,

        /// <summary> Inch.</summary>
        Inch = 3,

        /// <summary> Millimeter.</summary>
        Mm = 4,

        /// <summary> Centimeter.</summary>
        Cm = 5,

        /// <summary> Twip - twentieth of a point.</summary>
        Twip = 6,

        /// <summary> EMU - English Metric Unit.</summary>
        Emu = 7,

        /// <summary>Percentage.</summary>
        Percent = 8,

        /// <summary>Em.</summary>
        Em = 9,
    }
}