﻿using System;
using System.ComponentModel;

namespace Telerik.Windows.Documents.Model
{
    /// <summary>
    /// Specifies page orientation.
    /// </summary>
    public enum PageOrientation
    {
        /// <summary> 
        /// Portrait page orientation.
        /// </summary>
        Portrait,

        /// <summary> 
        /// Landscape page orientation.
        /// </summary>
        Landscape,

        /// <summary> 
        /// Page is rotated 180 degrees.
        /// </summary>
        [Obsolete("Use Portrait instead.")]
        [EditorBrowsable(EditorBrowsableState.Never)]
        Rotate180,

        /// <summary> 
        /// Page is rotated 270 degrees
        /// </summary>
        [Obsolete("Use Landscape instead.")]
        [EditorBrowsable(EditorBrowsableState.Never)]
        Rotate270,

        /// <summary> 
        /// Portrait page orientation.
        /// </summary>
        [Obsolete("Use Portrait instead.")]
        [EditorBrowsable(EditorBrowsableState.Never)]
        Rotate0 = Portrait,

        /// <summary> 
        /// Landscape page orientation.
        /// </summary>
        [Obsolete("Use Landscape instead.")]
        [EditorBrowsable(EditorBrowsableState.Never)]
        Rotate90 = Landscape,
    }
}
