﻿using System;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Primitives
{
    internal struct SizeI
    {
        private int width;
        private int height;

        public SizeI(int width, int height)
        {
            Guard.ThrowExceptionIfLessThan(0, width, "width");
            Guard.ThrowExceptionIfLessThan(0, height, "height");

            this.width = width;
            this.height = height;
        }

        public int Width
        {
            get
            {
                return this.width;
            }
            set
            {
                Guard.ThrowExceptionIfLessThan(0, value, "value");
                this.width = value;
            }
        }

        public int Height
        {
            get
            {
                return this.height;
            }
            set
            {
                Guard.ThrowExceptionIfLessThan(0, value, "value");
                this.height = value;
            }
        }
    }
}
