﻿namespace Telerik.Documents.Primitives
{
    internal class RotateTransform : Transform
    {
        public double Angle { get; set; }

        public double CenterX { get; set; }

        public double CenterY { get; set; }

        public RotateTransform()
        {
        }

        public RotateTransform(double angle)
        {
            this.Angle = angle;
        }

        public RotateTransform(double angle, double centerX, double centerY) : this(angle)
        {
            this.CenterX = centerX;
            this.CenterY = centerY;
        }

        public override Matrix Value
        {
            get
            {
                Matrix matrix = new Matrix();
                matrix.Rotate(this.Angle, this.CenterX, this.CenterY);

                return matrix;
            }
        }
    }
}
