﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Utilities
{
    internal class DisposableObject : IDisposable
    {
        private readonly Action action;

        public DisposableObject(Action action)
        {
            Guard.ThrowExceptionIfNull(action, "action");

            this.action = action;
        }

        public void Dispose()
        {
            this.action();
        }
    }
}
