﻿using System;

namespace Telerik.Windows.Documents.Utilities
{
    internal sealed class DisposeValidator : IDisposable
    {
        private bool isDisposed;

        public DisposeValidator()
        {
            this.isDisposed = false;
        }

        public bool IsDisposed
        {
            get
            {
                return this.isDisposed;
            }
        }

        public void Dispose()
        {
            Guard.ThrowExceptionIfTrue(this.isDisposed, "isDisposed");
            this.isDisposed = true;
        }
    }
}
