﻿using System;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Windows;

namespace Telerik.Windows.Documents.Utilities
{
    internal static class DocumentsHelper
    {
        public const char SpaceSymbol = ' ';
        public const char TabSymbol = '\t';
        public const char NewLine = '\n';
        public const char ZeroWidthSymbol = ((char)0x200D);
        public const char LineHeightMeasureSymbol = 'X';

        public static bool IsLineBreak(char ch)
        {
            return (ch == NewLine);
        }

        public static bool IsTab(char ch)
        {
            return (ch == TabSymbol);
        }

        public static bool IsWhiteSpace(char ch)
        {
            return (ch == SpaceSymbol);
        }

#if WPF
        public static string EscapeWhiteSpaces(string text)
        {
            if (char.IsWhiteSpace(text.Last()))
            {
                return text + ZeroWidthSymbol;
            }

            return text;
        }
#endif
    }
}
