﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Utilities
{
    internal class SnippetPerformanceCounterRelease
    {
        #region Fields

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1823:AvoidUnusedPrivateFields")]
        private string snippetName;
        private double totalMilliseconds;
        private bool isStartCalled;
        private DateTime currentStartTime;
        private bool hasBeenStarted;
        private int hitCounter;

        #endregion


        #region Constructors

        public SnippetPerformanceCounterRelease(string snippetName)
        {
            this.snippetName = snippetName;
            this.totalMilliseconds = 0;
            this.isStartCalled = false;
            this.hasBeenStarted = false;
        }

        #endregion


        #region Methods

        public void Start()
        {
            if (!this.hasBeenStarted)
            {
                this.hasBeenStarted = true;
            }

            if (!this.isStartCalled)
            {
                this.currentStartTime = DateTime.Now;
                this.isStartCalled = true;
            }

            hitCounter++;
        }

        public void Stop()
        {
            if (this.isStartCalled)
            {
                totalMilliseconds += (DateTime.Now - this.currentStartTime).TotalMilliseconds;
                this.isStartCalled = false;
            }
        }

        public void End()
        {
            this.Stop();

            if (this.hasBeenStarted)
            {
            }
        }

        #endregion

        public double TotalMilliseconds
        {
            get
            {
                return totalMilliseconds;
            }
        }
    }
}
