﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Model.Types;

namespace Telerik.Windows.Documents.Core.Tests.Common.FormatProviders.OpenXml.Model.Types
{
    [TestClass]
    public class SignedTwipsMeasureToDipConverterTests
    {
        [TestMethod]
        public void ConvertFromString_WithShortNumber_ReturnsTheValueInTwips()
        {
            IStringConverter<double> twipMeasureConverter = new SignedTwipsMeasureToDipConverter();
            double actual = twipMeasureConverter.ConvertFromString("6");

            Assert.AreEqual(0.4, actual);
        }

        [TestMethod]
        public void ConvertFromString_WithInvalidUnitSuffix_ReturnsZero()
        {
            IStringConverter<double> twipMeasureConverter = new SignedTwipsMeasureToDipConverter();
            double actual = twipMeasureConverter.ConvertFromString("6km");

            Assert.AreEqual(0, actual);
        }
    }
}
