﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;

namespace Telerik.Windows.Documents.Core.Tests.Common.FormatProviders.OpenXml.Model.Types
{
    [TestClass]
    public class TwipToDipConverterTests
    {
        [TestMethod]
        public void ConvertFromString_WithSimpleNumber_ReadsValueAsTwips()
        {
            IStringConverter<double> twipMeasureConverter = new TwipToDipConverter();
            double actual = twipMeasureConverter.ConvertFromString("1440");

            Assert.AreEqual(96, actual);
        }

        [TestMethod]
        public void ConvertFromString_WithNegativeNumber_ReadsValueAsTwips()
        {
            IStringConverter<double> twipMeasureConverter = new TwipToDipConverter();
            double actual = twipMeasureConverter.ConvertFromString("-1440");

            Assert.AreEqual(-96, actual);
        }

        [TestMethod]
        public void ConvertToString_WithPositiveNumber_ReturnsTheValueInTwips()
        {
            IStringConverter<double> twipMeasureConverter = new TwipToDipConverter();
            string actual = twipMeasureConverter.ConvertToString(96);

            Assert.AreEqual("1440", actual);
        }

        [TestMethod]
        public void ConvertToString_WithNegativeNumber_ReturnsTheValueInTwips()
        {
            IStringConverter<double> twipMeasureConverter = new TwipToDipConverter();
            string actual = twipMeasureConverter.ConvertToString(-96);

            Assert.AreEqual("-1440", actual);
        }

        [TestMethod]
        public void ConvertFromString_WithEmptyString_ReturnsZero()
        {
            IStringConverter<double> twipMeasureConverter = new TwipToDipConverter();
            double actual = twipMeasureConverter.ConvertFromString("");

            Assert.AreEqual(0, actual);
        }

        [TestMethod]
        public void ConvertFromString_WithShortNumber_ReturnsTheValueInTwips()
        {
            IStringConverter<double> twipMeasureConverter = new TwipToDipConverter();
            double actual = twipMeasureConverter.ConvertFromString("6");

            Assert.AreEqual(0.4, actual);
        }
    }
}
