﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.Core.Tests.Utils;
using Telerik.Windows.Documents.Media;

namespace Telerik.Windows.Documents.Core.Tests.Media
{
    [TestClass]
    public class ImageSourceTests
    {
        [TestMethod]
        public void Clone_CreatesCloning()
        {
            // Arrange
            byte[] data = new byte[] { 1, 2, 3 };
            ImageSource imageSource = new ImageSource(data, "png");

            // Act
            ImageSource clonedImageSource = imageSource.Clone();

            // Assert
            Assert.AreNotSame(imageSource, clonedImageSource);
            Assert.AreNotSame(imageSource.Data, clonedImageSource.Data);
            ImageSourceAssert.AreEqual(imageSource, clonedImageSource);
        }
    }
}
