﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Telerik.Windows.Documents.Core.Tests.PostScriptInterpretatorTests
{
    [TestClass]
    public class TestAbsOperator
    {
        [TestMethod]
        public void WhenTheArgumentIsFractionAndPositive()
        {
            string operation = "10.4 abs";

            double expected = 10.4;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenTheArgumentIsFractionAndNegative()
        {
            string operation = "-10.4 abs";

            double expected = 10.4;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenTheArgumentIsIntegerAndPositive()
        {
            string operation = "10 abs";

            double expected = 10;
            double result = Convert.ToInt32(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }
         
        [TestMethod]
        public void WhenTheArgumentIsIntegerAndNegative()
        {
            string operation = "-10 abs";

            double expected = 10;
            double result = Convert.ToInt32(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }
    }
}
