﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Core.PostScript;
using Telerik.Windows.Documents.Core.PostScript.Data;
using System.Collections.Generic;
using Telerik.Windows.Documents.Core.Tests.PostScriptInterpretatorTests;

namespace Telerik.Windows.Documents.Core.Tests.PostScriptCalculatorOperatorTests
{
    [TestClass]
    public class TestRollOperator
    {
        [TestMethod]
        public void WhenTheDirectionIsPositive()
        {
            string operation = "1 2 3 4 5 5 2 roll";
            int numberOfElements = 5;

            object[] expected = {4, 5, 1, 2, 3};
            object[] result = OperatorsUtil.ExecuteOperations(operation, numberOfElements);
            for (int i = 0; i < numberOfElements; i++)
            {
                Assert.AreEqual(expected[i], result[i]);
            }
        }

        [TestMethod]
        public void WhenTheDirectionIsNegatiev()
        {
            string operation = "1 2 3 4 5 5 -2 roll";
            int numberOfElements = 5;

            object[] expected = { 3, 4, 5, 1, 2 };
            object[] result = OperatorsUtil.ExecuteOperations(operation, numberOfElements);
            for (int i = 0; i < numberOfElements; i++)
            {
                Assert.AreEqual(expected[i], result[i]);
            }
        }

        [TestMethod]
        public void WhenTheDirectionIsPositiveWithSingleElement()
        {
            string operation = "1 1 1 roll";
            int numberOfElements = 1;

            object[] expected = { 1 };
            object[] result = OperatorsUtil.ExecuteOperations(operation, numberOfElements);
            for (int i = 0; i < numberOfElements; i++)
            {
                Assert.AreEqual(expected[i], result[i]);
            }
        }
    }
}
