﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Primitives;

namespace Telerik.Windows.Documents.Core.Tests.Primitives
{
    [TestClass]
    public class PaddingTests
    {
        [TestMethod]
        public void Clone_WhenInvoked_CreatePaddingWithSameValues()
        {
            // Arrange
            Padding padding = new Padding(1, 2, 3, 4);

            // Act
            Padding clonedPadding = padding.Clone();

            // Assert
            Assert.AreNotSame(padding, clonedPadding);
            Assert.AreEqual(1, clonedPadding.Left);
            Assert.AreEqual(2, clonedPadding.Top);
            Assert.AreEqual(3, clonedPadding.Right);
            Assert.AreEqual(4, clonedPadding.Bottom);
        }
    }
}
