﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Common.FormatProviders.OpenXml.Utilities;

namespace Telerik.Windows.Documents.Core.Tests.Utils
{
    [TestClass]
    public class EscapeHelperTests
    {
        // All characters not allowed in XML.
        private char[] escapedChars = new char[]
        {
            (char)0x00,
            (char)0x01,
            (char)0x02,
            (char)0x03,
            (char)0x04,
            (char)0x05,
            (char)0x06,
            (char)0x07,
            (char)0x08,
            (char)0x0B,
            (char)0x0C,
            (char)0x0E,
            (char)0x0F,
            (char)0x10,
            (char)0x11,
            (char)0x12,
            (char)0x13,
            (char)0x14,
            (char)0x15,
            (char)0x16,
            (char)0x17,
            (char)0x18,
            (char)0x19,
            (char)0x1A,
            (char)0x1B,
            (char)0x1C,
            (char)0x1D,
            (char)0x1E,
            (char)0x1F,
            (char)0xFFFE,
            (char)0xFFFF,
        };

        [TestMethod]
        public void BasicScenario_SkipOfInvalidCharsInAString_CharsAreDeleted()
        {
            string original = string.Concat(escapedChars);

            string result = IllegalXmlCharHelper.RemoveInvalidCharacters(original);

            Assert.AreEqual(string.Empty, result);
        }
    }
}
