﻿using System;
using System.IO;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using Telerik.Windows.Documents.Core.Fonts;
using Telerik.Windows.Documents.Core.Fonts.OpenType; 
using Telerik.Windows.Documents.Core.Utils;

namespace FontReaderTests.Utils
{
    internal class Helper
    {
        public static readonly string[] STANDARD_FONT_FAMILIES = new string[] { "Arial", "Arial Black", "Calibri", "Comic Sans MS", "Courier New", "Georgia", "Lucida Sans Unicode", "Times New Roman", "Trebuchet MS", "Verdana" };
        public static readonly string[] FALLBACK_FONT_FAMILIES = new string[] { "Arial", "MS Mincho" };
        public static readonly string[] FONT_FAMILIES = STANDARD_FONT_FAMILIES.Union(FALLBACK_FONT_FAMILIES).ToArray();

        public const string TEST_STRING = "1234567890’_-–/|:[]().,!~'\"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZабвгдежзийклмнопрстуфхцчшщъьюяАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЬЮЯ中國哲學書電子化計劃لوحة المفاتيح العربية";
        public const string SAMPLE_STRING = "1234567890’_-–/|:[]().,!~'\"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZабвгдежзийклмнопрстуфхцчшщъьюяАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЬЮЯ";
        public static readonly string[] SAMPLE_WORDS = SAMPLE_LONG_STRING.Replace(Environment.NewLine, " ").Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);

        private const string SAMPLE_LONG_STRING =
@"2.Project Tesseract – Motivation and History
Tesseract is an open-source OCR engine that was developed at HP between 1984 and 1994. Like a supernova, it appeared from nowhere for the 1995 UNLV Annual Test of OCR Accuracy, shone brightly with its results, and then vanished back under the same cloak of secrecy under which it had been developed. Now for the first time, details of the architecture and algorithms can be revealed.
Tesseract began as a PhD research project in HP Labs, Bristol, and gained momentum as a possible software and/or hardware add-on for HP’s line of flatbed scanners. Motivation was provided by the fact that the commercial OCR engines of the day were in their infancy, and failed miserably on anything but the best quality print. After a joint project between HP Labs Bristol, and HP’s scanner division in Colorado, Tesseract had a significant lead in accuracy over the commercial engines, but did not become a product. The next stage of its development was back in HP Labs Bristol as an investigation of OCR for compression. Work concentrated more on improving rejection efficiency than on base-level accuracy. At the end of this project, at the end of 1994, development ceased entirely. The engine was sent to UNLV for the 1995 Annual Test of OCR Accuracy, where it proved its worth against the commercial engines of the time. In late 2005, HP released Tesseract for open source. It is now available at a. 
3.Architecture
Since HP had independently-developed page layout analysis technology that was used in products, (and therefore not released for open-source) Tesseract never needed its own page layout analysis. Tesseract therefore assumes that its input is a binary image with optional polygonal text regions defined.
 
Processing follows a traditional step-by-step pipeline, but some of the stages were unusual in their day, and possibly remain so even now. The first step is a connected component analysis in which outlines of the components are stored. This was a computationally expensive design decision at the time, but had a significant advantage: by inspection of the nesting of outlines, and the number of child and grandchild outlines, it is simple to detect inverse text and recognize it as easily as black-on-white text. Tesseract was probably the first OCR engine able to handle white-on-black text so trivially. At this stage, outlines are gathered together, purely by nesting, into Blobs.
Blobs are organized into text lines, and the lines and regions are analyzed for fixed pitch or proportional text. Text lines are broken into words differently according to the kind of character spacing. Fixed pitch text is chopped immediately by character cells. Proportional text is broken into words using definite spaces and fuzzy spaces.
Recognition then proceeds as a two-pass process. In the first pass, an attempt is made to recognize each word in turn. Each word that is satisfactory is passed to an adaptive classifier as training data. The adaptive classifier then gets a chance to more accurately recognize text lower down the page. 
Since the adaptive classifier may have learned something useful too late to make a contribution near the top of the page, a second pass is run over the page, in which words that were not recognized well enough are recognized again. 
A final phase resolves fuzzy spaces, and checks alternative hypotheses for the x-height to locate smallcap text.
4.Adaptive Tresholding
Thresholding is the simplest method of image segmentation. From a grayscale image, thresholding can be used to create binary images. 
During the thresholding process, individual pixels in an image are marked as object pixels if their value is greater than some threshold value (assuming an object to be brighter than the background) and as background pixels otherwise. This convention is known as threshold above. Variants include threshold below, which is opposite of threshold above; threshold inside, where a pixel is labeled object if its value is between two thresholds; and threshold outside, which is the opposite of threshold inside (Shapiro, et al. 2001:83). Typically, an object pixel is given a value of 1 while a background pixel is given a value of 0. Finally, a binary image is created by coloring each pixel white or black, depending on a pixel's label.
Thresholding is called adaptive thresholding when a different threshold is used for different regions in the image. This may also be known as local or dynamic thresholding. 
The key parameter in the thresholding process is the choice of the threshold value (or values, as mentioned earlier). Several different methods for choosing a threshold exist; users can manually choose a threshold value, or a thresholding algorithm can compute a value automatically, which is known as automatic thresholding. A simple method would be to choose the mean or median value, the rationale being that if the object pixels are brighter than the background, they should also be brighter than the average. In a noiseless image with uniform background and object values, the mean or median will work well as the threshold, however, this will generally not be the case. A more sophisticated approach might be to create a histogram of the image pixel intensities and use the valley point as the threshold. The histogram approach assumes that there is some average value for the background and object pixels, but that the actual pixel values have some variation around these average values. However, this may be computationally expensive, and image histograms may not have clearly defined valley points, often making the selection of an accurate threshold difficult. One method that is relatively simple, does not require much specific knowledge of the image, and is robust against image noise, is the following iterative method:2.Project Tesseract – Motivation and History
Tesseract is an open-source OCR engine that was developed at HP between 1984 and 1994. Like a supernova, it appeared from nowhere for the 1995 UNLV Annual Test of OCR Accuracy, shone brightly with its results, and then vanished back under the same cloak of secrecy under which it had been developed. Now for the first time, details of the architecture and algorithms can be revealed.
Tesseract began as a PhD research project in HP Labs, Bristol, and gained momentum as a possible software and/or hardware add-on for HP’s line of flatbed scanners. Motivation was provided by the fact that the commercial OCR engines of the day were in their infancy, and failed miserably on anything but the best quality print. After a joint project between HP Labs Bristol, and HP’s scanner division in Colorado, Tesseract had a significant lead in accuracy over the commercial engines, but did not become a product. The next stage of its development was back in HP Labs Bristol as an investigation of OCR for compression. Work concentrated more on improving rejection efficiency than on base-level accuracy. At the end of this project, at the end of 1994, development ceased entirely. The engine was sent to UNLV for the 1995 Annual Test of OCR Accuracy, where it proved its worth against the commercial engines of the time. In late 2005, HP released Tesseract for open source. It is now available at a.";


        

        public const double FONT_SIZE = 1;
        public const double EPSYLON = .01;

        private const string METADATA_FOLDER = @"";

        private static readonly string[] differentText = new string[] { "abcdefghijklmnopqr", "дежзийклмнопр", "中國哲學書電子化計劃", "المفاتيح" };

        private static readonly FontWeight[] fontWeights = new FontWeight[] { FontWeights.Normal, FontWeights.Bold };
        private static readonly FontStyle[] fontStyles = new FontStyle[] { FontStyles.Normal, FontStyles.Italic };

        private static readonly FontsManager manager = new FontsManager();

        

        public static GlyphTypeface GetGlyphTypeface(FontDescriptor descr)
        {
            FontFamily ff = new FontFamily(descr.FontFamily);
            Typeface tf = new Typeface(ff, descr.FontStyle, descr.FontWeigth, FontStretches.Normal);
            GlyphTypeface gtf;
            tf.TryGetGlyphTypeface(out gtf);
            return gtf;
        }

        public static OpenTypeFontSourceBase GetFontSource(FontDescriptor descr)
        {
            return manager.GetFontSource(descr);
        }

        public static TextBlock GetTextBlock(FontDescriptor descr)
        {
            TextBlock tb = new TextBlock();
            tb.FontFamily = new FontFamily(descr.FontFamily);
            tb.FontWeight = descr.FontWeigth;
            tb.FontStyle = descr.FontStyle;
            return tb;
        }

        public static OpenTypeFontSource GetTrueTypeFontSource(FontDescriptor descr)
        {
            return (OpenTypeFontSource)Helper.GetFontSource(descr);
        }

        public static OpenTypeFontSourceFromMetaFile GetTrueTypeFontSourceFromMetaFile(OpenTypeFontSource fontSource)
        {
            byte[] bytes;
            using (FontWriter writer = new FontWriter())
            {
                fontSource.Write(writer);
                bytes = writer.GetBytes();
            }
            OpenTypeFontReader reader = new OpenTypeFontReader(bytes);
            return new OpenTypeFontSourceFromMetaFile(reader);
        }

        public static void ExecuteActionWithDifferentFontDescriptors(Action<FontDescriptor> action, string[] fontFamilies = null)
        {
            if (fontFamilies == null)
            {
                fontFamilies = FONT_FAMILIES;
            }
            for (int i = 0; i < fontFamilies.Length; i++)
            {
                for (int j = 0; j < fontStyles.Length; j++)
                {
                    for (int k = 0; k < fontWeights.Length; k++)
                    {
                        action(new FontDescriptor(fontFamilies[i], fontStyles[j], fontWeights[k]));
                    }
                }
            }
        }

        public static void ExecuteActionWithDifferentTexts(Action<string> action)
        {
            for (int i = 0; i < differentText.Length; i++)
            {
                action(differentText[i]);
            }
        }

        public static void ExecuteActionWithDifferentFontStyles(Action<FontDescriptor> action, string fontFamily)
        {
            for (int j = 0; j < fontStyles.Length; j++)
            {
                for (int k = 0; k < fontWeights.Length; k++)
                {
                    action(new FontDescriptor(fontFamily, fontStyles[j], fontWeights[k]));
                }
            }
        }
    }
}
