﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using Telerik.Windows.Documents.Exceptions;

namespace Telerik.Windows.Documents.Fixed.Exceptions
{
    /// <summary>
    /// Represents not supported font family exception.
    /// </summary>
#if WPF
    [Serializable]
#endif
    public class NotSupportedFontFamilyException : NotSupportedFeatureException
    {
        private const string DefaultMessage = "The FontFamily is not supported.";
         
        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedFontFamilyException" /> class.
        /// </summary>
        public NotSupportedFontFamilyException() : base(DefaultMessage)
        {
        }
         
        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedFontFamilyException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public NotSupportedFontFamilyException(string message) : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedFontFamilyException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public NotSupportedFontFamilyException(string message, Exception cause) : base(message, cause)
        {
        }

#if WPF 
        /// <summary>
        /// Initializes a new instance of the <see cref="NotSupportedFontFamilyException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected NotSupportedFontFamilyException(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }
#endif
    }
}
