using Telerik.Windows.Documents.Core.Fonts.OpenType.Utils;

namespace Telerik.Windows.Documents.Core.Fonts
{
    internal class FallbackRecord
    {
        public FallbackRecord(FallbackRange range, FontProperties descr)
        {
            this.Range = range;
            this.FontDescriptor = descr;
        }

        public FallbackRange Range { get; set; }

        public FontProperties FontDescriptor { get; set; }

        public override int GetHashCode()
        {
            unchecked
            {
                int result = 17;
                result = result * 23 + ((Range != null) ? this.Range.GetHashCode() : 0);
                result = result * 23 + ((FontDescriptor != null) ? this.FontDescriptor.GetHashCode() : 0);
                return result;
            }
        }

        public override bool Equals(object obj)
        {
            FallbackRecord r = obj as FallbackRecord;
            if (r == null)
            {
                return false;
            }
            return this.Range == r.Range && this.FontDescriptor == r.FontDescriptor;
        }
    }
}