﻿using System;
using System.Linq;
using System.Text;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType
{
    internal static class IDs
    {
        // Name IDs
        internal const ushort FONT_FAMILY_ID = 1;
        internal const ushort MANUFACTURER_NAME_ID = 8;
        internal const ushort DESIGNER_ID = 9;
        internal const ushort SAMPLE_TEXT_ID = 19;

        // Platform IDs
        internal const ushort WINDOWS_PLATFORM_ID = 3;

        // Windows encoding IDs
        internal const ushort WINDOWS_SYMBOL_ENCODING_ID = 0;
        internal const ushort WINDOWS_UNICODE_BMP_ENCODING_ID = 1;

        // Language IDs
        internal const ushort ENGLISH_US_ID = 0x0409;


        internal static Encoding GetEncodingFromEncodingID(ushort encodingId)
        {
            switch (encodingId)
            {
                case WINDOWS_SYMBOL_ENCODING_ID:
                case WINDOWS_UNICODE_BMP_ENCODING_ID:
                    return Encoding.BigEndianUnicode;
                default:
                    return null;
            }
        }
    }
}
