﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Data;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables
{
    internal class CMapFormat0Table : CMapTable
    {
        #region Consts

        private const ushort GLYPH_IDS = 256;

        #endregion


        #region Fields

        private ValueMapper<ushort, byte> glyphIdToCharId;

        #endregion


        #region Properties

        public override ushort FirstCode
        {
            get { throw new NotSupportedException(); }
        }
        
        #endregion


        #region Methods

        public override bool TryGetGlyphId(int unicode, out ushort glyphId)
        {
            byte uGlyphId;
            bool result = this.glyphIdToCharId.TryGetToValue((ushort)unicode, out uGlyphId);
            glyphId = uGlyphId;

            return result;
        }

        public override bool TryGetCharId(ushort glyphId, out ushort charCode)
        {
            return this.glyphIdToCharId.TryGetFromValue((byte)glyphId, out charCode);
        }

        #endregion


        #region Overrides

        public override void Read(OpenTypeFontReader reader)
        {
            reader.ReadUShort();
            reader.ReadUShort();
            this.glyphIdToCharId = new ValueMapper<ushort, byte>();
            for (ushort i = 0; i < GLYPH_IDS; i++)
            {
                this.glyphIdToCharId.AddPair(i, reader.Read());
            }
        }

        public override void Write(FontWriter writer)
        {
        }

        public override void Import(OpenTypeFontReader reader)
        {
        }

        #endregion
    }
}
