﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Data;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables
{
    internal class CMapFormat6Table : CMapTable
    {
        #region Fields

        private ushort firstCode;

        private ValueMapper<ushort, ushort> glyphIdToCharId;

        #endregion


        #region Properties

        public override ushort FirstCode
        {
            get
            {
                return this.firstCode;
            }
        }

        #endregion


        #region Methods

       

        #endregion


        #region Overrides

        public override bool TryGetGlyphId(int charCode, out ushort glyphId)
        {
            return this.glyphIdToCharId.TryGetToValue((ushort)(charCode - this.firstCode), out glyphId);
        }

        public override bool TryGetCharId(ushort glyphId, out ushort charId)
        {
            return this.glyphIdToCharId.TryGetFromValue((byte)glyphId, out charId);
        }

        public override void Read(OpenTypeFontReader reader)
        {
            reader.ReadUShort();
            reader.ReadUShort();
            this.firstCode = reader.ReadUShort();
            ushort entryCount = reader.ReadUShort();
            this.glyphIdToCharId = new ValueMapper<ushort, ushort>();
            for (ushort i = 0; i < entryCount; i++)
            {
                this.glyphIdToCharId.AddPair(i, reader.ReadUShort());
            }
        }

        public override void Write(FontWriter writer)
        {
           
        }

        public override void Import(OpenTypeFontReader reader)
        {
          
        }

        #endregion
    }
}
