﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.OpenType.Tables.Utils;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables
{
    internal class CoverageFormat2 : Coverage
    {
        #region Constructors

        public CoverageFormat2(OpenTypeFontSourceBase fontFile)
            : base(fontFile)
        {
        }

        #endregion


        #region Fields

        private RangeRecord[] rangeRecords;

        #endregion


        #region Methods
        #endregion


        #region Overrides

        public override void Read(OpenTypeFontReader reader)
        {
            ushort ranges = reader.ReadUShort();
            this.rangeRecords = new RangeRecord[ranges];
            for (int i = 0; i < ranges; i++)
            {
                this.rangeRecords[i] = new RangeRecord();
                this.rangeRecords[i].Read(reader);
            }
        }

        internal override void Write(FontWriter writer)
        {
            writer.WriteUShort(2);
            writer.WriteUShort((ushort)this.rangeRecords.Length);
            for (int i = 0; i < this.rangeRecords.Length; i++)
            {
                this.rangeRecords[i].Write(writer);
            }
        }

        public override int GetCoverageIndex(ushort glyphIndex)
        {
            // TODO: Binary search.
            foreach (RangeRecord rr in this.rangeRecords)
            {
                if (rr.Start <= glyphIndex && glyphIndex <= rr.End)
                {
                    return rr.GetCoverageIndex(glyphIndex);
                }
            }
            return -1;
        }

        #endregion
    }
}
