﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.Utils;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables.Features
{
    internal class IsolatedFeatureInfo : FeatureInfo
    {
        #region Properties

        public override uint Tag
        {
            get { return Tags.FEATURE_ISOLATED_FORMS; }
        }

        public override FeatureType Type
        {
            get { return FeatureType.SingleSubstitution; }
        }

        #endregion


        #region Overrides

        public override bool ShouldApply(GlyphInfo glyphInfo)
        {
            return glyphInfo.Form == GlyphForm.Isolated;
        }

        #endregion
    }
}
