﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.Utils;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables.Features
{
    internal class MedialFeatureInfo : FeatureInfo
    {
        #region Properties

        public override uint Tag
        {
            get { return Tags.FEATURE_MEDIAL_FORMS; }
        }

        public override FeatureType Type
        {
            get { return FeatureType.SingleSubstitution; }
        }

        #endregion


        #region Overrides

        public override bool ShouldApply(GlyphInfo glyphInfo)
        {
            return glyphInfo.Form == GlyphForm.Medial;
        }

        #endregion
    }
}
