﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables
{
    internal class HorizontalHeader : TrueTypeTableBase
    {
        #region Constructors

        public HorizontalHeader(OpenTypeFontSourceBase fontFile)
            : base(fontFile)
        {
        }

        #endregion


        #region Properties

        internal override uint Tag
        {
            get { return Tags.HHEA_TABLE; }
        }

        public short Ascender
        {
            get;
            private set;
        }

        public short Descender
        {
            get;
            private set;
        }

        public short LineGap
        {
            get;
            private set;
        }

        public ushort NumberOfHMetrics
        {
            get;
            private set;
        }

        #endregion


        #region Fields

        public override void Read(OpenTypeFontReader reader)
        {
            reader.ReadFixed();
            this.Ascender = reader.ReadShort();
            this.Descender = reader.ReadShort();
            this.LineGap = reader.ReadShort();
            reader.ReadUShort();
            reader.ReadShort();
            reader.ReadShort();
            reader.ReadShort();
            reader.ReadShort();
            reader.ReadShort();
            reader.ReadShort();
            reader.ReadShort();
            reader.ReadShort();
            reader.ReadShort();
            reader.ReadShort();
            reader.ReadShort();
            this.NumberOfHMetrics = reader.ReadUShort();
        }

        internal override void Write(FontWriter writer)
        {
            writer.WriteShort(this.Ascender);
            writer.WriteShort(this.Descender);
            writer.WriteShort(this.LineGap);
            writer.WriteUShort(this.NumberOfHMetrics);
        }

        internal override void Import(OpenTypeFontReader reader)
        {
            this.Ascender = reader.ReadShort();
            this.Descender = reader.ReadShort();
            this.LineGap = reader.ReadShort();
            this.NumberOfHMetrics = reader.ReadUShort();
        }

        #endregion
    }
}
