﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables
{
    internal class MaxProfile : TrueTypeTableBase
    {
        #region Constructors

        public MaxProfile(OpenTypeFontSourceBase fontFile)
            : base(fontFile)
        {
        }

        #endregion


        #region Properties

        internal override uint Tag
        {
            get { return Tags.MAXP_TABLE; }
        }



        public float Version
        {
            get;
            private set;
        }

        public ushort NumGlyphs
        {
            get;
            private set;
        }

        #endregion


        #region Methods

        override public void Read(OpenTypeFontReader reader)
        {
            this.Version = reader.ReadFixed();
            this.NumGlyphs = reader.ReadUShort();
        }


        #endregion
    }
}
