﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables
{
    internal abstract class Name : TrueTypeTableBase
    {
        #region StaticMembers

        internal static Name ReadNameTable(OpenTypeFontSourceBase fontSource, OpenTypeFontReader reader)
        {
            ushort format = reader.ReadUShort();
            Name name = null;
            switch (format)
            {
                case 0:
                    name = new NameFormat0(fontSource);
                    break;
                case 1:
                    name = new NameFormat1(fontSource);
                    break;
                default:
                    return null;
            }
            name.Read(reader);
            return name;
        }

        #endregion


        #region Constructors

        public Name(OpenTypeFontSourceBase fontSource)
            : base(fontSource)
        {
        }

        #endregion


        #region Properties

        internal override uint Tag
        {
            get { return Tags.NAME_TABLE; }
        }



        public abstract string FontFamily { get; }

        internal abstract string ReadName(ushort languageID, ushort nameID);

        #endregion
    }
}
