﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.Utils;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables
{
    internal class SingleSubstitutionFormat1 : SingleSubstitution
    {
        #region Constructors

        public SingleSubstitutionFormat1(OpenTypeFontSourceBase fontFile)
            : base(fontFile)
        {
        }

        #endregion


        #region Fields

        private ushort deltaGlyphId;

        #endregion


        #region Overrides

        public override GlyphsSequence Apply(GlyphsSequence glyphIDs)
        {
            GlyphsSequence res = new GlyphsSequence(glyphIDs.Count);
            for (int i = 0; i < glyphIDs.Count; i++)
            {
                ushort glyphIndex = glyphIDs[i].GlyphId;
                if (this.Coverage.GetCoverageIndex(glyphIndex) < 0)
                {
                    res.Add(glyphIDs[i]);
                }
                else
                {
                    res.Add((ushort)(glyphIndex + this.deltaGlyphId));
                }
            }
            return res;
        }

        public override void Read(OpenTypeFontReader reader)
        {
            base.Read(reader);
            this.deltaGlyphId = reader.ReadUShort();

        }

        internal override void Write(FontWriter writer)
        {
            writer.WriteUShort(1);
            base.Write(writer);
            writer.WriteUShort(this.deltaGlyphId);
        }

        internal override void Import(OpenTypeFontReader reader)
        {
            base.Import(reader);
            this.deltaGlyphId = reader.ReadUShort();
        }

        #endregion
    }
}
