﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.OpenType.Tables.Utils;
using Telerik.Windows.Documents.Core.Fonts.Utils;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables
{
    internal class SubRule : TableBase
    {
        #region Constructors

        public SubRule(OpenTypeFontSourceBase fontFile)
            : base(fontFile)
        {
        }

        #endregion


        #region Fields

        private ushort[] input;
        private SubstLookupRecord[] substitutions;

        #endregion


        #region Properties
        #endregion


        #region Methods

        public bool IsMatch(GlyphsSequence glyphIDs, int startIndex)
        {
            for (int i = 0; i < this.input.Length; i++)
            {
                if (glyphIDs[startIndex + i + 1].GlyphId != this.input[i])
                {
                    return false;
                }
            }
            return true;
        }

        #endregion


        #region Overrides

        public override void Read(OpenTypeFontReader reader)
        {
            ushort glyphCount = reader.ReadUShort();
            ushort substCount = reader.ReadUShort();
            this.input = new ushort[glyphCount];
            this.substitutions = new SubstLookupRecord[substCount];
            for (int i = 0; i < glyphCount; i++)
            {
                this.input[i] = reader.ReadUShort();
            }
            for (int i = 0; i < substCount; i++)
            {
                this.substitutions[i] = new SubstLookupRecord(this.FontSource);
                this.substitutions[i].Read(reader);
            }
        }

        #endregion
    }
}
