﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables.Utils
{
    internal class FeatureRecord
    {
        #region Properties

        public uint FeatureTag
        {
            get;
            private set;
        }

        public ushort FeatureOffset
        {
            get;
            private set;
        }

        #endregion


        #region Methods

        public void Read(OpenTypeFontReader reader)
        {
            this.FeatureTag = reader.ReadULong();
            this.FeatureOffset = reader.ReadUShort();
        }

        #endregion


        #region Overrides

        public override string ToString()
        {
            return Tags.GetStringFromTag(this.FeatureTag);
        }

        #endregion
    }
}
