﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables.Utils
{
    internal class LongHorMetric
    {
        #region Properties

        public ushort AdvanceWidth
        {
            get;
            private set;
        }

        public short LSB
        {
            get;
            private set;
        }

        #endregion


        #region Methods

        public void Read(OpenTypeFontReader reader)
        {
            this.AdvanceWidth = reader.ReadUShort();
            this.LSB = reader.ReadShort();
        }

        public void Write(FontWriter writer)
        {
            writer.WriteUShort(this.AdvanceWidth);
            writer.WriteShort(this.LSB);
        }

        public override string ToString()
        {
            return string.Format("AdvancedWidth: {0}; LSB: {1}", this.AdvanceWidth, this.LSB);
        }

        #endregion
    }
}
