﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables.Utils
{
    internal class NameRecord
    {
        #region Properties

        public ushort PlatformID
        {
            get;
            private set;
        }

        public ushort EncodingID
        {
            get;
            private set;
        }

        public ushort LanguageID
        {
            get;
            private set;
        }

        public ushort NameID
        {
            get;
            private set;
        }

        public ushort Length
        {
            get;
            private set;
        }

        public ushort Offset
        {
            get;
            private set;
        }

        #endregion


        #region Overrides

        public override bool Equals(object obj)
        {
            NameRecord r = obj as NameRecord;
            if (r == null)
            {
                return false;
            }
            return this.EncodingID == r.EncodingID &&
                this.LanguageID == r.LanguageID &&
                this.Length == r.Length &&
                this.NameID == r.NameID &&
                this.PlatformID == r.PlatformID;
        }

        public override int GetHashCode()
        {
            unchecked
            {
                int result = 17;
                result = result * 23 + this.PlatformID.GetHashCode();
                result = result * 23 + this.EncodingID.GetHashCode();
                result = result * 23 + this.LanguageID.GetHashCode();
                result = result * 23 + this.NameID.GetHashCode();
                result = result * 23 + this.Length.GetHashCode();
                return result;
            }
        }

        public void Read(OpenTypeFontReader reader)
        {
            this.PlatformID = reader.ReadUShort();
            this.EncodingID = reader.ReadUShort();
            this.LanguageID = reader.ReadUShort();
            this.NameID = reader.ReadUShort();
            this.Length = reader.ReadUShort();
            this.Offset = reader.ReadUShort();
        }

        #endregion
    }
}
