﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables.Utils
{
    internal class RangeRecord
    {
        #region Properties

        public ushort Start
        {
            get;
            private set;
        }

        public ushort End
        {
            get;
            private set;
        }

        public ushort StartCoverageIndex
        {
            get;
            private set;
        }

        #endregion


        #region Methods

        public int GetCoverageIndex(ushort glyphIndex)
        {
            return this.StartCoverageIndex + glyphIndex - this.Start;
        }

        public void Read(OpenTypeFontReader reader)
        {
            this.Start = reader.ReadUShort();
            this.End = reader.ReadUShort();
            this.StartCoverageIndex = reader.ReadUShort();
        }

        internal void Write(FontWriter writer)
        {
            writer.WriteUShort(this.Start);
            writer.WriteUShort(this.End);
            writer.WriteUShort(this.StartCoverageIndex);
        }

        #endregion
    }
}
