﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables.Utils
{
    internal class ScriptRecord
    {

        #region Properties

        public uint ScriptTag
        {
            get;
            private set;
        }

        public ushort ScriptOffset
        {
            get;
            private set;
        }

        #endregion


        #region Methods

        public void Read(OpenTypeFontReader reader)
        {
            this.ScriptTag = reader.ReadULong();
            this.ScriptOffset = reader.ReadUShort();
        }

        #endregion


        #region Overrides

        public override string ToString()
        {
            return Tags.GetStringFromTag(this.ScriptTag);
        }

        #endregion
    }
}
