﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables.Utils
{
    internal class Sequence
    {
        #region Properties

        public ushort[] Subsitutes
        {
            get;
            private set;
        }

        #endregion


        #region Methods

        public void Read(OpenTypeFontReader reader)
        {
            ushort count = reader.ReadUShort();
            this.Subsitutes = new ushort[count];
            for (int i = 0; i < count; i ++)
            {
                this.Subsitutes[i] = reader.ReadUShort();
            }
        }

        internal void Write(FontWriter writer)
        {
            writer.WriteUShort((ushort)this.Subsitutes.Length);
            for (int i = 0; i < this.Subsitutes.Length; i++)
            {
                writer.WriteUShort(this.Subsitutes[i]);
            }
        }

        internal void Import(OpenTypeFontReader reader)
        {
            this.Read(reader);
        }

        #endregion

        
    }
}
