﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType.Tables.Utils
{
    internal class SubstLookupRecord : TableBase
    {
        #region Constructors

        public SubstLookupRecord(OpenTypeFontSourceBase fontFile)
            : base(fontFile)
        {
        }

        #endregion


        #region Fields

        private ushort lookupIndex;
        private Lookup lookup;

        #endregion

        #region Properties

        public ushort SequenceIndex
        {
            get;
            private set;
        }

        public Lookup Lookup
        {
            get
            {
                if (this.lookup == null)
                {
                    this.lookup = this.FontSource.GetLookup(this.lookupIndex);
                }
                return this.lookup;
            }
        }
        

        #endregion


        #region Methods

        public override void Read(OpenTypeFontReader reader)
        {
            this.SequenceIndex = reader.ReadUShort();
            this.lookupIndex = reader.ReadUShort();
        }

        #endregion
    }
}
