﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.OpenType.Tables;

namespace Telerik.Windows.Documents.Core.Fonts.OpenType
{
    internal class TrueTypeCollection
    {
        #region Constructors

        public TrueTypeCollection(OpenTypeFontReader reader)
        {
            this.reader = reader;
        }

        #endregion


        #region Fields

        private readonly OpenTypeFontReader reader;
        private TCCHeader header;

        #endregion


        #region Properties

        internal OpenTypeFontReader Reader
        {
            get
            {
                return this.reader;
            }
        }

        public IEnumerable<OpenTypeFontSourceBase> Fonts
        {
            get
            {
                return this.header.Fonts;
            }
        }

        #endregion


        #region Methods

        public void Initialize()
        {
            this.header = new TCCHeader(this);
            this.header.Read(this.Reader);
        }

        #endregion
    }
}
