﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Core.Fonts.Type1
{
    internal class CFFFontReader : ReaderBase
    {
        #region Constructors

        public CFFFontReader(byte[] data)
            : base(data)
        {
        }

        #endregion


        #region Properties
        #endregion


        #region Methods

        public byte ReadCard8()
        {
            return Read();
        }

        public ushort ReadCard16()
        {
            byte[] bytes = new byte[2];
            this.ReadBE(bytes, 2);
            return BitConverter.ToUInt16(bytes, 0);
        }

        public uint ReadCard24()
        {
            byte[] bytes = new byte[4];
            this.ReadBE(bytes, 3);
            return BitConverter.ToUInt32(bytes, 0);
        }

        public uint ReadCard32()
        {
            byte[] bytes = new byte[4];
            this.ReadBE(bytes, 4);
            return BitConverter.ToUInt32(bytes, 0);
        }

        public uint ReadOffset(byte offsetSize)
        {
            switch (offsetSize)
            {
                case 1:
                    return this.ReadCard8();
                case 2:
                    return this.ReadCard16();
                case 3:
                    return this.ReadCard24();
                case 4:
                    return this.ReadCard32();
                default:
                    throw new NotSupportedException();
            }
        }

        public byte ReadOffSize()
        {
            return this.ReadCard8();
        }

        public ushort ReadSID()
        {
            return this.ReadCard16();
        }

        public string ReadString(int length)
        {
            byte[] bytes = new byte[length];
            this.Read(bytes, length);
            return System.Text.Encoding.UTF8.GetString(bytes, 0, bytes.Length);
        }

        #endregion


        #region Overrides
        #endregion
    }
}
