﻿namespace Telerik.Windows.Documents.Core.Fonts.Type1.CFFFormat.CFFTables
{
    internal abstract class CFFTable
    {
        #region Constructors

        public CFFTable(ICFFFontFile file, long offset)
        {
            this.file = file;
            this.offset = offset;
        }

        #endregion


        #region Fields

        private readonly ICFFFontFile file;
        private readonly long offset;

        #endregion


        #region Properties

        protected CFFFontReader Reader
        {
            get
            {
                return this.file.Reader;
            }
        }

        internal ICFFFontFile File
        {
            get
            {
                return this.file;
            }
        }

        public long Offset
        {
            get
            {
                return this.offset;
            }
        }


        #endregion


        #region Methods

        public abstract void Read(CFFFontReader reader);

        #endregion
    }
}
