﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.CFFFormat.CFFTables
{
    internal class NameIndex : Index
    {
        #region Constructors

        public NameIndex(ICFFFontFile file, long offset)
            : base(file, offset)
        {
        }

        #endregion


        #region Fields

        private string[] names;


        #endregion


        #region Indexers

        public string this[ushort sid]
        {
            get
            {
                return this.GetString(sid);
            }
        }

        #endregion


        #region Methods

        private string ReadString(CFFFontReader reader, uint offset, int length)
        {
            reader.BeginReadingBlock();
            reader.Seek(this.DataOffset + offset, System.IO.SeekOrigin.Begin);
            string res = reader.ReadString(length);
            reader.EndReadingBlock();
            return res;
        }
        private string GetString(int index)
        {
            if (this.names[index] == null)
            {
                this.names[index] = this.ReadString(this.Reader, this.Offsets[index], this.GetDataLength(index));
            }
            return this.names[index];
        }
        #endregion


        #region Overrides

        public override void Read(CFFFontReader reader)
        {
            base.Read(reader);
            if (this.Count == 0)
            {
                return;
            }
            this.names = new string[this.Count];
        }

        #endregion
    }
}
