﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.CFFFormat.CFFTables
{
    internal class TopIndex : Index
    {
        #region Constructors

        public TopIndex(ICFFFontFile file, long offset)
            : base(file, offset)
        {
        }

        #endregion


        #region Fields

        private Top[] tops;

        #endregion


        #region Indexers

        public Top this[int index]
        {
            get
            {
                return this.GetTop(index);
            }
        }

        #endregion


        #region Methods

        private Top ReadTop(CFFFontReader reader, uint offset, int length)
        {
            reader.BeginReadingBlock();
            long topOffset = this.DataOffset + offset;
            reader.Seek(topOffset, System.IO.SeekOrigin.Begin);
            Top t = new Top(this.File, topOffset, length);
            t.Read(reader);
            reader.EndReadingBlock();
            return t;
        }
        private Top GetTop(int index)
        {
            if (this.tops[index] == null)
            {
                this.tops[index] = this.ReadTop(this.Reader, this.Offsets[index], this.GetDataLength(index));
            }
            return this.tops[index];
        }

        #endregion


        #region Overrides

        public override void Read(CFFFontReader reader)
        {
            base.Read(reader);
            if (this.Count == 0)
            {
                return;
            }
            this.tops = new Top[this.Count];
        }

        #endregion
    }
}
