﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.CFFFormat.Data
{
    internal class PredefinedCharset
    {
        #region StaticMembers
        public static PredefinedCharset ISOAdobeCharset;
        public static PredefinedCharset ExpertCharset;
        public static PredefinedCharset ExpertSubsetCharset;

        public static ushort[] GetPredefinedCodes(int b)
        {
            switch (b)
            {
                case 0:
                    return PredefinedCharset.ISOAdobeCharset.GetCodes();
                case 1:
                    return PredefinedCharset.ExpertCharset.GetCodes();
                case 2:
                    return PredefinedCharset.ExpertSubsetCharset.GetCodes();
            }
            return null;
        }

        public static bool IsPredefinedCharset(int b)
        {
            return b == 0 || b == 1 || b == 2;
        }

        private static void InitializeExpertSubsetCharset()
        {
            ExpertSubsetCharset = new PredefinedCharset();
            ExpertSubsetCharset.codes = new ushort[86];
            ExpertSubsetCharset.codes[0] = 1;
            ExpertSubsetCharset.codes[1] = 231;
            ExpertSubsetCharset.codes[2] = 232;
            ExpertSubsetCharset.codes[3] = 235;
            ExpertSubsetCharset.codes[4] = 236;
            ExpertSubsetCharset.codes[5] = 237;
            ExpertSubsetCharset.codes[6] = 238;
            ExpertSubsetCharset.codes[7] = 13;
            ExpertSubsetCharset.codes[8] = 14;
            ExpertSubsetCharset.codes[9] = 15;
            ExpertSubsetCharset.codes[10] = 99;
            ExpertSubsetCharset.codes[11] = 239;
            ExpertSubsetCharset.codes[12] = 240;
            ExpertSubsetCharset.codes[13] = 241;
            ExpertSubsetCharset.codes[14] = 242;
            ExpertSubsetCharset.codes[15] = 243;
            ExpertSubsetCharset.codes[16] = 244;
            ExpertSubsetCharset.codes[17] = 245;
            ExpertSubsetCharset.codes[18] = 246;
            ExpertSubsetCharset.codes[19] = 247;
            ExpertSubsetCharset.codes[20] = 248;
            ExpertSubsetCharset.codes[21] = 27;
            ExpertSubsetCharset.codes[22] = 28;
            ExpertSubsetCharset.codes[23] = 249;
            ExpertSubsetCharset.codes[24] = 250;
            ExpertSubsetCharset.codes[25] = 251;
            ExpertSubsetCharset.codes[26] = 253;
            ExpertSubsetCharset.codes[27] = 254;
            ExpertSubsetCharset.codes[28] = 255;
            ExpertSubsetCharset.codes[29] = 256;
            ExpertSubsetCharset.codes[30] = 257;
            ExpertSubsetCharset.codes[31] = 258;
            ExpertSubsetCharset.codes[32] = 259;
            ExpertSubsetCharset.codes[33] = 260;
            ExpertSubsetCharset.codes[34] = 261;
            ExpertSubsetCharset.codes[35] = 262;
            ExpertSubsetCharset.codes[36] = 263;
            ExpertSubsetCharset.codes[37] = 264;
            ExpertSubsetCharset.codes[38] = 265;
            ExpertSubsetCharset.codes[39] = 266;
            ExpertSubsetCharset.codes[40] = 109;
            ExpertSubsetCharset.codes[41] = 110;
            ExpertSubsetCharset.codes[42] = 267;
            ExpertSubsetCharset.codes[43] = 268;
            ExpertSubsetCharset.codes[44] = 269;
            ExpertSubsetCharset.codes[45] = 270;
            ExpertSubsetCharset.codes[46] = 272;
            ExpertSubsetCharset.codes[47] = 300;
            ExpertSubsetCharset.codes[48] = 301;
            ExpertSubsetCharset.codes[49] = 302;
            ExpertSubsetCharset.codes[50] = 305;
            ExpertSubsetCharset.codes[51] = 314;
            ExpertSubsetCharset.codes[52] = 315;
            ExpertSubsetCharset.codes[53] = 158;
            ExpertSubsetCharset.codes[54] = 155;
            ExpertSubsetCharset.codes[55] = 163;
            ExpertSubsetCharset.codes[56] = 320;
            ExpertSubsetCharset.codes[57] = 321;
            ExpertSubsetCharset.codes[58] = 322;
            ExpertSubsetCharset.codes[59] = 323;
            ExpertSubsetCharset.codes[60] = 324;
            ExpertSubsetCharset.codes[61] = 325;
            ExpertSubsetCharset.codes[62] = 326;
            ExpertSubsetCharset.codes[63] = 150;
            ExpertSubsetCharset.codes[64] = 164;
            ExpertSubsetCharset.codes[65] = 169;
            ExpertSubsetCharset.codes[66] = 327;
            ExpertSubsetCharset.codes[67] = 328;
            ExpertSubsetCharset.codes[68] = 329;
            ExpertSubsetCharset.codes[69] = 330;
            ExpertSubsetCharset.codes[70] = 331;
            ExpertSubsetCharset.codes[71] = 332;
            ExpertSubsetCharset.codes[72] = 333;
            ExpertSubsetCharset.codes[73] = 334;
            ExpertSubsetCharset.codes[74] = 335;
            ExpertSubsetCharset.codes[75] = 336;
            ExpertSubsetCharset.codes[76] = 337;
            ExpertSubsetCharset.codes[77] = 338;
            ExpertSubsetCharset.codes[78] = 339;
            ExpertSubsetCharset.codes[79] = 340;
            ExpertSubsetCharset.codes[80] = 341;
            ExpertSubsetCharset.codes[81] = 342;
            ExpertSubsetCharset.codes[82] = 343;
            ExpertSubsetCharset.codes[83] = 344;
            ExpertSubsetCharset.codes[84] = 345;
            ExpertSubsetCharset.codes[85] = 346;
        }

        private static void InitializeExpertCharset()
        {
            ExpertCharset = new PredefinedCharset();
            ExpertCharset.codes = new ushort[165];
            ExpertCharset.codes[0] = 1;
            ExpertCharset.codes[1] = 229;
            ExpertCharset.codes[2] = 230;
            ExpertCharset.codes[3] = 231;
            ExpertCharset.codes[4] = 232;
            ExpertCharset.codes[5] = 233;
            ExpertCharset.codes[6] = 234;
            ExpertCharset.codes[7] = 235;
            ExpertCharset.codes[8] = 236;
            ExpertCharset.codes[9] = 237;
            ExpertCharset.codes[10] = 238;
            ExpertCharset.codes[11] = 13;
            ExpertCharset.codes[12] = 14;
            ExpertCharset.codes[13] = 15;
            ExpertCharset.codes[14] = 99;
            ExpertCharset.codes[15] = 239;
            ExpertCharset.codes[16] = 240;
            ExpertCharset.codes[17] = 241;
            ExpertCharset.codes[18] = 242;
            ExpertCharset.codes[19] = 243;
            ExpertCharset.codes[20] = 244;
            ExpertCharset.codes[21] = 245;
            ExpertCharset.codes[22] = 246;
            ExpertCharset.codes[23] = 247;
            ExpertCharset.codes[24] = 248;
            ExpertCharset.codes[25] = 27;
            ExpertCharset.codes[26] = 28;
            ExpertCharset.codes[27] = 249;
            ExpertCharset.codes[28] = 250;
            ExpertCharset.codes[29] = 251;
            ExpertCharset.codes[30] = 252;
            ExpertCharset.codes[31] = 253;
            ExpertCharset.codes[32] = 254;
            ExpertCharset.codes[33] = 255;
            ExpertCharset.codes[34] = 256;
            ExpertCharset.codes[35] = 257;
            ExpertCharset.codes[36] = 258;
            ExpertCharset.codes[37] = 259;
            ExpertCharset.codes[38] = 260;
            ExpertCharset.codes[39] = 261;
            ExpertCharset.codes[40] = 262;
            ExpertCharset.codes[41] = 263;
            ExpertCharset.codes[42] = 264;
            ExpertCharset.codes[43] = 265;
            ExpertCharset.codes[44] = 266;
            ExpertCharset.codes[45] = 109;
            ExpertCharset.codes[46] = 110;
            ExpertCharset.codes[47] = 267;
            ExpertCharset.codes[48] = 268;
            ExpertCharset.codes[49] = 269;
            ExpertCharset.codes[50] = 270;
            ExpertCharset.codes[51] = 271;
            ExpertCharset.codes[52] = 272;
            ExpertCharset.codes[53] = 273;
            ExpertCharset.codes[54] = 274;
            ExpertCharset.codes[55] = 275;
            ExpertCharset.codes[56] = 276;
            ExpertCharset.codes[57] = 277;
            ExpertCharset.codes[58] = 278;
            ExpertCharset.codes[59] = 279;
            ExpertCharset.codes[60] = 280;
            ExpertCharset.codes[61] = 281;
            ExpertCharset.codes[62] = 282;
            ExpertCharset.codes[63] = 283;
            ExpertCharset.codes[64] = 284;
            ExpertCharset.codes[65] = 285;
            ExpertCharset.codes[66] = 286;
            ExpertCharset.codes[67] = 287;
            ExpertCharset.codes[68] = 288;
            ExpertCharset.codes[69] = 289;
            ExpertCharset.codes[70] = 290;
            ExpertCharset.codes[71] = 291;
            ExpertCharset.codes[72] = 292;
            ExpertCharset.codes[73] = 293;
            ExpertCharset.codes[74] = 294;
            ExpertCharset.codes[75] = 295;
            ExpertCharset.codes[76] = 296;
            ExpertCharset.codes[77] = 297;
            ExpertCharset.codes[78] = 298;
            ExpertCharset.codes[79] = 299;
            ExpertCharset.codes[80] = 300;
            ExpertCharset.codes[81] = 301;
            ExpertCharset.codes[82] = 302;
            ExpertCharset.codes[83] = 303;
            ExpertCharset.codes[84] = 304;
            ExpertCharset.codes[85] = 305;
            ExpertCharset.codes[86] = 306;
            ExpertCharset.codes[87] = 307;
            ExpertCharset.codes[88] = 308;
            ExpertCharset.codes[89] = 309;
            ExpertCharset.codes[90] = 310;
            ExpertCharset.codes[91] = 311;
            ExpertCharset.codes[92] = 312;
            ExpertCharset.codes[93] = 313;
            ExpertCharset.codes[94] = 314;
            ExpertCharset.codes[95] = 315;
            ExpertCharset.codes[96] = 316;
            ExpertCharset.codes[97] = 317;
            ExpertCharset.codes[98] = 318;
            ExpertCharset.codes[99] = 158;
            ExpertCharset.codes[100] = 155;
            ExpertCharset.codes[101] = 163;
            ExpertCharset.codes[102] = 319;
            ExpertCharset.codes[103] = 320;
            ExpertCharset.codes[104] = 321;
            ExpertCharset.codes[105] = 322;
            ExpertCharset.codes[106] = 323;
            ExpertCharset.codes[107] = 324;
            ExpertCharset.codes[108] = 325;
            ExpertCharset.codes[109] = 326;
            ExpertCharset.codes[110] = 150;
            ExpertCharset.codes[111] = 164;
            ExpertCharset.codes[112] = 169;
            ExpertCharset.codes[113] = 327;
            ExpertCharset.codes[114] = 328;
            ExpertCharset.codes[115] = 329;
            ExpertCharset.codes[116] = 330;
            ExpertCharset.codes[117] = 331;
            ExpertCharset.codes[118] = 332;
            ExpertCharset.codes[119] = 333;
            ExpertCharset.codes[120] = 334;
            ExpertCharset.codes[121] = 335;
            ExpertCharset.codes[122] = 336;
            ExpertCharset.codes[123] = 337;
            ExpertCharset.codes[124] = 338;
            ExpertCharset.codes[125] = 339;
            ExpertCharset.codes[126] = 340;
            ExpertCharset.codes[127] = 341;
            ExpertCharset.codes[128] = 342;
            ExpertCharset.codes[129] = 343;
            ExpertCharset.codes[130] = 344;
            ExpertCharset.codes[131] = 345;
            ExpertCharset.codes[132] = 346;
            ExpertCharset.codes[133] = 347;
            ExpertCharset.codes[134] = 348;
            ExpertCharset.codes[135] = 349;
            ExpertCharset.codes[136] = 350;
            ExpertCharset.codes[137] = 351;
            ExpertCharset.codes[138] = 352;
            ExpertCharset.codes[139] = 353;
            ExpertCharset.codes[140] = 354;
            ExpertCharset.codes[141] = 355;
            ExpertCharset.codes[142] = 356;
            ExpertCharset.codes[143] = 357;
            ExpertCharset.codes[144] = 358;
            ExpertCharset.codes[145] = 359;
            ExpertCharset.codes[146] = 360;
            ExpertCharset.codes[147] = 361;
            ExpertCharset.codes[148] = 362;
            ExpertCharset.codes[149] = 363;
            ExpertCharset.codes[150] = 364;
            ExpertCharset.codes[151] = 365;
            ExpertCharset.codes[152] = 366;
            ExpertCharset.codes[153] = 367;
            ExpertCharset.codes[154] = 368;
            ExpertCharset.codes[155] = 369;
            ExpertCharset.codes[156] = 370;
            ExpertCharset.codes[157] = 371;
            ExpertCharset.codes[158] = 372;
            ExpertCharset.codes[159] = 373;
            ExpertCharset.codes[160] = 374;
            ExpertCharset.codes[161] = 375;
            ExpertCharset.codes[162] = 376;
            ExpertCharset.codes[163] = 377;
            ExpertCharset.codes[164] = 378;
        }

        private static void InitializeISOAdobeCharset()
        {
            ISOAdobeCharset = new PredefinedCharset();
            ISOAdobeCharset.codes = new ushort[229];
            ISOAdobeCharset.codes[0] = 1;
            ISOAdobeCharset.codes[1] = 2;
            ISOAdobeCharset.codes[2] = 3;
            ISOAdobeCharset.codes[3] = 4;
            ISOAdobeCharset.codes[4] = 5;
            ISOAdobeCharset.codes[5] = 6;
            ISOAdobeCharset.codes[6] = 7;
            ISOAdobeCharset.codes[7] = 8;
            ISOAdobeCharset.codes[8] = 9;
            ISOAdobeCharset.codes[9] = 10;
            ISOAdobeCharset.codes[10] = 11;
            ISOAdobeCharset.codes[11] = 12;
            ISOAdobeCharset.codes[12] = 13;
            ISOAdobeCharset.codes[13] = 14;
            ISOAdobeCharset.codes[14] = 15;
            ISOAdobeCharset.codes[15] = 16;
            ISOAdobeCharset.codes[16] = 17;
            ISOAdobeCharset.codes[17] = 18;
            ISOAdobeCharset.codes[18] = 19;
            ISOAdobeCharset.codes[19] = 20;
            ISOAdobeCharset.codes[20] = 21;
            ISOAdobeCharset.codes[21] = 22;
            ISOAdobeCharset.codes[22] = 23;
            ISOAdobeCharset.codes[23] = 24;
            ISOAdobeCharset.codes[24] = 25;
            ISOAdobeCharset.codes[25] = 26;
            ISOAdobeCharset.codes[26] = 27;
            ISOAdobeCharset.codes[27] = 28;
            ISOAdobeCharset.codes[28] = 29;
            ISOAdobeCharset.codes[29] = 30;
            ISOAdobeCharset.codes[30] = 31;
            ISOAdobeCharset.codes[31] = 32;
            ISOAdobeCharset.codes[32] = 33;
            ISOAdobeCharset.codes[33] = 34;
            ISOAdobeCharset.codes[34] = 35;
            ISOAdobeCharset.codes[35] = 36;
            ISOAdobeCharset.codes[36] = 37;
            ISOAdobeCharset.codes[37] = 38;
            ISOAdobeCharset.codes[38] = 39;
            ISOAdobeCharset.codes[39] = 40;
            ISOAdobeCharset.codes[40] = 41;
            ISOAdobeCharset.codes[41] = 42;
            ISOAdobeCharset.codes[42] = 43;
            ISOAdobeCharset.codes[43] = 44;
            ISOAdobeCharset.codes[44] = 45;
            ISOAdobeCharset.codes[45] = 46;
            ISOAdobeCharset.codes[46] = 47;
            ISOAdobeCharset.codes[47] = 48;
            ISOAdobeCharset.codes[48] = 49;
            ISOAdobeCharset.codes[49] = 50;
            ISOAdobeCharset.codes[50] = 51;
            ISOAdobeCharset.codes[51] = 52;
            ISOAdobeCharset.codes[52] = 53;
            ISOAdobeCharset.codes[53] = 54;
            ISOAdobeCharset.codes[54] = 55;
            ISOAdobeCharset.codes[55] = 56;
            ISOAdobeCharset.codes[56] = 57;
            ISOAdobeCharset.codes[57] = 58;
            ISOAdobeCharset.codes[58] = 59;
            ISOAdobeCharset.codes[59] = 60;
            ISOAdobeCharset.codes[60] = 61;
            ISOAdobeCharset.codes[61] = 62;
            ISOAdobeCharset.codes[62] = 63;
            ISOAdobeCharset.codes[63] = 64;
            ISOAdobeCharset.codes[64] = 65;
            ISOAdobeCharset.codes[65] = 66;
            ISOAdobeCharset.codes[66] = 67;
            ISOAdobeCharset.codes[67] = 68;
            ISOAdobeCharset.codes[68] = 69;
            ISOAdobeCharset.codes[69] = 70;
            ISOAdobeCharset.codes[70] = 71;
            ISOAdobeCharset.codes[71] = 72;
            ISOAdobeCharset.codes[72] = 73;
            ISOAdobeCharset.codes[73] = 74;
            ISOAdobeCharset.codes[74] = 75;
            ISOAdobeCharset.codes[75] = 76;
            ISOAdobeCharset.codes[76] = 77;
            ISOAdobeCharset.codes[77] = 78;
            ISOAdobeCharset.codes[78] = 79;
            ISOAdobeCharset.codes[79] = 80;
            ISOAdobeCharset.codes[80] = 81;
            ISOAdobeCharset.codes[81] = 82;
            ISOAdobeCharset.codes[82] = 83;
            ISOAdobeCharset.codes[83] = 84;
            ISOAdobeCharset.codes[84] = 85;
            ISOAdobeCharset.codes[85] = 86;
            ISOAdobeCharset.codes[86] = 87;
            ISOAdobeCharset.codes[87] = 88;
            ISOAdobeCharset.codes[88] = 89;
            ISOAdobeCharset.codes[89] = 90;
            ISOAdobeCharset.codes[90] = 91;
            ISOAdobeCharset.codes[91] = 92;
            ISOAdobeCharset.codes[92] = 93;
            ISOAdobeCharset.codes[93] = 94;
            ISOAdobeCharset.codes[94] = 95;
            ISOAdobeCharset.codes[95] = 96;
            ISOAdobeCharset.codes[96] = 97;
            ISOAdobeCharset.codes[97] = 98;
            ISOAdobeCharset.codes[98] = 99;
            ISOAdobeCharset.codes[99] = 100;
            ISOAdobeCharset.codes[100] = 101;
            ISOAdobeCharset.codes[101] = 102;
            ISOAdobeCharset.codes[102] = 103;
            ISOAdobeCharset.codes[103] = 104;
            ISOAdobeCharset.codes[104] = 105;
            ISOAdobeCharset.codes[105] = 106;
            ISOAdobeCharset.codes[106] = 107;
            ISOAdobeCharset.codes[107] = 108;
            ISOAdobeCharset.codes[108] = 109;
            ISOAdobeCharset.codes[109] = 110;
            ISOAdobeCharset.codes[110] = 111;
            ISOAdobeCharset.codes[111] = 112;
            ISOAdobeCharset.codes[112] = 113;
            ISOAdobeCharset.codes[113] = 114;
            ISOAdobeCharset.codes[114] = 115;
            ISOAdobeCharset.codes[115] = 116;
            ISOAdobeCharset.codes[116] = 117;
            ISOAdobeCharset.codes[117] = 118;
            ISOAdobeCharset.codes[118] = 119;
            ISOAdobeCharset.codes[119] = 120;
            ISOAdobeCharset.codes[120] = 121;
            ISOAdobeCharset.codes[121] = 122;
            ISOAdobeCharset.codes[122] = 123;
            ISOAdobeCharset.codes[123] = 124;
            ISOAdobeCharset.codes[124] = 125;
            ISOAdobeCharset.codes[125] = 126;
            ISOAdobeCharset.codes[126] = 127;
            ISOAdobeCharset.codes[127] = 128;
            ISOAdobeCharset.codes[128] = 129;
            ISOAdobeCharset.codes[129] = 130;
            ISOAdobeCharset.codes[130] = 131;
            ISOAdobeCharset.codes[131] = 132;
            ISOAdobeCharset.codes[132] = 133;
            ISOAdobeCharset.codes[133] = 134;
            ISOAdobeCharset.codes[134] = 135;
            ISOAdobeCharset.codes[135] = 136;
            ISOAdobeCharset.codes[136] = 137;
            ISOAdobeCharset.codes[137] = 138;
            ISOAdobeCharset.codes[138] = 139;
            ISOAdobeCharset.codes[139] = 140;
            ISOAdobeCharset.codes[140] = 141;
            ISOAdobeCharset.codes[141] = 142;
            ISOAdobeCharset.codes[142] = 143;
            ISOAdobeCharset.codes[143] = 144;
            ISOAdobeCharset.codes[144] = 145;
            ISOAdobeCharset.codes[145] = 146;
            ISOAdobeCharset.codes[146] = 147;
            ISOAdobeCharset.codes[147] = 148;
            ISOAdobeCharset.codes[148] = 149;
            ISOAdobeCharset.codes[149] = 150;
            ISOAdobeCharset.codes[150] = 151;
            ISOAdobeCharset.codes[151] = 152;
            ISOAdobeCharset.codes[152] = 153;
            ISOAdobeCharset.codes[153] = 154;
            ISOAdobeCharset.codes[154] = 155;
            ISOAdobeCharset.codes[155] = 156;
            ISOAdobeCharset.codes[156] = 157;
            ISOAdobeCharset.codes[157] = 158;
            ISOAdobeCharset.codes[158] = 159;
            ISOAdobeCharset.codes[159] = 160;
            ISOAdobeCharset.codes[160] = 161;
            ISOAdobeCharset.codes[161] = 162;
            ISOAdobeCharset.codes[162] = 163;
            ISOAdobeCharset.codes[163] = 164;
            ISOAdobeCharset.codes[164] = 165;
            ISOAdobeCharset.codes[165] = 166;
            ISOAdobeCharset.codes[166] = 167;
            ISOAdobeCharset.codes[167] = 168;
            ISOAdobeCharset.codes[168] = 169;
            ISOAdobeCharset.codes[169] = 170;
            ISOAdobeCharset.codes[170] = 171;
            ISOAdobeCharset.codes[171] = 172;
            ISOAdobeCharset.codes[172] = 173;
            ISOAdobeCharset.codes[173] = 174;
            ISOAdobeCharset.codes[174] = 175;
            ISOAdobeCharset.codes[175] = 176;
            ISOAdobeCharset.codes[176] = 177;
            ISOAdobeCharset.codes[177] = 178;
            ISOAdobeCharset.codes[178] = 179;
            ISOAdobeCharset.codes[179] = 180;
            ISOAdobeCharset.codes[180] = 181;
            ISOAdobeCharset.codes[181] = 182;
            ISOAdobeCharset.codes[182] = 183;
            ISOAdobeCharset.codes[183] = 184;
            ISOAdobeCharset.codes[184] = 185;
            ISOAdobeCharset.codes[185] = 186;
            ISOAdobeCharset.codes[186] = 187;
            ISOAdobeCharset.codes[187] = 188;
            ISOAdobeCharset.codes[188] = 189;
            ISOAdobeCharset.codes[189] = 190;
            ISOAdobeCharset.codes[190] = 191;
            ISOAdobeCharset.codes[191] = 192;
            ISOAdobeCharset.codes[192] = 193;
            ISOAdobeCharset.codes[193] = 194;
            ISOAdobeCharset.codes[194] = 195;
            ISOAdobeCharset.codes[195] = 196;
            ISOAdobeCharset.codes[196] = 197;
            ISOAdobeCharset.codes[197] = 198;
            ISOAdobeCharset.codes[198] = 199;
            ISOAdobeCharset.codes[199] = 200;
            ISOAdobeCharset.codes[200] = 201;
            ISOAdobeCharset.codes[201] = 202;
            ISOAdobeCharset.codes[202] = 203;
            ISOAdobeCharset.codes[203] = 204;
            ISOAdobeCharset.codes[204] = 205;
            ISOAdobeCharset.codes[205] = 206;
            ISOAdobeCharset.codes[206] = 207;
            ISOAdobeCharset.codes[207] = 208;
            ISOAdobeCharset.codes[208] = 209;
            ISOAdobeCharset.codes[209] = 210;
            ISOAdobeCharset.codes[210] = 211;
            ISOAdobeCharset.codes[211] = 212;
            ISOAdobeCharset.codes[212] = 213;
            ISOAdobeCharset.codes[213] = 214;
            ISOAdobeCharset.codes[214] = 215;
            ISOAdobeCharset.codes[215] = 216;
            ISOAdobeCharset.codes[216] = 217;
            ISOAdobeCharset.codes[217] = 218;
            ISOAdobeCharset.codes[218] = 219;
            ISOAdobeCharset.codes[219] = 220;
            ISOAdobeCharset.codes[220] = 221;
            ISOAdobeCharset.codes[221] = 222;
            ISOAdobeCharset.codes[222] = 223;
            ISOAdobeCharset.codes[223] = 224;
            ISOAdobeCharset.codes[224] = 225;
            ISOAdobeCharset.codes[225] = 226;
            ISOAdobeCharset.codes[226] = 227;
            ISOAdobeCharset.codes[227] = 228;

        }

        #endregion


        #region Constructors

        static PredefinedCharset()
        {
            InitializeISOAdobeCharset();
            InitializeExpertCharset();
            InitializeExpertSubsetCharset();
        }

        #endregion


        #region Fields

        private ushort[] codes;

        #endregion


        #region Methods

        private ushort[] GetCodes()
        {
            return Enumerable.ToArray(this.codes);
        }
        #endregion
    }
}
