﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.PostScript.Data;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.CFFFormat.Data
{
    internal class PredefinedEncoding : IEncoding
    {
        #region StaticMembers
        public static PredefinedEncoding StandardEncoding { get;private set; }
        public static PredefinedEncoding ExpertEncoding { get;private set; }

        public static PredefinedEncoding GetPredefinedEncoding(int b)
        {
            switch (b)
            {
                case 0:
                    return PredefinedEncoding.StandardEncoding;
                case 1:
                    return PredefinedEncoding.ExpertEncoding;
            }
            return null;
        }

        public static bool IsPredefinedEncoding(int b)
        {
            return b == 0 || b == 1;
        }

        private static void InitializeExpertEncoding()
        {
            ExpertEncoding = new PredefinedEncoding();
            ExpertEncoding.sids[0] = 0;
            ExpertEncoding.sids[1] = 0;
            ExpertEncoding.sids[2] = 0;
            ExpertEncoding.sids[3] = 0;
            ExpertEncoding.sids[4] = 0;
            ExpertEncoding.sids[5] = 0;
            ExpertEncoding.sids[6] = 0;
            ExpertEncoding.sids[7] = 0;
            ExpertEncoding.sids[8] = 0;
            ExpertEncoding.sids[9] = 0;
            ExpertEncoding.sids[10] = 0;
            ExpertEncoding.sids[11] = 0;
            ExpertEncoding.sids[12] = 0;
            ExpertEncoding.sids[13] = 0;
            ExpertEncoding.sids[14] = 0;
            ExpertEncoding.sids[15] = 0;
            ExpertEncoding.sids[16] = 0;
            ExpertEncoding.sids[17] = 0;
            ExpertEncoding.sids[18] = 0;
            ExpertEncoding.sids[19] = 0;
            ExpertEncoding.sids[20] = 0;
            ExpertEncoding.sids[21] = 0;
            ExpertEncoding.sids[22] = 0;
            ExpertEncoding.sids[23] = 0;
            ExpertEncoding.sids[24] = 0;
            ExpertEncoding.sids[25] = 0;
            ExpertEncoding.sids[26] = 0;
            ExpertEncoding.sids[27] = 0;
            ExpertEncoding.sids[28] = 0;
            ExpertEncoding.sids[29] = 0;
            ExpertEncoding.sids[30] = 0;
            ExpertEncoding.sids[31] = 0;
            ExpertEncoding.sids[32] = 1;
            ExpertEncoding.sids[33] = 229;
            ExpertEncoding.sids[34] = 230;
            ExpertEncoding.sids[35] = 0;
            ExpertEncoding.sids[36] = 231;
            ExpertEncoding.sids[37] = 232;
            ExpertEncoding.sids[38] = 233;
            ExpertEncoding.sids[39] = 234;
            ExpertEncoding.sids[40] = 235;
            ExpertEncoding.sids[41] = 236;
            ExpertEncoding.sids[42] = 237;
            ExpertEncoding.sids[43] = 238;
            ExpertEncoding.sids[44] = 13;
            ExpertEncoding.sids[45] = 14;
            ExpertEncoding.sids[46] = 15;
            ExpertEncoding.sids[47] = 99;
            ExpertEncoding.sids[48] = 239;
            ExpertEncoding.sids[49] = 240;
            ExpertEncoding.sids[50] = 241;
            ExpertEncoding.sids[51] = 242;
            ExpertEncoding.sids[52] = 243;
            ExpertEncoding.sids[53] = 244;
            ExpertEncoding.sids[54] = 245;
            ExpertEncoding.sids[55] = 246;
            ExpertEncoding.sids[56] = 247;
            ExpertEncoding.sids[57] = 248;
            ExpertEncoding.sids[58] = 27;
            ExpertEncoding.sids[59] = 28;
            ExpertEncoding.sids[60] = 249;
            ExpertEncoding.sids[61] = 250;
            ExpertEncoding.sids[62] = 251;
            ExpertEncoding.sids[63] = 252;
            ExpertEncoding.sids[64] = 0;
            ExpertEncoding.sids[65] = 253;
            ExpertEncoding.sids[66] = 254;
            ExpertEncoding.sids[67] = 255;
            ExpertEncoding.sids[68] = 256;
            ExpertEncoding.sids[69] = 257;
            ExpertEncoding.sids[70] = 0;
            ExpertEncoding.sids[71] = 0;
            ExpertEncoding.sids[72] = 0;
            ExpertEncoding.sids[73] = 258;
            ExpertEncoding.sids[74] = 0;
            ExpertEncoding.sids[75] = 0;
            ExpertEncoding.sids[76] = 259;
            ExpertEncoding.sids[77] = 260;
            ExpertEncoding.sids[78] = 261;
            ExpertEncoding.sids[79] = 262;
            ExpertEncoding.sids[80] = 0;
            ExpertEncoding.sids[81] = 0;
            ExpertEncoding.sids[82] = 263;
            ExpertEncoding.sids[83] = 264;
            ExpertEncoding.sids[84] = 265;
            ExpertEncoding.sids[85] = 0;
            ExpertEncoding.sids[86] = 266;
            ExpertEncoding.sids[87] = 109;
            ExpertEncoding.sids[88] = 110;
            ExpertEncoding.sids[89] = 267;
            ExpertEncoding.sids[90] = 268;
            ExpertEncoding.sids[91] = 269;
            ExpertEncoding.sids[92] = 0;
            ExpertEncoding.sids[93] = 270;
            ExpertEncoding.sids[94] = 271;
            ExpertEncoding.sids[95] = 272;
            ExpertEncoding.sids[96] = 273;
            ExpertEncoding.sids[97] = 274;
            ExpertEncoding.sids[98] = 275;
            ExpertEncoding.sids[99] = 276;
            ExpertEncoding.sids[100] = 277;
            ExpertEncoding.sids[101] = 278;
            ExpertEncoding.sids[102] = 279;
            ExpertEncoding.sids[103] = 280;
            ExpertEncoding.sids[104] = 281;
            ExpertEncoding.sids[105] = 282;
            ExpertEncoding.sids[106] = 283;
            ExpertEncoding.sids[107] = 284;
            ExpertEncoding.sids[108] = 285;
            ExpertEncoding.sids[109] = 286;
            ExpertEncoding.sids[110] = 287;
            ExpertEncoding.sids[111] = 288;
            ExpertEncoding.sids[112] = 289;
            ExpertEncoding.sids[113] = 290;
            ExpertEncoding.sids[114] = 291;
            ExpertEncoding.sids[115] = 292;
            ExpertEncoding.sids[116] = 293;
            ExpertEncoding.sids[117] = 294;
            ExpertEncoding.sids[118] = 295;
            ExpertEncoding.sids[119] = 296;
            ExpertEncoding.sids[120] = 297;
            ExpertEncoding.sids[121] = 298;
            ExpertEncoding.sids[122] = 299;
            ExpertEncoding.sids[123] = 300;
            ExpertEncoding.sids[124] = 301;
            ExpertEncoding.sids[125] = 302;
            ExpertEncoding.sids[126] = 303;
            ExpertEncoding.sids[127] = 0;
            ExpertEncoding.sids[128] = 0;
            ExpertEncoding.sids[129] = 0;
            ExpertEncoding.sids[130] = 0;
            ExpertEncoding.sids[131] = 0;
            ExpertEncoding.sids[132] = 0;
            ExpertEncoding.sids[133] = 0;
            ExpertEncoding.sids[134] = 0;
            ExpertEncoding.sids[135] = 0;
            ExpertEncoding.sids[136] = 0;
            ExpertEncoding.sids[137] = 0;
            ExpertEncoding.sids[138] = 0;
            ExpertEncoding.sids[139] = 0;
            ExpertEncoding.sids[140] = 0;
            ExpertEncoding.sids[141] = 0;
            ExpertEncoding.sids[142] = 0;
            ExpertEncoding.sids[143] = 0;
            ExpertEncoding.sids[144] = 0;
            ExpertEncoding.sids[145] = 0;
            ExpertEncoding.sids[146] = 0;
            ExpertEncoding.sids[147] = 0;
            ExpertEncoding.sids[148] = 0;
            ExpertEncoding.sids[149] = 0;
            ExpertEncoding.sids[150] = 0;
            ExpertEncoding.sids[151] = 0;
            ExpertEncoding.sids[152] = 0;
            ExpertEncoding.sids[153] = 0;
            ExpertEncoding.sids[154] = 0;
            ExpertEncoding.sids[155] = 0;
            ExpertEncoding.sids[156] = 0;
            ExpertEncoding.sids[157] = 0;
            ExpertEncoding.sids[158] = 0;
            ExpertEncoding.sids[159] = 0;
            ExpertEncoding.sids[160] = 0;
            ExpertEncoding.sids[161] = 304;
            ExpertEncoding.sids[162] = 305;
            ExpertEncoding.sids[163] = 306;
            ExpertEncoding.sids[164] = 0;
            ExpertEncoding.sids[165] = 0;
            ExpertEncoding.sids[166] = 307;
            ExpertEncoding.sids[167] = 308;
            ExpertEncoding.sids[168] = 309;
            ExpertEncoding.sids[169] = 310;
            ExpertEncoding.sids[170] = 311;
            ExpertEncoding.sids[171] = 0;
            ExpertEncoding.sids[172] = 312;
            ExpertEncoding.sids[173] = 0;
            ExpertEncoding.sids[174] = 0;
            ExpertEncoding.sids[175] = 313;
            ExpertEncoding.sids[176] = 0;
            ExpertEncoding.sids[177] = 0;
            ExpertEncoding.sids[178] = 314;
            ExpertEncoding.sids[179] = 315;
            ExpertEncoding.sids[180] = 0;
            ExpertEncoding.sids[181] = 0;
            ExpertEncoding.sids[182] = 316;
            ExpertEncoding.sids[183] = 317;
            ExpertEncoding.sids[184] = 318;
            ExpertEncoding.sids[185] = 0;
            ExpertEncoding.sids[186] = 0;
            ExpertEncoding.sids[187] = 0;
            ExpertEncoding.sids[188] = 158;
            ExpertEncoding.sids[189] = 155;
            ExpertEncoding.sids[190] = 163;
            ExpertEncoding.sids[191] = 319;
            ExpertEncoding.sids[192] = 320;
            ExpertEncoding.sids[193] = 321;
            ExpertEncoding.sids[194] = 322;
            ExpertEncoding.sids[195] = 323;
            ExpertEncoding.sids[196] = 324;
            ExpertEncoding.sids[197] = 325;
            ExpertEncoding.sids[198] = 0;
            ExpertEncoding.sids[199] = 0;
            ExpertEncoding.sids[200] = 326;
            ExpertEncoding.sids[201] = 150;
            ExpertEncoding.sids[202] = 164;
            ExpertEncoding.sids[203] = 169;
            ExpertEncoding.sids[204] = 327;
            ExpertEncoding.sids[205] = 328;
            ExpertEncoding.sids[206] = 329;
            ExpertEncoding.sids[207] = 330;
            ExpertEncoding.sids[208] = 331;
            ExpertEncoding.sids[209] = 332;
            ExpertEncoding.sids[210] = 333;
            ExpertEncoding.sids[211] = 334;
            ExpertEncoding.sids[212] = 335;
            ExpertEncoding.sids[213] = 336;
            ExpertEncoding.sids[214] = 337;
            ExpertEncoding.sids[215] = 338;
            ExpertEncoding.sids[216] = 339;
            ExpertEncoding.sids[217] = 340;
            ExpertEncoding.sids[218] = 341;
            ExpertEncoding.sids[219] = 342;
            ExpertEncoding.sids[220] = 343;
            ExpertEncoding.sids[221] = 344;
            ExpertEncoding.sids[222] = 345;
            ExpertEncoding.sids[223] = 346;
            ExpertEncoding.sids[224] = 347;
            ExpertEncoding.sids[225] = 348;
            ExpertEncoding.sids[226] = 349;
            ExpertEncoding.sids[227] = 350;
            ExpertEncoding.sids[228] = 351;
            ExpertEncoding.sids[229] = 352;
            ExpertEncoding.sids[230] = 353;
            ExpertEncoding.sids[231] = 354;
            ExpertEncoding.sids[232] = 355;
            ExpertEncoding.sids[233] = 356;
            ExpertEncoding.sids[234] = 357;
            ExpertEncoding.sids[235] = 358;
            ExpertEncoding.sids[236] = 359;
            ExpertEncoding.sids[237] = 360;
            ExpertEncoding.sids[238] = 361;
            ExpertEncoding.sids[239] = 362;
            ExpertEncoding.sids[240] = 363;
            ExpertEncoding.sids[241] = 364;
            ExpertEncoding.sids[242] = 365;
            ExpertEncoding.sids[243] = 366;
            ExpertEncoding.sids[244] = 367;
            ExpertEncoding.sids[245] = 368;
            ExpertEncoding.sids[246] = 369;
            ExpertEncoding.sids[247] = 370;
            ExpertEncoding.sids[248] = 371;
            ExpertEncoding.sids[249] = 372;
            ExpertEncoding.sids[250] = 373;
            ExpertEncoding.sids[251] = 374;
            ExpertEncoding.sids[252] = 375;
            ExpertEncoding.sids[253] = 376;
            ExpertEncoding.sids[254] = 377;
            ExpertEncoding.sids[255] = 378;
        }

        private static void InitializeStandardEncoding()
        {
            StandardEncoding = new PredefinedEncoding();
            StandardEncoding.sids[0] = 0;
            StandardEncoding.sids[1] = 0;
            StandardEncoding.sids[2] = 0;
            StandardEncoding.sids[3] = 0;
            StandardEncoding.sids[4] = 0;
            StandardEncoding.sids[5] = 0;
            StandardEncoding.sids[6] = 0;
            StandardEncoding.sids[7] = 0;
            StandardEncoding.sids[8] = 0;
            StandardEncoding.sids[9] = 0;
            StandardEncoding.sids[10] = 0;
            StandardEncoding.sids[11] = 0;
            StandardEncoding.sids[12] = 0;
            StandardEncoding.sids[13] = 0;
            StandardEncoding.sids[14] = 0;
            StandardEncoding.sids[15] = 0;
            StandardEncoding.sids[16] = 0;
            StandardEncoding.sids[17] = 0;
            StandardEncoding.sids[18] = 0;
            StandardEncoding.sids[19] = 0;
            StandardEncoding.sids[20] = 0;
            StandardEncoding.sids[21] = 0;
            StandardEncoding.sids[22] = 0;
            StandardEncoding.sids[23] = 0;
            StandardEncoding.sids[24] = 0;
            StandardEncoding.sids[25] = 0;
            StandardEncoding.sids[26] = 0;
            StandardEncoding.sids[27] = 0;
            StandardEncoding.sids[28] = 0;
            StandardEncoding.sids[29] = 0;
            StandardEncoding.sids[30] = 0;
            StandardEncoding.sids[31] = 0;
            StandardEncoding.sids[32] = 1;
            StandardEncoding.sids[33] = 2;
            StandardEncoding.sids[34] = 3;
            StandardEncoding.sids[35] = 4;
            StandardEncoding.sids[36] = 5;
            StandardEncoding.sids[37] = 6;
            StandardEncoding.sids[38] = 7;
            StandardEncoding.sids[39] = 8;
            StandardEncoding.sids[40] = 9;
            StandardEncoding.sids[41] = 10;
            StandardEncoding.sids[42] = 11;
            StandardEncoding.sids[43] = 12;
            StandardEncoding.sids[44] = 13;
            StandardEncoding.sids[45] = 14;
            StandardEncoding.sids[46] = 15;
            StandardEncoding.sids[47] = 16;
            StandardEncoding.sids[48] = 17;
            StandardEncoding.sids[49] = 18;
            StandardEncoding.sids[50] = 19;
            StandardEncoding.sids[51] = 20;
            StandardEncoding.sids[52] = 21;
            StandardEncoding.sids[53] = 22;
            StandardEncoding.sids[54] = 23;
            StandardEncoding.sids[55] = 24;
            StandardEncoding.sids[56] = 25;
            StandardEncoding.sids[57] = 26;
            StandardEncoding.sids[58] = 27;
            StandardEncoding.sids[59] = 28;
            StandardEncoding.sids[60] = 29;
            StandardEncoding.sids[61] = 30;
            StandardEncoding.sids[62] = 31;
            StandardEncoding.sids[63] = 32;
            StandardEncoding.sids[64] = 33;
            StandardEncoding.sids[65] = 34;
            StandardEncoding.sids[66] = 35;
            StandardEncoding.sids[67] = 36;
            StandardEncoding.sids[68] = 37;
            StandardEncoding.sids[69] = 38;
            StandardEncoding.sids[70] = 39;
            StandardEncoding.sids[71] = 40;
            StandardEncoding.sids[72] = 41;
            StandardEncoding.sids[73] = 42;
            StandardEncoding.sids[74] = 43;
            StandardEncoding.sids[75] = 44;
            StandardEncoding.sids[76] = 45;
            StandardEncoding.sids[77] = 46;
            StandardEncoding.sids[78] = 47;
            StandardEncoding.sids[79] = 48;
            StandardEncoding.sids[80] = 49;
            StandardEncoding.sids[81] = 50;
            StandardEncoding.sids[82] = 51;
            StandardEncoding.sids[83] = 52;
            StandardEncoding.sids[84] = 53;
            StandardEncoding.sids[85] = 54;
            StandardEncoding.sids[86] = 55;
            StandardEncoding.sids[87] = 56;
            StandardEncoding.sids[88] = 57;
            StandardEncoding.sids[89] = 58;
            StandardEncoding.sids[90] = 59;
            StandardEncoding.sids[91] = 60;
            StandardEncoding.sids[92] = 61;
            StandardEncoding.sids[93] = 62;
            StandardEncoding.sids[94] = 63;
            StandardEncoding.sids[95] = 64;
            StandardEncoding.sids[96] = 65;
            StandardEncoding.sids[97] = 66;
            StandardEncoding.sids[98] = 67;
            StandardEncoding.sids[99] = 68;
            StandardEncoding.sids[100] = 69;
            StandardEncoding.sids[101] = 70;
            StandardEncoding.sids[102] = 71;
            StandardEncoding.sids[103] = 72;
            StandardEncoding.sids[104] = 73;
            StandardEncoding.sids[105] = 74;
            StandardEncoding.sids[106] = 75;
            StandardEncoding.sids[107] = 76;
            StandardEncoding.sids[108] = 77;
            StandardEncoding.sids[109] = 78;
            StandardEncoding.sids[110] = 79;
            StandardEncoding.sids[111] = 80;
            StandardEncoding.sids[112] = 81;
            StandardEncoding.sids[113] = 82;
            StandardEncoding.sids[114] = 83;
            StandardEncoding.sids[115] = 84;
            StandardEncoding.sids[116] = 85;
            StandardEncoding.sids[117] = 86;
            StandardEncoding.sids[118] = 87;
            StandardEncoding.sids[119] = 88;
            StandardEncoding.sids[120] = 89;
            StandardEncoding.sids[121] = 90;
            StandardEncoding.sids[122] = 91;
            StandardEncoding.sids[123] = 92;
            StandardEncoding.sids[124] = 93;
            StandardEncoding.sids[125] = 94;
            StandardEncoding.sids[126] = 95;
            StandardEncoding.sids[127] = 0;
            StandardEncoding.sids[128] = 0;
            StandardEncoding.sids[129] = 0;
            StandardEncoding.sids[130] = 0;
            StandardEncoding.sids[131] = 0;
            StandardEncoding.sids[132] = 0;
            StandardEncoding.sids[133] = 0;
            StandardEncoding.sids[134] = 0;
            StandardEncoding.sids[135] = 0;
            StandardEncoding.sids[136] = 0;
            StandardEncoding.sids[137] = 0;
            StandardEncoding.sids[138] = 0;
            StandardEncoding.sids[139] = 0;
            StandardEncoding.sids[140] = 0;
            StandardEncoding.sids[141] = 0;
            StandardEncoding.sids[142] = 0;
            StandardEncoding.sids[143] = 0;
            StandardEncoding.sids[144] = 0;
            StandardEncoding.sids[145] = 0;
            StandardEncoding.sids[146] = 0;
            StandardEncoding.sids[147] = 0;
            StandardEncoding.sids[148] = 0;
            StandardEncoding.sids[149] = 0;
            StandardEncoding.sids[150] = 0;
            StandardEncoding.sids[151] = 0;
            StandardEncoding.sids[152] = 0;
            StandardEncoding.sids[153] = 0;
            StandardEncoding.sids[154] = 0;
            StandardEncoding.sids[155] = 0;
            StandardEncoding.sids[156] = 0;
            StandardEncoding.sids[157] = 0;
            StandardEncoding.sids[158] = 0;
            StandardEncoding.sids[159] = 0;
            StandardEncoding.sids[160] = 0;
            StandardEncoding.sids[161] = 96;
            StandardEncoding.sids[162] = 97;
            StandardEncoding.sids[163] = 98;
            StandardEncoding.sids[164] = 99;
            StandardEncoding.sids[165] = 100;
            StandardEncoding.sids[166] = 101;
            StandardEncoding.sids[167] = 102;
            StandardEncoding.sids[168] = 103;
            StandardEncoding.sids[169] = 104;
            StandardEncoding.sids[170] = 105;
            StandardEncoding.sids[171] = 106;
            StandardEncoding.sids[172] = 107;
            StandardEncoding.sids[173] = 108;
            StandardEncoding.sids[174] = 109;
            StandardEncoding.sids[175] = 110;
            StandardEncoding.sids[176] = 0;
            StandardEncoding.sids[177] = 111;
            StandardEncoding.sids[178] = 112;
            StandardEncoding.sids[179] = 113;
            StandardEncoding.sids[180] = 114;
            StandardEncoding.sids[181] = 0;
            StandardEncoding.sids[182] = 115;
            StandardEncoding.sids[183] = 116;
            StandardEncoding.sids[184] = 117;
            StandardEncoding.sids[185] = 118;
            StandardEncoding.sids[186] = 119;
            StandardEncoding.sids[187] = 120;
            StandardEncoding.sids[188] = 121;
            StandardEncoding.sids[189] = 122;
            StandardEncoding.sids[190] = 0;
            StandardEncoding.sids[191] = 123;
            StandardEncoding.sids[192] = 0;
            StandardEncoding.sids[193] = 124;
            StandardEncoding.sids[194] = 125;
            StandardEncoding.sids[195] = 126;
            StandardEncoding.sids[196] = 127;
            StandardEncoding.sids[197] = 128;
            StandardEncoding.sids[198] = 129;
            StandardEncoding.sids[199] = 130;
            StandardEncoding.sids[200] = 131;
            StandardEncoding.sids[201] = 0;
            StandardEncoding.sids[202] = 132;
            StandardEncoding.sids[203] = 133;
            StandardEncoding.sids[204] = 0;
            StandardEncoding.sids[205] = 134;
            StandardEncoding.sids[206] = 135;
            StandardEncoding.sids[207] = 136;
            StandardEncoding.sids[208] = 137;
            StandardEncoding.sids[209] = 0;
            StandardEncoding.sids[210] = 0;
            StandardEncoding.sids[211] = 0;
            StandardEncoding.sids[212] = 0;
            StandardEncoding.sids[213] = 0;
            StandardEncoding.sids[214] = 0;
            StandardEncoding.sids[215] = 0;
            StandardEncoding.sids[216] = 0;
            StandardEncoding.sids[217] = 0;
            StandardEncoding.sids[218] = 0;
            StandardEncoding.sids[219] = 0;
            StandardEncoding.sids[220] = 0;
            StandardEncoding.sids[221] = 0;
            StandardEncoding.sids[222] = 0;
            StandardEncoding.sids[223] = 0;
            StandardEncoding.sids[224] = 0;
            StandardEncoding.sids[225] = 138;
            StandardEncoding.sids[226] = 0;
            StandardEncoding.sids[227] = 139;
            StandardEncoding.sids[228] = 0;
            StandardEncoding.sids[229] = 0;
            StandardEncoding.sids[230] = 0;
            StandardEncoding.sids[231] = 0;
            StandardEncoding.sids[232] = 140;
            StandardEncoding.sids[233] = 141;
            StandardEncoding.sids[234] = 142;
            StandardEncoding.sids[235] = 143;
            StandardEncoding.sids[236] = 0;
            StandardEncoding.sids[237] = 0;
            StandardEncoding.sids[238] = 0;
            StandardEncoding.sids[239] = 0;
            StandardEncoding.sids[240] = 0;
            StandardEncoding.sids[241] = 144;
            StandardEncoding.sids[242] = 0;
            StandardEncoding.sids[243] = 0;
            StandardEncoding.sids[244] = 0;
            StandardEncoding.sids[245] = 145;
            StandardEncoding.sids[246] = 0;
            StandardEncoding.sids[247] = 0;
            StandardEncoding.sids[248] = 146;
            StandardEncoding.sids[249] = 147;
            StandardEncoding.sids[250] = 148;
            StandardEncoding.sids[251] = 149;
            StandardEncoding.sids[252] = 0;
            StandardEncoding.sids[253] = 0;
            StandardEncoding.sids[254] = 0;
            StandardEncoding.sids[255] = 0;
        }

        #endregion

        #region Constructors

        static PredefinedEncoding()
        {
            InitializeStandardEncoding();
            InitializeExpertEncoding();
        }

        public PredefinedEncoding() : base()
        {
            this.sids = new ushort[256];
        }

        #endregion

        #region Fields

        private readonly ushort[] sids;

        #endregion

        #region Methods

        public PostScriptArray ToArray()
        {
            PostScriptArray a = new PostScriptArray(this.sids.Length);
            for (int i = 0; i < this.sids.Length; i++)
            {
                a.Add(this.sids[i]);
            }
            return a;
        }

        public string GetGlyphName(ICFFFontFile fontFile, ushort index)
        {
            if (index >= this.sids.Length)
            {
                return PostScriptConstants.NotDef;
            }
            
            return fontFile.ReadString(this.sids[index]);
        }

        #endregion
    }
}
