﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.PostScript.Data;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.CFFFormat.Data
{
    internal static class StandardStrings
    {
        private static string[] standardStrings;

        public static int StandardStringsCount
        {
            get
            {
                return standardStrings.Length;
            }
        }

        public static bool IsStandardString(ushort sid)
        {
            return sid < standardStrings.Length;
        }

        public static string GetStandardString(ushort sid)
        {
            return standardStrings[sid];
        }

        static StandardStrings()
        {
            standardStrings = new string[391];

            standardStrings[0] = PostScriptConstants.NotDef;
            standardStrings[1] = "space";
            standardStrings[2] = "exclam";
            standardStrings[3] = "quotedbl";
            standardStrings[4] = "numbersign";
            standardStrings[5] = "dollar";
            standardStrings[6] = "percent";
            standardStrings[7] = "ampersand";
            standardStrings[8] = "quoteright";
            standardStrings[9] = "parenleft";
            standardStrings[10] = "parenright";
            standardStrings[11] = "asterisk";
            standardStrings[12] = "plus";
            standardStrings[13] = "comma";
            standardStrings[14] = "hyphen";
            standardStrings[15] = "period";
            standardStrings[16] = "slash";
            standardStrings[17] = "zero";
            standardStrings[18] = "one";
            standardStrings[19] = "two";
            standardStrings[20] = "three";
            standardStrings[21] = "four";
            standardStrings[22] = "five";
            standardStrings[23] = "six";
            standardStrings[24] = "seven";
            standardStrings[25] = "eight";
            standardStrings[26] = "nine";
            standardStrings[27] = "colon";
            standardStrings[28] = "semicolon";
            standardStrings[29] = "less";
            standardStrings[30] = "equal";
            standardStrings[31] = "greater";
            standardStrings[32] = "question";
            standardStrings[33] = "at";
            standardStrings[34] = "A";
            standardStrings[35] = "B";
            standardStrings[36] = "C";
            standardStrings[37] = "D";
            standardStrings[38] = "E";
            standardStrings[39] = "F";
            standardStrings[40] = "G";
            standardStrings[41] = "H";
            standardStrings[42] = "I";
            standardStrings[43] = "J";
            standardStrings[44] = "K";
            standardStrings[45] = "L";
            standardStrings[46] = "M";
            standardStrings[47] = "N";
            standardStrings[48] = "O";
            standardStrings[49] = "P";
            standardStrings[50] = "Q";
            standardStrings[51] = "R";
            standardStrings[52] = "S";
            standardStrings[53] = "T";
            standardStrings[54] = "U";
            standardStrings[55] = "V";
            standardStrings[56] = "W";
            standardStrings[57] = "X";
            standardStrings[58] = "Y";
            standardStrings[59] = "Z";
            standardStrings[60] = "bracketleft";
            standardStrings[61] = "backslash";
            standardStrings[62] = "bracketright";
            standardStrings[63] = "asciicircum";
            standardStrings[64] = "underscore";
            standardStrings[65] = "quoteleft";
            standardStrings[66] = "a";
            standardStrings[67] = "b";
            standardStrings[68] = "c";
            standardStrings[69] = "d";
            standardStrings[70] = "e";
            standardStrings[71] = "f";
            standardStrings[72] = "g";
            standardStrings[73] = "h";
            standardStrings[74] = "i";
            standardStrings[75] = "j";
            standardStrings[76] = "k";
            standardStrings[77] = "l";
            standardStrings[78] = "m";
            standardStrings[79] = "n";
            standardStrings[80] = "o";
            standardStrings[81] = "p";
            standardStrings[82] = "q";
            standardStrings[83] = "r";
            standardStrings[84] = "s";
            standardStrings[85] = "t";
            standardStrings[86] = "u";
            standardStrings[87] = "v";
            standardStrings[88] = "w";
            standardStrings[89] = "x";
            standardStrings[90] = "y";
            standardStrings[91] = "z";
            standardStrings[92] = "braceleft";
            standardStrings[93] = "bar";
            standardStrings[94] = "braceright";
            standardStrings[95] = "asciitilde";
            standardStrings[96] = "exclamdown";
            standardStrings[97] = "cent";
            standardStrings[98] = "sterling";
            standardStrings[99] = "fraction";
            standardStrings[100] = "yen";
            standardStrings[101] = "florin";
            standardStrings[102] = "section";
            standardStrings[103] = "currency";
            standardStrings[104] = "quotesingle";
            standardStrings[105] = "quotedblleft";
            standardStrings[106] = "guillemotleft";
            standardStrings[107] = "guilsinglleft";
            standardStrings[108] = "guilsinglright";
            standardStrings[109] = "fi";
            standardStrings[110] = "fl";
            standardStrings[111] = "endash";
            standardStrings[112] = "dagger";
            standardStrings[113] = "daggerdbl";
            standardStrings[114] = "periodcentered";
            standardStrings[115] = "paragraph";
            standardStrings[116] = "bullet";
            standardStrings[117] = "quotesinglbase";
            standardStrings[118] = "quotedblbase";
            standardStrings[119] = "quotedblright";
            standardStrings[120] = "guillemotright";
            standardStrings[121] = "ellipsis";
            standardStrings[122] = "perthousand";
            standardStrings[123] = "questiondown";
            standardStrings[124] = "grave";
            standardStrings[125] = "acute";
            standardStrings[126] = "circumflex";
            standardStrings[127] = "tilde";
            standardStrings[128] = "macron";
            standardStrings[129] = "breve";
            standardStrings[130] = "dotaccent";
            standardStrings[131] = "dieresis";
            standardStrings[132] = "ring";
            standardStrings[133] = "cedilla";
            standardStrings[134] = "hungarumlaut";
            standardStrings[135] = "ogonek";
            standardStrings[136] = "caron";
            standardStrings[137] = "emdash";
            standardStrings[138] = "AE";
            standardStrings[139] = "ordfeminine";
            standardStrings[140] = "Lslash";
            standardStrings[141] = "Oslash";
            standardStrings[142] = "OE";
            standardStrings[143] = "ordmasculine";
            standardStrings[144] = "ae";
            standardStrings[145] = "dotlessi";
            standardStrings[146] = "lslash";
            standardStrings[147] = "oslash";
            standardStrings[148] = "oe";
            standardStrings[149] = "germandbls";
            standardStrings[150] = "onesuperior";
            standardStrings[151] = "logicalnot";
            standardStrings[152] = "mu";
            standardStrings[153] = "trademark";
            standardStrings[154] = "Eth";
            standardStrings[155] = "onehalf";
            standardStrings[156] = "plusminus";
            standardStrings[157] = "Thorn";
            standardStrings[158] = "onequarter";
            standardStrings[159] = "divide";
            standardStrings[160] = "brokenbar";
            standardStrings[161] = "degree";
            standardStrings[162] = "thorn";
            standardStrings[163] = "threequarters";
            standardStrings[164] = "twosuperior";
            standardStrings[165] = "registered";
            standardStrings[166] = "minus";
            standardStrings[167] = "eth";
            standardStrings[168] = "multiply";
            standardStrings[169] = "threesuperior";
            standardStrings[170] = "copyright";
            standardStrings[171] = "Aacute";
            standardStrings[172] = "Acircumflex";
            standardStrings[173] = "Adieresis";
            standardStrings[174] = "Agrave";
            standardStrings[175] = "Aring";
            standardStrings[176] = "Atilde";
            standardStrings[177] = "Ccedilla";
            standardStrings[178] = "Eacute";
            standardStrings[179] = "Ecircumflex";
            standardStrings[180] = "Edieresis";
            standardStrings[181] = "Egrave";
            standardStrings[182] = "Iacute";
            standardStrings[183] = "Icircumflex";
            standardStrings[184] = "Idieresis";
            standardStrings[185] = "Igrave";
            standardStrings[186] = "Ntilde";
            standardStrings[187] = "Oacute";
            standardStrings[188] = "Ocircumflex";
            standardStrings[189] = "Odieresis";
            standardStrings[190] = "Ograve";
            standardStrings[191] = "Otilde";
            standardStrings[192] = "Scaron";
            standardStrings[193] = "Uacute";
            standardStrings[194] = "Ucircumflex";
            standardStrings[195] = "Udieresis";
            standardStrings[196] = "Ugrave";
            standardStrings[197] = "Yacute";
            standardStrings[198] = "Ydieresis";
            standardStrings[199] = "Zcaron";
            standardStrings[200] = "aacute";
            standardStrings[201] = "acircumflex";
            standardStrings[202] = "adieresis";
            standardStrings[203] = "agrave";
            standardStrings[204] = "aring";
            standardStrings[205] = "atilde";
            standardStrings[206] = "ccedilla";
            standardStrings[207] = "eacute";
            standardStrings[208] = "ecircumflex";
            standardStrings[209] = "edieresis";
            standardStrings[210] = "egrave";
            standardStrings[211] = "iacute";
            standardStrings[212] = "icircumflex";
            standardStrings[213] = "idieresis";
            standardStrings[214] = "igrave";
            standardStrings[215] = "ntilde";
            standardStrings[216] = "oacute";
            standardStrings[217] = "ocircumflex";
            standardStrings[218] = "odieresis";
            standardStrings[219] = "ograve";
            standardStrings[220] = "otilde";
            standardStrings[221] = "scaron";
            standardStrings[222] = "uacute";
            standardStrings[223] = "ucircumflex";
            standardStrings[224] = "udieresis";
            standardStrings[225] = "ugrave";
            standardStrings[226] = "yacute";
            standardStrings[227] = "ydieresis";
            standardStrings[228] = "zcaron";
            standardStrings[229] = "exclamsmall";
            standardStrings[230] = "Hungarumlautsmall";
            standardStrings[231] = "dollaroldstyle";
            standardStrings[232] = "dollarsuperior";
            standardStrings[233] = "ampersandsmall";
            standardStrings[234] = "Acutesmall";
            standardStrings[235] = "parenleftsuperior";
            standardStrings[236] = "parenrightsuperior";
            standardStrings[237] = "twodotenleader";
            standardStrings[238] = "onedotenleader";
            standardStrings[239] = "zerooldstyle";
            standardStrings[240] = "oneoldstyle";
            standardStrings[241] = "twooldstyle";
            standardStrings[242] = "threeoldstyle";
            standardStrings[243] = "fouroldstyle";
            standardStrings[244] = "fiveoldstyle";
            standardStrings[245] = "sixoldstyle";
            standardStrings[246] = "sevenoldstyle";
            standardStrings[247] = "eightoldstyle";
            standardStrings[248] = "nineoldstyle";
            standardStrings[249] = "commasuperior";
            standardStrings[250] = "threequartersemdash";
            standardStrings[251] = "periodsuperior";
            standardStrings[252] = "questionsmall";
            standardStrings[253] = "asuperior";
            standardStrings[254] = "bsuperior";
            standardStrings[255] = "centsuperior";
            standardStrings[256] = "dsuperior";
            standardStrings[257] = "esuperior";
            standardStrings[258] = "isuperior";
            standardStrings[259] = "lsuperior";
            standardStrings[260] = "msuperior";
            standardStrings[261] = "nsuperior";
            standardStrings[262] = "osuperior";
            standardStrings[263] = "rsuperior";
            standardStrings[264] = "ssuperior";
            standardStrings[265] = "tsuperior";
            standardStrings[266] = "ff";
            standardStrings[267] = "ffi";
            standardStrings[268] = "ffl";
            standardStrings[269] = "parenleftinferior";
            standardStrings[270] = "parenrightinferior";
            standardStrings[271] = "Circumflexsmall";
            standardStrings[272] = "hyphensuperior";
            standardStrings[273] = "Gravesmall";
            standardStrings[274] = "Asmall";
            standardStrings[275] = "Bsmall";
            standardStrings[276] = "Csmall";
            standardStrings[277] = "Dsmall";
            standardStrings[278] = "Esmall";
            standardStrings[279] = "Fsmall";
            standardStrings[280] = "Gsmall";
            standardStrings[281] = "Hsmall";
            standardStrings[282] = "Ismall";
            standardStrings[283] = "Jsmall";
            standardStrings[284] = "Ksmall";
            standardStrings[285] = "Lsmall";
            standardStrings[286] = "Msmall";
            standardStrings[287] = "Nsmall";
            standardStrings[288] = "Osmall";
            standardStrings[289] = "Psmall";
            standardStrings[290] = "Qsmall";
            standardStrings[291] = "Rsmall";
            standardStrings[292] = "Ssmall";
            standardStrings[293] = "Tsmall";
            standardStrings[294] = "Usmall";
            standardStrings[295] = "Vsmall";
            standardStrings[296] = "Wsmall";
            standardStrings[297] = "Xsmall";
            standardStrings[298] = "Ysmall";
            standardStrings[299] = "Zsmall";
            standardStrings[300] = "colonmonetary";
            standardStrings[301] = "onefitted";
            standardStrings[302] = "rupiah";
            standardStrings[303] = "Tildesmall";
            standardStrings[304] = "exclamdownsmall";
            standardStrings[305] = "centoldstyle";
            standardStrings[306] = "Lslashsmall";
            standardStrings[307] = "Scaronsmall";
            standardStrings[308] = "Zcaronsmall";
            standardStrings[309] = "Dieresissmall";
            standardStrings[310] = "Brevesmall";
            standardStrings[311] = "Caronsmall";
            standardStrings[312] = "Dotaccentsmall";
            standardStrings[313] = "Macronsmall";
            standardStrings[314] = "figuredash";
            standardStrings[315] = "hypheninferior";
            standardStrings[316] = "Ogoneksmall";
            standardStrings[317] = "Ringsmall";
            standardStrings[318] = "Cedillasmall";
            standardStrings[319] = "questiondownsmall";
            standardStrings[320] = "oneeighth";
            standardStrings[321] = "threeeighths";
            standardStrings[322] = "fiveeighths";
            standardStrings[323] = "seveneighths";
            standardStrings[324] = "onethird";
            standardStrings[325] = "twothirds";
            standardStrings[326] = "zerosuperior";
            standardStrings[327] = "foursuperior";
            standardStrings[328] = "fivesuperior";
            standardStrings[329] = "sixsuperior";
            standardStrings[330] = "sevensuperior";
            standardStrings[331] = "eightsuperior";
            standardStrings[332] = "ninesuperior";
            standardStrings[333] = "zeroinferior";
            standardStrings[334] = "oneinferior";
            standardStrings[335] = "twoinferior";
            standardStrings[336] = "threeinferior";
            standardStrings[337] = "fourinferior";
            standardStrings[338] = "fiveinferior";
            standardStrings[339] = "sixinferior";
            standardStrings[340] = "seveninferior";
            standardStrings[341] = "eightinferior";
            standardStrings[342] = "nineinferior";
            standardStrings[343] = "centinferior";
            standardStrings[344] = "dollarinferior";
            standardStrings[345] = "periodinferior";
            standardStrings[346] = "commainferior";
            standardStrings[347] = "Agravesmall";
            standardStrings[348] = "Aacutesmall";
            standardStrings[349] = "Acircumflexsmall";
            standardStrings[350] = "Atildesmall";
            standardStrings[351] = "Adieresissmall";
            standardStrings[352] = "Aringsmall";
            standardStrings[353] = "AEsmall";
            standardStrings[354] = "Ccedillasmall";
            standardStrings[355] = "Egravesmall";
            standardStrings[356] = "Eacutesmall";
            standardStrings[357] = "Ecircumflexsmall";
            standardStrings[358] = "Edieresissmall";
            standardStrings[359] = "Igravesmall";
            standardStrings[360] = "Iacutesmall";
            standardStrings[361] = "Icircumflexsmall";
            standardStrings[362] = "Idieresissmall";
            standardStrings[363] = "Ethsmall";
            standardStrings[364] = "Ntildesmall";
            standardStrings[365] = "Ogravesmall";
            standardStrings[366] = "Oacutesmall";
            standardStrings[367] = "Ocircumflexsmall";
            standardStrings[368] = "Otildesmall";
            standardStrings[369] = "Odieresissmall";
            standardStrings[370] = "OEsmall";
            standardStrings[371] = "Oslashsmall";
            standardStrings[372] = "Ugravesmall";
            standardStrings[373] = "Uacutesmall";
            standardStrings[374] = "Ucircumflexsmall";
            standardStrings[375] = "Udieresissmall";
            standardStrings[376] = "Yacutesmall";
            standardStrings[377] = "Thornsmall";
            standardStrings[378] = "Ydieresissmall";
            standardStrings[379] = "001.000";
            standardStrings[380] = "001.001";
            standardStrings[381] = "001.002";
            standardStrings[382] = "001.003";
            standardStrings[383] = "Black";
            standardStrings[384] = "Bold";
            standardStrings[385] = "Book";
            standardStrings[386] = "Light";
            standardStrings[387] = "Medium";
            standardStrings[388] = "Regular";
            standardStrings[389] = "Roman";
            standardStrings[390] = "Semibold";
        }
    }
}
