﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.PostScript.Data;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.CharStrings.Operators
{
    internal class EndChar : Operator
    {
        public override void Execute(BuildChar buildChar)
        {
            if (buildChar.Operands.Count >= 4)
            {
                int aChar = buildChar.Operands.GetLastAsInt();
                int bChar = buildChar.Operands.GetLastAsInt();
                int dy = buildChar.Operands.GetLastAsInt();
                int dx = buildChar.Operands.GetLastAsInt();

                string accentedChar = PredefinedEncodings.StandardEncoding[aChar];
                string baseChar = PredefinedEncodings.StandardEncoding[bChar];

                buildChar.CombineChars(accentedChar, baseChar, dx, dy);
            }

            RMoveTo.ReadWidth(buildChar, 0);
            buildChar.Operands.Clear();
        }
    }
}
