﻿using System;
using System.Linq;
#if !NETSTANDARD
using System.Windows;
#else
using Telerik.Documents.Primitives;
#endif
using Telerik.Windows.Documents.Core.Shapes;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.CharStrings.Operators
{
    internal abstract class Operator
    {
        internal static Point CalculatePoint(BuildChar interpreter, int dx, int dy)
        {
            interpreter.CurrentPoint = new Point(interpreter.CurrentPoint.X + dx, interpreter.CurrentPoint.Y + dy);
            return new Point(interpreter.CurrentPoint.X, interpreter.CurrentPoint.Y);
        }
       
        internal static void HLineTo(BuildChar interpreter, int dx)
        {
            LineTo(interpreter, dx, 0);
        }
       
        internal static void VLineTo(BuildChar interpreter, int dy)
        {
            LineTo(interpreter, 0, dy);
        }
       
        internal static void LineTo(BuildChar interpreter, int dx, int dy)
        {
            LineSegment ls = new LineSegment();
            ls.Point = Operator.CalculatePoint(interpreter, dx, dy);
            interpreter.CurrentPathFigure.Segments.Add(ls);
        }
       
        internal static void CurveTo(BuildChar interpreter, int dxa, int dya, int dxb, int dyb, int dxc, int dyc)
        {
            BezierSegment bs = new BezierSegment();
            bs.Point1 = Operator.CalculatePoint(interpreter, dxa, dya);
            bs.Point2 = Operator.CalculatePoint(interpreter, dxb, dyb);
            bs.Point3 = Operator.CalculatePoint(interpreter, dxc, dyc);
            interpreter.CurrentPathFigure.Segments.Add(bs);
        }
       
        internal static void MoveTo(BuildChar interpreter, int dx, int dy)
        {
            interpreter.CurrentPathFigure = new PathFigure();
            interpreter.CurrentPathFigure.IsClosed = true;
            interpreter.CurrentPathFigure.IsFilled = true;
            interpreter.CurrentPathFigure.StartPoint = Operator.CalculatePoint(interpreter, dx, dy);
            interpreter.GlyphOutlines.Add(interpreter.CurrentPathFigure);
        }
       
        internal static void ReadWidth(BuildChar interpreter, int operands)
        {
            if (interpreter.Width.HasValue)
            {
                return;
            }

            if (interpreter.Operands.Count == operands + 1)
            {
                interpreter.Width = interpreter.Operands.GetFirstAsInt();
            }
            else
            {
                interpreter.Width = 0;
            }
        }

        public abstract void Execute(BuildChar buildChar);
    }
}
