﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.PostScript.Data;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.CharStrings.Operators
{
    internal class VHCurveTo : Operator
    {
        public override void Execute(BuildChar interpreter)
        {
            OperandsCollection stack = interpreter.Operands;
            if (stack.Count % 8 == 0 || stack.Count % 8 == 1)
            {
                while (stack.Count / 8 > 0)
                {
                    int dya = stack.GetFirstAsInt();
                    int dxb = stack.GetFirstAsInt();
                    int dyb = stack.GetFirstAsInt();
                    int dxc = stack.GetFirstAsInt();
                    int dxd = stack.GetFirstAsInt();
                    int dxe = stack.GetFirstAsInt();
                    int dye = stack.GetFirstAsInt();
                    int dyf = stack.GetFirstAsInt();
                    int dxf = stack.Count == 1 ? stack.GetFirstAsInt() : 0;

                    RRCurveTo.CurveTo(interpreter, 0, dya, dxb, dyb, dxc, 0);
                    RRCurveTo.CurveTo(interpreter, dxd, 0, dxe, dye, dxf, dyf);
                }
            }
            else
            {
                int dy1 = stack.GetFirstAsInt();
                int dx2 = stack.GetFirstAsInt();
                int dy2 = stack.GetFirstAsInt();
                int dx3 = stack.GetFirstAsInt();
                int dyf = stack.Count == 1 ? stack.GetFirstAsInt() : 0;
                 
                RRCurveTo.CurveTo(interpreter, 0, dy1, dx2, dy2, dx3, dyf);

                while (stack.Count / 8 > 0)
                {
                    int dxa = stack.GetFirstAsInt();
                    int dxb = stack.GetFirstAsInt();
                    int dyb = stack.GetFirstAsInt();
                    int dyc = stack.GetFirstAsInt();
                    int dyd = stack.GetFirstAsInt();
                    int dxe = stack.GetFirstAsInt();
                    int dye = stack.GetFirstAsInt();
                    int dxf = stack.GetFirstAsInt();
                    dyf = stack.Count == 1 ? stack.GetFirstAsInt() : 0;

                    RRCurveTo.CurveTo(interpreter, dxa, 0, dxb, dyb, 0, dyc);
                    RRCurveTo.CurveTo(interpreter, 0, dyd, dxe, dye, dxf, dyf);
                }
            }

            stack.Clear();
        }
    }
}
