﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.Type1.Data;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.Encoding
{
    internal class FiveByteFixedEncoding : ByteEncoding
    {
        public FiveByteFixedEncoding() 
            : base(255, 255)
        {
        }

        public override object Read(EncodedDataReader reader)
        {
            reader.Read();
            byte b1 = reader.Read();
            byte b2 = reader.Read();
            byte b3 = reader.Read();
            byte b4 = reader.Read();

            int a = b1 << 24 | b2 << 16 | b3 << 8 | b4;
            if ((a & 0xFFFF) != 0 && (a & 0x8000) != 0)
            {
                return (a >> 16) + 1;
            }

            return a >> 16;
        }
    }
}
