﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.Type1.Utils;
using Telerik.Windows.Documents.Core.PostScript.Data;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.Type1Format.Dictionaries
{
    internal class FontInfo : PostScriptObject
    {
        #region Constructors

        public FontInfo()
        {
            this.familyName = this.CreateProperty<string>(new PropertyDescriptor { Name = "FamilyName" });
            this.weight = this.CreateProperty<string>(new PropertyDescriptor { Name = "Weight", });
            this.italicAngle = this.CreateProperty<double>(new PropertyDescriptor { Name = "ItalicAngle" }, 0);
            this.underlinePosition = this.CreateProperty<double>(new PropertyDescriptor { Name = "UnderlinePosition" }, Converters.Type1Converters.DoubleConverter);
            this.underlineThickness = this.CreateProperty<double>(new PropertyDescriptor { Name = "UnderlineThickness" }, Converters.Type1Converters.DoubleConverter);
        }

        #endregion


        #region Fields

        private readonly Property<string> familyName;
        private readonly Property<string> weight;
        private readonly Property<double> italicAngle;
        private readonly Property<double> underlinePosition;
        private readonly Property<double> underlineThickness;

        #endregion


        #region Properties

        public string FamilyName
        {
            get
            {
                return this.familyName.GetValue();
            }
        }

        public string Weight
        {
            get
            {
                return this.weight.GetValue();
            }
        }

        public double ItalicAngle
        {
            get
            {
                return this.italicAngle.GetValue();
            }
        }

        public double UnderlinePosition
        {
            get
            {
                return this.underlinePosition.GetValue();
            }
        }

        public double UnderlineThickness
        {
            get
            {
                return this.underlineThickness.GetValue();
            }
        } 

        #endregion

    }
}
