﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.Type1.Utils;
using Telerik.Windows.Documents.Core.PostScript.Data;
using System.Collections.Generic;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.Type1Format.Dictionaries
{
    internal class Private : PostScriptObject
    {
        private readonly Property<PostScriptArray> subrs;
        private readonly Property<PostScriptArray> otherSubrs;

        private readonly Dictionary<int, byte[]> subroutines;

        public Private()
        {
            this.subrs = this.CreateProperty<PostScriptArray>(new PropertyDescriptor { Name = "Subrs" });
            this.otherSubrs = this.CreateProperty<PostScriptArray>(new PropertyDescriptor { Name = "OtherSubrs" });

            this.subroutines = new Dictionary<int, byte[]>();
        }

        public PostScriptArray Subrs
        {
            get
            {
                return this.subrs.GetValue();
            }
        }

        public PostScriptArray OtherSubrs
        {
            get
            {
                return this.otherSubrs.GetValue();
            }
        }

        public byte[] GetSubr(int index)
        {
            byte[] subr;
            if (!this.subroutines.TryGetValue(index, out subr))
            {
                subr = this.Subrs.GetElementAs<PostScriptString>(index).ToByteArray();
                this.subroutines[index] = subr;
            }
            return subr;
        }
    }
}
