﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.Utils
{
    internal static class Helper
    { 
        public static bool UnboxInteger(object number, out int res)
        { 
            return Helper.Unbox<int>(number, out res); 
        }

        public static bool UnboxReal(object number, out double res)
        { 
            return Helper.Unbox<double>(number, out res);
        }

        public static byte[] CreateByteArray(params byte[] bytes)
        {
            return bytes;
        }

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1031:DoNotCatchGeneralExceptionTypes")]
        public static bool Unbox<T>(object value, out T res) 
            where T : struct
        {
            res = default(T);
            try
            { 
                object converted = Convert.ChangeType(value, typeof(T), CultureInfo.InvariantCulture);
                if (converted != null)
                {
                    res = (T)converted;
                    return true;
                }

                return false;
            }
            catch(Exception)
            {
                return false;
            }
        } 
    }
}
