﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Utilities;

namespace Telerik.Windows.Documents.Core.Fonts.Type1.Utils
{
    internal class Nibble
    {
        #region StaticMembers

        public static Nibble[] GetNibbles(byte b)
        {
            byte[] bits = BitsHelper.GetBits(b);

            Nibble[] res = new Nibble[2];
            res[1] = new Nibble(BitsHelper.ToByte(bits, 0, 4));
            res[0] = new Nibble(BitsHelper.ToByte(bits, 4, 4));
            return res;
        }

        #endregion


        #region Operators

        public static bool operator==(Nibble left, Nibble right)
        {
            if (object.ReferenceEquals(left, null))
            {
                return object.ReferenceEquals(right, null);
            }
            return left.Equals(right);
        }

        public static bool operator !=(Nibble left, Nibble right)
        {
            return !(left == right);
        }

        #endregion


        #region Constructors

        public Nibble(byte value)
        {
            this.value = value;
        }

        #endregion


        #region Fields

        private readonly byte value;

        #endregion


        #region Methods
        #endregion


        #region Overrides

        public override bool Equals(object obj)
        {
            Nibble right = obj as Nibble;
            if (right == null)
            {
                return false;
            }
            return this.value == right.value;
        }

        public override int GetHashCode()
        {
            unchecked
            {
                int result = 17;
                result = result * 23 + this.value.GetHashCode();
                return result;
            }
        }

        public override string ToString()
        {
            return string.Format("{0:X}", this.value);
        }

        #endregion
    }
}
