﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Telerik.Windows.Documents.Core.Fonts.Utils
{
    internal class TextManager
    {
        #region Consts

        private static readonly HashSet<char> charactersWithOnlyIsolatedOrFinalForm = new HashSet<char>(new char[] { 'ا', 'أ', 'إ', 'آ', 'د', 'ذ', 'ر', 'ز', 'و' });

        #endregion


        #region StaticMembers

        internal static GlyphForm GetGlyphForm(string text, int index)
        {
            if (!char.IsLetter(text[index]))
            {
                return GlyphForm.Undefined;
            }
            if (charactersWithOnlyIsolatedOrFinalForm.Contains(text[index]))
            {
                if (index - 1 >= 0 && char.IsLetter(text[index - 1]) && !charactersWithOnlyIsolatedOrFinalForm.Contains(text[index - 1]))
                {
                    return GlyphForm.Final;
                }
                return GlyphForm.Isolated;
            }

            if (index - 1 >= 0 && char.IsLetter(text[index - 1]) && !charactersWithOnlyIsolatedOrFinalForm.Contains(text[index - 1]))
            {
                if (index + 1 < text.Length && char.IsLetter(text[index + 1]))
                {
                    return GlyphForm.Medial;
                }
                return GlyphForm.Final;
            }
            else
            {
                if (index + 1 < text.Length && char.IsLetter(text[index + 1]))
                {
                    return GlyphForm.Initial;
                }
                return GlyphForm.Isolated;
            }
        }

        #endregion
    }
}
