﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.XObjects;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Annot
{
    [PdfClass]
    internal class AppearanceCharacteristicsOld : PdfObjectOld
    {
        private readonly InstantLoadProperty<PdfIntOld> rotation;
        private readonly LoadOnDemandProperty<PdfArrayOld> borderColor;
        private readonly LoadOnDemandProperty<PdfArrayOld> background;
        private readonly InstantLoadProperty<PdfStringOld> normalCaption;
        private readonly InstantLoadProperty<PdfStringOld> rolloverCaption;
        private readonly InstantLoadProperty<PdfStringOld> downCaption;
        private readonly LoadOnDemandProperty<XForm> normalIcon;
        private readonly LoadOnDemandProperty<XForm> rolloverIcon;
        private readonly LoadOnDemandProperty<XForm> downIcon;
        private readonly LoadOnDemandProperty<PdfDictionaryOld> iconFit;
        private readonly InstantLoadProperty<PdfIntOld> captionTextPosition;

        public AppearanceCharacteristicsOld(PdfContentManager contentManager)
            : base(contentManager)
        {
            this.rotation = this.CreateInstantLoadProperty<PdfIntOld>(new PdfPropertyDescriptor("R"));
            this.borderColor = this.CreateLoadOnDemandProperty<PdfArrayOld>(new PdfPropertyDescriptor("BC"));
            this.background = this.CreateLoadOnDemandProperty<PdfArrayOld>(new PdfPropertyDescriptor("BG"));
            this.normalCaption = this.CreateInstantLoadProperty<PdfStringOld>(new PdfPropertyDescriptor("CA"));
            this.rolloverCaption = this.CreateInstantLoadProperty<PdfStringOld>(new PdfPropertyDescriptor("RC"));
            this.downCaption = this.CreateInstantLoadProperty<PdfStringOld>(new PdfPropertyDescriptor("AC"));
            this.normalIcon = this.CreateLoadOnDemandProperty<XForm>(new PdfPropertyDescriptor("I"), Converters.XObjectConverter);
            this.rolloverIcon = this.CreateLoadOnDemandProperty<XForm>(new PdfPropertyDescriptor("RI"), Converters.XObjectConverter);
            this.downIcon = this.CreateLoadOnDemandProperty<XForm>(new PdfPropertyDescriptor("IX"), Converters.XObjectConverter);
            this.iconFit = this.CreateLoadOnDemandProperty<PdfDictionaryOld>(new PdfPropertyDescriptor("IF"));
            this.captionTextPosition = this.CreateInstantLoadProperty<PdfIntOld>(new PdfPropertyDescriptor("TP"));
        }
        
        public PdfIntOld Rotation
        {
            get
            {
                return this.rotation.GetValue();
            }
            set
            {
                this.rotation.SetValue(value);
            }
        }

        public PdfArrayOld BorderColor
        {
            get
            {
                return this.borderColor.GetValue();
            }
            set
            {
                this.borderColor.SetValue(value);
            }
        }

        public PdfArrayOld Background
        {
            get
            {
                return this.background.GetValue();
            }
            set
            {
                this.background.SetValue(value);
            }
        }

        public PdfStringOld NormalCaption
        {
            get
            {
                return this.normalCaption.GetValue();
            }
            set
            {
                this.normalCaption.SetValue(value);
            }
        }

        public PdfStringOld RolloverCaption
        {
            get
            {
                return this.rolloverCaption.GetValue();
            }
            set
            {
                this.rolloverCaption.SetValue(value);
            }
        }

        public PdfStringOld DownCaption
        {
            get
            {
                return this.downCaption.GetValue();
            }
            set
            {
                this.downCaption.SetValue(value);
            }
        }

        public XForm NormalIcon
        {
            get
            {
                return this.normalIcon.GetValue();
            }
            set
            {
                this.normalIcon.SetValue(value);
            }
        }

        public XForm RolloverIcon
        {
            get
            {
                return this.rolloverIcon.GetValue();
            }
            set
            {
                this.rolloverIcon.SetValue(value);
            }
        }

        public XForm DownIcon
        {
            get
            {
                return this.downIcon.GetValue();
            }
            set
            {
                this.downIcon.SetValue(value);
            }
        }

        public PdfDictionaryOld IconFit
        {
            get
            {
                return this.iconFit.GetValue();
            }
            set
            {
                this.iconFit.SetValue(value);
            }
        }

        public PdfIntOld CaptionTextPosition
        {
            get
            {
                return this.captionTextPosition.GetValue();
            }
            set
            {
                this.captionTextPosition.SetValue(value);
            }
        }
    }
}
