﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Navigation;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Annotations;
using Telerik.Windows.Documents.Fixed.Model.Annotations;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Annot
{
    [PdfClass(TypeName = "Annot", SubtypeProperty = "Subtype", SubtypeValue = AnnotationTypes.Link)]
    internal class LinkOld : AnnotationOld
    {
        private readonly LoadOnDemandProperty<Actions.ActionOld> action;
        private readonly LoadOnDemandProperty<DestinationOld> destination;

        public LinkOld(PdfContentManager contentManager)
            : base(contentManager)
        {
            this.action = this.CreateLoadOnDemandProperty<Actions.ActionOld>(new PdfPropertyDescriptor { Name = "A" }, Converters.ActionConverter);
            this.destination = this.CreateLoadOnDemandProperty<DestinationOld>(new PdfPropertyDescriptor { Name = "Dest" }, Converters.DestinationConverter);
        }

        public override AnnotationType Type
        {
            get
            {
                return AnnotationType.Link;
            }
        }

        public Actions.ActionOld Action
        {
            get
            {
                return this.action.GetValue();
            }
            set
            {
                this.action.SetValue(value);
            }
        }
                
        public DestinationOld Destination
        {
            get
            {
                return this.destination.GetValue();
            }
            set
            {
                this.destination.SetValue(value);
            }
        }
    }
}
