﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Forms;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Annotations;
using Telerik.Windows.Documents.Fixed.Model.Annotations;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Annot
{
    [PdfClass(TypeName = "Annot", SubtypeProperty = "Subtype", SubtypeValue = AnnotationTypes.Widget)]
    internal class WidgetOld : AnnotationOld
    {
        private readonly InstantLoadProperty<PdfNameOld> highlightingMode;
        private readonly LoadOnDemandProperty<AppearanceCharacteristicsOld> appearanceCharacteristics;
        private readonly LoadOnDemandProperty<PdfDictionaryOld> actions;
        private readonly LoadOnDemandProperty<PdfDictionaryOld> additionalActions;
        private readonly LoadOnDemandProperty<PdfDictionaryOld> borderStyle;
        private readonly LoadOnDemandProperty<FormFieldNodeOld> parentField;
        
        public WidgetOld(PdfContentManager contentManager)
            : base(contentManager)
        {
            this.highlightingMode = this.CreateInstantLoadProperty<PdfNameOld>(new PdfPropertyDescriptor("H"));
            this.appearanceCharacteristics = this.CreateLoadOnDemandProperty<AppearanceCharacteristicsOld>(new PdfPropertyDescriptor("MK"), Converters.PdfDictionaryToPdfObjectConverter);
            this.actions = this.CreateLoadOnDemandProperty<PdfDictionaryOld>(new PdfPropertyDescriptor("A"));
            this.additionalActions = this.CreateLoadOnDemandProperty<PdfDictionaryOld>(new PdfPropertyDescriptor("AA"));
            this.borderStyle = this.CreateLoadOnDemandProperty<PdfDictionaryOld>(new PdfPropertyDescriptor("BS"));
            this.parentField = this.CreateLoadOnDemandProperty<FormFieldNodeOld>(new PdfPropertyDescriptor("Parent"));
        }

        public override AnnotationType Type
        {
            get
            {
                return AnnotationType.Widget;
            }
        }

        public FormFieldNodeOld FormField
        {
            get
            {
                return this.parentField.GetValue();
            }
            set
            {
                this.parentField.SetValue(value);
            }
        }

        public PdfNameOld HighlightingMode
        {
            get
            {
                return this.highlightingMode.GetValue();
            }
            set
            {
                this.highlightingMode.SetValue(value);
            }
        }

        public AppearanceCharacteristicsOld AppearanceCharacteristics
        {
            get
            {
                return this.appearanceCharacteristics.GetValue();
            }
            set
            {
                this.appearanceCharacteristics.SetValue(value);
            }
        }

        public PdfDictionaryOld Actions
        {
            get
            {
                return this.actions.GetValue();
            }
            set
            {
                this.actions.SetValue(value);
            }
        }

        public PdfDictionaryOld AdditionalActions
        {
            get
            {
                return this.additionalActions.GetValue();
            }
            set
            {
                this.additionalActions.SetValue(value);
            }
        }

        public PdfDictionaryOld BorderStyle
        {
            get
            {
                return this.borderStyle.GetValue();
            }
            set
            {
                this.borderStyle.SetValue(value);
            }
        }
    }
}
