﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.ColorSpaces
{
    internal class ArrayCache<T>
    {
        private readonly Dictionary<HashArray, T> cache;

        public ArrayCache()
        {
            this.cache = new Dictionary<HashArray, T>();
        }

        public void AddToCache(object[] data, T result)
        {
            HashArray hashArray = new HashArray(data);
            this.cache[hashArray] = result;
        }

        public bool TryGetValue(object[] data, out T result)
        {
            result = default(T);
            HashArray hashArray = new HashArray(data);

            return this.cache.TryGetValue(hashArray, out result);
        }

        public T GetValue(object[] data)
        {
            HashArray hashArray = new HashArray(data);

            return this.cache[hashArray];
        }

        public void Clear()
        {
            this.cache.Clear();
        }
    }
}
