﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Text;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;
using Telerik.Windows.Documents.Fixed.Model.Internal;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Patterns;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.ColorSpaces
{
    [PdfClass(TypeName = PdfNames.Shading, SubtypeProperty = PdfNames.ShadingType, SubtypeValue = "2")]
    internal class AxialShadingOld : GradientShadingOld
    {
        public AxialShadingOld(PdfContentManager contentManager)
            : base(contentManager)
        {
        }
        
        public override GradientBrush CreateBrush(Matrix transform, object[] pars)
        {
            double x0;
            this.Coords.TryGetReal(0, out x0);

            double y0;
            this.Coords.TryGetReal(1, out y0);

            double x1;
            this.Coords.TryGetReal(2, out x1);

            double y1;
            this.Coords.TryGetReal(3, out y1);

            double t0;
            this.Domain.TryGetReal(0, out t0);

            double t1;
            this.Domain.TryGetReal(1, out t1);

            bool extendBefore;
            this.Extend.TryGetBool(0, out extendBefore);

            bool extendAfter;
            this.Extend.TryGetBool(1, out extendAfter);

            Rect? box = null;
            if (this.BoundingBox != null)
            {
                box = this.BoundingBox.ToRect();
            }

            LinearGradientBrush linearBrush = new LinearGradientBrush(
                this.GetColor(t0),
                this.GetColor(t1),
                new Point(x0, y0),
                new Point(x1, y1), 
                extendBefore, 
                extendAfter, 
                this.GetBackgroundColor(), 
                transform, 
                box);
            
            double step = GradientStopsCalculator.CalculateLinearGradientStopsMaximalStep(linearBrush);
            linearBrush.GradientStops = this.GetGradientStops(t0, t1, step);

            return linearBrush;
        }

        private GradientStop[] GetGradientStops(double t0, double t1, double step)
        {
            List<GradientStop> stops = new List<GradientStop>();
            for (double t = t0 + step; t < t1; t += step)
            {
                stops.Add(new GradientStop(this.GetColor(t), t));
            }

            return stops.ToArray();
        }
    }
}
