﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Imaging;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.ColorSpaces
{
    internal abstract class CachedColorSpaceOld : ColorSpaceOld
    {
        private readonly ArrayCache<Color> cache;

        public CachedColorSpaceOld(PdfContentManager contentManager)
            : base(contentManager)
        {
            this.cache = new ArrayCache<Color>();
        } 

        public override Color GetColor(object[] pars)
        { 
            Color result;
            if (this.cache.TryGetValue(pars, out result))
            {
                return result;
            }

            result = this.GetColorOverride(pars);
            this.cache.AddToCache(pars, result);

            return result;
        }

        public override void Clear()
        {
            this.cache.Clear();
        }  

        protected abstract Color GetColorOverride(object[] pars); 

    }
}
