﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.ColorSpaces
{
    internal class DeviceNAttributes : PdfObjectOld
    {
        private readonly InstantLoadProperty<PdfNameOld> subType;
        private readonly InstantLoadProperty<PdfDictionaryOld> colorants;
        private readonly InstantLoadProperty<PdfDictionaryOld> process;
        private readonly InstantLoadProperty<PdfDictionaryOld> mixingHints;

        public DeviceNAttributes(PdfContentManager contentManager)
            : base(contentManager)
        {
            this.subType = this.CreateInstantLoadProperty<PdfNameOld>(new PdfPropertyDescriptor("Subtype"), new PdfNameOld(this.ContentManager, "DeviceN"));
            this.colorants = this.CreateInstantLoadProperty<PdfDictionaryOld>(new PdfPropertyDescriptor("Colorants"));
            this.process = this.CreateInstantLoadProperty<PdfDictionaryOld>(new PdfPropertyDescriptor("Process"));
            this.mixingHints = this.CreateInstantLoadProperty<PdfDictionaryOld>(new PdfPropertyDescriptor("MixingHints"));
        }

        public PdfNameOld SubType
        {
            get
            {
                return this.subType.GetValue();
            }
            set
            {
                this.subType.SetValue(value);
            }
        }

        public PdfDictionaryOld Colorants
        {
            get
            {
                return this.colorants.GetValue();
            }
            set
            {
                this.colorants.SetValue(value);
            }
        }

        public PdfDictionaryOld Process
        {
            get
            {
                return this.process.GetValue();
            }
            set
            {
                this.process.SetValue(value);
            }
        }

        public PdfDictionaryOld MixingHints
        {
            get
            {
                return this.mixingHints.GetValue();
            }
            set
            {
                this.mixingHints.SetValue(value);
            }
        }

    }
}
