﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Imaging;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Functions;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.ColorSpaces
{
    internal abstract class GradientShadingOld : ShadingOld
    {
        private readonly InstantLoadProperty<PdfArrayOld> coords;
        private readonly InstantLoadProperty<PdfArrayOld> domain;
        private readonly LoadOnDemandProperty<FunctionOld> function;
        private readonly InstantLoadProperty<PdfArrayOld> extend;
        
        public GradientShadingOld(PdfContentManager contentManager)
            : base(contentManager)
        {
            this.coords = this.CreateInstantLoadProperty<PdfArrayOld>(new PdfPropertyDescriptor("Coords", true));
            this.domain = this.CreateInstantLoadProperty<PdfArrayOld>(new PdfPropertyDescriptor("Domain"), new PdfArrayOld(this.ContentManager, new object[] { 0.0, 1.0 }));
            this.function = this.CreateLoadOnDemandProperty<FunctionOld>(new PdfPropertyDescriptor("Function", true), Converters.FunctionConverter);
            this.extend = this.CreateInstantLoadProperty<PdfArrayOld>(new PdfPropertyDescriptor("Extend"), new PdfArrayOld(this.ContentManager, new object[] { false, false }));
        }

        public PdfArrayOld Coords
        {
            get
            {
                return this.coords.GetValue();
            }
            set
            {
                this.coords.SetValue(value);
            }
        }

        public PdfArrayOld Domain
        {
            get
            {
                return this.domain.GetValue();
            }
            set
            {
                this.domain.SetValue(value);
            }
        }

        public FunctionOld Function
        {
            get
            {
                return this.function.GetValue();
            }
            set
            {
                this.function.SetValue(value);
            }
        }

        public PdfArrayOld Extend
        {
            get
            {
                return this.extend.GetValue();
            }
            set
            {
                this.extend.SetValue(value);
            }
        }

        protected Color GetColor(double d)
        {
            double[] components = this.Function.Execute(new double[] { d });
         
            return this.ColorSpace.GetColor(Extensions.ToParams(components));
        }
    }
}
