﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.ColorSpaces
{
    internal class HashArray : IEquatable<HashArray>
    {
        private const int Base = 16777619;
        private const int InitialHashValue = 17;

        private readonly object[] items;

        public HashArray(object[] items)
        {
            this.items = items;
        } 

        public override bool Equals(object obj)
        {
            HashArray hashArray = obj as HashArray; 

            if (hashArray != null)
            {
                return this.Equals(hashArray);
            }

            return false;
        }

        public bool Equals(HashArray other)
        {
            if (other == this)
            {
                return true;
            }

            int itemsCount = this.items.Length;
            int otherItemsCount = other.items.Length;

            if (itemsCount != otherItemsCount)
            {
                return false;
            }

            for (int i = 0; i < itemsCount; i++)
            {
                if (!this.items[i].Equals(other.items[i]))
                {
                    return false;
                }
            }

            return true;
        }

        public override int GetHashCode()
        {
            unchecked
            {
                int result = InitialHashValue;
                if (this.items != null)
                {
                    foreach (var item in this.items)
                    {
                        result = result * Base + ((item == null) ? 0 : item.GetHashCode());
                    }

                    return result;
                }

                return 0;
            }
        } 
    }
}
