﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.ColorSpaces
{
    internal class ICCProfileOld : PdfStreamOld
    {
        private readonly InstantLoadProperty<PdfIntOld> n;
        private ColorSpaceOld alternate;
        
        public ICCProfileOld(PdfContentManager contentManager)
            : base(contentManager)
        {
            this.n = this.CreateInstantLoadProperty<PdfIntOld>(new PdfPropertyDescriptor { Name = "N", IsRequired = true });
        }
       
        public ColorSpaceOld Alternate
        {
            get
            {
                if (this.alternate == null)
                {
                    this.alternate = this.GetAlternateColorSpace();
                }
                
                return this.alternate;
            }
        }

        public PdfIntOld N
        {
            get
            {
                return this.n.GetValue();
            }
            set
            {
                this.n.SetValue(value);
            }
        }

        private ColorSpaceOld GetAlternateColorSpace()
        {
            switch (this.N.Value)
            {
                case 1:
                    return new DeviceGrayOld(this.ContentManager);
                case 3:
                    return new DeviceRgbOld(this.ContentManager);
                case 4:
                    return new DeviceCmykOld(this.ContentManager);
                default:
                    throw new NotSupportedException();
            }
        }
    }
}
