﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.ColorSpaces
{
    internal class LookupOld : PdfObjectOld
    {
        private byte[] data;

        public LookupOld(PdfContentManager contentManager)
            : base(contentManager)
        {
        }

        public byte[] Data
        {
            get
            {
                return this.data;
            }
        }

        public void Load(PdfDataStream stream)
        {
            Guard.ThrowExceptionIfNull(stream, "stream");

            this.data = stream.ReadData(this.ContentManager);
        }

        public void Load(PdfStringOld str)
        {
            Guard.ThrowExceptionIfNull(str, "str");

            this.data = str.Value;
        }

        public override void Load(IndirectObjectOld indirectObject)
        {
            Guard.ThrowExceptionIfNull(indirectObject, "indirectObject");
            
            PdfDataStream stream = indirectObject.Value as PdfDataStream;
            if (stream != null)
            {
                this.Load(stream);
            }
            else
            {
                PdfStringOld str = indirectObject.Value as PdfStringOld;
                if (str != null)
                {
                    this.Load(str);
                }
            }

            base.Load(indirectObject);
        }
    }
}
