﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Imaging;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.Model.Internal;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Filters;
using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Fixed.Model.Internal.Classes;
using Telerik.Windows.Documents.Fixed.Model.Resources;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.ColorSpaces
{
    internal class PatternColorSpaceOld : ColorSpaceOld
    {
        public PatternColorSpaceOld(PdfContentManager contentManager)
            : base(contentManager)
        {
        }

        public override int ComponentCount
        {
            get { return this.UnderlyingColorSpace.ComponentCount; }
        }

        public override ColorSpace Type
        {
            get
            {
                return ColorSpace.Pattern;
            }
        }

        public ColorSpaceOld UnderlyingColorSpace { get; set; }

        public override Color GetColor(object[] pars)
        {
            throw new NotSupportedException("This method is not supported.");
        }

        public override Color GetColor(byte[] bytes, int offset)
        {
            throw new NotSupportedException("This method is not supported.");
        }

        public override double[] GetDefaultDecodeArray(int bitsPerComponent)
        {
            return null;
        }

        protected override PixelContainer GetPixelsOverride(IImageDescriptor xImage, bool applyMask)
        {
            throw new NotSupportedException("This method is not supported.");
        }

        public override Brush GetBrush(PdfResourceOld resources, object[] pars)
        {
            Guard.ThrowExceptionIfNull(resources, "resources");
            Guard.ThrowExceptionIfNull(pars, "pars");

            int len = pars.Length - 1;
            PdfNameOld name = (PdfNameOld)pars[len];
            PatternOld p = resources.GetPattern(name);
            p.UnderlyingColorSpace = this.UnderlyingColorSpace;

            object[] newPars = new object[len];
            for (int i = 0; i < len; i++)
            {
                newPars[i] = pars[i];
            }

            return p.CreateBrush(newPars);
        }
    }
}
