﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Core.Fonts;
using Telerik.Windows.Documents.Core.Fonts.Type1.CFFFormat;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;
using Telerik.Windows.Documents.Fixed.Model.Fonts;
using Telerik.Windows.Documents.Fixed.Model.Internal;
using Telerik.Windows.Documents.Fixed.Model.Internal.Classes;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Fonts
{
    [PdfClass(TypeName = "Font", SubtypeProperty = "Subtype", SubtypeValue = "CIDFontType0")]
    internal class CIDFontType0Old : CIDFontOld
    {
        private CFFFontSource ccfFontSource;

        public CIDFontType0Old(PdfContentManager contentManager)
            : base(contentManager)
        {
        }

        public override FontSource FontSource
        {
            get
            {
                return this.CFFFontSource;
            }
        }

        private CFFFontSource CFFFontSource
        {
            get
            {
                if (ccfFontSource == null)
                {
                    this.ccfFontSource = this.FontDescriptor.GetCFFFontSource();
                }
                return this.ccfFontSource;
            }
        }

        public override IEnumerable<GlyphOld> GetGlyphs(IEnumerable<CharCodeOld> charIds)
        {
            if (this.CFFFontSource == null)
            {
                yield break;
            }

            foreach (CharCodeOld b in charIds)
            {
                GlyphOld g = new GlyphOld();
                g.CharId = b;
                CidType0Font.InitializeCoreGlyph(g, this.CFFFontSource, b.IntValue);

                yield return g;
            }
        }
    }
}
