﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Text;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;
using Telerik.Windows.Documents.Fixed.Model.Common.Functions;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Functions
{
    [PdfClass(TypeName = "Function", SubtypeProperty = PdfNames.FunctionType, SubtypeValue = "2")]
    internal class ExponentialInterpolationFunctionOld : FunctionOld
    {
        private readonly InstantLoadProperty<PdfArrayOld> c0;
        private readonly InstantLoadProperty<PdfArrayOld> c1;
        private readonly InstantLoadProperty<PdfRealOld> number;

        public ExponentialInterpolationFunctionOld(PdfContentManager contentManager)
            : base(contentManager)
        {
            this.c0 = this.CreateInstantLoadProperty<PdfArrayOld>(new PdfPropertyDescriptor("C0"));
            this.c1 = this.CreateInstantLoadProperty<PdfArrayOld>(new PdfPropertyDescriptor("C1"));
            this.number = this.CreateInstantLoadProperty<PdfRealOld>(new PdfPropertyDescriptor("N", true), Converters.PdfRealConverter);
        }

        public PdfArrayOld C0
        {
            get
            {
                return this.c0.GetValue();
            }
            set
            {
                this.c0.SetValue(value);
            }
        }

        public PdfArrayOld C1
        {
            get
            {
                return this.c1.GetValue();
            }
            set
            {
                this.c1.SetValue(value);
            }
        }

        public PdfRealOld Number
        {
            get
            {
                return this.number.GetValue();
            }
            set
            {
                this.number.SetValue(value);
            }
        }

        protected override FunctionBase CreateFunctionModel()
        {
            double n = this.Number.Value;
            double[] c0 = this.ReadDoubleArray(this.C0);
            double[] c1 = this.ReadDoubleArray(this.C1);
            double[] domain = this.ReadDoubleArray(this.Domain);
            double[] range = this.ReadDoubleArray(this.Range);

            ExponentialInterpolationFunction function = new ExponentialInterpolationFunction(n, c0, c1, domain, range);

            return function;
        }

        protected override FunctionBase CreateFunctionModel(byte[] data)
        {
            return this.CreateFunctionModel();
        }
    }
}
