﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Text;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;
using Telerik.Windows.Documents.Fixed.Model.Common.Functions;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Functions
{
    [PdfClass(TypeName = "Function", SubtypeProperty = PdfNames.FunctionType, SubtypeValue = "3")]
    internal class StitchingFunctionOld : FunctionOld
    {
        private readonly InstantLoadProperty<PdfArrayOld> functions;
        private readonly InstantLoadProperty<PdfArrayOld> bounds;
        private readonly InstantLoadProperty<PdfArrayOld> encode;

        public StitchingFunctionOld(PdfContentManager contentManager)
            : base(contentManager)
        {
            this.functions = this.CreateInstantLoadProperty<PdfArrayOld>(new PdfPropertyDescriptor("Functions", true));
            this.bounds = this.CreateInstantLoadProperty<PdfArrayOld>(new PdfPropertyDescriptor("Bounds", true));
            this.encode = this.CreateInstantLoadProperty<PdfArrayOld>(new PdfPropertyDescriptor("Encode", true));
        }

        public PdfArrayOld Functions
        {
            get
            {
                return this.functions.GetValue();
            }
            set
            {
                this.functions.SetValue(value);
            }
        }

        public PdfArrayOld Bounds
        {
            get
            {
                return this.bounds.GetValue();
            }
            set
            {
                this.bounds.SetValue(value);
            }
        }

        public PdfArrayOld Encode
        {
            get
            {
                return this.encode.GetValue();
            }
            set
            {
                this.encode.SetValue(value);
            }
        }

        protected override FunctionBase CreateFunctionModel()
        {
            FunctionBase[] functions = new FunctionBase[this.Functions.Count];

            for (int i = 0; i < functions.Length; i++)
            {
                FunctionOld functionObject = this.Functions.GetElement<FunctionOld>(i, Converters.FunctionConverter);
                functions[i] = functionObject.FunctionModel;
            }

            double[] bounds = this.ReadDoubleArray(this.Bounds);
            double[] encode = this.ReadDoubleArray(this.Encode);
            double[] domain = this.ReadDoubleArray(this.Domain);
            double[] range = this.ReadDoubleArray(this.Range);

            StitchingFunction function = new StitchingFunction(functions, bounds, encode, domain, range);

            return function;
        }

        protected override FunctionBase CreateFunctionModel(byte[] data)
        {
            return this.CreateFunctionModel();
        }
    }
}
