﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Actions;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Navigation
{
    internal class OutlineItemOld : PdfObjectOld
    {
        private readonly InstantLoadProperty<PdfStringOld> title;
        private readonly LoadOnDemandProperty<OutlineItemOld> parent;
        private readonly LoadOnDemandProperty<OutlineItemOld> prev;
        private readonly LoadOnDemandProperty<OutlineItemOld> next;
        private readonly LoadOnDemandProperty<OutlineItemOld> first;
        private readonly LoadOnDemandProperty<OutlineItemOld> last;
        private readonly InstantLoadProperty<PdfIntOld> count;
        private readonly LoadOnDemandProperty<DestinationOld> destination;
        private readonly LoadOnDemandProperty<ActionOld> action;
        private readonly InstantLoadProperty<PdfIntOld> flag;

        public OutlineItemOld(PdfContentManager contentManager) : base(contentManager)
        {
            this.title = this.CreateInstantLoadProperty<PdfStringOld>(new PdfPropertyDescriptor { Name = "Title" });
            this.parent = this.CreateLoadOnDemandProperty<OutlineItemOld>(new PdfPropertyDescriptor { Name = "Parent" });
            this.prev = this.CreateLoadOnDemandProperty<OutlineItemOld>(new PdfPropertyDescriptor { Name = "Prev" });
            this.next = this.CreateLoadOnDemandProperty<OutlineItemOld>(new PdfPropertyDescriptor { Name = "Next" });
            this.first = this.CreateLoadOnDemandProperty<OutlineItemOld>(new PdfPropertyDescriptor { Name = "First" });
            this.last = this.CreateLoadOnDemandProperty<OutlineItemOld>(new PdfPropertyDescriptor { Name = "Last" });
            this.count = this.CreateInstantLoadProperty<PdfIntOld>(new PdfPropertyDescriptor { Name = "Count" });
            this.destination = this.CreateLoadOnDemandProperty<DestinationOld>(new PdfPropertyDescriptor { Name = "Dest" }, Converters.DestinationConverter);
            this.action = this.CreateLoadOnDemandProperty<ActionOld>(new PdfPropertyDescriptor { Name = "A" }, Converters.ActionConverter);
            this.flag = this.CreateInstantLoadProperty<PdfIntOld>(new PdfPropertyDescriptor { Name = "F" });
        }

        public PdfStringOld Title
        {
            get
            {
                return this.title.GetValue();
            }
            set
            {
                this.title.SetValue(value);
            }
        }

        public OutlineItemOld Parent
        {
            get
            {
                return this.parent.GetValue();
            }
            set
            {
                this.parent.SetValue(value);
            }
        }

        public OutlineItemOld Prev
        {
            get
            {
                return this.prev.GetValue();
            }
            set
            {
                this.prev.SetValue(value);
            }
        }

        public OutlineItemOld Next
        {
            get
            {
                return this.next.GetValue();
            }
            set
            {
                this.next.SetValue(value);
            }
        }

        public OutlineItemOld First
        {
            get
            {
                return this.first.GetValue();
            }
            set
            {
                this.first.SetValue(value);
            }
        }

        public OutlineItemOld Last
        {
            get
            {
                return this.last.GetValue();
            }
            set
            {
                this.last.SetValue(value);
            }
        }

        public PdfIntOld Count
        {
            get
            {
                return this.count.GetValue();
            }
            set
            {
                this.count.SetValue(value);
            }
        }

        public DestinationOld Destination
        {
            get
            {
                return this.destination.GetValue();
            }
            set
            {
                this.destination.SetValue(value);
            }
        }

        public ActionOld Action
        {
            get
            {
                return this.action.GetValue();
            }
            set
            {
                this.action.SetValue(value);
            }
        }

        public PdfIntOld Flag
        {
            get
            {
                return this.flag.GetValue();
            }
            set
            {
                this.flag.SetValue(value);
            }
        }
    }
}
