﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Navigation
{
    internal class OutlinesOld : PdfObjectOld
    {
        private readonly InstantLoadProperty<PdfNameOld> type;
        private readonly LoadOnDemandProperty<OutlineItemOld> first;
        private readonly LoadOnDemandProperty<OutlineItemOld> last;
        private readonly InstantLoadProperty<PdfIntOld> count;

        public OutlinesOld(PdfContentManager contentManager) : base(contentManager)
        {
            this.type = this.CreateInstantLoadProperty<PdfNameOld>(new PdfPropertyDescriptor { Name = "Type" });
            this.first = this.CreateLoadOnDemandProperty<OutlineItemOld>(new PdfPropertyDescriptor { Name = "First" });
            this.last = this.CreateLoadOnDemandProperty<OutlineItemOld>(new PdfPropertyDescriptor { Name = "Last" });
            this.count = this.CreateInstantLoadProperty<PdfIntOld>(new PdfPropertyDescriptor { Name = "Count" });
        }

        public PdfNameOld Type
        {
            get
            {
                return this.type.GetValue();
            }
            set
            {
                this.type.SetValue(value);
            }
        }

        public OutlineItemOld First
        {
            get
            {
                return this.first.GetValue();
            }
            set
            {
                this.first.SetValue(value);
            }
        }

        public OutlineItemOld Last
        {
            get
            {
                return this.last.GetValue();
            }
            set
            {
                this.last.SetValue(value);
            }
        }

        public PdfIntOld Count
        {
            get
            {
                return this.count.GetValue();
            }
            set
            {
                this.count.SetValue(value);
            }
        }
    }
}
