﻿using System;
using System.Windows;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Trees;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core
{
    [PdfClass]
    internal class PageOld : PageTreeNodeOld
    {
        private readonly LoadOnDemandProperty<ContentStreamOld> contents;
        private readonly LoadOnDemandProperty<PdfArrayOld> annots;

        public PageOld(PdfContentManager contentManager)
            : base(contentManager)
        {
            this.contents = this.CreateLoadOnDemandProperty<ContentStreamOld>(new PdfPropertyDescriptor { Name = "Contents" }, Converters.ContentsConverter);
            this.annots = this.CreateLoadOnDemandProperty<PdfArrayOld>(new PdfPropertyDescriptor { Name = "Annots" });
        }

        public Rect Clip
        {
            get
            {
                return this.MediaBox.ToRect();
            }
        }

        public ContentStreamOld Contents
        {
            get
            {
                return this.contents.GetValue();
            }
            set
            {
                this.contents.SetValue(value);
            }
        }

        public PdfArrayOld Annots
        {
            get
            {
                return this.annots.GetValue();
            }
            set
            {
                this.annots.SetValue(value);
            }
        }

        public override string ToString()
        {
            if (this.Reference != null)
            {
                return this.Reference.ToString();
            }

            return base.ToString();
        }
    }
}
