﻿using System.Windows;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.XObjects
{
    [PdfClass(TypeName = "XObject", SubtypeProperty = "Subtype", SubtypeValue = "Form")]
    internal class XForm : XObject
    {
        private readonly LoadOnDemandProperty<PdfResourceOld> resources;
        private readonly LoadOnDemandProperty<PdfArrayOld> matrix;
        private readonly LoadOnDemandProperty<PdfArrayOld> bbox;

        public XForm(PdfContentManager contentManager)
            : base(contentManager)
        {
            this.matrix = this.CreateLoadOnDemandProperty<PdfArrayOld>(new PdfPropertyDescriptor { Name = "Matrix" }, PdfArrayOld.CreateMatrixIdentity(contentManager));
            this.resources = this.CreateLoadOnDemandProperty<PdfResourceOld>(new PdfPropertyDescriptor { Name = "Resources" }, Converters.PdfDictionaryToPdfObjectConverter);
            this.bbox = this.CreateLoadOnDemandProperty<PdfArrayOld>(new PdfPropertyDescriptor { Name = "BBox", IsRequired = true });
        }
       
        public Rect Clip
        {
            get
            {
                return this.BBox.ToRect();
            }
        }

        public PdfArrayOld Matrix
        {
            get
            {
                return this.matrix.GetValue();
            }
            set
            {
                this.matrix.SetValue(value);
            }
        }

        public PdfResourceOld Resources
        {
            get
            {
                return this.resources.GetValue();
            }
            set
            {
                this.resources.SetValue(value);
            }
        }

        public PdfArrayOld BBox
        {
            get
            {
                return this.bbox.GetValue();
            }
            set
            {
                this.bbox.SetValue(value);
            }
        }
    }
}
