﻿using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data
{
	internal class PdfSimpleTypeOld<T> : PdfSimpleTypeOld
    {
        private T value;

        public PdfSimpleTypeOld(PdfContentManager contentManager)
            : base(contentManager)
        {
        }

        public T Value
		{
			get
			{
				return this.value;
			}
			set
			{
				this.value = value;
				this.IsLoaded = true;
			}
		}

        public override void Load(Data.IndirectObjectOld indirectObject)
        {
            Guard.ThrowExceptionIfNull(indirectObject, "indirectObject");

            PdfSimpleTypeOld<T> value = indirectObject as PdfSimpleTypeOld<T>;
            if (value != null)
            {
                this.Value = value.Value;
            }

            base.Load(indirectObject);
        }

        public override object GetValue()
        {
            return this.Value;
        }

        public override string ToString()
        {
            return Value.ToString();
        }
    }
}
