﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data
{
    internal class PdfStringOld : PdfSimpleTypeOld<byte[]>
    {
        public PdfStringOld(PdfContentManager contentManager)
            : base(contentManager)
        {
        }

        public PdfStringOld(PdfContentManager contentManager, byte[] value)
            : base(contentManager)
        {
            this.Value = value;
        }

        public override string ToString()
        {
            return PdfString.GetString(this.Value);
        }

        public string ToUnicodeString()
        {
            return PdfString.GetUtfEncodedTextString(this.Value);
        }

        public void Increment()
        {
            if (this.Value == null)
            {
                return;
            }
            byte ost = 1;
            int n;
            for (int i = this.Value.Length - 1; i >= 0; i--)
            {
                n = this.Value[i] + ost;
                ost = (byte)(n / 256);
                this.Value[i] = (byte)(n % 256);
                if (ost == 0)
                {
                    break;
                }
            }
        }
    }
}
