﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Annot;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.XObjects;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters
{
    internal class AppearanceConverterOld : IndirectReferenceConverterBase
    {
        protected override object ConvertFromIndirectReference(Type type, PdfContentManager contentManager, IndirectReferenceOld indirectReference)
        {
            object cachedResult;
            AppearanceOld appearance;

            if (contentManager.TryGetPdfObject(indirectReference, out cachedResult))
            {
                XForm form = cachedResult as XForm;
                appearance = form == null ? ((AppearanceOld)cachedResult) : new AppearanceOld(contentManager, form);
            }
            else
            {
                appearance = (AppearanceOld)base.ConvertFromIndirectReference(type, contentManager, indirectReference);

                if (appearance.SingleStateAppearance != null)
                {
                    appearance.SingleStateAppearance.Reference = appearance.Reference;
                    contentManager.RegisterIndirectReference(indirectReference, appearance.SingleStateAppearance);
                }
            }

            return appearance;
        }

        protected override object ConvertFromPdfDataStream(Type type, PdfContentManager contentManager, PdfDataStream stream)
        {
            XForm form = (XForm)Converters.XObjectConverter.Convert(typeof(XForm), contentManager, stream);

            return new AppearanceOld(contentManager, form);
        }

        protected override object ConvertFromPdfDictionary(Type type, PdfContentManager contentManager, PdfDictionaryOld dictionary)
        {
            Dictionary<string, XForm> stateToAppearance = new Dictionary<string, XForm>();

            foreach (KeyValuePair<string, object> pair in dictionary)
            {
                XForm form = (XForm)Converters.XObjectConverter.Convert(typeof(XForm), contentManager, pair.Value);
                stateToAppearance[pair.Key] = form;
            }

            return new AppearanceOld(contentManager, stateToAppearance);
        }
    }
}
