﻿using System;
using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.ColorSpaces;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters
{
    internal class ColorSpaceConverter : IndirectReferenceConverterBase
	{
        protected override object ConvertFromPdfName(Type type, PdfContentManager contentManager, PdfNameOld name)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(name, "name");

            return ColorSpaceOld.CreateColorSpace(contentManager, name.Value);
        }

        protected override object ConvertFromPdfArray(Type type, PdfContentManager contentManager, PdfArrayOld array)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(array, "array");

            return ColorSpaceOld.CreateColorSpace(contentManager, array);
        }
	}
}
