﻿namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters
{
    internal static class Converters
    {
        private static readonly IndirectReferenceToPdfObjectConverter indirectReferenceToPdfObjectConverter;
        private static readonly EncryptConverter encryptConverter;
        private static readonly PdfDictionaryToPdfObjectConverter pdfDictionaryToPdfObjectConverter;
        private static readonly ColorSpaceConverter colorSpaceConverter;
        private static readonly PatternConverter patternConverter;
        private static readonly ShadingConverter shadingConverter;
        private static readonly ContentsConverter contentsConverter;
        private static readonly AppearanceConverterOld appearanceConverter;
        private static readonly CIDFontConverter cidFontConverter;
        private static readonly CIDToGIDMapConverter cidToGidMapConverter;
        private static readonly EncodingConverter encodingConverter;
        private static readonly CMapStreamConverter cmapConverter;
        private static readonly PdfRealConverter pdfRealConverter;
        private static readonly PdfIntConverter pdfIntConverter;
        private static readonly PdfBoolConverter pdfBoolConverter;
        private static readonly PdfNameConverter pdfNameConverter;
        private static readonly DestinationConverter destinationConverter;
        private static readonly ActionConverter actionConverter;
        private static readonly AnnotConverter annotConverter;
        private static readonly FunctionConverter functionConverter;
        private static readonly FontConverter fontConverter;
        private static readonly XObjectConverter xobjectConverter;
        private static readonly LookupConverter lookupConverter;
        private static readonly FiltersConverter filtersConverter;
        private static readonly DecodeParametersConverter decodeParametersConverter;
        private static readonly PdfStringConverter pdfStringConverter;
        private static readonly MaskConverter maskConverter;
        private static readonly XFAStreamConverterOld xfaConverter;
        private static readonly FieldsConverterOld fieldsConverter;
        private static readonly PdfArrayConverterOld arrayConverter;

        static Converters()
        {
            indirectReferenceToPdfObjectConverter = new IndirectReferenceToPdfObjectConverter();
            pdfDictionaryToPdfObjectConverter = new PdfDictionaryToPdfObjectConverter();
            colorSpaceConverter = new ColorSpaceConverter();
            contentsConverter = new ContentsConverter();
            appearanceConverter = new AppearanceConverterOld();
            encodingConverter = new EncodingConverter();
            cmapConverter = new CMapStreamConverter();
            pdfRealConverter = new PdfRealConverter();
            pdfIntConverter = new PdfIntConverter();
            pdfBoolConverter = new PdfBoolConverter();
            destinationConverter = new DestinationConverter();
            annotConverter = new AnnotConverter();
            actionConverter = new ActionConverter();
            encryptConverter = new EncryptConverter();
            cidFontConverter = new CIDFontConverter();
            cidToGidMapConverter = new CIDToGIDMapConverter();
            pdfNameConverter = new PdfNameConverter();
            patternConverter = new PatternConverter();
            shadingConverter = new ShadingConverter();
            functionConverter = new FunctionConverter();
            fontConverter = new FontConverter();
            xobjectConverter = new XObjectConverter();
            lookupConverter = new LookupConverter();
            filtersConverter = new FiltersConverter();
            decodeParametersConverter = new DecodeParametersConverter();
            pdfStringConverter = new PdfStringConverter();
            maskConverter = new MaskConverter();
            xfaConverter = new XFAStreamConverterOld();
            fieldsConverter = new FieldsConverterOld();
            arrayConverter = new PdfArrayConverterOld();
        }

        public static MaskConverter MaskConverter
        {
            get
            {
                return maskConverter;
            }
        }

        public static PdfStringConverter PdfStringConverter
        {
            get
            {
                return pdfStringConverter;
            }
        }

        public static PdfArrayConverterOld ArrayConverter
        {
            get
            {
                return arrayConverter;
            }
        }

        public static FunctionConverter FunctionConverter
        {
            get
            {
                return functionConverter;
            }
        }

        public static AnnotConverter AnnotConverter
        {
            get
            {
                return annotConverter;
            }
        }

        public static FieldsConverterOld FieldsConverter
        {
            get
            {
                return fieldsConverter;
            }
        }

        public static XFAStreamConverterOld XFAConverter
        {
            get
            {
                return xfaConverter;
            }
        }

        public static ActionConverter ActionConverter
        {
            get
            {
                return actionConverter;
            }
        }

        public static DestinationConverter DestinationConverter
        {
            get
            {
                return destinationConverter;
            }
        }

        public static PdfNameConverter PdfNameConverter
        {
            get
            {
                return pdfNameConverter;
            }
        }

        public static PdfBoolConverter PdfBoolConverter
        {
            get
            {
                return pdfBoolConverter;
            }
        }

        public static PdfIntConverter PdfIntConverter
        {
            get
            {
                return pdfIntConverter;
            }
        }

        public static PdfRealConverter PdfRealConverter
        {
            get
            {
                return pdfRealConverter;
            }
        }

        public static CIDToGIDMapConverter CidToGidMapConverter
        {
            get
            {
                return cidToGidMapConverter;
            }
        }

        public static CMapStreamConverter CMapStreamConverter
        {
            get
            {
                return cmapConverter;
            }
        }

        public static EncodingConverter EncodingConverter
        {
            get
            {
                return encodingConverter;
            }
        }

        public static CIDFontConverter CIDFontConverter
        {
            get
            {
                return cidFontConverter;
            }
        }

        public static ContentsConverter ContentsConverter
        {
            get
            {
                return contentsConverter;
            }
        }

        public static AppearanceConverterOld AppearanceConverter
        {
            get
            {
                return appearanceConverter;
            }
        }

        public static ShadingConverter ShadingConverter
        {
            get
            {
                return shadingConverter;
            }
        }

        public static PatternConverter PatternConverter
        {
            get
            {
                return patternConverter;
            }
        }

        public static ColorSpaceConverter ColorSpaceConverter
        {
            get
            {
                return colorSpaceConverter;
            }
        }

        public static PdfDictionaryToPdfObjectConverter PdfDictionaryToPdfObjectConverter
        {
            get
            {
                return pdfDictionaryToPdfObjectConverter;
            }
        }

        public static EncryptConverter EncryptConverter
        {
            get
            {
                return encryptConverter;
            }
        }

        public static FontConverter FontConverter
        {
            get
            {
                return fontConverter;
            }
        }

        public static XObjectConverter XObjectConverter
        {
            get
            {
                return xobjectConverter;
            }
        }

        public static LookupConverter LookupConverter
        {
            get
            {
                return lookupConverter;
            }
        }

        public static FiltersConverter FiltersConverter
        {
            get
            {
                return filtersConverter;
            }
        }

        public static DecodeParametersConverter DecodeParametersConverter
        {
            get
            {
                return decodeParametersConverter;
            }
        }

        public static IndirectReferenceToPdfObjectConverter IndirectReferenceToPdfObjectConverter
        {
            get
            {
                return indirectReferenceToPdfObjectConverter;
            }
        }
    }
}