﻿using System;
using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Navigation;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Text;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters
{
    internal class DestinationConverter : IndirectReferenceConverterBase
    {
        protected override object ConvertFromPdfDictionary(Type type, PdfReader.PdfContentManager contentManager, PdfDictionaryOld dictionary)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(dictionary, "dictionary");

            return dictionary.GetElement<DestinationOld>(PdfNames.D, Converters.DestinationConverter); 
        }

        protected override object ConvertFromPdfArray(Type type, PdfReader.PdfContentManager contentManager, PdfArrayOld array)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(array, "array");

            DestinationOld res = new DestinationOld(contentManager);
            res.Load(array);
          
            return res;
        }

        protected override object ConvertFromPdfName(Type type, PdfReader.PdfContentManager contentManager, PdfNameOld name)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(name, "name");

            return contentManager.DocumentCatalog.GetDestination(name);
        }

        protected override object ConvertFromPdfString(Type type, PdfReader.PdfContentManager contentManager, PdfStringOld str)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(str, "str");

            return contentManager.DocumentCatalog.GetDestination(str);
        }
    }
}
