﻿using System;
using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Encryption;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters
{
    internal class EncryptConverter : IndirectReferenceConverterBase
	{
        protected override object ConvertFromIndirectReference(Type type, PdfContentManager contentManager, IndirectReferenceOld indirectReference)
        {
            object res;
            if (!contentManager.TryGetPdfObject(indirectReference, out res))
            {
                IndirectObjectOld indirectObject;
                if (contentManager.TryGetIndirectObject(indirectReference, false, out indirectObject))
                {
                    res = Convert(type, contentManager, indirectObject.Value);
                }

                PdfObjectOld pdfObject = res as PdfObjectOld;
                if (pdfObject != null)
                {
                    pdfObject.Reference = indirectReference;

                }

                contentManager.RegisterIndirectReference(indirectReference, res);
            }

            return res;
        }

        protected override object ConvertFromPdfDictionary(Type type, PdfContentManager contentManager, PdfDictionaryOld dictionary)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(dictionary, "dictionary");

            return EncryptOld.CreateEncrypt(contentManager, dictionary);
        }
	}
}
