﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters
{
    internal class FiltersConverter : IndirectReferenceConverterBase
	{
        protected override object ConvertFromPdfName(Type type, PdfReader.PdfContentManager contentManager, Data.PdfNameOld name)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(name, "name");

            return new PdfNameOld[] { name };
        }

        protected override object ConvertFromPdfArray(Type type, PdfReader.PdfContentManager contentManager, PdfArrayOld array)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(array, "array");

            PdfNameOld[] res = new PdfNameOld[array.Count];
            for (int i = 0; i < array.Count; i++)
            {
                res[i] = array.GetElement<PdfNameOld>(i, Converters.PdfNameConverter);
            }

            return res;
        }
    }
}
