﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters
{
	internal class IndirectReferenceToPdfObjectConverter
	{
        public T Convert<T>(PdfContentManager contentManager, IndirectReferenceOld reference) where T : PdfObjectOld
        {
            object result;
            if (!contentManager.TryGetPdfObject(reference, out result))
            {
                T obj = (T)Activator.CreateInstance(typeof(T), contentManager);
                obj.Reference = reference;
                contentManager.RegisterIndirectReference(reference, obj);

                return obj;
            }
            else if (!(result is T))
            {
                T obj = (T)Activator.CreateInstance(typeof(T), contentManager);
                obj.Reference = reference;

                return obj;
            }

            return (T)result;
        }
	}
}
