﻿using System;
using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.ColorSpaces;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters
{
    internal class LookupConverter : IndirectReferenceConverterBase
	{
        protected override object ConvertFromPdfDataStream(Type type, PdfReader.PdfContentManager contentManager, Data.PdfDataStream stream)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(stream, "stream");

            LookupOld res = new LookupOld(contentManager);
            res.Load(stream);

            return res;
        }

        protected override object ConvertFromPdfString(Type type, PdfReader.PdfContentManager contentManager, Data.PdfStringOld str)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(str, "str");

            LookupOld res = new LookupOld(contentManager);
            res.Load(str);

            return res;
        }
    }
}
