﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters
{
    internal class PdfArrayConverterOld : IndirectReferenceConverterBase
    {
        public override object Convert(Type type, PdfContentManager contentManager, object value)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(value, "value");

            
            object directObject = base.Convert(type, contentManager, value);

            PdfArrayOld array = directObject as PdfArrayOld;
            if (array == null)
            {
                return new PdfArrayOld(contentManager, Enumerable.Repeat(directObject, 1));
            }
            else
            {
                return array;
            }
        }
    }
}
