﻿using System;
using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.PdfConverters
{
    internal class PdfBoolConverter : ConverterBase
    {
        public override object Convert(Type type, PdfContentManager contentManager, object value)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");
            Guard.ThrowExceptionIfNull(value, "value");

            PdfBoolOld b = value as PdfBoolOld;
            if (b != null)
            {
                return b;
            }

            bool res;
            Helper.UnboxBool(value, out res);

            return new PdfBoolOld(contentManager, res);
        }
    }
}
