﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Core.Annot;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.Model.Annotations;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader
{
    internal class AcroFormCacheManager
    {
        private readonly Dictionary<WidgetOld, Widget> widgetsMapping;
        private readonly FieldsAndWidgetsPropertiesImportContext fieldsAndWidgetImportContext;
        private int? currentBiggestImportId;

        public AcroFormCacheManager(PdfImportSettings importSettings)
        {
            this.widgetsMapping = new Dictionary<WidgetOld, Widget>();
            this.fieldsAndWidgetImportContext = new FieldsAndWidgetsPropertiesImportContext(importSettings);
        }

        public FieldsAndWidgetsPropertiesImportContext FieldsAndWidgetsImportContext
        {
            get
            {
                return this.fieldsAndWidgetImportContext;
            }
        }

        public int BiggestObjectId
        {
            get
            {
                if(this.currentBiggestImportId.HasValue)
                {
                    return this.currentBiggestImportId.Value;
                }

                return this.fieldsAndWidgetImportContext.CrossReferences.MaxObjectNumber;
            }
            set
            {
                this.currentBiggestImportId = value;
            }
        }

        public bool TryGetWidgetFromWidgetObject(WidgetOld widgetObject, out Widget widget)
        {
            bool success = this.widgetsMapping.TryGetValue(widgetObject, out widget);

            return success;
        }

        public void MapWidget(WidgetOld widgetObject, Widget widget)
        {
            this.widgetsMapping.Add(widgetObject, widget);
        }
    }
}
