﻿using System;
using System.IO;
using Telerik.Windows.Documents.Core.PostScript.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader.Parsers
{
    internal class ObjectStreamParser : PdfParserBase
    {
        public ObjectStreamParser(PdfContentManager contentManager, Stream stream)
            : base(contentManager, stream)
        {
        }

        public PdfObjectOld ReadPdfObject(long offset)
        {
            this.Reader.Seek(offset, SeekOrigin.Begin);
            Token tok = this.Reader.ReadToken();
            switch (tok)
            {
                case Token.ArrayStart:
                    return this.ParseCurrentTokenToArray();
                case Token.Boolean:
                    return this.ParseCurrentTokenToBool();
                case Token.DictionaryStart:
                    return this.ParseCurrentTokenToDictionary();
                case Token.Integer:
                    return this.ParseCurrentTokenToInt();
                case Token.Name:
                    return this.ParseCurrentTokenToName();
                case Token.Real:
                    return this.ParseCurrentTokenToReal();
                case Token.String:
                    return this.ParseCurrentTokenToString();
                default:
                    return null;
            }
        }

        public int[] ReadOffsets(int n, int first)
        {
            var res = new int[n];
            int numb;
            for (int i = 0; i < n; i++)
            {
                numb = this.ReadInt();
                numb = this.ReadInt();
                res[i] = numb + first;
            }
            return res;
        }
    }
}
