﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Graphics;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export.ContentElementWriters
{
    internal class ClippingGeometryWriter : GeometryWriterBase
    {
        protected override void WritePathGeometry(PdfWriter writer, IPdfContentExportContext context, PathGeometry pathGeometry)
        {
            base.WritePathGeometry(writer, context, pathGeometry);

            switch (pathGeometry.FillRule)
            {
                case FillRule.EvenOdd:
                    Operators.ContentStreamOperators.ModifyClippingPathEvenOddOperator.Write(writer, context);
                    break;
                case FillRule.Nonzero:
                    Operators.ContentStreamOperators.ModifyClippingPathNonzeroOperator.Write(writer, context);
                    break;
                default:
                    throw new NotSupportedException(string.Format("Fill rule of type {0} is not supported for clipping operator.", pathGeometry.FillRule));
            }

            Operators.ContentStreamOperators.EndPathOperator.Write(writer, context);
        }

        protected override void WriteRectangleGeometry(PdfWriter writer, IPdfContentExportContext context, RectangleGeometry rectangleGeometry)
        {
            base.WriteRectangleGeometry(writer, context, rectangleGeometry);

            Operators.ContentStreamOperators.ModifyClippingPathNonzeroOperator.Write(writer, context);
            Operators.ContentStreamOperators.EndPathOperator.Write(writer, context);
        }
    }
}
