﻿using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export.ContentElementWriters
{
    internal abstract class ColorWriterBase : ContentElementWriter<ColorBase>
    {
        protected override void WriteOverride(PdfWriter writer, IPdfContentExportContext context, ColorBase element)
        {
            if (context.Owner.CanWriteColors)
            {
                switch (element.ColorSpace.Name)
                {
                    case ColorSpaceNames.DeviceRgb:

                        this.WriteRgbColor(writer, context, (RgbColor)element);
                        break;

                    case ColorSpaceNames.Pattern:

                        this.WritePatternColor(writer, context, (PatternColor)element);
                        break;
                }
            }
        }

        protected abstract void WriteRgbColor(PdfWriter writer, IPdfContentExportContext context, RgbColor color);

        protected abstract void WritePatternColor(PdfWriter writer, IPdfContentExportContext context, PatternColor color);
    }
}
