﻿using Telerik.Windows.Documents.Fixed.Model.Common;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export.ContentElementWriters
{
    internal class ContainerWriter : ContentElementWriter<IContentRootElement>
    {
        protected override void WriteOverride(PdfWriter writer, IPdfContentExportContext context, IContentRootElement container)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(container, "container");

            foreach (ContentElementBase element in container.Content)
            {
                ContentElementWriterBase.WriteElement(writer, context, element);
            }
        }
    }
}
