﻿using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export.ContentElementWriters
{
    internal abstract class ContentElementWriter<T> : ContentElementWriterBase
    {
        public sealed override void Write(PdfWriter writer, IPdfContentExportContext context, object element)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(element, "element");

            this.WriteOverride(writer, context, (T)element);
        }

        protected abstract void WriteOverride(PdfWriter writer, IPdfContentExportContext context, T element);
    }
}
