﻿using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export.ContentElementWriters
{
    internal abstract class ContentElementWriterBase
    {
        public static void WriteElement(PdfWriter writer, IPdfContentExportContext context, object element)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(element, "element");

            ContentElementWriterBase elementWriter;
            if (ContentElementWriters.TryGetWriter(element, out elementWriter))
            {
                elementWriter.Write(writer, context, element);
            }
        }

        public abstract void Write(PdfWriter writer, IPdfContentExportContext context, object element);
    }
}
