﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Fixed.Model.Data;
using Telerik.Windows.Documents.Fixed.Model.Objects;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export.ContentElementWriters
{
    internal class FormWriter : MarkableContentElementWriter<Form>
    {
        protected override void WriteOverride(PdfWriter writer, IPdfContentExportContext context, Form element)
        {
            using (Operators.ContentStreamOperators.PushGraphicsState(writer, context))
            {
                bool applyTopLeftTransformation = true;
                Matrix scaledPosition = element.GetScaledPosition(applyTopLeftTransformation);
                MatrixPosition formPosition = new MatrixPosition(scaledPosition);

                ResourceEntry entry = context.GetResource(element.FormSource);
                Operators.ContentStreamOperators.ConcatMatrixOperator.Write(writer, context, formPosition);
                Operators.ContentStreamOperators.PaintOperator.Write(writer, context, entry.ResourceKey);
            }
        }
    }
}