﻿using Telerik.Windows.Documents.Fixed.Model;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export.ContentElementWriters
{
    internal class GeometryPropertiesWriter : ContentElementWriter<GeometryPropertiesOwner>
    {
        protected override void WriteOverride(PdfWriter writer, IPdfContentExportContext context, GeometryPropertiesOwner element)
        {
            if (element.IsFilled)
            {
                ContentElementWriters.ColorWriter.Write(writer, context, element.Fill);
            }

            if (element.IsStroked)
            {
                ContentElementWriters.StrokeColorWriter.Write(writer, context, element.Stroke);

                Operators.ContentStreamOperators.SetLineWidthOperator.Write(writer, context, element.StrokeThickness);
                Operators.ContentStreamOperators.SetLineJoinOperator.Write(writer, context, element.StrokeLineJoin);
                Operators.ContentStreamOperators.SetLineCapOperator.Write(writer, context, element.StrokeLineCap);

                if (element.StrokeDashArray != null)
                {
                    Operators.ContentStreamOperators.SetLineDashPatternOperator.Write(writer, context, element.StrokeDashArray, element.StrokeDashOffset);
                }

                if (element.MiterLimit.HasValue)
                {
                    Operators.ContentStreamOperators.SetMiterLimitOperator.Write(writer, context, element.MiterLimit.Value);
                }
            }
        }
    }
}
