﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Fixed.Model.Data;
using Telerik.Windows.Documents.Fixed.Model.Objects;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export.ContentElementWriters
{
    internal class ImageWriter : MarkableContentElementWriter<Image>
    {
        protected override void WriteOverride(PdfWriter writer, IPdfContentExportContext context, Image element)
        {
            using (Operators.ContentStreamOperators.PushGraphicsState(writer, context))
            {
                if (element.StencilColor != null)
                {
                    ContentElementWriters.ColorWriter.Write(writer, context, element.StencilColor);
                }

                Matrix matrix = new Matrix(element.Width, 0, 0, -element.Height, 0, element.Height);
                matrix = matrix.MultiplyBy(element.Position.Matrix);
                MatrixPosition imagePosition = new MatrixPosition(matrix);

                ResourceEntry entry = context.GetResource(element.ImageSource);
                Operators.ContentStreamOperators.ConcatMatrixOperator.Write(writer, context, imagePosition);
                Operators.ContentStreamOperators.PaintOperator.Write(writer, context, entry.ResourceKey);
            }
        }
    }
}
