﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Annotations;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Annotations;
using Telerik.Windows.Documents.Fixed.Model.InteractiveForms;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export
{
    internal class FieldsAndWidgetsPropertiesExportContext : RadFixedDocumentExportContext
    {
        private int currentObjectNumber;

        public FieldsAndWidgetsPropertiesExportContext(int startObjectId, RadFixedDocument document, PdfExportSettings settings) 
            : base(document, settings)
        {
            this.currentObjectNumber = startObjectId;
        }

        protected override int GetNextObjectNumber()
        {
            int result = this.currentObjectNumber;
            this.currentObjectNumber++;

            return result;
        }

        public override void PrepareWidgetAppearancesForExport()
        {
            base.PrepareWidgetAppearancesForExport();

            // This page is non-existing neither in Document, nor in export context and is used only to prevent NullReferenceException when creating WidgetObject.
            RadFixedPage page = new RadFixedPage();

            foreach (FormField field in this.Document.AcroForm.FormFields)
            {
                foreach (Widget widget in field.Widgets)
                {
                    AnnotationFactory.CreatePdfAnnotation(this, widget, page);
                }
            }
        }
    }
}
