﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export
{
    /// <summary>
    /// Represents PDF compliance levels.
    /// </summary>
    public enum PdfComplianceLevel
    {
    /// <summary>
    /// Specify no comliance level.
    /// </summary>
    None,

    /// <summary>
    /// Specify PDF/A-1b compliance level.
    /// </summary>
    PdfA1B,

    /// <summary>
    /// Specify PDF/A-2b compliance level.
    /// </summary>
    PdfA2B,

    /// <summary>
    /// Specify PDF/A-2u compliance level.
    /// </summary>
    PdfA2U,

    /// <summary>
    /// Specify PDF/A-3b compliance level.
    /// </summary>
    PdfA3B,

    /// <summary>
    /// Specify PDF/A-3u compliance level.
    /// </summary>
    PdfA3U
    }
}
