﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export
{
    internal class ResourceEntry
    {
        private readonly string resourceKey;
        private readonly IndirectObject resource;

        public ResourceEntry(string resourceKey, IndirectObject resource)
        {
            Guard.ThrowExceptionIfNullOrEmpty(resourceKey, "resourceKey");
            Guard.ThrowExceptionIfNull(resource, "resource");

            this.resourceKey = resourceKey;
            this.resource = resource;
        }
        public IndirectObject Resource
        {
            get
            {
                return this.resource;
            }
        }

        public string ResourceKey
        {
            get
            {
                return this.resourceKey;
            }
        }
    }
}
