﻿using System;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Filters
{
    /// <summary>
    /// Represents all color spaces.
    /// </summary>
    public enum ColorSpace
    {
        /// <summary>
        /// Represents undefined color space.
        /// </summary>
        Undefined,

        /// <summary>
        /// Represents grayscale color space.
        /// </summary>
        Gray,

        /// <summary>
        /// Represents RGB color space.
        /// </summary>
        RGB,

        /// <summary>
        /// Represents CMYK color space.
        /// </summary>
        CMYK,

        /// <summary>
        /// Represents indexed color space.
        /// </summary>
        Indexed,

        /// <summary>
        /// Represents ICC based color space.
        /// </summary>
        ICCBased,

        /// <summary>
        /// Represents pattern color space.
        /// </summary>
        Pattern,

        /// <summary>
        /// Represents separation color space.
        /// </summary>
        Separation,

        /// <summary>
        /// Represents DeviceN color space.
        /// </summary>
        DeviceN,

        /// <summary>
        /// Represents Lab color space.
        /// </summary>
        Lab,

        /// <summary>
        /// Represents CalRgb space.
        /// </summary>
        CalRgb,

        /// <summary>
        /// Represents CalGray space.
        /// </summary>
        CalGray
    }
}