﻿using System;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Filters
{
    /// <summary>
    /// Represents PDF filter.
    /// </summary>
    public interface IPdfFilter
    {
        /// <summary>
        /// Encodes the specified data.
        /// </summary>
        /// <param name="encodedObject">The encoded object.</param>
        /// <param name="inputData">The input data.</param>
        /// <returns>The encoded data.</returns>
        byte[] Encode(PdfObject encodedObject, byte[] inputData);

        /// <summary>
        /// Decodes the specified data.
        /// </summary>
        /// <param name="decodedObject">The decoded object.</param>
        /// <param name="inputData">The input data.</param>
        /// <param name="decodeParameters">The decode parameters.</param>
        /// <returns></returns>
        byte[] Decode(PdfObject decodedObject, byte[] inputData, DecodeParameters decodeParameters);

        /// <summary>
        /// Gets the name of the PDF filter.
        /// </summary>
        /// <value>The name.</value>
        string Name { get; }
    }
}
