﻿using System;
using System.Linq;
using JBig2Decoder;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Filters
{
    internal class JBIG2Decode : IPdfFilter
    {
        private const string JBIG2GlobalsName = "JBIG2Globals";

        public string Name
        {
            get
            {
                return "JBIG2Decode";
            }
        }


        public byte[] Encode(PdfObject encodedObject, byte[] inputData)
        {
            throw new NotImplementedException();
        }

        public byte[] Decode(PdfObject decodedObject, byte[] inputData, DecodeParameters parms)
        {
            JBIG2StreamDecoder jBig2Decoder = new JBIG2StreamDecoder();
            byte[] data;

            object globalsObj;
            if (parms != null && parms.TryGetValue(JBIG2GlobalsName, out globalsObj))
            {
                byte[] globals = (byte[])globalsObj;
               
                data = new byte[globals.Length + inputData.Length];
                globals.CopyTo(data, 0);
                inputData.CopyTo(data, globals.Length);
            }
            else
            {
                data = inputData;
            }

            return jBig2Decoder.decodeJBIG2(data);
        }
    }
}
