using System;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Filters
{
    internal class LZWDecode : IPdfFilter
    {
        public string Name
        {
            get { return PdfFilterNames.LZWDecode; }
        }

        public byte[] Encode(PdfObject encodedObject, byte[] data)
        {
            throw new NotImplementedException("LZW encoding is not supported.");
        }

        public byte[] Decode(PdfObject decodedObject, byte[] inputData, DecodeParameters parms)
        {
            int earlyChange = GetEarlyChange(parms);

            LzwDecoder lzwStream = new LzwDecoder(inputData, earlyChange);
            byte[] result = lzwStream.GetBytes();

            if (parms == null)
            {
                return result;
            }

            return Predictor.Decode(result, parms);
        }

        private static int GetEarlyChange(DecodeParameters parms)
        {
            int earlyChange = 1;

            object earlyChangeObj;
            if (parms != null && parms.TryGetValue("EarlyChange", out earlyChangeObj))
            {
                earlyChange = (int) earlyChangeObj;
            }

            return earlyChange;
        }
    }
}
