﻿/* Copyright 2012 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* Portions of /src/parser.js file as modified by Progress EAD - Copyright © 2016 Progress EAD. All rights reserved.
*/

using System;
using System.Linq;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Filters
{
    internal partial class LzwDecoder
    {
        private class LzwDecoderState
        {
            private const int maxLzwDictionarySize = 4096;

            private int earlyChange;
            private int codeLength = 9;
            private int nextCode = 258;
            private int prevCode;
            private byte[] dictionaryValues = new byte[maxLzwDictionarySize];
            private int[] dictionaryLengths = new int[maxLzwDictionarySize];
            private int[] dictionaryPrevCodes = new int[maxLzwDictionarySize];
            private byte[] currentSequence = new byte[maxLzwDictionarySize];
            private int currentSequenceLength = 0;

            public int EarlyChange
            {
                get
                {
                    return this.earlyChange;
                }
            }

            public int NextCode
            {
                get
                {
                    return this.nextCode;
                }

                set
                {
                    this.nextCode = value;
                }
            }

            public int PrevCode
            {
                get
                {
                    return this.prevCode;
                }

                set
                {
                    this.prevCode = value;
                }
            }

            public int CodeLength
            {
                get
                {
                    return this.codeLength;
                }

                set
                {
                    this.codeLength = value;
                }
            }

            public int CurrentSequenceLength
            {
                get
                {
                    return this.currentSequenceLength;
                }

                set
                {
                    this.currentSequenceLength = value;
                }
            }

            public byte[] DictionaryValues
            {
                get
                {
                    return this.dictionaryValues;
                }
            }

            public int[] DictionaryPrevCodes
            {
                get
                {
                    return this.dictionaryPrevCodes;
                }
            }

            public int[] DictionaryLengths
            {
                get
                {
                    return this.dictionaryLengths;
                }
            }

            public byte[] CurrentSequence
            {
                get
                {
                    return this.currentSequence;
                }
            }

            public LzwDecoderState(int earlyChange)
            {
                this.earlyChange = earlyChange;

                for (int i = 0; i < 256; ++i)
                {
                    this.DictionaryValues[i] = (byte)i;
                    this.DictionaryLengths[i] = 1;
                }
            }
        }
    }
}
