﻿using System;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Filters
{
    /// <summary>
    /// Contains valid names for PDF filters.
    /// </summary>
    public class PdfFilterNames
    {
        /// <summary>
        /// Name for ASCIIHexDecode filter.
        /// </summary>
        public const string ASCIIHexDecode = "ASCIIHexDecode";

        /// <summary>
        /// Name for ASCII85Decode filter.
        /// </summary>
        public const string ASCII85Decode = "ASCII85Decode";

        /// <summary>
        /// Name for LZWDecode filter.
        /// </summary>
        public const string LZWDecode = "LZWDecode";

        /// <summary>
        /// Name for FlateDecode filter.
        /// </summary>
        public const string FlateDecode = "FlateDecode";

        /// <summary>
        /// Name for RunLengthDecode filter.
        /// </summary>
        public const string RunLengthDecode = "RunLengthDecode";

        /// <summary>
        /// Name for CCITTFaxDecode filter.
        /// </summary>
        public const string CCITTFaxDecode = "CCITTFaxDecode";

        /// <summary>
        /// Name for JBIG2Decode filter.
        /// </summary>
        public const string JBIG2Decode = "JBIG2Decode";

        /// <summary>
        /// Name for DCTDecode filter.
        /// </summary>
        public const string DCTDecode = "DCTDecode";

        /// <summary>
        /// Name for JPXDecode filter.
        /// </summary>
        public const string JPXDecode = "JPXDecode";
    }
}
