﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Filters
{
    internal class RunLengthDecode : IPdfFilter
    {
        private const byte Eod = 128;

        public byte[] Encode(PdfObject encodedObject, byte[] inputData)
        {
            throw new NotImplementedException();
        }

        public byte[] Decode(PdfObject decodedObject, byte[] inputData, DecodeParameters decodeParameters)
        {
            LinkedList<byte> resultData = new LinkedList<byte>(); 
            byte lengthByte;
            int index = 0;
            while (index < inputData.Length && (lengthByte = inputData[index++]) != Eod)
            {
                if (lengthByte >= 0 && lengthByte <= 127)
                {
                    for (int i = 0; i <= lengthByte; i++)
                    {
                        resultData.AddLast(inputData[index++]);
                    }
                }
                else  
                {
                    for (int i = 0; i < 257 - lengthByte; i++)
                    {
                        resultData.AddLast(inputData[index]);
                    }

                    index++;
                } 
            }

            return resultData.ToArray();
        }

        public string Name
        {
            get { return PdfFilterNames.RunLengthDecode; }
        }
    }
}
