﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser.Keywords
{
    internal class ContentStreamKeywordCollection : KeywordCollection
    {
        public ContentStreamKeywordCollection()
        {
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SaveGraphicsStateOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.ConcatMatrixOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.BeginTextOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.CharSpaceOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.RenderingModeOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.HorizontalScaleOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.RiseOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.WordSpaceOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetRgbColorOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetStrokeRgbColorOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetGrayColorOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetStrokeGrayColorOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.FontOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.ShowTextOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.ShowTextArrayOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.MoveToNextLineAndShowTextOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetSpacingMoveToNextLineAndShowTextOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.MoveToNextLineOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.TextLeadingOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.TextMatrixOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.TranslateTextOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.TranslateTextAndSetLeadingOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.EndTextOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.RestoreGraphicsStateOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.AppendRectangleOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.FillPathOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.FillPathAliasOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.FillPathEvenOddOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.ClosePathOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.CurveToOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.VCurveToOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.YCurveToOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.EndPathOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.FillAndStrokePathOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.FillAndStrokePathEvenOddOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.CloseFillAndStrokePathOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.CloseFillAndStrokePathEvenOddOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.LineToOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.ModifyClippingPathNonzeroOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.ModifyClippingPathEvenOddOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.MoveToOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.StrokePathOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.CloseAndStrokePathOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetLineCapOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetLineJoinOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetLineWidthOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.PaintOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.BeginMarkedContentOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.EndMarkedContentOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetLineDashPatternOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetMiterLimitOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetGraphicsStateDictionaryOperator));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetColorSpace));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetStrokeColorSpace));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetColorN));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetColorNAlias));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetStrokeColorN));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetStrokeColorNAlias));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetCmykColor));
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.SetCmykStrokeColor));

            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.BeginInlineImageOperator));
            this.RegisterKeyword(new ImageDataKeyword());
            this.RegisterKeyword(new OperatorKeyword(ContentStreamOperators.EndInlineImageOperator));

            // Not supported operators.
            this.RegisterKeyword(new OperatorKeyword(new NotSupportedOperator(ContentStreamOperatorNames.SetFlatnessState)));
            this.RegisterKeyword(new OperatorKeyword(new NotSupportedOperator(ContentStreamOperatorNames.SetRenderingIntent)));
            this.RegisterKeyword(new OperatorKeyword(new NotSupportedOperator(ContentStreamOperatorNames.ShadingPattern))); // implemented in PdfViewer
            this.RegisterKeyword(new OperatorKeyword(new NotSupportedOperator(ContentStreamOperatorNames.MarkedContentPoint)));
            this.RegisterKeyword(new OperatorKeyword(new NotSupportedOperator(ContentStreamOperatorNames.MarkedContentPointWithProperties)));
            this.RegisterKeyword(new OperatorKeyword(new NotSupportedOperator(ContentStreamOperatorNames.EndMarkedContentWithProperties)));
            this.RegisterKeyword(new OperatorKeyword(new NotSupportedOperator(ContentStreamOperatorNames.SetWidthInfo)));
            this.RegisterKeyword(new OperatorKeyword(new NotSupportedOperator(ContentStreamOperatorNames.SetWidthAndBBInfo)));
            this.RegisterKeyword(new OperatorKeyword(new NotSupportedOperator(ContentStreamOperatorNames.BeginCompatibility)));
            this.RegisterKeyword(new OperatorKeyword(new NotSupportedOperator(ContentStreamOperatorNames.EndCompatibility)));
        }
    }
}
