﻿using System;
using System.Globalization;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import
{    internal class FlagReader<T>
        where T : struct, IConvertible
    {
        private readonly int flags;

        public FlagReader(int flags)
        {
            this.flags = flags;
        }

        public bool IsSet(T flag)
        {
            int bitNumber = flag.ToInt32(CultureInfo.InvariantCulture);
            Guard.ThrowExceptionIfOutOfRange(1, 32, bitNumber, "bitNumber");

            int bitIndex = bitNumber - 1;
            bool isSet = (this.flags & (1 << bitIndex)) != 0;

            return isSet;
        }
    }
}
