﻿using System;
using Telerik.Windows.Documents.Fixed.Model;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import
{
    /// <summary>
    /// Class responsible for page content caching operations.
    /// </summary>
    internal interface IPagesCacheManager
    {
        /// <summary>
        /// Preserves all currently applied changes of the page content in memory.
        /// </summary>
        /// <param name="page">The page instance.</param>
        void SavePage(RadFixedPage page);

        /// <summary>
        /// Loads the page content.
        /// </summary>
        /// <param name="page">The page instance.</param>
        /// <returns>A disposable object responsible for 
        /// unloading the page content.</returns>
        IDisposable BeginUsingPage(RadFixedPage page);

        /// <summary>
        /// Clears the cached content.
        /// </summary>
        void Clear();
    }
}