﻿using System;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.DocumentStructure;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Fonts;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Objects;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Fonts;
using Telerik.Windows.Documents.Fixed.Model.Resources;
using ImageSource = Telerik.Windows.Documents.Fixed.Model.Resources.ImageSource;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import
{
    internal interface IRadFixedDocumentImportContext : IPdfImportContext
    {
        RadFixedDocument Document { get; }

        void MapPages(Page page, RadFixedPage fixedPage);

        RadFixedPage GetFixedPage(Page page);

        Page GetPage(RadFixedPage fixedPage);

        IPdfContentImportContext GetAcroFormContentImportContext();

        Matrix GetPdfPointToDipTransformation(Page fixedPage);
        FontBase GetFont(PostScriptReader reader, FontObject font);

        ImageSource GetImageSource(PostScriptReader reader, ImageXObject image);

        FormSource GetFormSource(PostScriptReader reader, FormXObject form);

        ExtGState GetExtGState(PostScriptReader reader, Model.Elements.GraphicsState.ExtGStateObject extGState);
    }
}
