﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.Model;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import
{
    /// <summary>
    /// Represents password needed event args.
    /// </summary>
    public class PasswordNeededEventArgs : EventArgs
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PasswordNeededEventArgs" /> class.
        /// </summary>
        public PasswordNeededEventArgs()
        {
            this.Password = FixedDocumentDefaults.Password;
        }

        /// <summary>
        /// Gets or sets the password.
        /// </summary>
        /// <value>The password.</value>
        public string Password { get; set; }
    }
}
