﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Fonts;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Converters
{
    internal class CharCodeToGlyphIdMappingBaseConverter : Converter
    {
        protected override IPdfPrimitive ConvertFromName(Type type, PostScriptReader reader, IPdfImportContext context, PdfName name)
        {
            Guard.ThrowExceptionIfNull(name, "name");

            switch (name.Value)
            {
                case PdfNames.Identity: return CharIdToGlyphIdMappingBase.Identity;

                default: throw new NotSupportedException("Encoding type is not supported");
            }
        }

        protected override IPdfPrimitive ConvertFromStream(Type type, PostScriptReader reader, IPdfImportContext context, PdfStream stream)
        {
            Guard.ThrowExceptionIfNull(stream, "name");

            CharIdToGlyphIdMapping charCodeToGlyphIdMapping = new CharIdToGlyphIdMapping();
            charCodeToGlyphIdMapping.Load(reader, context, stream);

            return charCodeToGlyphIdMapping;
        }
    }
}
