﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.ColorSpaces;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Converters
{
    internal class ColorSpaceConverter : Converter
    {
        protected override IPdfPrimitive ConvertFromName(Type type, Import.Parser.PostScriptReader reader, Import.IPdfImportContext context, PdfName name)
        {
            return ColorSpaceManager.CreateColorSpaceObject(name.Value);
        }

        protected override IPdfPrimitive ConvertFromArray(Type type, Import.Parser.PostScriptReader reader, Import.IPdfImportContext context, PdfArray array)
        {
            PdfName name = (PdfName)array[0];
            ColorSpaceObject colorSpace = ColorSpaceManager.CreateColorSpaceObject(name.Value);

            if (colorSpace != null)
            {
                colorSpace.ImportFromArray(reader, context, array);

                return colorSpace;
            }

            throw new NotSupportedException(string.Format("The provided color space: {0} is not supported.", name));
        }
    }
}
