﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.DocumentStructure;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Converters
{
    internal class ContentStreamConverter : Converter
    {
        protected override IPdfPrimitive ConvertFromArray(Type type, PostScriptReader reader, IPdfImportContext context, PdfArray array)
        {
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(array, "array");

            PdfObjectDescriptor descriptor = PdfObjectDescriptors.GetPdfObjectDescriptor<ContentStream>();

            ContentStream stream = new ContentStream();
            for (int i = 0; i < array.Count; i++)
            {
                IPdfPrimitive currentArrayValue = array[i];
                ContentStream currentValue = (ContentStream)descriptor.Converter.Convert(typeof(ContentStream), reader, context, currentArrayValue);
                stream.Concat(currentValue);
            }

            return stream;
        }
    }
}