﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Destinations;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Converters
{
    internal class DestinationAndNamedDestinationConverter : Converter
    {
        protected override IPdfPrimitive ConvertFromName(Type type, PostScriptReader reader, IPdfImportContext context, PdfName name)
        {
            return FromName(context, name.Value);
        }

        protected override IPdfPrimitive ConvertFromString(Type type, PostScriptReader reader, IPdfImportContext context, PdfString str)
        {
            return FromName(context, str.ToString());
        }

        protected override IPdfPrimitive ConvertFromArray(Type type, PostScriptReader reader, IPdfImportContext context, PdfArray array)
        {
            PdfObjectDescriptor objectDescriptor = PdfObjectDescriptors.GetPdfObjectDescriptor<DestinationObject>();

            DestinationObject destination = objectDescriptor.Converter.Convert(typeof(DestinationObject), reader, context, array) as DestinationObject;

            return destination;
        }

        private static IPdfPrimitive FromName(IPdfImportContext context, string name)
        {
            NamedDestinationObject namedDestination;

            // Not working for remote files:
            context.TryGetNamedDestination(name, out namedDestination);

            return namedDestination;
        }
    }
}
