﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Destinations;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Converters
{
    internal class NamedDestinationsConverter : Converter
    {
        protected override IPdfPrimitive ConvertFromDictionary(Type type, PostScriptReader reader, IPdfImportContext context, PdfDictionary dictionary)
        {
            NamedDestinationsObject result = new NamedDestinationsObject();

            foreach (KeyValuePair<string, IPdfPrimitive> pair in dictionary)
            {
                string name = pair.Key;

                NamedDestinationObject namedDestination = new NamedDestinationObject();
                namedDestination.SetDestinationPrimitive(name, dictionary[name]);

                result.Store.Add(namedDestination);
            }

            return result;
        }

        protected override IPdfPrimitive ConvertFromArray(Type type, PostScriptReader reader, IPdfImportContext context, PdfArray array)
        {
            NamedDestinationsArrayObject result = new NamedDestinationsArrayObject();

            for (int i = 0; i < array.Count; i += 2)
            {
                string name = array[i].ToString();

                NamedDestinationObject namedDestination = new NamedDestinationObject();
                namedDestination.SetDestinationPrimitive(name, array[i + 1]);

                result.Store.Add(namedDestination);
            }

            return result;
        }
    }
}
