﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Converters
{
    internal class PdfArrayConverter : Converter
    {
        protected override IPdfPrimitive ConvertFromName(Type type, PostScriptReader reader, IPdfImportContext context, PdfName name)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(name, "name");

            return this.ConvertFromPrimitive(name);
        }

        protected override IPdfPrimitive ConvertFromInt(Type type, PostScriptReader reader, IPdfImportContext context, PdfInt i)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(i, "i");

            return this.ConvertFromPrimitive(i);
        }

        protected override IPdfPrimitive ConvertFromReal(Type type, PostScriptReader reader, IPdfImportContext context, PdfReal r)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(r, "r");

            return this.ConvertFromPrimitive(r);
        }

        protected override IPdfPrimitive ConvertFromString(Type type, PostScriptReader reader, IPdfImportContext context, PdfString str)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(str, "str");

            return this.ConvertFromPrimitive(str);
        }

        protected override IPdfPrimitive ConvertFromDictionary(Type type, PostScriptReader reader, IPdfImportContext context, PdfDictionary dictionary)
        {
            Guard.ThrowExceptionIfNull(type, "type");
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(dictionary, "dictionary");

            return this.ConvertFromPrimitive(dictionary);
        }

        private PdfArray ConvertFromPrimitive(IPdfPrimitive primitive)
        {
            Guard.ThrowExceptionIfNull(primitive, "primitive");

            return new PdfArray(primitive);
        }
    }
}
