﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Common;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Forms;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Converters
{
    internal class PrimitiveWrapperConverter : IConverter
    {
        public IPdfPrimitive Convert(Type type, PostScriptReader reader, IPdfImportContext context, IPdfPrimitive value)
        {
            Guard.ThrowExceptionIfNull(type, "type");

            if (value == null)
            {
                return null;
            }

            if(value.Type == PdfElementType.IndirectReference)
            {
                IndirectReference reference = (IndirectReference)value;
                IndirectObject obj = context.ReadIndirectObject(reference);

                return new PrimitiveWrapper(obj.Content);
            }
            else
            {
                return new PrimitiveWrapper(value);
            }
        }
    }
}
