﻿using System; 
using System.Linq; 
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Functions;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Converters
{
    internal class StitchingFunctionConverter : Converter
    {
        protected override Types.IPdfPrimitive ConvertFromArray(Type type, Import.Parser.PostScriptReader reader, Import.IPdfImportContext context, Types.PdfArray array)
        {
            PdfArray result = new PdfArray();
            foreach (var element in array)
            {
                var indirectReference = element as IndirectReference;
                if (indirectReference != null)
                {
                    IPdfPrimitive stitchingFunction;

                    context.TryGetIndirectObject(indirectReference, out stitchingFunction);

                    result.Add(stitchingFunction);
                }
                else
                {
                    result.Add(element);
                }
            }

            return result;
        }
    }
}
