﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.DocumentStructure;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Forms;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Converters
{
    internal class XFAStreamConverter : Converter
    {
        protected override IPdfPrimitive ConvertFromArray(Type type, PostScriptReader reader, IPdfImportContext context, PdfArray array)
        {
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(array, "array");

            PdfObjectDescriptor descriptor = PdfObjectDescriptors.GetPdfObjectDescriptor<XFAStreamConverter>();
            XFAStream stream = new XFAStream();

            for (int i = 1; i < array.Count; i += 2)
            {
                IPdfPrimitive currentArrayValue = array[i];
                XFAStream currentValue = (XFAStream)descriptor.Converter.Convert(typeof(XFAStream), reader, context, currentArrayValue);
                stream.Concat(currentValue);
            }

            return stream;
        }
    }
}
