﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data
{
    internal class DirectProperty<T> : PdfPropertyBase<T>
        where T : class, IPdfPrimitive
    {
        private T value;

        public DirectProperty(PdfPropertyDescriptor descriptor)
            : base(descriptor)
        {
        }

        public DirectProperty(PdfPropertyDescriptor descriptor, T defaultValue)
            : base(descriptor, defaultValue)
        {
            this.value = defaultValue;
        }

        public override T GetValue()
        {
            return this.value;
        }

        public override void SetValue(IPdfPrimitive source)
        {
            if (this.value != source)
            {
                this.value = (T)source;
            }
        }

        public override void SetValue(PostScriptReader reader, IPdfImportContext context, IPdfPrimitive value)
        {
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");

            T preparedValue = this.PrepareValue(reader, context, value);
            this.SetValue(preparedValue);
        }
    }
}
