﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Converters;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data
{
    internal class PdfObjectDescriptor
    {
        private static readonly IConverter defaultConverter;

        static PdfObjectDescriptor()
        {
            defaultConverter = new Converter();
        }

        public PdfObjectDescriptor()
        {
            this.Type = null;
            this.Converter = defaultConverter;
            this.SubType = null;
            this.SubTypeProperty = null;
        }

        public PdfObjectDescriptor(string type)
            : this()
        {
            this.Type = type;
        }

        public PdfObjectDescriptor(IConverter converter)
            : this()
        {
            this.Converter = converter;
        }

        public PdfObjectDescriptor(string type, IConverter converter)
            : this(type)
        {
            this.Converter = converter;
        }

        public PdfObjectDescriptor(IPdfPrimitive subType, string subTypeProperty = PdfNames.SubType)
            : this(null, subType, subTypeProperty)
        {
        }

        public PdfObjectDescriptor(string type, IPdfPrimitive subType, string subTypeProperty = PdfNames.SubType)
            : this(type)
        {
            this.SubType = subType;
            this.SubTypeProperty = subTypeProperty;
        }

        public string Type
        {
            get;
            set;
        }

        public IPdfPrimitive SubType
        {
            get;
            set;
        }

        public string SubTypeProperty
        {
            get;
            set;
        }

        public IConverter Converter
        {
            get;
            set;
        }
    }
}
