using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data
{
    internal class ReferencePropertyValueSource
    {
        private readonly PostScriptReader reader;
        private readonly IPdfImportContext context;
        private readonly IndirectReference source;

        public ReferencePropertyValueSource(PostScriptReader reader, IPdfImportContext context, IndirectReference source)
        {
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");

            this.reader = reader;
            this.context = context;
            this.source = source;
        }

        public IndirectReference Source
        {
            get
            {
                return this.source;
            }
        }

        public IPdfImportContext Context
        {
            get
            {
                return this.context;
            }
        }

        public PostScriptReader Reader
        {
            get
            {
                return this.reader;
            }
        }
    }
}