﻿using System;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Annotations
{
    /// <summary>
    /// Represents annotation types.
    /// </summary>
    internal static class AnnotationTypes
    { 
        /// <summary>
        /// Represents Link annotation type.
        /// </summary>
        public const string Link = "Link";
        
        /// <summary>
        /// Represents Widget annotation type.
        /// </summary>
        public const string Widget = "Widget";

        /// <summary>
        /// Represents Text annotation type.
        /// </summary>
        public const string Text = "Text";

        /// <summary>
        /// Represents FreeText annotation type.
        /// </summary>
        public const string FreeText = "FreeText";

        /// <summary>
        /// Represents Line annotation type.
        /// </summary>
        public const string Line = "Line";

        /// <summary>
        /// Represents Square annotation type.
        /// </summary>
        public const string Square = "Square";

        /// <summary>
        /// Represents Circle annotation type.
        /// </summary>
        public const string Circle = "Circle";

        /// <summary>
        /// Represents Polygon annotation type.
        /// </summary>
        public const string Polygon = "Polygon";

        /// <summary>
        /// Represents Polyline annotation type.
        /// </summary>
        public const string PolyLine = "PolyLine";

        /// <summary>
        /// Represents Highlight annotation type.
        /// </summary>
        public const string Highlight = "Highlight";

        /// <summary>
        /// Represents Underline annotation type.
        /// </summary>
        public const string Underline = "Underline";

        /// <summary>
        /// Represents Squiggly annotation type.
        /// </summary>
        public const string Squiggly = "Squiggly";

        /// <summary>
        /// Represents Strikeout annotation type.
        /// </summary>
        public const string StrikeOut = "StrikeOut";

        /// <summary>
        /// Represents Stamp annotation type.
        /// </summary>
        public const string Stamp = "Stamp";

        /// <summary>
        /// Represents Caret annotation type.
        /// </summary>
        public const string Caret = "Caret";

        /// <summary>
        /// Represents Ink annotation type.
        /// </summary>
        public const string Ink = "Ink";

        /// <summary>
        /// Represents Popup annotation type.
        /// </summary>
        public const string Popup = "Popup";

        /// <summary>
        /// Represents FileAttachment annotation type.
        /// </summary>
        public const string FileAttachment = "FileAttachment";

        /// <summary>
        /// Represents Sound annotation type.
        /// </summary>
        public const string Sound = "Sound";

        /// <summary>
        /// Represents Movie annotation type.
        /// </summary>
        public const string Movie = "Movie";

        /// <summary>
        /// Represents Screen annotation type.
        /// </summary>
        public const string Screen = "Screen";

        /// <summary>
        /// Represents PrinterMark annotation type.
        /// </summary>
        public const string PrinterMark = "PrinterMark";

        /// <summary>
        /// Represents TrapNet annotation type.
        /// </summary>
        public const string TrapNet = "TrapNet";

        /// <summary>
        /// Represents Watermark annotation type.
        /// </summary>
        public const string Watermark = "Watermark";

        /// <summary>
        /// Represents ThreeD annotation type.
        /// </summary>
        public const string ThreeD = "3D";

        /// <summary>
        /// Represents Redact annotation type.
        /// </summary>
        public const string Redact = "Redact";
    }
}
