﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Common;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Annotations
{
    internal class Appearances : PdfObject
    {
        public const string NormalAppearanceKey = "N";
        public const string RolloverAppearanceKey = "R";
        public const string DownAppearanceKey = "D";

        public Appearance NormalAppearance { get; set; }

        public Appearance RolloverAppearance { get; set; }

        public Appearance DownAppearance { get; set; }

        public override void Write(PdfWriter writer, IPdfExportContext context)
        {
            PdfDictionary dictionary = new PdfDictionary();

            if(this.NormalAppearance != null)
            {
                dictionary[NormalAppearanceKey] = this.GetAppearanceReference(this.NormalAppearance, context);
            }

            if(this.RolloverAppearance != null)
            {
                dictionary[RolloverAppearanceKey] = this.GetAppearanceReference(this.RolloverAppearance, context);
            }

            if(this.DownAppearance != null)
            {
                dictionary[DownAppearanceKey] = this.GetAppearanceReference(this.DownAppearance, context);
            }

            dictionary.Write(writer, context);
        }

        private IndirectReference GetAppearanceReference(Appearance appearance, IPdfExportContext context)
        {
            if(appearance.SingleStateAppearance == null)
            {
                return context.CreateIndirectObject(appearance).Reference;
            }
            else
            {
                return context.CreateIndirectObject(appearance.SingleStateAppearance).Reference;
            }
        }
    }
}
