﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Common;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Annotations
{
    internal class IconFit : PdfObject
    {
        private readonly DirectProperty<PdfName> scaleCondition;
        private readonly DirectProperty<PdfName> scaleType;
        private readonly ReferenceProperty<PdfArray> translationAfterProportionalScaling;
        private readonly DirectProperty<PdfBool> fitIgnoringBorderWidth;

        public IconFit()
        {
            this.scaleCondition = this.RegisterDirectProperty<PdfName>(new PdfPropertyDescriptor("SW"), new PdfName("A"));
            this.scaleType = this.RegisterDirectProperty<PdfName>(new PdfPropertyDescriptor("S"), new PdfName("P"));
            this.translationAfterProportionalScaling = this.RegisterReferenceProperty<PdfArray>(new PdfPropertyDescriptor("A"), new PdfArray(new PdfReal(0.5), new PdfReal(0.5)));
            this.fitIgnoringBorderWidth = this.RegisterDirectProperty<PdfBool>(new PdfPropertyDescriptor("FB"), new PdfBool(false));
        }

        public PdfName ScaleCondition
        {
            get
            {
                return this.scaleCondition.GetValue();
            }
            set
            {
                this.scaleCondition.SetValue(value);
            }
        }

        public PdfName ScaleType
        {
            get
            {
                return this.scaleType.GetValue();
            }
            set
            {
                this.scaleType.SetValue(value);
            }
        }

        public PdfArray TranslationAfterProportionalScaling
        {
            get
            {
                return this.translationAfterProportionalScaling.GetValue();
            }
            set
            {
                this.translationAfterProportionalScaling.SetValue(value);
            }
        }

        public PdfBool FitIgnoringBorderWidth
        {
            get
            {
                return this.fitIgnoringBorderWidth.GetValue();
            }
            set
            {
                this.fitIgnoringBorderWidth.SetValue(value);
            }
        }
    }
}
