﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Model.Data;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.CMaps
{
    internal class EncodingPredefined : EncodingBaseObject
    {
        private readonly string name;

        public EncodingPredefined(string name)
        {
            Guard.ThrowExceptionIfNullOrEmpty(name, "name");

            this.name = name;
        }

        public override PdfElementType ExportAs
        {
            get
            {
                return PdfElementType.PdfName;
            }
        }

        public string Name
        {
            get
            {
                return this.name;
            }
        }

        public override IEnumerable<CharCode> BuildCharCodes(PdfString s)
        {
            throw new NotImplementedException();
        }

        public override void Write(PdfWriter writer, IPdfExportContext context)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            writer.WritePdfName(this.Name);
        }
    }
}
