﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.Model.Fonts.Encoding;
using Telerik.Windows.Documents.Fixed.Model.Text;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.CMaps
{
    internal class ToUnicodeCMap : CMapObject
    {
        public ToUnicodeCMap()
            : base()
        {
        }

        public ToUnicodeCMap(CMapEncoding encoding)
            : base(encoding)
        {
        }

        public void CopyPropertiesFrom(IPdfExportContext context, IEnumerable<CharInfo> usedCharacters)
        {
            foreach (CharInfo glyph in usedCharacters)
            {
                this.Encoding.AddUnicodeMapping(glyph.CharCode, glyph.Unicode);
            }
        }
    }
}
