﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.ColorSpaces
{
    internal class GrayColorObject : ColorObjectBase
    {
        public GrayColorObject()
            : this(0)
        {
        }

        public GrayColorObject(double g)
            : this(new PdfReal(g))
        {
        }

        public GrayColorObject(PdfReal g)
        {
            this.G = g;
        }

        public PdfReal G { get; set; }

        public override ColorBase ToColor(PostScriptReader reader, IPdfContentImportContext context)
        {
            byte g = ConvertToByte(this.G);

            return new RgbColor(g, g, g);
        }

        protected override void CopyPropertiesFromOverride(IPdfContentExportContext context, ColorBase color)
        {
            // GrayColor inheritor of ColorBase is not implemented.
            throw new NotImplementedException();
        }
    }
}
