﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Common;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.ColorSpaces
{
    internal class IndexedLookupStream : PdfStreamObjectBase
    {
        private byte[] data;

        public IndexedLookupStream()
        {
        }

        public IndexedLookupStream(byte[] data)
        {
            this.data = data;
        }

        public IEnumerable<byte> Data
        {
            get
            {
                return this.data;
            }
        }

        protected override void InterpretData(PostScriptReader reader, IPdfImportContext context, PdfStreamBase stream)
        {
            this.data = stream.ReadDecodedPdfData();
        }

        protected override byte[] GetData(Export.IPdfExportContext context)
        {
            return this.data;
        }

        public override bool Equals(object obj)
        {
            IndexedLookupStream other = obj as IndexedLookupStream;

            if (other == null)
            {
                return false;
            }

            if (this.data.Length != other.data.Length)
            {
                return false;
            }

            return ObjectExtensions.ArrayValuesEquals(this.data, other.data);
        }

        public override int GetHashCode()
        {
            return this.data.GetHashCodeOrZero();
        }
    }
}