﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Converters;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.ColorSpaces
{
    internal abstract class PdfRealColorSpaceObject : ColorSpaceObject
    {
        public sealed override ColorObjectBase GetColor(IPdfContentImportContext context, PostScriptReader reader, PdfArray components)
        {
            IConverter converter = PdfObjectDescriptors.GetPdfObjectDescriptor<PdfReal>().Converter;
            PdfReal[] convertedComponents = new PdfReal[components.Count];
            for (int i = 0; i < components.Count; i++)
            {
                convertedComponents[i] = (PdfReal)converter.Convert(typeof(PdfReal), reader, context.Owner, components[i]);
            }

            return this.GetColor(context, reader, convertedComponents);
        }

        protected abstract ColorObjectBase GetColor(IPdfContentImportContext context, PostScriptReader reader, PdfReal[] components);
    }
}
