﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Common
{
    internal class PrimitiveWrapper : PdfPrimitive
    {
        private readonly IPdfPrimitive primitive;

        public PrimitiveWrapper(IPdfPrimitive primitive)
        {
            Guard.ThrowExceptionIfNull(primitive, "primitive");

            this.primitive = primitive;
        }

        public override PdfElementType Type
        {
            get
            {
                return this.primitive.Type;
            }
        }

        internal IPdfPrimitive Primitive
        {
            get
            {
                return this.primitive;
            }
        }

        public override void Write(PdfWriter writer, IPdfExportContext context)
        {
            this.primitive.Write(writer, context);
        }
    }
}
