﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Common;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Destinations
{
    internal class NamedDestinationsArrayObject : PdfObject
    {
        public List<NamedDestinationObject> Store { get; internal set; }

        public NamedDestinationsArrayObject()
        {
            this.Store = new List<NamedDestinationObject>();
        }

        public override void Write(PdfWriter writer, IPdfExportContext context)
        {
            writer.Write(PdfNames.PdfArrayStart);

            int lastIndex = this.Store.Count - 1;
            for (int i = 0; i < this.Store.Count; i++)
            {
                NamedDestinationObject item = this.Store[i];

                PdfLiteralString name = new PdfLiteralString(item.Name, StringType.UTFEncodedTextString);
                name.Write(writer, context);

                IPdfPrimitive value = (item.GoToAction != null) ? (IPdfPrimitive)item.GoToAction : item.Destination;
                WriteIndirectReference(writer, context, value);

                if (i != lastIndex)
                {
                    writer.WriteSeparator();
                }
            }

            writer.Write(PdfNames.PdfArrayEnd);
        }
    }
}
