﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Fixed.Model.DigitalSignatures;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.DigitalSignature
{
    internal class DocMdpTransformParametersElement : TransformParametersElement<DocMdpTransformParameters>
    {
        private readonly DirectProperty<PdfInt> accessPermission;

        public DocMdpTransformParametersElement()
        {
            this.accessPermission = this.RegisterDirectProperty<PdfInt>(new PdfPropertyDescriptor("P"), new PdfInt(2));
        }


        public PdfInt AccessPermission
        {
            get
            {
                return this.accessPermission.GetValue();
            }
            set
            {
                this.accessPermission.SetValue(value);
            }
        }

        protected override void CopyPropertiesTo(DocMdpTransformParameters transformParameters)
        {
            this.AccessPermission.CopyToProperty(transformParameters.AccessPermission, (accessPermission) => accessPermission.Value);
        }
    }
}