﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Fixed.Model.DigitalSignatures;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.DigitalSignature
{
    internal class FieldMdpTransformParametersElement : TransformParametersElement<FieldMdpTransformParameters>
    {
        private readonly DirectProperty<PdfName> action;
        private readonly DirectProperty<PdfArray> fields;

        public FieldMdpTransformParametersElement()
        {
            this.action = this.RegisterDirectProperty<PdfName>(new PdfPropertyDescriptor("Action"));
            this.fields = this.RegisterDirectProperty<PdfArray>(new PdfPropertyDescriptor("Fields"));
        }

        public PdfName Action
        {
            get
            {
                return this.action.GetValue();
            }
            set
            {
                this.action.SetValue(value);
            }
        }

        public PdfArray Fields
        {
            get
            {
                return this.fields.GetValue();
            }
            set
            {
                this.fields.SetValue(value);
            }
        }

        protected override void CopyPropertiesTo(FieldMdpTransformParameters transformParameters)
        {
            this.Action.CopyToProperty(transformParameters.Action, (action) => action.Value);
        }
    }
}