﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Model.Common;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.DigitalSignature
{
    internal class SignatureReferenceCollection : PdfPrimitive, IEnumerable<SignatureReferenceObject>, IEnumerable
    {
        List<SignatureReferenceObject> referenceElements = new List<SignatureReferenceObject>();

        public SignatureReferenceCollection(IEnumerable<SignatureReferenceObject> collection)
        {
            this.referenceElements.AddRange(collection);
        }

        public override PdfElementType Type
        {
            get
            {
                return PdfElementType.Array;
            }
        }

        public void Add(SignatureReferenceObject node)
        {
            this.referenceElements.Add(node);
        }

        public void AddRange(IEnumerable<SignatureReferenceObject> collection)
        {
            this.referenceElements.AddRange(collection);
        }

        public IEnumerator<SignatureReferenceObject> GetEnumerator()
        {
            return this.referenceElements.GetEnumerator();
        }

        public override void Write(PdfWriter writer, IPdfExportContext context)
        {
            // TODO:
            throw new NotImplementedException();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.referenceElements.GetEnumerator();
        }
    }
}
