﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Fixed.Model.DigitalSignatures;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.DigitalSignature
{
    internal class UrTransformParametersElement : TransformParametersElement<UrTransformParameters>
    {
        private readonly DirectProperty<PdfString> message;
        private readonly DirectProperty<PdfArray> annots;
        private readonly DirectProperty<PdfArray> formFieldUsage;

        public UrTransformParametersElement()
        {
            this.message = this.RegisterDirectProperty<PdfString>(new PdfPropertyDescriptor("Msg"));
            this.annots = this.RegisterDirectProperty<PdfArray>(new PdfPropertyDescriptor("Annots"));
            this.formFieldUsage = this.RegisterDirectProperty<PdfArray>(new PdfPropertyDescriptor("Form"));
        }

        public PdfString Message
        {
            get
            {
                return this.message.GetValue();
            }
            set
            {
                this.message.SetValue(value);
            }
        }

        public PdfArray Annotations
        {
            get
            {
                return this.annots.GetValue();
            }
            set
            {
                this.annots.SetValue(value);
            }
        }

        public PdfArray FormFieldUsage
        {
            get
            {
                return this.formFieldUsage.GetValue();
            }
            set
            {
                this.formFieldUsage.SetValue(value);
            }
        }

        protected override void CopyPropertiesTo(UrTransformParameters transformParameters)
        {
            this.Message.CopyToProperty(transformParameters.Message, (message) => message.ToString());
        }
    }
}