﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.ColorSpaces;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Common;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.DocumentStructure
{
    internal class OutputIntent : PdfObject
    {
        private readonly DirectProperty<PdfName> ouputIntentType;
        private readonly DirectProperty<PdfLiteralString> outputContition;
        private readonly DirectProperty<PdfLiteralString> outputContitionIdentifier;
        private readonly DirectProperty<PdfLiteralString> info;
        private readonly ReferenceProperty<IccProfileObject> iccProfile;

        public OutputIntent()
        {
            this.ouputIntentType = this.RegisterDirectProperty<PdfName>(new PdfPropertyDescriptor("S", true));
            this.outputContition = this.RegisterDirectProperty<PdfLiteralString>(new PdfPropertyDescriptor("OutputCondition"));
            this.outputContitionIdentifier = this.RegisterDirectProperty<PdfLiteralString>(new PdfPropertyDescriptor("OutputConditionIdentifier", true));
            this.info = this.RegisterDirectProperty<PdfLiteralString>(new PdfPropertyDescriptor("Info"));
            this.iccProfile = this.RegisterReferenceProperty<IccProfileObject>(new PdfPropertyDescriptor("DestOutputProfile"));

            this.ouputIntentType.SetValue(new PdfName("GTS_PDFA1"));
            this.outputContition.SetValue(new PdfLiteralString("sRGB IEC61966-2.1", StringType.ASCII));
            this.outputContitionIdentifier.SetValue(new PdfLiteralString("Custom", StringType.ASCII));
            this.info.SetValue(new PdfLiteralString("sRGB", StringType.ASCII));
            this.iccProfile.SetValue(IccProfileObject.SRgbProfile);
        }
    }
}
