﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Core.Imaging.Jpeg.Utils;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Common;
using Telerik.Windows.Documents.Fixed.Model.Fonts;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Fonts.Cid
{
    internal class CidSet : PdfStreamObject
    {
        internal void CopyPropertiesFrom(IPdfExportContext context, FontBase font)
        {
            HashSet<int> usedCids = new HashSet<int>(context.GetUsedCharacters(font).Select(g => g.CharCode.Code));
            List<byte> result = new List<byte>();

            if (usedCids.Count > 0)
            {
                int maxCharCode = usedCids.Max();
                BitsWriter writer = new BitsWriter();

                byte value;
                for (int i = 0; i < maxCharCode; i += 8)
                {
                    writer.Clear();
                    for (int j = 0; j < 8; j++)
                    {
                        value = usedCids.Contains(i + j) ? (byte)1 : (byte)0;
                        writer.WriteBits(value, 1);
                    }

                    result.Add(writer.Data);
                }
            }

            this.Data = result.ToArray();
        }
    }
}
