﻿using System;
using Telerik.Windows.Documents.Core.Fonts;
using Telerik.Windows.Documents.Fixed.Model.Fonts;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Fonts
{
    internal class CidFontType0Object : CidFontObject
    {
        internal override bool TryCreateFontFromFontFile(out FontBase font)
        {
            FontStream fontStream = this.FontDescriptor.FontFile3;

            if (fontStream != null)
            {
                FontSource fontSource = fontStream.ToFontSource(FontType.CidType0Font);
                font = new CidType0Font(this.BaseFont.Value, fontSource);
                font.FontFileInfo.Value = fontStream.ToFileInfo();

                return true;
            }
            else
            {
                font = null;
                return false;
            }
        }

        internal override FontBase CreateFontWithoutFontFile()
        {
            return new CidType0Font(this.BaseFont.Value, EmptyFontSource.Instance);
        }

        internal override bool TryCreateFontFromFontProperties(FontProperties fontProperties, out FontBase font)
        {
            font = null;
            return false;
        }
    }
}
