﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Common;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Fonts
{
    internal class SimpleFontEncoding : PdfObject
    {
        private readonly ReferenceProperty<PdfName> baseEncoding;
        private readonly ReferenceProperty<PdfArray> differences;

        public SimpleFontEncoding()
        {
            this.baseEncoding = this.RegisterReferenceProperty<PdfName>(new PdfPropertyDescriptor("BaseEncoding"));
            this.differences = this.RegisterReferenceProperty<PdfArray>(new PdfPropertyDescriptor("Differences"));
        }

        public override PdfElementType ExportAs
        {
            get
            {
                return PdfElementType.Dictionary;
            }
        }

        public PdfName BaseEncoding
        {
            get
            {
                return this.baseEncoding.GetValue();
            }
            set
            {
                this.baseEncoding.SetValue(value);
            }
        }

        public PdfArray Differences
        {
            get
            {
                return this.differences.GetValue();
            }
            set
            {
                this.differences.SetValue(value);
            }
        }
    }
}
