﻿using Telerik.Windows.Documents.Core.Fonts;
using Telerik.Windows.Documents.Fixed.Model.Fonts;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Fonts
{
    internal class Type1FontObject : SimpleFontObject
    {
        protected override bool TryCreateSimpleFontFromFontFile(out SimpleFont font)
        {
            FontStream fontStream = null;

            if (this.FontDescriptor != null)
            {
                fontStream = this.FontDescriptor.FontFile ?? this.FontDescriptor.FontFile3;
            }

            if (fontStream != null)
            {
                FontSource fontSource = fontStream.ToFontSource(FontType.Type1);
                font = new Type1Font(this.BaseFont.Value, fontSource);
                font.FontFileInfo.Value = fontStream.ToFileInfo();

                return true;
            }
            else
            {
                font = null;
                return false;
            }
        }

        protected override SimpleFont CreateSimpleFontWithoutFontFile()
        {
            return new Type1Font(this.BaseFont.Value, EmptyFontSource.Instance);
        }

        protected override bool TryCreateFontFromFontName(out FontBase font)
        {
            StandardFont standartFont;
            if (FontsRepository.TryCreateStandardFont(this.BaseFont.Value, out standartFont))
            {
                font = standartFont;

                return true;
            }

            return base.TryCreateFontFromFontName(out font);
        }

        protected override bool TryCreateFontFromFontProperties(FontProperties fontProperties, out FontBase font)
        {
            font = null;
            return false;
        }
    }
}
