﻿using System;
using System.Collections;
using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Forms
{
    internal class FormFieldsTree : PdfPrimitive, IEnumerable<FormFieldNode>, IEnumerable
    {
        private readonly List<FormFieldNode> fields;

        public FormFieldsTree()
        {
            this.fields = new List<FormFieldNode>();
        }

        public override PdfElementType Type
        {
            get
            {
                return PdfElementType.Array;
            }
        }

        public void Add(FormFieldNode node)
        {
            this.fields.Add(node);
        }

        public override void Write(PdfWriter writer, IPdfExportContext context)
        {
            PdfArray array = new PdfArray();

            foreach (FormFieldNode node in this.fields)
            {
                IndirectObject nodeObject = context.CreateIndirectObject(node);
                array.Add(nodeObject.Reference);
            }

            array.Write(writer, context);
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.fields.GetEnumerator();
        }

        public IEnumerator<FormFieldNode> GetEnumerator()
        {
            return this.fields.GetEnumerator();
        }
    }
}
