﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Fixed.Model.Common.Functions;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Functions
{
    internal class PostScriptCalculatorFunctionObject : FunctionObject
    {
        protected override bool HasStreamData
        {
            get
            {
                return true;
            }
        }

        public override FunctionBase ToFunction(PostScriptReader reader, IPdfImportContext context)
        {
            double[] domain = this.Domain.ToArray<PdfReal, double>(reader, context);
            double[] range = this.Range.ToArray<PdfReal, double>(reader, context);

            PostScriptCalculatorFunction function = new PostScriptCalculatorFunction(this.FunctionData, domain, range);

            return function;
        }

        protected override void CopyPropertiesFromOverride(IPdfExportContext context, FunctionBase function)
        {
            // There are no specific properties that need to be copied.
        }
    }
}
