﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Common.FormatProviders.XmlBased.Model.Namespaces;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Structure;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Data
{
    internal class DescriptionElement : XmpDataElementBase
    {
        private readonly IEnumerable<XmpDataElement> elements;

        public DescriptionElement(params XmpDataElement[] elements)
        {
            this.elements = elements;

            this.RegisterAttribute<string>("about", "", true);
        }

        public override string Name
        {
            get
            {
                return "Description";
            }
        }

        public override IEnumerable<XmlNamespace> Namespaces
        {
            get
            {
                return this.elements.Select(e => e.Namespace).Distinct();
            }
        }

        protected override IEnumerable<Common.XmpElementBase> EnumerateInnerElements()
        {
            return this.elements;
        }
    }
}
