﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Structure;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Data
{
    internal class LanguageAlternativeElement : XmpDataElementBase
    {
        private readonly string defaultLanguageValue;

        public LanguageAlternativeElement(string defaultLanguageValue)
        {
            Guard.ThrowExceptionIfNull(defaultLanguageValue, "defaultLanguageValue");

            this.defaultLanguageValue = defaultLanguageValue;
        }

        public override string Name
        {
            get
            {
                return "Alt";
            }
        }

        protected override System.Collections.Generic.IEnumerable<Common.XmpElementBase> EnumerateInnerElements()
        {
            yield return new ListItemElement(this.defaultLanguageValue, "x-default");
        }
    }
}
