﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Common.FormatProviders.XmlBased.Model.Attributes;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Structure;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Data
{
    internal class ListItemElement : XmpDataElementBase
    {
        private readonly XmlAttribute<string> language;

        public ListItemElement(string data)
        {
            Guard.ThrowExceptionIfNull(data, "data");

            this.InnerText = data;

            this.language = this.RegisterAttribute<string>("lang", XmpNamespaces.Xml, null);
        }

        public ListItemElement(string data, string language)
            : this(data)

        {
            Guard.ThrowExceptionIfNull(language, "language");

            this.Language = language;
        }

        public override string Name
        {
            get
            {
                return "li";
            }
        }

        public string Language
        {
            get
            {
                return this.language.GetValue();
            }
            set
            {
                this.language.SetValue(value);
            }
        }
    }
}
