﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Structure;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Data
{
    internal class SequenceElement : XmpDataElementBase
    {
        private readonly string[] sequence;

        public SequenceElement(params string[] sequence)
        {
            Guard.ThrowExceptionIfNull(sequence, "sequence");

            this.sequence = sequence;
        }

        public override string Name
        {
            get
            {
                return "Seq";
            }
        }

        protected override System.Collections.Generic.IEnumerable<Common.XmpElementBase> EnumerateInnerElements()
        {
            foreach (string item in this.sequence)
            {
                yield return new ListItemElement(item);
            }
        }
    }
}
