﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Common;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Structure
{
    internal class PaddingElement : XmpElementBase
    {
        private const int Rows = 24;
        private const int RowSize = 100;
        private const string EmptyCharacter = " ";

        public override string Name
        {
            get
            {
                return string.Empty;
            }
        }

        public override void Write(Export.IXmpWriter writer)
        {
            for (int i = 0; i < Rows; i++)
            {
                for (int j = 0; j < RowSize; j++)
                {
                    writer.WriteRaw(EmptyCharacter);
                }

                writer.WriteRawLine();
            }
        }
    }
}
