﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Common.FormatProviders.XmlBased.Model.Attributes;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Common;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Model.Structure
{
    internal class XPacketElement : XmpElementBase
    {
        public override string Name
        {
            get
            {
                return "xpacket";
            }
        }

        public override void Write(Export.IXmpWriter writer)
        {
            writer.WriteRaw(string.Format("<?xpacket "));
            foreach (XmlAttribute attribute in this.Attributes)
            {
                writer.WriteRaw(string.Format("{0}='{1}' ", attribute.Name, attribute.GetValue()));
            }

            writer.WriteRaw(string.Format("?>"));
            writer.WriteRawLine();
        }
    }
}
