﻿using System;
using System.Globalization;
using System.Linq;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Metadata.Xmp.Utilities
{
    internal static class Extensions
    {
        public static string ToXmpDate(this DateTime date)
        {
            /*
             * YYYY
             * YYYY-MM
             * YYYY-MM-DD
             * YYYY-MM-DDThh:mmTZD
             * YYYY-MM-DDThh:mm:ssTZD
             * YYYY-MM-DDThh:mm:ss.sTZD
             * 
             * In which:
             * YYYY = four-digit year
             * MM = two-digit month (01=January)
             * DD = two-digit day of month (01 to 31)
             * hh = two digits of hour (00 to 23)
             * mm = two digits of minute (00 to 59)
             * ss = two digits of second (00 to 59)
             * s = one or more digits representing a decimal fraction of a second
             * TZD = time zone designator (Z or +hh:mm or -hh:mm)
             */

            return date.ToString("o", CultureInfo.InvariantCulture);
        }
    }
}
