﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Common;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.NamedTrees
{
    internal class NamesObject : PdfObject
    {
        public const string DestsName = "Dests";

        private readonly ReferenceProperty<DestinationsNamesTreeNode> dests;

        public NamesObject()
            : base()
        {
            this.dests = this.RegisterReferenceProperty<DestinationsNamesTreeNode>(new PdfPropertyDescriptor(DestsName, false, PdfPropertyRestrictions.MustBeIndirectReference));
        }

        public DestinationsNamesTreeNode Dests
        {
            get
            {
                return this.dests.GetValue();
            }
            set
            {
                this.dests.SetValue(value);
            }
        }
    }
}
