﻿using System;
using Telerik.Windows.Documents.Fixed.Exceptions;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Objects
{
    internal static class XObjectFactory
    {
        public const string ImageSubtype = "Image";
        public const string FormSubtype = "Form";

        public static XObjectBase CreateInstance(PdfName subType, PdfBool imageMask)
        {
            Guard.ThrowExceptionIfNull(subType, "subType");

            switch (subType.Value)
            {
                case ImageSubtype:
                    bool isMask = imageMask != null && imageMask.Value;
                    return isMask ? new Mask() : new ImageXObject();
                case FormSubtype:
                    return new FormXObject();
                default:
                    throw new NotSupportedXObjectTypeException(string.Format("Not supported subtype value: {0}!", subType.Value));
            }
        }
    }
}