﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Common;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Outlines
{
    internal abstract class BaseOutlineObject : PdfObject
    {
        private readonly ReferenceProperty<OutlineItemObject> first;
        private readonly ReferenceProperty<OutlineItemObject> last;
        private readonly DirectProperty<PdfInt> count;

        public BaseOutlineObject()
        {
            this.first = this.RegisterReferenceProperty<OutlineItemObject>(new PdfPropertyDescriptor("First", false, PdfPropertyRestrictions.MustBeIndirectReference));
            this.last = this.RegisterReferenceProperty<OutlineItemObject>(new PdfPropertyDescriptor("Last", false, PdfPropertyRestrictions.MustBeIndirectReference));
            this.count = this.RegisterDirectProperty<PdfInt>(new PdfPropertyDescriptor("Count"));
        }

        internal OutlineItemObject First
        {
            get
            {
                return this.first.GetValue();
            }
            set
            {
                this.first.SetValue(value);
            }
        }

        internal OutlineItemObject Last
        {
            get
            {
                return this.last.GetValue();
            }
            set
            {
                this.last.SetValue(value);
            }
        }

        internal PdfInt Count
        {
            get
            {
                return this.count.GetValue();
            }
            set
            {
                this.count.SetValue(value);
            }
        }
    }
}
