﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types
{
    internal class PdfBool : PdfSimpleType<bool>
    {
        public PdfBool()
        {
        }

        public PdfBool(bool initialValue)
            : base(initialValue)
        {
        }

        public static implicit operator PdfInt(PdfBool instance)
        {
            int value = instance.Value ? 1 : 0;
            return new PdfInt(value);
        }

        public static implicit operator PdfReal(PdfBool instance)
        {
            int value = instance.Value ? 1 : 0;
            return new PdfReal(value);
        }

        public override PdfElementType Type
        {
            get
            {
                return PdfElementType.PdfBool;
            }
        }

        public override void Write(PdfWriter writer, IPdfExportContext context)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            writer.Write(this.Value.ToString().ToLower());
        }
    }
}
