﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types
{
    internal class PdfHexString : PdfString
    {
        public PdfHexString()
        {
        }

        public PdfHexString(byte[] initialValue)
            : base(initialValue)
        {
        }

        public PdfHexString(string initialValue, StringType stringType) : base(initialValue, stringType)
        {
        }

        public override StringObjectType StringObjectType
        {
            get { return StringObjectType.Hex; }
        }

        public override string ToString()
        {
            return PdfString.GetString(this.Value);
        }

        public override void Write(Export.PdfWriter writer, Export.IPdfExportContext context)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            string hexContent = BytesHelper.ToHexString(context.EncryptString(this.Value));
            string formattedString = string.Format("{0}{1}{2}", PdfNames.HexadecimalStringStart, hexContent, PdfNames.HexadecimalStringEnd);
            writer.Write(formattedString);
        }
    }
}
