﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types
{
    internal class PdfInt : PdfSimpleType<int>
    {
        public PdfInt()
            : base()
        {
        }

        public PdfInt(int defaultValue)
            : base(defaultValue)
        {
        }

        public static implicit operator PdfReal(PdfInt instance)
        {
            return new PdfReal(instance.Value);
        }

        public override PdfElementType Type
        {
            get
            {
                return PdfElementType.PdfInt;
            }
        }

        public override void Write(PdfWriter writer, IPdfExportContext context)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            writer.Write(this.Value.ToString());
        }
    }
}
