﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types
{
    internal class PdfNull : PdfPrimitive
    {
        public const string NullValue = "null";
        private static readonly PdfNull instance;

        static PdfNull()
        {
            PdfNull.instance = new PdfNull();
        }

        public static PdfNull Instance
        {
            get
            {
                return PdfNull.instance;
            }
        }

        public override PdfElementType Type
        {
            get
            {
                return PdfElementType.Null;
            }
        }

        public override void Write(PdfWriter writer, IPdfExportContext context)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            writer.Write(PdfNull.NullValue);
        }
    }
}
