﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types
{
    internal class PdfReal : PdfSimpleType<double>
    {
        private const string FormatString = "f5";

        public PdfReal()
        {
        }

        public PdfReal(double initialValue)
            : base(initialValue)
        {
        }

        public override PdfElementType Type
        {
            get
            {
                return PdfElementType.PdfReal;
            }
        }

        public override void Write(PdfWriter writer, IPdfExportContext context)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            string value = this.Value.ToString(PdfReal.FormatString, System.Globalization.CultureInfo.InvariantCulture);
            writer.Write(value);
        }
    }
}
