﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types
{
    internal abstract class PdfSimpleType<T> : PdfPrimitive, IPdfSimpleType
    {
        public PdfSimpleType()
        {
        }

        public PdfSimpleType(T initialValue)
        {
            this.Value = initialValue;
        }

        public T Value
        {
            get;
            set;
        }

        object IPdfSimpleType.Value
        {
            get
            {
                return this.Value;
            }
        }

        public override string ToString()
        {
            return this.Value.ToString();
        }

        public override bool Equals(object obj)
        {
            IPdfSimpleType other = obj as IPdfSimpleType;
            if (other == null)
            {
                return false;
            }

            return Object.Equals(this.Value, other.Value);
        }

        public override int GetHashCode()
        {
            unchecked
            {
                int result = 17;
                result = result * 23 + this.Value.GetHashCode();
                return result;
            }
        }
    }
}
