﻿using System.IO;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser.Keywords;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types
{
    internal class PdfStream : PdfStreamBase
    {
        public PdfStream(IPdfImportContext context, Stream stream, PdfDictionary dictionary, PdfInt length, long offset)
            : base(context, stream, dictionary, length, offset)
        {
        }

        protected override byte[] ReadRawPdfDataOverride()
        {
            byte[] data;

            if (this.Length != null)
            {
                this.Reader.Reader.Seek(this.Offset + this.Length.Value, SeekOrigin.Begin);

                if (StreamStartKeyword.TryFindPdfStreamEndOnNextRow(this.Reader.Reader))
                {
                    this.Reader.Reader.Seek(this.Offset, System.IO.SeekOrigin.Begin);
                    data = this.Reader.Reader.Read(this.Length.Value);
                }
                else
                {
                    data = this.CalculateStreamLengthAndReadData();
                }
            }
            else
            {
                data = this.CalculateStreamLengthAndReadData();
            }

            data = this.Context.DecryptStream(this.CurrentIndirectReference, data);

            return data;
        }

        protected override int CalculateLength(Reader reader)
        {
            return StreamStartKeyword.CalculateStreamLength(this.Reader.Reader);
        }
    }
}
