﻿using System;
using System.Linq;
using System.Windows;
using Telerik.DocumentProcessing.Fixed.FormatProviders.Pdf.Import;
using Telerik.DocumentProcessing.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.DocumentProcessing.Fixed.Model.Graphics;
using Telerik.Windows.Documents.Fixed.Utilities;

namespace Telerik.DocumentProcessing.Fixed.FormatProviders.Pdf.Operators
{
    internal class AppendRectangle : Operator
    {
        public override string Name
        {
            get { return Operators.AppendRectangle; }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");

            PdfReal height = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context);
            PdfReal width = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context);
            PdfReal y = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context);
            PdfReal x = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context);

            interpreter.Geometry = new RectangleGeometry()
            {
                Rect = new Rect(x.Value, y.Value, width.Value, height.Value)
            };
        }
    }
}
