﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.ColorSpaces;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Color
{
    internal abstract class SetCmykColorBase : SetSimpleColorBase<CmykColorObject, DeviceCmykColorSpaceObject>
    {
        protected sealed override void ReadColorComponents(ContentStreamInterpreter interpreter, IPdfContentImportContext context, out CmykColorObject color, out DeviceCmykColorSpaceObject colorspace)
        {
            PdfReal k = ReadRestrictedNumberComponentValue(interpreter, context);
            PdfReal y = ReadRestrictedNumberComponentValue(interpreter, context);
            PdfReal m = ReadRestrictedNumberComponentValue(interpreter, context);
            PdfReal c = ReadRestrictedNumberComponentValue(interpreter, context);

            color = new CmykColorObject(c, m, y, k);
            colorspace = new DeviceCmykColorSpaceObject();
        }
    }
}
