﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.ColorSpaces;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Color
{
    internal abstract class SetRgbColorBase : SetSimpleColorBase<RgbColorObject, DeviceRgbColorSpaceObject>
    {
        public void Write(Export.PdfWriter writer, Export.IPdfContentExportContext context, Fixed.Model.ColorSpaces.RgbColor color)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            this.WriteInternal(writer, context.Owner, color.ToRgbColor(context));
        }

        protected sealed override void ReadColorComponents(ContentStreamInterpreter interpreter, IPdfContentImportContext context, out RgbColorObject color, out DeviceRgbColorSpaceObject colorspace)
        {
            PdfReal b = ReadRestrictedNumberComponentValue(interpreter, context);
            PdfReal g = ReadRestrictedNumberComponentValue(interpreter, context);
            PdfReal r = ReadRestrictedNumberComponentValue(interpreter, context);
            color = new RgbColorObject(r, g, b);
            colorspace = new DeviceRgbColorSpaceObject();
        }
    }
}
