﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Graphics
{
    internal class ClosePath : ContentStreamOperator
    {

        public override string Name
        {
            get { return ContentStreamOperatorNames.ClosePath; }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");

            ClosePath.Execute(interpreter);
        }

        public static void Execute(ContentStreamInterpreter interpreter)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");

            if (interpreter.CurrentPathFigure != null)
            {
                interpreter.CurrentPathFigure.IsClosed = true;
                PdfReal startPointX = new PdfReal(interpreter.CurrentPathFigure.StartPoint.X);
                PdfReal startPointY = new PdfReal(interpreter.CurrentPathFigure.StartPoint.Y);

                interpreter.CurrentPathFigure = null;

                MoveTo.Execute(interpreter, startPointX, startPointY);
            }
        }

        public void Write(PdfWriter writer, IPdfContentExportContext context)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            this.WriteInternal(writer, context.Owner);
        }
    }
}
