﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.Model.Graphics;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Graphics
{
    internal class FillAndStrokePathEvenOdd : StrokePathBase
    {
        public override string Name
        {
            get { return ContentStreamOperatorNames.FillAndStrokePathEvenOdd; }
        } 

        protected override void ExecuteStrokeOverride(ContentStreamInterpreter interpreter, IPdfContentImportContext context, Path path)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(path, "path"); 
             
            path.Fill = interpreter.GraphicState.CalculateFillColor(interpreter.Reader, context);
            path.IsFilled = true;
            path.IsStroked = true;

            PathGeometry geometry = path.Geometry as PathGeometry;
            if (geometry != null)
            {
                geometry.FillRule = FillRule.EvenOdd;
            }
        } 
    }
}
