﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Graphics
{
    internal class YCurveTo : ContentStreamOperator
    {
        public override string Name
        {
            get { return ContentStreamOperatorNames.YCurveTo; }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");

            PdfReal y3 = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner);
            PdfReal x3 = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner);
            PdfReal y1 = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner);
            PdfReal x1 = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner);

            CurveTo.Execute(interpreter, x1, y1, x3, y3, x3, y3);
        }
    }
}
