﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.MarkedContent
{
    internal class BeginMarkedContent : ContentStreamOperator
    {
        public override string Name
        {
            get
            {
                return ContentStreamOperatorNames.BeginMarkedContent;
            }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");
            
            // Currently handling nested makers is not supported, so we track only the current marker.
            PdfName tag = interpreter.Operands.GetLast<PdfName>(interpreter.Reader, context.Owner);
            context.CurrentMarker = new Marker(tag.Value);
        }

        public void Write(PdfWriter writer, IPdfContentExportContext context, string name)
        {
            this.WriteInternal(writer, context.Owner, new PdfName(name));
        }
    }
}
