﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.State
{
    internal class GraphicsStatePusher : IDisposable
    {
        private readonly PdfWriter writer;
        private readonly IPdfContentExportContext context;

        public GraphicsStatePusher(PdfWriter writer, IPdfContentExportContext context)
        {
            this.writer = writer;
            this.context = context;

            this.SaveState();
        }

        public void Dispose()
        {
            this.RestoreGraphicsState();
        }

        private void SaveState()
        {
            ContentStreamOperators.SaveGraphicsStateOperator.Write(this.writer, this.context);
        }

        private void RestoreGraphicsState()
        {
            ContentStreamOperators.RestoreGraphicsStateOperator.Write(this.writer, this.context);
        }
    }
}
