﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.State
{
    internal class RestoreGraphicsState : ContentStreamOperator
    {
        public override string Name
        {
            get { return ContentStreamOperatorNames.RestorGraphicsState; }
        }

        public override void Execute(Import.ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");

            interpreter.RestoreGraphicState();
        } 

        public void Write(PdfWriter writer, IPdfContentExportContext context)
        {
            this.WriteInternal(writer, context.Owner);
        }
    }
}
