﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.State
{
    internal class SaveGraphicsState : ContentStreamOperator
    {
        public override string Name
        {
            get { return ContentStreamOperatorNames.SaveGraphicsState; }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");

            interpreter.SaveGraphicState();
        } 

        public void Write(PdfWriter writer, IPdfContentExportContext context)
        {
            this.WriteInternal(writer, context.Owner);
        }
    }
}
