﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.GraphicsState;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.State
{
    internal class SetGraphicsStateDictionary : ContentStreamOperator
    { 
        public override string Name
        {
            get { return Operators.ContentStreamOperatorNames.SetGraphicsStateDictionary; }
        }

        public override void Execute(Import.ContentStreamInterpreter interpreter, Import.IPdfContentImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");

            PdfName key = interpreter.Operands.GetLast<PdfName>(interpreter.Reader, context.Owner);
            ExtGStateObject pdfExtGState = context.GetExtGState(interpreter.Reader, key);
            Data.ExtGState extGState = context.Owner.GetExtGState(interpreter.Reader, pdfExtGState); 

            interpreter.GraphicState.UpdateProperties(extGState);
        }

        public void Write(PdfWriter writer, IPdfContentExportContext context, string dictionaryName)
        {
            this.WriteInternal(writer, context.Owner, new PdfName(dictionaryName));
        }
    }
}
