﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Model.Graphics;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.State
{
    internal class SetLineCap : ContentStreamOperator
    {
        public override string Name
        {
            get { return ContentStreamOperatorNames.SetLineCap; }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");

            PdfReal lineCap = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner);
            interpreter.GraphicState.StrokeLineCap = (LineCap)lineCap.Value;
        } 

        public void Write(PdfWriter writer, IPdfContentExportContext context, LineCap lineCap)
        {
            PdfInt lineCapStyle = new PdfInt((int)lineCap);
            this.WriteInternal(writer, context.Owner, lineCapStyle);
        }
    }
}
