﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Model.Graphics;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.State
{
    internal class SetLineJoin : ContentStreamOperator
    {
        public override string Name
        {
            get { return ContentStreamOperatorNames.SetLineJoin; }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");

            PdfReal lineJoin = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner);
            interpreter.GraphicState.StrokeLineJoin = (LineJoin)lineJoin.Value;
        } 

        public void Write(PdfWriter writer, IPdfContentExportContext context, LineJoin lineJoin)
        {
            PdfInt lineJoinStyle = new PdfInt((int)lineJoin);
            this.WriteInternal(writer, context.Owner, lineJoinStyle); 
        }
    }
}
