﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Media;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.State
{
    internal class SetLineWidth : ContentStreamOperator
    {
        public override string Name
        {
            get { return ContentStreamOperatorNames.SetLineWidth; }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");

            PdfReal lineWidth = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner);
            interpreter.GraphicState.StrokeLineWidth = lineWidth.Value;
        } 

        public void Write(PdfWriter writer, IPdfContentExportContext context, double width)
        {
            double convertedWidth = width;
            this.WriteInternal(writer, context.Owner, convertedWidth.ToPdfReal());
        }
    }
}
