﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.State
{
    internal class SetMiterLimit : ContentStreamOperator
    { 
        public override string Name
        {
            get { return ContentStreamOperatorNames.SetMiterLimit; }
        }

        public override void Execute(Import.ContentStreamInterpreter interpreter, Import.IPdfContentImportContext context)
        {
            PdfReal miterLimit = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner);
            interpreter.GraphicState.MiterLimit = miterLimit.Value;
        }

        public void Write(PdfWriter writer, IPdfContentExportContext context, double miterLimit)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            this.WriteInternal(writer, context.Owner, miterLimit.ToPdfReal());
        }
    }
}
