﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Text
{
    internal class CharSpace : ContentStreamOperator
    {
        public override string Name
        {
            get
            {
                return ContentStreamOperatorNames.CharSpace;
            }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            double charSpacing = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner).Value;
            CharSpace.Execute(interpreter.TextState, charSpacing);
        }

        public static void Execute(TextState textState, double charSpacing)
        {
            textState.CharacterSpacing = charSpacing;
        }

        public void Write(PdfWriter writer, IPdfContentExportContext context, double charSpace)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            this.WriteInternal(writer, context.Owner, charSpace.ToPdfReal());
        }
    }
}
