﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Text
{
    internal class Font : ContentStreamOperator
    {
        public override string Name
        {
            get
            {
                return ContentStreamOperatorNames.Font;
            }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");

            interpreter.TextState.FontSize = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner).Value;
            interpreter.TextState.Font = context.GetFont(interpreter.Reader, interpreter.Operands.GetLast<PdfName>(interpreter.Reader, context.Owner));
        } 

        public void Write(PdfWriter writer, IPdfContentExportContext context, string fontName, double fontSize)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNullOrEmpty(fontName, "fontName");

            this.WriteInternal(writer, context.Owner, fontName.ToPdfName(), fontSize.ToPdfReal());
        }
    }
}
