﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Text
{
    internal class HorizontalScale : ContentStreamOperator
    {
        public override string Name
        {
            get
            {
                return ContentStreamOperatorNames.HorizontalScale;
            }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            var horizontalScaling = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner).Value / 100d;
            interpreter.TextState.HorizontalScaling = horizontalScaling;
        }    

        public void Write(PdfWriter writer, IPdfContentExportContext context, double scale)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            this.WriteInternal(writer, context.Owner, (scale * 100).ToPdfReal());
        }
    }
}
