﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Fixed.Model.Text;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Text
{
    internal class RenderingMode : ContentStreamOperator
    {
        public override string Name
        {
            get
            {
                return ContentStreamOperatorNames.RenderingMode;
            }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            var renderingMode = (Telerik.Windows.Documents.Fixed.Model.Text.RenderingMode)interpreter.Operands.GetLast<PdfInt>(interpreter.Reader, context.Owner).Value;
            interpreter.TextState.RenderingMode = renderingMode;
        }

        public void Write(PdfWriter writer, IPdfContentExportContext context, Telerik.Windows.Documents.Fixed.Model.Text.RenderingMode renderingMode)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            this.WriteInternal(writer, context.Owner, ((int)renderingMode).ToPdfInt());
        }
    }
}
