﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Text
{
    internal class SetSpacingMoveToNextLineAndShowText : ContentStreamOperator
    {
        public override string Name
        {
            get
            {
                return ContentStreamOperatorNames.SetSpacingMoveToNextLineAndShowText;
            }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            PdfString text = interpreter.Operands.GetLast<PdfString>(interpreter.Reader, context.Owner);
            PdfReal charSpacing = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner);
            PdfReal wordSpacing = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner);

            CharSpace.Execute(interpreter.TextState, charSpacing.Value);
            WordSpace.Execute(interpreter.TextState, wordSpacing.Value);
            MoveToNextLineAndShowText.Execute(interpreter, context, text);
        }
    }
}
