﻿using System;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Text
{
    internal class TranslateText : ContentStreamOperator
    {
        public override string Name
        {
            get
            {
                return ContentStreamOperatorNames.TranslateText;
            }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            double ty = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner).Value;
            double tx = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner).Value;

            TranslateText.Execute(interpreter.TextState, tx, ty);
        }

        public static void Execute(TextState textState, double tx, double ty)
        {
            textState.TextLineMatrix = new Matrix(1, 0, 0, 1, tx, ty).MultiplyBy(textState.TextLineMatrix);
            textState.TextMatrix = textState.TextLineMatrix;
        }

        public static void MoveHorizontalPosition(TextState textState, double tx)
        {
            textState.TextMatrix = GetTranslatedTextMatrix(textState.TextMatrix, tx);
        }

        public static Matrix GetTranslatedTextMatrix(Matrix textMatrix, double tx)
        {
            Matrix translatedTextMatrix = new Matrix(1, 0, 0, 1, tx, 0).MultiplyBy(textMatrix);

            return translatedTextMatrix;
        }
    }
}
