﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Text
{
    internal class TranslateTextAndSetLeading : ContentStreamOperator
    {
        public override string Name
        {
            get
            {
                return ContentStreamOperatorNames.TranslateTextAndSetLeading;
            }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            double ty = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner).Value;
            double tx = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner).Value;

            interpreter.TextState.TextLead = -ty;
            TranslateText.Execute(interpreter.TextState, tx, ty);
        }
    }
}
