﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators.Text
{
    internal class WordSpace : ContentStreamOperator
    {
        public override string Name
        {
            get
            {
                return ContentStreamOperatorNames.WordSpace;
            }
        }

        public override void Execute(ContentStreamInterpreter interpreter, IPdfContentImportContext context)
        {
            double wordSpacing = interpreter.Operands.GetLast<PdfReal>(interpreter.Reader, context.Owner).Value;
            WordSpace.Execute(interpreter.TextState, wordSpacing);
        }

        public static void Execute(TextState textState, double wordSpacing)
        {
            textState.WordSpacing = wordSpacing;
        }

        public void Write(PdfWriter writer, IPdfContentExportContext context, double wordSpace)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            this.WriteInternal(writer, context.Owner, wordSpace.ToPdfReal());
        }
    }
}
