﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Forms;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Streaming.IncrementalUpdate.InteractiveForms
{
    internal class ChoiceFieldPropertiesEditor : SingleStateAppearanceFieldPropertiesEditor
    {
        private bool hasOptionsArray;
        private readonly PdfArray options;

        public ChoiceFieldPropertiesEditor(PdfIncrementalStreamExportContext context, PdfFormFieldSource field) 
            : base(context, field)
        {
            PdfSourceImportContext importContext = this.Field.FileSource.Context;            
            this.hasOptionsArray = this.Field.PdfDictionary.TryGetElement<PdfArray>(importContext.Reader, importContext, FormFieldNode.OptionsName, out this.options);
        }

        protected bool FieldHasOptions
        {
            get
            {
                return this.hasOptionsArray;
            }
        }

        protected string GetOptionValue(int optionIndex)
        {
            Guard.ThrowExceptionIfFalse(this.FieldHasOptions, "FieldHasOptions");

            IPdfPrimitive option = this.options[optionIndex];

            string value;
            if (option.Type == PdfElementType.Array)
            {
                PdfArray array = (PdfArray)option;
                value = array[0].ToString();
            }
            else
            {
                value = option.ToString();
            }

            return value;
        }
    }
}
