﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Forms;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Streaming.IncrementalUpdate.InteractiveForms
{
    internal class ComboBoxPropertiesEditor : ChoiceFieldPropertiesEditor
    {
        public ComboBoxPropertiesEditor(PdfIncrementalStreamExportContext context, PdfFormFieldSource field) 
            : base(context, field)
        {
        }
        
        public void SetValue(string customValue)
        {
            PdfDictionary clonedDictionary = this.GetClonedFieldDictionary();
            clonedDictionary.Remove(FormFieldNode.SortedIndicesName);

            if (string.IsNullOrEmpty(customValue))
            {
                clonedDictionary.Remove(FormFieldNode.FieldValueName);    
            }
            else
            {
                clonedDictionary[FormFieldNode.FieldValueName] = customValue.ToPdfString();
            }
        }

        public void SetValue(int selectedIndex)
        {
            if (this.FieldHasOptions)
            {
                string value = this.GetOptionValue(selectedIndex);
                PdfDictionary clonedDictionary = this.GetClonedFieldDictionary();
                clonedDictionary[FormFieldNode.FieldValueName] = value.ToPdfString();
                clonedDictionary[FormFieldNode.SortedIndicesName] = new PdfArray(new PdfInt(selectedIndex));
            }
        }
    }
}
