﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Forms;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Streaming.IncrementalUpdate.InteractiveForms
{
    internal class ListBoxPropertiesEditor : ChoiceFieldPropertiesEditor
    {
        public ListBoxPropertiesEditor(PdfIncrementalStreamExportContext context, PdfFormFieldSource field) 
            : base(context, field)
        {
        }

        public void SetValue (int[] sortedSelectedIndices)
        {
            if (sortedSelectedIndices == null || sortedSelectedIndices.Length == 0)
            {
                PdfDictionary clonedDictionary = this.GetClonedFieldDictionary();
                clonedDictionary.Remove(FormFieldNode.FieldValueName);
                clonedDictionary.Remove(FormFieldNode.SortedIndicesName);
            }
            else if (this.FieldHasOptions)
            {
                PdfDictionary clonedDictionary = this.GetClonedFieldDictionary();
                clonedDictionary[FormFieldNode.FieldValueName] = new PdfArray(sortedSelectedIndices.Select(i => this.GetOptionValue(i).ToPdfString()));
                clonedDictionary[FormFieldNode.SortedIndicesName] = sortedSelectedIndices.ToPdfArray();
            }
        }
    }
}
