﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Annotations;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Objects;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Model.Resources;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Streaming.IncrementalUpdate.InteractiveForms
{
    internal class SingleStateAppearanceFieldPropertiesEditor : FormFieldPropertiesEditor
    {
        public SingleStateAppearanceFieldPropertiesEditor(PdfIncrementalStreamExportContext context, PdfFormFieldSource field)
            : base(context, field)
        {
        }

        public void SetAppearance(IEnumerable<FormSource> normalAppearances)
        {
            Guard.ThrowExceptionIfNull(normalAppearances, "normalAppearances");

            int index = 0;

            foreach (FormSource normalAppearance in normalAppearances)
            {
                FormXObject formXObject = new FormXObject();
                formXObject.CopyPropertiesFrom(this.Context, normalAppearance);
                Appearances appearances = new Appearances();
                appearances.NormalAppearance = new Appearance(formXObject);
                PdfDictionary widgetDictionary = this.GetClonedWidgetDictionary(index);
                widgetDictionary[AnnotationObject.AppearanceName] = appearances;

                index++;
            }
        }
    }
}
