﻿using System;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Annotations;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Model.Annotations;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Streaming.IncrementalUpdate.InteractiveForms
{
    internal class TwoStateAppearanceFieldPropertiesEditor : FormFieldPropertiesEditor
    {
        private readonly string[] normalAppearancePropertyNames = { AnnotationObject.AppearanceName, Appearances.NormalAppearanceKey };

        public TwoStateAppearanceFieldPropertiesEditor(PdfIncrementalStreamExportContext context, PdfFormFieldSource field) 
            : base(context, field)
        {
        }

        protected bool TryGetWidgetOnState(int widgetIndex, out string onStateName)
        {
            PdfDictionary widgetDictionary = this.Field.WidgetObjects[widgetIndex].GetContent<PdfDictionary>();

            PdfDictionary normalAppearance;
            if (this.Field.FileSource.Context.TryGetNestedPrimitive(widgetDictionary, this.normalAppearancePropertyNames, out normalAppearance))
            {
                foreach (string key in normalAppearance.Keys)
                {
                    if (key != TwoStatesButtonWidget.OffState)
                    {
                        onStateName = key;
                        return true;
                    }
                }
            }

            onStateName = null;
            return false;
        }
    }
}
