﻿// The MIT License (MIT) 
// 
// Copyright (c) 2014 Daniel Glucksman 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights 
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
// SOFTWARE. 
using System;

namespace JBig2Decoder
{
    internal class HalftoneRegionFlags : Flags
    {

    public const string H_MMR = "H_MMR";
    public const string H_TEMPLATE = "H_TEMPLATE";
    public const string H_ENABLE_SKIP = "H_ENABLE_SKIP";
    public const string H_COMB_OP = "H_COMB_OP";
    public const string H_DEF_PIXEL = "H_DEF_PIXEL";

    public override void setFlags(int flagsAsInt) {
        this.flagsAsInt = flagsAsInt;

		flags[H_MMR] =  flagsAsInt & 1;
		
		flags[H_TEMPLATE] = (flagsAsInt >> 1) & 3;
		
		flags[H_ENABLE_SKIP] = (flagsAsInt >> 3) & 1;
		
		flags[H_COMB_OP]= (flagsAsInt >> 4) & 7;
		
		flags[H_DEF_PIXEL] = (flagsAsInt >> 7) & 1;

		
		if(JBIG2StreamDecoder.debug)
			Console.WriteLine(flags);
    }
}
}
