﻿// The MIT License (MIT) 
// 
// Copyright (c) 2014 Daniel Glucksman 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights 
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
// SOFTWARE. 
using System;

namespace JBig2Decoder
{
    internal class TextRegionFlags : Flags
    {

	public const string SB_HUFF = "SB_HUFF";
	public const string SB_REFINE = "SB_REFINE";
	public const string LOG_SB_STRIPES = "LOG_SB_STRIPES";
	public const string REF_CORNER = "REF_CORNER";
	public const string TRANSPOSED = "TRANSPOSED";
	public const string SB_COMB_OP = "SB_COMB_OP";
	public const string SB_DEF_PIXEL = "SB_DEF_PIXEL";
	public const string SB_DS_OFFSET = "SB_DS_OFFSET";
	public const string SB_R_TEMPLATE = "SB_R_TEMPLATE";
	public override void setFlags(int flagsAsInt) {
		this.flagsAsInt = flagsAsInt;

		flags[SB_HUFF] = flagsAsInt & 1;

		flags[SB_REFINE] = (flagsAsInt >> 1) & 1;

		flags[LOG_SB_STRIPES] = (flagsAsInt >> 2) & 3;

		flags[REF_CORNER] = (flagsAsInt >> 4) & 3;

		flags[TRANSPOSED] = (flagsAsInt >> 6) & 1;

		flags[SB_COMB_OP] = (flagsAsInt >> 7) & 3;

		flags[SB_DEF_PIXEL] = (flagsAsInt >> 9) & 1;

		int sOffset = (flagsAsInt >> 10) & 0x1f;
		if ((sOffset & 0x10) != 0) {
			sOffset |= -1 - 0x0f;
		}
		flags[SB_DS_OFFSET] = sOffset;

		flags[SB_R_TEMPLATE]=(flagsAsInt >> 15) & 1;

		if (JBIG2StreamDecoder.debug)
			Console.WriteLine(flags);
	}
}
}
