﻿// The MIT License (MIT) 
// 
// Copyright (c) 2014 Daniel Glucksman 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights 
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
// SOFTWARE. 
using System;

namespace JBig2Decoder
{
    internal class TextRegionHuffmanFlags : Flags
    {

	    public const string SB_HUFF_FS = "SB_HUFF_FS";
	    public const string SB_HUFF_DS = "SB_HUFF_DS";
	    public const string SB_HUFF_DT = "SB_HUFF_DT";
	    public const string SB_HUFF_RDW = "SB_HUFF_RDW";
	    public const string SB_HUFF_RDH = "SB_HUFF_RDH";
	    public const string SB_HUFF_RDX = "SB_HUFF_RDX";
	    public const string SB_HUFF_RDY = "SB_HUFF_RDY";
	    public const string SB_HUFF_RSIZE = "SB_HUFF_RSIZE";

	    public override void setFlags(int flagsAsInt) {
		    this.flagsAsInt = flagsAsInt;

		    flags[SB_HUFF_FS] =  flagsAsInt & 3;

		    flags[SB_HUFF_DS] = (flagsAsInt >> 2) & 3;

		    flags[SB_HUFF_DT] = (flagsAsInt >> 4) & 3;

		    flags[SB_HUFF_RDW] =  (flagsAsInt >> 6) & 3;

		    flags[SB_HUFF_RDH] =  (flagsAsInt >> 8) & 3;

		    flags[SB_HUFF_RDX] =  (flagsAsInt >> 10) & 3;

		    flags[SB_HUFF_RDY] = (flagsAsInt >> 12) & 3;

		    flags[SB_HUFF_RSIZE] = (flagsAsInt >> 14) & 1;

		    if (JBIG2StreamDecoder.debug)
			    Console.WriteLine(flags);
	    }
    }
}
