﻿// The MIT License (MIT) 
// 
// Copyright (c) 2014 Daniel Glucksman 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights 
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
// SOFTWARE. 
using System;

namespace JBig2Decoder
{
    internal class SymbolDictionaryFlags : Flags
    {

        public const string SD_HUFF = "SD_HUFF";
        public const string SD_REF_AGG = "SD_REF_AGG";
        public const string SD_HUFF_DH = "SD_HUFF_DH";
        public const string SD_HUFF_DW = "SD_HUFF_DW";
        public const string SD_HUFF_BM_SIZE = "SD_HUFF_BM_SIZE";
        public const string SD_HUFF_AGG_INST = "SD_HUFF_AGG_INST";
        public const string BITMAP_CC_USED = "BITMAP_CC_USED";
        public const string BITMAP_CC_RETAINED = "BITMAP_CC_RETAINED";
        public const string SD_TEMPLATE = "SD_TEMPLATE";
        public const string SD_R_TEMPLATE = "SD_R_TEMPLATE";

        public override void setFlags(int flagsAsInt) {
		    this.flagsAsInt = flagsAsInt;

		    flags[SD_HUFF] =  (flagsAsInt & 1);

		    flags[SD_REF_AGG] =(flagsAsInt >> 1) & 1;

		    flags[SD_HUFF_DH] = (flagsAsInt >> 2) & 3;

		    flags[SD_HUFF_DW] =  (flagsAsInt >> 4) & 3;

		    flags[SD_HUFF_BM_SIZE] = (flagsAsInt >> 6) & 1;

		    flags[SD_HUFF_AGG_INST]=(flagsAsInt >> 7) & 1;

		    flags[BITMAP_CC_USED] = (flagsAsInt >> 8) & 1;

		    flags[BITMAP_CC_RETAINED] =  (flagsAsInt >> 9) & 1;

		    flags[SD_TEMPLATE] = (flagsAsInt >> 10) & 3;

		    flags[SD_R_TEMPLATE] = (flagsAsInt >> 12) & 1;

		    if (JBIG2StreamDecoder.debug)
			    Console.WriteLine(flags);
	    }
    }
}
