﻿// The MIT License (MIT) 
// 
// Copyright (c) 2014 Daniel Glucksman 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights 
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
// SOFTWARE. 

namespace JBig2Decoder
{
    internal class SegmentHeader
    {
        private int segmentNumber;
        private int segmentType;
        private bool pageAssociationSizeSet;
        private bool deferredNonRetainSet;
        private int referredToSegmentCount;
        private short[] rententionFlags;
        private int[] referredToSegments;
        private int pageAssociation;
        private int dataLength;

        public void setSegmentNumber(int SegmentNumber)
        {
            this.segmentNumber = SegmentNumber;
        }
        public void setSegmentHeaderFlags(short SegmentHeaderFlags) {
		    segmentType = SegmentHeaderFlags & 63; // 63 = 00111111
		    pageAssociationSizeSet = (SegmentHeaderFlags & 64) == 64; // 64 = // 01000000
		    deferredNonRetainSet = (SegmentHeaderFlags & 80) == 80; // 64 = 10000000		
	    }
        public void setReferredToSegmentCount(int referredToSegmentCount)
        {
            this.referredToSegmentCount = referredToSegmentCount;
        }

        public void setRententionFlags(short[] rententionFlags)
        {
            this.rententionFlags = rententionFlags;
        }

        public void setReferredToSegments(int[] referredToSegments)
        {
            this.referredToSegments = referredToSegments;
        }

        public int[] getReferredToSegments()
        {
            return referredToSegments;
        }

        public int getSegmentType()
        {
            return segmentType;
        }

        public int getSegmentNumber()
        {
            return segmentNumber;
        }

        public bool isPageAssociationSizeSet()
        {
            return pageAssociationSizeSet;
        }

        public bool isDeferredNonRetainSet()
        {
            return deferredNonRetainSet;
        }

        public int getReferredToSegmentCount()
        {
            return referredToSegmentCount;
        }

        public short[] getRententionFlags()
        {
            return rententionFlags;
        }

        public int getPageAssociation()
        {
            return pageAssociation;
        }

        public void setPageAssociation(int pageAssociation)
        {
            this.pageAssociation = pageAssociation;
        }

        public void setDataLength(int dataLength)
        {
            this.dataLength = dataLength;
        }

        public void setSegmentType(int type)
        {
            this.segmentType = type;
        }

        public int getSegmentDataLength()
        {
            return dataLength;
        }
    }
}
