﻿// The MIT License (MIT) 
// 
// Copyright (c) 2014 Daniel Glucksman 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights 
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions: 
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software. 
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
// SOFTWARE. 
#pragma warning disable 0675

namespace JBig2Decoder
{
    internal class BinaryOperation {

	    public const int LEFT_SHIFT = 0;
	    public const int RIGHT_SHIFT = 1;
	
	    public const long LONGMASK = 0xffffffffL; // 1111 1111 1111 1111 1111 1111 1111 1111
	    public const int INTMASK = 0xff; // 1111 1111

	    public static int getInt32(short[] number) {
		    return (number[0] << 24) | (number[1] << 16) | (number[2] << 8) | number[3];
	    }

	    public static int getInt16(short[] number) {
		    return (number[0] << 8) | number[1];
	    }

	    public static long bit32ShiftL(long number, int shift) {
		    //return (number << shift) & LONGMASK;
		    return number << shift;
	    }

	    public static long bit32ShiftR(long number, int shift) {
		    //return (number >> shift) & LONGMASK;
		    return number >> shift;
	    }
	  
	    public static int bit8Shift(int number, int shift, int direction) {
		    if (direction == LEFT_SHIFT)
			    number <<= shift;
		    else
			    number >>= shift;

		    return (number & INTMASK);
	    }

	    public static int getInt32(byte[] number) {
		    return (number[0] << 24) | (number[1] << 16) | (number[2] << 8) | number[3];
	    }
}
}
#pragma warning restore 0675
