namespace Telerik.Windows.Documents.Fixed.Imaging.Silverlight
{
	/// <summary>
	/// Represents the BitmapCodecInfo class.
	/// </summary>
    internal abstract class BitmapCodecInfo
	{
		/// <summary>
		/// Initializes a new instance of the BitmapCodecInfo class.
		/// </summary>
        protected BitmapCodecInfo()
        {
        }

		/// <summary>
		/// Gets a value that identifies the file extensions associated with the codec.
		/// </summary>
		public virtual string FileExtensions
        {
            get
            {
                return string.Empty;
            }
        }

		/// <summary>
		/// Gets a value that identifies the MIME types associated with the codec.
		/// </summary>
		public virtual string MimeTypes
        {
            get
            {
                return string.Empty;
            }
        }

		/// <summary>
		/// Gets a value that indicates whether the codec supports animation.
		/// </summary>
		public virtual bool SupportsAnimation
		{
			get
			{
				return false;
			}
		}

		/// <summary>
		/// Gets a value that identifies whether the codec supports multiple frames.
		/// </summary>
		public virtual bool SupportsMultipleFrames
		{
			get
			{
				return false;
			}
		}
	}
}
