﻿using System;
using System.IO;

namespace Telerik.Windows.Documents.Fixed.Imaging.Silverlight
{
	/// <summary>
	/// The StreamExtension class.
	/// </summary>
    internal static class StreamExtension
    {
        public static void WriteInt(this Stream stream, int value)
        {
            stream.Write(BitConverter.GetBytes(value), 0, 4);
        }

        public static void WriteShort(this Stream stream, short value)
        {
            stream.Write(BitConverter.GetBytes(value), 0, 2);
        }

        public static void WriteToStream(this Stream source, Stream destination)
        {
            const int BufSize = 0x1000;
			byte[] buf = new byte[BufSize];

            int bytesRead;
			while ((bytesRead = source.Read(buf, 0, BufSize)) > 0)
            {
                destination.Write(buf, 0, bytesRead);
            }
        }
    }
}
