namespace Telerik.Windows.Documents.Fixed.Model.Annotations
{
    /// <summary>
    /// Describes the possible types for the style of the border.
    /// </summary>
    public enum AnnotationBorderStyle
    {
        /// <summary>
        /// Specifies that the border should be from one solid line.
        /// </summary>
        Solid,

        /// <summary>
        /// Specifies that the border should be from one dashed line.
        /// </summary>
        Dashed,

        /// <summary>
        /// A simulated embossed rectangle that appearance to be raised above the surface of the page.
        /// </summary>
        Beveled,

        /// <summary>
        /// A simulated engraved rectangle that appears to be recessed below the surface of the page.
        /// </summary>
        Inset,

        /// <summary>
        /// Specifies that no border should be applied on this element.
        /// Table cell borders will not inherit their value from the containing table.
        /// </summary>
        None
    }
}