﻿using System;

namespace Telerik.Windows.Documents.Fixed.Model.Annotations
{
    /// <summary>
    /// Represents the characteristics of button Widget annotation dynamic appearance.
    /// </summary>
    public class ButtonAppearanceCharacteristics : DynamicAppearanceCharacteristics
    {
        /// <summary>
        /// Initializes a new instance of <see cref="ButtonAppearanceCharacteristics"/> class.
        /// </summary>
        public ButtonAppearanceCharacteristics()
        {
        }

        /// <summary>
        /// Initializes a new instance of <see cref="ButtonAppearanceCharacteristics"/> class by copying its properties from other instance.
        /// </summary>
        /// <param name="other">Other <see cref="ButtonAppearanceCharacteristics"/> instance.</param>
        public ButtonAppearanceCharacteristics(ButtonAppearanceCharacteristics other)
            : base(other)
        {
            this.NormalCaption = other.NormalCaption;
        }

        /// <summary>
        /// Gets or sets the button normal caption displayed when the mouse is not interacting with the widget.
        /// </summary>
        public string NormalCaption { get; set; }
    }
}
