﻿using System;

namespace Telerik.Windows.Documents.Fixed.Model.Annotations
{
    /// <summary>
    /// Represents the effect to be applied to widget appearance when the annotation is highlighted.
    /// </summary>
    public enum HighlightingMode
    {
        /// <summary>
        /// No highlighting should be applied.
        /// </summary>
        NoHighlighting,

        /// <summary>
        /// The content of the annotation rectangle should be inverted.
        /// </summary>
        InvertContentOfAnnotationRectangle,

        /// <summary>
        /// The border of the annotation rectangle should be inverted.
        /// </summary>
        InvertBorderOfAnnotationRectangle,

        /// <summary>
        /// The annotation source for MouseDown state should be used.
        /// </summary>
        UseAnnotationDownAppearance
    }
}
