﻿using System;

namespace Telerik.Windows.Documents.Fixed.Model.Annotations
{
    /// <summary>
    /// Represents the relative positioning between button icon and caption.
    /// </summary>
    public enum IconAndCaptionPosition
    {
        /// <summary>
        /// No icon will be displayed and only the caption will be drawn.
        /// </summary>
        NoIconCaptionOnly = 0,

        /// <summary>
        /// No caption will be displayed and only the icon will be drawn.
        /// </summary>
        NoCaptionIconOnly = 1,

        /// <summary>
        /// The caption will be positioned below the icon.
        /// </summary>
        CaptionBelowIcon = 2,

        /// <summary>
        /// The caption will be positioned above the icon.
        /// </summary>
        CaptionAboveIcon = 3,

        /// <summary>
        /// The caption will be position right of the icon.
        /// </summary>
        CaptionToRightOfIcon = 4,

        /// <summary>
        /// The caption will be positioned left of the icon.
        /// </summary>
        CaptionToLeftOfIcon = 5,

        /// <summary>
        /// The caption will be positioned over the icon.
        /// </summary>
        CaptionOverIcon = 6
    }
}
