﻿using System;

namespace Telerik.Windows.Documents.Fixed.Model.Annotations
{
    /// <summary>
    /// Represents the conditions by which the button icon will be scaled in Annotation rectangle.
    /// </summary>
    public enum IconScaleCondition
    {
        /// <summary>
        /// Always scale the icon.
        /// </summary>
        AlwaysScale,

        /// <summary>
        /// Scale the icon if it is bigger than Annotation Rectangle.
        /// </summary>
        ScaleIfBiggerThanAnnotationRectangle,

        /// <summary>
        /// Scale the icon if it is smaller than Annotation Rectangle.
        /// </summary>
        ScaleIfSmallerThanAnnotationRectangle,

        /// <summary>
        /// Never scale the icon.
        /// </summary>
        NeverScale
    }
}
