﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.Model.Common;
using Telerik.Windows.Documents.Fixed.Model.Text;

namespace Telerik.Windows.Documents.Fixed.Model.Annotations
{
    /// <summary>
    /// Represents highlight annotation.
    /// </summary>
    public class TextMarkup : Annotation
    {
        private readonly TextMarkupType textMarkupType;

        /// <summary>
        /// Initializes a new instance of the <see cref="TextMarkup" /> class.
        /// </summary>
        /// <param name="textMarkupType">Type of the text markup.</param>
        public TextMarkup(TextMarkupType textMarkupType)   
        {
            this.textMarkupType = textMarkupType;
        } 

        /// <summary>
        /// Gets the text markup type.
        /// </summary>
        /// <value>The text markup type.</value>
        public TextMarkupType TextMarkupType
        {
            get
            {
                return this.textMarkupType;
            }
        }

        /// <summary>
        /// Gets or sets the text fragment associated that is associated for the annotation.
        /// </summary>
        /// <value>The associated text fragment.</value>
        public TextFragment AssociatedTextFragment { get; set; }

        internal override AnnotationType AnnotationType 
        {
            get
            {
                return AnnotationType.TextMarkup;
            }
        }
    }
}
