﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Fixed.Model.Annotations
{
    /// <summary>
    /// Represents the text markup type.
    /// </summary>
    public enum TextMarkupType
    {
        /// <summary>
        /// Represents highlight text markup.
        /// </summary>
        Highlight,

        /// <summary>
        /// Represents underline text markup.
        /// </summary>
        Underline,

        /// <summary>
        /// Represents squiggly text markup.
        /// </summary>
        Squiggly,

        /// <summary>
        /// Represents strike out text markup.
        /// </summary>
        StrikeOut
    }
}
