﻿using System;

namespace Telerik.Windows.Documents.Fixed.Model.Annotations
{
    /// <summary>
    /// Represents the widget content types.
    /// </summary>
    public enum WidgetContentType
    {
        /// <summary>
        /// The variable content type.
        /// </summary>
        VariableContent,

        /// <summary>
        /// The content type for widgets that have two states.
        /// </summary>
        TwoStatesContent,

        /// <summary>
        /// The content type for signature widget.
        /// </summary>
        SignatureContent,

        /// <summary>
        /// The content type for push button widget.
        /// </summary>
        PushButtonContent
    }
}
