﻿#if !NETSTANDARD
using System.Windows.Media;
#else
using Telerik.Documents.Primitives;
#endif
using Telerik.Windows.Documents.Fixed.Model.Common;
using Telerik.Windows.Documents.Fixed.Model.Graphics;

namespace Telerik.Windows.Documents.Fixed.Model
{
    /// <summary>
    /// Represents fixed page.
    /// </summary>
    public class Clipping : ContentElementBase, IContextClonable<Clipping>
    {
        /// <summary>
        /// Gets or sets the clip.
        /// </summary>
        /// <value>The clip.</value>
        public GeometryBase Clip { get; set; }

        internal Matrix Transform { get; set; }

        internal override FixedDocumentElementType ElementType
        {
            get
            {
                return FixedDocumentElementType.Clipping;
            }
        }

        Clipping IContextClonable<Clipping>.Clone(RadFixedDocumentCloneContext cloneContext)
        {
            var clonedClipping = new Clipping();

            clonedClipping.Clip = this.Clip;
            clonedClipping.Transform = this.Transform;
            clonedClipping.Clipping = cloneContext.GetClonedClipping(this.Clipping);

            return clonedClipping;
        }
    }
}
