﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Fixed.Model.ColorSpaces
{
    /// <summary>
    /// Represents the color space names.
    /// </summary>
    public class ColorSpaceNames
    {
        /// <summary>
        /// The CalRGB color space.
        /// </summary>
        public const string CalRgb = "CalRGB";

        /// <summary>
        /// The CalGray color space.
        /// </summary>
        public const string CalGray = "CalGray";

        /// <summary>
        /// The Lab color space.
        /// </summary>
        public const string Lab = "Lab";

        /// <summary>
        /// The ICCBased color space.
        /// </summary>
        public const string IccBased = "ICCBased";

        /// <summary>
        /// The DeviceRGB color space.
        /// </summary>
        public const string DeviceRgb = "DeviceRGB";

        /// <summary>
        /// The DeviceCMYK color space.
        /// </summary>
        public const string DeviceCmyk = "DeviceCMYK";

        /// <summary>
        /// The DeviceGray color space.
        /// </summary>
        public const string DeviceGray = "DeviceGray";

        /// <summary>
        /// The Separation color space.
        /// </summary>
        public const string Separation = "Separation";

        /// <summary>
        /// The DeviceN color space.
        /// </summary>
        public const string DeviceN = "DeviceN";

        /// <summary>
        /// The Indexed color space.
        /// </summary>
        public const string Indexed = "Indexed";

        /// <summary>
        /// The Pattern color space.
        /// </summary>
        public const string Pattern = "Pattern";
    }
}