﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
#endif

namespace Telerik.Windows.Documents.Fixed.Model.ColorSpaces
{
    /// <summary>
    /// Represents linear gradient.
    /// </summary>
    public class LinearGradient : Gradient
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="LinearGradient" /> class.
        /// </summary>
        /// <param name="startPoint">The start point.</param>
        /// <param name="endPoint">The end point.</param>
        public LinearGradient(Point startPoint, Point endPoint) 
            : base(startPoint, endPoint)
        {
        }

        internal override GradientType GradientType
        {
            get
            {
                return GradientType.Linear;
            }
        }

        /// <summary>
        /// Equalses the specified other.
        /// </summary>
        /// <param name="other">The other.</param>
        /// <returns></returns>
        public override bool Equals(ColorBase other)
        {
            LinearGradient gradient = other as LinearGradient;
            if (gradient == null)
            {
                return false;
            }

            return base.Equals(other);
        }
    }
}
