﻿using System;
#if !NETSTANDARD
using System.Windows;
#else
using Telerik.Documents.Primitives;
#endif
using Telerik.Windows.Documents.Fixed.Model.Collections;

namespace Telerik.Windows.Documents.Fixed.Model.Common
{
    internal class EmptyContentRoot : IContentRootElement
    {
        private readonly ContentElementCollection content;

        public EmptyContentRoot()
        {
            this.content = new ContentElementCollection(this);
        }

        bool IContentRootElement.SupportsAnnotations
        {
            get
            {
                return false;
            }
        }

        AnnotationCollection IContentRootElement.Annotations
        {
            get
            {
                throw new NotSupportedException();
            }
        }

        ContentElementCollection IContainerElement.Content
        {
            get
            {
                return this.content;
            }
        }

        IFixedDocumentElement IFixedDocumentElement.Parent
        {
            get
            {
                return null;
            }
        }

        Size IContentRootElement.Size
        {
            get
            {
                return Size.Empty;
            }
        }
    }
}
