﻿namespace Telerik.Windows.Documents.Fixed.Model.Common
{
    /// <summary>
    /// Represents all fixed document element types.
    /// </summary>
    internal enum FixedDocumentElementType
    {
        /// <summary>
        /// RadFixedDocument element type.
        /// </summary>
        RadFixedDocument,

        /// <summary>
        /// RadFixedPage element type.
        /// </summary>
        RadFixedPage,

        /// <summary>
        /// Container element type.
        /// </summary>
        Clipping,

        /// <summary>
        /// Path element type.
        /// </summary>
        Path,

        /// <summary>
        /// Image element type.
        /// </summary>
        Image,

        /// <summary>
        /// TextSegment element type.
        /// </summary>
        TextFragment,

        /// <summary>
        /// Form element type.
        /// </summary>
        Form,

        /// <summary>
        /// Destination element type.
        /// </summary>
        Destination,

        /// <summary>
        /// Annotation element type.
        /// </summary>
        Annotation,

        /// <summary>
        /// BookmarkItem element type.
        /// </summary>
        BookmarkItem,

        /// <summary>
        /// NamedDestination element type.
        /// </summary>
        NamedDestination
    }
}
