﻿using System;
using System.Linq;
using System.Windows;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#endif
using Telerik.Windows.Documents.Fixed.Model.Collections;

namespace Telerik.Windows.Documents.Fixed.Model.Common
{
    /// <summary>
    /// Represents the base interface for the root of the content elements tree.
    /// </summary>
    public interface IContentRootElement : IContainerElement
    {
        /// <summary>
        /// Gets the size.
        /// </summary>
        /// <value>The size.</value>
        Size Size { get; }

        /// <summary>
        /// Gets if the element supports annotations.
        /// </summary>
        /// <value>True if the element supports annotations.</value>
        bool SupportsAnnotations { get; }

        /// <summary>
        /// Gets the annotations collection.
        /// </summary>
        /// <value>The annotations collection.</value>
        AnnotationCollection Annotations { get; }
    }
}
