﻿using System.Windows;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#endif
using Telerik.Windows.Documents.Fixed.Model.Data;

namespace Telerik.Windows.Documents.Fixed.Model.Common
{
    /// <summary>
    /// Abstraction representing a fixed page.
    /// </summary>
    public interface IFixedPage
    {
        /// <summary>
        /// Gets the rectangle defining the boundaries of the physical medium 
        /// on which the page is intended to be displayed or printed.
        /// </summary>
        Rect MediaBox { get; }

        /// <summary>
        /// Gets the rectangle defining the boundaries of the visible region of the page. 
        /// When the page is displayed or printed, its contents are to be clipped (cropped) to this rectangle.
        /// </summary>
        Rect CropBox { get; }

        /// <summary>
        /// Gets the rotation.
        /// </summary>
        Rotation Rotation { get; }
    }
}
