﻿using System;

namespace Telerik.Windows.Documents.Fixed.Model.DigitalSignatures
{
    /// <summary>
    ///  Defines a class used for reading a document source in a byte array format.
    /// </summary>
    internal class ByteArraySourceStream : ISourceStream
    {
        private byte[] source;

        public ByteArraySourceStream(byte[] source)
        {
            this.source = source;
        }

        public bool CanRead
        {
            get
            {
                return true;
            }
        }

        public bool CanSeek
        {
            get
            {
                return true;
            }
        }

        /// <summary>
        /// Reads the specified output buffer.
        /// </summary>
        /// <param name="outputBuffer">The output buffer.</param>
        /// <param name="outputBufferPosition">The output buffer position.</param>
        /// <param name="streamOffset">The stream offset.</param>
        /// <param name="length">The length.</param>
        /// <returns>The total number of bytes read into the buffer.</returns>
        public int Read(byte[] outputBuffer, int outputBufferPosition, long streamOffset, int length)
        {
            Array.Copy(this.source, streamOffset, outputBuffer, outputBufferPosition, length);

            return length;
        }
    }
}
