﻿using System;

namespace Telerik.Windows.Documents.Fixed.Model.DigitalSignatures
{
    /// <summary>
    /// Defines an interface used for reading a document source.
    /// </summary>
    internal interface ISourceStream
    {
        bool CanRead { get; }

        bool CanSeek { get; }

        /// <summary>
        /// Reads the specified output buffer.
        /// </summary>
        /// <param name="outputBuffer">The output buffer.</param>
        /// <param name="outputBufferPosition">The output buffer position.</param>
        /// <param name="streamOffset">The stream offset.</param>
        /// <param name="length">The length.</param>
        /// <returns>The total number of bytes read into the buffer.</returns>
        int Read(byte[] outputBuffer, int outputBufferPosition, long streamOffset, int length);
    }
}