﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Fixed.Model.DigitalSignatures
{
    /// <summary>
    /// Defines a class with predefined constants for sub filter strings.
    /// </summary>
    public static class SignatureSubFilterNames
    {
        /// <summary>
        /// Gets the name of the x509 rsa sha1 sub filter.
        /// </summary>
        /// <value>Sub filter.</value>
        public const string ADBE_X509_RSA_SHA1 = "adbe.x509.rsa_sha1";

        /// <summary>
        /// Gets the name of the pkcs7 sub filter.
        /// </summary>
        /// <value>Sub filter.</value>
        public const string ADBE_PKCS7_SHA1 = "adbe.pkcs7.sha1";

        /// <summary>
        /// Gets the name of the pkcs7 detached sub filter.
        /// </summary>
        /// <value>Sub filter.</value>
        public const string ADBE_PKCS7_DETACHED = "adbe.pkcs7.detached";
    }
}
