﻿using System;

namespace Telerik.Windows.Documents.Fixed.Model.DigitalSignatures
{
    /// <summary>
    /// Defines a class used for determining what part of a <see cref="ISourceStream"/> should be read.
    /// </summary>
    internal class SourcePart
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SourcePart" /> class.
        /// </summary>
        /// <param name="offset">The offset.</param>
        /// <param name="length">The length.</param>
        public SourcePart(int offset, int length)
        {
            this.Offset = offset;
            this.Length = length;
        }

        /// <summary>
        /// Gets or sets the offset.
        /// </summary>
        /// <value>The offset.</value>
        public int Offset { get; set; }

        /// <summary>
        /// Gets or sets the length.
        /// </summary>
        /// <value>The length.</value>
        public int Length { get; set; }
    }
}
