﻿using Telerik.Windows.Documents.Fixed.Model.Editing.Flow;
using Telerik.Windows.Documents.Fixed.Model.Editing.Lists;
using Telerik.Windows.Documents.Fixed.Model.Editing.Tables;

namespace Telerik.Windows.Documents.Fixed.Model.Editing.Collections
{
    /// <summary>
    /// Defines a collection of blocks.
    /// </summary>
    public class BlockCollection : CollectionBase<IBlockElement>
    {
        /// <summary>
        /// Adds a new table to the collection.
        /// </summary>
        /// <returns></returns>
        public Table AddTable()
        {
            Table table = new Table();
            this.Add(table);

            return table;
        }

        /// <summary>
        /// Adds a new block to the collection.
        /// </summary>
        /// <returns></returns>
        public Block AddBlock()
        {
            Block block = new Block();
            this.Add(block);

            return block;
        }

        /// <summary>
        /// Adds a new block with list bullet.
        /// </summary>
        /// <param name="list">The list.</param>
        /// <param name="listLevel">The list level.</param>
        /// <returns>The block.</returns>
        public Block AddBlock(List list, int listLevel)
        {
            Block block = this.AddBlock();
            block.SetBullet(list, listLevel);

            return block;
        }
    }
}
