﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Editing.Lists;

namespace Telerik.Windows.Documents.Fixed.Model.Editing.Collections
{
    /// <summary>
    /// Represents the collection of list levels.
    /// </summary>
    public class ListLevelCollection : CollectionBase<ListLevel>
    {
        /// <summary>
        /// Adds a list level.
        /// </summary>
        /// <returns>The list level.</returns>
        public ListLevel AddListLevel()
        {
            ListLevel level = new ListLevel();
            this.Add(level);

            return level;
        }

        internal override void OnAddingElement(ListLevel element)
        {
            if (element.IsAddedToListLevelCollection)
            {
                throw new InvalidOperationException("Cannot add ListLevel to ListLevelCollection twice!");
            }

            element.IsAddedToListLevelCollection = true;
        }
    }
}
