﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
#endif
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;
using Telerik.Windows.Documents.Fixed.Model.Graphics;

namespace Telerik.Windows.Documents.Fixed.Model.Editing.Flow
{
    internal class ParagraphInfo
    {
        public ParagraphInfo()
        {
            this.Clear();
        }

        public bool IsEmpty
        {
            get;
            private set;
        }

        public bool HasBackground
        {
            get;
            private set;
        }

        public ColorBase BackgroundColor
        {
            get;
            private set;
        }

        public double SpacingBefore
        {
            get;
            private set;
        }

        public double SpacingAfter
        {
            get;
            private set;
        }

        public double LeftIndent
        {
            get;
            private set;
        }

        public double RightIndent
        {
            get;
            private set;
        }

        public double ActualWidth
        {
            get;
            private set;
        }

        public void Copy(IBlockElement blockElement)
        {
            Block block = blockElement as Block;
            if (block == null)
            {
                this.Clear();
            }
            else
            {
                this.HasBackground = block.HasBackground;
                this.BackgroundColor = block.BackgroundColor;
                this.SpacingBefore = block.SpacingBefore;
                this.SpacingAfter = block.SpacingAfter;
                this.LeftIndent = block.LeftIndent;
                this.RightIndent = block.RightIndent;
                this.ActualWidth = block.ActualSize.Width;
                this.IsEmpty = false;
            }
        }

        public Path CreateAdditionalBackgroundPath(double offsetX, double offsetY)
        {
            return Block.CreateBackgroundPath(new Rect(offsetX + this.LeftIndent, offsetY - this.SpacingAfter, this.ActualWidth - this.LeftIndent - this.RightIndent, this.SpacingAfter), this.BackgroundColor);
        }

        public void Clear()
        {
            this.IsEmpty = true;
        }
    }
}
