﻿namespace Telerik.Windows.Documents.Fixed.Model.Editing.Flow
{
    /// <summary>
    /// Defines tab stop types.
    /// </summary>
    internal enum TabStopType
    {
        /// <summary> 
        /// Left aligned tab. 
        /// </summary>
        Left,

        /// <summary> 
        /// Center aligned tab. 
        /// </summary>
        Center,

        /// <summary> 
        /// Right aligned tab. 
        /// </summary>
        Right,

        /// <summary> 
        /// Decimal tab stop. 
        /// </summary>
        Decimal,

        /// <summary> 
        /// Specifies that the current tab is a bar tab. 
        /// </summary>
        Bar,

        /// <summary> 
        /// Clears an inherited tab stop.
        /// </summary>
        Clear
    }
}