﻿using Telerik.Windows.Documents.Fixed.Model.Actions;
using Telerik.Windows.Documents.Fixed.Model.Annotations;
using Telerik.Windows.Documents.Fixed.Model.Fonts;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Model.Editing.Layout
{
    internal class ActionHyperlinkStartLayoutElement : HyperlinkStartLayoutElement
    {
        private readonly Action action;

        public ActionHyperlinkStartLayoutElement(Action action, FontBase font, double fontSize)
            : base(font, fontSize)
        {
            Guard.ThrowExceptionIfNull(action, "action");

            this.action = action;
        }

        public Action Action
        {
            get
            {
                return this.action;
            }
        }

        public override Annotation CreateAnnotation()
        {
            return new Link(this.action);
        }

        public override StartMarkerLayoutElement Clone()
        {
            return new ActionHyperlinkStartLayoutElement(this.action, this.Font, this.FontSize);
        }
    }
}
