﻿using System;
using System.Collections.Generic;
using System.Linq;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
#endif

namespace Telerik.Windows.Documents.Fixed.Model.Editing.Layout
{
    internal class SpaceLayoutElement : LayoutElementBase
    {
        public SpaceLayoutElement(TextProperties textProperties)
            : this(new Size(0, TextFragmentLayoutElement.GetBaselineOffset(textProperties.Font, textProperties.FontSize)), textProperties)
            {
            }

        public SpaceLayoutElement(Size size, TextProperties textProperties)
            : base(size.Width, 0, size.Height, textProperties.Font, textProperties.FontSize)
        {
        }

        internal override LineInfo CompleteLine(double maxLineWidth, double currentLineOffsetX, List<LayoutElementBase> elementsInCurrentLine, out IEnumerable<LayoutElementBase> pendingLayoutElements)
        {
            LineInfo line = new LineInfo();
            line.AddRange(elementsInCurrentLine);
            line.Add(this);
            pendingLayoutElements = Enumerable.Empty<LayoutElementBase>();

            return line;
        }

        internal override void Draw(DrawLayoutElementContext context)
        {
        }

        internal override bool CanFit(double maxTotalWidth, double currentLineOffsetX)
        {
            return true;
        }
    }
}
