﻿using Telerik.Windows.Documents.Fixed.Model.Fonts;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Model.Editing.Layout
{
    internal abstract class StartMarkerLayoutElement : MarkerLayoutElementBase
    {
        public StartMarkerLayoutElement(FontBase font, double fontSize)
            : base(font, fontSize)
        {
        }

        public double OffsetX
        {
            get;
            private set;
        }

        public LineInfo Line
        {
            get;
            private set;
        }

        public Block Block
        {
            get;
            private set;
        }

        public abstract EndMarkerLayoutElement CreateEnd();
        public abstract StartMarkerLayoutElement Clone();


        internal override void Draw(DrawLayoutElementContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            this.Block = context.Block;
            this.Line = context.Line;
            this.OffsetX = context.OffsetX;
        }

    }

    internal abstract class StartMarkerLayoutElement<TStart> : StartMarkerLayoutElement
        where TStart : StartMarkerLayoutElement
    {
        public StartMarkerLayoutElement(FontBase font, double fontSize)
            : base(font, fontSize)
        {
        }
    }
}
