﻿using Telerik.Windows.Documents.Fixed.Model.Editing.Collections;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Model.Editing.Lists
{
    internal class ListLevelsIndexer : IListLevelsIndexer
    {
        private readonly ListLevelCollection levels;

        public ListLevelsIndexer(ListLevelCollection levels)
        {
            this.levels = levels;
        }

        public int GetCurrentIndex(int listLevel)
        {
            Guard.ThrowExceptionIfOutOfRange(FixedDocumentDefaults.FirstListLevelIndex, this.levels.Count - 1, listLevel, "listLevel");
            return this.levels[listLevel].LastInsertedIndex;
        }

        public void MoveToNextIndex(int listLevel)
        {
            this.levels[listLevel].LastInsertedIndex++;

            for (int i = listLevel + 1; i < this.levels.Count; i++)
            {
                ListLevel level = this.levels[i];

                if (level.RestartAfterLevel < 0 || listLevel <= level.RestartAfterLevel)
                {
                    level.RestartCurrentNumber();
                }
            }
        }
    }
}
