﻿using System;

namespace Telerik.Windows.Documents.Fixed.Model.Editing.Lists
{
    /// <summary>
    /// Represents the paragraph properties of a list level.
    /// </summary>
    public class ParagraphProperties : PropertiesBase<ParagraphProperties>
    {
        /// <summary>
        /// Gets or sets the first line indent.
        /// </summary>
        /// <value>The first line indent.</value>
        public double FirstLineIndent { get; set; }

        /// <summary>
        /// Gets or sets the left indent.
        /// </summary>
        /// <value>The left indent.</value>
        public double LeftIndent { get; set; }

        /// <summary>
        /// Copies the text properties from other instance.
        /// </summary>
        /// <param name="other">The other properties.</param>
        public override void CopyFrom(ParagraphProperties other)
        {
            this.FirstLineIndent = other.FirstLineIndent;
            this.LeftIndent = other.LeftIndent;
        }
    }
}
