﻿using System;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
#endif
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Model.Editing.Tables
{
    /// <summary>
    /// Represents the properties of a cell.
    /// </summary>
    public class CellProperties
    {
        private TableCellBorders borders;

        /// <summary>
        /// Initializes a new instance of the <see cref="CellProperties" /> class.
        /// </summary>
        public CellProperties()
        {
            this.Borders = new TableCellBorders();
            this.Padding = new Thickness();
            this.Background = null;
        }

        /// <summary>
        /// Gets the borders.
        /// </summary>
        /// <value>The borders.</value>
        public TableCellBorders Borders
        {
            get
            {
                return this.borders;
            }
            set
            {
                Guard.ThrowExceptionIfNull(value, "value");

                this.borders = value;
            }
        }

        /// <summary>
        /// Gets or sets the padding.
        /// </summary>
        /// <value>The padding.</value>
        public Thickness Padding { get; set; }

        /// <summary>
        /// Gets or sets the background.
        /// </summary>
        /// <value>The background.</value>
        public ColorBase Background { get; set; }
    }
}
