﻿using System.Linq;
#if !NETSTANDARD
using System.Windows;
#else
using Telerik.Documents.Primitives;
#endif
using Telerik.Windows.Documents.Fixed.Model.Annotations;
using Telerik.Windows.Documents.Fixed.Model.Collections;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Model.Extensions
{
    internal static class AnnotationExtentions
    {
        internal static bool TryGetAnnotationFromLocation(this AnnotationCollection annotations, Point location, out Annotation annotation)
        {
            annotation = null;
            bool result = false;

            for (int i = annotations.Count - 1; i >= 0; i--)
            {
                Annotation currentAnnotation = annotations[i];
                Guard.ThrowExceptionIfNull(currentAnnotation.BoundingRect, "annot");

                Rect boundingRect = currentAnnotation.BoundingRect.Value;

                if (boundingRect.Contains(location))
                {
                    annotation = currentAnnotation;
                    result = true;
                    break;
                }
            }

            return result;
        }
    }
}
