﻿using System;
using System.Linq;
#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;

namespace Telerik.Windows.Documents.Fixed.Model.Extensions
{
    /// <summary>
    /// Extensions for creating color objects.
    /// </summary>
    public static class ColorExtensions
    {
        /// <summary>
        /// Converts the Color to ColorBase that is usend in RadPdfProcessing.
        /// </summary>
        /// <param name="color">The color.</param>
        /// <returns></returns>
        public static ColorBase ToColor(this Color color)
        {
            return new RgbColor(color.A, color.R, color.G, color.B);
        }
    }
}
