﻿using System;
using Telerik.Windows.Documents.Core.Fonts;
using Telerik.Windows.Documents.Core.Fonts.Type1.CFFFormat;
using Telerik.Windows.Documents.Fixed.Model.Data;

namespace Telerik.Windows.Documents.Fixed.Model.Fonts
{
    internal class CidType0Font : CidFontBase
    {
        public CidType0Font(string name, FontSource fontSource)
            : base(name, fontSource)
        {
        }

        internal override FontType Type
        {
            get
            {
                return FontType.CidType0Font;
            }
        }

        internal static void InitializeCoreGlyph(Core.Fonts.Glyphs.Glyph g, CFFFontSource fontSource, int charCode)
        {
            if (fontSource.UsesCIDFontOperators)
            {
                ushort glyphId;
                fontSource.TryGetGlyphId((ushort)charCode, out glyphId);
                g.GlyphId = glyphId;
            }
            else
            {
                g.GlyphId = (ushort)charCode;
            }
        }

        internal override void InitializeCoreGlyph(Core.Fonts.Glyphs.Glyph glyphInfo, CharCode charcode)
        {
            CFFFontSource cff = this.ActualFontSource as CFFFontSource;

            if (cff != null)
            {
                InitializeCoreGlyph(glyphInfo, cff, charcode.Code);
            }
        }
    }
}
