﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts;
using Telerik.Windows.Documents.Core.Fonts.OpenType;
using Telerik.Windows.Documents.Fixed.Model.Data;
using Telerik.Windows.Documents.Fixed.Model.Fonts.Encoding;
using Telerik.Windows.Documents.Fixed.Model.Text;

namespace Telerik.Windows.Documents.Fixed.Model.Fonts
{
    internal partial class CidType2Font : CidFontBase
    {
        public CidType2Font(string name, FontSource fontSource)
            : base(name, fontSource)
        {
        }

        internal override FontType Type
        {
            get
            {
                return FontType.CidType2Font;
            }
        }

        internal override IEnumerable<CharInfo> CalculateCharacters(string text)
        {
            foreach (char ch in text)
            {
                ushort glyphId;
                if (this.TryGetGlyphId(ch, out glyphId))
                {
                    yield return new CharInfo(ch.ToString(), new CharCode(glyphId));
                }
            }
        }

        internal static void InitializeCoreGlyph(Core.Fonts.Glyphs.Glyph g, ICidToGidMap mapping, int charCode)
        {
            if (mapping != null)
            {
                g.GlyphId = mapping.GetGlyphId(charCode);
            }
            else
            {
                g.GlyphId = (ushort)charCode;
            }
        }

        internal override void InitializeCoreGlyph(Core.Fonts.Glyphs.Glyph glyphInfo, CharCode charcode)
        {
            InitializeCoreGlyph(glyphInfo, this.CharIdToGlyphIdMapping.Value, charcode.Code);
        }
    }
}