﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace Telerik.Windows.Documents.Fixed.Model.Fonts
{
    internal class CidWidths<T> : IEnumerable, IEnumerable<CidWidthsRange<T>>
    {
        private readonly List<CidWidthsRange<T>> ranges;

        public CidWidths()
        {
            this.ranges = new List<CidWidthsRange<T>>();
        }

        public void Add(CidWidthsRange<T> range)
        {
            this.ranges.Add(range);
        }

        public IEnumerator<CidWidthsRange<T>> GetEnumerator()
        {
            foreach (CidWidthsRange<T> range in this.ranges)
            {
                yield return range;
            }
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            foreach (CidWidthsRange<T> range in this.ranges)
            {
                yield return range;
            }
        }
    }
}
