﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.Model.Data;

namespace Telerik.Windows.Documents.Fixed.Model.Fonts.Encoding
{
    internal class CharCodeRange : IComparable<CharCodeRange>
    {
        private readonly bool isSequential;
        private readonly CharCode start;
        private readonly CharCode end;
        private readonly List<string> unicodes;

        public CharCodeRange(CharCode start, CharCode end, List<string> unicodes = null, bool isSequential = false)
        {
            this.isSequential = isSequential;
            this.start = start;
            this.end = end;
            this.unicodes = unicodes;
        }

        public bool IsSequential
        {
            get
            {
                return this.isSequential;
            }
        }

        internal CharCode Start
        {
            get
            {
                return this.start;
            }
        }

        internal CharCode End
        {
            get
            {
                return this.end;
            }
        }

        public List<string> Unicodes
        {
            get
            {
                return this.unicodes;
            }
        }

        public int CompareTo(CharCodeRange other)
        {
            int result;

            if (this.Start.Code > other.End.Code)
            {
                result = 1;
            }
            else if (this.End.Code < other.Start.Code)
            {
                result = -1;
            }
            else
            {
                result = 0;
            }

            return result;
        }
    }
}
