﻿using System;

namespace Telerik.Windows.Documents.Fixed.Model.Fonts.Encoding
{
    internal class CidSystemInfo
    {
        private static readonly CidSystemInfo defaultValue;
        private readonly string registry;
        private readonly string ordering;
        private readonly int supplement;

        static CidSystemInfo()
        {
            CidSystemInfo.defaultValue = new CidSystemInfo("Adobe", "Identity", 0);
        }

        public CidSystemInfo(string registry, string ordering, int supplement)
        {
            this.registry = registry;
            this.ordering = ordering;
            this.supplement = supplement;
        }

        public static CidSystemInfo Default
        {
            get
            {
                return CidSystemInfo.defaultValue;
            }
        }

        public string Registry
        {
            get
            {
                return this.registry;
            }
        }

        public string Ordering
        {
            get
            {
                return this.ordering;
            }
        }

        public int Supplement
        {
            get
            {
                return this.supplement;
            }
        }
    }
}
