﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Data;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Model.Fonts.Encoding
{
    internal class CidToGidMap : ICidToGidMap
    {
        private readonly byte[] data;

        public CidToGidMap()
        {
            this.data = null;
        }

        public CidToGidMap(byte[] data)
        {
            this.data = data;
        }

        public bool IsIdentityMapping
        {
            get
            {
                return this.data == null;
            }
        }

        public byte[] Data
        {
            get
            {
                return this.data;
            }
        }

        public ushort GetGlyphId(int charCode)
        {
            if (this.IsIdentityMapping)
            {
                return (ushort)charCode;
            }
            else
            {
                return BitConverter.ToUInt16(this.data, 2 * charCode);
            }
        }
    }
}
