﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace Telerik.Windows.Documents.Fixed.Model.Fonts.Encoding
{
    internal class DifferencesRanges : IEnumerable, IEnumerable<DifferencesRange>
    {      
        private readonly List<DifferencesRange> ranges;

        public DifferencesRanges()
        {
            this.ranges = new List<DifferencesRange>();
        }

        public DifferencesRange AddDifferencesRange(byte startCharCode)
        {
            DifferencesRange range = new DifferencesRange(startCharCode);
            this.ranges.Add(range);

            return range;
        }

        public IEnumerator GetEnumerator()
        {
            foreach (DifferencesRange range in this.ranges)
            {
                yield return range;
            }
        }

        IEnumerator<DifferencesRange> IEnumerable<DifferencesRange>.GetEnumerator()
        {
            foreach (DifferencesRange range in this.ranges)
            {
                yield return range;
            }
        }
    }
}
