﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Common;

namespace Telerik.Windows.Documents.Fixed.Model.Fonts
{
    internal class FontFileInfo
    {
        private readonly PdfProperty<FontFileType> fileType;
        private readonly PdfProperty<FontFileSubType> fileSubType;
        private readonly PdfProperty<int> length1;
        private readonly PdfProperty<int> length2;
        private readonly PdfProperty<int> length3;
        private readonly PdfProperty<byte[]> metadata;

        public FontFileInfo()
        {
            this.fileType = new PdfProperty<FontFileType>();
            this.fileSubType = new PdfProperty<FontFileSubType>();
            this.length1 = new PdfProperty<int>();
            this.length2 = new PdfProperty<int>();
            this.length3 = new PdfProperty<int>();
            this.metadata = new PdfProperty<byte[]>();
        }

        internal PdfProperty<FontFileType> FileType
        {
            get
            {
                return this.fileType;
            }
        }

        internal PdfProperty<FontFileSubType> FileSubType
        {
            get
            {
                return this.fileSubType;
            }
        }

        internal PdfProperty<int> Length1
        {
            get
            {
                return this.length1;
            }
        }

        internal PdfProperty<int> Length2
        {
            get
            {
                return this.length2;
            }
        }

        internal PdfProperty<int> Length3
        {
            get
            {
                return this.length3;
            }
        }

        internal PdfProperty<byte[]> Metadata
        {
            get
            {
                return this.metadata;
            }
        }
    }
}
