﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.Type1.Type1Format;

namespace Telerik.Windows.Documents.Fixed.Model.Fonts
{
    internal class StandardFont : Type1Font
    {
        private readonly double lineGap;
        private readonly bool isBold;

        public StandardFont(string name, double ascent, double descent, double lineGap, bool isBold, bool isItalic, Type1FontSource fontSource)
            : base(name, fontSource)
        {
            this.Ascent.SetDefaultValueFunc(() => (ascent / FontBase.FontRatio));
            this.Descent.SetDefaultValueFunc(() => (descent / FontBase.FontRatio));
            this.lineGap = lineGap / FontBase.FontRatio;
            this.isBold = isBold;
            this.IsItalic = isItalic;
        }

        internal override FontType Type
        {
            get
            {
                return FontType.Standard;
            }
        }

        internal override double LineGap
        {
            get
            {
                return this.lineGap;
            }
        }

        internal override bool IsBold
        {
            get
            {
                return this.isBold;
            }
        }
    }
}
