﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Fixed.Model.Common;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#endif

namespace Telerik.Windows.Documents.Fixed.Model.Graphics
{
    /// <summary>
    /// Represents base class for geometry objects.
    /// </summary>
    public abstract class GeometryBase  
    {
        internal GeometryBase()
        {
        }

        /// <summary>
        /// Gets the bounds of the geometry.
        /// </summary>
        /// <value>The bounds.</value>
        public Rect Bounds
        {
            get
            {
                return this.GetBounds();
            }
        }

        /// <summary>
        /// Gets the geometry bounds.
        /// </summary>
        /// <returns></returns>
        protected abstract Rect GetBounds();
    }
}
