﻿using System;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
using System.Windows.Media;
#endif

namespace Telerik.Windows.Documents.Fixed.Model.Graphics
{
    internal static class GeometryExtensions
    {
        public static PathGeometry TransformRectangle(this Matrix matrix, Rect rectangle)
        {
            Point topLeft = matrix.Transform(new Point(rectangle.Left, rectangle.Top));
            Point topRight = matrix.Transform(new Point(rectangle.Right, rectangle.Top));
            Point bottomRight = matrix.Transform(new Point(rectangle.Right, rectangle.Bottom));
            Point bottomLeft = matrix.Transform(new Point(rectangle.Left, rectangle.Bottom));

            var path = new PathGeometry();
            var figure = path.Figures.AddPathFigure();
            figure.IsClosed = true;

            figure.StartPoint = topLeft;
            figure.Segments.AddLineSegment().Point = topRight;
            figure.Segments.AddLineSegment().Point = bottomRight;
            figure.Segments.AddLineSegment().Point = bottomLeft;

            return path;
        }
    }
}
