﻿using System;
using System.Linq;
using System.Windows;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#endif

namespace Telerik.Windows.Documents.Fixed.Model.Graphics
{
    /// <summary>
    /// Represents rectangle geometry.
    /// </summary>
    public class RectangleGeometry : GeometryBase
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RectangleGeometry" /> class.
        /// </summary>
        public RectangleGeometry()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RectangleGeometry" /> class.
        /// </summary>
        /// <param name="rect">The rect.</param>
        public RectangleGeometry(Rect rect)
        {
            this.Rect = rect;
        }

        /// <summary>
        /// Gets or sets the rect.
        /// </summary>
        /// <value>The rect.</value>
        public Rect Rect { get; set; }

        /// <summary>
        /// Gets the geometry bounds.
        /// </summary>
        /// <returns></returns>
        protected override Rect GetBounds()
        {
            return this.Rect;
        }
    }
}
