﻿using System;

namespace Telerik.Windows.Documents.Fixed.Model.InteractiveForms
{
    /// <summary>
    /// Represents an interactive form instance specific for each <see cref="RadFixedDocument"/> instance.
    /// </summary>
    public class AcroForm
    {
        private readonly FormFieldCollection fields;

        internal AcroForm()
        {
            this.fields = new FormFieldCollection();
        }

        /// <summary>
        /// Represents the form fields
        /// </summary>
        public FormFieldCollection FormFields
        {
            get
            {
                return this.fields;
            }
        }

        /// <summary>
        /// Gets or sets boolean value indicating whether the Widget appearances should be recalculated before visualizing them in a PDF viewer.
        /// If true then the PDF viewers should dynamically reconstruct all widgets content based on widget text properties and appearance characteristics.
        /// </summary>
        public bool ViewersShouldRecalculateWidgetAppearances { get; set; }
    }
}
