﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Annotations;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;

namespace Telerik.Windows.Documents.Fixed.Model.InteractiveForms
{
    /// <summary>
    /// Represents the widgets collection of a <see cref="RadioButtonField"/>.
    /// </summary>
    public class RadioButtonWidgetCollection : WidgetCollectionBase<RadioButtonWidget>
    {
        internal RadioButtonWidgetCollection(IWidgetCreator<RadioButtonWidget> creator)
            : base(creator)
        {
        }

        /// <summary>
        /// Adds option in the collection.
        /// </summary>
        /// <param name="option">The option.</param>
        /// <returns></returns>
        public RadioButtonWidget AddWidget(RadioOption option)
        {
            RadioButtonWidget widget = this.AddEmptyWidget();
            widget.Option = option;
            widget.Border = new AnnotationBorder(FixedDocumentDefaults.ButtonWidgetBorderThickness, AnnotationBorderStyle.Inset, null);
            widget.AppearanceCharacteristics.BorderColor = RgbColors.Black;
            widget.AppearanceCharacteristics.Background = RgbColors.White;
            widget.AppearanceCharacteristics.NormalCaption = TwoStatesButtonTemplateCaptions.Circle;

            return widget;
        }
    }
}
