﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Annotations;

namespace Telerik.Windows.Documents.Fixed.Model.InteractiveForms
{
    /// <summary>
    /// Represents a collection of widgets.
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public class WidgetCollection<T> : WidgetCollectionBase<T>
        where T : Widget
    {
        private readonly Action<T> initializeVariableContentProperties;

        internal WidgetCollection(IWidgetCreator<T> creator, Action<T> variableContentPropertiesInitializer)
            : base(creator)
        {
            this.initializeVariableContentProperties = variableContentPropertiesInitializer;
        }

        /// <summary>
        /// Creates and adds a Widget in the collection. 
        /// </summary>
        /// <returns>The created widget.</returns>
        public T AddWidget()
        {
            T widget = this.AddEmptyWidget();
            this.initializeVariableContentProperties(widget);

            return widget;
        }
    }
}
