﻿using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Fixed.Model.Internal.Classes;
using Telerik.Windows.Documents.Core.Data;

namespace Telerik.Windows.Documents.Fixed.Model.Internal.Collections
{
    internal class ContentCollection : List<IContentElement>
	{
        private int currentZIndex;

        public ContentCollection()
        {
            this.currentZIndex = 0;
        }

        public void AddChild(IContentElement child)
        {
            Guard.ThrowExceptionIfNull(child, "child");

            child.ZIndex = currentZIndex++;
            this.Add(child);
        }

        public IEnumerable<GlyphOld> GetAllNonWhiteSpaceGlyphs()
        {
            return Enumerable.Where(FormatProviders.Old.Pdf.Utils.Extensions.EnumerateChildrenOfType<GlyphOld>(this), g => !Telerik.Windows.Documents.Utilities.Extensions.IsNullEmptyOrWhiteSpace(g.ToUnicode));
        }

        public IEnumerable<GlyphOld> GetAllGlyphs()
        {
            return FormatProviders.Old.Pdf.Utils.Extensions.EnumerateChildrenOfType<GlyphOld>(this);
        }

        public IEnumerable<GlyphsLayoutBox> GetAllGlyphLayoutBoxes()
        {
            return FormatProviders.Old.Pdf.Utils.Extensions.EnumerateChildrenOfType<GlyphsLayoutBox>(this);
        }

        public void Arrange(Matrix matrix)
        {
            foreach (ContentElement ce in this)
            {
                ce.Arrange(matrix);
            }
        }
    }
}