﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Core.PostScript.Data;
using Telerik.Windows.Documents.Core.Shapes;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;
using Telerik.Windows.Documents.Fixed.Model.Internal.Classes;
using FontStyle = System.Windows.FontStyle;
using FontWeight = System.Windows.FontWeight;
using Point = System.Windows.Point;
using Rect = System.Windows.Rect;
using Size = System.Windows.Size;

namespace Telerik.Windows.Documents.Fixed.Model.Internal
{
    internal class GlyphOld : Core.Fonts.Glyphs.Glyph, IContentElement
    {
        private GlyphInfo glyphInfo;

        public GlyphOld(GlyphInfo glyphInfo)
        {
            this.TransformMatrix = Matrix.Identity;
            this.glyphInfo = glyphInfo;
        }

        public GlyphOld() : this(new GlyphInfo())
        {
        }

        public GlyphInfo GlyphInfo
        {
            get
            {
                return this.glyphInfo;
            }
        }

        public ResourceKey Key
        {
            get
            {
                return this.glyphInfo.Key;
            }
            set
            {
                this.glyphInfo.Key = value;
            }
        }

        public CharCodeOld CharId
        {
            get
            {
                return this.glyphInfo.CharId;
            }
            set
            {
                this.glyphInfo.CharId = value;
            }
        }

        public string ToUnicode
        {
            get
            {
                return this.glyphInfo.ToUnicode;
            }
            set
            {
                this.glyphInfo.ToUnicode = value;
            }
        }

        public string FontFamily
        {
            get
            {
                return this.glyphInfo.FontFamily;
            }
            set
            {
                this.glyphInfo.FontFamily = value;
            }
        }

        public FontStyle FontStyle
        {
            get
            {
                return this.glyphInfo.FontStyle;
            }
            set
            {
                this.glyphInfo.FontStyle = value;
            }
        }

        public FontWeight FontWeight
        {
            get
            {
                return this.glyphInfo.FontWeight;
            }
            set
            {
                this.glyphInfo.FontWeight = value;
            }
        }

        public bool IsBold
        {
            get
            {
                return this.glyphInfo.IsBold;
            }
            set
            {
                this.glyphInfo.IsBold = value;
            }
        }

        public bool IsItalic
        {
            get
            {
                return this.glyphInfo.IsItalic;
            }
            set
            {
                this.glyphInfo.IsItalic = value;
            }
        }

        public double FontSize
        {
            get
            {
                return this.glyphInfo.FontSize;
            }
            set
            {
                this.glyphInfo.FontSize = value;
            }
        }

        public double Rise
        {
            get
            {
                return this.glyphInfo.Rise;
            }
            set
            {
                this.glyphInfo.Rise = value;
            }
        }

        public double CharSpacing
        {
            get
            {
                return this.glyphInfo.CharSpacing;
            }
            set
            {
                this.glyphInfo.CharSpacing = value;
            }
        }

        public double WordSpacing
        {
            get
            {
                return this.glyphInfo.WordSpacing;
            }
            set
            {
                this.glyphInfo.WordSpacing = value;
            }
        }

        public double HorizontalScaling
        {
            get
            {
                return this.glyphInfo.HorizontalScaling;
            }
            set
            {
                this.glyphInfo.HorizontalScaling = value;
            }
        }

        public double Width
        {
            get
            {
                return this.glyphInfo.Width;
            }
            set
            {
                this.glyphInfo.Width = value;
            }
        }

        public double Ascent
        {
            get
            {
                return this.glyphInfo.Ascent;
            }
            set
            {
                this.glyphInfo.Ascent = value;
            }
        }

        public double Descent
        {
            get
            {
                return this.glyphInfo.Descent;
            }
            set
            {
                this.glyphInfo.Descent = value;
            }
        }

        public Brush Fill
        {
            get
            {
                return this.glyphInfo.Fill;
            }
            set
            {
                this.glyphInfo.Fill = value;
            }
        }

        public Brush Stroke
        {
            get
            {
                return this.glyphInfo.Stroke;
            }
            set
            {
                this.glyphInfo.Stroke = value;
            }
        }

        public bool IsFilled
        {
            get
            {
                return this.glyphInfo.IsFilled;
            }
            set
            {
                this.glyphInfo.IsFilled = value;
            }
        }

        public bool IsStroked
        {
            get
            {
                return this.glyphInfo.IsStroked;
            }
            set
            {
                this.glyphInfo.IsStroked = value;
            }
        }

        public IEnumerable<ContentElement> Contents
        {
            get;
            set;
        }

        public Matrix TransformMatrix
        {
            get;
            set;
        }

        public Size Size
        {
            get
            {
                return this.glyphInfo.Size;
            }
            set
            {
                this.glyphInfo.Size = value;
            }
        }

        public Rect BoundingRect
        {
            get;
            set;
        }

        public bool IsSpace
        {
            get
            {
                return this.glyphInfo.IsSpace;
            }
        }

        public int ZIndex
        {
            get;
            set;
        }

        public PathGeometry Clip
        {
            get;
            set;
        }

        public bool HasChildren
        {
            get { return false; }
        }

        public IEnumerable<IContentElement> Children
        {
            get { return null; }
        }

        public double StrokeThickness
        {
            get
            {
                return this.glyphInfo.StrokeThickness;
            }
            set
            {
                this.glyphInfo.StrokeThickness = value;
            }
        }

        public double ScaledStrokeThickness
        {
            get
            {
                return this.glyphInfo.ScaledStrokeThickness;
            }
        }

        public ContentElementTypeOld Type
        {
            get { return ContentElementTypeOld.Glyph; }
        }

        public double TextTranslation
        {
            get
            {
                return this.glyphInfo.TextTranslation;
            }
            set
            {
                this.glyphInfo.TextTranslation = value;
            }
        }

        public IContentElement Clone()
        {
            GlyphInfo glyphInfo = this.GlyphInfo.Clone();
            GlyphOld glyph = new GlyphOld(glyphInfo);

            glyph.Name = this.Name;
            glyph.TransformMatrix = this.TransformMatrix;
            glyph.ZIndex = this.ZIndex;
            glyph.GlyphId = this.GlyphId;

            if (this.Outlines != null)
            {
                glyph.Outlines = this.Outlines.Clone();
            }

            return glyph;
        }

        public Rect Arrange(Matrix transformMatrix)
        {
            this.BoundingRect = Helper.GetBoundingRect(new Rect(new Point(0, 0), new Size(this.Width, Math.Max(1, (this.Ascent - (2 * this.Descent)) / 1000))), this.TransformMatrix * transformMatrix);
            if (this.Contents != null)
            {
                foreach (ContentElement ce in this.Contents)
                {
                    ce.Arrange(transformMatrix * this.TransformMatrix);
                }
            }

            return this.BoundingRect;
        }

        public void FreezeGlyphInfo()
        {
            // Freezing glyph info was meaningful when we were using GlyphInfoFactory. 
            // However, this factory leads to both performance and memory leak issues and it is deleted with the changeset which adds this comment.
            // The whole GlyphInfo and Freeze concept needs rethinking and refactoring which is logged in Teampulse as 239377 and in TFS as 284981.

            if (!this.GlyphInfo.IsFrozen)
            {
                this.GlyphInfo.Freeze();
            }
        }

        public override string ToString()
        {
            return this.ToUnicode;
        }
    }
}
