﻿using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Core.Imaging;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;
using Telerik.Windows.Documents.Fixed.Model.Internal.Classes;
using Point = System.Windows.Point;
using Rect = System.Windows.Rect;
using Size = System.Windows.Size;

namespace Telerik.Windows.Documents.Fixed.Model.Internal
{
    internal class Image : ContentElement
    {
        public override ContentElementTypeOld Type
        {
            get { return ContentElementTypeOld.Image; }
        }

        public ImageResourceKey ImageSourceKey
        {
            get;
            set;
        }

        public override Rect Arrange(Matrix transformMatrix)
        {
            this.BoundingRect = Helper.GetBoundingRect(new Rect(new Point(0, 0), new Size(1, 1)), this.TransformMatrix * transformMatrix);
            return this.BoundingRect;
        }

        public override IContentElement Clone()
        {
            Image i = new Image();
            i.ImageSourceKey = this.ImageSourceKey;
            i.Size = this.Size;
            i.TransformMatrix = this.TransformMatrix;
            i.ZIndex = this.ZIndex;
            
            return i;
        }
    }
}
