﻿using System;
using Telerik.Windows.Documents.Core.Imaging;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Model.Internal
{
    internal class ImageResourceKey : ResourceKey
    {
        public Color? StencilColor { get; set; }

        public override bool Equals(object obj)
        {
            ImageResourceKey other = obj as ImageResourceKey;

            if (other == null)
            {
                return false;
            }

            if (this.Type == ResourceType.Local)
            {
                return base.Equals(obj);
            }
            else
            {
                return base.Equals(obj) && ObjectExtensions.EqualsOfT(this.StencilColor, other.StencilColor);
            }
        }

        public override int GetHashCode()
        {
            if (this.Type == ResourceType.Local)
            {
                return base.GetHashCode();
            }
            else
            {
                return ObjectExtensions.CombineHashCodes(base.GetHashCode(), this.StencilColor.GetHashCodeOrZero());
            }
        }
    }
}
