﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Telerik.Windows.Documents.Fixed.Model
{
    /// <summary>
    /// Represents on document exception event args.
    /// </summary>
    public class OnDocumentExceptionEventArgs : EventArgs
    {
        private readonly Exception documentException; 

        /// <summary>
        /// Initializes a new instance of the <see cref="OnDocumentExceptionEventArgs" /> class.
        /// </summary>
        /// <param name="documentException">The document exception.</param>
        public OnDocumentExceptionEventArgs(Exception documentException)
        {
            this.documentException = documentException;
            this.Handle = true;
        }

        /// <summary>
        /// Gets the document exception.
        /// </summary>
        /// <value>The document exception.</value>
        public Exception DocumentException 
        {
            get
            {
                return this.documentException;
            }
        }

        /// <summary>
        /// Defines if the exception should be handled.
        /// </summary>
        /// <value>True by default.</value>
        public bool Handle { get; set; }
    }
}
