﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Core.Shapes;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.Utils;
using Telerik.Windows.Documents.Fixed.Model.Internal.Classes;
using Rect = System.Windows.Rect;

namespace Telerik.Windows.Documents.Fixed.Model.Internal
{
    internal class Path : ContentElement
    {
        public Path()
        {
        }

		public PathGeometry Data
		{
			get;
			set;
		}

		public Brush Fill
		{
			get;
			set;
		}

		public double StrokeThickness
		{
			get;
			set;
		}

		public PenLineCap StrokeStartLineCap
		{
			get;
			set;
		}

		public PenLineCap StrokeEndLineCap
		{
			get;
			set;
		}

		public PenLineJoin StrokeLineJoin
		{
			get;
			set;
		}

		public double StrokeMiterLimit
		{
			get;
			set;
		}

		public double StrokeDashOffset
		{
			get;
			set;
		}

		public IEnumerable<double> StrokeDashArray
		{
			get;
			set;
		}
		
		public Brush Stroke
		{
			get;
			set;
        }

        public override ContentElementTypeOld Type
        {
            get { return ContentElementTypeOld.Path; }
        }

        public override IContentElement Clone()
        {
            Path p = new Path();
            p.Fill = this.Fill;
            p.Size = this.Size;
            p.Stroke = this.Stroke;
            p.StrokeDashOffset = this.StrokeDashOffset;
            p.StrokeEndLineCap = this.StrokeEndLineCap;
            p.StrokeLineJoin = this.StrokeLineJoin;
            p.StrokeMiterLimit = this.StrokeMiterLimit;
            p.StrokeStartLineCap = this.StrokeStartLineCap;
            p.StrokeThickness = this.StrokeThickness;
            p.TransformMatrix = this.TransformMatrix;
            p.ZIndex = this.ZIndex;
            if (this.Data != null)
            {
                p.Data = this.Data.Clone();
            }
           
            if (this.StrokeDashArray != null)
            {
                p.StrokeDashArray = (double[])Enumerable.ToArray(this.StrokeDashArray).Clone();
            }

            return p;
        }

        public override Rect Arrange(Matrix transformMatrix)
        {
            this.BoundingRect = Helper.GetBoundingRect(this.Data.GetBoundingRect(), this.TransformMatrix * transformMatrix);
          
            return this.BoundingRect;
        }
    }
}
