﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;

namespace Telerik.Windows.Documents.Fixed.Model.Internal
{
    internal abstract class PatternBrush : Brush, IPatternColor
    {
        private readonly Matrix transform;
        
        public PatternBrush(Matrix transform)
        {
            this.transform = transform;
        }

        public Matrix Transform
        {
            get
            {
                return this.transform;
            }
        }

        System.Windows.Media.Matrix IPatternColor.Position
        {
            get
            {
                return this.Transform.ToMatrix();
            }
        }
    }
}
