﻿using System;
using System.Windows;
using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Core.Imaging;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;

namespace Telerik.Windows.Documents.Fixed.Model.Internal
{
    internal class RadialGradientBrush : GradientBrush, IRadialGradient
    {
        private readonly double r1;
        private readonly double r2;

        public RadialGradientBrush(Color startColor, Color endColor, Point startPoint, Point endPoint, double r1, double r2, bool extendBefore, bool extendAfter, Color? background, Matrix transform, Rect? boundingBox)
            : base(startColor, endColor, startPoint, endPoint, extendBefore, extendAfter, background, transform, boundingBox)
        {
            this.r1 = r1;
            this.r2 = r2;
        }

        public double Radius1
        {
            get
            {
                return this.r1;
            }
        }

        public double Radius2
        {
            get
            {
                return this.r2;
            }
        }
        
        double IRadialGradient.StartRadius
        {
            get
            {
                return this.Radius1;
            }
        }

        double IRadialGradient.EndRadius
        {
            get
            {
                return this.Radius2;
            }
        }

        protected override GradientBrush CloneOverride()
        {
            return new RadialGradientBrush(
                this.StartColor,
                this.EndColor,
                this.StartPoint,
                this.EndPoint,
                this.Radius1,
                this.Radius2,
                this.ExtendBefore,
                this.ExtendAfter,
                this.Background,
                this.Transform,
                this.BoundingBox);
        }
    }
}
