﻿using Telerik.Windows.Documents.Core.Imaging;

namespace Telerik.Windows.Documents.Fixed.Model.Internal
{
    internal class SolidColorBrush : Brush
    {
        private readonly Color color;

        public SolidColorBrush(Color color)
        {
            this.color = color;
        }

        public Color Color
        {
            get
            {
                return this.color;
            }
        }

        public override Brush Clone()
        {
            return new SolidColorBrush(this.Color);
        }

        public override bool Equals(object obj)
        {
            SolidColorBrush other = obj as SolidColorBrush;
            if (other == null)
            {
                return false;
            }

            return this.Color.Equals(other.Color);
        }

        public override int GetHashCode()
        {
            unchecked
            {
                // 17 * 23 = 391
                int result = 391 + this.Color.GetHashCode();

                return result;
            }
        }
    }
}
