﻿using System;
using System.Linq;
using System.Windows.Media;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Model.Internal
{
    internal class TransformBrush
    {
        internal TransformBrush(Brush brush)
            : this(brush, Matrix.Identity)
        {
        }

        internal TransformBrush(Brush brush, Matrix parentMatrixTransform)
        {
            Guard.ThrowExceptionIfNull(brush, "brush");

            this.Brush = brush;
            this.ParentMatrixTransform = parentMatrixTransform;
        }

        public Brush Brush { get; private set; }

        public Matrix ParentMatrixTransform { get; private set; }

        public override bool Equals(object obj)
        {
            TransformBrush other = obj as TransformBrush;

            if (other == null)
            {
                return false;
            }

            return this.Brush.Equals(other.Brush) && this.ParentMatrixTransform.Equals(other.ParentMatrixTransform);
        }

        public override int GetHashCode()
        {
            return ObjectExtensions.CombineHashCodes(this.Brush.GetHashCode(), this.ParentMatrixTransform.GetHashCode());
        }
    }
}