﻿using System;
using System.Windows;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#endif

namespace Telerik.Windows.Documents.Fixed.Model.Navigation
{
    /// <summary>
    /// Represents bounding rectangle fit.
    /// </summary>
    public class BoundingRectangleFit : Destination
    {
        /// <summary>
        /// Gets or sets the type of the destination.
        /// </summary>
        /// <value>The type of the destination.</value>
        internal override DestinationType DestinationType
        {
            get { return Navigation.DestinationType.BoundingRectangleFit; }
        }

        internal override bool TryGetScaleFactor(Size viewportSize, out double scaleFactor)
        {
            // TODO: There are differences in how PageFit works and BoundingRectangle fit works!
            return PageFit.TryGetScaleFactor(this.Page, viewportSize, out scaleFactor);
        }

        internal override bool TryGetHorizontalOffsetOnPage(Size viewportSize, out double offset)
        {
            // TODO: There are differences in how PageFit works and BoundingRectangle fit works!
            return PageFit.TryGetHorizontalOffsetOnPage(out offset);
        }

        internal override bool TryGetVerticalOffsetOnPage(Size viewportSize, out double offset)
        {
            // TODO: There are differences in how PageFit works and BoundingRectangle fit works!
            return PageFit.TryGetVerticalOffsetOnPage(out offset);
        }

        internal override Destination CreateClonedInstance()
        {
            return new BoundingRectangleFit();
        }
    }
}
