﻿using System;
using System.Windows;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#endif

namespace Telerik.Windows.Documents.Fixed.Model.Navigation
{
    /// <summary>
    /// Represents bounding rectangle horizontal fit.
    /// </summary>
    public class BoundingRectangleHorizontalFit : Destination
    {   
        /// <summary>
        /// Gets or sets the type of the destination.
        /// </summary>
        /// <value>The type of the destination.</value>
        internal override DestinationType DestinationType
        {
            get { return Navigation.DestinationType.BoundingRectangleHorizontalFit; }
        }

        /// <summary>
        /// Gets or sets the top.
        /// </summary>
        /// <value>The top.</value>
        public double? Top { get;set; }

        internal override bool TryGetScaleFactor(Size viewportSize, out double scaleFactor)
        {
            // TODO: There are differences in how PageHorizontalFit works and PageHorizontalFit fit works!
            return PageHorizontalFit.TryGetScaleFactor(this.Page, viewportSize, out scaleFactor);
        }

        internal override bool TryGetHorizontalOffsetOnPage(Size viewportSize, out double offset)
        {
            // TODO: There are differences in how PageHorizontalFit works and PageHorizontalFit fit works!
            return PageHorizontalFit.TryGetHorizontalOffsetOnPage(out offset);
        }

        internal override bool TryGetVerticalOffsetOnPage(Size viewportSize, out double offset)
        {
            // TODO: There are differences in how PageHorizontalFit works and PageHorizontalFit fit works!
            return PageHorizontalFit.TryGetVerticalOffsetOnPage(this.Top, out offset);
        }

        internal override Destination CreateClonedInstance()
        {
            return new BoundingRectangleHorizontalFit() { Top = this.Top };
        }
    }
}
