﻿using System;
using System.Windows;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#endif

namespace Telerik.Windows.Documents.Fixed.Model.Navigation
{
    /// <summary>
    /// Represents bounding rectangle vertical fit.
    /// </summary>
    public class BoundingRectangleVerticalFit : Destination
    {  
        /// <summary>
        /// Gets or sets the type of the destination.
        /// </summary>
        /// <value>The type of the destination.</value>
        internal override DestinationType DestinationType
        {
            get { return Navigation.DestinationType.BoundingRectangleVerticalFit; }
        }

        /// <summary>
        /// Gets or sets the left.
        /// </summary>
        /// <value>The left.</value>
        public double? Left { get;set; }

        internal override bool TryGetScaleFactor(Size viewportSize, out double scaleFactor)
        {
            // TODO: There are differences in how PageVerticalFit works and BoundingRectangleVerticalFit fit works!
            return PageVerticalFit.TryGetScaleFactor(this.Page, viewportSize, out scaleFactor);
        }

        internal override bool TryGetHorizontalOffsetOnPage(Size viewportSize, out double offset)
        {
            // TODO: There are differences in how PageVerticalFit works and BoundingRectangleVerticalFit fit works!
            return PageVerticalFit.TryGetHorizontalOffsetOnPage(this.Left, out offset);
        }

        internal override bool TryGetVerticalOffsetOnPage(Size viewportSize, out double offset)
        {
            // TODO: There are differences in how PageVerticalFit works and BoundingRectangleVerticalFit fit works!
            return PageVerticalFit.TryGetVerticalOffsetOnPage(out offset);
        }

        internal override Destination CreateClonedInstance()
        {
            return new BoundingRectangleVerticalFit() { Left = this.Left };
        }
    }
}
