﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Fixed.Model.Navigation
{
    /// <summary>
    /// Represents enum with all destination types.
    /// </summary>
    internal enum DestinationType
    {
        /// <summary>
        /// Represents location destination type.
        /// </summary>
        Location,

        /// <summary>
        /// Represents fit to page destination type.
        /// </summary>
        PageFit,

        /// <summary>
        /// Represents fit horizontal to page destination type.
        /// </summary>
        PageHorizontalFit,

        /// <summary>
        /// Represents fit vertical to page destination type.
        /// </summary>
        PageVerticalFit,

        /// <summary>
        /// Represents fit to rectangle destination type.
        /// </summary>
        RectangleFit,

        /// <summary>
        /// Represents fit to bounding rectangle destination type.
        /// </summary>
        BoundingRectangleFit,

        /// <summary>
        /// Represents fit horizontal to bounding rectangle destination type.
        /// </summary>
        BoundingRectangleHorizontalFit,

        /// <summary>
        /// Represents fit vertical to bounding rectangle destination type.
        /// </summary>
        BoundingRectangleVerticalFit
    }
}
 