﻿using System;
using System.Linq;
using System.Windows;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#endif

namespace Telerik.Windows.Documents.Fixed.Model.Navigation
{
    /// <summary>
    /// Represents page fit.
    /// </summary>
    public class PageFit : Destination
    {
        internal override DestinationType DestinationType
        {
            get { return Navigation.DestinationType.PageFit; }
        }

        internal override bool TryGetScaleFactor(Size viewportSize, out double scaleFactor)
        {
            return PageFit.TryGetScaleFactor(this.Page, viewportSize, out scaleFactor);
        }

        internal override bool TryGetHorizontalOffsetOnPage(Size viewportSize, out double offset)
        {
            return PageFit.TryGetHorizontalOffsetOnPage(out offset);
        }

        internal override bool TryGetVerticalOffsetOnPage(Size viewportSize, out double offset)
        {
            return PageFit.TryGetVerticalOffsetOnPage(out offset);
        }

        internal static bool TryGetScaleFactor(RadFixedPage page, Size viewportSize, out double scaleFactor)
        {
            Size scaleSize = Destination.GetScale(page.Size, viewportSize);
            scaleFactor = Math.Min(scaleSize.Width, scaleSize.Height);

            return true;
        }

        internal static bool TryGetHorizontalOffsetOnPage(out double offset)
        {
            offset = 0;
            return true;
        }

        internal static bool TryGetVerticalOffsetOnPage(out double offset)
        {
            offset = 0;
            return true;
        }

        internal override Destination CreateClonedInstance()
        {
            return new PageFit();
        }
    }
}
