﻿using Telerik.Windows.Documents.Core.Imaging;

namespace Telerik.Windows.Documents.Fixed.Model.Resources
{
    internal class GrayPixelContainer : PixelContainer
    {
        private int index;

        public override ImageDecodedDataType DataType
        {
            get
            {
                return ImageDecodedDataType.Gray;
            }
        }

        public override int PixelCount
        {
            get
            {
                return this.Array.Length;
            }
        }

        public GrayPixelContainer(int pixelCount) :
            base(pixelCount)
        {
            this.index = 0;
        }

        public override void Add(Color color)
        {
            byte grayComponent = color.GetGrayComponent();
            this.Array[this.index] = grayComponent;
            this.index++;
        }

        public override Color GetColorFromIndex(int index)
        {
            byte grayComponent = this.Array[index];
            return Color.FromGray(grayComponent);
        }

        public override void SetColorToIndex(Color color, int index)
        {
            this.Array[index] = color.GetGrayComponent();
        }
    }
}
