﻿using Telerik.Windows.Documents.Core.Imaging;

namespace Telerik.Windows.Documents.Fixed.Model.Resources
{
    internal class PixelContainer
    {
        private int[] array;
        private int index;

        public int PixelCount
        {
            get
            {
                return this.array.Length;
            }
        }

        public int[] Array
        {
            get
            {
                return this.array;
            }
        }

        public PixelContainer(int pixelCapacity)
            : this(new int[pixelCapacity])
        {
        }

        public PixelContainer(int[] array)
        {
            this.array = array;
            this.index = 0;
        }

        public void SetColorToIndex(Color color, int index)
        {
            this.array[index] = color.ToPixel();
        }

        public Color GetColorFromIndex(int index)
        {
            return Color.FromPixel(this.array[index]);
        }

        public void Add(Color color)
        {
            int pixel = color.ToPixel();
            this.Add(pixel);
        }

        private void Add(int item)
        {
            this.array[this.index] = item;
            this.index++;
        }
    }
}
