﻿using Telerik.Windows.Documents.Fixed.Model.Data;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Model.Text
{
    internal class CharInfo
    {
        private readonly string unicode;
        private readonly CharCode charCode;

        internal CharInfo(string unicode, CharCode charCode)
        {
            Guard.ThrowExceptionIfNull(charCode, "charCode");

            this.unicode = unicode;
            this.charCode = charCode;
        }

        public CharCode CharCode
        {
            get
            {
                return this.charCode;
            }
        }

        public string Unicode
        {
            get
            {
                return this.unicode;
            }
        }

        public override int GetHashCode()
        {
            return this.CharCode.Code;
        }

        public override bool Equals(object obj)
        {
            CharInfo other = obj as CharInfo;
            if (other != null)
            {
                return this.CharCode.Equals(other.CharCode) && this.Unicode == other.Unicode;
            }

            return false;
        }
    }
}
