namespace Telerik.Windows.Documents.Fixed.Model.Text
{
    /// <summary>
    /// Represents the text rendering modes.
    /// </summary>
    public enum RenderingMode
    {
        /// <summary>
        /// Represents the fill text rendering mode.
        /// </summary>
        Fill = 0,

        /// <summary>
        /// Represents the stroke text rendering mode.
        /// </summary>
        Stroke = 1,

        /// <summary>
        /// Represents the fill then stroke text rendering mode.
        /// </summary>
        FillAndStroke = 2,

        /// <summary>
        /// Represents the none text rendering mode.
        /// </summary>
        None = 3,

        /// <summary>
        /// Represents the fill then add to current clipping path text rendering mode.
        /// </summary>
        FillAndAddToClippingPath = 4,

        /// <summary>
        /// Represents the stroke then add to current clipping path text rendering mode.
        /// </summary>
        StrokeAndAddToClippingPath = 5,

        /// <summary>
        /// Represents the fill, stroke then add to current clipping path text rendering mode.
        /// </summary>
        FillStrokeAndAddToClippingPath = 6,

        /// <summary>
        /// Represents the add to clipping path text rendering mode.
        /// </summary>
        AddToClippingPath = 7
    }
}