﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.Type1.Utils;

namespace Telerik.Windows.Documents.Core.PostScript.Data
{
    internal class OperandsCollection
    {
        #region Constructors
        public OperandsCollection()
        {
            this.store = new LinkedList<object>();
        }

        #endregion


        #region Fields

        private readonly LinkedList<object> store;


        #endregion


        #region Properties

        public int Count
        {
            get
            {
                return this.store.Count;
            }
        }
        public object First
        {
            get
            {
                return Enumerable.First(this.store);
            }
        }
        public object Last
        {
            get
            {
                return Enumerable.Last(this.store);
            }
        }

        #endregion


        #region Methods

        public object GetElementAt(Origin origin, int index)
        {
            if (origin == Origin.Begin)
            {
                LinkedListNode<object> item = this.store.First;
                for (int i = 0; i < index; i++)
                {
                    item = item.Next;
                }
                return item.Value;
            }
            else
            {
                LinkedListNode<object> item = this.store.Last;
                for (int i = 0; i < index; i++)
                {
                    item = item.Previous;
                }
                return item.Value;
            }
        }

        public void AddLast(object obj)
        {
            this.store.AddLast(obj);
        }

        public void AddFirst(object obj)
        {
            this.store.AddFirst(obj);
        }

        public object GetLast()
        {
            object last = this.store.Last.Value;
            this.store.RemoveLast();
            return last;
        }

        public T GetLastAs<T>() 
        {
            T result = (T)this.GetLast();
            return result;
        }

        public T GetLastUnboxedAs<T>() 
            where T : struct
        {
            object lastValue = this.GetLast();
            T result;
            Helper.Unbox<T>(lastValue, out result);
            return result;
        }

        public int GetLastAsInt()
        {
            int res;
            Helper.UnboxInteger(this.GetLast(), out res);
            return res;
        }
         
        public double GetLastAsReal()
        {
            double res;
            Helper.UnboxReal(this.GetLast(), out res);
            return res;
        }

        public object GetFirst()
        {
            object first = this.store.First.Value;
            this.store.RemoveFirst();
            return first;
        }

        public T GetFirstAs<T>()
        {
            return (T)this.GetFirst();
        }

        public int GetFirstAsInt()
        {
            int res;
            Helper.UnboxInteger(this.GetFirst(), out res);
            return res;
        }

        public double GetFirstAsReal()
        {
            double res;
            Helper.UnboxReal(this.GetFirst(), out res);
            return res;
        }

        public void Clear()
        {
            this.store.Clear();
        }
        #endregion
    }
}
