﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.PostScript.Data
{
    internal class PostScriptString
    {
        public PostScriptString(string str)
        {
            this.value = str.ToCharArray();
        }

        public PostScriptString(int capacity)
        {
            this.value = new char[capacity];
        }

        private readonly char[] value;

        public string Value
        {
            get
            {
                return this.value.ToString();
            }
        }
        public int Capacity
        {
            get
            {
                return this.value.Length;
            }
        }

        public char this[int index]
        {
            get
            {
                return this.value[index];
            }
            set
            {
                this.value[index] = value;
            }
        }

        public byte[] ToByteArray()
        {
            byte[] res = new byte[this.value.Length];
            for (int i = 0; i < this.value.Length; i++)
            {
                res[i] = (byte)this.value[i];
            }
            return res;
        }

        public override string ToString()
        {
            return new string(this.value);
        }
    }
}
