﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Core.PostScript.Encryption
{
    internal abstract class EncryptionBase
    {
        #region Consts

        private const ushort C1 = 52845;
        private const ushort C2 = 22719;

        #endregion


        #region Constructors

        public EncryptionBase(PostScriptReader reader, ushort r, int n)
        {
            this.reader = reader;
            this.r = r;
            this.randomBytesCount = n;
        }

        #endregion


        #region Fields

        private readonly int randomBytesCount;
        private readonly PostScriptReader reader;

        private ushort r;

        #endregion


        #region Properties

        public int RandomBytesCount
        {
            get
            {
                return this.randomBytesCount;
            }
        }

        protected PostScriptReader Reader
        {
            get
            {
                return this.reader;
            }
        }

        #endregion


        #region Methods

        public abstract void Initialize();
        
        public byte Decrypt(byte cipher)
        {
            byte plain;
            plain = (byte)(cipher ^ (this.r >> 8));
            this.r = (ushort)(((cipher + r) * C1 + C2));
            return plain;
        }

        #endregion
    }
}
