﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Telerik.Windows.Documents.Core.PostScript.Encryption
{
    internal class EncryptionCollection
    {
        public EncryptionCollection()
        {
            this.store = new List<EncryptionBase>();
        }

        private readonly List<EncryptionBase> store;

        public bool HasEncryption
        {
            get
            {
                return this.store.Count != 0;
            }
        }

        public void PushEncryption(EncryptionBase encryption)
        {
            this.store.Add(encryption);
        }

        public void PopEncryption()
        {
            this.store.Remove(Enumerable.Last(this.store));
        }

        public byte Decrypt(byte b)
        {
            byte res = this.store[0].Decrypt(b);
            for (int i = 1; i < this.store.Count; i++)
            {
                EncryptionBase encr = this.store[i];
                res = encr.Decrypt(res);
            }
            return res;
        }
    }
}
