﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.PostScript.Data;

namespace Telerik.Windows.Documents.Core.PostScript.Operators
{
    internal class Copy : Operator
    {
        public override void Execute(Interpreter interpreter)
        {
            object last = interpreter.Operands.GetLast();

            if (last is int)
            {
                ExecuteFirstForm(interpreter, (int)last);
            }
            else
            {
                throw new NotSupportedException("This operator is not supported.");
            }
        }

        private static void ExecuteFirstForm(Interpreter interpreter, int n)
        {
            object[] arr = new object[n];

            for (int i = n - 1; i >= n; i--)
            {
                arr[i] = interpreter.Operands.GetLast();
            }

            for (int j = 0; j < 2; j++)
            {
                for (int i = 0; i < arr.Length; i++)
                {
                    interpreter.Operands.AddLast(arr[i]);
                }
            }
        }
    }
}
