﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.Type1.Type1Format.Dictionaries;
using Telerik.Windows.Documents.Core.PostScript.Data;

namespace Telerik.Windows.Documents.Core.PostScript.Operators
{
    internal class DefineFont : Operator
    {
        public override void Execute(Interpreter interpreter)
        {
            PostScriptDictionary dict = interpreter.Operands.GetLastAs<PostScriptDictionary>();
            object operand = interpreter.Operands.GetLast();
            string key = operand as string;

            if (key == null)
            {
                PostScriptString postScriptString = operand as PostScriptString;

                if (postScriptString == null)
                {
                    throw new InvalidOperationException(string.Format("Cannot convert key from type: {0}", operand.GetType()));
                }
                else
                {
                    key = postScriptString.Value;
                }
            }

            Type1Font font = new Type1Font();
            font.Load(dict);


            interpreter.Fonts[key] = font;
            interpreter.Operands.AddLast(font);
        }
    }
}
