﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.PostScript.Data;

namespace Telerik.Windows.Documents.Core.PostScript.Operators
{
    internal class For : Operator
    {
        public override void Execute(Interpreter interpreter)
        {
            PostScriptArray proc = interpreter.Operands.GetLastAs<PostScriptArray>();
            double limit = interpreter.Operands.GetLastAsReal();
            double increment = interpreter.Operands.GetLastAsReal();
            double initial = interpreter.Operands.GetLastAsReal();

            for (double i = initial; limit > 0 ? i < limit : i > limit; i += increment)
            {
                interpreter.Operands.AddLast(i);
                interpreter.ExecuteProcedure(proc);
            }
        }
    }
}
