﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Telerik.Windows.Documents.Core.PostScript.Operators
{
    internal abstract class GenericBinaryOperator<T1, T2, TResult> : Operator 
        where T1 : struct
        where T2 : struct
    {   
        public override void Execute(Interpreter interpreter)
        {
            T2 y = interpreter.Operands.GetLastUnboxedAs<T2>();
            T1 x = interpreter.Operands.GetLastUnboxedAs<T1>();

            TResult result = this.Execute(x, y);
            interpreter.Operands.AddLast(result); 
        }

        protected abstract TResult Execute(T1 x, T2 y);
    }
}
