﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.Type1.Utils;
using Telerik.Windows.Documents.Core.PostScript.Data;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Core.PostScript.Operators
{
    internal class Get : Operator
    {
        public override void Execute(Interpreter interpreter)
        {
            object key = interpreter.Operands.GetLast();
            object target = interpreter.Operands.GetLast();

            if (target is PostScriptArray)
            {
                PostScriptArray arr = (PostScriptArray)target;
                int index;
                Helper.UnboxInteger(key, out index);
                interpreter.Operands.AddLast(arr[index]);
            }
            else if (target is PostScriptDictionary)
            {
                PostScriptDictionary dict = (PostScriptDictionary)target;
                interpreter.Operands.AddLast(dict[(string)key]);
            }
            else if (target is PostScriptString)
            {
                PostScriptString str = (PostScriptString)target;
                int index;
                Helper.UnboxInteger(key, out index);
                interpreter.Operands.AddLast(str[index]);
            }
            else
            {
                Guard.ThrowNotSupportedException();
            }
        }
    }
}
