﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Fonts.Type1.Utils;
using Telerik.Windows.Documents.Core.PostScript.Data;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Core.PostScript.Operators
{
    internal class Put : Operator
    {
        public override void Execute(Interpreter interpreter)
        {
            object value = interpreter.Operands.GetLast();
            object key = interpreter.Operands.GetLast();
            object target = interpreter.Operands.GetLast();

            if (target is PostScriptArray)
            {
                PostScriptArray arr = (PostScriptArray)target;
                int index;
                Helper.UnboxInteger(key, out index);
                arr[index] = value;
            }
            else if (target is PostScriptDictionary)
            {
                PostScriptDictionary dict = (PostScriptDictionary)target;
                dict[(string)key] = value;
            }
            else if (target is PostScriptString)
            {
                PostScriptString str = (PostScriptString)target;
                int index;
                Helper.UnboxInteger(key, out index);
                int ch;
                Helper.UnboxInteger(value, out ch);
                str[index] = (char)ch;
            }
            else
            {
                Guard.ThrowNotSupportedException();
            }
        }
    }
}
