﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.PostScript.Encryption;

namespace Telerik.Windows.Documents.Core.PostScript.Operators
{
    internal class RD : Operator
    {
        public override void Execute(Interpreter interpreter)
        {
            interpreter.Reader.Read();

            int bytes = interpreter.Operands.GetLastAsInt();

            CharStringEncryption encrypt = new CharStringEncryption(interpreter.Reader);
            interpreter.Reader.PushEncryption(encrypt);
            encrypt.Initialize();

            interpreter.Operands.AddLast(bytes - encrypt.RandomBytesCount); 
            interpreter.ExecuteProcedure(interpreter.RD);
            interpreter.Reader.PopEncryption();
        }
    }
}
