﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Telerik.Windows.Documents.Core.PostScript.Operators
{
    internal class Roll : Operator
    {
        public override void Execute(Interpreter interpreter)
        {
            int j = interpreter.Operands.GetLastAsInt();
            int n = interpreter.Operands.GetLastAsInt();

            object[] a = new object[n];
            for (int i = 0; i < n; i++)
            {
                a[i] = interpreter.Operands.GetLast();
            }

            object[] rotated = Rotate(a, ((j % n) + n) % n);
            foreach (var obj in rotated)
            {
                interpreter.Operands.AddLast(obj);
            }
        }

        private static object[] Rotate(object[] a, int j)
        {
            int n = a.Length;
            List<object> result = new List<object>(n);
            int start = (j - 1) % n;
            for (int i = start; i >= 0 ; i--)
            {
                result.Add(a[i]);
            }

            int end = j % n;
            for (int i = n - 1; i >= end; i--)
            {
                result.Add(a[i]);
            }

            return result.ToArray();
        } 
    }
}
