﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Telerik.Windows.Documents.Core.PostScript.Operators
{
    internal abstract class UnaryOperator<T, TResult> : Operator 
        where T : struct
    {
        public override void Execute(Interpreter interpreter)
        { 
            T x = interpreter.Operands.GetLastUnboxedAs<T>();

            TResult result = this.Execute(x);
            interpreter.Operands.AddLast(result);
        }

        protected abstract TResult Execute(T x);
    }
}
