﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser.Keywords
{
    internal class IndirectObjectEndKeyword : Keyword
    {
        public override string Name
        {
            get
            {
                return PdfNames.IndirectObjectEnd;
            }
        }

        public override void Complete(PostScriptReader reader, IPdfImportContext context)
        {
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");

            IPdfPrimitive content = reader.PopToken();
            int generationNumber = ((PdfInt)reader.PopToken()).Value;
            int objectNumber = ((PdfInt)reader.PopToken()).Value;

            reader.PushToken(new IndirectObject(new IndirectReference(objectNumber, generationNumber), content));
        }
    }
}
