﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser.Keywords
{
    internal class IndirectReferenceKeyword : Keyword
    {
        public override string Name
        {
            get
            {
                return PdfNames.IndirectReferenceMarker;
            }
        }

        public override void Complete(PostScriptReader reader, IPdfImportContext context)
        {
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");

            var generationNumberToken = reader.PopToken();
            int generationNumber = ((PdfInt)generationNumberToken).Value;

            var objectNumberToken = reader.PopToken();
            int objectNumber = ((PdfInt)objectNumberToken).Value;

            IndirectReference reference = new IndirectReference(objectNumber, generationNumber);
            reader.PushToken(reference);
        }
    }
}
