﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Operators;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser.Keywords
{
    internal class OperatorKeyword : Keyword
    {
        private readonly Operator op;

        public OperatorKeyword(Operator op)
        {
            this.op = op;
        }

        public override string Name
        {
            get { return this.op.Name; }
        }

        public override void Complete(PostScriptReader parser, IPdfImportContext context)
        {
            Guard.ThrowExceptionIfNull(parser, "reader");
            Guard.ThrowExceptionIfNull(context, "context");

            parser.PushToken(this.op);
        }
    }
}
