﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Model.Data;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.PostScript.Parser.Operators
{
    internal class EndBFChar : CMapEncodingOperator
    {
        public override string Name
        {
            get
            {
                return PostScriptOperatorNames.EndBFChar;
            }
        }

        public override void Execute(ICMapEncodingInterpreter interpreter, IPdfImportContext context)
        {
            Guard.ThrowExceptionIfNull(interpreter, "interpreter");
            Guard.ThrowExceptionIfNull(context, "context");

            for (int i = 0; i < interpreter.Operands.Count; i += 2)
            {
                PdfString charCode = (PdfString)interpreter.Operands.GetElementAt(Origin.Begin, i);
                PdfString unicode = (PdfString)interpreter.Operands.GetElementAt(Origin.Begin, i + 1);

                string unicodeString = PdfString.GetUtfEncodedTextString(unicode.Value).ToString();
                interpreter.Encoding.AddUnicodeMapping(new CharCode(charCode.Value), unicodeString);
            }
        }
    }
}
