﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser.PrimitiveParsers
{
    internal class DictionaryParser
    {
        private int nestedDictionariesCounters;
        private readonly PostScriptReader parser;

        public DictionaryParser(PostScriptReader parser)
        {
            Guard.ThrowExceptionIfNull(parser, "parser");

            this.nestedDictionariesCounters = 0;
            this.parser = parser;
        }

        public void Start()
        {
            this.nestedDictionariesCounters++;
            this.parser.PushCollection();
        }

        public void End()
        {
            if (this.nestedDictionariesCounters > 0)
            {
                this.nestedDictionariesCounters--;

                Stack<IPdfPrimitive> values = this.parser.PopCollection();
                PdfDictionary result = new PdfDictionary();

                while (values.Count > 0)
                {
                    IPdfPrimitive value = values.Pop();
                    IPdfPrimitive objectKey = values.Pop();
                    PdfName key = (PdfName)objectKey;

                    result[key.Value] = value;
                }

                this.parser.PushToken(result);
            }
        }
    }
}
