﻿using System;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser.Keywords;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser.PrimitiveParsers
{
    internal class KeywordParser
    {
        private readonly PostScriptReader parser;
        private readonly StringBuilder token;
        private readonly KeywordCollection keywords;

        public KeywordParser(PostScriptReader parser, KeywordCollection keywords)
        {
            Guard.ThrowExceptionIfNull(parser, "parser");

            this.parser = parser;
            this.token = new StringBuilder();
            this.keywords = keywords;
        }

        public void Append(PostScriptReaderArgs args)
        {
            Guard.ThrowExceptionIfNull(args, "args");

            this.token.Append((char)args.Byte);
        }

        public void Complete(PostScriptReaderArgs args)
        {
            Guard.ThrowExceptionIfNull(args, "args");

            Keyword keyword;
            if (this.keywords.TryGetKeyword(this.token.ToString(), out keyword))
            {
                keyword.Complete(this.parser, args.Context);
            }

            this.token.Clear();
        }
    }
}
