﻿using System;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser.PrimitiveParsers
{
    internal class NameParser
    {
        private readonly PostScriptReader parser;
        private readonly StringBuilder token;

        public NameParser(PostScriptReader parser)
        {
            Guard.ThrowExceptionIfNull(parser, "parser");

            this.parser = parser;
            this.token = new StringBuilder();
        }

        public void Append(PostScriptReaderArgs args)
        {
            this.token.Append((char)args.Byte);
        }

        public void Complete()
        {
            string stripped = PdfNames.StripEscape(token);
            PdfName name = new PdfName(stripped);
            this.parser.PushToken(name);
            this.token.Clear();
        }
    }
}
