﻿using System.Collections.Generic;
using System.Text;

namespace Telerik.Windows.Documents.Fixed.Search
{
    internal static class WordSeparators
    {
        private static readonly char[] defaultSeparators = new char[]
            {
                '.', ',', '!', '?', ' ', ':', ';'
            };

        private static readonly List<char> wordSeparators;

        static WordSeparators()
        {
            wordSeparators = new List<char>();

            AddDefaultWordSeparators();
        }

        private static void AddDefaultWordSeparators()
        {
            foreach (char separator in defaultSeparators)
            {
                Add(separator);
            }
        }

        internal static bool IsWordSeparator(char symbol)
        {
            return wordSeparators.Contains(symbol);
        }

        internal static void Add(char separator)
        {
            wordSeparators.Add(separator);
        }

        internal static void Clear()
        {
            wordSeparators.Clear();
        }

        internal static string GetRegex()
        {
            if (wordSeparators.Count == 0)
            {
                return "";
            }

            StringBuilder result = new StringBuilder();
            result.Append("[");

            foreach (char separator in wordSeparators)
            {
                result.Append(separator);
            }

            result.Append("]");
            return result.ToString();
        }
    }
}
