﻿using System.Collections.Generic;
using System.Windows;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#endif
using Matrix = Telerik.Windows.Documents.Core.Data.Matrix;

namespace Telerik.Windows.Documents.Core.Shapes
{
    internal class PathFigure
    {
        public PathFigure()
        {
            this.Segments = new List<PathSegment>();
        }

        public List<PathSegment> Segments { get; set; }

        public bool IsClosed { get; set; }

        public bool IsFilled { get; set; }

        public Point StartPoint { get; set; }

        public PathFigure Clone()
        {
            PathFigure pf = new PathFigure();
            pf.IsClosed = this.IsClosed;
            pf.IsFilled = this.IsFilled;
            pf.StartPoint = this.StartPoint;
            foreach (PathSegment ps in this.Segments)
            {
                pf.Segments.Add(ps.Clone());
            }
            return pf;
        }

        internal void Transform(Matrix transformMatrix)
        {
            this.StartPoint = transformMatrix.Transform(this.StartPoint);
            foreach (PathSegment ps in this.Segments)
            {
                ps.Transform(transformMatrix);
            }
        }
    }
}
