﻿using System.Windows;
using Matrix = Telerik.Windows.Documents.Core.Data.Matrix;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#endif

namespace Telerik.Windows.Documents.Core.Shapes
{
    internal class QuadraticBezierSegment : PathSegment
    {
        public Point Point1 { get;set; }

        public Point Point2 { get;set; }

        public override PathSegment Clone()
        {
            return new QuadraticBezierSegment { Point1 = this.Point1, Point2 = this.Point2 };
        }

        public override void Transform(Matrix transformMatrix)
        {
            this.Point1 = transformMatrix.Transform(this.Point1);
            this.Point2 = transformMatrix.Transform(this.Point2);
        }
    }
}
