﻿#if !NETSTANDARD
using System.Windows.Media;
using Rect = System.Windows.Rect;
#else
using Telerik.Documents.Primitives;
#endif

namespace Telerik.Windows.Documents.Fixed.Text
{
    internal class Character
    {
        private readonly Rect boundingRect;
        private readonly string toUnicode;
        private readonly double charSpacing;
        private readonly Matrix textPosition;
        private readonly double fontSize;
        private readonly double textTranslation;

        public Character(Rect boundingRect, string toUnicode, double charSpacing, Matrix textPosition, double fontSize, double textTranslation)
        {
            this.boundingRect = boundingRect;
            this.toUnicode = toUnicode;
            this.charSpacing = charSpacing;
            this.textPosition = textPosition;
            this.fontSize = fontSize;
            this.textTranslation = textTranslation;
        }

        public char Char
        {
            get
            {
                return this.toUnicode[0];
            }
        }

        public Rect BoundingRect
        {
            get
            {
                return this.boundingRect;
            }
        }

        public double Height
        {
            get
            {
                return this.boundingRect.Height;
            }
        }

        public string ToUnicode
        {
            get
            {
                return this.toUnicode;
            }
        }

        public double CharSpacing
        {
            get
            {
                return this.charSpacing;
            }
        }

        public Matrix TextPosition
        {
            get
            {
                return this.textPosition;
            }
        }

        public double FontSize
        {
            get
            {
                return this.fontSize;
            }
        }

        public double TextTranslation
        {
            get
            {
                return this.textTranslation;
            }
        }

        public override string ToString()
        {
            return this.Char.ToString();
        }
    }
}
