﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.Model.Internal;
using Telerik.Windows.Documents.Fixed.Model.Internal.Collections;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Text.Internal
{
    internal class TextRecognizerOld : TextRecognizer
    {
        private readonly object lockObject = new object();

        public TextRecognizerOld(TextDocument parent) : base(parent)
        {
        }

        public TextPage CreateTextPage(RadFixedPageInternal page)
        {
            Guard.ThrowExceptionIfNull(page, "page");

            TextPage result = null;
            lock (lockObject)
            {
                // TODO Make base method private when Old model is deleted.
                this.StartNewTextPage(page.PublicPage);
                ContentCollection contentCollection = page.Content ?? page.Document.FormatProvider.ParseOnlyTextRelatedContent(page);
                IEnumerable<GlyphOld> glyphs = contentCollection.GetAllNonWhiteSpaceGlyphs();

                foreach (GlyphOld glyph in glyphs)
                {
                    Character character = new Character(
                        glyph.BoundingRect,
                        glyph.ToUnicode,
                        glyph.CharSpacing,
                        glyph.TransformMatrix.ToMatrix(),
                        glyph.FontSize,
                        glyph.TextTranslation);

                    // TODO Make base method private when Old model is deleted.
                    this.ProcessCharacter(character);
                }

                // TODO Make base method private when Old model is deleted.
                result = this.FinishCurrentTextPage();
            }

            return result;
        }

        protected override double GetScaledCharacterSpacing(Character character)
        {
            // TODO Make base method private when Old model is deleted.
            return character.CharSpacing * character.TextPosition.M11;
        }

        protected override double GetScaledTextTranslation(Character character)
        {
            // TODO Make base method private when Old model is deleted.
            return character.TextTranslation * character.TextPosition.M11;
        }
    }
}
