﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Annotations;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Utilities.Rendering.Annotations
{
    internal class AnnotationLayoutHelper
    {
        private readonly Annotation annotation;

        public AnnotationLayoutHelper(Annotation annotation)
        {
            this.annotation = annotation;
        }

        internal Rect CalculateAnnotationBoundingRectangle()
        {
            Matrix visibleContentTransformation = PageLayoutHelper.CalculateVisibibleContentTransformation((RadFixedPage)annotation.Parent);
            Rect boundingRectangle = visibleContentTransformation.Transform(this.annotation.Rect);

            return boundingRectangle;
        }
    }
}
