﻿using Telerik.Windows.Documents.Fixed.Model.Annotations;
using Telerik.Windows.Documents.Fixed.Model.Resources;

namespace Telerik.Windows.Documents.Fixed.Utilities.Rendering.Annotations
{
    internal class DefaultAppearanceProvider : BaseAppearanceProvider
    {
        internal DefaultAppearanceProvider(BaseAppearanceProvider nextProvider) : base(nextProvider)
        {
        }

        protected override bool CanProvide(Annotation annotation, AnnotationAppearanceMode annotationAppearanceMode)
        {
            return annotation != null && this.GetCurrentAnnotationAppearances(annotation) != null;
        }

        protected override FormSource ProvideAppearance(Annotation annotation, AnnotationAppearanceMode annotationAppearanceMode)
        {
            SingleStateAppearances singleStateAppearances = this.GetCurrentAnnotationAppearances(annotation);

            FormSource appearance = this.GetAppearanceFormSource(singleStateAppearances, annotationAppearanceMode);

            return appearance;
        }

        private SingleStateAppearances GetCurrentAnnotationAppearances(Annotation annotation)
        {
            SingleStateAppearances singleStateAppearances = null;

            if (annotation.Appearances is SingleStateAppearances)
            {
                singleStateAppearances = annotation.Appearances as SingleStateAppearances;
            }
            else if (annotation.Appearances is MultiStateAppearances)
            {
                MultiStateAppearances multyStateAppearances = annotation.Appearances as MultiStateAppearances;
                singleStateAppearances = multyStateAppearances[multyStateAppearances.CurrentState];
            }

            return singleStateAppearances;
        }
    }
}
