﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.Model.Common;

namespace Telerik.Windows.Documents.Fixed.Utilities.Rendering
{
    internal class ContentElementsGraphCache
    {
        private readonly Dictionary<IContentRootElement, ContentElementsGraph> rootElementToElementsGraphMapping;

        public ContentElementsGraphCache()
        {
            this.rootElementToElementsGraphMapping = new Dictionary<IContentRootElement, ContentElementsGraph>();
        }

        public ContentElementsGraph GetGraph(IContentRootElement element)
        {
            ContentElementsGraph graph;

            if (!this.rootElementToElementsGraphMapping.TryGetValue(element, out graph))
            {
                graph = new ContentElementsGraph(element);
                this.rootElementToElementsGraphMapping.Add(element, graph);
            }

            return graph;
        }

        public void Clear()
        {
            this.rootElementToElementsGraphMapping.Clear();
        }
    }
}
