﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Fixed.Model.Common;

namespace Telerik.Windows.Documents.Fixed.Utilities.Rendering
{
    internal class ContentRenderingContext : IContentRenderingContext
    {
        private readonly Matrix renderedElementMatrix;
        private readonly Rect currentContainerBounds;

        protected ContentRenderingContext(PositionContentElement renderedElement, Rect currentContainerBounds)
        {
            this.renderedElementMatrix = renderedElement.Position.Matrix;
            this.currentContainerBounds = currentContainerBounds;
        }

        Rect IContentRenderingContext.CurrentContainerBounds
        {
            get
            {
                return this.currentContainerBounds;
            }
        }

        Matrix IContentRenderingContext.RenderedElementPositionMatrix
        {
            get
            {
                return this.renderedElementMatrix;
            }
        }
    }
}
