﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
#endif
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Graphics;

namespace Telerik.Windows.Documents.Fixed.Utilities.Rendering
{
    internal class GeometryRenderingContext : ContentRenderingContext
    {
        private readonly GeometryBase geometry;
        private readonly GeometryPropertiesOwner properties;

        internal GeometryRenderingContext(Path path, Rect currentContainerBounds)
            : base(path, currentContainerBounds)
        {
            this.geometry = path.Geometry;
            this.properties = path.GeometryProperties;
        }

        /// <summary>
        /// The rendered geometry.
        /// </summary>
        public GeometryBase Geometry
        {
            get
            {
                return this.geometry;
            }
        }

        /// <summary>
        /// The geometry properties.
        /// </summary>
        public GeometryPropertiesOwner Properties
        {
            get
            {
                return this.properties;
            }
        }
    }
}
