﻿using System;
using System.IO;
using System.Linq;
using System.Reflection;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Fixed.Utilities
{
    internal static class ResourcesHelper
    {
        public static Stream GetApplicationResourceStream(string resourceName)
        {
            Guard.ThrowExceptionIfNullOrEmpty(resourceName, "resourceName");

            try
            {
                return Assembly.GetExecutingAssembly().GetManifestResourceStream(resourceName);
            }
            catch
            {
                throw new InvalidOperationException("Cannot access the resource file.");
            }
        }
    }
}
