﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model.Internal.Classes;

namespace Telerik.Windows.Documents.Fixed.Tests.CMapTests
{
    [TestClass]
    public class TestCharCode
    {
        [TestMethod]
        public void TestCharCodeIncrement()
        {
            CharCodeOld begin = new CharCodeOld((ushort)0x0000);
            CharCodeOld end = new CharCodeOld((ushort)0xFFFF);

            int expected = begin.IntValue;
            for (CharCodeOld c = begin; c < end; c++, expected++)
            {
                Assert.AreEqual(expected, c.IntValue);
            }
        }

        [TestMethod]
        [ExpectedException(typeof(OverflowException))]
        public void TestCharCodeOverflow()
        {
            CharCodeOld c = new CharCodeOld((ushort)0xFFFF);
            c++;
        }
    }
}
