﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Linq;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;
using Telerik.Windows.Documents.Fixed.Model.Graphics;
using Telerik.Windows.Documents.Fixed.Tests.Utils;

namespace Telerik.Windows.Documents.Fixed.Tests.ColorSpaces
{
    [TestClass]
    public class RgbColorSpaceTests
    {
        [TestMethod]
        public void RoundUpComponentValue_WhenTheValueUsOutOfAllowedRangeTest()
        {
            RadFixedDocument document = TestUtils.CreateFixedDocument("ColorSpaces/RGBConvertComponentTestDocument", true);
            RadFixedPage page = document.Pages.First();

            Path path = (Path)page.Content[0];

            RgbColor colorSpace = (RgbColor)path.Fill;
            Assert.AreEqual(0, colorSpace.R);
            Assert.AreEqual(255, colorSpace.G);
            Assert.AreEqual(0, colorSpace.B);
        }
    }
}
