﻿using System.IO;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Editing;
using Telerik.Windows.Documents.Fixed.Model.Editing.Flow;
using Telerik.Windows.Documents.Fixed.Model.Fonts;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using Size = System.Windows.Size;
using Rect = System.Windows.Rect;
#endif

namespace Telerik.Windows.Documents.Fixed.Tests.Editing
{
    public class TestReport
    {
        public TestReport()
        {
        }

        public Stream CreateReport(int reportId, FontBase font)
        {
            var document = new RadFixedDocument();

            for (int i = 0; i < 10; i++)
            {
                var page = new RadFixedPage();
                page.Size = new Size(1123, 794);

                var editor = new FixedContentEditor(page);

                var block = new Block();
                block.TextProperties.Font = font;

                block.VerticalAlignment = VerticalAlignment.Center;
                block.LeftIndent = 2;
                block.RightIndent = 2;
                block.TextProperties.FontSize = 12;

                block.InsertText("TestTestTestTestTestTestTest");

                var boundingRect = new Rect(200, 300, 40, 30);

                editor.Position.Translate(0, boundingRect.Y);
                editor.DrawBlock(block, new Size(boundingRect.Width, boundingRect.Height));

                document.Pages.Add(page);
            }

            var resultStream = new MemoryStream();
            var provider = new PdfFormatProvider();
            var settings = new PdfExportSettings();
            settings.ImageQuality = ImageQuality.High;
            provider.ExportSettings = settings;

            provider.Export(document, resultStream);

            resultStream.Position = 0;

            return resultStream;
        }
    }
}
