﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Editing;

namespace Telerik.Windows.Documents.Fixed.Tests.Flow
{
    [TestClass]
    public class RadFixedDocumentEditorTests
    {
        [TestMethod]
        public void TestPageSplitWhenSingleLineParagraphs()
        {
            RadFixedDocument document = new RadFixedDocument();

            using (RadFixedDocumentEditor editor = new RadFixedDocumentEditor(document))
            {
                for (int i = 0; i < 100; i++)
                {
                    editor.InsertParagraph();
                    editor.InsertRun(string.Format("test {0}", i));
                }
            }

            int expectedPages = 3;
            int actualPages = document.Pages.Count;

            Assert.AreEqual(expectedPages, actualPages);
        }
    }
}
