﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.DocumentModel.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Old.Pdf.PdfReader;

namespace Telerik.Windows.Documents.Fixed.Tests.FormatProviders.Old.Pdf.PdfReader
{
    internal class PdfContentManagerMockForIndirectReferences : PdfContentManager
    {
        private Dictionary<IndirectReferenceOld, IndirectObjectOld> cache;

        public PdfContentManagerMockForIndirectReferences()
            : base()
        {
            this.cache = new Dictionary<IndirectReferenceOld, IndirectObjectOld>();
        }

        public void RegisterMockIndirectObject(IndirectReferenceOld reference, object value)
        {
            IndirectObjectOld indirectObject = new IndirectObjectOld() { Value = value };
            this.cache.Add(reference, indirectObject);
        }

        public override bool TryReadIndirectObject(IndirectReferenceOld reference, bool isEncrypted, out IndirectObjectOld indirectObject)
        {
            if (reference == null)
            {
                indirectObject = null;
                return false;
            }

            if (!this.cache.TryGetValue(reference, out indirectObject))
            {
                return false;
            }

            return true;
        }
    }

}
