﻿using System;
using System.Collections.Generic;
#if WPF
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.DigitalSignature;
#endif
#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.DocumentStructure;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Forms;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Encryption;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;
using Telerik.Windows.Documents.Fixed.Model.Common;
using Telerik.Windows.Documents.Fixed.Model.Fonts;
using Telerik.Windows.Documents.Fixed.Model.InteractiveForms;
using Telerik.Windows.Documents.Fixed.Model.Resources;
using Telerik.Windows.Documents.Fixed.Model.Text;
using Telerik.Windows.Documents.Fixed.Model.Annotations;
using System.Linq;

namespace Telerik.Windows.Documents.Fixed.Tests.FormatProviders.Pdf.Export
{
    internal class TestPdfExportContext : IPdfExportContext
    {
        private readonly PdfExportSettings settings = new PdfExportSettings();
        private readonly Dictionary<RadFixedPage, Page> fixedPageToPage = new Dictionary<RadFixedPage, Page>();
        private readonly Dictionary<IContentRootElement, Matrix> fixedPageToMatrix = new Dictionary<IContentRootElement, Matrix>();
        private readonly Dictionary<FontBase, List<CharInfo>> fontToUsedCharacters = new Dictionary<FontBase, List<CharInfo>>();

        public TestPdfExportContext()
        {
            this.TryGetPageMethodCalledCounter = 0;
            this.GetDipToPdfPointTransformationMethodCalledCounter = 0;
        }

        public bool CanWriteColors
        {
            get
            {
                throw new NotImplementedException();
            }

            set
            {
                throw new NotImplementedException();
            }
        }

        public CrossReferenceCollection CrossReferenceCollection
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public RadFixedDocument Document { get; set; }

        public byte[] DocumentId
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public Encrypt Encryption
        {
            get
            {
                throw new NotImplementedException();
            }

            set
            {
                throw new NotImplementedException();
            }
        }

        public IEnumerable<FontBase> FontResources
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public Queue<IndirectObject> IndirectObjectsQueue
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public IEnumerable<RadFixedPage> Pages
        {
            get
            {
                throw new NotImplementedException();
            }
        }

        public PdfExportSettings Settings
        {
            get
            {
                return this.settings;
            }
        }

        public RadFixedDocumentInfo DocumentInfo { get; set; }

#if WPF
        public SignatureExportInfo SignatureExportInfo
        {
            get
            {
                throw new NotImplementedException();
            }
        }
#endif

        public IPdfContentExportContext AcroFormContentExportContext
        {
            get
            {
                throw new NotImplementedException();
            }

            set
            {
                throw new NotImplementedException();
            }
        }

        internal Dictionary<RadFixedPage, Page> FixedPageToPage
        {
            get
            {
                return this.fixedPageToPage;
            }
        }

        public Dictionary<IContentRootElement, Matrix> FixedPageToMatrix
        {
            get
            {
                return this.fixedPageToMatrix;
            }
        }

        public int TryGetPageMethodCalledCounter { get; set; }

        public int GetDipToPdfPointTransformationMethodCalledCounter { get; set; }

        internal Dictionary<FontBase, List<CharInfo>> FontToUsedCharacters
        {
            get
            {
                return this.fontToUsedCharacters;
            }
        }

        public void BeginExportIndirectObject(IndirectObject indirectObject, long offset)
        {
            throw new NotImplementedException();
        }

        public IPdfContentExportContext CreateContentExportContext(IResourceHolder resourceHolder, IContentRootElement contentRoot)
        {
            throw new NotImplementedException();
        }

        public IndirectObject CreateIndirectObject(IPdfPrimitive primitive)
        {
            throw new NotImplementedException();
        }

        public byte[] EncryptStream(byte[] data)
        {
            return data;
        }

        public byte[] EncryptString(byte[] data)
        {
            return data;
        }

        public void EndExportIndirectObject()
        {
            throw new NotImplementedException();
        }

        public Matrix GetDipToPdfPointTransformation(IContentRootElement fixedPage)
        {
            this.GetDipToPdfPointTransformationMethodCalledCounter++;

            return this.FixedPageToMatrix[fixedPage];
        }

        public bool TryGetPage(RadFixedPage fixedPage, out Page page)
        {
            this.TryGetPageMethodCalledCounter++;

            return this.FixedPageToPage.TryGetValue(fixedPage, out page);
        }

        public ResourceEntry GetResource(ExtGState state)
        {
            throw new NotImplementedException();
        }

        public ResourceEntry GetResource(FormSource form)
        {
            throw new NotImplementedException();
        }

        public ResourceEntry GetResource(Fixed.Model.Resources.ImageSource image)
        {
            throw new NotImplementedException();
        }

        public ResourceEntry GetResource(FontBase resource)
        {
            throw new NotImplementedException();
        }

        public ResourceEntry GetResource(ColorSpaceBase first, ColorSpaceBase second)
        {
            throw new NotImplementedException();
        }

        public ResourceEntry GetResource(PatternColor pattern, IPdfContentExportContext context)
        {
            throw new NotImplementedException();
        }

        public IEnumerable<CharInfo> GetUsedCharacters(FontBase font)
        {
            List<CharInfo> characters;

            if (!this.fontToUsedCharacters.TryGetValue(font, out characters))
            {
                characters = new List<CharInfo>();
            }

            return characters;
        }

        public void MapPages(RadFixedPage fixedPage, Page page)
        {
            throw new NotImplementedException();
        }

        public void SetUsedCharacters(FontBase font, TextCollection glyphs)
        {
            throw new NotImplementedException();
        }

        public void MapWidgets(Widget widgetModel, Fixed.FormatProviders.Pdf.Model.Elements.Annotations.WidgetObject widgetObject)
        {
            throw new NotImplementedException();
        }

        public bool TryGetWidget(Widget widgetModel, out Fixed.FormatProviders.Pdf.Model.Elements.Annotations.WidgetObject widgetObject)
        {
            throw new NotImplementedException();
        }

        public FormFieldNode CreateFormFieldObject(FormField field, bool includeInIndirectObjectQueue)
        {
            throw new NotImplementedException();
        }
    }
}
