﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.Model;

namespace Telerik.Windows.Documents.Fixed.Tests.FormatProviders.Pdf.Import
{
    public class TestPagesContentCache : IPagesContentCache
    {
        public TestPagesContentCache()
        {
            this.PageToCachedPageCount = new Dictionary<RadFixedPage, int>();
            this.PageToLoadedCachedPageCount = new Dictionary<RadFixedPage, int>();
            this.ClearedCount = 0;
            this.IsCached = false;
        }

        public bool IsCached { get; set; }

        public Dictionary<RadFixedPage, int> PageToCachedPageCount { get; set; }

        public Dictionary<RadFixedPage, int> PageToLoadedCachedPageCount { get; set; }

        public int ClearedCount { get; set; }

        public void CachePageContent(RadFixedPage page)
        {
            int count;
            if (!this.PageToCachedPageCount.TryGetValue(page, out count))
            {
                count = 1;
                this.PageToCachedPageCount.Add(page, count);
            }
            else
            {
                this.PageToCachedPageCount[page] = ++count;
            }
        }

        public void Clear()
        {
            this.ClearedCount++;
        }

        public bool TryLoadCachedPageContent(RadFixedPage page)
        {
            int count;
            if (!this.PageToLoadedCachedPageCount.TryGetValue(page, out count))
            {
                count = 1;
                this.PageToLoadedCachedPageCount.Add(page, count);
            }
            else
            {
                this.PageToLoadedCachedPageCount[page] = ++count;
            }

            return this.IsCached;
        }
    }
}
