﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.IO;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser.Keywords;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Tests.Import;

namespace Telerik.Windows.Documents.Fixed.Tests.FormatProviders.Pdf.Model.Elements.ColorSpaces
{
    [TestClass]
    public class PdfRealColorSpaceObjectTests
    {
        [TestMethod]
        public void GetColor_WhenComponentsAreIntegers_ShouldConvertComponentsCorrectly()
        {
            // Arrange
            TestPdfContentImportContext context = new TestPdfContentImportContext();
            PostScriptReader reader = new PostScriptReader(new MemoryStream(), new KeywordCollection());
            PdfInt firstElement = new PdfInt(1);
            PdfInt secondElement = new PdfInt(0);
            PdfInt thirdElement = new PdfInt(1);
            PdfInt fourthElement = new PdfInt(0);
            PdfArray pdfArray = new PdfArray(firstElement, secondElement, thirdElement, fourthElement);

            TestPdfRealColorSpaceObject pdfRealColorSpaceObjectMock = new TestPdfRealColorSpaceObject();

            // Act
            TestColorObjectBase color = (TestColorObjectBase)pdfRealColorSpaceObjectMock.GetColor(context, reader, pdfArray);

            // Assert
            Assert.IsNotNull(color);
            Assert.AreEqual(4, color.Components.Length);
            Assert.AreEqual(firstElement.Value, color.Components[0].Value);
            Assert.AreEqual(secondElement.Value, color.Components[1].Value);
            Assert.AreEqual(thirdElement.Value, color.Components[2].Value);
            Assert.AreEqual(fourthElement.Value, color.Components[3].Value);
        }
    }
}
