﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Actions;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Destinations;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.NamedTrees;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.Tests.FormatProviders.Pdf.Model.Elements.Destinations
{
    [TestClass]
    public class DestiantionNamesTreeNode
    {
        [TestMethod]
        public void DestinationNamesTree_EnumeratesCorrectly()
        {
            DestinationsNamesTreeNode destinationsNamesTreeNode = new DestinationsNamesTreeNode();

            DestinationsNamesTreeNode firstLevelChild = new DestinationsNamesTreeNode();
            destinationsNamesTreeNode.Kids = new PdfArray();
            destinationsNamesTreeNode.Kids.Add(firstLevelChild);

            DestinationsNamesTreeNode firstLevelChild1 = new DestinationsNamesTreeNode();
            destinationsNamesTreeNode.Kids.Add(firstLevelChild1);

            firstLevelChild1.Destinations = new NamedDestinationsArrayObject();
            firstLevelChild1.Destinations.Store.Add(new NamedDestinationObject()
            {
                Name = "0",
                GoToAction = new GoToActionObject()
            });

            firstLevelChild1.Destinations.Store.Add(new NamedDestinationObject()
            {
                Name = "1",
                GoToAction = new GoToActionObject()
            });

            DestinationsNamesTreeNode secondLevelChild = new DestinationsNamesTreeNode();
            firstLevelChild.Kids = new PdfArray();
            firstLevelChild.Kids.Add(secondLevelChild);

            secondLevelChild.Destinations = new NamedDestinationsArrayObject();
            secondLevelChild.Destinations.Store.Add(new NamedDestinationObject
            {
                Name = "0.0",
                GoToAction = new GoToActionObject()
            });

            secondLevelChild.Destinations.Store.Add(new NamedDestinationObject
            {
                Name = "0.1",
                GoToAction = new GoToActionObject()
            });

            DestinationsNamesTreeNode secondLevelChild1 = new DestinationsNamesTreeNode();
            firstLevelChild.Kids.Add(secondLevelChild1);

            DestinationsNamesTreeNode thirdLevelChild = new DestinationsNamesTreeNode();
            secondLevelChild1.Kids = new PdfArray();
            secondLevelChild1.Kids.Add(thirdLevelChild);
            thirdLevelChild.Destinations = new NamedDestinationsArrayObject();
            thirdLevelChild.Destinations.Store.Add(new NamedDestinationObject()
            {
                Name = "0.1.0",
                GoToAction = new GoToActionObject()
            });
            thirdLevelChild.Destinations.Store.Add(new NamedDestinationObject()
            {
                Name = "0.1.1",
                GoToAction = new GoToActionObject()
            });

            var destinations = destinationsNamesTreeNode.EnumerateChildDestinations(null, null).ToList();
            Assert.AreEqual(6, destinations.Count);
            Assert.AreEqual("0.0", destinations[0].Name);
            Assert.AreEqual("0.1", destinations[1].Name);
            Assert.AreEqual("0.1.0", destinations[2].Name);
            Assert.AreEqual("0.1.1", destinations[3].Name);
            Assert.AreEqual("0", destinations[4].Name);
            Assert.AreEqual("1", destinations[5].Name);
        }
    }
}
