﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.IO;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Data;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.DocumentStructure;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Forms;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.Tests.Import;

namespace Telerik.Windows.Documents.Fixed.Tests.FormatProviders.Pdf.Model.Elements.DocumentStructure
{
    [TestClass]
    public class DocumentCatalogTests
    {
        [TestMethod]
        public void CopyPropertiesTo_WhenFormFieldsCollectionOfAcroFormIsEmpty_DoesntThrowException()
        {
            TestPdfImportContext context = new TestPdfImportContext();

            DocumentCatalog catalog = new DocumentCatalog();
            catalog.Pages = new PageTreeNode();
            catalog.Pages.Children = new PdfArray(new IPdfPrimitive[0]);

            context.Root = new ReferenceProperty<DocumentCatalog>(new PdfPropertyDescriptor());
            context.Root.SetValue(catalog);

            catalog.AcroForm = new AcroFormObject();
            catalog.AcroForm.Fields = null;
            catalog.CopyPropertiesTo(new PostScriptReader(new MemoryStream(), null), context);

            Assert.AreEqual(0, context.Document.AcroForm.FormFields.Count);
        }

    }
}
