﻿using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Import.Parser;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Elements.Functions;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Utilities;
using Telerik.Windows.Documents.Fixed.Model.Common.Functions;
using Telerik.Windows.Documents.Fixed.Tests.Functions;

namespace Telerik.Windows.Documents.Fixed.Tests.FormatProviders.Pdf.Model.Elements.Functions
{
    internal class TestPostScriptCalculatorFunctionObject : FunctionObject
    {
        private readonly bool hasStreamData;

        public TestPostScriptCalculatorFunctionObject() : this(true)
        {
        }

        public TestPostScriptCalculatorFunctionObject(bool hasStreamData)
        {
            this.hasStreamData = hasStreamData;
            this.IsCopyPropertiesFromOverrideInvoked = false;
            this.CopyPropertiesFromOverrideInvocationCount = 0;
        }

        public bool IsCopyPropertiesFromOverrideInvoked { get; private set; }

        public int CopyPropertiesFromOverrideInvocationCount { get; private set; }

        public object[] CopyPropertiesFromOverrideArgs { get; private set; }

        public byte[] GetFunctionData()
        {
            return this.FunctionData;
        }

        protected override bool HasStreamData
        {
            get
            {
                return this.hasStreamData;
            }
        }

        public override FunctionBase ToFunction(PostScriptReader reader, IPdfImportContext context)
        {
            double[] domain = this.Domain.ToArray<PdfReal, double>(reader, context);
            double[] range = this.Range.ToArray<PdfReal, double>(reader, context);

            TestPostScriptCalculatorFunction function = new TestPostScriptCalculatorFunction(domain, range);

            return function;
        }

        protected override void CopyPropertiesFromOverride(IPdfExportContext context, FunctionBase function)
        {
            this.IsCopyPropertiesFromOverrideInvoked = true;
            this.CopyPropertiesFromOverrideInvocationCount += 1;
            this.CopyPropertiesFromOverrideArgs = new object[] { context, function };
        }
    }
}
