﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.Tests.FormatProviders.Pdf.Model.Types
{
    [TestClass]
    public class PdfBoolTests
    {
        [TestMethod]
        public void Implicit_WhenTrue_ShouldReturnPdfIntInstanceOfOne()
        {
            // Arrange
            PdfBool pdfBool = new PdfBool(true);

            // Act
            PdfInt pdfInt = pdfBool;

            // Assert
            Assert.AreEqual(1, pdfInt.Value);
        }

        [TestMethod]
        public void Implicit_WhenFalse_ShouldReturnPdfIntInstanceOfZero()
        {
            // Arrange
            PdfBool pdfBool = new PdfBool(false);

            // Act
            PdfInt pdfInt = pdfBool;

            // Assert
            Assert.AreEqual(0, pdfInt.Value);
        }

        [TestMethod]
        public void Implicit_WhenTrue_ShouldReturnPdfRealInstanceOfOne()
        {
            // Arrange
            PdfBool pdfBool = new PdfBool(true);

            // Act
            PdfReal pdfReal = pdfBool;

            // Assert
            Assert.AreEqual(1, pdfReal.Value);
        }

        [TestMethod]
        public void Implicit_WhenFalse_ShouldReturnPdfRealInstanceOfZero()
        {
            // Arrange
            PdfBool pdfBool = new PdfBool(false);

            // Act
            PdfReal pdfReal = pdfBool;

            // Assert
            Assert.AreEqual(0, pdfReal.Value);
        }
    }
}
