﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Model.Types;

namespace Telerik.Windows.Documents.Fixed.Tests.FormatProviders.Pdf.Model.Types
{
    [TestClass]
    public class PdfLiteralStringTests
    {
        private const string FamilyName = "FamilyName";
        private readonly byte[] FamilyNameBytes = new byte[] { 254, 255, 0, 70, 0, 97, 0, 109, 0, 105, 0, 108, 0, 121, 0, 78, 0, 97, 0, 109, 0, 101 };

        [TestMethod]
        public void Constructor_WhenUtfEncodedStringType_ShouldSetCorrectValue()
        {
            // Arrange & Act
            PdfHexString pdfHexString = new PdfHexString(FamilyName, StringType.UTFEncodedTextString);

            // Assert
            Assert.IsTrue(FamilyNameBytes.SequenceEqual(pdfHexString.Value));
        }

        [TestMethod]
        public void AssertToStringConvertsPdfEncodedTextCorrectly()
        {
            byte[] value = new byte[] { 82, 233, 112, 111, 110, 115, 101, 95, 51, 48 };
            PdfLiteralString literalString = new PdfLiteralString(value);

            string actual = literalString.ToString();
            string expected = "Réponse_30";

            Assert.AreEqual(expected, actual);
        }

        [TestMethod]
        public void AssertToStringConvertsUtfEncodedTextCorrectly()
        {
            PdfLiteralString literalString = new PdfLiteralString(FamilyNameBytes);

            string actual = literalString.ToString();
            string expected = FamilyName;

            Assert.AreEqual(expected, actual);
        }
    }
}
