﻿using Telerik.Windows.Documents.Fixed.Model.Common.Functions;

namespace Telerik.Windows.Documents.Fixed.Tests.Functions
{
    internal class TestPostScriptCalculatorFunction : FunctionBase
    {
        public TestPostScriptCalculatorFunction(double[] domain, double[] range) : this(new byte[0], domain, range)
        {
        }

        public TestPostScriptCalculatorFunction(byte[] data, double[] domain, double[] range) : base(domain, range)
        {
            this.Data = data;
        }

        public byte[] Data { get; set; }

        public override FunctionType FunctionType
        {
            get
            {
                return FunctionType.PostScriptCalculator;
            }
        }

        public override byte[] GetFunctionData()
        {
            return this.Data;
        }

        protected override bool IsRangeRequired
        {
            get
            {
                return true;
            }
        }

        protected override double[] ExecuteOverride(double[] clippedInputValues)
        {
            return clippedInputValues;
        }
    }
}
