﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows.Media;
#endif

namespace Telerik.Windows.Documents.Fixed.Tests.Import
{
    public class ExpectedTextFragment
    {
        private readonly string text;
        private readonly Matrix position;
        private readonly double characterSpacing;
        private readonly double wordSpacing;

        public ExpectedTextFragment(string text, Matrix position)
            : this(text, position, 0, 0)
        {
        }

        public ExpectedTextFragment(string text, Matrix position, double characterSpacing, double wordSpacing)
        {
            this.text = text;
            this.position = position;
            this.characterSpacing = characterSpacing;
            this.wordSpacing = wordSpacing;
        }

        public string Text
        {
            get
            {
                return this.text;
            }
        }

        public Matrix Position
        {
            get
            {
                return this.position;
            }
        }

        public double CharacterSpacing
        {
            get
            {
                return this.characterSpacing;
            }
        }

        public double WordSpacing
        {
            get
            {
                return this.wordSpacing;
            }
        }

        public ExpectedClipping Clipping
        {
            get;
            set;
        }
    }
}
