﻿using System;
using System.IO;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Common;
using Telerik.Windows.Documents.Fixed.Model.Text;
using Telerik.Windows.Documents.Fixed.Tests.Utils;

namespace Telerik.Windows.Documents.Fixed.Tests.Import
{
    [TestClass]
    public class TestPageContentArray
    {
        [TestMethod]
        public void ImportPageContentArrayTest()
        {
            using (Stream stream = ResourceHelper.GetResourceMemoryStream("Documents/PageContentArrayGeneratedUsingRadPdfProcessing.pdf"))
            {
                PdfFormatProvider provider = new PdfFormatProvider();

                RadFixedDocument pdfDocument = provider.Import(stream);
                RadFixedPage page = pdfDocument.Pages.First();

                foreach (ContentElementBase contentElement in page.Content)
                {
                    TextFragment textFragment = contentElement as TextFragment;

                    Assert.IsNotNull(textFragment);
                    Assert.AreEqual("Hello PDF/A", textFragment.Text);
                }
            }
        }
    }
}