﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Tests.Utils;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;

namespace Telerik.Windows.Documents.Fixed.Tests.Integration.ImportExport.Editing
{
    [TestClass]
    public class EncryptionTests : FixedContentEditorTestBase
    {
        [TestMethod]
        [TestCategory(PdfProcessingCategory.VisualTest)]
        public void Test_Encryption_Pdf()
        {
            RadFixedDocument document = new RadFixedDocument();
            document.Pages.AddPage();

            this.AssertAreVisualyEqual(document, new PdfExportSettings { IsEncrypted = true });
        }

        [TestMethod]
        [TestCategory(PdfProcessingCategory.VisualTest)]
        public void Test_EncryptionPdfA_Pdf()
        {
            RadFixedDocument document = new RadFixedDocument();
            document.Pages.AddPage();

            this.AssertAreVisualyEqual(document, new PdfExportSettings { IsEncrypted = true, ComplianceLevel = PdfComplianceLevel.PdfA1B });
        }
    }
}
