﻿using System;
using System.IO;
using System.Linq;
using System.Windows;
using System.Windows.Media;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model;

namespace Telerik.Windows.Documents.Fixed.Tests.Integration.ImportExport.Fonts
{
    [TestClass]
    public class TestExportImportCidType2Fonts : FontTestBase
    {
        [TestMethod]
        public void Test_TextFragment_ExportImport_Arial()
        {
            TestExportImport("Arial", FontStyles.Normal, FontWeights.Normal);
        }

        [TestMethod]
        public void Test_TextFragment_ExportImport_ArialBold()
        {
            TestExportImport("Arial", FontStyles.Normal, FontWeights.Bold);
        }

        [TestMethod]
        public void Test_TextFragment_ExportImport_ArialBoldItalic()
        {
            TestExportImport("Arial", FontStyles.Italic, FontWeights.Bold);
        }

        [TestMethod]
        public void Test_TextFragment_ExportImport_ArialItalic()
        {
            TestExportImport("Arial", FontStyles.Italic, FontWeights.Normal);
        }

        // TODO: This test fails only on the build machine. There is a TeamPulse item about this issue: http://tpdogfood.telerik.com/view#item/144096
        //[TestMethod]
        //public void Test_TextFragment_ExportImport_Arial_Unicode()
        //{
        //    string arialUnicodeFontFamily = "Arial Unicode MS";
        //    FontBase font;
        //    if (FontsRepository.TryCreateFont(new FontFamily(arialUnicodeFontFamily), out font))
        //    {
        //        TestExportImport(arialUnicodeFontFamily, FontStyles.Normal, FontWeights.Normal, "日本人");
        //    }
        //    else
        //    {
        //        Assert.Inconclusive("Font {0} is missing.", arialUnicodeFontFamily);
        //    }
        //}

        [TestMethod]
        public void Test_TextFragment_ExportImport_MissingGlyphs()
        {
            RadFixedDocument document = new RadFixedDocument();
            document.Pages.AddPage().Content.AddTextFragment("日本人");

            using (MemoryStream stream = new MemoryStream())
            {
                RadFixedDocument result = ExportAndImport(stream, document);

                RadFixedDocument expected = new RadFixedDocument();
                expected.Pages.AddPage();

                AssertDocument(expected, result);
            }
        }

        private static void TestExportImport(string fontFamily, FontStyle fontStyle, FontWeight fontWeight, string text = "Alabala")
        {
            RadFixedDocument document = CreateDocumentWithTextFragment(new FontFamily(fontFamily), fontStyle, fontWeight, text);
            ExportImportAndAssert(document);
        }
    }
}
