﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Text;
using Telerik.Windows.Documents.Core.Fonts;

namespace Telerik.Windows.Documents.Fixed.Tests.Integration.ImportExport.Fonts
{
    [TestClass]
    public class TestExportImportTestFragmentPosition : FontTestBase
    {
        [TestMethod]
        public void Test_TextFragment_ExportImport_ScaledPosition()
        {
            TextFragment textFragment;
            RadFixedDocument document = CreateDocumentWithTextFragment(FontsManager.Helvetica, out textFragment);
            textFragment.Position.Scale(0.5, 3);

            ExportImportAndAssert(document);
        }

        [TestMethod]
        public void Test_TextFragment_ExportImport_RotatedPosition()
        {
            TextFragment textFragment;
            RadFixedDocument document = CreateDocumentWithTextFragment(FontsManager.Helvetica, out textFragment);
            textFragment.Position.Rotate(43);

            ExportImportAndAssert(document);
        }

        [TestMethod]
        public void Test_TextFragment_ExportImport_TranslatedPosition()
        {
            TextFragment textFragment;
            RadFixedDocument document = CreateDocumentWithTextFragment(FontsManager.Helvetica, out textFragment);
            textFragment.Position.Translate(433, 20);

            ExportImportAndAssert(document);
        }

        [TestMethod]
        public void Test_TextFragment_ExportImport_CombinedTransformations()
        {
            TextFragment textFragment;
            RadFixedDocument document = CreateDocumentWithTextFragment(FontsManager.Helvetica, out textFragment);
            textFragment.Position.Scale(0.5, 3);
            textFragment.Position.Translate(43, -80);
            textFragment.Position.Rotate(22);

            ExportImportAndAssert(document);
        }
    }
}
