﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Graphics;

namespace Telerik.Windows.Documents.Fixed.Tests.Integration.ImportExport.Graphics
{
    [TestClass]
    public class TestExportImportPathPositions : GraphicsTestBase
    {
        [TestMethod]
        public void Test_Path_ExportImport_ScaledPosition()
        {
            Path path;
            RadFixedDocument document = CreateDocumentWithSamplePath(out path);
            path.Position.Scale(4, 2);

            ExportImportAndAssert(document);
        }

        [TestMethod]
        public void Test_Path_ExportImport_RotatedPosition()
        {
            Path path;
            RadFixedDocument document = CreateDocumentWithSamplePath(out path);
            path.Position.Rotate(43);

            ExportImportAndAssert(document);
        }

        [TestMethod]
        public void Test_Path_ExportImport_TranslatedPosition()
        {
            Path path;
            RadFixedDocument document = CreateDocumentWithSamplePath(out path);
            path.Position.Translate(236, 85);

            ExportImportAndAssert(document);
        }

        [TestMethod]
        public void Test_Path_ExportImport_CombinedTransformations()
        {
            Path path;
            RadFixedDocument document = CreateDocumentWithSamplePath(out path);
            path.Position.Translate(236, 85);
            path.Position.Scale(3, 1.2);
            path.Position.Rotate(-43);

            ExportImportAndAssert(document);
        }
    }
}
