﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Objects;

namespace Telerik.Windows.Documents.Fixed.Tests.Integration.ImportExport.Images
{
    [TestClass]
    public abstract class TestImageBase : IntegrationTestClassBase
    {
        protected const string TestDocumentsPath = "Documents/Images/";

        protected static string CreateImageName(int id)
        {
            return string.Format("sample{0}.jpg", id);
        }

        protected static RadFixedDocument CreateDocumentWithImage(out Image image, string name)
        {
            RadFixedDocument document = new RadFixedDocument();
            var page = document.Pages.AddPage();

            image = page.Content.AddImage();
            image.ImageSource = CreateImageSource(name);
            return document;
        }

        protected static RadFixedDocument CreateDocumentWithImage(out Image image)
        {
            return CreateDocumentWithImage(out image, CreateImageName(0));
        }
    }
}