﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Fixed.Model.InteractiveForms;

namespace Telerik.Windows.Documents.Fixed.Tests.Integration.ImportExport.InteractiveForms
{
    [TestClass]
    public class TestCheckBoxField : TestTwoOppositeFieldValuesBase<CheckBoxField>
    {
        protected override string NamePrefix
        {
            get
            {
                return "check";
            }
        }

        [TestMethod]
        public void TestCheckBoxFieldProperties()
        {
            this.GenerateAssertExportAndImportSinglePageDocument();
        }

        protected override CheckBoxField CreateField(string name, bool isFirstCase)
        {            
            CheckBoxField field = new CheckBoxField(name);
            field.IsChecked = isFirstCase;
            field.IsCheckedByDefault = !isFirstCase;
            field.ExportValue = isFirstCase.ToString();

            return field;
        }

        protected override void AssertCheckBox(CheckBoxField field)
        {
            bool isFirstCase = this.AssertFieldNameAndGetIfFirstCase(field);

            Assert.AreEqual(isFirstCase, field.IsChecked);
            Assert.AreEqual(!isFirstCase, field.IsCheckedByDefault);
            Assert.AreEqual(isFirstCase.ToString(), field.ExportValue);
        }
    }
}
