﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Fixed.Model.InteractiveForms;

namespace Telerik.Windows.Documents.Fixed.Tests.Integration.ImportExport.InteractiveForms
{
    [TestClass]
    public class TestCombTextBoxField : TestTwoOppositeFieldValuesBase<CombTextBoxField>
    {
        protected override string NamePrefix
        {
            get
            {
                return "comb";
            }
        }

        [TestMethod]
        public void TestCombTextBoxFieldProperties()
        {
            this.GenerateAssertExportAndImportSinglePageDocument();
        }

        protected override CombTextBoxField CreateField(string name, bool isFirstCase)
        {
            CombTextBoxField field = new CombTextBoxField(name);
            field.MaxLengthOfInputCharacters = isFirstCase ? 4 : 6;
            field.Value = isFirstCase ? "1234" : null;

            return field;
        }

        protected override void AssertCombTextBox(CombTextBoxField field)
        {
            bool isFirstCase = this.AssertFieldNameAndGetIfFirstCase(field);
            int expectedMax = isFirstCase ? 4 : 6;
            string expectedValue = isFirstCase ? "1234" : null;

            Assert.AreEqual(expectedMax, field.MaxLengthOfInputCharacters);
            Assert.AreEqual(expectedValue, field.Value);
        }
    }
}
