﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Linq;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.InteractiveForms;

namespace Telerik.Windows.Documents.Fixed.Tests.Integration.ImportExport.InteractiveForms
{
    [TestClass]
    public class TestSignatureField : TestTwoOppositeFieldValuesBase<SignatureField>
    {
        protected override string NamePrefix
        {
            get
            {
                return "signature";
            }
        }

        [TestMethod]
        public void TestSignatureFieldProperties()
        {
            this.GenerateAssertExportAndImportSinglePageDocument();
        }

        [TestMethod]
        public void TestSignatureField_WithoutSignature_CanBeCloned()
        {
            RadFixedDocument document = new RadFixedDocument();
            base.CreateFields(document);

            RadFixedDocument cloned = document.Clone();

            Assert.IsTrue(cloned.AcroForm.FormFields.Any(f => f.FieldType == FormFieldType.Signature));
#if !NETSTANDARD
            Assert.IsTrue(cloned.AcroForm.FormFields.Any(f => (f as SignatureField).Signature == null));
#endif
        }

        protected override SignatureField CreateField(string name, bool isFirstCase)
        {
            return new SignatureField(name);
        }

        protected override void AssertSignature(SignatureField field)
        {
            this.AssertFieldNameAndGetIfFirstCase(field);
        }
    }
}
