﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
#endif
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model;

namespace Telerik.Windows.Documents.Fixed.Tests.Integration.ImportExport.PageBoundaries
{
    [TestClass]
    public class TestExportImportPageBoxes : IntegrationTestClassBase
    {
        [TestMethod]
        public void Test_CropBox_ExportImport()
        {
            // Arrange
            RadFixedDocument document = new RadFixedDocument();
            RadFixedPage page = document.Pages.AddPage();
            page.CropBox = new Rect(0, 0, 300, 400);

            // Act & Assert
            ExportImportAndAssert(document);
        }

        [TestMethod]
        public void Test_CropBox_ExportImport_With_PositiveOffsets()
        {
            // Arrange
            RadFixedDocument document = new RadFixedDocument();
            RadFixedPage page = document.Pages.AddPage();
            page.CropBox = new Rect(50, 100, 300, 400);

            // Act & Assert
            ExportImportAndAssert(document);
        }

        [TestMethod]
        public void Test_CropBox_ExportImport_With_NegativeOffsets()
        {
            // Arrange
            RadFixedDocument document = new RadFixedDocument();
            RadFixedPage page = document.Pages.AddPage();
            page.CropBox = new Rect(-100, -150, 300, 400);

            // Act & Assert
            ExportImportAndAssert(document);
        }

        [TestMethod]
        public void Test_MediaBox_ExportImport()
        {
            // Arrange
            RadFixedDocument document = new RadFixedDocument();
            RadFixedPage page = document.Pages.AddPage();
            page.MediaBox = new Rect(0, 0, 800, 1000);

            // Act & Assert
            ExportImportAndAssert(document);
        }

        [TestMethod]
        public void Test_MediaBox_ExportImport_With_PositiveOffsets()
        {
            // Arrange
            RadFixedDocument document = new RadFixedDocument();
            RadFixedPage page = document.Pages.AddPage();
            page.CropBox = new Rect(400, 500, 500, 800);

            // Act & Assert
            ExportImportAndAssert(document);
        }

        [TestMethod]
        public void Test_MediaBox_ExportImport_With_NegativeOffsets()
        {
            // Arrange
            RadFixedDocument document = new RadFixedDocument();
            RadFixedPage page = document.Pages.AddPage();
            page.CropBox = new Rect(-2000, -3000, 700, 800);

            // Act & Assert
            ExportImportAndAssert(document);
        }
    }
}
