﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Graphics;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using Matrix = System.Windows.Media.Matrix;
#endif

namespace Telerik.Windows.Documents.Fixed.Tests.Model
{
    [TestClass]
    public class ClippingTests
    {
        [TestMethod]
        public void Clone_ShouldCreateClonedClippingInstanceWithCorrectClip()
        {
            // Arrange
            Clipping clipping = new Clipping();

            PathGeometry clip = new PathGeometry();
            clipping.Clip = clip;

            // Act
            Clipping cloned = ((IContextClonable<Clipping>)clipping).Clone(new RadFixedDocumentCloneContext());

            // Assert
            Assert.AreEqual(clip, cloned.Clip);
        }

        [TestMethod]
        public void Clone_ShouldCreateClonedClippingInstanceWithCorrectTransform()
        {
            // Arrange
            Clipping clipping = new Clipping();
            
            Matrix transform = new Matrix();
            clipping.Transform = transform;

            // Act
            Clipping cloned = ((IContextClonable<Clipping>)clipping).Clone(new RadFixedDocumentCloneContext());

            // Assert
            Assert.AreEqual(transform, cloned.Transform);
        }
    }
}
