﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;

namespace Telerik.Windows.Documents.Fixed.Tests.Model.ColorSpaces
{
    [TestClass]
    public class CalGrayTests
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void GetColor_WhenParsIsNull_ThrowsException()
        {
            CalGray calGrayColorSpace = new CalGray();
            ColorBase result = calGrayColorSpace.GetColor(null);
        }

        [TestMethod]
        public void GetColor_WhenParsIsNotNullAndNotEmpty_ReturnsCorrectRgbColor()
        {
            // Arrange
            double[] pars = new double[] { 1, 0, 0 };
            RgbColor expectedColorBase = new RgbColor(255, 255, 255);

            CalGray calGrayColorSpace = new CalGray();

            // Act
            ColorBase result = calGrayColorSpace.GetColor(pars);

            RgbColor rgbColor = result as RgbColor;

            // Assert
            Assert.IsNotNull(rgbColor);

            // the first double from the pars is taken; this is 1-component color space

            Assert.AreEqual(expectedColorBase, rgbColor);
        }
    }
}
