﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;

namespace Telerik.Windows.Documents.Fixed.Tests.Model.ColorSpaces
{
    [TestClass]
    public class CalRgbTests
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void GetColor_WhenParsIsNull_ThrowsException()
        {
            CalRgb calRgbColorSpace = new CalRgb();
            ColorBase result = calRgbColorSpace.GetColor(null);
        }

        [TestMethod]
        public void GetColor_WhenParsIsNotNullAndNotEmpty_ReturnsCorrectRgbColor()
        {
            // Arrange
            double[] pars = new double[] { 1, 0, 1, 0, 0, 0 };
            RgbColor expectedColorBase = new RgbColor(255, 0, 0, 0);

            CalRgb calRgbColorSpace = new CalRgb();

            //Act
            ColorBase result = calRgbColorSpace.GetColor(pars);
            RgbColor rgbColor = result as RgbColor;

            //Assert
            Assert.IsNotNull(rgbColor);

            // the last three doubles from the pars are taken; this is a 3-component color space

            Assert.AreEqual(expectedColorBase, rgbColor);
        }
    }
}
