﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;

namespace Telerik.Windows.Documents.Fixed.Tests.Model.ColorSpaces
{
    [TestClass]
    public class DeviceGrayTests
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void GetColor_WhenParsIsNull_ThrowsException()
        {
            DeviceGray deviceGrayColorSpace = new DeviceGray();
            ColorBase result = deviceGrayColorSpace.GetColor(null);
        }

        [TestMethod]
        public void GetColor_WhenParsIsNotNullAndNotEmpty_ReturnsCorrectRgbColor()
        {
            // Arrange
            double[] pars = new double[] { 1, 0, 0 };
            RgbColor expectedColorBase = new RgbColor(255, 255, 255);

            DeviceGray deviceGrayColorSpace = new DeviceGray();

            // Act
            ColorBase result = deviceGrayColorSpace.GetColor(pars);

            RgbColor rgbColor = result as RgbColor;

            // Assert
            Assert.IsNotNull(rgbColor);

            // the first double from the pars is taken; DeviceGray is 1-component color space

            Assert.AreEqual(expectedColorBase, rgbColor);
        }
    }
}
