﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;
using Telerik.Windows.Documents.Fixed.Tests.Functions;

namespace Telerik.Windows.Documents.Fixed.Tests.Model.ColorSpaces
{
    [TestClass]
    public class DeviceNTests
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void GetColor_WhenParsIsNull_ThrowsException()
        {
            DeviceN deviceNColorSpace = new DeviceN();
            ColorBase result = deviceNColorSpace.GetColor(null);
        }

        [TestMethod]
        public void GetColor_WhenParsIsNotNullAndNotEmpty_ReturnsCorrectRgbColor()
        {
            // Arrange
            double[] pars = new double[] { 1, 0 };
            RgbColor expectedColorBase = new RgbColor(255, 255, 255);

            double[] domain = new double[] { 0, 1, 0, 1 };
            double[] range = domain;
            TestPostScriptCalculatorFunction function = new TestPostScriptCalculatorFunction(new byte[0], domain, range);
            DeviceN deviceNColorSpace = new DeviceN()
            {
                TintTransform = function,
                AlternateColorSpace = new DeviceGray()
            };

            // Act
            ColorBase result = deviceNColorSpace.GetColor(pars);

            RgbColor rgbColor = result as RgbColor;

            // Assert
            Assert.IsNotNull(rgbColor);

            Assert.AreEqual(expectedColorBase, rgbColor);
        }
    }
}
