﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;

namespace Telerik.Windows.Documents.Fixed.Tests.Model.ColorSpaces
{
    [TestClass]
    public class DeviceRgbTests
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void GetColor_WhenParsIsNull_ThrowsException()
        {
            DeviceRgb deviceRgbColorSpace = new DeviceRgb();
            ColorBase result = deviceRgbColorSpace.GetColor(null);
        }

        [TestMethod]
        public void GetColor_WhenParsIsNotNullAndNotEmpty_ReturnsCorrectRgbColor()
        {
            // Arrange
            double[] pars = new double[] { 1, 0, 1, 0, 0, 0 };
            RgbColor expectedColorBase = new RgbColor(255, 255, 0, 255);

            DeviceRgb deviceRgbColorSpace = new DeviceRgb();

            // Act
            ColorBase result = deviceRgbColorSpace.GetColor(pars);

            RgbColor rgbColor = result as RgbColor;

            // Assert
            Assert.IsNotNull(rgbColor);

            // the first three doubles from the pars are taken; this is a 3-component color space

            Assert.AreEqual(expectedColorBase, rgbColor);
        }
    }
}
