﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Core.Fonts.OpenType.Tables;

namespace Telerik.Windows.Documents.Fixed.Tests.Model.Fonts
{
    internal class TestCMap : CMap
    {
        private readonly Dictionary<Tuple<ushort, ushort>, CMapTable> tablesMapping;

        public TestCMap() 
            : base(null)
        {
            this.tablesMapping = new Dictionary<Tuple<ushort, ushort>, CMapTable>();
        }

        public override CMapTable GetCMapTable(ushort platformId, ushort encodingId)
        {
            CMapTable table;
            Tuple<ushort, ushort> key = new Tuple<ushort, ushort>(platformId, encodingId);
            this.tablesMapping.TryGetValue(key, out table);

            return table;
        }

        public void AddCMapTable(ushort platformId, ushort encodingId, CMapTable table)
        {
            Tuple<ushort, ushort> key = new Tuple<ushort, ushort>(platformId, encodingId);
            this.tablesMapping.Add(key, table);
        }
    }
}
