﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Core.Fonts;
using Telerik.Windows.Documents.Core.Fonts.OpenType;
using Telerik.Windows.Documents.Core.Fonts.OpenType.Tables;

namespace Telerik.Windows.Documents.Fixed.Tests.Model.Fonts
{
    internal class TestCMapTable : CMapTable
    {
        private readonly ushort firstCode;
        private readonly Dictionary<int, ushort> glyphIdMapping;

        public TestCMapTable(ushort firstCode)
        {
            this.firstCode = firstCode;
            this.glyphIdMapping = new Dictionary<int, ushort>();
        }

        public override ushort FirstCode
        {
            get
            {
                return this.firstCode;
            }
        }

        public override void Import(OpenTypeFontReader reader)
        {
            throw new NotImplementedException();
        }

        public override void Read(OpenTypeFontReader reader)
        {
            throw new NotImplementedException();
        }

        public override bool TryGetCharId(ushort glyphId, out ushort charCode)
        {
            throw new NotImplementedException();
        }

        public override bool TryGetGlyphId(int unicode, out ushort glyphId)
        {
            return this.glyphIdMapping.TryGetValue(unicode, out glyphId);
        }

        public override void Write(FontWriter writer)
        {
            throw new NotImplementedException();
        }

        public void AddGlyphIdMapping(int unicode, ushort glyphId)
        {
            this.glyphIdMapping.Add(unicode, glyphId);
        }
    }
}
