﻿using Telerik.Windows.Documents.Core.Fonts.OpenType;
using Telerik.Windows.Documents.Core.Fonts.OpenType.Tables;

namespace Telerik.Windows.Documents.Fixed.Tests.Model.Fonts
{
    internal class TestOpenTypeFontSource : OpenTypeFontSource
    {
        private readonly bool isItalic;
        private readonly TestCMap cMap;

        public TestOpenTypeFontSource()
            : this(false)
        {
        }

        public TestOpenTypeFontSource(bool isItalic)
            : base(new TestOpenTypeFontReader())
        {
            this.isItalic = isItalic;
            this.cMap = new TestCMap();
        }

        internal override CMap GetCMap()
        {
            return this.cMap;
        }

        public override bool GetIsItalic()
        {
            return this.isItalic;
        }

        public override double GetItalicAngle()
        {
            return this.isItalic ? 30 : 0;
        }
    }
}
