﻿using System;
#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
#endif
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model;

namespace Telerik.Windows.Documents.Fixed.Tests.Model
{
    [TestClass]
    public class RadFixedPageTests
    {
        [TestMethod]
        public void CropBox_ByDefault_MatchesMediaBox()
        {
            // Arrange and act
            RadFixedPage page = new RadFixedPage();

            // Assert
            Assert.AreEqual(page.MediaBox, page.CropBox);
        }

        [TestMethod]
        public void CropBox_WhenMediaBoxIsSet_MatchesMediaBox()
        {
            // Arrange
            RadFixedPage page = new RadFixedPage();
            Rect rect = new Rect(new Point(1, 1), new Point(5, 5));

            // Act
            page.MediaBox = rect;

            // Assert
            Assert.AreEqual(page.MediaBox, page.CropBox);
        }

        [TestMethod]
        public void CropBox_WhenOnlySizeIsSet_MatchesMediaBox()
        {
            // Arrange
            RadFixedPage page = new RadFixedPage();
            Size size = new Size(10, 10);

            // Act
            page.Size = size;

            // Assert
            Assert.AreEqual(page.MediaBox, page.CropBox);
        }

        [TestMethod]
        public void CropBox_WhenCropBoxIsSet_ReturnsTheSetValue()
        {
            // Arrange
            RadFixedPage page = new RadFixedPage();
            Rect rect = new Rect(new Point(1, 1), new Point(5, 5));

            // Act
            page.CropBox = rect;

            // Assert
            Assert.AreEqual(rect, page.CropBox);
        }
    }
}
