﻿using System;
using Telerik.Windows.Documents.Fixed.Model.ColorSpaces;
using Telerik.Windows.Documents.Fixed.Model.Resources;

namespace Telerik.Windows.Documents.Fixed.Tests.Model.Resources
{
    internal class TestImageDescriptor : IImageDescriptor
    {
        private readonly byte[] encodedData;
        private readonly byte[] decodedData;

        public TestImageDescriptor(byte[] encodedData, byte[] decodedData)
        {
            this.encodedData = encodedData;
            this.decodedData = decodedData;
        }

        public int Width { get; set; }

        public int Height { get; set; }

        public int BitsPerComponent { get; set; }

        public double[] Decode { get; set; }

        public string[] Filters { get; set; }

        public IColorSpace ColorSpace { get; set; }

        public IMask Mask { get; set; }

        public IImageDescriptor SMask { get; set; }

        public byte[] GetDecodedData()
        {
            return this.decodedData;
        }

        public byte[] GetEncodedData()
        {
            return this.encodedData;
        }
    }
}
