﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Telerik.Windows.Documents.Core.Tests.PostScriptInterpretatorTests
{
    [TestClass]
    public class TestAddOperator
    {
        [TestMethod]
        public void WhenTheOneArgumentIsDoubleAndTheOtherIsInt()
        {
            string operation = "10.4 -4 add";

            double expected = 6.4;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenBothArgumentsAreDouble()
        {
            string operation = "-10.4 -12.6 add";

            double expected = -23;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenBothArgumentsAreInt()
        {
            string operation = "12 13 add";

            double expected = 25;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }
    }
}
