﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Telerik.Windows.Documents.Core.Tests.PostScriptInterpretatorTests
{
    [TestClass]
    public class TestDivOperator
    {
        [TestMethod]
        public void WhenTheOneArgumentIsDoubleAndTheOtherIsInt()
        {
            string operation = "16.8 2 div";

            double expected = 8.4;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenBothArgumentsAreDouble()
        {
            string operation = "50.5 0.5 div";

            double expected = 101;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenBothArgumentsAreInt()
        {
            string operation = "18 9 div";

            double expected = 2;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }
    }
}
