﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Telerik.Windows.Documents.Core.Tests.PostScriptInterpretatorTests
{
    [TestClass]
    public class TestModOperator
    {
        [TestMethod]
        public void WhenBothArgumentsArePositive()
        {
            string operation = "10 4 mod";

            double expected = 2;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenTheFirstArgumentIsNegativeAndTheSecondIsPositive()
        {
            string operation = "-10 4 mod";

            double expected = -2;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenTheFirstArgumentIsPositiveAndTheSecondIsNegative()
        {
            string operation = "10 -4 mod";

            double expected = 2;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }
    }
}
