﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Telerik.Windows.Documents.Core.Tests.PostScriptInterpretatorTests
{
    [TestClass]
    public class TestMulOperator
    {
        [TestMethod]
        public void WhenTheOneArgumentIsDoubleAndTheOtherIsInt()
        {
            string operation = "10.1 -4 mul";

            double expected = -40.4;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenBothArgumentsAreDouble()
        {
            string operation = "0.5 0.5 mul";

            double expected = 0.25;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenBothArgumentsAreInt()
        {
            string operation = "6 5 mul";

            double expected = 30;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }
    }
}
