﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Telerik.Windows.Documents.Core.Tests.PostScriptInterpretatorTests
{
    [TestClass]
    public class TestRoundOperator
    {
        [TestMethod]
        public void WhenTheArgumentIsInt()
        {
            string operation = "10 round";

            double expected = 10;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenTheArgumentIsDoubleAndTheNearestIntegerValueIsSmaller()
        {
            string operation = "10.45 round";

            double expected = 10;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenTheArgumentIsDoubleAndTheNearestIntegerValueIsBigger()
        {
            string operation = "10.86 round";

            double expected = 11;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }
    }
}
