﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Telerik.Windows.Documents.Core.Tests.PostScriptInterpretatorTests
{
    [TestClass]
    public class TestSubOperator
    {
        [TestMethod]
        public void WhenTheOneArgumentIsDoubleAndTheOtherIsInt()
        {
            string operation = "10.4 -4 sub";

            double expected = 14.4;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenBothArgumentsAreDouble()
        {
            string operation = "-10.5 -12.5 sub";

            double expected = 2;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }

        [TestMethod]
        public void WhenBothArgumentsAreInt()
        {
            string operation = "12 13 sub";

            double expected = -1;
            double result = Convert.ToDouble(OperatorsUtil.ExecuteOperations(operation, 1)[0]);
            Assert.AreEqual(expected, result);
        }
    }
}
