﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Text;

namespace Telerik.Windows.Documents.Fixed.Tests.Text
{
    [TestClass]
    public class TextDocumentTests
    {
        [TestMethod]
        public void GetTextPage_WhenHasText_ShouldCacheTheTextPageInstance()
        {
            // Arrange
            RadFixedDocument document = new RadFixedDocument();
            RadFixedPage page = document.Pages.AddPage();
            page.Content.AddTextFragment("Text");

            TextDocument textDocument = new TextDocument(document);

            // Act
            TextPage firstCallResult = textDocument.GetTextPage(0);
            TextPage secondCallResult = textDocument.GetTextPage(0);

            // Assert
            Assert.AreSame(firstCallResult, secondCallResult);
        }

        [TestMethod]
        public void GetTextPage_WhenHasNoText_ShouldNotCacheTheTextPageInstance()
        {
            // Arrange
            RadFixedDocument document = new RadFixedDocument();
            document.Pages.AddPage();

            TextDocument textDocument = new TextDocument(document);

            // Act
            TextPage firstCallResult = textDocument.GetTextPage(0);
            TextPage secondCallResult = textDocument.GetTextPage(0);

            // Assert
            Assert.AreNotSame(firstCallResult, secondCallResult);
        }
    }
}
