﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Utilities.Rendering;

namespace Telerik.Windows.Documents.Fixed.Tests.Utilities.Rendering
{
    [TestClass]
    public class ContentElementsGraphCacheTests
    {
        [TestMethod]
        public void GetGraph_ShouldCreateContentElementsGraphInstance()
        {
            // Arrange
            RadFixedPage page = new RadFixedPage();
            ContentElementsGraphCache contentElementsGraphCache = new ContentElementsGraphCache();

            // Act
            ContentElementsGraph contentElementsGraph = contentElementsGraphCache.GetGraph(page);

            // Assert
            Assert.IsNotNull(contentElementsGraph);
        }

        [TestMethod]
        public void GetGraph_ShouldCacheContentElementsGraphInstance()
        {
            // Arrange
            RadFixedPage page = new RadFixedPage();
            ContentElementsGraphCache contentElementsGraphCache = new ContentElementsGraphCache();

            // Act
            ContentElementsGraph contentElementsGraph = contentElementsGraphCache.GetGraph(page);
            ContentElementsGraph contentElementsGraphCached = contentElementsGraphCache.GetGraph(page);
            ContentElementsGraph contentElementsGraphCached2 = contentElementsGraphCache.GetGraph(page);

            // Assert
            Assert.AreEqual(contentElementsGraph, contentElementsGraphCached);
            Assert.AreEqual(contentElementsGraph, contentElementsGraphCached2);
        }

        [TestMethod]
        public void Clear_ShouldClearCachedContentElementsGraphInstances()
        {
            // Arrange
            RadFixedPage page = new RadFixedPage();
            ContentElementsGraphCache contentElementsGraphCache = new ContentElementsGraphCache();
            ContentElementsGraph contentElementsGraph = contentElementsGraphCache.GetGraph(page);

            // Act
            contentElementsGraphCache.Clear();
            ContentElementsGraph newContentElementsGraph = contentElementsGraphCache.GetGraph(page);

            // Assert
            Assert.AreNotEqual(contentElementsGraph, newContentElementsGraph);
        }
    }
}
