﻿using System;
using System.IO;
using System.Linq;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf.Export;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Tests.Integration;
using Telerik.Windows.Documents.Flow.Tests.Flow.Utils;

namespace Telerik.Windows.Documents.Fixed.Tests.Utils
{
    public static class AssertVisualTest
    {
        public static void AssertAreVisualyEqual(RadFixedDocument document, PdfExportSettings settings = null)
        {
#if VISUAL
            PdfFormatProvider provider = new PdfFormatProvider();
            if (settings != null)
            {
                provider.ExportSettings = settings;
            }

            byte[] data = provider.Export(document);
            VisualTestHelper.Assert(data, IntegrationTestClassBase.PDFFILEEXTENSION);
#endif
        }

        public static void AssertAreVisualyEqual(RadFixedDocument document, Action action, int actionExecuteCount = 1)
        {
#if VISUAL
            PdfFormatProvider provider = new PdfFormatProvider();
            byte[] data = provider.Export(document);
            VisualTestHelper.Assert(data, IntegrationTestClassBase.PDFFILEEXTENSION, action, actionExecuteCount);
#endif
        }
    }
}
