﻿using System;
using System.IO;
using System.Linq;

namespace Telerik.Windows.Documents.Fixed.Tests.Utils
{
    public static class FolderSettings
    {
        public static string FolderPathDplWordProcessing { get; set; }
        public static string FolderPathDplPdfProcessing { get; set; }
        public static string ImageVerificationResultFolder { get; set; }
        public static string BuildResults { get; set; }

        static FolderSettings()
        {
            var buildMachine = @"\\" + Environment.MachineName + @"\";
            BuildResults = buildMachine + @"TeamBuildResults\";
            string imagesFolder = @"Images\";
            string imageVerificationFolder = buildMachine + @"ImageVerificationResults\";
            string platform = "";
#if WPF
            platform = "WPF";
#else
            platform = "SL";
#endif
            FolderPathDplWordProcessing = buildMachine + imagesFolder + platform + @"\DPL\WordProcessing\";
            FolderPathDplPdfProcessing = buildMachine + imagesFolder + platform + @"\DPL\PdfProcessing\";
            ImageVerificationResultFolder = buildMachine + @"ImageVerificationResults\";

            if (!Directory.Exists(ImageVerificationResultFolder))
            {
                Directory.CreateDirectory(ImageVerificationResultFolder);
            }

            if (!Directory.Exists(FolderPathDplWordProcessing))
            {
                Directory.CreateDirectory(FolderPathDplWordProcessing);
            }

            if (!Directory.Exists(FolderPathDplPdfProcessing))
            {
                Directory.CreateDirectory(FolderPathDplPdfProcessing);
            }
        }
    }
}
