﻿using ArtOfTest.WebAii.Core;
using ArtOfTest.WebAii.TestTemplates;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.Fixed.Tests.Utils;

namespace Telerik.Windows.Documents.Fixed.Tests.Integration
{
    public partial class IntegrationTestClassBase : BaseWpfTest
    {
        private TestContext testContextInstance = null;


        public static string BuildResults = FolderSettings.BuildResults;
        public static string ImageVerificationResultFolder = FolderSettings.ImageVerificationResultFolder;
        public static string PdfProcessingFolder = FolderSettings.FolderPathDplPdfProcessing;
        public static string PdfProcessingControl = @"PdfProcessing\";
        public static string WordProcessingControl = @"WordProcessing\";
        public static string TempFolder = @"C:\DPL_Temp\";
        public static string PdfFileExtenssion = ".pdf";

        /// <summary>
        ///Gets or sets the VS test context which provides
        ///information about and functionality for the
        ///current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        public static string TestName = null;

        static IntegrationTestClassBase()
        {
        }

        [TestInitialize()]
        public void MyTestInitialize()
        {
            Settings settings = GetSettings();
            Initialize(settings, new TestContextWriteLine(this.TestContext.WriteLine));
            SetTestMethod(this, (string)TestContext.Properties["TestName"]);
            TestName = TestContext.TestName;
        }

        [TestCleanup()]
        public void MyTestCleanup()
        {
            KillPdfViewerProccess();
            this.CleanUp();
        }

        private static void KillPdfViewerProccess()
        {
            Process[] processes = Process.GetProcessesByName("AcroRd32");

            if (processes.Count() > 0)
            {
                foreach (Process process in processes)
                {
                    try
                    {
                        process.Kill();
                    }
                    catch { }
                }
            }
        }

        [ClassCleanup()]
        public static void MyClassCleanup()
        {
            Directory.Delete(TempFolder);
            ShutDown();
        }
    }
}
