﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.UI;
using Telerik.Windows.Documents.Fixed.UI.PointerHandlers;
using Telerik.Windows.Documents.UI;

namespace Telerik.Windows.Documents.Fixed.Tests.Utils
{
    public class TestDocumentPresenter  : IFixedDocumentPresenter
    {
        public double OffsetX { get; set; }

        public double OffsetY { get; set; }

        public RadFixedDocument Document { get; set; }

        #region IFixedDocumentPresenter Members

        public FixedDocumentViewerBase Owner
        {
            get { throw new NotImplementedException(); }
        }

        public FixedDocumentViewerMode Mode
        {
            get;
            set;
        }

        public bool CanHorizontallyScroll
        {
            get;
            set;
        }

        public bool CanVerticallyScroll
        {
            get;
            set;
        }

        public void HideCaret()
        {
        }

        public void ShowCaret()
        {
        }

        public Point GetScrollOffset()
        {
            return new Point(this.OffsetX, this.OffsetY);
        }

        public void Scroll(double? offsetX, double? offsetY)
        {
            if (offsetX.HasValue)
            {
                this.OffsetX += offsetX.Value;
            }
            if (offsetY.HasValue)
            {
                this.OffsetX += offsetX.Value;
            }
        }

        public void ScrollTo(double? x, double? y)
        {
            if (x.HasValue)
            {
                this.OffsetX = x.Value;
            }
            if (y.HasValue)
            {
                this.OffsetY = y.Value;
            }
        }

        public bool GetLocationFromViewPoint(Point viewPoint, out RadFixedPage page, out Point location)
        {
            double top = 0;
            page = this.Document.Pages.Last();
            for (int i = 0; i < this.Document.Pages.Count; i++)
            {
                if (top + this.Document.Pages[i].ActualHeight > viewPoint.Y)
                {
                    page = this.Document.Pages[i];
                    break;
                }
                top += this.Document.Pages[i].ActualHeight;
            }

            location = new Point(viewPoint.X, viewPoint.Y - top);

            return true;
        }

        public bool GetViewPointFromLocation(RadFixedPage page, Point location, out Point viewPoint)
        {
            throw new NotImplementedException();
        }

        public void UpdatePresenterLayout()
        {
        }

        public void GoToPage(int pageNo)
        {
        }

        public void GoToDestination(Model.Navigation.Destination destination)
        {
        }

        public RadFixedPage CurrentPage
        {
            get { throw new NotImplementedException(); }
        }

        public event EventHandler<CurrentPageChangedEventArgs> CurrentPageChanged;

        private void OnCurrentPageChanged()
        {
            if (this.CurrentPageChanged != null)
            {
                this.CurrentPageChanged(this, new CurrentPageChangedEventArgs(this.CurrentPage));
            }
        }

        public void PageUp()
        {
            throw new NotImplementedException();
        }

        public void PageDown()
        {
            throw new NotImplementedException();
        }

        public void Initialize(RadFixedDocument document)
        {
            throw new NotImplementedException();
        }

        public void Release()
        {
            throw new NotImplementedException();
        }

        #endregion


        public PointerHandlersController MouseHandlersController
        {
            get { throw new NotImplementedException(); }
        }

        public void ShowSelectionIndicators()
        {
            throw new NotImplementedException();
        }

        public void HideSelectionIndicators()
        {
            throw new NotImplementedException();
        }


        public void ShowSelectionMarkers()
        {
            throw new NotImplementedException();
        }

        public void HideSelectionMarkers()
        {
            throw new NotImplementedException();
        }


        public bool ShouldShowSelectionMarkers
        {
            get { throw new NotImplementedException(); }
        }

        public void SetRotationAngle(RotationAngle angle)
        {
        }

        IFixedDocumentViewer IFixedDocumentPresenter.Owner
        {
            get { throw new NotImplementedException(); }
        }
    }
}
