﻿using System;
using System.IO;
using System.Linq;
using System.Threading;
using DPL_Visual;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.FixedDocumentViewers.Tests.Integration;
using Telerik.Windows.Documents.Fixed.Tests.Integration;


namespace Telerik.Windows.Documents.Fixed.Tests.Utils
{
    public static class VisualTestHelper
    {
        private static string TestName;
        private static int Counter = 1;

        public static void Assert(byte[] data, int wait = 4000)
        {
            ExportAndLoadPdf(data, wait);

            TestName = IntegrationTestClassBase.TestName + ".png";

            bool equality = ImageComparerHelper.CompareImages(TestName, 0.1, 0.1, 0.1);

            Microsoft.VisualStudio.TestTools.UnitTesting.Assert.IsTrue(equality);
        }

        public static void Assert(byte[] data, Action action, int repeatAction, int wait = 4000)
        {
            Assert(data, wait);

            for (int i = 0; i < repeatAction; i++)
            {
                action();
                TestName = IntegrationTestClassBase.TestName + (i + 1) + ".png";

                bool equality = ImageComparerHelper.CompareImages(TestName, 0.1, 0.1, 0.1);

                Microsoft.VisualStudio.TestTools.UnitTesting.Assert.IsTrue(equality);
            }
        }

        public static void ExportAndLoadPdf(byte[] data, int wait)
        {
            string fileName = IntegrationTestClassBase.TempFolder + Counter + IntegrationTestClassBase.PdfFileExtenssion;
            File.WriteAllBytes(fileName, data);
            Thread.Sleep(wait);
            System.Diagnostics.Process.Start(fileName);
            Thread.Sleep(wait);

            Counter++;
        }
    }
}
