﻿using Telerik.Windows.Documents.Flow.Model;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Common
{
    internal static class DocumentElementDocxExtensions
    {
        public static bool IsLastInSectionButNotLastInDocument(this Paragraph paragraph, Section parentSection)
        {
            if (parentSection == null)
            {
                // Paragraph is not in Section.
                return false;
            }

            if (parentSection.IsLastSectionInDocument())
            {
                return false;
            }

            if (parentSection.Blocks.Count == 0)
            {
                return false;
            }

            int lastBlockIndex = parentSection.Blocks.Count - 1;
            if (paragraph == parentSection.Blocks[lastBlockIndex])
            {
                return true;
            }

            return false;
        }

        private static bool IsLastSectionInDocument(this Section section)
        {
            if (section.Document.Sections.Count == 0)
            {
                return false;
            }

            int lastSectionIndex = section.Document.Sections.Count - 1;
            if (section == section.Document.Sections[lastSectionIndex])
            {
                return true;
            }

            return false;
        }
    }
}
