﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Export;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx
{
    /// <summary>
    /// Contains settings for export with <see cref="DocxFormatProvider"/>.
    /// </summary>
    public class DocxExportSettings : OpenXmlExportSettings
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocxExportSettings" /> class.
        /// </summary>
        public DocxExportSettings()
        {
            this.AutoUpdateFields = false;
            this.InvalidDocumentAction = Telerik.Windows.Documents.Flow.FormatProviders.Docx.InvalidDocumentAction.Repair;
            this.CompatibilityVersion = 15;
        }

        /// <summary>
        /// Gets or sets the value indicating if fields should be auto-updated when document is opened.
        /// </summary>
        /// <value>Should auto-update fields.</value>
        public bool AutoUpdateFields { get; set; }

        /// <summary>
        /// Gets or sets the action which will be executed when the document is invalid.
        /// </summary>
        /// <value>The action.</value>
        public InvalidDocumentAction InvalidDocumentAction { get; set; }

        internal int? CompatibilityVersion { get; set; }
    }
}