namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx
{
    /// <summary>
    /// Represents enumeration of available actions when the document is invalid during export with <see cref="DocxFormatProvider"/>.
    /// </summary>
    public enum InvalidDocumentAction
    {
        /// <summary>
        /// Export the document as is. This can result in document that is not compliant with Docx format.
        /// </summary>
        None,

        /// <summary>
        /// The format provider will try to repair the document when exporting.
        /// This can lead to modifications in the document structure.
        /// </summary>
        Repair,

        /// <summary>
        /// An exception will be thrown if the document structure is not compliant with Docx format.
        /// </summary>
        ThrowException
    }
}