﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common
{
    internal abstract class BoolValueElementBase : DocxElementBase
    {
        private readonly BoolOpenXmlAttribute valueAttribute;

        public BoolValueElementBase(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.valueAttribute = this.RegisterAttribute(new BoolOpenXmlAttribute("val", OpenXmlNamespaces.WordprocessingMLNamespace, true, false));
        }

        public bool Value
        {
            get
            {
                return this.valueAttribute.Value;
            }
            set
            {
                this.valueAttribute.Value = value;
            }
        }

        public override bool AlwaysExport
        {
            get
            {
                return true;
            }
        }
    }
}
