﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common
{
    internal abstract class DocxRequiredValueElementBase<T> : DocxElementBase
    {
        private readonly OpenXmlAttribute<T> value;

        public DocxRequiredValueElementBase(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.value = this.RegisterAttribute(new OpenXmlAttribute<T>("val", OpenXmlNamespaces.WordprocessingMLNamespace, true));
        }

        public T Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }

        public override bool AlwaysExport
        {
            get
            {
                return true;
            }
        }
    }
}
