﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Export;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Parts;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Document
{
    internal class DocumentElement : DocxPartRootElementBase
    {
        private readonly OpenXmlChildElement<BodyElement> bodyChildElement;

        public DocumentElement(DocxPartsManager partsManager, OpenXmlPartBase part)
            : base(partsManager, part)
        {
            this.bodyChildElement = this.RegisterChildElement<BodyElement>(DocxElementNames.Body);
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.Document;
            }
        }

        public override IEnumerable<OpenXmlNamespace> Namespaces
        {
            get
            {
                yield return OpenXmlNamespaces.OfficeDocumentRelationshipsNamespace;
            }
        }

        protected override void OnBeforeWrite(IDocxExportContext context)
        {
            this.CreateElement(this.bodyChildElement);
        }
    }
}
