﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Types;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Document
{
    internal abstract class HeaderFooterReferenceElementBase : DocxElementBase
    {
        private readonly OpenXmlAttribute<string> relationshipIdAttribute;
        private readonly MappedOpenXmlAttribute<HeaderFooterType> headerFooterTypeAttribute;

        public HeaderFooterReferenceElementBase(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.relationshipIdAttribute = this.RegisterAttribute(new OpenXmlAttribute<string>("id", OpenXmlNamespaces.OfficeDocumentRelationshipsNamespace, true));
            this.headerFooterTypeAttribute = this.RegisterAttribute(new MappedOpenXmlAttribute<HeaderFooterType>("type", OpenXmlNamespaces.WordprocessingMLNamespace, TypeMappers.HeaderFooterTypeMapper, true));
        }

        public string RelationshipId
        {
            get
            {
                return this.relationshipIdAttribute.Value;
            }
            set
            {
                this.relationshipIdAttribute.Value = value;
            }
        }

        public HeaderFooterType HeaderFooterType
        {
            get
            {
                return this.headerFooterTypeAttribute.Value;
            }
            set
            {
                this.headerFooterTypeAttribute.Value = value;
            }
        }
    }
}
