﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Types;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Document
{
    internal abstract class MergeElementBase : DocxElementBase
    {
        private readonly MappedOpenXmlAttribute<TableCellMergeType> valueAttribute;

        protected MergeElementBase(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.valueAttribute = this.RegisterAttribute(
                new MappedOpenXmlAttribute<TableCellMergeType>("val", OpenXmlNamespaces.WordprocessingMLNamespace, TypeMappers.TableCellMergeTypeMapper));
        }

        public TableCellMergeType TableCellMergeType
        {
            get
            {
                return this.valueAttribute.Value;
            }
            set
            {
                this.valueAttribute.Value = value;
            }
        }
    }
}
