﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Types;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Document
{
    internal class SectionTypeElement : DocxElementBase
    {
        private readonly MappedOpenXmlAttribute<SectionType> sectionTypeAttribute;

        public SectionTypeElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.sectionTypeAttribute = this.RegisterAttribute(new MappedOpenXmlAttribute<SectionType>("val", OpenXmlNamespaces.WordprocessingMLNamespace, TypeMappers.SectionTypeMapper));
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.SectionType;
            }
        }

        public SectionType SectionType
        {
            get
            {
                return this.sectionTypeAttribute.Value;
            }
            set
            {
                this.sectionTypeAttribute.Value = value;
            }
        }
    }
}