﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Types;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Document
{
    internal class TextDirectionElement : DocxElementBase
    {
        private readonly MappedOpenXmlAttribute<TextDirection> textDirection;

        public TextDirectionElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.textDirection =
               this.RegisterAttribute(new MappedOpenXmlAttribute<TextDirection>("val", OpenXmlNamespaces.WordprocessingMLNamespace, TypeMappers.TextDirectionMapper));
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.TextDirection;
            }
        }

        public TextDirection Value
        {
            get
            {
                return this.textDirection.Value;
            }
            set
            {
                this.textDirection.Value = value;
            }
        }
    }
}