﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Types;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Document
{
    internal class VerticalAlignmentElement : DocumentElementBase
    {
        private readonly MappedOpenXmlAttribute<VerticalAlignment> verticalAlignment;

        public VerticalAlignmentElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.verticalAlignment =
                this.RegisterAttribute(new MappedOpenXmlAttribute<VerticalAlignment>("val", OpenXmlNamespaces.WordprocessingMLNamespace, TypeMappers.VerticalAlignmentMapper));
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.VerticalAlignment;
            }
        }

        public VerticalAlignment Value
        {
            get
            {
                return this.verticalAlignment.Value;
            }
            set
            {
                this.verticalAlignment.Value = value;
            }
        }
    }
}
