﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Utilities;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Export;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Import;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements.Pictures;
using Telerik.Windows.Documents.Media;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Drawing
{
    internal class PictureFillElement : PictureFillElementBase
    {
        public PictureFillElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
        }

        public DocxPartsManager DocxPartsManager
        {
            get
            {
                return (DocxPartsManager)this.PartsManager;
            }
        }

        protected override ImageSource CreateImageSourceFromRelationshipId(IOpenXmlImportContext context, string relationshipId)
        {
            string target = this.PartsManager.GetRelationshipTarget(this.Part.Name, relationshipId);
            string resourceKey = this.Part.GetResourceName(target);

            try
            {
                return (ImageSource)context.GetResourceByResourceKey(resourceKey);
            }
            catch (KeyNotFoundException)
            {
                return null;
            }
        }

        protected override string CreateRelationshipIdFromImageSource(IOpenXmlExportContext context, ImageSource resource)
        {
            string resourceName = DocxHelper.CreateResourceName(resource);
            
            return this.PartsManager.CreateRelationship(this.Part.Name, resourceName, OpenXmlRelationshipTypes.GetRelationshipTypeByExtension(resource.Extension));
        }
    }
}
