﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Types;
using Telerik.Windows.Documents.Flow.Model.Lists;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Lists
{
    internal class MultiLevelTypeElement : DocxElementBase
    {
        private readonly MappedOpenXmlAttribute<MultilevelType> multiLevelTypeAttribute;

        public MultiLevelTypeElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.multiLevelTypeAttribute = new MappedOpenXmlAttribute<MultilevelType>("val", OpenXmlNamespaces.WordprocessingMLNamespace, TypeMappers.MultilevelTypeMapper, true);
            this.RegisterAttribute(this.multiLevelTypeAttribute);
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.MultiLevelType;
            }
        }

        public MultilevelType Value
        {
            get
            {
                return this.multiLevelTypeAttribute.Value;
            }

            set
            {
                this.multiLevelTypeAttribute.Value = value;
            }
        }
    }
}
