﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Settings
{
    internal class DocumentVariableElement : DocxElementBase
    {
        private readonly OpenXmlAttribute<string> name;
        private readonly OpenXmlAttribute<string> value;

        public DocumentVariableElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.name = this.RegisterAttribute<string>("name", OpenXmlNamespaces.WordprocessingMLNamespace);
            this.value = this.RegisterAttribute<string>("val", OpenXmlNamespaces.WordprocessingMLNamespace);
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.DocumentVariable;
            }
        }

        public string Name
        {
            get
            {
                return this.name.Value;
            }
            set
            {
                this.name.Value = value;
            }
        }

        public string Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }
    }
}