﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Styles.RunPropertiesElements
{
    internal class FontSizeElement : DocxElementBase
    {
        private readonly OpenXmlAttribute<double> valueAttribute;

        public FontSizeElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.valueAttribute = this.RegisterAttribute(new OpenXmlAttribute<double>("val", OpenXmlNamespaces.WordprocessingMLNamespace, true));
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.FontSize;
            }
        }

        public double Value
        {
            get
            {
                return this.valueAttribute.Value;
            }
            set
            {
                this.valueAttribute.Value = value;
            }
        }

        public override bool AlwaysExport
        {
            get
            {
                return true;
            }
        }
    }
}