﻿#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Types;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Theming;
#else
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Styles.RunPropertiesElements
{
    internal class ForegroundColorElement : DocxElementBase
    {
        private readonly ThemableColorAttributes colorAttributes;

        public ForegroundColorElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.colorAttributes = new ThemableColorAttributes(
                this.RegisterAttribute(new ConvertedOpenXmlAttribute<AutoColor>("val", OpenXmlNamespaces.WordprocessingMLNamespace, DocxConverters.AutoColorConverter)),
                this.RegisterAttribute(new MappedOpenXmlAttribute<ThemeColorType>("themeColor", OpenXmlNamespaces.WordprocessingMLNamespace, TypeMappers.ThemeColorTypeMapper)),
                this.RegisterAttribute(new ConvertedOpenXmlAttribute<double>("themeTint", OpenXmlNamespaces.WordprocessingMLNamespace, Converters.HexToTintConverter)),
                this.RegisterAttribute(new ConvertedOpenXmlAttribute<double>("themeShade", OpenXmlNamespaces.WordprocessingMLNamespace, Converters.HexToTintConverter)),
                Colors.Black);
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.ForegroundColor;
            }
        }

        public void FillAttributes(ThemableColor color, DocumentTheme theme)
        {
            this.colorAttributes.FillAttributes(color, theme);
        }

        public ThemableColor GetThemableColor()
        {
            ThemableColor color = this.colorAttributes.GetThemableColor();
            return color;
        }
    }
}