﻿#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Types;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Styles.RunPropertiesElements
{
    internal class HighlightElement : DocxElementBase
    {
        private readonly MappedOpenXmlAttribute<Color> colorAttribute;

        public HighlightElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.colorAttribute = new MappedOpenXmlAttribute<Color>(
                "val", OpenXmlNamespaces.WordprocessingMLNamespace, HighlightColors.Mapper);

            this.RegisterAttribute(this.colorAttribute);
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.Highlight;
            }
        }

        public Color Value
        {
            get
            {
                return this.colorAttribute.Value;
            }
            set
            {
                this.colorAttribute.Value = HighlightColors.GetNearestHighlightingColor(value);
            }
        }
    }
}