﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Styles.TablePropertiesElements
{
    internal class OverlapElement : DocxElementBase
    {
        private readonly OpenXmlAttribute<string> valueAttribute;

        public OverlapElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.valueAttribute = this.RegisterAttribute(new OpenXmlAttribute<string>("val", OpenXmlNamespaces.WordprocessingMLNamespace, true));
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.Overlap;
            }
        }

        public bool Value
        {
            get
            {
                if (this.valueAttribute.Value == "never")
                {
                    return false;
                }

                return true;
            }
            set
            {
                this.valueAttribute.Value = value == true ? "overlap" : "never";
            }
        }
    }
}
