﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Document;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Types;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Styles.TablePropertiesElements
{
    internal class TableLayoutTypeElement : DocumentElementBase
    {
        private readonly MappedOpenXmlAttribute<TableLayoutType> type;

        public TableLayoutTypeElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.type = this.RegisterAttribute(new MappedOpenXmlAttribute<TableLayoutType>("type", OpenXmlNamespaces.WordprocessingMLNamespace, TypeMappers.TableLayoutTypeMapper));
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.TableLayoutType;
            }
        }

        public void FillAttributes(TableProperties tableProperties)
        {
            this.type.Value = tableProperties.LayoutType.LocalValue.Value;
        }

        public void ReadAttributes(TableProperties tableProperties)
        {
            if (this.type.HasValue)
            {
                tableProperties.LayoutType.LocalValue = this.type.Value;
            }
        }
    }
}
