﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Common;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Types;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Styles.TableRowPropertiesElements
{
    internal class TableRowHeightElement : DocxElementBase
    {
        private readonly ConvertedOpenXmlAttribute<double> heightAttribute;
        private readonly MappedOpenXmlAttribute<HeightType> heightTypeAttribute;

        public TableRowHeightElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.heightAttribute = this.RegisterAttribute(new ConvertedOpenXmlAttribute<double>("val", OpenXmlNamespaces.WordprocessingMLNamespace, Converters.SignedTwipsMeasureToDipConverter));
            this.heightTypeAttribute = this.RegisterAttribute(new MappedOpenXmlAttribute<HeightType>("hRule", OpenXmlNamespaces.WordprocessingMLNamespace, TypeMappers.HeightTypeMapper));
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.TableRowHeight;
            }
        }

        public TableRowHeight Value
        {
            get
            {
                double heightValue = this.heightAttribute.Value;
                return new TableRowHeight(this.heightTypeAttribute.Value, heightValue);
            }
            set
            {
                this.heightAttribute.Value = value.Value;
                this.heightTypeAttribute.Value = value.Type;
            }
        }
    }
}
