﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Vector
{
    internal class FillElement : VectorElementBase
    {
        private readonly OpenXmlAttribute<double> opacity;

        public FillElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.opacity = this.RegisterAttribute<double>("opacity");
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.Fill;
            }
        }

        public double Opacity
        {
            get
            {
                return this.opacity.Value;
            }
            set
            {
                this.opacity.Value = value;
            }
        }
    }
}
