﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Vector
{
    internal class ImageDataElement : VectorElementBase
    {
        private readonly OpenXmlAttribute<string> id;

        public ImageDataElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.id = this.RegisterAttribute<string>("id", OpenXmlNamespaces.OfficeDocumentRelationshipsNamespace);
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.ImageData;
            }
        }

        public string Id
        {
            get
            {
                return this.id.Value;
            }
            set
            {
                this.id.Value = value;
            }
        }
    }
}
