﻿using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Vector
{
    internal class TextpathElement : VectorElementBase
    {
        private readonly OpenXmlAttribute<string> stringAttribute;
        private readonly OpenXmlAttribute<string> style;

        public TextpathElement(DocxPartsManager partsManager)
            : base(partsManager)
        {
            this.stringAttribute = this.RegisterAttribute(new OpenXmlAttribute<string>("string"));
            this.style = this.RegisterAttribute(new OpenXmlAttribute<string>("style"));
        }

        public override string ElementName
        {
            get
            {
                return DocxElementNames.Textpath;
            }
        }

        public string StringAttribute
        {
            get
            {
                return this.stringAttribute.Value;
            }
            set
            {
                this.stringAttribute.Value = value;
            }
        }

        public string Style
        {
            get
            {
                return this.style.Value;
            }
            set
            {
                this.style.Value = value;
            }
        }
    }
}
