﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Comments;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Parts
{
    internal class CommentsPart : DocxPartBase
    {
        private readonly CommentsElement commentsElement;

        public CommentsPart(DocxPartsManager partsManager)
            : this(partsManager, DocxPartNames.CommentsPartName)
        {
            this.PartsManager.CreateDocumentRelationship(this.Name, DocxRelationshipTypes.CommentsRelationshipType);
        }

        public CommentsPart(DocxPartsManager partsManager, string partName)
            : base(partsManager, partName)
        {
            this.commentsElement = new CommentsElement(this.PartsManager, this);
        }

        public override string ContentType
        {
            get
            {
                return DocxContentTypeNames.CommentsContentType;
            }
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level6;
            }
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return this.commentsElement;
            }
        }
    }
}