﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Document;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Parts
{
    internal class DocumentPart : DocxPartBase
    {
        private readonly DocumentElement documentElement;

        public DocumentPart(DocxPartsManager partsManager)
            : base(partsManager, DocxPartNames.DocumentPartName)
        {
            this.PartsManager.CreateApplicationRelationship(this.Name, DocxRelationshipTypes.OfficeDocumentRelationshipType);
            this.documentElement = new DocumentElement(this.PartsManager, this);
        }

        public DocumentPart(DocxPartsManager partsManager, string partName)
            : base(partsManager, partName)
        {
            this.documentElement = new DocumentElement(this.PartsManager, this);
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level4;
            }
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return this.documentElement;
            }
        }

        public override string ContentType
        {
            get
            {
                return DocxContentTypeNames.DocumentContentType;
            }
        }
    }
}
