﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Settings;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Parts
{
    internal class DocumentSettingsPart : DocxPartBase
    {
        private readonly SettingsElement settingsElement;

        public DocumentSettingsPart(DocxPartsManager partsManager)
            : this(partsManager, DocxPartNames.DocumentSettingsPartName)
        {
            this.PartsManager.CreateDocumentRelationship(this.Name, DocxRelationshipTypes.SettingsRelationshipType);
        }

        public DocumentSettingsPart(DocxPartsManager partsManager, string partName)
            : base(partsManager, partName)
        {
            this.settingsElement = new SettingsElement(this.PartsManager, this);
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return this.settingsElement;
            }
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level4;
            }
        }

        public override string ContentType
        {
            get
            {
                return DocxContentTypeNames.DocumentSettingsContentType;
            }
        }
    }
}
