﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Lists;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Parts
{
    internal class ListsPart : DocxPartBase
    {
        private readonly ListsElement listsElement;

        public ListsPart(DocxPartsManager partsManager)
            : this(partsManager, DocxPartNames.ListsPartName)
        {
            this.PartsManager.CreateDocumentRelationship(this.Name, DocxRelationshipTypes.ListsRelationshipType);
        }

        public ListsPart(DocxPartsManager partsManager, string partName)
            : base(partsManager, partName)
        {
            this.listsElement = new ListsElement(this.PartsManager, this);
        }

        public override string ContentType
        {
            get
            {
                return DocxContentTypeNames.ListsContentType;
            }
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level3;
            }
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return this.listsElement;
            }
        }
    }
}
