﻿using Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Elements.Styles;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Parts
{
    internal class StylesPart : DocxPartBase
    {
        private readonly StylesElement stylesElement;

        public StylesPart(DocxPartsManager partsManager)
            : this(partsManager, DocxPartNames.StylesPartName)
        {
            this.PartsManager.CreateDocumentRelationship(this.Name, DocxRelationshipTypes.StylesRelationshipType);
        }

        public StylesPart(DocxPartsManager partsManager, string partName)
            : base(partsManager, partName)
        {
            this.stylesElement = new StylesElement(this.PartsManager, this);
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return this.stylesElement;
            }
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level4;
            }
        }

        public override string ContentType
        {
            get
            {
                return DocxContentTypeNames.StylesContentType;
            }
        }
    }
}
