﻿using System.Globalization;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Model.Types
{
    internal class TableLookConverter : IStringConverter<TableLooks>
    {
        public TableLooks ConvertFromString(string hexValue)
        {
            int result;
            if (int.TryParse(hexValue, NumberStyles.HexNumber, CultureInfo.InvariantCulture, out result))
            {
                result = result >> 5;

                TableLooks returnValue = (TableLooks)result;
                returnValue ^= TableLooks.BandedColumns;
                returnValue ^= TableLooks.BandedRows;

                return returnValue;
            }

            return TableLooks.BandedColumns | TableLooks.BandedRows;
        }

        public string ConvertToString(TableLooks tableLook)
        {
            tableLook ^= TableLooks.BandedColumns;
            tableLook ^= TableLooks.BandedRows;

            int result = (int)tableLook;
            result = result << 5;

            return result.ToString("X4");
        }
    }
}
