﻿using System;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Docx.Validation
{
    internal class RepairRule<T> : IRepairRule
        where T : DocumentElementBase
    {
        private readonly Action<T> repairAction;

        public RepairRule(Action<T> repairAction)
        {
            Guard.ThrowExceptionIfNull(repairAction, "repairAction");

            this.repairAction = repairAction;
        }

        public void Repair(DocumentElementBase documentElement)
        {
            Guard.ThrowExceptionIfNull(documentElement, "documentElement");

            this.repairAction((T)documentElement);
        }
    }
}
