﻿using System.Text;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Export
{
    internal class CssWriter
    {
        private const string CssPropertyFormat = "{0}: {1};";

        private readonly StringBuilder writer;

        public CssWriter()
        {
            this.writer = new StringBuilder();
        }

        protected StringBuilder Writer
        {
            get
            {
                return this.writer;
            }
        }

        public void WriteStyleProperty(string name, string value)
        {
            Guard.ThrowExceptionIfNullOrEmpty(name, "name");
            Guard.ThrowExceptionIfNullOrEmpty(value, "value");

            this.writer.Append(string.Format(CssPropertyFormat, name, value));
            this.WriteStylePropertyOverride(name, value);
        }

        public string GetData()
        {
            return this.writer.ToString();
        }

        protected virtual void WriteStylePropertyOverride(string name, string value)
        {
        }
    }
}
