﻿using System.Collections.Generic;
using System.Globalization;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Export
{
    internal class ImageRepository
    {
        private const string ImageNamePrefix = "image";

        private readonly IdGenerator idGenerator;
        private readonly Dictionary<int, string> registeredImages;

        public ImageRepository()
        {
            this.idGenerator = new IdGenerator();
            this.registeredImages = new Dictionary<int, string>();
        }

        public bool TryGetImageName(int sourceId, out string imageName)
        {
            return this.registeredImages.TryGetValue(sourceId, out imageName);
        }

        public string RegisterImage(int sourceId)
        {
            int imageNumber = this.idGenerator.GetNext();
            string imageName = ImageNamePrefix + imageNumber.ToString(CultureInfo.InvariantCulture);

            this.registeredImages[sourceId] = imageName;

            return imageName;
        }
    }
}
