﻿using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Model;
using Telerik.Windows.Documents.Flow.Model.Styles;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Export
{
    internal static class StyleToElementSelectorMappings
    {
        private static readonly ValueMapper<string, string> elementStylesNames;

        static StyleToElementSelectorMappings()
        {
            elementStylesNames = new ValueMapper<string, string>();
            elementStylesNames.AddPair(BuiltInStyleNames.NormalWebStyleId, HtmlElementNames.Paragraph);
            elementStylesNames.AddPair(BuiltInStyleNames.GetHeadingStyleIdByIndex(1), HtmlElementNames.Heading1);
            elementStylesNames.AddPair(BuiltInStyleNames.GetHeadingStyleIdByIndex(2), HtmlElementNames.Heading2);
            elementStylesNames.AddPair(BuiltInStyleNames.GetHeadingStyleIdByIndex(3), HtmlElementNames.Heading3);
            elementStylesNames.AddPair(BuiltInStyleNames.GetHeadingStyleIdByIndex(4), HtmlElementNames.Heading4);
            elementStylesNames.AddPair(BuiltInStyleNames.GetHeadingStyleIdByIndex(5), HtmlElementNames.Heading5);
            elementStylesNames.AddPair(BuiltInStyleNames.GetHeadingStyleIdByIndex(6), HtmlElementNames.Heading6);
            elementStylesNames.AddPair(BuiltInStyleNames.HyperlinkStyleId, HtmlElementNames.Hyperlink);
        }

        public static IEnumerable<string> GetSelectors()
        {
            return elementStylesNames.ToValues.Where(selector => selector != HtmlElementNames.Paragraph);
        }

        public static bool TryGetElementSelector(string styleId, out string selector)
        {
            return elementStylesNames.TryGetToValue(styleId, out selector);
        }

        public static bool TryGetStyleId(string selector, out string styleId)
        {
            return elementStylesNames.TryGetFromValue(selector, out styleId);
        }
    }
}
