#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Spreadsheet.Model;
#else
using Telerik.Documents.Common.Model;
#endif
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html
{
    /// <summary>
    /// Represents a collection of generic fonts that will be used during Html import.
    /// </summary>
    public class GenericHtmlFonts
    {
        private ThemableFontFamily cursive;
        private ThemableFontFamily fantasy;
        private ThemableFontFamily monospace;
        private ThemableFontFamily sansSerif;
        private ThemableFontFamily serif;

        internal GenericHtmlFonts()
        {
            this.Cursive = new ThemableFontFamily("Comic Sans MS");
            this.Fantasy = new ThemableFontFamily("Algerian");
            this.Monospace = new ThemableFontFamily("Courier New");
            this.SansSerif = new ThemableFontFamily("Arial");
            this.Serif = new ThemableFontFamily("Times New Roman");
        }

        /// <summary>
        /// Gets or sets the cursive generic font.
        /// </summary>
        /// <value>The cursive.</value>
        public ThemableFontFamily Cursive
        {
            get
            {
                return this.cursive;
            }
            set
            {
                Guard.ThrowExceptionIfNull(value, "value");
                this.cursive = value;
            }
        }

        /// <summary>
        /// Gets or sets the fantasy generic font.
        /// </summary>
        /// <value>The fantasy generic font.</value>
        public ThemableFontFamily Fantasy
        {
            get
            {
                return this.fantasy;
            }
            set
            {
                Guard.ThrowExceptionIfNull(value, "value");
                this.fantasy = value;
            }
        }

        /// <summary>
        /// Gets or sets the monospace generic font.
        /// </summary>
        /// <value>The monospace generic font.</value>
        public ThemableFontFamily Monospace
        {
            get
            {
                return this.monospace;
            }
            set
            {
                Guard.ThrowExceptionIfNull(value, "value");
                this.monospace = value;
            }
        }

        /// <summary>
        /// Gets or sets the sans-serif generic font.
        /// </summary>
        /// <value>The sans-serif generic font.</value>
        public ThemableFontFamily SansSerif
        {
            get
            {
                return this.sansSerif;
            }
            set
            {
                Guard.ThrowExceptionIfNull(value, "value");
                this.sansSerif = value;
            }
        }

        /// <summary>
        /// Gets or sets the serif generic font.
        /// </summary>
        /// <value>The serif generic font.</value>
        public ThemableFontFamily Serif
        {
            get
            {
                return this.serif;
            }
            set
            {
                Guard.ThrowExceptionIfNull(value, "value");
                this.serif = value;
            }
        }
    }
}