﻿using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Styles;
#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Spreadsheet.Model;
#else
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Import
{
    internal static class HtmlImportDocumentFactory
    {
        private const int NormalStyleFontSize = 16;
        private static readonly ThemableFontFamily defaultFontFamily;

        static HtmlImportDocumentFactory()
        {
            HtmlImportDocumentFactory.defaultFontFamily = new ThemableFontFamily("Times New Roman");
        }

        public static RadFlowDocument CreateDocumentForImport()
        {
            RadFlowDocument document = new RadFlowDocument();

            ModifyBuiltInStyles(document);

            return document;
        }

        private static void ModifyBuiltInStyles(RadFlowDocument document)
        {
            document.DefaultStyle.CharacterProperties.FontFamily.LocalValue = HtmlImportDocumentFactory.defaultFontFamily;
            document.DefaultStyle.CharacterProperties.FontSize.ClearValue();
            document.DefaultStyle.ParagraphProperties.SpacingAfter.ClearValue();
            document.DefaultStyle.ParagraphProperties.LineSpacing.ClearValue();
            document.DefaultStyle.ParagraphProperties.LineSpacingType.ClearValue();

            document.StyleRepository.GetStyle(BuiltInStyleNames.NormalStyleId).CharacterProperties.FontSize.LocalValue = NormalStyleFontSize;
        }
    }
}