﻿using System.Collections.Generic;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Import
{
    internal class ListImportContext
    {
        private readonly Stack<ListLevelContentImporter> listLevelContentImporters;

        public ListImportContext()
        {
            this.listLevelContentImporters = new Stack<ListLevelContentImporter>();
        }

        public ListLevelContentImporter CurrentListLevelContentImporter
        {
            get
            {
                return this.listLevelContentImporters.Peek();
            }
        }

        public bool IsInListLevel
        {
            get
            {
                return this.listLevelContentImporters.Count > 0;
            }
        }

        public void BeginListLevel()
        {
            this.listLevelContentImporters.Push(new ListLevelContentImporter());
        }

        public void EndListLevel()
        {
            this.listLevelContentImporters.Pop();
        }
    }
}