﻿namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Import
{
    internal class ListLevelContentImporter
    {
        private const int ChildIndexDefaultValue = -1;

        private int childIndex;
        private bool shouldImportOnlyInlines;
        private bool shouldApplyIndentationOnParagraph;

        public ListLevelContentImporter()
        {
            this.childIndex = ChildIndexDefaultValue;
            this.shouldApplyIndentationOnParagraph = false;
            this.shouldImportOnlyInlines = false;
        }

        internal bool ShouldApplyIndentationOnParagraph
        {
            get
            {
                return this.shouldApplyIndentationOnParagraph;
            }
        }

        internal bool ShouldCreateParagraph
        {
            get
            {
                return !this.shouldImportOnlyInlines && this.childIndex != 0;
            }
        }

        internal void BeginChildRead()
        {
            this.shouldApplyIndentationOnParagraph = ++this.childIndex > 0;
        }

        internal void EndChildRead(bool isReadParagraphEmpty)
        {
            // There is an empty line or string empty text as a first child element of the <li> element.
            this.shouldImportOnlyInlines = this.childIndex == 0 && isReadParagraphEmpty;
        }
    }
}