﻿// Copyright (c) 2012 James Treworgy
// 
// LICENSE (MIT License)
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights to 
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
// of the Software, and to permit persons to whom the Software is furnished to do 
// so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
// PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION 
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CsQuery.Implementation
{
    /// <summary>
    /// A single CSS style definition.
    /// </summary>

    internal class CssStyle : ICSSStyle
    {
        /// <summary>
        /// The name of the style.
        /// </summary>

        public string Name { get; set; }

        /// <summary>
        /// The type of data contained by this style.
        /// </summary>

        public CSSStyleType Type { get; set; }

        /// <summary>
        /// Gets or sets a format required by this style.
        /// </summary>

        public string Format { get; set; }

        /// <summary>
        /// A description of this style.
        /// </summary>

        public string Description { get; set; }

        /// <summary>
        /// The acceptable options for Option-type styles.
        /// </summary>

        public HashSet<string> Options { get; set; }

    }
}
