﻿// Copyright (c) 2012 James Treworgy
// 
// LICENSE (MIT License)
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights to 
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
// of the Software, and to permit persons to whom the Software is furnished to do 
// so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
// PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION 
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CsQuery
{
    /// <summary>
    /// Values that represent NodeType.
    /// </summary>

    internal enum NodeType : byte
    {
        /// <summary>
        /// An element node.
        /// </summary>
        ELEMENT_NODE = 1,
        
        //ATTRIBUTE_NODE =2,
        /// <summary>
        /// A text node.
        /// </summary>
        TEXT_NODE = 3,
        /// <summary>
        /// A CDATA node.
        /// </summary>
        CDATA_SECTION_NODE = 4,
        //ENTITY_REFERENCE_NODE = 5,
        //ENTITY_NODE=  6,
        //PROCESSING_INSTRUCTION_NODE =7,
        /// <summary>
        /// A comment node.
        /// </summary>
        COMMENT_NODE = 8,
        /// <summary>
        /// A document node.
        /// </summary>
        DOCUMENT_NODE = 9,
        /// <summary>
        /// The DOCTYPE node.
        /// </summary>
        DOCUMENT_TYPE_NODE = 10,
        /// <summary>
        /// A document fragment node.
        /// </summary>
        DOCUMENT_FRAGMENT_NODE = 11,
        //NOTATION_NODE  =12
    }
}
