﻿// Copyright (c) 2012 James Treworgy
// 
// LICENSE (MIT License)
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights to 
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
// of the Software, and to permit persons to whom the Software is furnished to do 
// so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
// PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION 
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// TODO this should be fully commented; however it's not part of the main public API

#pragma warning disable 1591
#pragma warning disable 1570


namespace CsQuery.EquationParser.Implementation.Functions
{

    internal class Abs : Function
    {
        public Abs()
            : base("abs")
        {

        }

        protected override IConvertible GetValue()
        {
            IConvertible value = FirstOperand.Value;

            if (Utils.IsIntegralType(value))
            {
                return Math.Abs(Convert.ToInt64(value));
            }
            else
            {
                return Math.Abs(Convert.ToDouble(value));
            }
        }
       
        
        public override int RequiredParmCount
        {
            get { return 1; }
        }

        public override int MaxParmCount
        {
            get { return 1; }
        }

        public override AssociationType AssociationType
        {
            get { return AssociationType.Function; }
        }

        protected override IOperand GetNewInstance()
        {
            return new Abs();
        }

        //protected override IOperand<U> CloneAsImpl<U>()
        //{
        //    throw new NotImplementedException();
        //}
    }

    //public class Abs<T> : Abs, IFunction<T> where T: IConvertible
    //{

    //    public new T Value
    //    {
    //        get { 
    //            return (T)GetValue(); 
    //        }
    //    }

    //    public new IOperand<T> Clone()
    //    {
    //        return new Abs<T>();
    //    }
    //}
}
