﻿// Copyright (c) 2012 James Treworgy
// 
// LICENSE (MIT License)
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights to 
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
// of the Software, and to permit persons to whom the Software is furnished to do 
// so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
// PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION 
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// TODO this should be fully commented; however it's not part of the main public API

#pragma warning disable 1591
#pragma warning disable 1570


namespace CsQuery.EquationParser.Implementation.Functions
{

    internal class Sum : NativeOperation, IOperation
    {
        public Sum()
            : base("sum")
        {

        }
        public Sum(params IConvertible[] operands)
            : base("sum", operands)
        {
        }

        public override AssociationType AssociationType
        {
            get { return AssociationType.Addition; }
        }
        protected override IOperand GetNewInstance()
        {
            return new Sum();
        }
        protected override OperationType PrimaryOperator
        {
            get { return OperationType.Addition; }
        }
        protected override OperationType ComplementaryOperator
        {
            get { return OperationType.Subtraction; }
        }
    }
    internal class Sum<T> : Sum, IFunction<T> where T : IConvertible
    {
        public Sum()
            : base()
        {
        }

        public Sum(params IConvertible[] operands)
            : base( operands)
        {
        }
 
        public new T Value
        {
            get { return (T)Convert.ChangeType(GetValue(),typeof(T)); }
        }

        protected override IOperand GetNewInstance()
        {
            return new Sum<T>();
        }

        public new Sum<T> Clone()
        {
            return (Sum<T>)Clone();
        }

        IOperand<T> IOperand<T>.Clone()
        {
            return Clone();
        }
    }

}
