﻿// Copyright (c) 2012 James Treworgy
// 
// LICENSE (MIT License)
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights to 
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
// of the Software, and to permit persons to whom the Software is furnished to do 
// so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
// PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION 
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CsQuery.EquationParser.Implementation
{

    interface IIntegerValue : IComparable, IConvertible,
        IEquatable<byte>, IEquatable<short>, IEquatable<ushort>,
        IEquatable<int>, IEquatable<uint>,
        IEquatable<long>, IEquatable<ulong>,
        IEquatable<double>, IEquatable<float>,
        IComparable<byte>, IComparable<short>, IComparable<ushort>,
        IComparable<int>, IComparable<uint>,
        IComparable<long>, IComparable<ulong>
    {

    }
    interface INumericValue : IIntegerValue,
        IComparable<double>, IComparable<float>, IComparable<decimal>,
        IEquatable<double>, IEquatable<float>, IEquatable<decimal>
    {

    }
    interface ITextValue : IComparable, IConvertible,
        IComparable<string>, IComparable<char>,
        IEquatable<string>, IEquatable<char>
    {

    }
    interface IBooleanValue : IComparable, IConvertible,
        IComparable<bool>, IEquatable<bool>
    {

    }
}
