﻿// Copyright (c) 2012 James Treworgy
// 
// LICENSE (MIT License)
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights to 
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
// of the Software, and to permit persons to whom the Software is furnished to do 
// so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in all 
// copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
// PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION 
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CsQuery
{
    /// <summary>
    /// The methodology applied when parsing strings of HTML
    /// </summary>

    internal enum HtmlParsingMode : byte
    {
        
        /// <summary>
        /// Automatically detect the document type. When no DocType node is provided, will default to FragmentWithSelfClosingTags.
        /// </summary>
        
        Auto = 0,

        /// <summary>
        /// A fragment whose context is determined by the first tag.
        /// </summary>
        
        Fragment = 1,
        
        /// <summary>
        /// A content block, assumed to be in BODY context.
        /// </summary>
        
        Content = 2,
        
        /// <summary>
        /// A complete document; the HTML and BODY tag constructs will be addded if missing..
        /// </summary>
        
        Document = 3
    }
}
