﻿// Copyright (c) 2013 Milkshake Software (http://milkshakesoftware.com)
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System.Text.RegularExpressions;

namespace PreMailer.Net
{
    internal class CssSelector
	{
		protected static Regex NotMatcher = new Regex(@":not\((.+)\)", RegexOptions.IgnoreCase & RegexOptions.Compiled);

		public string Selector { get; protected set; }

		public bool HasNotPseudoClass
		{
			get
			{
				return NotMatcher.IsMatch(Selector);
			}
		}
		
		public string NotPseudoClassContent
		{
			get
			{
				var match = NotMatcher.Match(Selector);
				return match.Success ? match.Groups[1].Value : null;
			}
		}

		public CssSelector(string selector)
		{
			Selector = selector;
		}

		public CssSelector StripNotPseudoClassContent()
		{
			var stripped = NotMatcher.Replace(Selector, string.Empty);
			return new CssSelector(stripped);
		}

		public override string ToString()
		{
			return Selector;
		}
	}
}