﻿using CsQuery;
using System.Linq;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Import
{
    internal class StyleNamesResolver
    {
        private readonly CQ cq;

        public StyleNamesResolver(CQ cq)
        {
            Guard.ThrowExceptionIfNull(cq, "cq");

            this.cq = cq;
        }

        public StyleNamesInfo Resolve()
        {
            StyleNamesInfo stylesNames = new StyleNamesInfo();

            stylesNames.CharacterStyles = this.cq.Select("span[class]")
                                                .Select(s => s.Classes.First())
                                                .Distinct()
                                                .ToList();

            stylesNames.ParagraphStyles = this.cq.Select("p[class]")
                                                .Select(p => p.Classes.First())
                                                .Distinct()
                                                .ToList();

            stylesNames.TableStyles = this.cq.Select("table[class]")
                                            .Select(t => t.Classes.First())
                                            .Distinct()
                                            .ToList();

            return stylesNames;
        }
    }
}