﻿using Telerik.Windows.Documents.Flow.FormatProviders.Html.Export;
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Import;
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Styles;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Attributes
{
    internal class StyleAttribute : HtmlAttribute<HtmlStyleProperties>
    {
        public StyleAttribute()
            : base("style")
        {
            this.Value = new HtmlStyleProperties();
        }

        public override bool ShouldExport()
        {
            return this.Value.HasProperties;
        }

        public override string GetValue()
        {
            CssWriter writer = new CssWriter();
            this.Value.Write(writer);

            return writer.GetData();
        }

        public override void SetValue(string value)
        {
            InlineCssReader reader = new InlineCssReader();

            reader.ReadStyleProperties(this.Value, value);
        }

        public override void ResetValue()
        {
            this.Value.ClearProperties();
        }
    }
}
