﻿using System;
#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Export;
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Import;
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Styles;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Converters
{
    internal class ColorMediaConverter : StringConverterBase<Color>
    {
        public override bool Convert(IHtmlImportContext context, HtmlStyleProperty property, DocumentElementPropertiesBase properties, out Color result)
        {
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(property, "property");

            try
            {
                object color = ColorConverter.ConvertFromString(property.Values[0].Value);
                result = (Color)color;

                return true;
            }
            catch (FormatException)
            {
                result = Colors.Transparent;
                return false;
            }
        }

        public override bool ConvertBack(IHtmlExportContext context, Color value, DocumentElementPropertiesBase properties, out string result)
        {
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(value, "value");

            string color = "#" + value.R.ToString("X2") + value.G.ToString("X2") + value.B.ToString("X2");

            result = color;
            return true;
        }
    }
}
