﻿using Telerik.Windows.Documents.Flow.FormatProviders.Html.Export;
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Import;
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Styles;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.Media;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Converters
{
    internal class DoubleConverter : StringConverterBase<double>
    {
        public override bool Convert(IHtmlImportContext context, HtmlStyleProperty property, DocumentElementPropertiesBase properties, out double result)
        {
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(property, "property");

            HtmlStylePropertyValue firstValue = property.Values[0];
            result = firstValue.ValueAsDouble;
            if (firstValue.UnitType.HasValue)
            {
                if (!Unit.IsRelativeUnitType(firstValue.UnitType.Value))
                {
                    result = Unit.UnitToDip(result, firstValue.UnitType.Value);
                }
            }

            return !double.IsNaN(result);
        }

        public override bool ConvertBack(IHtmlExportContext context, double value, DocumentElementPropertiesBase properties, out string result)
        {
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(value, "value");

            result = CssValueTypesHelper.ConvertToPixels(context, value);

            return true;
        }
    }
}
