﻿using Telerik.Windows.Documents.Flow.Model.Lists;
using Telerik.Windows.Documents.Flow.Model.Styles;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Converters
{
    internal static class HtmlConverters
    {
        static HtmlConverters()
        {
            FontStyleConverter = new FontStyleConverter();
            FontWeightConverter = new FontWeightConverter();
            ThemableColorConverter = new ThemableColorConverter();
            UnderlinePatternConverter = new UnderlinePatternConverter();
            UnderlineColorConverter = new UnderlineColorConverter();
            StrikethroughConverter = new StrikethroughConverter();
            AlignmentConverter = new AlignmentConverter();
            DoubleConverter = new DoubleConverter();
            SpacingAfterConverter = new SpacingAfterConverter();
            SpacingBeforeConverter = new SpacingBeforeConverter();
            AutomaticSpacingAfterConverter = new AutomaticSpacingAfterConverter();
            AutomaticSpacingBeforeConverter = new AutomaticSpacingBeforeConverter();
            ThemableFontFamilyConverter = new ThemableFontFamilyConverter();
            ColorMediaConverter = new ColorMediaConverter();
            FlowDirectionConverter = new FlowDirectionConverter();
            LineSpacingTypeConverter = new LineSpacingTypeConverter();
            FontSizeConverter = new FontSizeConverter();
            PreferredWidthConverter = new PreferredWidthConverter();
            BaselineAlignmentConverter = new MappedConverter<BaselineAlignment>(HtmlValueMappers.BaselineAlignmentMapper);
            TableLayoutTypeConverter = new MappedConverter<TableLayoutType>(HtmlValueMappers.TableLayoutTypeMapper);
            VerticalAlignmentConverter = new MappedConverter<VerticalAlignment>(HtmlValueMappers.VerticalAlignmentMapper);
            CellSpacingConverter = new CellSpacingConverter();
            TableBordersConverter = new TableBordersConverter();
            TableBordersColorConverter = new TableBordersColorConverter();
            BorderConverter = new BorderConverter();
            LineSpacingConverter = new LineSpacingConverter();
            RowHeightConverter = new RowHeightConverter();
            TableCellBordersConverter = new TableCellBordersConverter();
            BorderCollapseConverter = new BorderCollapseConverter();
            PaddingConverter = new PaddingConverter();
            PaddingShortHandConverter = new PaddingShortHandConverter();
            ListNumberingStyleTypeConverter = new MappedConverter<NumberingStyle>(HtmlValueMappers.NumberingStyleTypeMapper);
            FirstLineIndentConverter = new FirstLineIndentConverter();
            HangingIndentConverter = new HangingIndentConverter();
        }

        public static FirstLineIndentConverter FirstLineIndentConverter { get; private set; }
        public static HangingIndentConverter HangingIndentConverter { get; private set; }
        public static FontStyleConverter FontStyleConverter { get; private set; }
        public static FontWeightConverter FontWeightConverter { get; private set; }
        public static ThemableColorConverter ThemableColorConverter { get; private set; }
        public static UnderlinePatternConverter UnderlinePatternConverter { get; private set; }
        public static UnderlineColorConverter UnderlineColorConverter { get; private set; }
        public static StrikethroughConverter StrikethroughConverter { get; private set; }
        public static AlignmentConverter AlignmentConverter { get; private set; }
        public static DoubleConverter DoubleConverter { get; private set; }
        public static ThemableFontFamilyConverter ThemableFontFamilyConverter { get; private set; }
        public static ColorMediaConverter ColorMediaConverter { get; private set; }
        public static FlowDirectionConverter FlowDirectionConverter { get; private set; }
        public static LineSpacingTypeConverter LineSpacingTypeConverter { get; private set; }
        public static FontSizeConverter FontSizeConverter { get; private set; }
        public static PreferredWidthConverter PreferredWidthConverter { get; private set; }
        public static MappedConverter<BaselineAlignment> BaselineAlignmentConverter { get; private set; }
        public static MappedConverter<TableLayoutType> TableLayoutTypeConverter { get; private set; }
        public static MappedConverter<VerticalAlignment> VerticalAlignmentConverter { get; private set; }
        public static CellSpacingConverter CellSpacingConverter { get; private set; }
        public static TableBordersConverter TableBordersConverter { get; private set; }
        public static TableBordersColorConverter TableBordersColorConverter { get; private set; }
        public static TableCellBordersConverter TableCellBordersConverter { get; private set; }
        public static BorderConverter BorderConverter { get; private set; }
        public static LineSpacingConverter LineSpacingConverter { get; private set; }
        public static RowHeightConverter RowHeightConverter { get; private set; }
        public static PaddingConverter PaddingConverter { get; private set; }
        public static PaddingShortHandConverter PaddingShortHandConverter { get; private set; }

        public static SpacingAfterConverter SpacingAfterConverter { get; private set; }
        public static SpacingBeforeConverter SpacingBeforeConverter { get; private set; }
        public static AutomaticSpacingAfterConverter AutomaticSpacingAfterConverter { get; private set; }
        public static AutomaticSpacingBeforeConverter AutomaticSpacingBeforeConverter { get; private set; }

        public static BorderCollapseConverter BorderCollapseConverter { get; private set; }

        public static MappedConverter<NumberingStyle> ListNumberingStyleTypeConverter { get; private set; }
    }
}