﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Converters
{
    internal class NumericAttributeToPixelUnitTypeConverter : ILegacyConverter
    {
        private const string PixelUnitType = "px";

        public bool TryGetConvertedValue(string value, out string convertedValue)
        {
            Guard.ThrowExceptionIfNullOrEmpty(value, "value");

            convertedValue = string.Empty;

            string firstNumberValue = value.Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries).FirstOrDefault();
            if (IsStringANumber(firstNumberValue))
            {
                convertedValue = string.Concat(firstNumberValue, PixelUnitType);
                return true;
            }

            return false;
        }

        private static bool IsStringANumber(string numberCandidate)
        {
            if (string.IsNullOrEmpty(numberCandidate))
            {
                return false;
            }

            bool isNumber = true;
            foreach (char ch in numberCandidate)
            {
                if (!char.IsDigit(ch))
                {
                    isNumber = false;
                    break;
                }
            }

            return isNumber;
        }
    }
}