﻿using Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Styles;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.Flow.Model.Styles.Core;
#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Spreadsheet.Model;
#else
using Telerik.Documents.Common.Model;
#endif
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Converters
{
    internal class UnderlineColorConverter : StringConverterBase<ThemableColor>
    {
        public override bool Convert(Import.IHtmlImportContext context, HtmlStyleProperty property, DocumentElementPropertiesBase properties, out ThemableColor result)
        {
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(property, "property");

            if (property.Values[0].Value == "underline")
            {
                IStyleProperty styleProperty = properties.GetStyleProperty(Run.ForegroundColorPropertyDefinition);
                if (styleProperty != null)
                {
                    result = (ThemableColor)styleProperty.GetActualValueAsObject();
                    return true;
                }
            }

            result = null;
            return false;
        }

        public override bool ConvertBack(Export.IHtmlExportContext context, ThemableColor value, DocumentElementPropertiesBase properties, out string result)
        {
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(value, "value");

            // Cannot convert back.
            result = null;
            return false;
        }
    }
}
