﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Export;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Elements
{
    internal abstract class BlockContainerElementBase : BodyElementBase
    {
        private BlockContainerBase blockContainer;

        public BlockContainerElementBase(HtmlContentManager contentManager)
            : base(contentManager)
        {
        }

        protected BlockContainerBase AssociatedBlockContainer
        {
            get
            {
                return this.blockContainer;
            }
        }

        public void SetAssociatedFlowElement(BlockContainerBase blockContainer)
        {
            Guard.ThrowExceptionIfNull(blockContainer, "blockContainer");

            this.blockContainer = blockContainer;
        }

        protected override IEnumerable<HtmlElementBase> OnEnumerateInnerElements(IHtmlWriter writer, IHtmlExportContext context)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            foreach (HtmlElementBase element in this.ContentManager.ExportBlockContainer(context, this.blockContainer))
            {
                yield return element;
            }
        }

        protected override void ClearOverride()
        {
            base.ClearOverride();

            this.blockContainer = null;
        }
    }
}
