﻿using Telerik.Windows.Documents.Flow.FormatProviders.Html.Import;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Elements
{
    internal class BlockElement : BodyElementBase
    {
        private readonly string name;

        public BlockElement(HtmlContentManager contentManager, string name)
            : base(contentManager)
        {
            Guard.ThrowExceptionIfNullOrEmpty(name, "name");

            this.name = name;
        }

        public override string Name
        {
            get
            {
                return this.name;
            }
        }

        protected override void OnBeforeRead(IHtmlReader reader, IHtmlImportContext context)
        {
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");

            context.EndParagraph();
        }
    }
}
