﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Export;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Elements
{
    internal class BodyElement : BlockContainerElementBase
    {
        public BodyElement(HtmlContentManager contentManager)
            : base(contentManager)
        {
        }

        public override string Name
        {
            get
            {
                return HtmlElementNames.Body;
            }
        }

        protected override IEnumerable<HtmlElementBase> OnEnumerateInnerElements(IHtmlWriter writer, IHtmlExportContext context)
        {
            Guard.ThrowExceptionIfNull(writer, "writer");
            Guard.ThrowExceptionIfNull(context, "context");

            foreach (Section section in context.Document.Sections)
            {
                foreach (HtmlElementBase element in this.ContentManager.ExportBlockContainer(context, section))
                {
                    yield return element;
                }
            }
        }
    }
}
