﻿using Telerik.Windows.Documents.Flow.FormatProviders.Html.Import;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Elements
{
    internal class DefaultElement : BodyElementBase
    {
        public DefaultElement(HtmlContentManager contentManager)
            : base(contentManager)
        {
        }

        public override string Name
        {
            get
            {
                return HtmlElementNames.Default;
            }
        }

        protected override void OnReadInnerText(IHtmlReader reader, IHtmlImportContext context, string text)
        {
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNullOrEmpty(text, "text");

            TextElement textElement = this.CreateElement<TextElement>(HtmlElementNames.Text);

            this.OnBeforeReadChildElement(reader, context, textElement);
            textElement.InnerText = text;
            this.OnAfterReadChildElement(reader, context, textElement);
        }
    }
}
