﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Export;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Elements
{
    internal class HeadElement : HtmlElementBase
    {
        public HeadElement(HtmlContentManager contentManager)
            : base(contentManager)
        {
        }

        public override string Name
        {
            get
            {
                return HtmlElementNames.Head;
            }
        }

        protected override IEnumerable<HtmlElementBase> OnEnumerateInnerElements(IHtmlWriter writer, IHtmlExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            switch (context.Settings.StylesExportMode)
            {
                case StylesExportMode.Embedded:

                    StyleElement style = this.CreateElement<StyleElement>(HtmlElementNames.Style);

                    yield return style;

                    break;

                case StylesExportMode.External:

                    LinkElement link = this.CreateElement<LinkElement>(HtmlElementNames.Link);

                    yield return link;

                    break;
            }

            yield return this.CreateElement<TitleElement>(HtmlElementNames.Title);
        }
    }
}
