﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Flow.FormatProviders.Html.Export;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Elements
{
    internal class HtmlElement : HtmlElementBase
    {
        public HtmlElement(HtmlContentManager contentManager)
            : base(contentManager)
        {
        }

        public override Documents.Common.FormatProviders.XmlBased.Model.Namespaces.XmlNamespace Namespace
        {
            get
            {
                return HtmlNamespaces.XHtmlNamespace;
            }
        }

        public override string Name
        {
            get
            {
                return HtmlElementNames.Html;
            }
        }

        protected override IEnumerable<HtmlElementBase> OnEnumerateInnerElements(IHtmlWriter writer, IHtmlExportContext context)
        {
            HeadElement head = this.CreateElement<HeadElement>(HtmlElementNames.Head);

            yield return head;

            BodyElement body = this.CreateElement<BodyElement>(HtmlElementNames.Body);

            yield return body;
        }
    }
}
