﻿using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Flow.Model.Lists;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Elements.Lists
{
    internal class HtmlListManager
    {
        private readonly List<BulletListInfo> bulletListInfos;

        private ListIndexes listIndexes;

        public HtmlListManager()
        {
            this.bulletListInfos = new List<BulletListInfo>();

            this.Initialize();
        }

        internal ListIndexes ListIndexes
        {
            get
            {
                return this.listIndexes;
            }
            set
            {
                this.listIndexes = value;
            }
        }

        internal BulletListInfo GetBulletListInfoBySymbol(string bulletSymbol)
        {
            return this.bulletListInfos.Where(b => b.BulletSymbol == bulletSymbol).FirstOrDefault();
        }

        internal BulletListInfo GetBulletListInfoByHtmlName(string htmlName)
        {
            return this.bulletListInfos.Where(b => b.HtmlName == htmlName).FirstOrDefault();
        }

        private void Initialize()
        {
            this.bulletListInfos.Add(new BulletListInfo("disc", ListFactory.BulletSymbols[0], ListFactory.BulletsFontFamily[0]));
            this.bulletListInfos.Add(new BulletListInfo("circle", ListFactory.BulletSymbols[1], ListFactory.BulletsFontFamily[1]));
            this.bulletListInfos.Add(new BulletListInfo("square", ListFactory.BulletSymbols[2], ListFactory.BulletsFontFamily[2]));
        }
    }
}