﻿using Telerik.Windows.Documents.Flow.FormatProviders.Html.Import;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Elements.Tables
{
    internal abstract class TableRowContainerElement : BodyElementBase
    {
        public TableRowContainerElement(HtmlContentManager contentManager)
            : base(contentManager)
        {
        }

        protected abstract RowType RowType { get; }

        protected override void OnBeforeReadChildElement(IHtmlReader reader, IHtmlImportContext context, HtmlElementBase innerElement)
        {
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(innerElement, "innerElement");

            base.OnBeforeReadChildElement(reader, context, innerElement);

            switch (innerElement.Name)
            {
                case HtmlElementNames.TableRow:
                    ((TableRowElement)innerElement).SetRowType(this.RowType);

                    break;
            }
        }
    }
}
