﻿using Telerik.Windows.Documents.Flow.FormatProviders.Html.Import;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Elements.Text
{
    internal class LineBreakElement : BodyElementBase, IPhrasingElement
    {
        public LineBreakElement(HtmlContentManager contentManager)
            : base(contentManager)
        {
        }

        public override string Name
        {
            get
            {
                return HtmlElementNames.LineBreak;
            }
        }

        protected override void OnAfterRead(IHtmlReader reader, IHtmlImportContext context)
        {
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");

            Break b = new Break(context.Document);
            b.BreakType = BreakType.LineBreak;

            context.InsertInline(b);
        }
    }
}
