﻿using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Elements
{
    internal class TextElement : HtmlElementBase
    {
        public TextElement(HtmlContentManager contentManager)
            : base(contentManager)
        {
        }

        public override string Name
        {
            get
            {
                return HtmlElementNames.Text;
            }
        }

        protected override void OnReadInnerText(Import.IHtmlReader reader, Import.IHtmlImportContext context, string text)
        {
            Guard.ThrowExceptionIfNull(reader, "reader");
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNullOrEmpty(text, "text");

            this.InnerText = text;
        }
    }
}