﻿using Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Elements;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model
{
    internal class HtmlElementsPool : ElementsPoolBase<HtmlElementBase>
    {
        private readonly HtmlContentManager contentManager;

        public HtmlElementsPool(HtmlContentManager contentManager)
        {
            Guard.ThrowExceptionIfNull(contentManager, "contentManager");

            this.contentManager = contentManager;
        }

        protected override HtmlElementBase CreateInstance(string elementName)
        {
            Guard.ThrowExceptionIfNullOrEmpty(elementName, "elementName");

            HtmlElementBase element;
            HtmlElementsFactory.TryCreateInstance(this.contentManager, elementName, out element);

            return element;
        }
    }
}
