﻿using Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Converters;
using Telerik.Windows.Documents.Flow.Model.Styles.Core;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Styles
{
    internal class HtmlPropertyMapperElement
    {
        private readonly IStylePropertyDefinition propertyDefinition;
        private readonly bool isDescriptorToDefinitionElement;
        private readonly bool isDefinitionToDescriptorElement;
        private readonly IStringConverter converter;
        private readonly HtmlStylePropertyDescriptor htmlPropertyDescriptor;

        public HtmlPropertyMapperElement(HtmlStylePropertyDescriptor htmlPropertyDescriptor,
            IStylePropertyDefinition propertyDefinition,
            IStringConverter converter,
            bool isDescriptorToDefinitionElement,
            bool isDefinitionToDescriptorElement)
        {
            Guard.ThrowExceptionIfNull(converter, "converter");
            Guard.ThrowExceptionIfNull(propertyDefinition, "propertyDefinition");
            Guard.ThrowExceptionIfNull(htmlPropertyDescriptor, "htmlPropertyDescriptor");

            this.propertyDefinition = propertyDefinition;
            this.htmlPropertyDescriptor = htmlPropertyDescriptor;
            this.converter = converter;
            this.isDescriptorToDefinitionElement = isDescriptorToDefinitionElement;
            this.isDefinitionToDescriptorElement = isDefinitionToDescriptorElement;
        }

        public HtmlStylePropertyDescriptor HtmlPropertyDescriptor
        {
            get
            {
                return this.htmlPropertyDescriptor;
            }
        }

        public IStringConverter Converter
        {
            get
            {
                return this.converter;
            }
        }

        public bool IsDescriptorToDefinitionElement
        {
            get
            {
                return this.isDescriptorToDefinitionElement;
            }
        }

        public bool IsDefinitionToDescriptorElement
        {
            get
            {
                return this.isDefinitionToDescriptorElement;
            }
        }

        public IStylePropertyDefinition PropertyDefinition
        {
            get
            {
                return this.propertyDefinition;
            }
        }
    }
}
