﻿using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html.Model.Styles
{
    internal class HtmlStylePropertyDescriptor
    {
        private readonly string name;
        private readonly bool isInheritable;
        private readonly bool applyAsLocalValueIfRelative;
        private readonly bool isBubblingInheritable;

        public HtmlStylePropertyDescriptor(string name, bool isInheritable)
            : this(name, isInheritable, false)
        {
        }

        public HtmlStylePropertyDescriptor(string name, bool isInheritable, bool applyAsLocalValueIfRelative = false, bool isBubblingInheritable = false)
        {
            Guard.ThrowExceptionIfNullOrEmpty(name, "name");

            this.name = name;
            this.isInheritable = isInheritable;
            this.applyAsLocalValueIfRelative = applyAsLocalValueIfRelative;
            this.isBubblingInheritable = isBubblingInheritable;
        }

        public string Name
        {
            get
            {
                return this.name;
            }
        }

        public bool IsInheritable
        {
            get
            {
                return this.isInheritable;
            }
        }

        public bool ApplyAsLocalValueIfRelative
        {
            get
            {
                return this.applyAsLocalValueIfRelative;
            }
        }

        public bool IsBubblingInheritable
        {
            get
            {
                return this.isBubblingInheritable;
            }
        }
    }
}
