﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Styles.Core;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Html
{
    internal static class StylePropertyHelper
    {
        private static readonly HashSet<IStylePropertyDefinition> stylePropertiesWithDefaultValuesDifferentThanHtml = new HashSet<IStylePropertyDefinition>();

        static StylePropertyHelper()
        {
            stylePropertiesWithDefaultValuesDifferentThanHtml.Add(Run.FontFamilyPropertyDefinition);
            stylePropertiesWithDefaultValuesDifferentThanHtml.Add(Run.FontSizePropertyDefinition);
            stylePropertiesWithDefaultValuesDifferentThanHtml.Add(Paragraph.SpacingAfterPropertyDefinition);
            stylePropertiesWithDefaultValuesDifferentThanHtml.Add(Paragraph.SpacingBeforePropertyDefinition);
            stylePropertiesWithDefaultValuesDifferentThanHtml.Add(Paragraph.LineSpacingPropertyDefinition);
        }

        internal static bool IsStylePropertyWithNonDefaultHtmlActualValue(IStylePropertyDefinition stylePropertyDefinition)
        {
            return stylePropertiesWithDefaultValuesDifferentThanHtml.Contains(stylePropertyDefinition);
        }
    }
}
