namespace Telerik.Windows.Documents.Flow.FormatProviders.Html
{
    /// <summary>
    /// Describes the export mode for the styles in <see cref="Flow.Model.RadFlowDocument.StyleRepository"/>.
    /// </summary>
    public enum StylesExportMode
    {
        /// <summary> 
        /// Styles are exported as CSS selectors to external CSS file.
        /// </summary> 
        External,

        /// <summary> 
        /// Styles are exported as CSS selectors in 'style' element in the 'head' section.
        /// </summary> 
        Embedded,

        /// <summary> 
        /// Styles are exported as CSS properties in 'style' attribute of the HTML elements.
        /// </summary> 
        Inline,

        /// <summary> 
        /// Styles are not exported.
        /// </summary> 
        None
    }
}