﻿using System;
using Telerik.Windows.Documents.Flow.Model;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Pdf.Export
{
    internal class HeadersFootersInfo
    {
        private Header defaultHeader;
        private Header firstHeader;
        private Header evenHeader;

        private Footer defaultFooter;
        private Footer firstFooter;
        private Footer evenFooter;

        public Header GetLastUsedHeader(HeaderFooterType type)
        {
            switch (type)
            {
                case HeaderFooterType.Default:
                    return this.defaultHeader;
                case HeaderFooterType.Even:
                    return this.evenHeader;
                case HeaderFooterType.First:
                    return this.firstHeader;
                default:
                    throw new NotSupportedException();
            }
        }

        public void SetLastUsedHeader(HeaderFooterType type, Header header)
        {
            switch (type)
            {
                case HeaderFooterType.Default:
                    this.defaultHeader = header;
                    break;
                case HeaderFooterType.Even:
                    this.evenHeader = header;
                    break;
                case HeaderFooterType.First:
                    this.firstHeader = header;
                    break;
                default:
                    throw new NotSupportedException();
            }
        }

        public Footer GetLastUsedFooter(HeaderFooterType type)
        {
            switch (type)
            {
                case HeaderFooterType.Default:
                    return this.defaultFooter;
                case HeaderFooterType.Even:
                    return this.evenFooter;
                case HeaderFooterType.First:
                    return this.firstFooter;
                default:
                    throw new NotSupportedException();
            }
        }

        public void SetLastUsedFooter(HeaderFooterType type, Footer footer)
        {
            switch (type)
            {
                case HeaderFooterType.Default:
                    this.defaultFooter = footer;
                    break;
                case HeaderFooterType.Even:
                    this.evenFooter = footer;
                    break;
                case HeaderFooterType.First:
                    this.firstFooter = footer;
                    break;
                default:
                    throw new NotSupportedException();
            }
        }
    }
}