﻿using Telerik.Windows.Documents.Flow.FormatProviders.Pdf.Utils;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Pdf.Export
{
    /// <summary>
    /// Represents PDF export settings.
    /// </summary>
    public class PdfExportSettings : Fixed.FormatProviders.Pdf.Export.PdfExportSettings
    {
        private readonly ExtensibilityManager extensibilityManager;

        /// <summary>
        /// Initializes a new instance of the <see cref="PdfExportSettings" /> class.
        /// </summary>
        public PdfExportSettings()
        {
            this.extensibilityManager = new ExtensibilityManager();
        }

        /// <summary>
        /// Gets the extensibility manager.
        /// </summary>
        /// <value>The extensibility manager.</value>
        public ExtensibilityManager ExtensibilityManager
        {
            get
            {
                return this.extensibilityManager;
            }
        }
    }
}
