﻿using Telerik.Windows.Documents.Flow.Model.Lists;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Pdf.Utils
{
    /// <summary>
    /// Provides methods for extending the functionality of the PdfFormatProvider.
    /// </summary>
    public class ExtensibilityManager
    {
        private readonly ListHelper listHelper;

        internal ExtensibilityManager()
        {
            this.listHelper = new ListHelper();
        }

        internal ListHelper ListHelper
        {
            get
            {
                return this.listHelper;
            }
        }

        /// <summary>
        /// Registers the numbering style converter.
        /// </summary>
        /// <param name="numberingStyle">The numbering style.</param>
        /// <param name="converter">The converter.</param>
        public void RegisterNumberingStyleConverter(NumberingStyle numberingStyle, INumberingStyleConverter converter)
        {
            this.ListHelper.RegisterNumberingStyle(numberingStyle, converter);
        }
    }
}
