using System;
using System.Runtime.Serialization;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Exceptions
{
    /// <summary>
    /// Represents errors related to brace nesting when importing RTF document.
    /// </summary>
    [Serializable]
    public class RtfBraceNestingException : RtfStructureException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RtfBraceNestingException" /> class.
        /// </summary>
        public RtfBraceNestingException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfBraceNestingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public RtfBraceNestingException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfBraceNestingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public RtfBraceNestingException(string message, Exception cause)
            : base(message, cause)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfBraceNestingException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected RtfBraceNestingException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
    }
}