using System;
using System.Runtime.Serialization;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Exceptions
{
    /// <summary>
    /// Represents errors related to the color table in an RTF document.
    /// </summary>
    [Serializable]
    public class RtfColorTableFormatException : RtfException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RtfColorTableFormatException" /> class.
        /// </summary>
        public RtfColorTableFormatException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfColorTableFormatException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public RtfColorTableFormatException(string message) : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfColorTableFormatException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public RtfColorTableFormatException(string message, Exception cause) : base(message, cause)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfColorTableFormatException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected RtfColorTableFormatException(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }
    }
}