using System;
using System.Runtime.Serialization;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Exceptions
{
    /// <summary>
    /// Represents errors that occur when opening RTF document that has no content.
    /// </summary>
    [Serializable]
    public class RtfEmptyDocumentException : RtfStructureException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RtfEmptyDocumentException" /> class.
        /// </summary>
        public RtfEmptyDocumentException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfEmptyDocumentException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public RtfEmptyDocumentException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfEmptyDocumentException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public RtfEmptyDocumentException(string message, Exception cause)
            : base(message, cause)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfEmptyDocumentException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected RtfEmptyDocumentException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
    }
}