using System;
using System.Runtime.Serialization;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Exceptions
{
    /// <summary>
    /// Represents errors related to encoding when opening RTF document.
    /// </summary>
    [Serializable]
    public class RtfEncodingException : RtfParserException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RtfEncodingException" /> class.
        /// </summary>
        public RtfEncodingException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfEncodingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public RtfEncodingException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfEncodingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public RtfEncodingException(string message, Exception cause)
            : base(message, cause)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfEncodingException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected RtfEncodingException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
    }
}
