using System;
using System.Runtime.Serialization;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Exceptions
{
    /// <summary>
    /// Represents errors that occur during import/export to RTF format.
    /// </summary>
    [Serializable]
    public class RtfException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RtfException" /> class.
        /// </summary>
        public RtfException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public RtfException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public RtfException(string message, Exception cause)
            : base(message, cause)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected RtfException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
    }
}
