using System;
using System.Runtime.Serialization;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Exceptions
{
    /// <summary>
    /// Represents errors related to hex encoding when opening RTF document.
    /// </summary>
    [Serializable]
    public class RtfHexEncodingException : RtfEncodingException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RtfHexEncodingException" /> class.
        /// </summary>
        public RtfHexEncodingException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfHexEncodingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public RtfHexEncodingException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfHexEncodingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public RtfHexEncodingException(string message, Exception cause)
            : base(message, cause)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfHexEncodingException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected RtfHexEncodingException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
    }
}
