using System;
using System.Runtime.Serialization;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Exceptions
{
    /// <summary>
    /// Represents errors related to multi-byte encoding when opening RTF document.
    /// </summary>
    [Serializable]
    public class RtfMultiByteEncodingException : RtfEncodingException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RtfMultiByteEncodingException" /> class.
        /// </summary>
        public RtfMultiByteEncodingException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfMultiByteEncodingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public RtfMultiByteEncodingException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfMultiByteEncodingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public RtfMultiByteEncodingException(string message, Exception cause)
            : base(message, cause)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfMultiByteEncodingException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected RtfMultiByteEncodingException(SerializationInfo info, StreamingContext context) 
            : base(info, context)
        { 
        }
    }
}
