using System;
using System.Runtime.Serialization;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Exceptions
{
    /// <summary>
    /// Represents errors related to parsing the RTF document.
    /// </summary>
    [Serializable]
    public class RtfParserException : RtfException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RtfParserException" /> class.
        /// </summary>
        public RtfParserException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfParserException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public RtfParserException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfParserException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="cause">The cause.</param>
        public RtfParserException(string message, Exception cause)
            : base(message, cause)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RtfParserException" /> class.
        /// </summary>
        /// <param name="info">The info.</param>
        /// <param name="context">The context.</param>
        protected RtfParserException(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }
    }
}
