﻿using Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Utilities;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Import.Model
{
    internal abstract class RtfElement
    {
        public abstract RtfElementType Type
        {
            get;
        }

        public sealed override bool Equals(object obj)
        {
            if (obj == this)
            {
                return true;
            }

            if (obj == null || this.GetType() != obj.GetType())
            {
                return false;
            }

            return this.IsEqual(obj);
        }

        public sealed override int GetHashCode()
        {
            return HashTool.AddHashCode(this.GetType().GetHashCode(), this.ComputeHashCode());
        }

        protected virtual bool IsEqual(object obj)
        {
            return true;
        }

        protected virtual int ComputeHashCode()
        {
            return 0x0f00ba11;
        }
    }
}