﻿using System;
using System.IO;
using System.Linq;
using System.Text;

public class Program
{
    static int[] codepages = new int[] {
        437,
        708,
        //709,
        //710,
        //711,
        720,
        //819,
        850,
        852,
        860,
        862,
        863,
        864,
        865,
        866,
        874,
        932,
        936,
        949,
        950,
        1250,
        1251,
        1252,
        1253,
        1254,
        1255,
        1256,
        1257,
        1258,
        1361,
        10000,
        10001,
        10004,
        10005,
        10006,
        10007,
        10029,
        10081,
        57002,
        57003,
        57004,
        57005,
        57006,
        57007,
        57008,
        57009,
        57010,
        57011
    };

    public static void Export(Encoding e)
    {
        Decoder d = e.GetDecoder();

        StreamWriter output = new StreamWriter("codepages\\" + e.CodePage + ".bin");
        byte[] bytes = Enumerable.Range(0, 256).Select(i => (byte)i).ToArray();
        char[] chars = new char[d.GetCharCount(bytes, 0, bytes.Length)];

        int bytesUsed, charsUsed;
        bool completed;
        d.Convert(bytes, 0, bytes.Length, chars, 0, chars.Length, true, out bytesUsed, out charsUsed, out completed);

        output.Write(new string(chars));

        output.Close();
    }

    [STAThread]
    public static void Main()
    {

        foreach (int codepage in codepages)
        {
            Encoding encoding = null;

            try
            {
                encoding = Encoding.GetEncoding(codepage);
            }
            catch
            {
                Console.WriteLine(codepage);
            }

            if (encoding != null)
            {
                Export(encoding);
            }
        }
    }
}
