﻿using System.Diagnostics;
using Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Import.Model;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Import.Parser
{
    internal class RtfDebugListener : RtfParserListenerBase
    {
        protected override void DoParseBegin()
        {
            Debug.WriteLine("---START---");
        }

        protected override void DoGroupBegin()
        {
        }

        protected override void DoTagFound(RtfTag tag)
        {
            Debug.WriteLine(new string(' ', this.Level * 2) + "tag:" + tag.Name + " v:" + tag.ValueAsText);
        }

        protected override void DoTextFound(RtfText text)
        {
            Debug.WriteLine(new string(' ', this.Level * 2) + text.Text);
        }

        protected override void DoBinaryFound(RtfBinary bin)
        {
            Debug.WriteLine("binary chunk length - " + bin.Length);
        }

        protected override void DoGroupEnd()
        {
        }

        protected override void DoParseEnd()
        {
            Debug.WriteLine("---END---");
        }
    }
}
