﻿using Telerik.Windows.Documents.Flow.Model.Styles;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Import.RtfTypes.Borders
{
    internal class RtfParagraphBorder
    {
        public RtfParagraphBorder()
        {
            this.Top = new RtfBorder();
            this.Left = new RtfBorder();
            this.Bottom = new RtfBorder();
            this.Right = new RtfBorder();
            this.Between = new RtfBorder();
            this.Box = new RtfBorder();
        }

        public bool HasValue { get; set; }

        public RtfBorder Top { get; set; }

        public RtfBorder Left { get; set; }

        public RtfBorder Bottom { get; set; }

        public RtfBorder Right { get; set; }

        public RtfBorder Box { get; set; }

        public RtfBorder Between { get; set; }

        public ParagraphBorders CreateBorders()
        {
            return new ParagraphBorders(
                this.Left.CreateBorder(),
                this.Top.CreateBorder(),
                this.Right.CreateBorder(),
                this.Bottom.CreateBorder(),
                this.Between.CreateBorder());
        }

        public RtfParagraphBorder CreateCopy()
        {
            RtfParagraphBorder result = new RtfParagraphBorder();

            if (this.HasValue)
            {
                result.HasValue = true;
                result.Top = this.Top.CreateCopy();
                result.Left = this.Left.CreateCopy();
                result.Bottom = this.Bottom.CreateCopy();
                result.Right = this.Right.CreateCopy();
                result.Between = this.Between.CreateCopy();
                result.Box = this.Box.CreateCopy();
            }

            return result;
        }
    }
}