﻿using System.Collections.Generic;
using System.Diagnostics;
using Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Import.Model;
using Telerik.Windows.Documents.Flow.Model.Lists;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Import.RtfTypes.Lists
{
    internal class RtfListOverrideTable : RtfElementIteratorBase
    {
        private readonly Dictionary<int, List> lists;
        private RtfImportContext context;

        public RtfListOverrideTable()
        {
            this.lists = new Dictionary<int, List>();
        }

        public void ReadTable(RtfGroup group, RtfImportContext context)
        {
            this.context = context;

            if (!this.context.ListTable.IsLoaded)
            {
                Debug.Assert(false, "Trying to initalize list overrides table, but the list table is not loaded.");
                return;
            }

            this.VisitGroupChildren(group, false);
        }

        public List GetList(int id)
        {
            List result = null;
            this.lists.TryGetValue(id, out result);
            return result;
        }

        protected override void DoVisitGroup(RtfGroup group)
        {
            if (group.Destination == RtfTags.TagListOverride)
            {
                RtfListOverride listOverride = new RtfListOverride();
                listOverride.Context = this.context;
                listOverride.ReadListOverride(group);

                List list = listOverride.CreateListOverride(this.context);
                this.lists[listOverride.ListOverrideId] = list;
            }
        }
    }
}
