﻿using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.Model;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Import.RtfTypes.Styles
{
    internal class RtfDocumentSettings
    {
        private const double DefaultPageWidth = 816;
        private const double DefaultPageHeight = 1056;
        private const double DefaultHorizontalMargin = 120;
        private const double DefaultVerticalMargin = 96;
        private const VerticalAlignment DefaultVerticalAlignment = VerticalAlignment.Top;

        public RtfDocumentSettings()
        {
            this.PageWidth = DefaultPageWidth;
            this.PageHeight = DefaultPageHeight;
            this.LeftPageMargin = DefaultHorizontalMargin;
            this.RightPageMargin = DefaultHorizontalMargin;
            this.TopPageMargin = DefaultVerticalMargin;
            this.BottomPageMargin = DefaultVerticalMargin;
            this.VerticalAlignment = DefaultVerticalAlignment;
        }

        public PageOrientation PageOrientation { get; set; }

        public double PageWidth { get; set; }

        public double PageHeight { get; set; }

        public double LeftPageMargin { get; set; }

        public double TopPageMargin { get; set; }

        public double RightPageMargin { get; set; }

        public double BottomPageMargin { get; set; }

        public VerticalAlignment VerticalAlignment { get; set; }
    }
}