﻿using System.Collections.Generic;
using System.Diagnostics;
using Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Import.Model;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Import.TagHandlers
{
    internal static class BorderHandlers
    {
        public static void InitializeBorderHandlers(Dictionary<string, ControlTagHandler> tagHandlers)
        {
            // Borders generic handler
            tagHandlers[RtfTags.TagBorderThickness] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeSingleThickness] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeDoubleThickness] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderColor] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeShadowed] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeDouble] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeDotted] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeDashed] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeHairline] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeDashedSmall] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeDotDashed] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeDotDotDashed] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeDotDashedAlt] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeDotDotDashedAlt] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeInset] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeOutset] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeTriple] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeThickThinS] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeThinThickS] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeThinThickThinS] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeThickThinM] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeThinThickM] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeThinThickThinM] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeThickThinL] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeThinThickL] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeThinThickThinL] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeWavy] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeDoubleWavy] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeStriped] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeEmbossed] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeEngraved] = BorderHandlers.BorderSettingsHandler;
            tagHandlers[RtfTags.TagBorderTypeNoBorder] = BorderHandlers.BorderSettingsHandler;
        }

        private static void BorderSettingsHandler(RtfTag tag, RtfImportContext context)
        {
            Debug.Assert(context.CurrentStyle.CurrentBorder != null,
                   "Expecting to handle cell or row border but there is no CurrentBorder.");
            if (context.CurrentStyle.CurrentBorder != null)
            {
                context.CurrentStyle.CurrentBorder.HandleTag(tag, context);
            }
        }
    }
}
