﻿namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf
{
    internal static class RtfTags
    {

        // --- rtf general ----
        public const string TagRtf = "rtf";

        // --- header groups ---
        public const string TagStyleSheet = "stylesheet";
        public const string TagThemeData = "themedata";
        public const string TagColorSchemeMapping = "colorschememapping";
        public const string TagFileTable = "filetbl";
        public const string TagDefaultCharacterProperties = "defchp";
        public const string TagDefaultParagraphProperties = "defpap";
        public const string TagListTable = "listtable";
        public const string TagListOverrideTable = "listoverridetable";
        public const string TagParagraphGroupProperties = "pgptbl";
        public const string TagRevisionMarksTable = "revtbl";
        public const string TagRevisionSaveIdTable = "rsidtbl";
        public const string TagUserProtectionInfoTable = "protusertbl";
        public const string TagGenerator = "generator";
        public const string TagDefaultLanguage = "deflang";

        // --- encoding ----
        public const string TagEncodingAnsi = "ansi";
        public const string TagEncodingMac = "mac";
        public const string TagEncodingPc = "pc";
        public const string TagEncodingPca = "pca";
        public const string TagEncodingAnsiCodePage = "ansicpg";
        public const int SymbolFakeCodePage = 42; // a windows legacy hack ...

        public const string TagUnicodeSkipCount = "uc";
        public const string TagUnicodeCode = "u";
        public const string TagUnicodeAlternativeChoices = "upr";
        public const string TagUnicodeAlternativeUnicode = "ud";

        // --- font ----
        public const string TagFontTable = "fonttbl";
        public const string TagDefaultFont = "deff";
        public const string TagDefaultBiDiFont = "adeff";
        public const string TagFont = "f";
        public const string TagFontAlt = "falt";
        public const string TagFontKindNil = "fnil";
        public const string TagFontKindRoman = "froman";
        public const string TagFontKindSwiss = "fswiss";
        public const string TagFontKindModern = "fmodern";
        public const string TagFontKindScript = "fscript";
        public const string TagFontKindDecor = "fdecor";
        public const string TagFontKindTech = "ftech";
        public const string TagFontKindBidi = "fbidi";
        public const string TagFontCharset = "fcharset";
        public const string TagFontPitch = "fprq";
        public const string TagFontDown = "dn";
        public const string TagFontUp = "up";

        public const string TagThemeFontLoMajor = "flomajor"; // these are 'theme' fonts
        public const string TagThemeFontHiMajor = "fhimajor"; // used in new font tables
        public const string TagThemeFontDbMajor = "fdbmajor";
        public const string TagThemeFontBiMajor = "fbimajor";
        public const string TagThemeFontLoMinor = "flominor";
        public const string TagThemeFontHiMinor = "fhiminor";
        public const string TagThemeFontDbMinor = "fdbminor";
        public const string TagThemeFontBiMinor = "fbiminor";

        public const int DefaultFontSize = 24;

        public const string TagCodePage = "cpg";

        // --- color ----
        public const string TagColorTable = "colortbl";
        public const string TagColorRed = "red";
        public const string TagColorGreen = "green";
        public const string TagColorBlue = "blue";
        public const string TagColorForeground = "cf";
        public const string TagColorBackground = "cb";
        public const string TagColorBackgroundWord = "chcbpat";
        public const string TagColorHighlight = "highlight";


        // --- character ----
        public const char TagDelimiterChar = ';';
        public const string TagDelimiter = ";";
        public const string TagExtensionDestination = "*";
        public const string TagTilde = "~";
        public const string TagHyphen = "-";
        public const string TagNonBreakingHyphen = "_";

        // --- special character ----
        public const string TagPageBreak = "page";
        public const string TagLineBreak = "line";
        public const string TagColumnBreak = "column";
        public const string TagLineBreakTextWrapping = "lbr";
        public const string TagTabulator = "tab";
        public const string TagEmDash = "emdash";
        public const string TagEnDash = "endash";
        public const string TagEmSpace = "emspace";
        public const string TagEnSpace = "enspace";
        public const string TagQmSpace = "qmspace";
        public const string TagBulltet = "bullet";
        public const string TagLeftSingleQuote = "lquote";
        public const string TagRightSingleQuote = "rquote";
        public const string TagLeftDoubleQuote = "ldblquote";
        public const string TagRightDoubleQuote = "rdblquote";

        // --- info ----
        public const string TagInfo = "info";
        public const string TagInfoVersion = "version";
        public const string TagInfoRevision = "vern";
        public const string TagInfoNumberOfPages = "nofpages";
        public const string TagInfoNumberOfWords = "nofwords";
        public const string TagInfoNumberOfChars = "nofchars";
        public const string TagInfoId = "id";
        public const string TagInfoTitle = "title";
        public const string TagInfoSubject = "subject";
        public const string TagInfoAuthor = "author";
        public const string TagInfoManager = "manager";
        public const string TagInfoCompany = "company";
        public const string TagInfoOperator = "operator";
        public const string TagInfoCategory = "category";
        public const string TagInfoKeywords = "keywords";
        public const string TagInfoComment = "comment";
        public const string TagInfoDocumentComment = "doccomm";
        public const string TagInfoHyperLinkBase = "hlinkbase";
        public const string TagInfoCreationTime = "creatim";
        public const string TagInfoRevisionTime = "revtim";
        public const string TagInfoPrintTime = "printim";
        public const string TagInfoBackupTime = "buptim";
        public const string TagInfoYear = "yr";
        public const string TagInfoMonth = "mo";
        public const string TagInfoDay = "dy";
        public const string TagInfoHour = "hr";
        public const string TagInfoMinute = "min";
        public const string TagInfoSecond = "sec";
        public const string TagInfoEditingTimeMinutes = "edmins";

        // --- user properties ----
        public const string TagUserProperties = "userprops";
        public const string TagUserPropertyType = "proptype";
        public const string TagUserPropertyName = "propname";
        public const string TagUserPropertyValue = "staticval";
        public const string TagUserPropertyLink = "linkval";


        // -- document
        public const string TagLayoutMode = "viewkind";
        public const string TagDocumentPageWidth = "paperw";
        public const string TagDocumentPageHeight = "paperh";
        public const string TagDocumentPageMarginLeft = "margl";   // (default is 1800).
        public const string TagDocumentPageMarginRight = "margr";  // (default is 1800).
        public const string TagDocumentPageMarginTop = "margt";    // (default is 1440).
        public const string TagDocumentPageMarginBottom = "margb"; // (default is 1440).
        public const string TagDocumentLandscapeMode = "landscape";
        public const string TagDocumentTabDefaultWidth = "deftab";  //Default tab width in twips 

        // --- section 
        public const string TagSectionDefaults = "sectd";
        public const string TagSectionWidth = "pgwsxn";
        public const string TagSectionHeight = "pghsxn";
        public const string TagSectionMarginLeft = "marglsxn";
        public const string TagSectionMarginRight = "margrsxn";
        public const string TagSectionMarginTop = "margtsxn";
        public const string TagSectionMarginBottom = "margbsxn";
        public const string TagSectionLandscapeMode = "lndscpsxn";
        public const string TagSectionStartingPageNumber = "pgnstarts";
        public const string TagSectionRestartPageNumberingFromStartingPageNumber = "pgnrestart";
        public const string TagSectionChapterHeadingStyle = "pgnhn";
        public const string TagSectionChapterSeparatorCharacterHyphen = "pgnhnsh";
        public const string TagSectionChapterSeparatorCharacterPeriod = "pgnhnsp";
        public const string TagSectionChapterSeparatorCharacterColon = "pgnhnsc";
        public const string TagSectionChapterSeparatorCharacterEmDash = "pgnhnsm";
        public const string TagSectionChapterSeparatorCharacterEnDash = "pgnhnsn";

        public const string TagSectionVerticalAlignmentTop = "vertalt";
        public const string TagSectionVerticalAlignmentCenter = "vertalc";
        public const string TagSectionVerticalAlignmentJustified = "vertalj";
        public const string TagSectionVerticalAlignmentBottom = "vertalb";
        public const string TagSectionVerticalAlignmentBottomAlias = "vertal"; // Alias for '\vertalb' tag. MS Word uses this control word.

        public const string TagSectionBreakNone = "sbknone";   // No section break.
        public const string TagSectionBreakColumn = "sbkcol";    // Section break starts a new column.
        public const string TagSectionBreakNewPage = "sbkpage";   // Section break starts a new page (the default).
        public const string TagSectionBreakEvenPage = "sbkeven";   // Section break starts at an even page.
        public const string TagSectionBreakOddPage = "sbkodd";     // Section break starts at an odd page.

        public const string TagSectionPageNumberFormatDecimal = "pgndec";
        public const string TagSectionPageNumberFormatUppercaseRomanNumeral = "pgnucrm";
        public const string TagSectionPageNumberFormatLowerRomanNumeral = "pgnlcrm";
        public const string TagSectionPageNumberFormatUppercaseLetter = "pgnucltr";
        public const string TagSectionPageNumberFormatLowercaseLetter = "pgnlcltr";
        public const string TagSectionPageNumberFormatKoreanNumbering = "pgnchosung";
        public const string TagSectionPageNumberFormatKoreanNumbering2 = "pgnganada";
        public const string TagSectionPageNumberFormatCircleNumbering = "pgncnum";
        public const string TagSectionPageNumberFormatArabicAbjad = "pgnbidia";
        public const string TagSectionPageNumberFormatHindiVowel = "pgnhindia";
        public const string TagSectionPageNumberFormatHindiConsonants = "pgnhindib";
        public const string TagSectionPageNumberFormatHindiNumbers = "pgnhindic";
        public const string TagSectionPageNumberFormatHindiCounting = "pgnhindid";
        public const string TagSectionPageNumberFormatThaiLetters = "pgnthaia";
        public const string TagSectionPageNumberFormatThaiNumbers = "pgnthaib";
        public const string TagSectionPageNumberFormatThaiCounting = "pgnthaic";
        public const string TagSectionPageNumberFormatVietnameseCounting = "pgnvieta";


        // --- paragraph
        public const string TagParagraphDefaults = "pard";

        public const string TagAlignLeft = "ql";
        public const string TagAlignCenter = "qc";
        public const string TagAlignRight = "qr";
        public const string TagAlignJustify = "qj";
        public const string TagAlignDistribute = "qd";
        public const string TagAlignKashida = "qk";
        public const string TagAlignThai = "qt";

        public const string TagParagraphFirstLineIndent = "fi";
        public const string TagParagraphFistLineIndentInCharUnits = "cufi";
        public const string TagParagraphLeftIndent = "li";
        public const string TagParagraphLeftIndentBiDirectional = "lin";
        public const string TagParagraphLeftIndentInCharUnits = "culi";
        public const string TagParagraphRightIndent = "ri";
        public const string TagParagraphRightIndentBiDirectional = "rin";
        public const string TagParagraphRightIndentInCharUnits = "curi";

        public const string TagParagraphSpacingBefore = "sb";
        public const string TagParagraphAutomaticSpacingBefore = "sbauto";
        public const string TagParagraphSpacingAfter = "sa";
        public const string TagParagraphAutomaticSpacingAfter = "saauto";
        public const string TagParagraphSpacingBeforeInCharUnits = "lisb";
        public const string TagParagraphSpacingAfterInCharUnits = "lisa";
        public const string TagParagraphLineSpacing = "sl";
        public const string TagParagraphLineSpacingType = "slmult";

        public const string TagParagraphShadingBackground = "cbpat";
        public const string TagParagraphShadingForeground = "cfpat";
        public const string TagParagraphShadingPercent = "shading";

        //borders
        public const string TagParagraphBorderLeft = "brdrl";
        public const string TagParagraphBorderTop = "brdrt";
        public const string TagParagraphBorderRight = "brdrr";
        public const string TagParagraphBorderBottom = "brdrb";
        public const string TagParagraphBorderBetween = "brdrbtw";

        //tab stops
        public const string TagTabStopPosition = "tx";     //Tab position in twips from the left margin.
        public const string TagTabStopRight = "tqr";     //Flush-right tab.
        public const string TagTabStopCenter = "tqc";     //Centered tab.
        public const string TagTabStopDecimal = "tqdec"; //Decimal tab.
        public const string TagTabStopBarPosition = "tb";         //Bar tab position in twips from the left margin.
        public const string TagTabStopLeaderDots = "tldot";     //Leader dots.
        public const string TagTabStopLeaderMiddleDots = "tlmdot"; //Leader middle dots.
        public const string TagTabStopLeaderHyphens = "tlhyph"; //Leader hyphens.
        public const string TagTabStopLeaderUnderline = "tlul";    //Leader underline.
        public const string TagTabStopLeaderThickLine = "tlth";    //Leader thick line.
        //public const string TagTabStopLeaderEqualSign = "tleq";    //Leader equal sign.


        // --- format ----
        public const string TagResetFormatting = "plain";
        public const string TagBold = "b";
        public const string TagItalic = "i";
        public const string TagStrikethrough = "strike";
        public const string TagDoubleStrikethrough = "striked";
        public const string TagSpanHighlight = "cb";
        public const string TagSpanHighlightWord = "highlight";
        public const string TagSpanForecolor = "cf";
        public const string TagFontSize = "fs";
        public const string TagSubscript = "sub";
        public const string TagSuperscript = "super";
        public const string TagResetBaselineAlignement = "nosupersub";
        public const string TagSpanStyle = "cs";
        public const string TagUnderlineColor = "ulc";
        public const string TagUnderlineNone = "ulnone";
        public const string TagUnderlineLine = "ul";
        public const string TagUnderlineDotted = "uld";
        public const string TagUnderlineDashed = "uldash";
        public const string TagUnderlineDashDotted = "uldashd";
        public const string TagUnderlineDashDotDotted = "uldashdd";
        public const string TagUnderlineDouble = "uldb";
        public const string TagUnderlineHeavyWave = "ulhwave";
        public const string TagUnderlineLongDashed = "ulldash";
        public const string TagUnderlineThick = "ulth";
        public const string TagUnderlineThickDotted = "ulthd";
        public const string TagUnderlineThickDashed = "ulthdash";
        public const string TagUnderlineThickDashDotted = "ulthdashd";
        public const string TagUnderlineThickDashDotDotted = "ulthdashdd";
        public const string TagUnderlineThickLongDashed = "ulthldash";
        public const string TagUnderlineDoubleWave = "ululdbwave";
        public const string TagUnderlineWord = "ulw";
        public const string TagUnderlineWave = "ulwave";
        public const string TagHidden = "v";

        public const string TagSpanShadingForeground = "chcfpat";
        public const string TagSpanShadingBackground = "chcbpat";
        public const string TagSpanShadingPercent = "chshdng";
        // TODO: Shading patterns


        // --- Structure ----
        public const string TagNoNestedTablesDestenation = "nonesttables";

        public const string TagSectionEnd = "sect";
        public const string TagParagraphEnd = "par";
        public const string TagCellEnd = "cell";
        public const string TagRowEnd = "row";
        public const string TagLastRow = "lastrow";

        public const string TagNestedRowEnd = "nestrow";
        public const string TagNestedCellEnd = "nestcell";

        public const string TagRowIndex = "irow";
        public const string TagRowIndexHeaderAdjusted = "irowband";

        public const string TagParagraphInTable = "intbl";
        public const string TagParagraphNestingLevel = "itap";



        //Table properties
        public const string TagRowDefaults = "trowd";
        public const string TagNestedTablePropertiesDestenation = "nesttableprops";
        public const string TagTableHeader = "trhdr";               //Table row header. This row should appear at the top of every page on which the current table appears.

        public const string TagFirstColumnSpannedCell = "clmgf";       //The first cell in a range of table cells to be merged.
        public const string TagColumnSpannedCell = "clmrg";            //Contents of the table cell are merged with those of the preceding cell.
        public const string TagFirstRowSpannedCell = "clvmgf";   //The first cell in a range of table cells to be vertically merged.
        public const string TagRowSpannedCell = "clvmrg";        //Contents of the table cell are vertically merged with those of the preceding cell.

        public const string TagRowPosition = "trleft";     //Position in twips of the leftmost edge of the table with respect to the left edge of its column.
        public const string TagRowAlignemntCenter = "trqc"; //Centers a table row with respect to its containing column.
        public const string TagRowAlignemntLeft = "trql"; //Left-justifies a table row with respect to its containing column.
        public const string TagRowAlignemntRight = "trqr"; //Right-justifies a table row with respect to its containing column.
        public const string TagRowHeight = "trrh";         //Height of a table row in twips. When 0, the height is sufficient for all the text in the line; when positive, the height is guaranteed to be at least the specified height; when negative, the absolute value of the height is used, regardless of the height of the text in the line.
        public const string TagRowAutoFit = "trautofit"; //0 No AutoFit (default). 1 AutoFit is on for the row. Overridden by \clwWidthN and \trwWidthN in any table row.

        public const string TagRowPreferredWidth = "trwWidth";          //Preferred row width. Overrides \trautofitN.

        public const string TagTableRowBanding = "tscbandsh"; //	Count of rows in a row band
        public const string TagTableColumnBanding = "tscbandsv"; //	Count of cells in a cell band


        //Units for \trwWidthN:
        //0 Null. Ignore \trwWidthN in favor of \cellxN (Word 97 style of determining cell and row width)
        //1 Auto, no preferred row width, ignores \trwWidthN if present; \trwWidthN will generally not be written, giving precedence to row defaults and autofit.
        //2 Percentage (in 50ths of a percent).
        //3 Twips.
        public const string TagRowPreferredWidthUnit = "trftsWidth";

        public const string TagSpaceBetweenCells = "trgaph"; // This porperty concerns default cell padding for tables

        public const string TagRowDefaultCellPaddingLeft = "trpaddl";     //Default left cell margin or padding for the row.
        public const string TagRowDefaultCellPaddingTop = "trpaddt";      //Default top cell margin or padding for the row.
        public const string TagRowDefaultCellPaddingRight = "trpaddr";    //Default right cell margin or padding for the row.
        public const string TagRowDefaultCellPaddingBottom = "trpaddb";   //Default bottom cell margin or padding for the row.

        public const string TagRowDefaultCellPaddingUnitLeft = "trpaddfl";    // 0 - Ignore in favor of \trgaphN , 3 - twips
        public const string TagRowDefaultCellPaddingUnitTop = "trpaddft";     // 0 - Ignore in favor of \trgaphN , 3 - twips
        public const string TagRowDefaultCellPaddingUnitRight = "trpaddfr";   // 0 - Ignore in favor of \trgaphN , 3 - twips
        public const string TagRowDefaultCellPaddingUnitBottom = "trpaddfb";  // 0 - Ignore in favor of \trgaphN , 3 - twips

        public const string TagRowCellSpacingLeft = "trspdl";
        public const string TagRowCellSpacingTop = "trspdt";
        public const string TagRowCellSpacingRight = "trspdr";
        public const string TagRowCellSpacingBottom = "trspdb";

        public const string TagRowCellSpacingUnitLeft = "trspdfl";      // 0 - Ignore trspdl, 3 - twips
        public const string TagRowCellSpacingUnitTop = "trspdft";       // 0 - Ignore trspdt, 3 - twips
        public const string TagRowCellSpacingUnitRight = "trspdfr";     // 0 - Ignore trspdr, 3 - twips
        public const string TagRowCellSpacingUnitBottom = "trspdfb";    // 0 - Ignore trspdb, 3 - twips

        public const string TagRowNoSplit = "trkeep";               //Keep table row together. 
        public const string TagRowRepeatOnEveryPage = "trhdr";      //Keep table row together. 

        public const string TagCellPaddingLeft = "clpadt";          //Left cell margin or padding. Overrides \trpaddlN.
        public const string TagCellPaddingTop = "clpadl";           //Top cell margin or padding. Overrides \trpaddtN.
        public const string TagCellPaddingRight = "clpadr";         //Right cell margin or padding. Overrides \trpaddrN.
        public const string TagCellPaddingBottom = "clpadb";        //Bottom cell margin or padding. Overrides \trpaddbN.
        public const string TagCellPaddingUnitLeft = "clpadft";     //0 - Ignore \clpadl in favor of \trgaphN (Word 97 style cell padding).3-Twips.
        public const string TagCellPaddingUnitTop = "clpadfl";      //0 - Ignore \clpadt in favor of \trgaphN (Word 97 style cell padding).3-Twips.
        public const string TagCellPaddingUnitRight = "clpadfr";    //0 - Ignore \clpadr in favor of \trgaphN (Word 97 style cell padding).3-Twips.
        public const string TagCellPaddingUnitBottom = "clpadfb";   //0 - Ignore \clpadb in favor of \trgaphN (Word 97 style cell padding).3-Twips.

        public const string TagTableIndent = "tblind";

        //0 – auto (Automatically Determined Width) Specifies that the value for the measurement of the current table width property in the parent table shall be automatically determined by the table layout algorithm when the table is displayed (this width can be adjusted as appropriate).
        //1(default) – dxa (Width in Twentieths of a Point) Specifies that the value for the measurement of the current table width property in the parent table shall be interpreted as twentieths of a point (1/1440 of an inch).
        //2 – nil (No Width) Specifies that the current width is zero, regardless of any width value specified on the parent element.
        //3 – pct (Width in Fiftieths of a Percent) Specifies that the value for the measurement of the current table width property in the parent table shall be interpreted as fiftieths of a percent.
        public const string TagTableIndentType = "tblindtype";

        public const string TagTableLookFirstRow = "tbllkhdrrows";
        public const string TagTableLookLastRow = "tbllklastrow";
        public const string TagTableLookFirstColumn = "tbllkhdrcols";
        public const string TagTableLookLastColumn = "tbllklastcol";
        public const string TagTableLookNoBandedRows = "tbllknorowband";
        public const string TagTableLookNoBandedColumns = "tbllknocolband";

        public const string TagRowShadingBackground = "trcbpat";
        public const string TagRowShadingForeground = "trcfpat";
        public const string TagRowShadingPercent = "trshdng";

        //Cell properties
        public const string TagCellDefaults = "tcelld";

        public const string TagCellNoWrapText = "clNoWrap";
        public const string TagCellIgnoreCellMarkerInRowHeight = "clhidemark";

        public const string TagCellContentAlignmentTop = "clvertalt";
        public const string TagCellContentAlignmentCenter = "clvertalc";
        public const string TagCellContentAlignmentBottom = "clvertalb";

        public const string TagCellContentAlignmentTopInStyle = "tsvertalt";    // this is valid only in table style definition
        public const string TagCellContentAlignmentCenterInStyle = "tsvertalc";    // this is valid only in table style definition
        public const string TagCellContentAlignmentBottomInStyle = "tsvertalb";    // this is valid only in table style definition

        public const string TagCellBackground = "clcbpat";     //N is the background color of the background pattern.
        public const string TagCellBackgroundWithStyles = "clcbpatraw"; //Same as \clcbpatN for use with table styles.
        public const string TagCellBackgroundInStyle = "tscellcbpat"; // this is valid only in table style definition

        public const string TagCellForeground = "clcfpat";     //Foreground cell shading color
        public const string TagCellForegroundWithStyles = "clcfpatraw"; //Same as \clcfpatN for use with table styles.
        public const string TagCellForegroundInStyle = "tscellcfpat"; // this is valid only in table style definition

        public const string TagCellShadingPercent = "clshdng";     //N is the shading of a table cell in hundredths of a percent. This control should be included in RTF along with cell border information.
        public const string TagCellShadingPercentWithStyles = "clshdngraw"; //Same as \clshdngN for use with table styles.
        public const string TagCellShadingPercentInStyles = "tscellpct"; //Same as \clshdngN for use with table styles.

        public const string TagCellRightBoundry = "cellx";

        public const string TagCellFirstInHorizontalRange = "clmgf"; //The first cell in a range of table cells to be merged.
        public const string TagCellInHorizontalRange = "clmrg";         //Contents of the table cell are merged with those of the preceding cell.
        public const string TagCellFirstInVerticalRange = "clvmgf";     //The first cell in a range of table cells to be vertically merged.
        public const string TagCellInVerticalRange = "clvmrg";         //Contents of the table cell are vertically merged with those of the preceding cell.

        public const string TagCellPreferredWidth = "clwWidth";
        public const string TagCellPreferredWidthUnit = "clftsWidth";   //Units for \clwWidthN: 
        //0 Null. Ignore \clwWidthN in favor of \cellxN (Word 97 style of determining cell and row width).
        //1 Auto, no preferred cell width, ignores \clwWidthN if present; \clwWidthN will generally not be written, giving precedence to row defaults.
        //2 Percentage (in 50ths of a percent).
        //3 Twips.

        public const string TagCellTextFlowLeftRightTopBottom = "cltxlrtb";
        public const string TagCellTextFlowRightLeftTopBottom = "cltxtbrl";
        public const string TagCellTextFlowLeftRightBottomTop = "cltxbtlr";
        public const string TagCellTextFlowLeftRightTopBottomVertical = "cltxlrtbv";
        public const string TagCellTextFlowRightLeftTopBottomVertical = "cltxtbrlv";

        //Row Borders
        public const string TagRowBordersTop = "trbrdrt";
        public const string TagRowBordersLeft = "trbrdrl";
        public const string TagRowBordersBottom = "trbrdrb";
        public const string TagRowBordersRight = "trbrdrr";
        public const string TagRowBordersInnerHorizontal = "trbrdrh";
        public const string TagRowBordersInnerVertical = "trbrdrv";

        //Cell Borders
        public const string TagCellBorderNone = "brdrnil";
        public const string TagCellBorderTop = "clbrdrt";
        public const string TagCellBorderLeft = "clbrdrl";
        public const string TagCellBorderBottom = "clbrdrb";
        public const string TagCellBorderRight = "clbrdrr";
        public const string TagCellBorderDiagonalUpperLeft = "cldglu";
        public const string TagCellBorderDiagonalLowerLeft = "cldgll";

        //CommonBorders
        public const string TagBorderTypeBox = "box";                          //Border around the paragraph (box paragraph).
        public const string TagBorderTypeSingleThickness = "brdrs";            //Single-thickness border.
        public const string TagBorderTypeDoubleThickness = "brdrth";           //Double-thickness border.
        public const string TagBorderTypeShadowed = "brdrsh";                 //Shadowed border.
        public const string TagBorderTypeDouble = "brdrdb";                   //Double border.
        public const string TagBorderTypeDotted = "brdrdot";                  //Dotted border.
        public const string TagBorderTypeDashed = "brdrdash";                 //Dashed border.
        public const string TagBorderTypeHairline = "brdrhair";               //Hairline border.
        public const string TagBorderTypeDashedSmall = "brdrdashsm";           //Dashed border (small).
        public const string TagBorderTypeDotDashed = "brdrdashd";             //Dot-dashed border.
        public const string TagBorderTypeDotDotDashed = "brdrdashdd";         //Dot-dot-dashed border.
        public const string TagBorderTypeDotDashedAlt = "brdrdashdot";         //Dot-dashed border (alias for \brdrdashd read but not written by Word)
        public const string TagBorderTypeDotDotDashedAlt = "brdrdashdotdot";   //Dot-dot-dashed border (alias for \brdrdashdd read but not written by Word)
        public const string TagBorderTypeInset = "brdrinset";                 //Inset border.
        public const string TagBorderTypeNoBorder = "brdrnone";               //No border.
        public const string TagBorderTypeOutset = "brdroutset";               //Outset border.
        public const string TagBorderTypeTriple = "brdrtriple";               //Triple border.
        public const string TagBorderTypeThickThinS = "brdrtnthsg";            //Thick-thin border (small).
        public const string TagBorderTypeThinThickS = "brdrthtnsg";            //Thin-thick border (small).
        public const string TagBorderTypeThinThickThinS = "brdrtnthtnsg";      //Thin-thick thin border (small).
        public const string TagBorderTypeThickThinM = "brdrtnthmg";            //Thick-thin border (medium).
        public const string TagBorderTypeThinThickM = "brdrthtnmg";            //Thin-thick border (medium).
        public const string TagBorderTypeThinThickThinM = "brdrtnthtnmg";      //Thin-thick thin border (medium).
        public const string TagBorderTypeThickThinL = "brdrtnthlg";            //Thick-thin border (large).
        public const string TagBorderTypeThinThickL = "brdrthtnlg";            //Thin-thick border (large).
        public const string TagBorderTypeThinThickThinL = "brdrtnthtnlg";      //Thin-thick-thin border (large).
        public const string TagBorderTypeWavy = "brdrwavy";                   //Wavy border.
        public const string TagBorderTypeDoubleWavy = "brdrwavydb";           //Double wavy border.
        public const string TagBorderTypeStriped = "brdrdashdotstr";          //Striped border.
        public const string TagBorderTypeEmbossed = "brdremboss";             //Embossed border.
        public const string TagBorderTypeEngraved = "brdrengrave";            //Engraved border.
        public const string TagBorderTypeFrame = "brdrframe";                  //Border resembles a “Frame.”

        public const string TagBorderColor = "brdrcf";
        public const string TagBorderThickness = "brdrw";

        // --- picture ----
        public const string TagPicture = "pict";
        public const string TagInlinePictureShapeProperties = "picprop";
        public const string TagIsWordArtShape = "defshp";
        public const string TagPictureWrapper = "shppict";
        public const string TagPictureWrapperAlternative = "nonshppict";

        public const string TagPictureFormatEmf = "emfblip";
        public const string TagPictureFormatPng = "pngblip";
        public const string TagPictureFormatJpg = "jpegblip";
        public const string TagPictureFormatQuickDraw = "macpict";
        public const string TagPictureFormatWinDib = "dibitmap";
        public const string TagPictureFormatWinBmp = "wbitmap";
        public const string TagPictureFormatOs2Metafile = "pmmetafile";
        public const string TagPictureFormatWinMetafile = "wmetafile";
        public const string TagBinary = "bin";


        public const string TagPictureWidth = "picw";
        public const string TagPictureHeight = "pich";
        public const string TagPictureWidthGoal = "picwgoal";
        public const string TagPictureHeightGoal = "pichgoal";
        public const string TagPictureScaleX = "picscalex";
        public const string TagPictureScaleY = "picscaley";

        //--- Shapes ---
        public const string TagNoUICompatibilityTag = "nouicompat";

        public const string TagShape = "shp";
        public const string TagShapeInstructions = "shpinst";
        public const string TagShapeResultDestination = "shprslt";


        public const string TagShapeTop = "shptop";  //Specifies position of shape from the top of the anchor. The value N is in twips.
        public const string TagShapeLeft = "shpleft";  //Specifies position of shape from the left of the anchor. The value N is in twips.
        public const string TagShapeBottom = "shpbottom";  //Specifies position of shape from the bottom of the anchor. The value N is in twips.
        public const string TagShapeRight = "shpright"; //Specifies position of shape from the right of the anchor. The value N is in twips. 

        public const string TagShapeZOrder = "shpz";
        public const string TagShapeIsInHeader = "shpfhdr";

        public const string TagShapeHorizontalRelativeToPage = "shpbxpage";   //The shape is positioned relative to the page in the x (horizontal) direction. 
        public const string TagShapeHorizontalRelativeToMargin = "shpbxmargin";  //The shape is positioned relative to the margin in the x (horizontal) direction.
        public const string TagShapeHorizontalRelativeToColumn = "shpbxcolumn";     //The shape is positioned relative to the column in the x (horizontal) direction.
        public const string TagShapeHorizontalRelativeToIgnore = "shpbxignore";     //Ignore \shpbxpage, \shpbxmargin, and \shpbxcolumn, in favor of the posrelh property.

        public const string TagShapeVerticalRelativeToPage = "shpbypage";          //The shape is positioned relative to the page in the y (vertical) direction.
        public const string TagShapeVerticalRelativeToMargin = "shpbymargin";      //The shape is positioned relative to the margin in the y (vertical) direction.
        public const string TagShapeVerticalRelativeToParagraph = "shpbypara";     //The shape is positioned relative to the paragraph in the y (vertical) direction.
        public const string TagShapeVerticalRelativeToIgnore = "shpbyignore";     //Ignore \shpbypage, \shpbymargin, and \shpbxpara, in favor of the posrelh property. 

        // Describes the type of wrap for the shape:
        // 1 Wrap around top and bottom of shape (no text allowed beside shape)
        // 2 Wrap around shape
        // 3 None (wrap as if shape isn’t present)
        // 4 Wrap tightly around shape
        // 5 Wrap text through shape
        public const string TagShapeWrappingType = "shpwr";

        // Wrap on side (for types 2 and 4 for \shpwrN ):
        // 0 Wrap both sides of shape
        // 1 Wrap left side only
        // 2 Wrap right side only
        // 3 Wrap only on largest side
        public const string TagShapeTextWrap = "shpwrk";

        // 0 Text is below shape
        // 1 Shape is below text
        public const string TagShapeIsBelowText = "shpfblwtxt";

        public const string TagShapePopertyDestenation = "sp";
        public const string TagShapePopertyNameDestenation = "sn";
        public const string TagShapePopertyValueDestenation = "sv";

        public const string ShapeTypeProperty = "shapeType";

        public const string ShapePictureDataProperty = "pib";
        public const string ShapeHorizontalPositionProperty = "posh";
        public const string ShapeHorizontalRelativeToPositionProperty = "posrelh";
        public const string ShapeVerticalPositionProperty = "posv";
        public const string ShapeVerticalRelativeToPositionProperty = "posrelv";

        public const string ShapeLayoutInCellProperty = "fLayoutInCell";
        public const string ShapeAllowOverlapProperty = "fAllowOverlap";

        public const string ShapeMarginLeftProperty = "dxWrapDistLeft";
        public const string ShapeMarginTopProperty = "dyWrapDistTop";
        public const string ShapeMarginRightProperty = "dxWrapDistRight";
        public const string ShapeMarginBottomProperty = "dyWrapDistBottom";

        public const string ShapeBehindDocumentProperty = "fBehindDocument";

        public const string ShapePseudoInlineProperty = "fPseudoInline";
        public const string ShapeRotationProperty = "rotation";

        public const string ShapeNameProperty = "wzName";
        public const string ShapeTextProperty = "gtextUNICODE";
        public const string ShapeTextSizeProperty = "gtextSize";
        public const string ShapeTextFontProperty = "gtextFont";
        public const string ShapeFillColorProperty = "fillColor";
        public const string ShapeFillOpacityProperty = "fillOpacity";
        public const string ShapeLineProperty = "fLine";

        public const string ShapeVerticalFlipProperty = "fFlipV";
        public const string ShapeHorizontalFlipProperty = "fFlipH";
        public const string ShapeZIndexProperty = "dhgt";


        // --- bullets/numbering ----
        public const string TagParagraphNumberText = "pntext";
        public const string TagListText = "listtext";

        public const string TagList = "list";
        public const string TagListId = "listid";
        public const string TagListTemplateId = "listtemplateid";
        public const string TagListSingleLevel = "listsimple";
        public const string TagListIsHybrid = "listhybrid";
        public const string TagListName = "listname";
        public const string TagListStyleId = "liststyleid";
        public const string TagListStyleName = "liststylename";

        public const string TagListLevel = "listlevel";
        public const string TagListLevelNumberingFormat = "levelnfc";
        public const string TagListLevelNumberingFormatAlt = "levelnfcn";
        public const string TagListLevelJustification = "leveljc";
        public const string TagListLevelJustificationAlt = "leveljcn";
        public const string TagListLevelFollowChar = "levelfollow";
        public const string TagListLevelStartIndex = "levelstartat";
        public const string TagListLevelRestartAfterLevel = "levelnorestart";
        public const string TagListLevelIsLegal = "levellegal";

        public const string TagListLevelText = "leveltext";
        public const string TagListLevelNumbers = "levelnumbers";
        public const string TagListLevelTemplateId = "leveltemplateid";


        public const string TagListOverride = "listoverride";
        public const string TagListOverrideCount = "listoverridecount";
        public const string TagListOverrideStartAt = "listoverridestartat";
        public const string TagListOverrideFormat = "listoverrideformat";
        public const string TagListOverrideLevelDestination = "lfolevel";
        public const string TagListOverrideId = "ls";
        public const string TagParagraphListLevel = "ilvl";

        //Fields
        public const string TagBookmarkStart = "bkmkstart";
        public const string TagBookmarkEnd = "bkmkend";
        public const string TagField = "field";
        public const string TagFieldInstructions = "fldinst";
        public const string TagFieldResult = "fldrslt";
        public const string TagFieldIsLocked = "fldlock";
        public const string TagFieldIsDirty = "flddirty";

        public const string TagDocumentVariable = "docvar";

        //Comments
        public const string CommentStart = "atrfstart";
        public const string CommentEnd = "atrfend";
        public const string CommentID = "atnid";
        public const string CommentAuthor = "atnauthor";
        public const string CommentDefinition = "annotation";
        public const string CommentTime = "atntime";
        public const string CommentDate = "atndate";
        public const string CommentParent = "atnparent";
        public const string CommentRef = "atnref";
        public const string CommentMarkerTag = "chatn";

        //Headers and footers
        public const string TagHeaderAllPages = "header";
        public const string TagHeaderFirstPage = "headerf";
        public const string TagHeaderLeftPages = "headerl";
        public const string TagHeaderRightPages = "headerr";
        public const string TagFooterAllPages = "footer";
        public const string TagFooterFirstPage = "footerf";
        public const string TagFooterLeftPages = "footerl";
        public const string TagFooterRightPages = "footerr";

        public const string TagDifferentFirstHeaderFooter = "titlepg";
        public const string TagDifferentOddEvenHeaderFooter = "facingp";
        public const string TagHeaderTopMargin = "headery";       // Header is N twips from the top of the page (default is 720).
        public const string TagFooterBottomMargin = "footery";    // Footer is N twips from the bottom of the page (default is 720).

        public const string TagFootnote = "footnote";


        //Right to left
        public const string TagSpanRtl = "rtlch";     //The character data following this control word will be treated as a right-to-left run.
        public const string TagSpanLtr = "ltrch";       //The character data following this control word will be treated as a left-to-right run (the default).
        public const string TagParagraphRtl = "rtlpar"; //Text in this paragraph will be displayed with right-to-left precedence.
        public const string TagParagraphLtr = "ltrpar"; //Text in this paragraph will be displayed with left-to-right precedence (the default).
        public const string TagRowRtl = "rtlrow";     //Cells in this table row will have right-to-left precedence.
        public const string TagRowLtr = "ltrrow";       //Cells in this table row will have left-to-right precedence (the default).
        public const string TagTableRtl = "taprtl";     //Indicates that the table direction is right-to-left.

        // Columns:
        //public const string TagSectionRTL = "rtlsect"; //This section will thread columns from right to left.
        //public const string TagSectionLTR = "ltrsect"; //This section will thread columns from left to right (the default).


        //Styles
        public const string TagStyleParagraph = "s";
        public const string TagStyleCharacter = "cs";
        public const string TagStyleTable = "ts";
        public const string TagStyleTableForParagraph = "yts";
        public const string TagStyleSection = "ds";
        public const string TagStyleRowDefaults = "tsrowd";
        public const string TagStyleBasedOn = "sbasedon";
        public const string TagStyleLinked = "slink";
        public const string TagStyleNextParagraphStyle = "snext";
        public const string TagStyleIsPrimary = "sqformat";
        public const string TagStyleAdditive = "additive";
        public const string TagStyleUIPriority = "spriority";


        // this table is from the RTF specification 1.9.1, page 40
        public const int PropertyTypeInteger = 3;
        public const int PropertyTypeRealNumber = 5;
        public const int PropertyTypeDate = 64;
        public const int PropertyTypeBoolean = 11;
        public const int PropertyTypeText = 30;

        public static string TextWatermarkShapeName = "PowerPlusWaterMarkObject";
        public static string ImageWatermarkShapeName = "WordPictureWatermark";
    }
}
