﻿using System.Collections.Generic;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Utilities
{
    internal static class CharSetHelper
    {
        public static readonly int AnsiCodePage = 1252;

        private static readonly Dictionary<int, int> CharSetToCodepage;

        static CharSetHelper()
        {
            CharSetToCodepage = new Dictionary<int, int>();
            CharSetToCodepage[0] = CharSetHelper.AnsiCodePage; // ANSI
            CharSetToCodepage[1] = 0; // Default
            CharSetToCodepage[2] = 42; // Symbol
            CharSetToCodepage[77] = 10000; // Mac Roman
            CharSetToCodepage[78] = 10001; // Mac Shift Jis
            CharSetToCodepage[79] = 10003; // Mac Hangul
            CharSetToCodepage[80] = 10008; // Mac GB2312
            CharSetToCodepage[81] = 10002; // Mac Big5
            CharSetToCodepage[82] = 0; // Mac Johab (old)
            CharSetToCodepage[83] = 10005; // Mac Hebrew
            CharSetToCodepage[84] = 10004; // Mac Arabic
            CharSetToCodepage[85] = 10006; // Mac Greek
            CharSetToCodepage[86] = 10081; // Mac Turkish
            CharSetToCodepage[87] = 10021; // Mac Thai
            CharSetToCodepage[88] = 10029; // Mac East Europe
            CharSetToCodepage[89] = 10007; // Mac Russian
            CharSetToCodepage[128] = 932; // Shift JIS
            CharSetToCodepage[129] = 949; // Hangul
            CharSetToCodepage[130] = 1361; // Johab
            CharSetToCodepage[134] = 936; // GB2312
            CharSetToCodepage[136] = 950; // Big5
            CharSetToCodepage[161] = 1253; // Greek
            CharSetToCodepage[162] = 1254; // Turkish
            CharSetToCodepage[163] = 1258; // Vietnamese
            CharSetToCodepage[177] = 1255; // Hebrew
            CharSetToCodepage[178] = 1256; // Arabic
            CharSetToCodepage[179] = 0; // Arabic Traditional (old)
            CharSetToCodepage[180] = 0; // Arabic user (old)
            CharSetToCodepage[181] = 0; // Hebrew user (old)
            CharSetToCodepage[186] = 1257; // Baltic
            CharSetToCodepage[204] = 1251; // Russian
            CharSetToCodepage[222] = 874; // Thai
            CharSetToCodepage[238] = 1250; // Eastern European
            CharSetToCodepage[254] = 437; // PC 437
            CharSetToCodepage[255] = 850; // OEM
        }

        public static int GetCodePage(int charSet)
        {
            int result = 0;
            if (CharSetToCodepage.TryGetValue(charSet, out result))
            {
                return result;
            }

            return 0;
        }
    }
}
