using System;
using System.Collections;

namespace Telerik.Windows.Documents.Flow.FormatProviders.Rtf.Utilities
{
    // TODO: Use other hash-helper class.
    internal static class HashTool
    {
        public static int AddHashCode(int hash, object obj)
        {
            int combinedHash = obj != null ? obj.GetHashCode() : 0;

            // Perform this check to prevent FxCop warning 'op could overflow'
            if (hash != 0)
            {
                combinedHash += hash * 31;
            }
            return combinedHash;
        }

        public static int AddHashCode(int hash, int objHash)
        {
            int combinedHash = objHash;

            // Perform this check to prevent FxCop warning 'op could overflow'
            if (hash != 0)
            {
                combinedHash += hash * 31;
            }
            return combinedHash;
        }

        public static int ComputeHashCode(IEnumerable enumerable)
        {
            int hash = 1;
            if (enumerable == null)
            {
                throw new ArgumentNullException("enumerable");
            }
            foreach (object item in enumerable)
            {
                hash = (hash * 31) + (item != null ? item.GetHashCode() : 0);
            }
            return hash;
        }
    }
}