﻿using System.Collections.Generic;

namespace Telerik.Windows.Documents.Flow.Model
{
    internal class AnnotationCloneContext<TStart, TEnd>
        where TStart : AnnotationRangeStartBase
        where TEnd : AnnotationRangeEndBase
    {
        private readonly Stack<TStart> hangingAnnotationStarts;
        private readonly Stack<TEnd> hangingAnnotationEnds;

        public AnnotationCloneContext()
        {
            this.hangingAnnotationStarts = new Stack<TStart>();
            this.hangingAnnotationEnds = new Stack<TEnd>();
        }

        public void AddHangingAnnotationStart(TStart start)
        {
            this.hangingAnnotationStarts.Push(start);
        }

        public void AddHangingAnnotationEnd(TEnd end)
        {
            this.hangingAnnotationEnds.Push(end);
        }

        public TStart PopHangingAnnotationStart()
        {
            return this.hangingAnnotationStarts.Count > 0 ? this.hangingAnnotationStarts.Pop() : default(TStart);
        }

        public Stack<TStart> GetHangingAnnotationStarts()
        {
            return this.hangingAnnotationStarts;
        }

        public Stack<TEnd> GetHangingAnnotationEnds()
        {
            return this.hangingAnnotationEnds;
        }
    }
}