﻿namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// An abstract class that provides a base for all block-level flow content elements.
    /// </summary>
    public abstract class BlockBase : DocumentElementBase
    {
        internal BlockBase(RadFlowDocument document)
            : base(document)
        {
        }

        /// <summary>
        /// Gets the parent block container of the inline.
        /// </summary>
        /// <value>The block container.</value>
        public BlockContainerBase BlockContainer
        {
            get
            {
                return (BlockContainerBase)this.Parent;
            }
        }
    }
}
