﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Flow.Model.Collections;

namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// Provides base functionality for containers for document elements of type <see cref="BlockBase"/>.
    /// </summary>
    public abstract class BlockContainerBase : DocumentElementBase
    {
        private readonly BlockCollection blocks;

        internal BlockContainerBase(RadFlowDocument document)
            : base(document)
        {
            this.blocks = new BlockCollection(this);
        }

        /// <summary>
        /// Gets the blocks in this container.
        /// </summary>
        /// <value>The blocks.</value>
        public BlockCollection Blocks
        {
            get
            {
                return this.blocks;
            }
        }

        internal override IEnumerable<DocumentElementBase> Children
        {
            get { return this.Blocks; }
        }
    }
}
