﻿namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// Defines different break types.
    /// </summary>
    public enum BreakType
    {
        /// <summary>
        /// Specifies that the current break shall restart itself on the next line in the document.
        /// </summary>
        LineBreak,

        /// <summary>
        /// Specifies that the current break shall restart itself on the next page of the document.
        /// </summary>
        PageBreak,

        /// <summary>
        /// Specifies that the current break shall restart itself on the next column available on the current page of the document.
        /// </summary>
        ColumnBreak,
    }
}