﻿namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// Describes the chapter separator character which should be used to separate the chapter heading style index from the page number.
    /// </summary>
    public enum ChapterSeparatorType
    {
        /// <summary>
        /// Colon separator character.
        /// </summary>
        Colon,

        /// <summary>
        /// Em dash separator character.
        /// </summary>
        EmDash,

        /// <summary>
        /// En dash separator character.
        /// </summary>
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "En")]
        [System.Diagnostics.CodeAnalysis.SuppressMessage("StyleCop.CSharp.DocumentationRules", "SA1650:ElementDocumentationMustBeSpelledCorrectly", Justification = "Reviewed.")]
        EnDash,

        /// <summary>
        /// Hyphen separator character.
        /// </summary>
        Hyphen,

        /// <summary>
        /// Period separator character.
        /// </summary>
        Period
    }
}