﻿using Telerik.Windows.Documents.Flow.Model.Lists;

namespace Telerik.Windows.Documents.Flow.Model.Cloning
{
    internal class ListCollectionMerger
    {
        private readonly ListCollection targetListCollection;
        private readonly ListCollection sourceListCollection;

        public ListCollectionMerger(ListCollection target, ListCollection source)
        {
            this.targetListCollection = target;
            this.sourceListCollection = source;
        }

        internal void Merge(CloneContext cloneContext)
        {
            foreach (List sourceList in this.sourceListCollection)
            {
                List clonedList = sourceList.Clone();
                this.targetListCollection.Add(clonedList);
                cloneContext.ReinitializedLists.Add(sourceList.Id, clonedList.Id);

                if (!string.IsNullOrEmpty(sourceList.StyleId))
                {
                    if (cloneContext.RenamedStyles.ContainsKey(sourceList.StyleId))
                    {
                        clonedList.StyleId = cloneContext.RenamedStyles[sourceList.StyleId];
                    }
                }
            }
        }
    }
}
