﻿namespace Telerik.Windows.Documents.Flow.Model.Collections
{
    /// <summary>
    /// Defines a collection of block elements.
    /// </summary>
    public sealed class BlockCollection : DocumentElementCollection<BlockBase, BlockContainerBase>
    {
        internal BlockCollection(BlockContainerBase parent)
            : base(parent)
        {
        }

        /// <summary>
        /// Adds a new <see cref="Paragraph"/> to the collection.
        /// </summary>
        /// <returns>The added paragraph.</returns>
        public Paragraph AddParagraph()
        {
            Paragraph paragraph = new Paragraph(this.Owner.Document);
            this.Add(paragraph);

            return paragraph;
        }

        /// <summary>
        /// Adds a new <see cref="Table"/> to the collection.
        /// </summary>
        /// <returns>The added table.</returns>
        public Table AddTable()
        {
            Table table = new Table(this.Owner.Document);
            this.Add(table);

            return table;
        }
    }
}
