﻿namespace Telerik.Windows.Documents.Flow.Model.Collections
{
    /// <summary>
    /// Defines a collection of sections.
    /// </summary>
    public sealed class SectionCollection : DocumentElementCollection<Section, RadFlowDocument>
    {
        internal SectionCollection(RadFlowDocument parent)
            : base(parent)
        {
        }

        /// <summary>
        /// Adds a new <see cref="Section"/> to the collection.
        /// </summary>
        /// <returns>The added section.</returns>
        public Section AddSection()
        {
            Section section = new Section(this.Owner.Document);
            this.Add(section);

            return section;
        }
    }
}
