﻿namespace Telerik.Windows.Documents.Flow.Model.Collections
{
    /// <summary>
    /// Defines a collection of table cells.
    /// </summary>
    public sealed class TableCellCollection : DocumentElementCollection<TableCell, TableRow>
    {
        internal TableCellCollection(TableRow parent)
            : base(parent)
        {
        }

        /// <summary>
        /// Adds a new <see cref="TableCell"/> to the collection.
        /// </summary>
        /// <returns>The added table cell.</returns>
        public TableCell AddTableCell()
        {
            TableCell tableCell = new TableCell(this.Owner.Document);
            this.Add(tableCell);

            return tableCell;
        }
    }
}
