﻿namespace Telerik.Windows.Documents.Flow.Model.Collections
{
    /// <summary>
    /// Defines a collection of table rows.
    /// </summary>
    public sealed class TableRowCollection : DocumentElementCollection<TableRow, Table>
    {
        internal TableRowCollection(Table parent)
            : base(parent)
        {
        }

        /// <summary>
        /// Adds a new <see cref="TableRow"/> to the collection.
        /// </summary>
        /// <returns>The added table row.</returns>
        public TableRow AddTableRow()
        {
            TableRow tableRow = new TableRow(this.Owner.Document);
            this.Add(tableRow);

            return tableRow;
        }
    }
}
