﻿namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// Describes the type of the document element.
    /// </summary>
    internal enum DocumentElementType
    {
        /// <summary>
        /// Document element.
        /// </summary>
        Document,

        /// <summary>
        /// Section element.
        /// </summary>
        Section,

        /// <summary>
        /// Paragraph element.
        /// </summary>
        Paragraph,

        /// <summary>
        /// Table element.
        /// </summary>
        Table,

        /// <summary>
        /// Table row element.
        /// </summary>
        TableRow,

        /// <summary>
        /// Table cell element.
        /// </summary>
        TableCell,

        /// <summary>
        /// Run element.
        /// </summary>
        Run,

        /// <summary>
        /// Header element.
        /// </summary>
        Header,

        /// <summary>
        /// Footer element.
        /// </summary>
        Footer,

        /// <summary>
        /// Field character element.
        /// </summary>
        FieldCharacter,

        /// <summary>
        /// Image inline element.
        /// </summary>
        ImageInline,

        /// <summary>
        /// Floating image.
        /// </summary>
        FloatingImage,

        /// <summary>
        /// Break element.
        /// </summary>
        Break,

        /// <summary>
        /// Comment element.
        /// </summary>
        Comment,

        // TODO Implement.
        /////// <summary>
        /////// Footnote reference element.
        /////// </summary>
        ////FootnoteReference,

        // TODO Implement.
        /////// <summary>
        /////// Endnote reference element.
        /////// </summary>
        ////EndnoteReference,

        /// <summary>
        /// Bookmark range start element.
        /// </summary>
        BookmarkRangeStart,

        /// <summary>
        /// Bookmark range end element.
        /// </summary>
        BookmarkRangeEnd,

        /// <summary>
        /// Comment range start element.
        /// </summary>
        CommentRangeStart,

        /// <summary>
        /// Comment range end element.
        /// </summary>
        CommentRangeEnd,

        // TODO Implement.
        /////// <summary>
        /////// Hyperlink element.
        /////// </summary>
        ////Hyperlink,

        /// <summary>
        /// Permission range start element.
        /// </summary>
        PermissionRangeStart,

        /// <summary>
        /// Permission range end element.
        /// </summary>
        PermissionRangeEnd,
    }
}
