namespace Telerik.Windows.Documents.Flow.Model.Editing
{
    /// <summary>
    /// Static class holding extension methods related to editing.
    /// </summary>
    public static class EditingExtensions
    {
        /// <summary>
        /// Gets RadFlowDocumentEditor positioned after the inline.
        /// </summary>
        /// <param name="inline">The inline.</param>
        /// <returns></returns>
        public static RadFlowDocumentEditor GetEditorAfter(this InlineBase inline)
        {
            RadFlowDocumentEditor editor = new RadFlowDocumentEditor(inline.Document);
            editor.MoveToInlineEnd(inline);
            return editor;
        }

        /// <summary>
        /// Gets RadFlowDocumentEditor positioned before the inline.
        /// </summary>
        /// <param name="inline">The inline.</param>
        /// <returns></returns>
        public static RadFlowDocumentEditor GetEditorBefore(this InlineBase inline)
        {
            RadFlowDocumentEditor editor = new RadFlowDocumentEditor(inline.Document);
            editor.MoveToInlineStart(inline);
            return editor;
        }

        ////// TODO: Revise move methods. Consider "at start/end" parameters
        ////public static RadFlowDocumentEditor GetEditor(this Paragraph paragraph)
        ////{
        ////    RadFlowDocumentEditor editor = new RadFlowDocumentEditor(paragraph.Document);
        ////    editor.MoveToParagraphStart(paragraph);
        ////    return editor;
        ////}
    }
}