﻿using Telerik.Windows.Documents.Flow.Model.Cloning;

namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// This inline should be used only for preserving the end of paragraph when converting to Plain text.
    /// </summary>
    internal class EndOfParagraphMarker : InlineBase
    {
        public EndOfParagraphMarker(RadFlowDocument document)
            : base(document)
        {
        }

        internal override DocumentElementType Type
        {
            get
            {
                return DocumentElementType.Run;
            }
        }

        internal override DocumentElementBase CloneCore(CloneContext cloneContext)
        {
            return new EndOfParagraphMarker(cloneContext.Document);
        }
    }
}
