using Telerik.Windows.Documents.Flow.Model.Editing;
using Telerik.Windows.Documents.Flow.Model.Fields.FieldCode;

namespace Telerik.Windows.Documents.Flow.Model.Fields
{
    /// <summary>
    /// Represents a COMPARE field.
    /// </summary>
    public class CompareField : ComparisonFieldBase
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CompareField" /> class.
        /// </summary>
        /// <param name="document">The document.</param>
        internal CompareField(RadFlowDocument document)
            : base(document)
        {
        }

        internal override FieldResult GetFieldResult(FieldUpdateContext context)
        {
            FieldParameters parameters = context.Parameters;
            RadFlowDocumentEditor editor = context.Editor;
            ComparisonFieldResult comparisonResult = ComparisonFieldBase.Compare(parameters.Comparison, editor.Document);

            return comparisonResult;
        }
    }
}