﻿using System;
using Telerik.Windows.Documents.Core.Sevices;
using Telerik.Windows.Documents.Flow.Model.Fields.Formatting;

namespace Telerik.Windows.Documents.Flow.Model.Fields
{
    /// <summary>
    /// Represents a date field.
    /// </summary>
    public class DateField : Field
    {
        internal DateField(RadFlowDocument document)
            : base(document)
        {
        }

        internal override FieldResult GetFieldResult(FieldUpdateContext context)
        {
            DateTime date = DateTimeService.GetDateTime();
            string result = DateTimeFormatter.FormatDate(date, this.DateTimeFormatting);

            return new FieldResult(result);
        }
    }
}