using Telerik.Windows.Documents.Flow.Model.Fields.Expressions;

namespace Telerik.Windows.Documents.Flow.Model.Fields
{
    /// <summary>
    /// Represents an expression field.
    /// </summary>
    public class ExpressionField : Field
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ExpressionField" /> class.
        /// </summary>
        /// <param name="document">The document.</param>
        internal ExpressionField(RadFlowDocument document)
            : base(document)
        {
        }

        internal override FieldResult GetFieldResult(FieldUpdateContext context)
        {
            FieldResult fieldResult = null;

            if (context.Parameters.Expression != null)
            {
                Expression expression = ExpressionParser.Parse(context.Parameters.Expression, this.Document);
                ExpressionResult result = expression.GetResult();
                if (result.Error == null)
                {
                    fieldResult = new FieldResult(result.Value.ToString());
                }
                else
                {
                    fieldResult = new FieldResult("#ExpressionError", true);
                }
            }

            return fieldResult;
        }
    }
}