namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions
{
    internal class BooleanExpression : Expression
    {
        /// <summary>
        /// The True BooleanExpression.
        /// </summary>
        public static readonly BooleanExpression True = new BooleanExpression(true);

        /// <summary>
        /// The False BooleanExpression.
        /// </summary>
        public static readonly BooleanExpression False = new BooleanExpression(false);

        private readonly bool value;

        private BooleanExpression(bool value)
        {
            this.value = value;
        }

        public bool Value
        {
            get
            {
                return this.value;
            }
        }

        /// <summary>
        /// Gets the result.
        /// </summary>
        /// <returns></returns>
        public override ExpressionResult GetResult()
        {
            return new ExpressionResult(this.value ? 1 : 0);
        }
    }
}