﻿using System;
using System.Collections.Generic;

namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions
{
    internal static class ErrorExpressions
    {
        private static readonly Dictionary<ExpressionErrorType, ExpressionResult> errorExpressions;

        static ErrorExpressions()
        {
            errorExpressions = new Dictionary<ExpressionErrorType, ExpressionResult>();
            InitializeErrorExpressions();
        }

        public static ExpressionResult GetExpressionResult(ExpressionErrorType error)
        {
            return errorExpressions[error];
        }

        private static void InitializeErrorExpressions()
        {
            Func<string, ExpressionResult> expressionResultCreator = (message) => new ExpressionResult(new ExpressionException(message));

            errorExpressions.Add(ExpressionErrorType.UndefinedBookmark, expressionResultCreator("Undefined bookmark."));
            errorExpressions.Add(ExpressionErrorType.DivisionByZero, expressionResultCreator("You cannot divide by zero."));
            errorExpressions.Add(ExpressionErrorType.ExponentNotAnInteger, expressionResultCreator("Exponent is not an integer."));
        }
    }
}