using System;

namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions
{
    /// <summary>
    /// Inheritor of System.Exception used when an ExpressionException needs to be thrown.
    /// </summary>
    [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1032:ImplementStandardExceptionConstructors"), System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2237:MarkISerializableTypesWithSerializable")]
    public class ExpressionException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ExpressionException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public ExpressionException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ExpressionException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public ExpressionException(string message, Exception innerException)
            : base(message, innerException)
        {
        }
    }
}