﻿namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Functions
{
    internal class DefinedFunctionExpression : SingleArgumentFunctionExpression
    {
        public DefinedFunctionExpression(Expression[] operand)
            : base(operand)
        {
        }

        public override ExpressionResult GetResult()
        {
            double result = this.Argument.GetResult().Error == null ? 1 : 0;
            if (result != 0 && this.Argument is BookmarkExpression)
            {
                BookmarkExpression bookmarkExpression = (BookmarkExpression)this.Argument;
                result = bookmarkExpression.Document.GetBookmarkByName(bookmarkExpression.BookmarkName) != null ? 1 : 0;
            }

            return new ExpressionResult(result);
        }
    }
}