using System;
using System.Collections.ObjectModel;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Functions
{
    internal abstract class FunctionExpression : Expression
    {
        private readonly ReadOnlyCollection<Expression> arguments;

        internal FunctionExpression(Expression[] arguments)
        {
            Guard.ThrowExceptionIfNull(arguments, "arguments");
            this.arguments = Array.AsReadOnly(arguments);
        }

        public ReadOnlyCollection<Expression> Arguments
        {
            get
            {
                return this.arguments;
            }
        }
    }
}