﻿using System;

namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Functions
{
    internal class MaxFunctionExpression : FunctionExpression
    {
        public MaxFunctionExpression(Expression[] arguments)
            : base(arguments)
        {
        }

        public override ExpressionResult GetResult()
        {
            double result = this.Arguments.Count > 0 ? double.MinValue : 0;
            for (int i = 0; i < this.Arguments.Count; i++)
            {
                result = Math.Max(result, this.Arguments[i].GetResult().Value);
            }

            return new ExpressionResult(result);
        }
    }
}