﻿using System;

namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Functions
{
    internal class MinFunctionExpression : FunctionExpression
    {
        public MinFunctionExpression(Expression[] arguments)
            : base(arguments)
        {
        }

        public override ExpressionResult GetResult()
        {
            double result = this.Arguments.Count > 0 ? double.MaxValue : 0;
            for (int i = 0; i < this.Arguments.Count; i++)
            {
                result = Math.Min(result, this.Arguments[i].GetResult().Value);
            }

            return new ExpressionResult(result);
        }
    }
}