﻿using System;

namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Functions
{
    internal class RoundFunctionExpression : TwoArgumentFunctionExpression
    {
        public RoundFunctionExpression(Expression[] arguments)
            : base(arguments)
        {
        }

        public override ExpressionResult GetResult()
        {
            double firstArgument = this.FirstArgument.GetResult().Value;
            int secondArgument = (int)this.SecondArgument.GetResult().Value;

            int sign = Math.Sign(firstArgument);
            firstArgument *= sign;

            double result = sign * Math.Floor(firstArgument * Math.Pow(10, secondArgument)) / Math.Pow(10, secondArgument);

            return new ExpressionResult(result);
        }
    }
}