using System.Linq;

namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Functions
{
    internal class SumFunctionExpression : FunctionExpression
    {
        public SumFunctionExpression(Expression[] arguments)
            : base(arguments)
        {
        }

        /// <summary>
        /// Gets the result.
        /// </summary>
        /// <returns></returns>
        public override ExpressionResult GetResult()
        {
            double result = this.Arguments.Sum(arg => arg.GetResult().Value);
            return new ExpressionResult(result);
        }
    }
}