using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Functions
{
    internal abstract class TwoArgumentFunctionExpression : FunctionExpression
    {
        public TwoArgumentFunctionExpression(Expression[] arguments)
            : base(arguments)
        {
            Guard.ThrowExceptionIfOutOfRange(2, 2, arguments.Length, "arguments");
        }

        protected Expression FirstArgument
        {
            get
            {
                return this.Arguments[0];
            }
        }

        protected Expression SecondArgument
        {
            get
            {
                return this.Arguments[1];
            }
        }
    }
}