namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Operators
{
    /// <summary>
    /// Provides methods and properties for using AdditionExpression.
    /// </summary>
    internal class AdditionExpression : BinaryOperatorExpression
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AdditionExpression" /> class.
        /// </summary>
        /// <param name="left">The left.</param>
        /// <param name="right">The right.</param>
        public AdditionExpression(Expression left, Expression right)
            : base(left, right)
        {
        }

        /// <summary>
        /// Gets the operator info.
        /// </summary>
        /// <returns>The operator info as OperatorInfo.</returns>
        /// <value>The operator info.</value>
        public override OperatorInfo OperatorInfo
        {
            get
            {
                return OperatorInfos.Plus;
            }
        }

        public override ExpressionResult GetResult()
        {
            return new ExpressionResult(this.Left.GetResult().Value + this.Right.GetResult().Value);
        }
    }
}