﻿namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Operators
{
    internal class DivisionExpression : BinaryOperatorExpression
    {
        public DivisionExpression(Expression left, Expression right)
            : base(left, right)
        {
        }

        public override OperatorInfo OperatorInfo
        {
            get
            {
                return OperatorInfos.Divide;
            }
        }

        public override ExpressionResult GetResult()
        {
            double rightOperandValue = this.Right.GetResult().Value;
            if (rightOperandValue == 0)
            {
                return ErrorExpressions.GetExpressionResult(ExpressionErrorType.DivisionByZero);
            }

            return new ExpressionResult(this.Left.GetResult().Value / rightOperandValue);
        }
    }
}