﻿using System;

namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Operators
{
    internal class PowerExpression : BinaryOperatorExpression
    {
        public PowerExpression(Expression left, Expression right)
            : base(left, right)
        {
        }

        public override OperatorInfo OperatorInfo
        {
            get
            {
                return OperatorInfos.Power;
            }
        }

        public override ExpressionResult GetResult()
        {
            double left = this.Left.GetResult().Value;
            double right = this.Right.GetResult().Value;

            if (left == 0)
            {
                if (right < 0)
                {
                    return ErrorExpressions.GetExpressionResult(ExpressionErrorType.DivisionByZero);
                }
            }
            else if (left < 0)
            {
                if ((int)right != right)
                {
                    return ErrorExpressions.GetExpressionResult(ExpressionErrorType.ExponentNotAnInteger);
                }
            }

            double result = Math.Pow(left, right);
            return new ExpressionResult(result);
        }
    }
}