namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Operators
{
    internal class UnaryMinusExpression : UnaryOperatorExpression
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="UnaryMinusExpression" /> class.
        /// </summary>
        /// <param name="operand">The operand.</param>
        public UnaryMinusExpression(Expression operand)
            : base(operand)
        {
        }

        /// <summary>
        /// Gets the operator info.
        /// </summary>
        /// <returns>The operator info as OperatorInfo.</returns>
        /// <value>The operator info.</value>
        public override OperatorInfo OperatorInfo
        {
            get
            {
                return OperatorInfos.UnaryMinus;
            }
        }

        public override ExpressionResult GetResult()
        {
            return new ExpressionResult(-this.Operand.GetResult().Value);
        }
    }
}