using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.Model.Fields.Expressions.Operators
{
    internal abstract class UnaryOperatorExpression : OperatorExpression
    {
        private readonly Expression operand;

        /// <summary>
        /// Initializes a new instance of the <see cref="UnaryOperatorExpression" /> class.
        /// </summary>
        /// <param name="operand">The operand.</param>
        protected UnaryOperatorExpression(Expression operand)
        {
            Guard.ThrowExceptionIfNull(operand, "operand");

            this.operand = operand;
        }

        /// <summary>
        /// Gets the operand.
        /// </summary>
        /// <value>The operand.</value>
        /// <returns>The operand as Expression.</returns>
        public Expression Operand
        {
            get
            {
                return this.operand;
            }
        }
    }
}