﻿namespace Telerik.Windows.Documents.Flow.Model.Fields
{
    /// <summary>
    /// Specifies the type of the a field character.
    /// </summary>
    public enum FieldCharacterType
    {
        /// <summary>
        /// Specifies that the character is a start character, 
        /// which defines the start of a complex field.
        /// </summary>
        Start,

        /// <summary>
        /// Specifies that the character is an end character, 
        /// which defines the end of a complex field.
        /// </summary>
        End,

        /// <summary>
        /// Specifies that the character is a separator character, 
        /// which defines the end of the field codes and the start of the field result for a complex field.
        /// </summary>
        Separator
    }
}
