using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.Model.Fields.FieldCode
{
    /// <summary>
    /// Represents a field argument.
    /// </summary>
    public class FieldArgument
    {
        private readonly string value;

        /// <summary>
        /// Initializes a new instance of the <see cref="FieldArgument" /> class.
        /// </summary>
        /// <param name="value">The value.</param>
        internal FieldArgument(string value)
        {
            Guard.ThrowExceptionIfNull(value, "value");

            this.value = value;
        }

        /// <summary>
        /// Gets the value.
        /// </summary>
        /// <value>The value.</value>
        public string Value
        {
            get
            {
                return this.value;
            }
        }
    }
}