namespace Telerik.Windows.Documents.Flow.Model.Fields.FieldCode
{
    /// <summary>
    /// Represent field comparison part.
    /// </summary>
    public class FieldComparison
    {
        internal FieldComparison(string left, bool isLeftQuoted, string op, string right, bool isRightQuoted)
        {
            this.LeftArgument = left;
            this.IsLeftArgumentQuoted = isLeftQuoted;
            this.Operator = op;
            this.RightArgument = right;
            this.IsRightArgumentQuoted = isRightQuoted;
        }

        /// <summary>
        /// Gets the left.
        /// </summary>
        /// <value>The left.</value>
        public string LeftArgument { get; private set; }

        /// <summary>
        /// Gets a value indicating that the left argument is quoted.
        /// </summary>
        /// <value>The value indicating that the left argument is quoted.</value>
        public bool IsLeftArgumentQuoted { get; private set; }

        /// <summary>
        /// Gets the operator.
        /// </summary>
        /// <value>The operator.</value>
        public string Operator { get; private set; }

        /// <summary>
        /// Gets or sets the right argument.
        /// </summary>
        /// <value>The right argument.</value>
        public string RightArgument { get; private set; }

        /// <summary>
        /// Gets a value indicating that the right argument is quoted.
        /// </summary>
        /// <value>The value indicating that the right argument is quoted.</value>
        public bool IsRightArgumentQuoted { get; private set; }
    }
}