namespace Telerik.Windows.Documents.Flow.Model.Fields.FieldCode
{
    /// <summary>
    /// Represents a fields switch.
    /// </summary>
    public class FieldSwitch
    {
        private readonly string switchValue;
        private FieldArgument argument;

        /// <summary>
        /// Initializes a new instance of the <see cref="FieldSwitch" /> class.
        /// </summary>
        /// <param name="switchValue">The switch key.</param>
        public FieldSwitch(string switchValue)
        {
            this.switchValue = switchValue;
        }

        /// <summary>
        /// Gets or sets the argument.
        /// </summary>
        /// <value>The argument.</value>
        public FieldArgument Argument
        {
            get
            {
                return this.argument;
            }
            set
            {
                this.argument = value;
            }
        }

        /// <summary>
        /// Gets the switch key.
        /// </summary>
        /// <value>The switch key.</value>
        public string SwitchValue
        {
            get
            {
                return this.switchValue;
            }
        }
    }
}