using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.Model.Fields.FieldCode
{
    internal class FieldToken
    {
        private readonly bool isQuoted;
        private readonly string value;
        private readonly FieldTokenType tokenType;

        public FieldToken(FieldTokenType type, string value, bool isQuoted = false)
        {
            Guard.ThrowExceptionIfNull(value, "value");

            this.tokenType = type;
            this.value = value;
            this.isQuoted = isQuoted;
        }

        public FieldTokenType TokenType
        {
            get
            {
                return this.tokenType;
            }
        }

        public string Value
        {
            get
            {
                return this.value;
            }
        }

        public bool IsQuoted
        {
            get
            {
                return this.isQuoted;
            }
        }
    }
}