﻿using Telerik.Windows.Documents.Flow.Model.Editing;
using Telerik.Windows.Documents.Flow.Model.Fields.FieldCode;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.Model.Fields
{
    internal class FieldUpdateContext
    {
        private RadFlowDocumentEditor editor;

        /// <summary>
        /// Initializes a new instance of the <see cref="FieldUpdateContext" /> class.
        /// </summary>
        /// <param name="fieldInfo">The field info.</param>
        public FieldUpdateContext(FieldInfo fieldInfo)
        {
            Guard.ThrowExceptionIfNull(fieldInfo, "fieldInfo");
            this.FieldInfo = fieldInfo;
        }

        public FieldParameters Parameters { get; internal set; }

        public FieldInfo FieldInfo { get; private set; }

        public RadFlowDocumentEditor Editor
        {
            get
            {
                if (this.editor == null)
                {
                    this.editor = new RadFlowDocumentEditor(this.FieldInfo.Document);
                }

                return this.editor;
            }
        }

        public RadFlowDocument Document
        {
            get
            {
                return this.FieldInfo.Document;
            }
        }
    }
}