using Telerik.Windows.Documents.Flow.Model.Editing;
using Telerik.Windows.Documents.Flow.Model.Fields.FieldCode;

namespace Telerik.Windows.Documents.Flow.Model.Fields
{
    /// <summary>
    /// Represents an IF field.
    /// </summary>
    public class IfField : ComparisonFieldBase
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="IfField" /> class.
        /// </summary>
        /// <param name="document">The document.</param>
        internal IfField(RadFlowDocument document)
            : base(document)
        {
        }

        /// <summary>
        /// Updates field result fragment.
        /// </summary>
        /// <param name="context">The update context.</param>
        internal override FieldResult GetFieldResult(FieldUpdateContext context)
        {
            FieldParameters parameters = context.Parameters;
            RadFlowDocumentEditor editor = context.Editor;
            ComparisonFieldResult comparisonResult = ComparisonFieldBase.Compare(parameters.Comparison, editor.Document);

            string result = comparisonResult.Result;
            if (!comparisonResult.IsError)
            {
                if (comparisonResult.CompareValue)
                {
                    result = parameters.FirstArgument.Value;
                }
                else
                {
                    result = parameters.SecondArgument.Value;
                }
            }

            return new FieldResult(result, comparisonResult.IsError);
        }
    }
}