﻿using System.Collections.Generic;
using System.Dynamic;

namespace Telerik.Windows.Documents.Flow.Model.Fields.MailMerge
{
    internal static class PropertyValueExtractor
    {
        internal static object GetValue(object source, string propertyName)
        {
            object data = source;
            if (data == null)
            {
                return null;
            }

            DynamicObject dynamicObj = data as DynamicObject;
            if (dynamicObj != null)
            {
                object result = null;
                SimpleGetMemberBinder binder = new SimpleGetMemberBinder(propertyName);

                dynamicObj.TryGetMember(binder, out result);

                return result;
            }

            ExpandoObject expandoObj = data as ExpandoObject;
            if (expandoObj != null)
            {
                object result = null;

                (expandoObj as IDictionary<string, object>).TryGetValue(propertyName, out result);

                return result;
            }

            // TODO: optimization. Try to cache the property info per type.
            System.Reflection.PropertyInfo propertyInfo = data.GetType().GetProperty(propertyName);
            if (propertyInfo != null)
            {
                object propertyValue = propertyInfo.GetValue(data, null);
                return propertyValue;
            }

            return null;
        }
    }
}
