using System;
using System.Linq.Expressions;

namespace Telerik.Windows.Documents.Flow.Model.Fields.MailMerge
{
    internal class SimpleGetMemberBinder : System.Dynamic.GetMemberBinder
    {
        internal static readonly string ExceptionFormat = "Property path is not valid. '{0}' does not have a public property named '{1}'.";

        internal SimpleGetMemberBinder(string propertyName) : base(propertyName, false)
        {
        }

        public override System.Dynamic.DynamicMetaObject FallbackGetMember(System.Dynamic.DynamicMetaObject target, System.Dynamic.DynamicMetaObject error)
        {
            return error ?? Throw(string.Format(SimpleGetMemberBinder.ExceptionFormat, new object[] { target, this.Name }), this.ReturnType);
        }

        internal static System.Dynamic.DynamicMetaObject Throw(string message, Type returnType)
        {
            return new System.Dynamic.DynamicMetaObject(Expression.Throw(Expression.New(typeof(InvalidOperationException).GetConstructor(new Type[] { typeof(string) }), new Expression[] { Expression.Constant(message) }), returnType), System.Dynamic.BindingRestrictions.Empty);
        }
    }
}