﻿namespace Telerik.Windows.Documents.Flow.Model.Fields
{
    /// <summary>
    /// Represents an instance of ParseErrorField.
    /// </summary>
    public sealed class ParseErrorField : Field
    {
        internal ParseErrorField(RadFlowDocument document, string errorMessage)
            : base(document)
        {
            this.ErrorMessage = errorMessage;
        }

        /// <summary>
        /// Gets the error message.
        /// </summary>
        /// <value>The error message.</value>
        public string ErrorMessage { get; private set; }

        internal override FieldResult GetFieldResult(FieldUpdateContext context)
        {
            return null;
        }
    }
}