﻿using Telerik.Windows.Documents.Flow.Model.Cloning;

namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// Represents footer for pages in a section.
    /// </summary>
    public sealed class Footer : HeaderFooterBase
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Footer" /> class.
        /// </summary>
        /// <param name="document">The document.</param>
        /// <param name="section">The section.</param>
        internal Footer(RadFlowDocument document, Section section)
            : base(document, section)
        {
        }

        /// <summary>
        /// Gets the type of the element.
        /// </summary>
        /// <value>The type.</value>
        internal override DocumentElementType Type
        {
            get
            {
                return DocumentElementType.Footer;
            }
        }

        internal override DocumentElementBase CloneCore(CloneContext cloneContext)
        {
            Footer footer = new Footer(cloneContext.Document, cloneContext.CurrentSection);
            footer.Blocks.AddClonedChildrenFrom(this.Blocks, cloneContext);

            return footer;
        }
    }
}
