﻿namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// Combines all footers that can be available in a <see cref="Section"/>.
    /// </summary>
    public sealed class Footers : HeadersFootersBase<Footer>
    {
        internal Footers(RadFlowDocument document, Section section)
            : base(document, section)
        {
        }

        /// <summary>
        /// Creates an instance of <see cref="Header"/> or <see cref="Footer"/> class.
        /// </summary>
        /// <returns>The new <see cref="Header"/> or <see cref="Footer"/> instance.</returns>
        protected override Footer CreateHeaderFooterInstance()
        {
            return new Footer(this.Document, this.Section);
        }
    }
}
