﻿namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// Describes the type of <see cref="Header"/> or <see cref="Footer"/>, regarding to document pagination.
    /// </summary>
    public enum HeaderFooterType
    {
        /// <summary>
        /// Default <see cref="Header"/> or <see cref="Footer"/> for document pages.
        /// </summary>
        Default,

        /// <summary>
        /// <see cref="Header"/> or <see cref="Footer"/> for even numbered pages.
        /// </summary>
        Even,

        /// <summary>
        /// <see cref="Header"/> or <see cref="Footer"/> for first page.
        /// </summary>
        First
    }
}
