﻿namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// Combines all headers that can be available in a <see cref="Section" />.
    /// </summary>
    public sealed class Headers : HeadersFootersBase<Header>
    {
        internal Headers(RadFlowDocument document, Section section)
            : base(document, section)
        {
        }

        /// <summary>
        /// Creates an instance of <see cref="Header"/> or <see cref="Footer"/> class.
        /// </summary>
        /// <returns>The new <see cref="Header"/> or <see cref="Footer"/> instance.</returns>
        protected override Header CreateHeaderFooterInstance()
        {
            return new Header(this.Document, this.Section);
        }
    }
}