﻿using System.Collections.Generic;
using System.Linq;

namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// Provides base functionality for all inline flow content elements.
    /// </summary>
    public abstract class InlineBase : DocumentElementBase
    {
        internal InlineBase(RadFlowDocument document)
            : base(document)
        {
        }

        /// <summary>
        /// Gets the parent paragraph of the inline.
        /// </summary>
        /// <value>The paragraph.</value>
        public Paragraph Paragraph
        {
            get
            {
                return (Paragraph)this.Parent;
            }
        }

        internal override IEnumerable<DocumentElementBase> Children
        {
            get
            {
                return Enumerable.Empty<DocumentElementBase>();
            }
        }
    }
}
