﻿namespace Telerik.Windows.Documents.Flow.Model.Protection
{
    /// <summary>
    /// Describes supported protection algorithm names.
    /// </summary>
    public static class ProtectionAlgorithmNames
    {
        /// <summary>
        /// Represents the SHA-1 algorithm name.
        /// </summary>
        public const string SHA1 = Common.Model.Protection.SHA1.Name;

        /// <summary>
        /// Represents the SHA-256 algorithm name.
        /// </summary>
        public const string SHA256 = Common.Model.Protection.SHA256.Name;

        /// <summary>
        /// Represents the SHA-384 algorithm name.
        /// </summary>
        public const string SHA384 = Common.Model.Protection.SHA384.Name;

        /// <summary>
        /// Represents the SHA-512 algorithm name.
        /// </summary>
        public const string SHA512 = Common.Model.Protection.SHA512.Name;
    }
}
