﻿namespace Telerik.Windows.Documents.Flow.Model.Protection
{
    /// <summary>
    /// Describes possible editing restrictions.
    /// </summary>
    public enum ProtectionMode
    {
        /// <summary> 
        /// Specifies that no editing restrictions are applied.
        /// </summary>
        NoProtection,

        /// <summary> 
        /// Specifies that working with comments is allowed in addition to editing in permission ranges.
        /// </summary> 
        AllowComments,

        /// <summary> 
        /// Specifies that editing is allowed only in permission regions.
        /// </summary> 
        ReadOnly
    }
}
