﻿using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.Flow.Model.Styles.Core;

namespace Telerik.Windows.Documents.Flow.Model
{
    public partial class RadFlowDocument
    {
        /// <summary>
        /// Holds the property definition for the HasDifferentEvenOddPageHeadersFooters property.
        /// </summary>
        public static readonly StylePropertyDefinition<bool?> HasDifferentEvenOddPageHeadersFootersPropertyDefinition =
            new StylePropertyDefinition<bool?>("HasDifferentEvenOddPageHeadersFooters",
                DocumentDefaultStyleSettings.HasDifferentEvenOddPageHeadersFooters,
                StylePropertyType.Document);

        /// <summary>
        /// Holds the property definition for the ViewType property.
        /// </summary>
        public static readonly StylePropertyDefinition<DocumentViewType?> ViewTypePropertyDefinition =
            new StylePropertyDefinition<DocumentViewType?>("ViewType",
                DocumentDefaultStyleSettings.ViewType,
                StylePropertyType.Document);

        /// <summary>
        /// Holds the property definition for the DefaultTabStopWidth property.
        /// </summary>
        public static readonly StylePropertyDefinition<double?> DefaultTabStopWidthPropertyDefinition =
            new StylePropertyDefinition<double?>("DefaultTabStopWidth",
            DocumentDefaultStyleSettings.DefaultTabStopWidth,
            StylePropertyType.Document);

        static RadFlowDocument()
        {
            DefaultTabStopWidthPropertyDefinition.Validation.AddRule(new ValidationRule<double>(value => value >= 0));
        }
    }
}
