﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
#endif
using Telerik.Windows.Documents.Primitives;
using Telerik.Windows.Documents.Flow.Model.Lists;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.Flow.Model.Styles.Core;
using Telerik.Windows.Documents.Model;

namespace Telerik.Windows.Documents.Flow.Model
{
    public partial class Section
    {
        /// <summary>
        /// Gets the font size property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<bool?> HasDifferentFirstPageHeaderFooterPropertyDefinition =
            new StylePropertyDefinition<bool?>("HasDifferentFirstPageHeaderFooter",
                DocumentDefaultStyleSettings.HasDifferentFirstPageHeaderFooter,
                StylePropertyType.Section);

        /// <summary>
        /// Gets the page orientation property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<PageOrientation?> PageOrientationPropertyDefinition =
            new StylePropertyDefinition<PageOrientation?>("PageOrientation",
                DocumentDefaultStyleSettings.PageOrientation,
                StylePropertyType.Section);

        /// <summary>
        /// Gets the page size property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<Size?> PageSizePropertyDefinition =
            new StylePropertyDefinition<Size?>("PageSize",
                DocumentDefaultStyleSettings.PageSize,
                StylePropertyType.Section);

        /// <summary>
        /// Gets the page margins property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<Padding> PageMarginsPropertyDefinition =
            new StylePropertyDefinition<Padding>("PageMargins",
                DocumentDefaultStyleSettings.PageMargins,
                StylePropertyType.Section);

        /// <summary>
        /// Gets the header top margin property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<double?> HeaderTopMarginPropertyDefinition =
            new StylePropertyDefinition<double?>("HeaderTopMargin",
                DocumentDefaultStyleSettings.SectionHeaderTopMargin,
                StylePropertyType.Section);

        /// <summary>
        /// Gets the header top margin property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<double?> FooterBottomMarginPropertyDefinition =
            new StylePropertyDefinition<double?>("FooterBottomMargin",
                DocumentDefaultStyleSettings.SectionFooterBottomMargin,
                StylePropertyType.Section);

        /// <summary>
        /// Gets the section type property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<SectionType?> SectionTypePropertyDefinition =
            new StylePropertyDefinition<SectionType?>("SectionType",
                DocumentDefaultStyleSettings.SectionType,
                StylePropertyType.Section);

        /// <summary>
        /// Gets the vertical alignment property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<Styles.VerticalAlignment> VerticalAlignmentPropertyDefinition =
            new StylePropertyDefinition<Styles.VerticalAlignment>("VerticalAlignment",
                DocumentDefaultStyleSettings.VerticalAlignment,
                StylePropertyType.Section);

        /// <summary>
        /// Gets the chapter separator character property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<ChapterSeparatorType?> ChapterSeparatorCharacterPropertyDefinition =
            new StylePropertyDefinition<ChapterSeparatorType?>("ChapterSeparatorCharacter",
                null,
                StylePropertyType.Section);

        /// <summary>
        /// Gets the chapter heading style index property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<int?> ChapterHeadingStyleIndexPropertyDefinition =
            new StylePropertyDefinition<int?>("ChapterHeadingStyleIndex",
                null,
                StylePropertyType.Section);

        /// <summary>
        /// Gets the page number format property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<NumberingStyle?> PageNumberFormatPropertyDefinition =
            new StylePropertyDefinition<NumberingStyle?>("PageNumberFormat",
                null,
                StylePropertyType.Section);

        /// <summary>
        /// Gets the starting page number property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<int?> StartingPageNumberPropertyDefinition =
            new StylePropertyDefinition<int?>("StartingPageNumber",
                null,
                StylePropertyType.Section);
    }
}
