namespace Telerik.Windows.Documents.Flow.Model.Shapes
{
    /// <summary>
    /// This type contains the possible settings specifying how the shape may be horizontally aligned 
    /// relative to the horizontal alignment base defined by the parent element.
    /// </summary>
    public enum RelativeHorizontalAlignment
    {
        /// <summary>
        /// Specifies that the object shall be left aligned to the horizontal alignment base.
        /// </summary>
        Left,

        /// <summary>
        /// Specifies that the object shall be centered with respect to the horizontal alignment base.
        /// </summary>
        Center,

        /// <summary>
        /// Specifies that the object shall be right aligned to the horizontal alignment base.
        /// </summary>
        Right,

        /// <summary>
        /// Specifies that the object shall be inside of the horizontal alignment base.
        /// </summary>
        Inside,

        /// <summary>
        /// Specifies that the object shall be outside of the horizontal alignment base.
        /// </summary>
        Outside,
    }
}