namespace Telerik.Windows.Documents.Flow.Model.Shapes
{
    /// <summary>
    /// This type contains the possible settings specifying how the shape may be vertically aligned 
    /// relative to the vertical alignment base defined by the parent element.
    /// </summary>
    public enum RelativeVerticalAlignment
    {
        /// <summary>
        /// Specifies that the object shall be at the top of the vertical alignment base.
        /// </summary>
        Top,

        /// <summary>
        /// Specifies that the object shall be centered with respect to the vertical alignment base.
        /// </summary>
        Center,

        /// <summary>
        /// Specifies that the object shall be at the bottom of the vertical alignment base.
        /// </summary>
        Bottom,

        /// <summary>
        /// Specifies that the object shall be inside of the vertical alignment base.
        /// </summary>
        Inside,

        /// <summary>
        /// Specifies that the object shall be outside of the vertical alignment base.
        /// </summary>
        Outside,
    }
}