namespace Telerik.Windows.Documents.Flow.Model.Shapes
{
    /// <summary>
    /// Defines different modes of wrapping.
    /// </summary>
    public enum ShapeWrappingType
    {
        /// <summary>
        /// No wrapping should be used for the related element. 
        /// In effect, this setting shall place the object in front of or behind the text.
        /// </summary>
        None,

        /// <summary>
        /// This element specifies that text shall wrap around a virtual rectangle bounding this shape.
        /// </summary>
        Square,

        /// <summary>
        /// This element specifies that text shall wrap around the top and bottom of this object, but not its left or right edges.
        /// </summary>
        TopAndBottom,
    }
}