namespace Telerik.Windows.Documents.Flow.Model.Shapes
{
    /// <summary>
    /// Specifies different text wrapping modes.
    /// </summary>
    public enum TextWrap
    {
        /// <summary>
        /// Specifies that text shall wrap around both sides of the object.
        /// </summary>
        BothSides,

        /// <summary>
        /// Specifies that text shall only wrap around the left side of the object.
        /// </summary>
        LeftOnly,

        /// <summary>
        /// Specifies that text shall only wrap around the right side of the object.
        /// </summary>
        RightOnly,

        /// <summary>
        /// Specifies that text shall only wrap around the largest side of the object.
        /// </summary>
        Largest,
    }
}