﻿namespace Telerik.Windows.Documents.Flow.Model.Styles.Core
{
    internal static class GlobalPropertyIndexGenerator
    {
        private static readonly int[] counters = new int[7];
        private static readonly object lockObject = new object();

        public static int GetNext(StylePropertyType stylePropertyType)
        {
            int index = 0;
            switch (stylePropertyType)
            {
                case StylePropertyType.Character:
                    index = 0;
                    break;
                case StylePropertyType.Paragraph:
                    index = 1;
                    break;
                case StylePropertyType.Table:
                    index = 2;
                    break;
                case StylePropertyType.TableRow:
                    index = 3;
                    break;
                case StylePropertyType.TableCell:
                    index = 4;
                    break;
                case StylePropertyType.Section:
                    index = 5;
                    break;
                case StylePropertyType.Document:
                    index = 6;
                    break;
                case StylePropertyType.DocumentElement:
                    return 0;
            }

            lock (lockObject)
            {
                return ++counters[index];
            }
        }
    }
}
