﻿namespace Telerik.Windows.Documents.Flow.Model.Styles.Core
{
    /// <summary>
    /// Describes the type of a style property.
    /// </summary>
    public enum StylePropertyType
    {
        /// <summary>
        /// Character style property type.
        /// </summary>
        Character,

        /// <summary>
        /// Paragraph style property type.
        /// </summary>
        Paragraph,

        /// <summary>
        /// Table style property type.
        /// </summary>
        Table,

        /// <summary>
        /// TableRow style property type.
        /// </summary>
        TableRow,

        /// <summary>
        /// TableCell style property type.
        /// </summary>
        TableCell,

        /// <summary>
        /// Section style property type.
        /// </summary>
        Section,

        /// <summary>
        /// Document style property type.
        /// </summary>
        Document,

        /// <summary>
        /// Generic DocumentElement style property type.
        /// </summary>
        DocumentElement
    }
}
