﻿using Telerik.Windows.Documents.Flow.Model.Styles.Core;
#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Spreadsheet.Model;
#else
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Flow.Model.Styles
{
    /// <summary>
    /// Establishes common functionality for document element properties with shading.
    /// </summary>
    public interface IPropertiesWithShading
    {
        /// <summary>
        /// Gets the color of the background.
        /// </summary>
        /// <value>The color of the background.</value>
        IStyleProperty<ThemableColor> BackgroundColor { get; }

        /// <summary>
        /// Gets a value indicating the color for any foreground pattern used in this shading.
        /// </summary>
        /// <value>The color of the pattern.</value>
        IStyleProperty<ThemableColor> ShadingPatternColor { get; }

        /// <summary>
        /// Gets a value indicating the pattern which shall be used to lay the pattern color over the background color for this shading.
        /// </summary>
        /// <value>The pattern.</value>
        IStyleProperty<ShadingPattern?> ShadingPattern { get; }

        /// <summary>
        /// Gets the document.
        /// </summary>
        /// <value>The document.</value>
        RadFlowDocument Document { get; }
    }
}
