﻿namespace Telerik.Windows.Documents.Flow.Model.Styles
{
    /// <summary>
    /// Describes how the baseline for a text-based element is positioned on the vertical axis, relative to the established baseline for text.
    /// </summary>
    public enum BaselineAlignment
    {
        /// <summary>
        /// A baseline that is aligned at the actual baseline of the containing box.
        /// </summary>
        Baseline,

        /// <summary>
        /// A baseline that is aligned at the subscript position of the containing box.
        /// </summary>
        Subscript,

        /// <summary>
        /// A baseline that is aligned at the superscript position of the containing box.
        /// </summary>
        Superscript
    }
}
