﻿namespace Telerik.Windows.Documents.Flow.Model.Styles
{
    /// <summary>
    /// Describes the document view types.
    /// </summary>
    public enum DocumentViewType
    {
        /// <summary>
        /// None.
        /// </summary>
        None,

        /// <summary>
        /// Print layout view.
        /// </summary>
        PrintLayout,

        /// <summary>
        /// Outline view.
        /// </summary>
        Outline,

        /// <summary>
        /// Master pages view (master document view).
        /// </summary>
        MasterPages,

        /// <summary>
        /// Normal (draft) view.
        /// </summary>
        Normal,

        /// <summary>
        /// Web layout view.
        /// </summary>
        WebLayout
    }
}
