﻿namespace Telerik.Windows.Documents.Flow.Model.Styles
{
    /// <summary>
    /// Defines section types.
    /// </summary>
    public enum SectionType
    {
        /// <summary> 
        /// Specifies that the section starts on the next page.
        /// </summary>
        NextPage,

        /// <summary> 
        /// Specifies that the section starts on the next even page.
        /// </summary>
        EvenPage,

        /// <summary> 
        /// Specifies that the section starts on the next odd page.
        /// </summary>
        OddPage,

        /// <summary> 
        /// Specifies that the section starts on the same page.
        /// </summary>
        Continuous,

        /// <summary> 
        /// Specifies that the section starts on the next column on the page.
        /// </summary>
        NextColumn,
    }
}
