﻿namespace Telerik.Windows.Documents.Flow.Model.Styles
{
    /// <summary>
    /// Describes the type of shading pattern.
    /// </summary>
    public enum ShadingPattern
    {
        /// <summary>
        /// No shading.
        /// </summary>
        None,

        /// <summary>
        /// No pattern.
        /// </summary>
        Clear,

        /// <summary>
        /// 100% fill pattern. 
        /// </summary>
        Solid,

        /// <summary>
        /// Series of horizontal stripes.
        /// </summary>
        HorizontalStripe,

        /// <summary>
        /// Series of vertical stripes.
        /// </summary>
        VerticalStripe,

        /// <summary>
        /// Series of reversed diagonal stripes.
        /// </summary>
        ReverseDiagonalStripe,

        /// <summary>
        /// Series of diagonal stripes.
        /// </summary>
        DiagonalStripe,

        /// <summary>
        /// Series of horizontal crosses.
        /// </summary>
        HorizontalCross,

        /// <summary>
        /// Series of diagonal crosses.
        /// </summary>
        DiagonalCross,

        /// <summary>
        /// Series of thin horizontal stripes.
        /// </summary>
        ThinHorizontalStripe,

        /// <summary>
        /// Series of thin vertical stripes.
        /// </summary>
        ThinVerticalStripe,

        /// <summary>
        /// Series of thin reversed diagonal stripes.
        /// </summary>
        ThinReverseDiagonalStripe,

        /// <summary>
        /// Series of thin diagonal stripes.
        /// </summary>
        ThinDiagonalStripe,

        /// <summary>
        /// Series of thin horizontal crosses.
        /// </summary>
        ThinHorizontalCross,

        /// <summary>
        /// Series of thin diagonal crosses.
        /// </summary>
        ThinDiagonalCross,

        /// <summary>
        /// 5% fill pattern.
        /// </summary>
        Percent5,

        /// <summary>
        /// 10% fill pattern.
        /// </summary>
        Percent10,

        /// <summary>
        /// 12.5% fill pattern.
        /// </summary>
        Percent12,

        /// <summary>
        /// 15% fill pattern.
        /// </summary>
        Percent15,

        /// <summary>
        /// 20% fill pattern.
        /// </summary>
        Percent20,

        /// <summary>
        /// 25% fill pattern.
        /// </summary>
        Percent25,

        /// <summary>
        /// 30% fill pattern.
        /// </summary>
        Percent30,

        /// <summary>
        /// 35% fill pattern.
        /// </summary>
        Percent35,

        /// <summary>
        /// 37.5% fill pattern.
        /// </summary>
        Percent37,

        /// <summary>
        /// 40% fill pattern.
        /// </summary>
        Percent40,

        /// <summary>
        /// 45% fill pattern.
        /// </summary>
        Percent45,

        /// <summary>
        /// 50% fill pattern.
        /// </summary>
        Percent50,

        /// <summary>
        /// 55% fill pattern.
        /// </summary>
        Percent55,

        /// <summary>
        /// 60% fill pattern.
        /// </summary>
        Percent60,

        /// <summary>
        /// 62.5% fill pattern.
        /// </summary>
        Percent62,

        /// <summary>
        /// 65% fill pattern.
        /// </summary>
        Percent65,

        /// <summary>
        /// 70% fill pattern.
        /// </summary>
        Percent70,

        /// <summary>
        /// 75% fill pattern.
        /// </summary>
        Percent75,

        /// <summary>
        /// 80% fill pattern.
        /// </summary>
        Percent80,

        /// <summary>
        /// 85% fill pattern.
        /// </summary>
        Percent85,

        /// <summary>
        /// 87.5% fill pattern.
        /// </summary>
        Percent87,

        /// <summary>
        /// 90% fill pattern.
        /// </summary>
        Percent90,

        /// <summary>
        /// 95% fill pattern.
        /// </summary>
        Percent95,
    }
}
