﻿namespace Telerik.Windows.Documents.Flow.Model.Styles
{
    /// <summary>
    /// Specifies the possible values for the units of the width property of table cell or table.
    /// </summary>
    public enum TableWidthUnitType
    {
        /// <summary>
        /// Automatically determined width.
        /// </summary>
        Auto,

        /// <summary>
        /// Fixed width.
        /// </summary>
        Fixed,

        /// <summary>
        /// Width is defined as a percent.
        /// </summary>
        Percent,

        /// <summary>
        /// The width should be zero.
        /// </summary>
        Nil
    }
}
