﻿namespace Telerik.Windows.Documents.Flow.Model.Styles
{
    /// <summary>
    /// Defines constants which specify the text flow direction in a <see cref="Telerik.Windows.Documents.Flow.Model.TableCell"/>.
    /// </summary>
    public enum TextDirection
    {
        /// <summary>
        /// Specifies the text shall flow from left to right horizontally and from top to bottom vertically.
        /// </summary>
        LeftToRightTopToBottom,

        /// <summary>
        /// Specifies the text shall flow from bottom to top vertically and from left to right horizontally.
        /// </summary>
        BottomToTopLeftToRight,

        /// <summary>
        /// Specifies the text shall flow from top to bottom vertically and from right to left horizontally.
        /// </summary>
        TopToBottomRightToLeft,

        /// <summary>
        /// Specifies the text shall flow from left to right horizontally and from top to bottom vertically. This flow is rotated.
        /// </summary>
        LeftToRightTopToBottomRotated,

        /// <summary>
        /// Specifies the text shall flow from top to bottom vertically and from left to right horizontally. This flow is rotated.
        /// </summary>
        TopToBottomLeftToRightRotated,

        /// <summary>
        /// Specifies the text shall flow from top to bottom vertically and from right to left horizontally. This flow is rotated.
        /// </summary>
        TopToBottomRightToLeftRotated,
    }
}