﻿namespace Telerik.Windows.Documents.Flow.Model.Styles
{
    /// <summary>
    /// Specifies the types of patterns which may be used to create an underline.
    /// </summary>
    public enum UnderlinePattern
    {
        /// <summary>No underline.</summary>
        None,

        /// <summary>Single line underline.</summary>
        Single,

        /// <summary>Underline non-space Characters only.</summary>
        Words,

        /// <summary>Double line underline.</summary>
        Double,

        /// <summary>Thick line underline.</summary>
        Thick,

        /// <summary>Dotted line underline.</summary>
        Dotted,

        /// <summary>Thick dotted line underline.</summary>
        DottedHeavy,

        /// <summary>Dashed line underline.</summary>
        Dash,

        /// <summary>Thick dashed line underline.</summary>
        DashedHeavy,

        /// <summary>Long dashed line underline.</summary>
        DashLong,

        /// <summary>Thick long dashed line underline.</summary>
        DashLongHeavy,

        /// <summary>Dot-dashed line underline.</summary>
        DotDash,

        /// <summary>Thick dot-dashed line underline.</summary>
        DashDotHeavy,

        /// <summary>Dot-dot-dashed line underline.</summary>
        DotDotDash,

        /// <summary>Thick dot-dot-dashed line underline.</summary>
        DashDotDotHeavy,

        /// <summary>Wavy line underline.</summary>
        Wave,

        /// <summary>Thick wavy line underline.</summary>
        WavyHeavy,

        /// <summary>Double wavy line underline.</summary>
        WavyDouble
    }
}
