﻿namespace Telerik.Windows.Documents.Flow.Model.Styles
{
    /// <summary>
    /// Describes vertical alignment of an element.
    /// </summary>
    public enum VerticalAlignment
    {
        /// <summary>
        /// The element is aligned to the top of the parent's layout slot.
        /// </summary>
        Top,

        /// <summary>
        /// The element is aligned to the bottom of the parent's layout slot.
        /// </summary>
        Bottom,

        /// <summary>
        /// The element is aligned to the center of the parent's layout slot.
        /// </summary>
        Center,

        /// <summary>
        /// Specifies that the text should be justified between the top and the bottom of the parent's layout slot.
        /// </summary>
        Justified
    }
}