﻿using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.Flow.Model.Styles.Core;
using Telerik.Windows.Documents.Primitives;
#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Spreadsheet.Model;
#else
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Flow.Model
{
    public partial class Table
    {
        /// <summary>
        /// Gets the alignment property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<Alignment?> AlignmentPropertyDefinition =
            new StylePropertyDefinition<Alignment?>("Alignment", DocumentDefaultStyleSettings.TableAlignment, StylePropertyType.Table);

        /// <summary>
        /// Gets the table cell padding property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<Padding> TableCellPaddingPropertyDefinition =
            new StylePropertyDefinition<Padding>("TableCellPadding", DocumentDefaultStyleSettings.TableTableCellPadding, StylePropertyType.Table);

        /// <summary>
        /// Gets the table cell spacing property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<double?> TableCellSpacingPropertyDefinition =
            new StylePropertyDefinition<double?>("TableCellSpacing", DocumentDefaultStyleSettings.TableTableCellSpacing, StylePropertyType.Table);

        /// <summary>
        /// Gets the indent property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<double?> IndentPropertyDefinition =
            new StylePropertyDefinition<double?>("Indent", DocumentDefaultStyleSettings.TableIndent, StylePropertyType.Table);

        /// <summary>
        /// Gets the row banding property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<int?> RowBandingPropertyDefinition =
            new StylePropertyDefinition<int?>("RowBanding", DocumentDefaultStyleSettings.RowBanding, StylePropertyType.Table);

        /// <summary>
        /// Gets the column banding property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<int?> ColumnBandingPropertyDefinition =
            new StylePropertyDefinition<int?>("ColumnBanding", DocumentDefaultStyleSettings.ColumnBanding, StylePropertyType.Table);

        /// <summary>
        /// Gets the top border property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<TableBorders> TableBordersPropertyDefinition =
            new StylePropertyDefinition<TableBorders>("Borders", DocumentDefaultStyleSettings.TableBorders, StylePropertyType.Table);

        /// <summary>
        /// Gets the background color property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<ThemableColor> BackgroundColorPropertyDefinition =
            new StylePropertyDefinition<ThemableColor>("BackgroundColor", DocumentDefaultStyleSettings.TableBackgroundColor, StylePropertyType.Table);

        /// <summary>
        /// Gets the shading pattern color property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<ThemableColor> ShadingPatternColorPropertyDefinition =
            new StylePropertyDefinition<ThemableColor>("ShadingPatternColor", DocumentDefaultStyleSettings.TableShadingPatternColor, StylePropertyType.Table);

        /// <summary>
        /// Gets the shading pattern property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<ShadingPattern?> ShadingPatternPropertyDefinition =
            new StylePropertyDefinition<ShadingPattern?>("ShadingPattern", DocumentDefaultStyleSettings.TableShadingPattern, StylePropertyType.Table);

        /// <summary>
        /// Gets the flow direction property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<FlowDirection?> FlowDirectionPropertyDefinition =
            new StylePropertyDefinition<FlowDirection?>("FlowDirection", DocumentDefaultStyleSettings.TableFlowDirection, StylePropertyType.Table);

        // TODO Implement.
        /////// <summary>
        /////// Gets the floating position property definition.
        /////// </summary>
        ////public static readonly StylePropertyDefinition<FloatingPosition> FloatingPositionPropertyDefinition =
        ////    new StylePropertyDefinition<FloatingPosition>("TableFloatingPosition", DocumentDefaultStyleSettings.TableFloatingPosition, StylePropertyType.Table);

        /// <summary>
        /// Gets the preferred width property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<TableWidthUnit> PreferredWidthPropertyDefinition =
           new StylePropertyDefinition<TableWidthUnit>("PreferredWidth", DocumentDefaultStyleSettings.TablePreferredWidth, StylePropertyType.Table);

        /// <summary>
        /// Gets the table looks property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<TableLooks?> LooksPropertyDefinition =
            new StylePropertyDefinition<TableLooks?>("Looks", DocumentDefaultStyleSettings.TableLooks, StylePropertyType.Table);

        /// <summary>
        /// Gets the layout type property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<TableLayoutType?> LayoutTypePropertyDefinition =
            new StylePropertyDefinition<TableLayoutType?>("LayoutType", DocumentDefaultStyleSettings.TableLayoutType, StylePropertyType.Table);

        /// <summary>
        /// Gets the overlap property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<bool?> OverlapPropertyDefinition =
            new StylePropertyDefinition<bool?>("Overlap", DocumentDefaultStyleSettings.TableOverlap, StylePropertyType.Table);
    }
}
