﻿using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.Flow.Model.Styles.Core;

namespace Telerik.Windows.Documents.Flow.Model
{
    public partial class TableRow
    {
        /// <summary>
        /// Gets the table cell spacing property definition for the row.
        /// </summary>
        public static readonly StylePropertyDefinition<double?> TableCellSpacingPropertyDefinition =
            new StylePropertyDefinition<double?>("TableCellSpacing", DocumentDefaultStyleSettings.TableRowTableCellSpacing, StylePropertyType.TableRow);

        /// <summary>
        /// Gets the repeat on every page property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<bool?> RepeatOnEveryPagePropertyDefinition =
            new StylePropertyDefinition<bool?>("RepeatOnEveryPage", DocumentDefaultStyleSettings.TableRowRepeatOnEveryPage, StylePropertyType.TableRow);

        /// <summary>
        /// Gets the height property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<TableRowHeight> HeightPropertyDefinition =
            new StylePropertyDefinition<TableRowHeight>("Height", DocumentDefaultStyleSettings.TableRowHeight, StylePropertyType.TableRow);

        /// <summary>
        /// Gets the can split property definition.
        /// </summary>
        public static readonly StylePropertyDefinition<bool?> CanSplitPropertyDefinition =
            new StylePropertyDefinition<bool?>("CanSplit", DocumentDefaultStyleSettings.TableRowCanSplit, StylePropertyType.TableRow);
    }
}
