﻿namespace Telerik.Windows.Documents.Flow.Model
{
    /// <summary>
    /// Defines the possible text wrapping restart locations.
    /// </summary>
    public enum TextWrappingRestartLocation
    {
        /// <summary>
        /// Specifies that the line break shall advance the text to the next line in the document.
        /// </summary>
        NextLine, // none

        /// <summary>
        /// Specifies that the line break shall advance the text to the next line in the document which is not interrupted by any floating objects.
        /// </summary>
        NextFullLine, // all

        /// <summary>
        /// Specifies that the line break shall advance the text to the next line in the document which is not interrupted by any floating objects on the left.
        /// </summary>
        NextTextRegionUnblockedOnLeft, // left

        /// <summary>
        /// Specifies that the line break shall advance the text to the next line in the document which is not interrupted by any floating objects on the right.
        /// </summary>
        NextTextRegionUnblockedOnRight // right
    }
}