﻿namespace System.Collections.Generic
{
    /// <summary>
    /// Extension methods for generic collections.
    /// </summary>
    public static class ExtensionMethods
    {
        /// <summary>
        /// Gets the value or null.
        /// </summary>
        /// <typeparam name="TKey">The type of the T key.</typeparam>
        /// <typeparam name="TValue">The type of the T value.</typeparam>
        /// <param name="dictionary">The dictionary.</param>
        /// <param name="key">The key.</param>
        /// <returns></returns>
        public static TValue GetValueOrNull<TKey, TValue>(this IDictionary<TKey, TValue> dictionary, TKey key) where TValue : class
        {
            TValue value = null;
            if (dictionary.TryGetValue(key, out value))
            {
                return value;
            }

            return null;
        }
    }
}
