﻿using System.Collections.Generic;
using System.Text.RegularExpressions;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Flow.TextSearch
{
    internal static class FindReplaceManager
    {
        public static IEnumerable<RunTextMatch> Find(Regex regex, RadFlowDocument document)
        {
            Guard.ThrowExceptionIfNull(document, "document");

            FindTextService findService = new FindTextService(document);

            return findService.Find(regex);
        }

        public static void Replace(IEnumerable<RunTextMatch> matches, Regex regex, string replaceText, ReplaceHandlerBase replaceHandler)
        {
            ReplaceTextService replaceService = new ReplaceTextService(replaceHandler);
            replaceService.Replace(matches, regex, replaceText);
        }
    }
}