﻿using Telerik.Windows.Documents.Flow.Model;

namespace Telerik.Windows.Documents.Flow.TextSearch
{
    internal sealed class MergedRunInfo
    {
        private const int NonInitializedIndex = -1;

        public MergedRunInfo()
        {
            this.ParagraphInsertIndex = NonInitializedIndex;
        }

        public Run Run
        {
            get;
            set;
        }

        public int ParagraphInsertIndex
        {
            get;
            set;
        }

        public string Text
        {
            get;
            set;
        }

        public bool IsInsertIndexInitialized
        {
            get
            {
                return this.ParagraphInsertIndex != NonInitializedIndex;
            }
        }

        public bool CanInsertMergedRun
        {
            get
            {
                return this.Run != null;
            }
        }

        public void AppendText(string text)
        {
            this.Text = string.Concat(this.Text, text);
        }
    }
}