﻿using System.Text;
#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.FormatProviders.Rtf;
using Telerik.Windows.Documents.Flow.Model;

#if !WPF && !SILVERLIGHT
using Telerik.Documents.Common.Model;
#else
using Telerik.Windows.Documents.Spreadsheet.Model;
#endif

namespace Telerik.Windows.Documents.Flow.Tests.Integration.Export.Rtf
{
    [TestClass]
    public class DocumentHeaderTests
    {
        [TestMethod]
        public void ColorTable_WhenRunHasTransparentForegroundAndTransparentHighlightColor_DoesntContainTheirValuesAsOmittedColors_Export_Rtf()
        {
            // Arrange
            RadFlowDocument document = new RadFlowDocument();
            Section s = document.Sections.AddSection();
            Paragraph p = new Paragraph(document);
            Run r = new Run(document);
            r.Text = "test";
            r.HighlightColor = Colors.Transparent;
            r.ForegroundColor = new ThemableColor(Colors.Transparent);
            p.Inlines.Add(r);
            s.Blocks.Add(p);

            // Act
            string rtf = new RtfFormatProvider().Export(document);

            // Assert
            string colorTable = ExtractGroup(rtf, "colortbl");
            Assert.AreEqual("colortbl\\red0\\green0\\blue0 ;", colorTable);
        }

        private static string ExtractGroup(string rtf, string groupName)
        {
            int startIndex = rtf.IndexOf(groupName);
            StringBuilder builder = new StringBuilder();

            char currentChar = rtf[startIndex];
            while (currentChar != '}' && startIndex < rtf.Length - 1)
            {
                builder.Append(currentChar);
                startIndex++;
                currentChar = rtf[startIndex];
            }

            return builder.ToString();
        }
    }
}