﻿#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.FormatProviders.Rtf;
using Telerik.Windows.Documents.Flow.Model;
#if !WPF && !SILVERLIGHT
using Telerik.Documents.Common.Model;
#else
using Telerik.Windows.Documents.Spreadsheet.Model;
#endif

namespace Telerik.Windows.Documents.Flow.Tests.Integration.Export.Rtf
{
    [TestClass]
    public class RunPropertiesTests
    {
        [TestMethod]
        public void HighlightColor_WhenIsTransparent_HighlightTagIsNotExported_Export_Rtf()
        {
            // Arrange
            RadFlowDocument original = new RadFlowDocument();
            Run run = original.Sections.AddSection().Blocks.AddParagraph().Inlines.AddRun();
            run.Text = "HighlightColor";
            run.HighlightColor = Colors.Transparent;

            // Act
            string rtf = new RtfFormatProvider().Export(original);
            string highlightTag = @"\highlight";
            string runBackgroundColorTag = @"\cb";

            // Assert.
            Assert.IsFalse(rtf.Contains(highlightTag));
            Assert.IsFalse(rtf.Contains(runBackgroundColorTag));
        }

        [TestMethod]
        public void ForegroundColor_WhenIsTransparent_ForegroundTagIsNotExported_Export_Rtf()
        {
            // Arrange
            RadFlowDocument original = new RadFlowDocument();
            Run run = original.Sections.AddSection().Blocks.AddParagraph().Inlines.AddRun();
            run.Text = "ForegroundColor";
            run.ForegroundColor = new ThemableColor(Colors.Transparent);

            // Act
            string rtf = new RtfFormatProvider().Export(original);
            string tagColorForeground = "cf";

            // Assert.
            Assert.IsFalse(rtf.Contains(tagColorForeground));
        }
    }
}