﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.HtmlImportExport
{
    [TestClass]
    public class BodyTagTests : HtmlTestBase
    {
        protected override string FolderName
        {
            get
            {
                return "Html";
            }
        }

        [TestMethod]
        public void Test_BodyWithText_Import()
        {
            // Arrange
            RadFlowDocument expected = this.GetExpectedDocumentForImport(addNormalWebStyle: false);
            Paragraph paragraph = expected.Sections.AddSection().Blocks.AddParagraph();
            paragraph.Inlines.AddRun("text");

            // Act
            RadFlowDocument imported = this.ImportHtmlFromString("<html><body>text</body></html>");

            //Assert
            this.AssertDocuments(expected, imported);
        }
    }
}
