﻿using System.Linq;
#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Lists;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.HtmlImportExport.Lists
{
    [TestClass]
    public class CharacterPropertiesTests : ListTestsBase
    {
        [TestMethod]
        public void ListLevel_WhenHasCharacterProperties_PropertiesAreImportedAsParagraphMarkerProperties()
        {
            // Arrange
            string html = "<html>" +
"<body><ol style=\"list-style-type: decimal;\"><li style=\"font-size: 30px;color: #FF0000;\" value=\"1\"><span>item 1</span></li>" +
"<li value=\"2\"><span>item 2</span></li>" +
"</ol></body></html>";

            // Act
            RadFlowDocument imported = this.ImportHtmlFromString(html);

            // Assert
            Paragraph paragraph = imported.EnumerateChildrenOfType<Paragraph>().FirstOrDefault();
            Assert.AreEqual(30, paragraph.Properties.ParagraphMarkerProperties.FontSize.LocalValue);
            Assert.AreEqual(Colors.Red, paragraph.Properties.ParagraphMarkerProperties.ForegroundColor.LocalValue.LocalValue);

            ListLevel listLevel = imported.Lists.GetList(paragraph.ListId).Levels[paragraph.ListLevel];
            Assert.IsFalse(listLevel.CharacterProperties.FontSize.HasLocalValue);
            Assert.IsFalse(listLevel.CharacterProperties.ForegroundColor.HasLocalValue);
        }
    }
}