﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.HtmlImportExport.Paragraphs
{
    [TestClass]
    public class DivTests : ParagraphTestsBase
    {
        [TestMethod]
        public void Test_DivWithTextBefore_Import()
        {
            // Arrange
            RadFlowDocument expected = this.GetExpectedDocumentForImport(false);
            Section section = expected.Sections.AddSection();
            section.Blocks.AddParagraph().Inlines.AddRun("text1");
            section.Blocks.AddParagraph().Inlines.AddRun("text2");

            // Act
            RadFlowDocument imported = this.ImportHtmlFromString(
@"<html>
    <body>
        text1
        <div>
            <span>text2</span>
        </div>
    </body>
</html>");

            //Assert
            this.AssertDocuments(expected, imported);
        }
    }
}
