﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Flow.FormatProviders.Html;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Editing;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.HtmlImportExport.Paragraphs
{
    [TestClass]
    public class FieldsTests : HtmlTestBase
    {
        protected override string FolderName
        {
            get { throw new NotImplementedException(); }
        }

        [TestMethod]
        public void Test_AuthorField_ImportExport()
        {
            // Arrange
            RadFlowDocumentEditor editor = new RadFlowDocumentEditor(new RadFlowDocument());

            editor.InsertText("Before ");
            editor.InsertField(" AUTHOR   \\* MERGEFORMAT ", "Alexander Vakrilov");
            editor.InsertText(" after");

            //Act
            RadFlowDocument actual = this.ExportImportDocument(editor.Document, new HtmlFormatProvider());

            editor = new RadFlowDocumentEditor(new RadFlowDocument());
            editor.InsertText("Before ");
            editor.InsertText("Alexander Vakrilov");
            editor.InsertText(" after");

            //Assert
            StructureAsserter.AssertDocumentsAreEqual(editor.Document, actual);
        }
    }
}
