﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.FormatProviders.Html;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Editing;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.HtmlImportExport.Paragraphs
{
    [TestClass]
    public class LineBreakTests : ParagraphTestsBase
    {
        [TestMethod]
        public void Test_LineBreak_ExportImport()
        {
            // Arrange
            RadFlowDocument expected = this.GetExpectedDocumentForExportImport(false);
            RadFlowDocumentEditor editor = new RadFlowDocumentEditor(expected);
            editor.InsertText("line1");
            editor.InsertBreak(BreakType.LineBreak);
            editor.InsertBreak(BreakType.LineBreak);
            editor.InsertBreak(BreakType.LineBreak);
            editor.InsertText("line5");

            // Act
            RadFlowDocument actual = this.ExportImportDocument(expected, new HtmlFormatProvider());

            //Assert
            this.AssertDocuments(expected, actual, true);
        }
    }
}
