﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections.Generic;
using System.Linq;
#if NETSTANDARD
using Telerik.Documents.Media;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Flow.FormatProviders.Html;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.HtmlImportExport.Styles.CharacterProperties
{
    [TestClass]
    public class HighlightColorTests : StyleTestsBase
    {
        [TestMethod]
        public void Highlight_Color_ExportImport_AsBackgroundColor()
        {
            // Arrange
            RadFlowDocument expected = this.GetExpectedDocumentForExportImport();
            Paragraph p = expected.Sections.AddSection().Blocks.AddParagraph();
            p.StyleId = BuiltInStyleNames.NormalWebStyleId;

            Run run = p.Inlines.AddRun("test");
            run.HighlightColor = Colors.Red;

            // Act
            RadFlowDocument imported = this.ExportImportDocument(expected, new HtmlFormatProvider());

            //Assert
            StructureAsserter.AssertDocumentsAreEqual(expected, imported);
            StylePropertyAsserter.AssertStylesAreEqual(expected, imported, true);


            List<Run> originalElements = expected.EnumerateChildrenOfType<Run>().ToList();
            List<Run> exportedElements = imported.EnumerateChildrenOfType<Run>().ToList();

            for (int i = 0; i < originalElements.Count; i++)
            {
                Assert.IsTrue(exportedElements[i].Shading.BackgroundColor.LocalValue == originalElements[i].HighlightColor);
            }
        }
    }
}
