﻿#if NETSTANDARD
using Telerik.Documents.Core.Fonts;
#else
using System.Windows.Media;
#endif
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;
#if WPF || SILVERLIGHT
using Telerik.Windows.Documents.Spreadsheet.Model;
#else
using Telerik.Documents.Common.Model;
#endif
using Telerik.Windows.Documents.Flow.Model.Styles;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.HtmlImportExport.Styles
{
    [TestClass]
    public class DefaultStylePropertiesValuesTests : StyleTestsBase
    {
        [TestMethod]
        public void DefaultStyleProperties_ForParagraphAndRun_AreImporterd()
        {
            // Arrange
            // Act
            RadFlowDocument actual = this.ImportHtmlFromString("<html><body><p><span>test</span><p></body></html>");

            //Assert
            RadFlowDocument expected = new RadFlowDocument();
            HtmlTestBase.ModifyBuiltInStyles(expected);

            StylePropertyAsserter.AssertPropertiesAreEqual(expected.DefaultStyle.CharacterProperties, actual.DefaultStyle.CharacterProperties);
            StylePropertyAsserter.AssertPropertiesAreEqual(expected.DefaultStyle.ParagraphProperties, actual.DefaultStyle.ParagraphProperties);
        }

        [TestMethod]
        public void DefaultStyleProperties_WhenAreChanged_ForParagraphAndRun_ExportImport()
        {
            // Arrange 
            RadFlowDocument actual = new RadFlowDocument();
            actual.DefaultStyle.CharacterProperties.FontSize.LocalValue = 36;
            actual.DefaultStyle.CharacterProperties.FontFamily.LocalValue = new ThemableFontFamily(new FontFamily("Arial"));
            actual.DefaultStyle.ParagraphProperties.LineSpacing.LocalValue = 10;
            actual.DefaultStyle.ParagraphProperties.LineSpacingType.LocalValue = HeightType.Exact;

            // Act
            RadFlowDocument expected = this.ExportImportDocument(actual);

            //Assert
            StylePropertyAsserter.AssertStylesAreEqual(expected.StyleRepository.GetStyle(BuiltInStyleNames.NormalStyleId),
                                                       actual.StyleRepository.GetStyle(BuiltInStyleNames.NormalStyleId),
                                                       true);
        }
    }
}