﻿using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Styles;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.HtmlImportExport.Styles
{
    public class StyleTestsBase : HtmlTestBase
    {
        protected override string FolderName
        {
            get
            {
                return "Styles";
            }
        }

        protected static RadFlowDocument CreateDocument()
        {
            RadFlowDocument expected = new RadFlowDocument();
            HtmlTestBase.ModifyBuiltInStyles(expected);

            return expected;
        }

        protected static Style CreateWebBasedParagraphStyle(string name)
        {
            Style style = new Style(name, StyleType.Paragraph);
            style.BasedOnStyleId = BuiltInStyleNames.NormalStyleId;
            style.ParagraphProperties.AutomaticSpacingAfter.LocalValue = true;
            style.ParagraphProperties.AutomaticSpacingBefore.LocalValue = true;
            style.ParagraphProperties.SpacingAfter.LocalValue = 6.66;
            style.ParagraphProperties.SpacingBefore.LocalValue = 6.66;

            return style;
        }
    }
}
