﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Flow.Model;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.HtmlImportExport
{
    [TestClass]
    public class TestEscape : HtmlTestBase
    {
        protected override string FolderName
        {
            get { throw new NotImplementedException(); }
        }

        [TestMethod]
        public void Test_EscapeCodes_Import()
        {
            // Arrange
            RadFlowDocument expected = new RadFlowDocument();
            expected.Sections.AddSection().Blocks.AddParagraph().Inlines.AddRun("™ &");

            // Act
            RadFlowDocument imported = this.ImportHtmlFromString("<html><body><span>&#8482; &#38</span></body></html>");

            //Assert
            this.AssertDocumentsStructureOnly(expected, imported);
        }

        [TestMethod]
        public void Test_EscapeNames_Import()
        {
            // Arrange
            RadFlowDocument expected = new RadFlowDocument();
            expected.Sections.AddSection().Blocks.AddParagraph().Inlines.AddRun("€ &");

            // Act
            RadFlowDocument imported = this.ImportHtmlFromString("<html><body><span>&euro; &amp;</span></body></html>");

            //Assert
            this.AssertDocumentsStructureOnly(expected, imported);
        }
    }
}
