﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Common.FormatProviders;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.CharacterProperties
{
    [TestClass]
    public class CharacterPropertiesTestsBase : PropertiesTestsBase
    {
        public const string TestFilesFolder = "CharacterProperties/";

        protected void CharacterPropertiesExportImportTemplate(
          RadFlowDocument original,
          IFormatProvider<RadFlowDocument> provider)
        {
            //Act
            RadFlowDocument testDocument = this.ExportImportDocument(original, provider);

            //Assert
            this.AssertCharcterProperties(original, testDocument);
        }

        protected void AssertCharcterProperties(RadFlowDocument original, RadFlowDocument exported)
        {
            StylePropertyAsserter.AssertPropertiesAreEqualForAllElementsOfType<Run>(original, exported);
        }
    }
}
