﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Common.FormatProviders;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.DocumentProperties
{
    [TestClass]
    public class DocumentPropertiesTestBase : PropertiesTestsBase
    {
        protected const string TestFilesFolder = "DocumentProperties/";

        protected void DocumentPropertiesExportImportTemplate(
            RadFlowDocument original,
            IFormatProvider<RadFlowDocument> provider)
        {
            //Act
            RadFlowDocument testDocument = this.ExportImportDocument(original, provider);

            //Assert
            this.AssertDocumentProperties(original, testDocument);
        }

        protected void AssertDocumentProperties(RadFlowDocument original, RadFlowDocument exported)
        {
            StructureAsserter.AssertDocumentsAreEqual(original, exported);
            StylePropertyAsserter.AssertPropertiesAreEqual(original, exported);
        }
    }
}
