﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Flow.FormatProviders.Rtf;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Styles;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.DocumentProperties
{
    [TestClass]
    public class ViewTypeTests : DocumentPropertiesTestBase
    {
        [TestMethod]
        public void ViewType_ExportImport_Rtf()
        {
            foreach (DocumentViewType viewType in Enum.GetValues(typeof(DocumentViewType)))
            {
                // Arrange
                RadFlowDocument document = CreateDocumentWithViewType(viewType);

                // Act and Assert
                this.DocumentPropertiesExportImportTemplate(document, new RtfFormatProvider());
            }
        }

        private static RadFlowDocument CreateDocumentWithViewType(DocumentViewType type)
        {
            RadFlowDocument expected = new RadFlowDocument();
            expected.ViewType = type;

            Section section = expected.Sections.AddSection();
            section.Blocks.AddParagraph();

            return expected;
        }
    }
}
