﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx;
using Telerik.Windows.Documents.Flow.FormatProviders.Rtf;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.Fields
{
    [TestClass]
    public class TocTests : TestsBase
    {
        public const string TestFilesFolder = "Fields/Toc/";

        [TestMethod]
        public void TestToc_WithHyperlinkElement_ImportExport_Docx()
        {
            // The document contains TOC field with hyperlink element as child. The hyperlink element contains more then one runs.
            // Such content can't be reproduced with our api as we insert the hyperlink as field. Nevertheless we should be able to import and export it whitout problems.

            // Act and Assert
            DocxFormatProvider formatProvider = new DocxFormatProvider();
            RadFlowDocument importedDocument = TestHelper.GetDocumentFromFile(string.Format("{0}TocWithHyperlinkElement.docx", TestFilesFolder), formatProvider);

            formatProvider.Export(importedDocument);
        }

        [TestMethod]
        public void TestToc_WithHyperlinkElement_ImportExport_Rtf()
        {
            // The document contains TOC field with hyperlink element as child. The hyperlink element contains more then one runs.
            // Such content can't be reproduced with our api as we insert the hyperlink as field. Nevertheless we should be able to import and export it whitout problems.

            // Act and Assert
            RtfFormatProvider formatProvider = new RtfFormatProvider();
            RadFlowDocument importedDocument = TestHelper.GetDocumentFromFile(string.Format("{0}TocWithHyperlinkElement.rtf", TestFilesFolder), formatProvider);

            formatProvider.Export(importedDocument);
        }
    }
}
