﻿#if NETSTANDARD
using Telerik.Documents.Primitives;
#else
using System.Windows;
#endif
using Telerik.Windows.Documents.Common.FormatProviders;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.Images
{
    public class ImagesTestsBase : TestsBase
    {
        public const string TestFilesFolder = "Images/";

        // Note: The constant in ShapeBase is internal and it is not visible for this project. 
        // Change this value in order of chaning the ShapeBase.DefaultSize value.
        protected static readonly Size ShapeBaseDefaultSize = new Size(1, 1);

        protected void ExportImportTemplate(RadFlowDocument originalDoc, IFormatProvider<RadFlowDocument> provider)
        {
            // Act
            RadFlowDocument testDocument = this.ExportImportDocument(originalDoc, provider);

            // Assert
            StructureAsserter.AssertDocumentsAreEqual(originalDoc, testDocument);

            // Assert Visual 
            this.AssertDocumentVisual(testDocument);
        }
    }
}