﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.Fixed.Tests.Integration;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx;
using Telerik.Windows.Documents.Flow.FormatProviders.Html;
using Telerik.Windows.Documents.Flow.FormatProviders.Pdf;
using Telerik.Windows.Documents.Flow.FormatProviders.Rtf;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utils;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport
{
    public class ImportExportBase : DocumentFlowVisualBaseTest
    {
        public static RadFlowDocument ImportDocx(string file)
        {
            RadFlowDocument document = new RadFlowDocument();
            DocxFormatProvider provider = new DocxFormatProvider();

            using (Stream stream = File.Open(file, FileMode.Open))
            {
                document = provider.Import(stream);
            }

            return document;
        }

        public static RadFlowDocument ImportRtf(string file)
        {
            RadFlowDocument document = new RadFlowDocument();
            RtfFormatProvider provider = new RtfFormatProvider();

            using (Stream stream = File.Open(file, FileMode.Open))
            {
                document = provider.Import(stream);
            }

            return document;
        }

        public static RadFlowDocument ImportPdf(string file)
        {
            RadFlowDocument document = new RadFlowDocument();
            PdfFormatProvider provider = new PdfFormatProvider();

            using (Stream stream = File.Open(file, FileMode.Open))
            {
                document = provider.Import(stream);
            }

            return document;
        }

        public static RadFlowDocument ImportHtml(string file)
        {
            RadFlowDocument document = new RadFlowDocument();
            HtmlFormatProvider provider = new HtmlFormatProvider();

            using (Stream stream = File.Open(file, FileMode.Open))
            {
                document = provider.Import(stream);
            }

            return document;
        }
    }
}
