﻿using System.IO;
using Telerik.Windows.Documents.Common.FormatProviders;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Lists;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.Lists
{
#if !VISUAL
    public class ListsTestBase
#else
    public abstract class ListsTestBase : IntegrationTestClassBase
#endif
    {
        public const string TestFilesFolder = "Lists/";

        protected RadFlowDocument StyleExportImportTemplate(
          RadFlowDocument original,
          IFormatProvider<RadFlowDocument> provider)
        {
            // Act
            RadFlowDocument exported = null;
            using (Stream stream = new MemoryStream())
            {
                provider.Export(original, stream);
                stream.Seek(0, SeekOrigin.Begin);

                string rtfString = new StreamReader(stream).ReadToEnd();
                stream.Seek(0, SeekOrigin.Begin);

                exported = provider.Import(stream);
            }

            return exported;
        }

        protected void AssertListProperties(List expected, List actual)
        {
            StylePropertyAsserter.AssertListsAreEqual(expected, actual);
        }
    }
}
