﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx;
using Telerik.Windows.Documents.Flow.FormatProviders.Rtf;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Styles;

#if VISUAL
using Telerik.Windows.Documents.Flow.Tests.Utilities;
#else
using Telerik.Windows.Documents.Flow.Tests.Utilities.XmlValidation;
#endif

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.ParagraphProperties
{
    [TestClass]
    public class OutlineLevelTests : ParagraphPropertiesTestsBase
    {
        //protected const string TestFilesFolder = "ParagraphProperties/";
        // TODO: [TestMethod]
        public void OutlineLevel_ExportImport_Rtf()
        {
            // Arrange
            RadFlowDocument doc = new RadFlowDocument();
            doc.Sections.AddSection().Blocks.AddParagraph().OutlineLevel = OutlineLevel.Level2;

            // Act and Assert
            this.ParagraphPropertiesExportImportTemplate(doc, new RtfFormatProvider());
        }

        [TestMethod]
        public void OutlineLevel_ExportImport_Docx()
        {
            // Arrange
            RadFlowDocument doc = new RadFlowDocument();
            doc.Sections.AddSection().Blocks.AddParagraph().OutlineLevel = OutlineLevel.Level2;

            // Act and Assert
            this.ParagraphPropertiesExportImportTemplate(doc, new DocxFormatProvider());
        }
#if !VISUAL
        [TestMethod]
        public void OutlineLevel_Validate_Xml()
        {
            RadFlowDocument doc = new RadFlowDocument();
            doc.Sections.AddSection().Blocks.AddParagraph().OutlineLevel = OutlineLevel.Level2;

            XmlValidator.ValidateOpenXmlDocument(doc);
        }
#endif

#if VISUAL
        [TestMethod]
        [TestCategory(WordsProcessingCategory.VisualTest)]
        [TestCategory(WordsProcessingCategory.ImportExportDocument)]

        public void OutlineLevel_Export_Pdf()
        {
            RadFlowDocument doc = TestHelper.GetDocumentFromFile(TestFilesFolder + "OutlineLevel.docx", new DocxFormatProvider());

            AssertVisual(doc);
        }
#endif
    }
}
