﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Common.FormatProviders;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.ParagraphProperties
{
    [TestClass]
    public class ParagraphPropertiesTestsBase : PropertiesTestsBase
    {
        public const string TestFilesFolder = "ParagraphProperties/";

        protected void ParagraphPropertiesExportImportTemplate(
            RadFlowDocument original,
            IFormatProvider<RadFlowDocument> provider)
        {
            //Act
            RadFlowDocument testDocument = this.ExportImportDocument(original, provider);

            //Assert
            this.AssertParagraphProperties(original, testDocument);
        }

        protected void AssertParagraphProperties(RadFlowDocument expected, RadFlowDocument actual)
        {
            StylePropertyAsserter.AssertPropertiesAreEqualForAllElementsOfType<Paragraph>(expected, actual);
        }

        protected void AssertRunProperties(RadFlowDocument expected, RadFlowDocument actual)
        {
            StylePropertyAsserter.AssertPropertiesAreEqualForAllElementsOfType<Run>(expected, actual);
        }
    }
}
