﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx;
using Telerik.Windows.Documents.Flow.FormatProviders.Rtf;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities.XmlValidation;
using Telerik.Windows.Documents.Model;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.SectionProperties
{
    [TestClass]
    public class PageOrientationTests : SectionPropertiesTestBase
    {
        [TestMethod]
        public void PageOrientation_ExportImport_Rtf()
        {
            // Arrange
            Section section = this.CreateDocumentWithSection();
            section.PageOrientation = PageOrientation.Landscape;

            // Act and Assert
            this.SectionPropertiesExportImportTemplate(section.Document, new RtfFormatProvider());
        }

        [TestMethod]
        public void PageOrientation_ExportImport_Docx()
        {
            // Arrange
            Section section = this.CreateDocumentWithSection();
            section.PageOrientation = PageOrientation.Landscape;

            // Act and Assert
            this.SectionPropertiesExportImportTemplate(section.Document, new DocxFormatProvider());
        }

        [TestMethod]
        public void PageOrientation_Validate_Xml()
        {
            Section section = this.CreateDocumentWithSection();
            section.PageOrientation = PageOrientation.Landscape;

            RadFlowDocument document = section.Document;
            XmlValidator.ValidateOpenXmlDocument(document);
        }
    }
}
