﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Common.FormatProviders;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.SectionProperties
{
    [TestClass]
    public class SectionPropertiesTestBase : PropertiesTestsBase
    {
        protected const string TestFilesFolder = "SectionProperties/";

        protected void SectionPropertiesExportImportTemplate(
            RadFlowDocument original,
            IFormatProvider<RadFlowDocument> provider)
        {
            //Act
            RadFlowDocument testDocument = this.ExportImportDocument(original, provider);

            //Assert
            this.AssertSectionProperties(original, testDocument);
        }

        protected void AssertSectionProperties(RadFlowDocument expected, RadFlowDocument actual)
        {
            StylePropertyAsserter.AssertPropertiesAreEqualForAllElementsOfType<Section>(expected, actual);
        }

        protected Section CreateDocumentWithSection()
        {
            RadFlowDocument doc = new RadFlowDocument();
            Section section = doc.Sections.AddSection();

            section.Blocks.AddParagraph();

            return section;
        }
    }
}
