﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.Sections
{
    [TestClass]
    public class NoSectionDocumentWithParagraphTests
    {
        private const string TestFilesWithoutExtension = "Sections/NoSectionDocumentWithParagraph";

        [TestMethod]
        public void NoSectionEmptyDocument_Import_Docx()
        {
            RadFlowDocument expected = CreateDocumentWithOneParagraph();
            RadFlowDocument imported = TestHelper.GetDocumentFromFile(TestFilesWithoutExtension + ".docx", new DocxFormatProvider());

            //Assert
            StructureAsserter.AssertDocumentsAreEqual(expected, imported);
        }

        [TestMethod]
        public void NoSectionEmptyDocument_ExportImport_Docx()
        {
            //this.NoSectionEmptyDocumentExportImportTemplate(new DocxFormatProvider());
        }

        //private void NoSectionEmptyDocumentExportImportTemplate(IFormatProvider<RadFlowDocument> provider)
        //{
        //    //Arrange
        //    RadFlowDocument originalDoc = CreateEmptyDocument();

        //    //Act
        //    RadFlowDocument testDocument = null;
        //    using (Stream stream = new MemoryStream())
        //    {
        //        provider.Export(originalDoc, stream);
        //        stream.Seek(0, SeekOrigin.Begin);

        //        string debugStr = new StreamReader(stream).ReadToEnd();
        //        stream.Seek(0, SeekOrigin.Begin);

        //        testDocument = provider.Import(stream);
        //    }

        //    //Assert
        //    StructureAsserter.AssertDocumentsAreEqual(originalDoc, testDocument);
        //}

        private static RadFlowDocument CreateDocumentWithOneParagraph()
        {
            RadFlowDocument expected = new RadFlowDocument();
            expected
                .Sections.AddSection()
                .Blocks.AddParagraph()
                .Inlines.AddRun()
                .Text = "text";


            return expected;
        }
    }
}
