﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.Sections
{
    [TestClass]
    public class NoSectionEmptyDocumentTests
    {
        private const string TestFilesWithoutExtension = "Sections/NoSectionEmptyDocument";

        [TestMethod]
        public void NoSectionEmptyDocument_Import_Docx()
        {
            RadFlowDocument expected = CreateDocumentWithOneSection();
            RadFlowDocument imported = TestHelper.GetDocumentFromFile(TestFilesWithoutExtension + ".docx", new DocxFormatProvider());

            //Assert
            StructureAsserter.AssertDocumentsAreEqual(expected, imported);
        }

        private static RadFlowDocument CreateDocumentWithOneSection()
        {
            RadFlowDocument expected = new RadFlowDocument();
            expected.Sections.AddSection();

            return expected;
        }
    }
}
