﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.Styles
{
    [TestClass]
    public class MissingAttributesImportTests : StyleTestBase
    {
        [TestMethod]
        public void StyleId_WhenMissing_Import_Docx()
        {
            // Arrange
            RadFlowDocument expected = new RadFlowDocument();
            expected.Sections.AddSection().Blocks.AddParagraph().Inlines.AddRun("test");

            // Act
            RadFlowDocument imported = TestHelper.GetDocumentFromFile(string.Format("{0}MissingStyleIdAndTypeAttributes.docx", TestFilesFolder), new DocxFormatProvider());

            // Assert
            StructureAsserter.AssertDocumentsAreEqual(expected, imported);

            Style unknownStyle = imported.StyleRepository.GetStyle("UndefinedStyleId0");
            Assert.IsNotNull(unknownStyle);
            Assert.AreEqual(StyleType.Paragraph, unknownStyle.StyleType);
        }
    }
}