﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Common.FormatProviders;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.TableCellProperties
{
    [TestClass]
    public class TableCellPropertiesTestBase : PropertiesTestsBase
    {
        public const string TestFilesFolder = "TableCellProperties/";

        protected void TableCellPropertiesExportImportTemplate(
          RadFlowDocument original,
          IFormatProvider<RadFlowDocument> provider)
        {
            //Act
            RadFlowDocument testDocument = this.ExportImportDocument(original, provider);

            //Assert
            StylePropertyAsserter.AssertPropertiesAreEqualForAllElementsOfType<TableCell>(original, testDocument);
        }

        protected TableCell CreateDocumentWithCell(bool addParagraphBeforeTable = true)
        {
            RadFlowDocument doc = new RadFlowDocument();
            Section section = doc.Sections.AddSection();
            if (addParagraphBeforeTable)
            {
                section.Blocks.AddParagraph();
            }
            TableCell cell = section.Blocks.AddTable().Rows.AddTableRow().Cells.AddTableCell();
            section.Blocks.AddParagraph();
            return cell;
        }

        protected void AssertTableCellProperties(RadFlowDocument original, RadFlowDocument exported)
        {
            StylePropertyAsserter.AssertPropertiesAreEqualForAllElementsOfType<TableCell>(original, exported);
        }
    }
}

