﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Common.FormatProviders;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.TableProperties
{
    [TestClass]
    public class TablePropertiesTestsBase : PropertiesTestsBase
    {
        public const string TestFilesFolder = "TableProperties/";

        protected void TablePropertiesExportImportTemplate(
            RadFlowDocument original,
            IFormatProvider<RadFlowDocument> provider)
        {
            //Act
            RadFlowDocument testDocument = this.ExportImportDocument(original, provider);

            //Assert
            StylePropertyAsserter.AssertPropertiesAreEqualForAllElementsOfType<Table>(original, testDocument);
        }

        protected void AssertTableProperties(RadFlowDocument original, RadFlowDocument exported)
        {
            StylePropertyAsserter.AssertPropertiesAreEqualForAllElementsOfType<Table>(original, exported);
        }
    }
}
