﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Common.FormatProviders;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.TableRowProperties
{
    [TestClass]
    public class TableRowPropertiesTestsBase : PropertiesTestsBase
    {
        public const string TestFilesFolder = "TableRowProperties/";

        protected void TableRowPropertiesExportImportTemplate(
            RadFlowDocument original,
            IFormatProvider<RadFlowDocument> provider)
        {
            //Act
            RadFlowDocument testDocument = this.ExportImportDocument(original, provider);

            //Assert
            StylePropertyAsserter.AssertPropertiesAreEqualForAllElementsOfType<TableRow>(original, testDocument);
        }

        protected void AssertTableRowProperties(RadFlowDocument original, RadFlowDocument exported)
        {
            StylePropertyAsserter.AssertPropertiesAreEqualForAllElementsOfType<TableRow>(original, exported);
        }
    }
}
