﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx;
using Telerik.Windows.Documents.Flow.Tests.Utilities;
#if WPF || SILVERLIGHT
using Telerik.Windows.Documents.Spreadsheet.Theming;
#else
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Flow.Tests.Integration.ImportExport.Themes
{
    [TestClass]
    public class ThemesTests
    {
        [TestMethod]
        public void Themes_ExportImport_Docx()
        {
            RadFlowDocument expected = new RadFlowDocument();
            expected.Sections.AddSection().Blocks.AddParagraph().Inlines.AddRun("Run");
            expected.Theme = new DocumentTheme("TestTheme", PredefinedThemeSchemes.ColorSchemes[0], PredefinedThemeSchemes.FontSchemes[1]);

            DocxFormatProvider provider = new DocxFormatProvider();
            RadFlowDocument actual = provider.Import(provider.Export(expected));

            StructureAsserter.AssertThemesAreEqual(expected.Theme, actual.Theme);
        }
    }
}
