﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Utilities;

namespace Telerik.Windows.Documents.Flow.Tests.Model.Annotations
{
    [TestClass]
    public class BookmarkTests
    {
        [TestMethod]
        public void CreateBookmark_WithNullName_ThrowsException()
        {
            // Act & Assert
            TestHelper.AssertExceptionIsThrown<ArgumentException>(() =>
                new Bookmark(new RadFlowDocument(), null));
        }

        [TestMethod]
        public void CreateBookmark_WithEmptyName_ThrowsException()
        {
            // Act & Assert
            TestHelper.AssertExceptionIsThrown<ArgumentException>(() =>
                new Bookmark(new RadFlowDocument(), string.Empty));
        }

        [TestMethod]
        public void CreateBookmark_NameWithWhitespace_ThrowsException()
        {
            // Act & Assert
            TestHelper.AssertExceptionIsThrown<ArgumentException>(() =>
                new Bookmark(new RadFlowDocument(), " test"));

            TestHelper.AssertExceptionIsThrown<ArgumentException>(() =>
                new Bookmark(new RadFlowDocument(), "test "));

            TestHelper.AssertExceptionIsThrown<ArgumentException>(() =>
                new Bookmark(new RadFlowDocument(), "te st"));
        }
    }
}
