using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model.Fields;

namespace Telerik.Windows.Documents.Flow.Tests.Model.Fields
{
    [TestClass]
    public class CompareFieldTests : UpdateFieldTestsBase
    {
        [TestMethod]
        public void InsertField_WithCompareCode_CreatesCompareField()
        {
            this.AssertInsertFieldCreatesFieldOfType("COMPARE 2 = 2", typeof(CompareField));
        }

        [TestMethod]
        public void UpdateCompareField_WithSimpleNumericValues_UpdatesCorrectly()
        {
            FieldUpdateTestCaseCollection testCases = new FieldUpdateTestCaseCollection();

            testCases.Add("COMPARE 2 = 2", "1");
            testCases.Add("COMPARE 1 = 2", "0");
            testCases.Add("COMPARE 2 = 1", "0");

            testCases.Add("COMPARE 2 >= 2", "1");
            testCases.Add("COMPARE 1 >= 2", "0");
            testCases.Add("COMPARE 2 >= 1", "1");

            testCases.Add("COMPARE 2 <= 2", "1");
            testCases.Add("COMPARE 1 <= 2", "1");
            testCases.Add("COMPARE 2 <= 1", "0");

            testCases.Add("COMPARE 2 > 2", "0");
            testCases.Add("COMPARE 1 > 2", "0");
            testCases.Add("COMPARE 2 > 1", "1");

            testCases.Add("COMPARE 2 < 2", "0");
            testCases.Add("COMPARE 1 < 2", "1");
            testCases.Add("COMPARE 2 < 1", "0");

            testCases.Add("COMPARE 2 <> 2", "0");
            testCases.Add("COMPARE 1 <> 2", "1");
            testCases.Add("COMPARE 2 <> 1", "1");

            this.AssertTestCases(testCases);
        }

        // More Comparison test are implemented in the IfFieldTests.
    }
}