﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Flow.Model.Fields;

namespace Telerik.Windows.Documents.Flow.Tests.Model.Fields
{
    [TestClass]
    public class TimeFieldTests : UpdateFieldTestsBase
    {
        [TestMethod]
        public void InsertField_WithIfCode_CreatesIfField()
        {
            this.AssertInsertFieldCreatesFieldOfType("TIME", typeof(TimeField));
        }

        // Formatting tests are in the Internal tests where DateTime service can be accessed.
        [TestMethod]
        public void UpdateTimeField_NoFormattingString_UsesCurrentCulture()
        {
            string expected = DateTime.Now.ToShortTimeString();

            FieldUpdateTestCaseCollection testCases = new FieldUpdateTestCaseCollection();
            testCases.Add("TIME", expected);
            this.AssertTestCases(testCases);
        }
    }
}
