﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Flow.Model.Lists;

namespace Telerik.Windows.Documents.Flow.Tests.Model.Lists
{
    [TestClass]
    public class ListLevelCollectionTests
    {
        [TestMethod]
        public void IndexerSet_ListLevelFromOtherList_ThrowsInvalidOperationException()
        {
            // Arrange
            List list1 = new List();
            List list2 = new List();
            ListLevelCollection levels1 = list1.Levels;
            ListLevel levelFromAnotherList = list2.Levels[0];

            try
            {
                // Act
                levels1[0] = levelFromAnotherList;

                // Assert
                Assert.Fail("InvalidOperationException should be thrown.");
            }
            catch (InvalidOperationException)
            {
            }
        }

        [TestMethod]
        public void IndexerSet_ClonedListLevelFromOtherList_CanBeSet()
        {
            // Arrange
            List list1 = new List();
            List list2 = new List();
            ListLevelCollection levels1 = list1.Levels;
            ListLevel clonedLevelFromAnotherList = list2.Levels[0].Clone(list1);

            // Act
            levels1[0] = clonedLevelFromAnotherList;

            // Assert
            Assert.AreEqual(clonedLevelFromAnotherList, levels1[0]);
        }
    }
}
