﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
#if NETSTANDARD
using Telerik.Documents.Core.Fonts;
#else
using System.Windows.Media;
#endif
using Telerik.Windows.Documents.Flow.Model.Lists;
using Telerik.Windows.Documents.Flow.Model.Styles;
using Telerik.Windows.Documents.Flow.Tests.Utilities;
#if WPF || SILVERLIGHT
using Telerik.Windows.Documents.Spreadsheet.Model;
#else
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Flow.Tests.Model.Lists
{
    [TestClass]
    public class ListLevelTests
    {
        [TestMethod]
        public void Clone_WhenPropertiesAreSet_CloningHasSameProperties()
        {
            // Arrange
            List list = new List();
            ListLevel level = list.Levels[0];
            level.Alignment = Alignment.Center;
            level.CharacterProperties.FontFamily.LocalValue = new ThemableFontFamily(new FontFamily("Comic Sans MS"));
            level.IsLegal = true;
            level.NumberingStyle = NumberingStyle.ThaiLetters;
            level.NumberTextFormat = "__%1)__";
            level.ParagraphProperties.SpacingBefore.LocalValue = 7;
            level.RestartAfterLevel = 2;
            level.StartIndex = 3;
            level.StyleId = "test";

            // Act
            ListLevel clone = level.Clone(list);

            // Assert
            StylePropertyAsserter.AssertListLevelsAreEqual(level, clone);

            // Verify (partially) this is deep copy.
            Assert.AreNotSame(level, clone);
            Assert.AreNotSame(level.CharacterProperties, clone.CharacterProperties);
            Assert.AreNotSame(level.ParagraphProperties, clone.ParagraphProperties);
        }
    }
}
