﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model.Protection;

namespace Telerik.Windows.Documents.Flow.Tests.Model.Protection
{
    public abstract class ProtectionBaseTests
    {
        public void AssertDocumentIsProtected(ProtectionSettings protectionSettings, ProtectionMode protectionMode, string algorithmName)
        {
            // Assert
            Assert.IsTrue(protectionSettings.Enforced);

            Assert.IsTrue(protectionSettings.ProtectionMode == protectionMode);
            Assert.IsTrue(!string.IsNullOrEmpty(protectionSettings.Hash));
            Assert.IsTrue(!string.IsNullOrEmpty(protectionSettings.Salt));
            Assert.AreEqual(protectionSettings.AlgorithmName, algorithmName);
        }
    }
}
