﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Styles;

namespace Telerik.Windows.Documents.Flow.Tests.Model.Styles
{
    [TestClass]
    public class TestBuiltInStyles
    {
        [TestMethod]
        public void Register_Heading_Styles()
        {
            RadFlowDocument document = new RadFlowDocument();

            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(1)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(2)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(3)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(4)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(5)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(6)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(7)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(8)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(9)));

            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(1));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(2));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(3));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(4));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(5));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(6));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(7));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(8));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(9));

            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(1)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(2)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(3)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(4)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(5)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(6)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(7)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(8)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetHeadingStyleIdByIndex(9)));
        }

        [TestMethod]
        public void Register_Toc_Styles()
        {
            RadFlowDocument document = new RadFlowDocument();

            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(1)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(2)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(3)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(4)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(5)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(6)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(7)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(8)));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(9)));

            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetTocStyleIdByIndex(1));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetTocStyleIdByIndex(2));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetTocStyleIdByIndex(3));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetTocStyleIdByIndex(4));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetTocStyleIdByIndex(5));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetTocStyleIdByIndex(6));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetTocStyleIdByIndex(7));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetTocStyleIdByIndex(8));
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.GetTocStyleIdByIndex(9));

            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(1)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(2)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(3)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(4)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(5)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(6)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(7)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(8)));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.GetTocStyleIdByIndex(9)));
        }

        [TestMethod]
        public void Register_FootEnd_Notes_Styles()
        {
            RadFlowDocument document = new RadFlowDocument();

            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.FootnoteReferenceStyleId));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.FootnoteTextStyleId));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.EndnoteReferenceStyleId));
            Assert.IsNull(document.StyleRepository.GetStyle(BuiltInStyleNames.EndnoteTextStyleId));

            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.FootnoteReferenceStyleId);
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.FootnoteTextStyleId);
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.EndnoteReferenceStyleId);
            document.StyleRepository.AddBuiltInStyle(BuiltInStyleNames.EndnoteTextStyleId);

            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.FootnoteReferenceStyleId));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.FootnoteTextStyleId));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.EndnoteReferenceStyleId));
            Assert.IsNotNull(document.StyleRepository.GetStyle(BuiltInStyleNames.EndnoteTextStyleId));
        }
    }
}
