﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Linq;
using Telerik.Windows.Documents.Flow.Model;

namespace Telerik.Windows.Documents.Flow.Tests.Utilities
{
    internal static class DocumentAsserter
    {
        public static void AssertParagraphWithText(BlockBase block, string text)
        {
            Paragraph paragraph = block as Paragraph;
            Assert.IsNotNull(paragraph);

            Assert.AreEqual(1, paragraph.Inlines.Count());
            Run run = paragraph.Inlines.First() as Run;
            Assert.IsNotNull(run);

            Assert.AreEqual(text, run.Text);
        }

        public static void AssertEmptyParagraph(BlockBase block)
        {
            Paragraph paragraph = block as Paragraph;
            Assert.IsNotNull(paragraph);
            Assert.AreEqual(0, paragraph.Inlines.Count());
        }
    }
}
