﻿using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Media;
#if WPF || SILVERLIGHT
using Telerik.Windows.Documents.Spreadsheet.Model;
#else
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Flow.Tests.Utilities
{
    public static class DocumentHelper
    {
#if !VISUAL
        public static void CreateHeaderFooterWithText<T>(string text, HeadersFootersBase<T> headersFooters, Flow.Model.HeaderFooterType headerFooterType) where T : HeaderFooterBase
        {
#else
        public static void CreateHeaderFooterWithText<T>(string text, HeadersFootersBase<T> headersFooters, HeaderFooterType headerFooterType) where T : HeaderFooterBase
        {
#endif
            T headerFooter = headersFooters.Add(headerFooterType);

            headerFooter.Blocks.AddParagraph()
                  .Inlines.AddRun()
                  .Text = text;
        }

        /// <summary>
        /// Sets the default FontFamily and Fontsize marker properties for a paragraph. MS Word export those properties and they are imported as local ones.
        /// <para>This applies only for RTF format.</para>
        /// </summary>
        /// <param name="paragraph">The paragraph.</param>
        public static void SetRtfDefaultDocumentParagraphMarkerProperties(Paragraph paragraph)
        {
            paragraph.Properties.ParagraphMarkerProperties.FontSize.LocalValue = Unit.PointToDip(11);
            paragraph.Properties.ParagraphMarkerProperties.FontFamily.LocalValue = new ThemableFontFamily("Calibri");
        }
    }
}