﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Lists;

namespace Telerik.Windows.Documents.Flow.Tests.Utilities
{
    internal static class ListPropertyAsserter
    {
        public static void AssertListsAreEqual(RadFlowDocument original, RadFlowDocument exported)
        {
            List<List> originalStyles = original.Lists.OrderBy(s => s.Id).ToList();
            List<List> exportedStyles = exported.Lists.OrderBy(s => s.Id).ToList();

            Assert.AreEqual(originalStyles.Count, exportedStyles.Count);
            for (int i = 0; i < originalStyles.Count; i++)
            {
                ListPropertyAsserter.AssertListsAreEqual(originalStyles[i], exportedStyles[i]);
            }
        }

        public static void AssertListsAreEqual(List expected, List actual)
        {
            Assert.IsTrue(expected.MultilevelType == actual.MultilevelType);
            Assert.IsTrue(expected.StyleId == actual.StyleId);
            Assert.IsTrue(expected.Levels.Count == actual.Levels.Count);

            for (int i = 0; i < expected.Levels.Count; i++)
            {
                Assert.AreEqual(expected.Levels[i].Alignment, actual.Levels[i].Alignment);
                Assert.AreEqual(expected.Levels[i].IsLegal, actual.Levels[i].IsLegal);
                Assert.AreEqual(expected.Levels[i].NumberingStyle, actual.Levels[i].NumberingStyle);
                Assert.AreEqual(expected.Levels[i].NumberTextFormat, actual.Levels[i].NumberTextFormat);
                Assert.AreEqual(expected.Levels[i].RestartAfterLevel, actual.Levels[i].RestartAfterLevel);
                Assert.AreEqual(expected.Levels[i].StartIndex, actual.Levels[i].StartIndex);
                Assert.AreEqual(expected.Levels[i].StyleId, actual.Levels[i].StyleId);
                StylePropertyAsserter.AssertPropertiesAreEqual(expected.Levels[i].CharacterProperties, actual.Levels[i].CharacterProperties);
                StylePropertyAsserter.AssertPropertiesAreEqual(expected.Levels[i].ParagraphProperties, actual.Levels[i].ParagraphProperties);
            }
        }
    }
}
