﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.Fixed.Tests.Integration;
using Telerik.Windows.Documents.Flow.Tests.Flow.Utils;

namespace Telerik.Windows.Documents.Flow.Tests.Utils
{
    public static class ProcessKiller
    {
        public static void KillProcess(string fileExtenssion, string caption)
        {
            List<string> processesNames = new List<string>();

            switch (fileExtenssion)
            {
                case TestSettings.DOCXFILEEXTENSION: processesNames.Add(TestSettings.WORDPROCESS); processesNames.Add(TestSettings.WORDPAD); break;
                case TestSettings.RTFFILEEXTENSION: processesNames.Add(TestSettings.WORDPROCESS); processesNames.Add(TestSettings.WORDPAD); break;
                case TestSettings.PDFFILEEXTENSION: processesNames.Add(TestSettings.PDFPROCESS); processesNames.Add(TestSettings.PDF_ARM_PROCESS); break;
                case TestSettings.HTMLFILEEXTENSION: processesNames.Add(TestSettings.IEPROCESS); break;
                case TestSettings.XLSXFILEEXTENSION:
                case TestSettings.CSVFILEEXTENSION: processesNames.Add(TestSettings.EXCELPROCESS); break;
                default:
                    throw new ArgumentException("This process is unknown");
            }

            List<Process> processes = Process.GetProcesses().Where(x => processesNames.Contains(x.ProcessName)).ToList();

            if (!String.IsNullOrWhiteSpace(caption) && !processesNames.Contains(TestSettings.PDFPROCESS)
                && !processesNames.Contains(TestSettings.IEPROCESS) && !processesNames.Contains(TestSettings.EXCELPROCESS))
            {
                try
                {
                    UIInteractionHelper.ClickOnCloseBtn(caption);
                    System.Threading.Thread.Sleep(3000);
                }
                catch { }
            }

            processes = Process.GetProcesses().Where(x => processesNames.Contains(x.ProcessName)).ToList();
            if (processes.Count() > 0)
            {
                foreach (Process process in processes)
                {
                    try
                    {
                        process.Kill();
                    }
                    catch { }
                }
            }
        }
    }
}
