﻿using Microsoft.Expression.Encoder.ScreenCapture;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Telerik.Windows.Documents.Flow.Tests.Utils
{
    public class VideoRecorder : ScreenCaptureJob
    {
        private string videoPath;
        private string imageStoragePath;
        private string testName;

        public VideoRecorder()
        { }

        public void DisposeCapture(bool isTestPassed)
        {
            if (isTestPassed)
            {
                FileInfo file = new FileInfo(this.OutputScreenCaptureFileName);
                if (!Directory.Exists(this.imageStoragePath + @"Videos\"))
                {
                    Directory.CreateDirectory(this.imageStoragePath + @"Videos\");
                }

                file.CopyTo(this.imageStoragePath + @"Videos\" + testName + ".wmv", true);

                this.Stop();
                this.Dispose();

                file.Delete();
            }
            else
            {
                this.Stop();
                this.Dispose();
            }
        }

        public void StartRecordingVideo(string imageStoragePath, string resultsFolderPath, string testName)
        {
            this.testName = testName;
            this.imageStoragePath = imageStoragePath;
            this.CaptureMouseCursor = true;
            this.ShowFlashingBoundary = false;

            if (!Directory.Exists(resultsFolderPath))
            {
                Directory.CreateDirectory(resultsFolderPath);
            }

            DirectoryInfo videoFolder = new DirectoryInfo(resultsFolderPath);

            if (!videoFolder.Exists)
            {
                videoFolder.Create();
            }

            this.videoPath = videoFolder.FullName + @"\" + testName + ".wmv";

            if (File.Exists(this.videoPath))
            {
                File.Delete(this.videoPath);
            }

            this.OutputScreenCaptureFileName = this.videoPath;
            this.Start();
        }
    }
}
