﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Fixed.Tests.Integration;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Tests.Flow.Utils;
using Telerik.Windows.Documents.Flow.Tests.Utilities;
using Telerik.Windows.Documents.Flow.Tests.Utils;

namespace Telerik.Windows.Documents.Flow.Tests.VisualTests
{
    [TestClass]
    public class MailMergeTests : DocumentFlowVisualBaseTest
    {
        public static string TestFilesFolder = "VisualTestsDocuments/";

        [TestMethod]
         [TestCategory(WordsProcessingCategory.VisualTest)]
         [TestCategory(WordsProcessingCategory.MailMerge)]
        public void MailMergeDocumentWithDocumentVarialbesAndAppliedStyles()
        {
            RadFlowDocument document = new DocxFormatProvider().Import(VisualTestHelper.LoadVisualTestDocumentFromStream("DocumentVarialblesTest.docx"));
            RadFlowDocument mergedDoc = document.MailMerge(new List<MailMergeRecord>() { new MailMergeRecord(25) });

            this.AssertVisual(mergedDoc, new string[] { DOCXFILEEXTENSION });
        }
    }

    public class MailMergeRecord
    {
        public int QuoteNum { get; set; }

        public MailMergeRecord(int info)
        {
            this.QuoteNum = info;
        }
    }
}
