﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Collections;

namespace Telerik.Windows.Documents.Flow.InternalTests.Model.Collections
{
    [TestClass]
    public class BlockCollectionTests
    {
        [TestMethod]
        public void AddParagraph_AddsParagraphWithCorrectParentAndDocument()
        {
            RadFlowDocument expectedDocument = new RadFlowDocument();
            Section section = new Section(expectedDocument);

            BlockCollection blockCollection = new BlockCollection(section);

            Paragraph paragraph = blockCollection.AddParagraph();

            Assert.AreEqual(expectedDocument, paragraph.Document);
            Assert.AreEqual(section, paragraph.Parent);
        }

        [TestMethod]
        public void AddTable_AddsTableWithCorrectParentAndDocument()
        {
            RadFlowDocument expectedDocument = new RadFlowDocument();
            Section section = new Section(expectedDocument);

            BlockCollection blockCollection = new BlockCollection(section);

            Table table = blockCollection.AddTable();

            Assert.AreEqual(expectedDocument, table.Document);
            Assert.AreEqual(section, table.Parent);
        }
    }
}
