﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Collections;
using Telerik.Windows.Documents.Flow.Model.Shapes;

namespace Telerik.Windows.Documents.Flow.InternalTests.Model.Collections
{
    [TestClass]
    public class InlineCollectionTests
    {
        [TestMethod]
        public void AddRun_AddsRunWithCorrectParentAndDocument()
        {
            RadFlowDocument document = new RadFlowDocument();
            Paragraph parent = new Paragraph(document);

            InlineCollection inlineCollection = new InlineCollection(parent);

            Run addedRun = inlineCollection.AddRun();

            Assert.AreEqual(document, addedRun.Document);
            Assert.AreEqual(parent, addedRun.Parent);
        }

        [TestMethod]
        public void AddImageInline_AddsImageInlineWithCorrectParentAndDocument()
        {
            RadFlowDocument document = new RadFlowDocument();
            Paragraph parent = new Paragraph(document);

            InlineCollection inlineCollection = new InlineCollection(parent);

            ImageInline imageInline = inlineCollection.AddImageInline();

            Assert.AreEqual(document, imageInline.Document);
            Assert.AreEqual(parent, imageInline.Parent);
        }
    }
}
