﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model.Shapes;

namespace Telerik.Windows.Documents.Flow.InternalTests.Model.Shapes
{
    [TestClass]
    public class HorizontalPositionTests
    {
        [TestMethod]
        public void Clone_WhenInvoked_CreatesCloning()
        {
            // Arrange
            HorizontalPosition horizontalPosition = new HorizontalPosition();
            horizontalPosition.Alignment = RelativeHorizontalAlignment.Center;
            horizontalPosition.Offset = 15;
            horizontalPosition.RelativeFrom = HorizontalRelativeFrom.OutsideMargin;
            horizontalPosition.ValueType = PositionValueType.Alignment;

            // Act
            HorizontalPosition clonedHorizontalPosition = horizontalPosition.Clone();

            // Assert
            Assert.AreNotSame(horizontalPosition, clonedHorizontalPosition);
            Assert.AreEqual(RelativeHorizontalAlignment.Center, clonedHorizontalPosition.Alignment);
            Assert.AreEqual(15, clonedHorizontalPosition.Offset);
            Assert.AreEqual(HorizontalRelativeFrom.OutsideMargin, clonedHorizontalPosition.RelativeFrom);
            Assert.AreEqual(PositionValueType.Alignment, clonedHorizontalPosition.ValueType);
        }
    }
}
