﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model.Shapes;

namespace Telerik.Windows.Documents.Flow.InternalTests.Model.Shapes
{
    [TestClass]
    public class VerticalPositionTests
    {
        [TestMethod]
        public void Clone_WhenInvoked_CreatesCloning()
        {
            // Arrange
            VerticalPosition verticalPosition = new VerticalPosition();
            verticalPosition.Alignment = RelativeVerticalAlignment.Center;
            verticalPosition.Offset = 15;
            verticalPosition.RelativeFrom = VerticalRelativeFrom.OutsideMargin;
            verticalPosition.ValueType = PositionValueType.Alignment;

            // Act
            VerticalPosition clonedVerticalPosition = verticalPosition.Clone();

            // Assert
            Assert.AreNotSame(verticalPosition, clonedVerticalPosition);
            Assert.AreEqual(RelativeVerticalAlignment.Center, clonedVerticalPosition.Alignment);
            Assert.AreEqual(15, clonedVerticalPosition.Offset);
            Assert.AreEqual(VerticalRelativeFrom.OutsideMargin, clonedVerticalPosition.RelativeFrom);
            Assert.AreEqual(PositionValueType.Alignment, clonedVerticalPosition.ValueType);
        }
    }
}
