﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Linq;
using Telerik.Windows.Documents.Flow.Model.Styles.Core;

namespace Telerik.Windows.Documents.Flow.InternalTests.Model.Styles
{
    [TestClass]
    public class StylePropertyValidationTests
    {
        [TestMethod]
        public void AddRemoveClear()
        {
            StylePropertyValidation validation = new StylePropertyValidation();
            Assert.IsTrue(validation.Rules.Count() == 0);

            ValidationRule<double> rule = new ValidationRule<double>(value => value > 0);
            validation.AddRule(rule);
            Assert.IsTrue(validation.Rules.Count() == 1);

            validation.RemoveRule(rule);
            Assert.IsTrue(validation.Rules.Count() == 0);

            validation.AddRule(new ValidationRule<double>(value => value > 0));
            validation.ClearRules();
            Assert.IsTrue(validation.Rules.Count() == 0);
        }
    }
}
