﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.BorderEvaluation;
using Telerik.Windows.Documents.Flow.Model.Editing;

namespace Telerik.Windows.Documents.Flow.InternalTests.Model
{
    [TestClass]
    public class TableBordersCalculatorTests
    {
        [TestMethod]
        public void TestBordersCalculator_WithIncorrectTable_NotToCrash()
        {
            RadFlowDocument flowDocument = new RadFlowDocument();
            RadFlowDocumentEditor editor = new RadFlowDocumentEditor(flowDocument);

            Table table = editor.InsertTable();

            TableRow row = table.Rows.AddTableRow();

            row = table.Rows.AddTableRow();
            row = table.Rows.AddTableRow();
            row = table.Rows.AddTableRow();
            row = table.Rows.AddTableRow();

            TableCell cell = row.Cells.AddTableCell();
            Paragraph p = cell.Blocks.AddParagraph();
            Run r = p.Inlines.AddRun();
            r.Text = "0-0";

            table.InvalidateTableGrid();
            table.AssureTableGrid();

            TableBorderGrid borderGrid = new TableBorderGrid(table);
            borderGrid.AssureValid();
        }
    }
}
