﻿using System.IO;
using Telerik.Windows.Documents.Common.FormatProviders;
using Telerik.Windows.Documents.Flow.Model;
#if VISUAL
using Telerik.Windows.Documents.Fixed.Tests.Integration;
using Telerik.Windows.Documents.Flow.Tests.Utils;
#endif

namespace Telerik.Windows.Documents.Flow.FormatProviders.Pdf.Tests
{
#if !VISUAL
    public abstract class TestsBase
#else
    public abstract class TestsBase : DocumentFlowVisualBaseTest
#endif
    {
#if !VISUAL
        public const string VISUALTESTCATEGORY = "VisualTests";
#endif

        protected virtual RadFlowDocument ExportImportDocument(RadFlowDocument original, IFormatProvider<RadFlowDocument> provider)
        {
            //Act
            RadFlowDocument testDocument = null;
            using (Stream stream = new MemoryStream())
            {
                provider.Export(original, stream);
                stream.Seek(0, SeekOrigin.Begin);

                string stringContent = new StreamReader(stream).ReadToEnd();
                stream.Seek(0, SeekOrigin.Begin);

                testDocument = provider.Import(stream);
            }
            return testDocument;
        }

        protected virtual void AssertDocumentVisual(RadFlowDocument document)
        {
#if VISUAL
            this.AssertVisual(document, DOCXFILEEXTENSSION, new System.Drawing.Rectangle() { X = 400, Y = 200, Width = 400, Height = 400 });
            this.AssertVisual(document, RTFFILEEXTENSSION, new System.Drawing.Rectangle() { X = 400, Y = 200, Width = 400, Height = 400 });
            this.AssertVisual(document, PDFFILEEXTENSION, new System.Drawing.Rectangle() { X = 400, Y = 200, Width = 400, Height = 400 });
#endif
        }
    }
}