﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Flow.Model;
using Telerik.Windows.Documents.Flow.Model.Editing;
using Telerik.Windows.Documents.Utilities;
using Telerik.Windows.Documents.Flow.FormatProviders.Docx;

namespace Telerik.Windows.Documents.SlowRunningTests.DocumentsFlow
{
    [TestClass]
    public class TablePerformanceTests
    {
        [TestMethod]
        public void CreatingDocumentWithBigTable()
        {
            RadFlowDocument document = new RadFlowDocument();
            RadFlowDocumentEditor editor = new RadFlowDocumentEditor(document);

            SnippetPerformanceCounterRelease counter = new SnippetPerformanceCounterRelease("CreatingDocumentWithBigTable");

            counter.Start();
            editor.InsertTable(30000, 10);

            counter.Stop();

            int maxExpectedValue = 3500;

            Assert.IsTrue(counter.TotalMilliseconds < maxExpectedValue, string.Format("Expected value: {0}, Actual: {1}", maxExpectedValue, counter.TotalMilliseconds));
        }

        [TestMethod]
        public void CreatingDocumentWithBigTable_AndExportToDocx()
        {
            RadFlowDocument document = new RadFlowDocument();
            RadFlowDocumentEditor editor = new RadFlowDocumentEditor(document);

            SnippetPerformanceCounterRelease counter = new SnippetPerformanceCounterRelease("CreatingDocumentWithBigTable");

            counter.Start();
            editor.InsertTable(30000, 10);

            DocxFormatProvider provider = new DocxFormatProvider();
            provider.Export(editor.Document);

            counter.Stop();

            int maxExpectedValue = 17000;

            Assert.IsTrue(counter.TotalMilliseconds < maxExpectedValue, string.Format("Expected value: {0}, Actual: {1}", maxExpectedValue, counter.TotalMilliseconds));
        }
    }
}
