﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands
{
    /// <summary>
    /// The arguments for the CommandError event.
    /// </summary>
    public class CommandErrorEventArgs : CommandExecuteEventArgsBase
    {
		#region Properties
        /// <summary>
        /// Gets the exception.
        /// </summary>
        /// <value>The exception.</value>
        public Exception Exception { get; private set; }

        /// <summary>
        /// Gets or sets a value indicating whether the exception is handled.
        /// </summary>
        /// <value>The value indicating whether the exception is handled.</value>
        public bool Handled { get; set; }

		#endregion


		#region Constructors

        internal CommandErrorEventArgs(Exception exception, IWorkbookCommand command, WorkbookCommandContextBase commandContext, bool isInUndo = false)
            : base(command, commandContext, isInUndo)

		{
            Guard.ThrowExceptionIfNull(exception, "Exception");
			this.Exception = exception;
		}

		#endregion
	}
}