﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Commands
{
    /// <summary>
    /// Arguments for the CommandExecuting event.
    /// </summary>
    public class CommandExecutingEventArgs : CommandExecuteEventArgsBase
    {
		#region Properties

        /// <summary>
        /// Gets a value indicating whether the command is canceled.
        /// </summary>
        /// <value>The value indicating whether the command is canceled.</value>
        public bool Canceled { get; private set; }
		
		#endregion


		#region Constructors

		internal CommandExecutingEventArgs(IWorkbookCommand command, WorkbookCommandContextBase commandContext, bool isInUndo = false)
            : base(command, commandContext, isInUndo)
		{
		}

		#endregion


        #region Methods

        /// <summary>
        /// Cancels the command.
        /// </summary>
        public void Cancel()
        {
            this.Canceled = true;
        }

        #endregion
	}
}