﻿using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Commands
{
    internal abstract class SheetCommandContextBase : WorkbookCommandContextBase
    {
        #region Fields

        private readonly Sheet sheet;

        #endregion


        #region Properties

        public Sheet Sheet
        {
            get
            {
                return this.sheet;
            }
        }

        #endregion


        #region Constructors

        public SheetCommandContextBase(Sheet sheet)
            : base(sheet.Workbook)
        {
            this.sheet = sheet;
        }

        #endregion


        #region Methods

        internal override void InvalidateLayout()
        {
            this.Sheet.InvalidateLayout();
        }

        #endregion
    }
}