﻿using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorkbookCommands
{
    internal class AddRemoveStyleCommandContext : WorkbookCommandContextBase
    {
        #region Fields

        private readonly CellStyle cellStyle;

        #endregion


        #region Properties

        public CellStyle CellStyle
        {
            get
            {
                return this.cellStyle;
            }
        }

        #endregion


        #region Constructors

        public AddRemoveStyleCommandContext(Workbook workbook, CellStyle cellStyle)
            : base(workbook)
        {
            Guard.ThrowExceptionIfNull(cellStyle, "cellStyle");
            this.cellStyle = cellStyle;
        }

        #endregion
    }
}