﻿using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorkbookCommands
{
    internal class SetStylePropertyCommandContext : WorkbookCommandContextBase
    {
        #region Fields

        private readonly StylePropertyBase styleProperty;
        private readonly object oldValue;
        private readonly object newValue;

        #endregion


        #region Properties

        public StylePropertyBase StyleProperty
        {
            get
            {
                return this.styleProperty;
            }
        }

        public object OldValue
        {
            get
            {
                return this.oldValue;
            }
        }

        public object NewValue
        {
            get
            {
                return this.newValue;
            }
        }

        #endregion


        #region Constructors

        public SetStylePropertyCommandContext(Workbook workbook, StylePropertyBase styleProperty, object oldValue, object newValue)
            : base(workbook)
        {
            Guard.ThrowExceptionIfNull(styleProperty, "property");

            this.styleProperty = styleProperty;
            this.oldValue = oldValue;
            this.newValue = newValue;
        }

        #endregion
    }
}