﻿using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorkbookCommands
{
    internal class SetStylePropertyGroupIncludedCommand : UndoableWorkbookCommandBase<SetStylePropertyGroupIncludedCommandContext>
    {
        #region Methods

        protected override bool AffectsLayoutOverride(SetStylePropertyGroupIncludedCommandContext context)
        {
            return true;
        }

        protected override bool CanExecuteOverride(SetStylePropertyGroupIncludedCommandContext context)
        {
            return !TelerikHelper.EqualsOfT(context.OldValue, context.NewValue);
        }

        protected override void PreserveStateBeforeExecute(SetStylePropertyGroupIncludedCommandContext context)
        {
            // Nothing to preserve.
        }

        protected override void ExecuteOverride(SetStylePropertyGroupIncludedCommandContext context)
        {
            context.Style.SetIsStylePropertyGroupIncludedInternal(context.StylePropertyGroup, context.NewValue);
        }

        protected override void UndoOverride(SetStylePropertyGroupIncludedCommandContext context)
        {
            context.Style.SetIsStylePropertyGroupIncludedInternal(context.StylePropertyGroup, context.OldValue);
        }

        #endregion
    }
}