﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorkbookCommands
{
    internal class SetStylePropertyGroupIncludedCommandContext : WorkbookCommandContextBase
    {
        #region Fields

        private readonly CellStyle style;
        private readonly StylePropertyGroup stylePropertyGroup;
        private readonly bool oldValue;
        private readonly bool newValue;

        #endregion


        #region Properties

        public StylePropertyGroup StylePropertyGroup
        {
            get
            {
                return this.stylePropertyGroup;
            }
        }

        public CellStyle Style
        {
            get
            {
                return this.style;
            }
        }

        public bool OldValue
        {
            get
            {
                return this.oldValue;
            }
        }

        public bool NewValue
        {
            get
            {
                return this.newValue;
            }
        }

        #endregion


        #region Constructors

        public SetStylePropertyGroupIncludedCommandContext(Workbook workbook, CellStyle style, StylePropertyGroup stylePropertyGroup, bool oldValue, bool newValue)
            : base(workbook)
        {
            Guard.ThrowExceptionIfNull(style, "style");
            Guard.ThrowExceptionIfNull(stylePropertyGroup, "stylePropertyGroup");

            this.style = style;
            this.stylePropertyGroup = stylePropertyGroup;
            this.oldValue = oldValue;
            this.newValue = newValue;
        }
            
        #endregion
    }
}