﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class AddRemoveHyperlinkCommandContext : WorksheetCommandContextBase
    {
        #region Fields

        private readonly SpreadsheetHyperlink hyperlink;

        #endregion


        #region Properties

        public SpreadsheetHyperlink Hyperlink
        {
            get
            {
                return this.hyperlink;
            }
        }

        #endregion


        #region Constructors

        public AddRemoveHyperlinkCommandContext(Worksheet worksheet, SpreadsheetHyperlink hyperlink)
            : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(worksheet, "worksheet");
            Guard.ThrowExceptionIfNull(hyperlink, "hyperlink");

            this.hyperlink = hyperlink;
        }

        #endregion
    }
}