﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Printing;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class AddRemovePageBreakCommandContext : WorksheetCommandContextBase
    {
        private readonly PageBreak pageBreak;

        public PageBreak PageBreak
        {
            get
            {
                return this.pageBreak;
            }
        }

        public AddRemovePageBreakCommandContext(Worksheet worksheet, PageBreak pageBreak)
            : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(worksheet, "worksheet");
            Guard.ThrowExceptionIfNull(pageBreak, "pageBreak");

            this.pageBreak = pageBreak;
        }
    }
}
