﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class AddRemoveShapeCommandContext : WorksheetCommandContextBase
    {
        #region Fields

        private readonly FloatingShapeBase shape;

        #endregion


        #region Properties

        public FloatingShapeBase Shape
        {
            get
            {
                return this.shape;
            }
        }

        #endregion


        #region Constructors

        public AddRemoveShapeCommandContext(Worksheet worksheet, FloatingShapeBase shape) : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(worksheet, "worksheet");
            Guard.ThrowExceptionIfNull(shape, "shape");

            this.shape = shape;
        }

        #endregion
    }
}
