﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class AddRemoveSpreadsheetNameCommandContext : WorksheetCommandContextBase
    {
        #region Fields

        private readonly SpreadsheetNameCollectionScope owner;
        private readonly ISpreadsheetName name;

        #endregion


        #region Properties

        public ISpreadsheetName Name
        {
            get
            {
                return this.name;
            }
        }

        public SpreadsheetNameCollectionScope Owner
        {
            get
            {
                return this.owner;
            }
        }

        #endregion


        #region Constructors

        public AddRemoveSpreadsheetNameCommandContext(SpreadsheetNameCollectionScope owner, ISpreadsheetName name)
            : base(owner.CurrentWorksheet)
        {
            Guard.ThrowExceptionIfNull(owner, "owner");
            Guard.ThrowExceptionIfNull(name, "name");

            this.owner = owner;
            this.name = name;
        }

        #endregion
    }
}
