﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class AddSpreadsheetNameCommand : UndoableWorksheetCommandBase<AddRemoveSpreadsheetNameCommandContext>
    {
        protected override bool AffectsLayoutOverride(AddRemoveSpreadsheetNameCommandContext context)
        {
            return true;
        }

        protected override void ExecuteOverride(AddRemoveSpreadsheetNameCommandContext context)
        {
            if (context.Owner.IsGlobal)
            {
                context.Workbook.Names.AddInternal(context.Name);
            }
            else
            {
                context.Owner.CurrentWorksheet.Names.AddInternal(context.Name);
            }
        }

        protected override void PreserveStateBeforeExecute(AddRemoveSpreadsheetNameCommandContext context)
        {
            //Nothing to preserve
        }

        protected override void UndoOverride(AddRemoveSpreadsheetNameCommandContext context)
        {
            if (context.Owner.IsGlobal)
            {
                context.Workbook.Names.RemoveInternal(context.Name);
            }
            else
            {
                context.Owner.CurrentWorksheet.Names.RemoveInternal(context.Name);
            }
        }

    }
}
