﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class AddToPrintAreaCommand : UndoableWorksheetCommandBase<AddToRemoveFromPrintAreaCommandContext>
    {
        protected override void PreserveStateBeforeExecute(AddToRemoveFromPrintAreaCommandContext context)
        {
            // Nothing to preserve.
        }

        protected override void UndoOverride(AddToRemoveFromPrintAreaCommandContext context)
        {
            context.Worksheet.WorksheetPageSetup.PrintArea.RemoveRangesInternal(context.Index, context.Ranges.Count);
        }

        protected override bool AffectsLayoutOverride(AddToRemoveFromPrintAreaCommandContext context)
        {
            return true;
        }

        protected override void ExecuteOverride(AddToRemoveFromPrintAreaCommandContext context)
        {
            context.Worksheet.WorksheetPageSetup.PrintArea.InsertRangesInternal(context.Ranges, context.Index);
        }
    }
}
