﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class AddToRemoveFromPrintAreaCommandContext : WorksheetCommandContextBase
    {
        #region Fields

        private readonly List<CellRange> ranges;
        private readonly int index;

        #endregion


        #region Properties

        public List<CellRange> Ranges
        {
            get
            {
                return this.ranges;
            }
        }

        public int Index
        {
            get
            {
                return this.index;
            }
        }

        #endregion


        #region Constructor

        public AddToRemoveFromPrintAreaCommandContext(Worksheet worksheet, IEnumerable<CellRange> ranges, int index)
            : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(worksheet, "worksheet");
            Guard.ThrowExceptionIfNull(ranges, "printRange");

            this.ranges = new List<CellRange>(ranges);
            this.index = index;
        }

        #endregion
    }
}
