﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class BringShapeForwardCommand : UndoableWorkbookCommandBase<MoveShapeInDepthCommandContext>
    {
        protected override void PreserveStateBeforeExecute(MoveShapeInDepthCommandContext context)
        {
            foreach (FloatingShapeBase shape in context.Shapes)
            {
                int zIndex = context.Worksheet.Shapes.GetZIndex(shape);
                context.OldShapeIndices.Add(shape, zIndex);
            }
        }

        protected override void UndoOverride(MoveShapeInDepthCommandContext context)
        {
            context.Worksheet.Shapes.MoveShapesToIndices(context.OldShapeIndices);
        }

        protected override bool AffectsLayoutOverride(MoveShapeInDepthCommandContext context)
        {
            return true;
        }

        protected override void ExecuteOverride(MoveShapeInDepthCommandContext context)
        {
            context.Worksheet.Shapes.BringForwardInternal(context.Shapes);
        }
    }
}
