﻿using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class InsertCellCommandContext : WorksheetCommandContextBase
	{
		#region Fields

        private readonly CellRange cellRange;
        private readonly InsertShiftType shiftType;

		#endregion


		#region Properties

        public CellRange CellRange
        {
            get
            {
                return this.cellRange;
            }
        }

		public InsertShiftType ShiftType
		{
			get
			{
				return this.shiftType;
			}
		}

		#endregion


		#region Constructors

        public InsertCellCommandContext(Worksheet worksheet, CellRange cellRange, InsertShiftType shiftType)
            : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(cellRange, "cellRange");

            this.cellRange = cellRange;
            this.shiftType = shiftType;
        }

		#endregion
	}
}