﻿using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class InsertColumnCommandContext : WorksheetCommandContextBase
	{
		#region Fields

		private readonly int index;
		private readonly int itemCount;

		#endregion


		#region Properties

		public int Index
		{
			get
			{
				return this.index;
			}
		}

		public int ItemCount
		{
			get
			{
				return this.itemCount;
			}
		}

		#endregion


		#region Constructors

		public InsertColumnCommandContext(Worksheet worksheet, int index, int itemCount)
			: base(worksheet)
		{
			Guard.ThrowExceptionIfInvalidColumnIndex(index);
			Guard.ThrowExceptionIfLessThan(0, itemCount, "itemCount");

			this.index = index;
			this.itemCount = itemCount;
		}

		#endregion
	}
}