﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class MergeCellsCommandContext : WorksheetCommandContextBase
    {
        #region Fields

        private readonly CellRange newMergedCellRange;
        private ISet<CellRange> oldMergedCellRanges;

        #endregion


        #region Properties

        public CellRange NewMergedCellRange
        {
            get
            {
                return this.newMergedCellRange;
            }
        }

        public ISet<CellRange> OldMergedCellRanges
        {
            get
            {
                return this.oldMergedCellRanges;
            }
            internal set
            {
                this.oldMergedCellRanges = value;
            }
        }

        #endregion


        #region Constructors

        public MergeCellsCommandContext(Worksheet worksheet, CellRange newMergedCellRange)
            : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(newMergedCellRange, "newMergedCellRange");

            this.newMergedCellRange = newMergedCellRange;
            this.oldMergedCellRanges = new HashSet<CellRange>();
        }

        #endregion
    }
}