﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class RearrangeFilterRowsCommand : UndoableWorksheetCommandBase<RearrangeFilterRowsCommandContext>
    {
        protected override void PreserveStateBeforeExecute(RearrangeFilterRowsCommandContext context)
        {
            //Nothing to preserve.
        }

        protected override void UndoOverride(RearrangeFilterRowsCommandContext context)
        {
            ShiftType reverseType;

            if (context.ShiftType == ShiftType.Down)
            {
                reverseType = ShiftType.Up;
            }
            else if (context.ShiftType == ShiftType.Up)
            {
                reverseType = ShiftType.Down;
            }
            else
            {
                throw new NotSupportedException();
            }

            context.Worksheet.Filter.RearrangeFilterRows(context.AbsoluteIndex, context.Delta, reverseType);
        }

        protected override bool AffectsLayoutOverride(RearrangeFilterRowsCommandContext context)
        {
            return true;
        }

        protected override void ExecuteOverride(RearrangeFilterRowsCommandContext context)
        {
            context.Worksheet.Filter.RearrangeFilterRows(context.AbsoluteIndex, context.Delta, context.ShiftType);
        }
    }
}
