﻿using Telerik.Windows.Documents.Spreadsheet.PropertySystem;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    // TODO: Improve performance!
    internal class RemoveCellCommand : UndoableWorksheetCommandBase<RemoveCellCommandContext>
	{
		#region Methods

		protected override bool AffectsLayoutOverride(RemoveCellCommandContext context)
		{
			return true;
		}

		protected override void PreserveStateBeforeExecute(RemoveCellCommandContext context)
		{
			// Preserve the cell properties.
			context.OldCellProperties = new CellsPropertyBag();
			context.OldCellProperties.CopyPropertiesFrom(
				context.Worksheet.Cells.PropertyBag, context.CellRange);
		}

        protected override bool CanExecuteOverride(RemoveCellCommandContext context)
        {
            return context.Worksheet.Cells.CanRemove(context.CellRange, context.ShiftType);
        }

		protected override void ExecuteOverride(RemoveCellCommandContext context)
		{
            context.Worksheet.Cells.RemoveInternal(context.CellRange, context.ShiftType);
		}

		protected override void UndoOverride(RemoveCellCommandContext context)
		{
            InsertShiftType shiftType = context.ShiftType.ReverseShiftType();
            context.Worksheet.Cells.InsertInternal(context.CellRange, shiftType, context.OldCellProperties);
        }

		#endregion
	}
}