﻿using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class RemoveCellCommandContext : WorksheetCommandContextBase
    {
        #region Fields

        private readonly CellRange cellRange;
        private readonly RemoveShiftType shiftType;

        #endregion


        #region Properties

        public RemoveShiftType ShiftType
        {
            get
            {
                return this.shiftType;
            }
        }

        public CellRange CellRange
        {
            get
            {
                return this.cellRange;
            }
        }

        internal CellsPropertyBag OldCellProperties { get; set; }

        #endregion


        #region Constructors

        public RemoveCellCommandContext(Worksheet worksheet, CellRange cellRange, RemoveShiftType shiftType)
            : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(cellRange, "cellRange");
            this.cellRange = cellRange;
            this.shiftType = shiftType;
        }

        #endregion
    }
}