﻿using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class RemoveColumnCommandContext : WorksheetCommandContextBase
	{
		#region Fields

		private readonly int fromIndex;
		private readonly int itemCount;

		#endregion


		#region Properties

		public int FromIndex
		{
			get
			{
				return this.fromIndex;
			}
		}

		public int ToIndex
		{
			get
			{
				return this.fromIndex + this.itemCount - 1;
			}
		}

		public int ItemCount
		{
			get
			{
				return this.itemCount;
			}
		}

		internal ColumnsPropertyBag OldColumnProperties { get; set; }
		internal CellsPropertyBag OldCellProperties { get; set; }

		#endregion


		#region Constructors

        public RemoveColumnCommandContext(Worksheet worksheet, int fromIndex, int itemCount)
			: base(worksheet)
		{
			Guard.ThrowExceptionIfInvalidColumnIndex(fromIndex);
			Guard.ThrowExceptionIfLessThan(0, itemCount, "itemCount");

			this.fromIndex = fromIndex;
			this.itemCount = itemCount;
		}

		#endregion
	}
}