﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class RemovePageBreakCommand : UndoableWorksheetCommandBase<AddRemovePageBreakCommandContext>
    {
        protected override void PreserveStateBeforeExecute(AddRemovePageBreakCommandContext context)
        {
            // Nothing to preserve.
        }

        protected override void UndoOverride(AddRemovePageBreakCommandContext context)
        {
            context.Worksheet.WorksheetPageSetup.PageBreaks.AddPageBreakInternal(context.PageBreak);
        }

        protected override bool AffectsLayoutOverride(AddRemovePageBreakCommandContext context)
        {
            return true;
        }

        protected override void ExecuteOverride(AddRemovePageBreakCommandContext context)
        {
            context.Worksheet.WorksheetPageSetup.PageBreaks.RemovePageBreakInternal(context.PageBreak);
        }
    }
}
