﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class RemoveShapeCommand : UndoableWorksheetCommandBase<AddRemoveShapeCommandContext>
    {
        protected override bool AffectsLayoutOverride(AddRemoveShapeCommandContext context)
        {
            return true;
        }

        protected override void PreserveStateBeforeExecute(AddRemoveShapeCommandContext context)
        {
            // Nothing to preserve.
        }

        protected override void ExecuteOverride(AddRemoveShapeCommandContext context)
        {
            context.Worksheet.Shapes.RemoveInternal(context.Shape);
        }

        protected override void UndoOverride(AddRemoveShapeCommandContext context)
        {
            context.Worksheet.Shapes.AddInternal(context.Shape);
        }

        protected override bool CanExecuteOverride(AddRemoveShapeCommandContext context)
        {
            return context.Worksheet.Shapes.Contains(context.Shape);
        }
    }
}
