﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Core.DataStructures;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetCellBordersCommandContext : SetBordersCommandContextBase
    {
        public SetCellBordersCommandContext(Worksheet worksheet, CellRange cellRange, CellBorders newValue)
            : base(worksheet, cellRange, newValue)
        {
        }

        public override ICompressedList<CellBorder> GetBorderProperty(IPropertyDefinition<CellBorder> borderProperty, CellRange range)
        {
            return this.Worksheet.Cells.PropertyBag.GetPropertyValue(borderProperty, range);
        }

        public override void SetBorderProperty(IPropertyDefinition<CellBorder> borderProperty, CellRange range, ICompressedList<CellBorder> values)
        {
            this.Worksheet.Cells.PropertyBag.SetPropertyValue(borderProperty, range, values);
        }

        protected override void SetValuesInRange(CellRange range, ICompressedList<CellBorder> collection, CellBorder value)
        {
            foreach (LongRange longRange in CellsPropertyBag.ConvertCellRangeToLongRanges(range))
            {
                collection.SetValue(longRange.Start, longRange.End, value);
            }
        }

        protected override void ClearValuesInRange(CellRange range, ICompressedList collection)
        {
            foreach (LongRange longRange in CellsPropertyBag.ConvertCellRangeToLongRanges(range))
            {
                collection.ClearValue(longRange.Start, longRange.End);
            }
        } 
    }
}