﻿namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetCellPropertyCommand<T> : UndoableWorksheetCommandBase<SetCellPropertyCommandContext<T>>
	{
		#region Methods

		protected override bool AffectsLayoutOverride(SetCellPropertyCommandContext<T> context)
		{
			return context.Property.AffectsLayout;
		}

		protected override void PreserveStateBeforeExecute(SetCellPropertyCommandContext<T> context)
		{
			context.OldValues = context.Worksheet.Cells.PropertyBag.GetPropertyValue(context.Property, context.CellRange);
		}

		protected override void ExecuteOverride(SetCellPropertyCommandContext<T> context)
		{
            if (context.NewValue == null)
            {
                context.Worksheet.Cells.PropertyBag.ClearPropertyValue(context.Property, context.CellRange);
            }
            else
            {
                context.Worksheet.Cells.PropertyBag.SetPropertyValue(context.Property, context.CellRange, context.NewValue.Value);
            }
		}

		protected override void UndoOverride(SetCellPropertyCommandContext<T> context)
		{
			context.Worksheet.Cells.PropertyBag.SetPropertyValue(context.Property, context.CellRange, context.OldValues);
		}

		#endregion
	}
}