﻿using Telerik.Windows.Documents.Spreadsheet.Core;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetCellPropertyCommandContext<T> : SetPropertyInRangeCommandContext<T>
	{
		#region Fields

		private readonly CellRange cellRange;
		
		#endregion


		#region Properties

		public CellRange CellRange
		{
			get
			{
				return this.cellRange;
			}
		}

		#endregion


		#region Constructors

        public SetCellPropertyCommandContext(Worksheet sheet, IPropertyDefinition<T> property, CellRange cellRange, T newValue)
            : this(sheet, property, cellRange, new ValueBox<T>(newValue))
        {
        }

        protected SetCellPropertyCommandContext(Worksheet sheet, IPropertyDefinition<T> property, CellRange cellRange, ValueBox<T> newValue)
			: base(sheet, property, newValue)
		{
			Guard.ThrowExceptionIfNull(cellRange, "cellRange");

			this.cellRange = cellRange;
		}

		#endregion

        internal override void InvalidateLayout()
        {
            if(this.Property == CellPropertyDefinitions.ValueProperty)
            {
                this.Workbook.InvalidateLayout();
            }
            else
            {
                base.InvalidateLayout();
            }
        }
	}
}