﻿namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetColumnPropertyCommand<T> : UndoableWorksheetCommandBase<SetRowColumnPropertyCommandContext<T>>
	{
		#region Methods

		protected override bool AffectsLayoutOverride(SetRowColumnPropertyCommandContext<T> context)
		{
			return context.Property.AffectsLayout;
		}

		protected override void PreserveStateBeforeExecute(SetRowColumnPropertyCommandContext<T> context)
		{
			context.OldValues = context.Worksheet.Columns.PropertyBag.GetPropertyValue(context.Property, context.FromIndex, context.ToIndex);
		}

		protected override void ExecuteOverride(SetRowColumnPropertyCommandContext<T> context)
		{
            if (context.NewValue == null)
            {
                context.Worksheet.Columns.PropertyBag.ClearPropertyValue(context.Property, context.FromIndex, context.ToIndex);
            }
            else
            {
                context.Worksheet.Columns.PropertyBag.SetPropertyValue(context.Property, context.FromIndex, context.ToIndex, context.NewValue.Value);
            }
		}

		protected override void UndoOverride(SetRowColumnPropertyCommandContext<T> context)
		{
			context.Worksheet.Columns.PropertyBag.SetPropertyValue(context.Property, context.OldValues);
		}

		#endregion
	}
}