﻿namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetDefaultPropertyValueCommand<T> : UndoableWorksheetCommandBase<SetDefaultPropertyValueCommandContext<T>>
	{
		#region Methods

		protected override bool AffectsLayoutOverride(SetDefaultPropertyValueCommandContext<T> context)
		{
			return context.Property.AffectsLayout;
		}

		protected override void PreserveStateBeforeExecute(SetDefaultPropertyValueCommandContext<T> context)
		{
			context.OldValue = context.PropertyBag.GetDefaultPropertyValue(context.Property);
		}

		protected override void ExecuteOverride(SetDefaultPropertyValueCommandContext<T> context)
		{
			context.PropertyBag.SetDefaultPropertyValue(context.Property, context.NewValue);
		}

		protected override void UndoOverride(SetDefaultPropertyValueCommandContext<T> context)
		{
			context.PropertyBag.SetDefaultPropertyValue(context.Property, context.OldValue);
		}

		#endregion
	}
}