﻿using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetDefaultPropertyValueCommandContext<T> : WorksheetCommandContextBase
	{
		#region Fields

		private readonly IPropertyDefinition<T> property;
		private readonly PropertyBagBase propertyBag;
		private T oldValue;
		private readonly T newValue;

		#endregion


		#region Properties

		public IPropertyDefinition<T> Property
		{
			get
			{
				return this.property;
			}
		}

		public PropertyBagBase PropertyBag
		{
			get
			{
				return this.propertyBag;
			}
		}

		public T OldValue
		{
			get
			{
				return this.oldValue;
			}
			internal set
			{
				this.oldValue = value;
			}
		}

		public T NewValue
		{
			get
			{
				return this.newValue;
			}
		}

		#endregion


		#region Constructors

        public SetDefaultPropertyValueCommandContext(Worksheet worksheet, IPropertyDefinition<T> property, PropertyBagBase propertyBag, T newValue) 
			: base(worksheet)
		{
			Guard.ThrowExceptionIfNull(property, "property");
			Guard.ThrowExceptionIfNull(propertyBag, "propertyBag");

			this.property = property;
			this.propertyBag = propertyBag;
			this.newValue = newValue;
		}

		#endregion
	}
}