﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Core.DataStructures;
using Telerik.Windows.Documents.Spreadsheet.Model.Filtering;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetFilterRangeCommand : UndoableWorksheetCommandBase<SetFilterRangeCommandContext>
    {
        protected override void PreserveStateBeforeExecute(SetFilterRangeCommandContext context)
        {
            AutoFilter autoFilter = context.Worksheet.Filter;

            context.OldRange = autoFilter.FilterRange;
        }

        protected override void UndoOverride(SetFilterRangeCommandContext context)
        {
            AutoFilter autoFilter = context.Worksheet.Filter;

            autoFilter.SetFilterRangeInternal(context.OldRange);
        }

        protected override bool AffectsLayoutOverride(SetFilterRangeCommandContext context)
        {
            return true;
        }

        protected override void ExecuteOverride(SetFilterRangeCommandContext context)
        {
            context.Worksheet.Filter.SetFilterRangeInternal(context.NewRange);
        }
    }
}
