﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Media;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetImageImageSourceCommandContext : WorksheetCommandContextBase
    {
        private readonly FloatingImage image;
        private readonly ImageSource newImageSource;
        private ImageSource oldImageSource;

        public FloatingImage Image
        {
            get
            {
                return this.image;
            }
        }

        public ImageSource NewImageSource
        {
            get
            {
                return this.newImageSource;
            }
        }

        public ImageSource OldImageSource
        {
            get
            {
                return this.oldImageSource;
            }
            set
            {
                this.oldImageSource = value;
            }
        }

        public SetImageImageSourceCommandContext(Worksheet worksheet, FloatingImage image, ImageSource newSource)
            :base(worksheet)
        {
            Guard.ThrowExceptionIfNull(image, "image");
            Guard.ThrowExceptionIfNull(newSource, "newSource");

            this.image = image;
            this.newImageSource = newSource;
        }
    }
}
