﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Core.DataStructures;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal abstract class SetPropertyCommandContextBase<T> : WorksheetCommandContextBase
	{
		#region Fields

		private readonly IPropertyDefinition<T> property;
        private ICompressedList<T> oldValues;

		#endregion


		#region Properties

		public IPropertyDefinition<T> Property
		{
			get
			{
				return this.property;
			}
		}

        public ICompressedList<T> OldValues
		{
			get
			{
				return this.oldValues;
			}
			internal set
			{
				this.oldValues = value;
			}
		}

		#endregion


		#region Constructors

        public SetPropertyCommandContextBase(Worksheet worksheet, IPropertyDefinition<T> property)
            : base(worksheet)
		{
			Guard.ThrowExceptionIfNull(property, "property");

			this.property = property;
		}

		#endregion
	}
}