﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Core.DataStructures;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetPropertyValuesCommandContext : WorksheetCommandContextBase
    {
        #region Fields

        private readonly IPropertyDefinition property;
        private ICompressedList oldValues;
        private readonly ICompressedList newValues;

        #endregion


        #region Properties

        public ICompressedList NewValues
        {
            get 
            {
                return this.newValues;
            }
        }

        public IPropertyDefinition Property
        {
            get
            {
                return this.property;
            }
        }

        public ICompressedList OldValues
        {
            get
            {
                return this.oldValues;
            }
            internal set
            {
                this.oldValues = value;
            }
        }

        #endregion


        #region Constructors

        public SetPropertyValuesCommandContext(Worksheet worksheet, IPropertyDefinition property, ICompressedList newValues)
            : base(worksheet)
		{
            Guard.ThrowExceptionIfNull(property, "property");
            Guard.ThrowExceptionIfNull(newValues, "newValues");

            this.property = property;
			this.newValues = newValues;
		}

        #endregion
    }
}