﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetShapeFlipCommandContext : WorksheetCommandContextBase
    {
        private readonly FloatingShapeBase shape;

        private readonly bool horizontalFlip;
        private readonly bool verticalFlip;
        private bool oldHorizontalFlip;
        private bool oldVerticalFlip;

        public FloatingShapeBase Shape
        {
            get
            {
                return this.shape;
            }
        }

        public bool HorizontalFlip
        {
            get
            {
                return this.horizontalFlip;
            }
        }

        public bool VerticalFlip
        {
            get
            {
                return this.verticalFlip;
            }
        }

        public bool OldHorizontalFlip
        {
            get
            {
                return this.oldHorizontalFlip;
            }
            set
            {
                this.oldHorizontalFlip = value;
            }
        }

        public bool OldVerticalFlip
        {
            get
            {
                return this.oldVerticalFlip;
            }
            set
            {
                this.oldVerticalFlip = value;
            }
        }

        public SetShapeFlipCommandContext(Worksheet worksheet, FloatingShapeBase shape, bool horizontalFlip, bool verticalFlip)
            :base(worksheet)
        {
            Guard.ThrowExceptionIfNull(shape, "shape");

            this.shape = shape;
            this.horizontalFlip = horizontalFlip;
            this.verticalFlip = verticalFlip;
        }
    }
}
