﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetShapeLockAspectRatioCommandContext : WorksheetCommandContextBase
    {
        private readonly bool lockAspectRatio;
        private bool oldLockAspectRatio;
        private readonly FloatingShapeBase shape;

        public bool LockAspectRatio
        {
            get
            {
                return this.lockAspectRatio;
            }
        }

        public bool OldLockAspectRatio
        {
            get
            {
                return this.oldLockAspectRatio;
            }
            set
            {
                this.oldLockAspectRatio = value;
            }
        }

        public FloatingShapeBase Shape
        {
            get
            {
                return this.shape;
            }
        }

        public SetShapeLockAspectRatioCommandContext(Worksheet worksheet, FloatingShapeBase shape, bool lockAspectRatio)
            : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(shape, "shape");

            this.lockAspectRatio = lockAspectRatio;
            this.shape = shape;
        }

    }
}
