﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetShapeNameCommandContext : WorksheetCommandContextBase
    {
        private readonly FloatingShapeBase shape;
        private readonly string newName;
        private string oldName;

        public FloatingShapeBase Shape
        {
            get
            {
                return this.shape;
            }
        }

        public string NewName
        {
            get
            {
                return this.newName;
            }
        }

        public string OldName
        {
            get
            {
                return this.oldName;
            }
            set
            {
                this.oldName = value;
            }
        }

        public SetShapeNameCommandContext(Worksheet worksheet, FloatingShapeBase shape, string newName)
            : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(shape, "shape");
            Guard.ThrowExceptionIfNull(newName, "newName");

            this.shape = shape;
            this.newName = newName;
        }
    }
}
