﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetShapePositionCommandContext : WorksheetCommandContextBase
    {
        private readonly FloatingShapeBase shape;
        private readonly CellIndex newCellIndex;
        private readonly double newOffsetX;
        private readonly double newOffsetY;

        private CellIndex oldCellIndex;
        private double oldOffsetX;
        private double oldOffsetY;

        public FloatingShapeBase Shape
        {
            get
            {
                return this.shape;
            }
        }

        public CellIndex NewCellIndex
        {
            get
            {
                return this.newCellIndex;
            }
        }

        public double NewOffsetX
        {
            get
            {
                return this.newOffsetX;
            }
        }

        public double NewOffsetY
        {
            get
            {
                return this.newOffsetY;
            }
        }

        public CellIndex OldCellIndex
        {
            get
            {
                return this.oldCellIndex;
            }
            set
            {
                this.oldCellIndex = value;
            }
        }

        public double OldOffsetX
        {
            get
            {
                return this.oldOffsetX;
            }
            set
            {
                this.oldOffsetX = value;
            }
        }

        public double OldOffsetY
        {
            get
            {
                return this.oldOffsetY;
            }
            set
            {
                this.oldOffsetY = value;
            }
        }

        public SetShapePositionCommandContext(Worksheet worksheet, FloatingShapeBase shape, CellIndex newCellIndex, double newOffsetX, double newOffsetY) 
            : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(shape, "shape");
            Guard.ThrowExceptionIfNull(newCellIndex, "newCellIndex");

            this.shape = shape;
            this.newCellIndex = newCellIndex;
            this.newOffsetX = newOffsetX;
            this.newOffsetY = newOffsetY;
        }

    }
}
