﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetShapeSizeCommandContext : WorksheetCommandContextBase
    {
        private readonly FloatingShapeBase shape;
        private readonly double newValue;
        private double oldValue;
        private readonly bool respectLockAspectRatio;
        private readonly bool adjustCellIndex;

        public double NewValue
        {
            get
            {
                return this.newValue;
            }
        }

        public double OldValue
        {
            get
            {
                return this.oldValue;
            }
            set
            {
                this.oldValue = value;
            }
        }

        public bool RespectLockAspectRatio
        {
            get
            {
                return this.respectLockAspectRatio;
            }
        }

        public FloatingShapeBase Shape
        {
            get
            {
                return this.shape;
            }
        }

        public bool AdjustCellIndex
        {
            get
            {
                return this.adjustCellIndex;
            }
        }

        public SetShapeSizeCommandContext(Worksheet worksheet, FloatingShapeBase shape, double newValue, bool respectLockAspectRatio, bool adjustCellIndex)
            : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(shape, "shape");

            this.shape = shape;
            this.newValue = newValue;
            this.respectLockAspectRatio = respectLockAspectRatio;
            this.adjustCellIndex = adjustCellIndex;
        }
    }
}
