﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class RemoveSortConditionCommand : UndoableWorksheetCommandBase<RemoveSortConditionCommandContext>
    {
        protected override void PreserveStateBeforeExecute(RemoveSortConditionCommandContext context)
        {
            // Nothing to preserve.
        }

        protected override void UndoOverride(RemoveSortConditionCommandContext context)
        {
            context.Worksheet.SortState.Insert(context.OrderIndex, context.Condition);
        }

        protected override bool AffectsLayoutOverride(RemoveSortConditionCommandContext context)
        {
            return true;
        }

        protected override void ExecuteOverride(RemoveSortConditionCommandContext context)
        {
            context.Worksheet.SortState.Remove(context.Condition);
        }
    }
}
