﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Sorting;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetSortCommandContext : WorksheetCommandContextBase
    {
        #region Fields

        private readonly CellRange sortRange;
        private readonly ISortCondition sortCondition;
        private readonly int[] sortedIndexes;
        private int[] oldSortedIndexes;

        #endregion


        #region Properties

        public int[] OldSortedIndexes
        {
            get
            {
                return this.oldSortedIndexes;
            }
            set
            {
                this.oldSortedIndexes = value;
            }
        }

        public CellRange SortRange
        {
            get
            {
                return this.sortRange;
            }
        }

        public ISortCondition SortCondition
        {
            get
            {
                return this.sortCondition;
            }
        }

        public int[] SortedIndexes
        {
            get
            {
                return this.sortedIndexes;
            }
        }

        public override bool ShouldBringActiveCellIntoView
        {
            get
            {
                return false;
            }
        }

        #endregion


        #region Constructors

        public SetSortCommandContext(Worksheet worksheet, CellRange sortRange, ISortCondition sortCondition, int[] sortedIndexes)
            : base(worksheet)
        {
            this.sortRange = sortRange;
            this.sortCondition = sortCondition;
            this.sortedIndexes = sortedIndexes;
        }

        #endregion
    }
}