﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class SetSortRangeCommandContext : WorksheetCommandContextBase
    {
        private readonly CellRange newSortRange;
        private CellRange oldSortRange;

        public CellRange NewSortRange
        {
            get
            {
                return this.newSortRange;
            }
        }

        public CellRange OldSortRange
        {
            get
            {
                return this.oldSortRange;
            }
            set
            {
                if (this.oldSortRange != value)
                {
                    this.oldSortRange = value;
                }
            }
        }

        public override bool ShouldBringActiveCellIntoView
        {
            get
            {
                return false;
            }
        }

        public SetSortRangeCommandContext(Worksheet worksheet, CellRange newRange)
            :base(worksheet)
        {
            Guard.ThrowExceptionIfNull(newRange, "newRange");

            this.newSortRange = newRange;
        }
    }
}
