﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Commands.WorksheetCommands
{
    internal class UnmergeCellsCommandContext : WorksheetCommandContextBase
    {
        #region Fields

        private readonly CellRange cellRangeToUnmerge;
        private ISet<CellRange> oldMergedCellRanges;

        #endregion


        #region Properties

        public CellRange CellRangeToUnmerge
        {
            get
            {
                return this.cellRangeToUnmerge;
            }
        }

        public ISet<CellRange> OldMergedCellRanges
        {
            get
            {
                return this.oldMergedCellRanges;
            }
            internal set
            {
                this.oldMergedCellRanges = value;
            }
        }

        #endregion


        #region Constructors

        public UnmergeCellsCommandContext(Worksheet worksheet, CellRange cellRangeToUnmerge)
            : base(worksheet)
        {
            Guard.ThrowExceptionIfNull(cellRangeToUnmerge, "cellRangeToUnmerge");

            this.cellRangeToUnmerge = cellRangeToUnmerge;
            this.oldMergedCellRanges = new HashSet<CellRange>();
        }

        #endregion
    }
}