﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Core
{
	internal class BeginEndCounter
	{
		#region Fields

		private int beginUpdateCount;
		private readonly Action action;
        private bool isUpdateInProgress;

		#endregion


		#region Properties

		public bool IsUpdateInProgress
		{
			get
			{
                return this.beginUpdateCount > 0 || this.isUpdateInProgress;
			}
		}

		public int BeginUpdateCounter
		{
			get
			{
				return this.beginUpdateCount;
			}
		}

		#endregion


		#region Constructors

		public BeginEndCounter()
		{
		}

		public BeginEndCounter(Action action)
		{
			this.action = action;
		}

		#endregion


		#region Methods

		public void BeginUpdate()
		{
			this.beginUpdateCount++;
            this.isUpdateInProgress = true;
		}

		public void EndUpdate()
		{
			if (this.beginUpdateCount == 0)
			{
                throw new InvalidOperationException("There is no active update to end.");
			}

			this.beginUpdateCount--;
			if (this.beginUpdateCount == 0)
			{
				if (action != null)
				{
					this.action();
				}

                this.isUpdateInProgress = false;
			}
		}

		#endregion
	}
}