﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Telerik.Windows.Documents.Spreadsheet.Core.DataStructures
{
    internal interface ICompressedList : ITranslateableCollection, IEnumerable
    {
        bool ContainsNonDefaultValues(long start, long end);

        void Sort(long fromIndex, long toIndex, int[] sortedIndexes);

        long FromIndex { get; }

        long ToIndex { get; }

        void SetValue(ICompressedList compressedList);

        /// <summary>
        /// Sets a single value of compressed list to range starting from "fromIndex" and ending at "toIndex".
        /// </summary>
        /// <param name="fromIndex">From index.</param>
        /// <param name="toIndex">To index.</param>
        /// <param name="singleValueCompressedList">The single value compressed list.</param>
        void SetValue(long fromIndex, long toIndex, ICompressedList singleValueCompressedList);

        void SetDefaultValue(long fromIndex, long toIndex);

        IEnumerable<LongRange> GetRanges(bool getDefaultRanges);

        long? GetLastNonEmptyRangeEnd(long fromIndex, long toIndex);

        ICompressedList Offset(long delta);

        void ClearValue(long index);

        void ClearValue(long fromIndex, long toIndex);

        ICompressedList GetValue(long fromIndex, long toIndex);

        ICompressedList CreateInstance(long fromIndex, long toIndex);
    }
}
