﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Core
{
    /// <summary>
    /// Represents event arguments for events that can be canceled.
    /// </summary>
    public class RadCancelEventArgs : EventArgs
    {
        #region Properties

        /// <summary>
        /// Gets a value indicating whether the event is canceled.
        /// </summary>
        /// <value>The canceled.</value>
        public bool Canceled { get; private set; }

        #endregion


        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="RadCancelEventArgs" /> class.
        /// </summary>
        public RadCancelEventArgs()
        {
        }

        #endregion


        #region Methods

        /// <summary>
        /// Cancels the event.
        /// </summary>
        public void Cancel()
        {
            this.Canceled = true;
        }

        #endregion
    }
}