﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Spreadsheet.Core
{
    /// <summary>
    /// Class representing update scope.
    /// </summary>
    public sealed class UpdateScope : IDisposable
    {
        private readonly Action endUpdateAction;

        /// <summary>
        /// Initializes a new instance of the <see cref="UpdateScope" /> class.
        /// </summary>
        /// <param name="beginUpdateAction">The begin update action.</param>
        /// <param name="endUpdateAction">The end update action.</param>
        public UpdateScope(Action beginUpdateAction, Action endUpdateAction)
        {
            this.endUpdateAction = endUpdateAction;
            beginUpdateAction();
        }

        /// <summary>
        /// Performs application-defined tasks associated with freeing, releasing,
        /// or resetting unmanaged resources.
        /// </summary>
        public void Dispose()
        {
            this.endUpdateAction();
        }
    }
}