﻿using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Core
{
    internal class ValueBox<T>
    {
        #region Fields

        private readonly T value;

        #endregion


        #region Properties

        public T Value
        {
            get
            {
                return this.value;
            }
        }

        #endregion


        #region Constructors

        public ValueBox(T value)
        {
            this.value = value;
        }

        #endregion


        #region Methods

        public override int GetHashCode()
        {
            return this.value.GetHashCode();
        }

        public override bool Equals(object obj)
        {
            ValueBox<T> other = obj as ValueBox<T>;
            return other != null && TelerikHelper.EqualsOfT(this.value, other.value);
        }

        public override string ToString()
        {
            if (this.value == null) 
            {
                return "null";
            }

            return this.value.ToString();
        }

        #endregion      
    }
}