﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model.Filtering;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class AutoFilterFilterRangeChangedWeakEventManager : WeakEventManager
    {
        public static AutoFilterFilterRangeChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(AutoFilterFilterRangeChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as AutoFilterFilterRangeChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new AutoFilterFilterRangeChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            AutoFilter autoFilter = (AutoFilter)source;
            autoFilter.FilterRangeChanged += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            AutoFilter autoFilter = (AutoFilter)source;
            autoFilter.FilterRangeChanged -= this.DeliverEvent;
        }
    }
}