﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model.Filtering;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class AutoFilterFiltersChangedWeakEventManager : WeakEventManager
    {
        public static AutoFilterFiltersChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(AutoFilterFiltersChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as AutoFilterFiltersChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new AutoFilterFiltersChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            AutoFilter autoFilter = (AutoFilter)source;
            autoFilter.FiltersChanged += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            AutoFilter autoFilter = (AutoFilter)source;
            autoFilter.FiltersChanged -= this.DeliverEvent;
        }
    }
}