﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class CellsMergedCellsChangedWeakEventManager : WeakEventManager
    {
        public static CellsMergedCellsChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(CellsMergedCellsChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as CellsMergedCellsChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new CellsMergedCellsChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            Cells cells = (Cells)source;
            cells.MergedCellsChanged += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            Cells cells = (Cells)source;
            cells.MergedCellsChanged -= this.DeliverEvent;
        }
    }
}