﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class CellsPropertyBagPropertyChangedWeakEventManager : WeakEventManager
    {
        public static CellsPropertyBagPropertyChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(CellsPropertyBagPropertyChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as CellsPropertyBagPropertyChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new CellsPropertyBagPropertyChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            CellsPropertyBag cellsPropertyBag = (CellsPropertyBag)source;
            cellsPropertyBag.PropertyChanged += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            CellsPropertyBag cellsPropertyBag = (CellsPropertyBag)source;
            cellsPropertyBag.PropertyChanged -= this.DeliverEvent;
        }
    }
}