﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.History;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class HistoryRecordExecutedWeakEventManager : WeakEventManager
    {
        public static HistoryRecordExecutedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(HistoryRecordExecutedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as HistoryRecordExecutedWeakEventManager;

                if (manager == null)
                {
                    manager = new HistoryRecordExecutedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            WorkbookHistory history = (WorkbookHistory)source;
            history.RecordExecuted += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            WorkbookHistory history = (WorkbookHistory)source;
            history.RecordExecuted -= this.DeliverEvent;
        }
    }
}