﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class NameManagerChangedWeakEventManager : WeakEventManager
    {
        public static NameManagerChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(NameManagerChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as NameManagerChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new NameManagerChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            NameManager nameManger = (NameManager)source;
            nameManger.Changed += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            NameManager nameManger = (NameManager)source;
            nameManger.Changed -= this.DeliverEvent;
        }
    }
}