﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Expressions;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class RadExpressionValueChangedWeakEventManager : WeakEventManager
    {
        public static RadExpressionValueChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(RadExpressionValueChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as RadExpressionValueChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new RadExpressionValueChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            RadExpression cellsPropertyBag = (RadExpression)source;
            cellsPropertyBag.ValueInvalidated += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            RadExpression cellsPropertyBag = (RadExpression)source;
            cellsPropertyBag.ValueInvalidated -= this.DeliverEvent;
        }
    }
}