﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class ShapeCollectionChangedWeakEventManager : WeakEventManager
    {
        public static ShapeCollectionChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(ShapeCollectionChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as ShapeCollectionChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new ShapeCollectionChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            ShapeCollection shapeCollection = (ShapeCollection)source;
            shapeCollection.Changed += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            ShapeCollection shapeCollection = (ShapeCollection)source;
            shapeCollection.Changed -= this.DeliverEvent;
        }
    }
}