﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class SheetCollectionActiveSheetChangedWeakEventManager : WeakEventManager
    {
        public static SheetCollectionActiveSheetChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(SheetCollectionActiveSheetChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as SheetCollectionActiveSheetChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new SheetCollectionActiveSheetChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            SheetCollection sheetCollection = (SheetCollection)source;
            sheetCollection.ActiveSheetChanged += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            SheetCollection sheetCollection = (SheetCollection)source;
            sheetCollection.ActiveSheetChanged -= this.DeliverEvent;
        }
    }
}