﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class SheetCollectionActiveSheetIndexChangedWeakEventManager : WeakEventManager
    {
        public static SheetCollectionActiveSheetIndexChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(SheetCollectionActiveSheetIndexChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as SheetCollectionActiveSheetIndexChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new SheetCollectionActiveSheetIndexChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            SheetCollection sheetCollection = (SheetCollection)source;
            sheetCollection.ActiveSheetIndexChanged += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            SheetCollection sheetCollection = (SheetCollection)source;
            sheetCollection.ActiveSheetIndexChanged -= this.DeliverEvent;
        }
    }
}