﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class SheetCollectionChangedWeakEventManager : WeakEventManager
    {
        public static SheetCollectionChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(SheetCollectionChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as SheetCollectionChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new SheetCollectionChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            SheetCollection sheets = (SheetCollection)source;
            sheets.Changed += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            SheetCollection sheets = (SheetCollection)source;
            sheets.Changed -= this.DeliverEvent;
        }
    }
}