﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class SheetPropertyChangedWeakEventManager : WeakEventManager
    {
        public static SheetPropertyChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(SheetPropertyChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as SheetPropertyChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new SheetPropertyChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            Sheet sheet = (Sheet)source;
            sheet.PropertyChanged += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            Sheet sheet = (Sheet)source;
            sheet.PropertyChanged -= this.DeliverEvent;
        }
    }
}