﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class WorkbookCommandErrorWeakEventManager : WeakEventManager
    {
        public static WorkbookCommandErrorWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(WorkbookCommandErrorWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as WorkbookCommandErrorWeakEventManager;

                if (manager == null)
                {
                    manager = new WorkbookCommandErrorWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            Workbook workbook = (Workbook)source;
            workbook.CommandError += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            Workbook workbook = (Workbook)source;
            workbook.CommandError -= this.DeliverEvent;
        }
    }
}