﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class WorkbookContentChangedWeakEventManager : WeakEventManager
    {
        public static WorkbookContentChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(WorkbookContentChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as WorkbookContentChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new WorkbookContentChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            Workbook workbook = (Workbook)source;
            workbook.WorkbookContentChanged += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            Workbook workbook = (Workbook)source;
            workbook.WorkbookContentChanged -= this.DeliverEvent;
        }
    }
}