﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class WorkbookProtectionChangedWeakEventManager : WeakEventManager
    {
        public static WorkbookProtectionChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(WorkbookProtectionChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as WorkbookProtectionChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new WorkbookProtectionChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            Workbook workbook = (Workbook)source;
            workbook.IsProtectedChanged += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            Workbook workbook = (Workbook)source;
            workbook.IsProtectedChanged -= this.DeliverEvent;
        }
    }
}
