﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class WorksheetCopiedWeakEventManager :  WeakEventManager
    {
        public static WorksheetCopiedWeakEventManager CurrentManager
        {
            get
            {
                Type managerType = typeof(WorksheetCopiedWeakEventManager);
                WorksheetCopiedWeakEventManager manager = WeakEventManager.GetCurrentManager(managerType) as WorksheetCopiedWeakEventManager;

                if (manager == null)
                {
                    manager = new WorksheetCopiedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            Worksheet worksheet = (Worksheet)source;
            worksheet.Copied += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            Worksheet worksheet = (Worksheet)source;
            worksheet.Copied -= this.DeliverEvent;
        }
    }
}