﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Layout;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class WorksheetLayoutMeasureExecutedWeakEventManager : WeakEventManager
    {
        public static WorksheetLayoutMeasureExecutedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(WorksheetLayoutMeasureExecutedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as WorksheetLayoutMeasureExecutedWeakEventManager;

                if (manager == null)
                {
                    manager = new WorksheetLayoutMeasureExecutedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            RadWorksheetLayout worksheetLayout = (RadWorksheetLayout)source;
            worksheetLayout.MeasureExecuted += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            RadWorksheetLayout worksheetLayout = (RadWorksheetLayout)source;
            worksheetLayout.MeasureExecuted -= this.DeliverEvent;
        }
    }
}