﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model.Printing;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class WorksheetPageSetupPageSetupChangedWeakEventManager : WeakEventManager
    {
        public static WorksheetPageSetupPageSetupChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(WorksheetPageSetupPageSetupChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as WorksheetPageSetupPageSetupChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new WorksheetPageSetupPageSetupChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            WorksheetPageSetup worksheetPageSetup = (WorksheetPageSetup)source;
            worksheetPageSetup.PageSetupChanged += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            WorksheetPageSetup worksheetPageSetup = (WorksheetPageSetup)source;
            worksheetPageSetup.PageSetupChanged -= this.DeliverEvent;
        }
    }
}