﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Core.WeakEventManagers
{
    internal class WorksheetProtectedChangedWeakEventManager : WeakEventManager
    {
        public static WorksheetProtectedChangedWeakEventManager CurrentManager
        {
            get
            {
                var managerType = typeof(WorksheetProtectedChangedWeakEventManager);
                var manager = WeakEventManager.GetCurrentManager(managerType) as WorksheetProtectedChangedWeakEventManager;

                if (manager == null)
                {
                    manager = new WorksheetProtectedChangedWeakEventManager();
                    WeakEventManager.SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        public static void AddListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        public static void RemoveListener(object source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        protected override void StartListening(object source)
        {
            Worksheet worksheet = (Worksheet)source;
            worksheet.IsProtectedChanged += this.DeliverEvent;
        }

        protected override void StopListening(object source)
        {
            Worksheet worksheet = (Worksheet)source;
            worksheet.IsProtectedChanged -= this.DeliverEvent;
        }
    }
}