﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.DataSeries.AutoFill
{
    internal class RepeatAutoFillGenerator : IAutoFillGenerator
    {
        #region Constants

        private static readonly string NAME = "Repeat";

        #endregion


        #region Properties

        public string Name
        {
            get
            {
                return NAME;
            }
        }

        #endregion 


        #region Methods

        public void FillSeries(Worksheet worksheet, CellIndex[] indexes, int initialIndexesCount)
        {
            for (int i = 0; i < initialIndexesCount; i++)
            {
                using (WorksheetFragment value = worksheet.Cells[indexes[i]].Copy())
                {
                    for (int j = i + initialIndexesCount; j < indexes.Length; j += initialIndexesCount)
                    {
                        worksheet.Cells[indexes[j]].Paste(value, new PasteOptions(PasteType.Formulas));
                    }
                }
            }
        }

        #endregion
    }
}