﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions
{
    /// <summary>
    /// Provides methods and properties for using BooleanExpression.
    /// </summary>
    public class BooleanExpression : ConstantExpression<bool>
    {
		#region Constants
        
        /// <summary>
        /// The True BooleanExpression.
        /// </summary>
		public static readonly BooleanExpression True = new BooleanExpression(true);

        /// <summary>
        /// The False BooleanExpression.
        /// </summary>
		public static readonly BooleanExpression False = new BooleanExpression(false);

		#endregion


		#region Constructors

		private BooleanExpression(bool value)
            : base(value)
		{
		}

		#endregion


        #region Methods

        internal override string GetValueAsString(SpreadsheetCultureHelper cultureInfo)
        {
            if (this.Value == true)
            {
                return SpreadsheetCultureHelper.TrueLiteral;
            }

            return SpreadsheetCultureHelper.FalseLiteral;
        }
        #endregion
    }
}