﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions
{
    /// <summary>
    /// Inheritor of System.Exception used when an ExpressionException needs to be thrown.
    /// </summary>
    public class ExpressionException : LocalizableException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ExpressionException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public ExpressionException(string message) 
            : base(message)
		{
		}

        /// <summary>
        /// Initializes a new instance of the <see cref="ExpressionException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="key">The key.</param>
        /// <param name="formatStringArguments">The format string arguments.</param>
        public ExpressionException(string message, string key, string[] formatStringArguments = null) : base(message, key, formatStringArguments)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ExpressionException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public ExpressionException(string message, Exception innerException) 
            : base(message, innerException)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ExpressionException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        /// <param name="key">The key.</param>
        /// <param name="formatStringArguments">The format string arguments.</param>
        public ExpressionException(string message, Exception innerException, string key, string[] formatStringArguments = null) : base(message, innerException, key, formatStringArguments)
        {
        }
	}
}