﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions
{
    /// <summary>
    /// Represents the defined name input string class.
    /// </summary>
    internal class DefinedNameInputString : UserInputStringBase<SpreadsheetNameExpression>
    {
        public override bool IsSheetNameDependent
        {
            get
            {
                return this.Expression.IsNameReferringWorksheet;
            }
        }

        public override bool IsWorkbookNameDependent
        {
            get
            {
                return this.Expression.IsNameReferringWorbook;
            }
        }

        public DefinedNameInputString(SpreadsheetNameExpression expression)
            : base(expression)
        {
            
        }

        public override string ToString(SpreadsheetCultureHelper cultureInfo)
        {
            return this.Expression.ToString(cultureInfo);
        }

        public override UserInputStringBase Clone()
        {
            return new DefinedNameInputString(this.Expression);
        }
    }
}
