﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions
{
    /// <summary>
    /// Represents the list separator input string.
    /// </summary>
    internal class ListSeparatorInputString : UserInputStringBase
    {
        /// <summary>
        /// Toes the string.
        /// </summary>
        /// <param name="cultureInfo">The culture info.</param>
        /// <returns></returns>
        public override string ToString(SpreadsheetCultureHelper cultureInfo)
        {
            return cultureInfo.ListSeparator;
        }

        /// <summary>
        /// Clones this instance.
        /// </summary>
        /// <returns></returns>
        public override UserInputStringBase Clone()
        {
            return new ListSeparatorInputString();
        }
    }
}
