﻿using Telerik.Windows.Documents.Spreadsheet.Expressions.Functions;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions
{
    /// <summary>
    /// Provides methods and properties for using NumberBinaryOperatorExpression.
    /// </summary>
    public abstract class NumberBinaryOperatorExpression : BinaryOperatorExpression<double>
    {
        #region Properties

        /// <summary>
        /// Gets the type of the operands.
        /// </summary>
        /// <returns>The type of the operands as ArgumentType.</returns>
        /// <value>The type of the operands.</value>
        public override ArgumentType OperandsType
        {
            get 
            {
                return ArgumentType.Number;
            }
        }

        #endregion


        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="NumberBinaryOperatorExpression" /> class.
        /// </summary>
        /// <param name="left">The left.</param>
        /// <param name="right">The right.</param>
        protected NumberBinaryOperatorExpression(RadExpression left, RadExpression right) : base(left, right)
		{
		}

		#endregion
	}
}