﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions
{
    /// <summary>
    /// Represents the possible result values of the parse operation.
    /// </summary>
    internal enum ParseResult : byte
    {
        /// <summary>
        /// The method could not parse the value, however, no errors were encountered.
        /// </summary>
        Unsuccessful = 0,

        /// <summary>
        /// The method successfully parsed the value.
        /// </summary>
        Successful = 1,

        /// <summary>
        /// The method was supposed to parse the value, however, an error was encountered.
        /// </summary>
        Error = 2,
    }
}
