﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions.Parser
{
    /// <summary>
    /// Represents array expression token.
    /// </summary>
    internal class ArrayExpressionToken : ExpressionToken
    {
        private readonly ExpressionToken[,] array;

        /// <summary>
        /// Gets the array.
        /// </summary>
        /// <value>The array.</value>
        public ExpressionToken[,] Array
        {
            get
            {
                return this.array;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ArrayExpressionToken" /> class.
        /// </summary>
        /// <param name="array">The array.</param>
        /// <param name="value">The value.</param>
        public ArrayExpressionToken(ExpressionToken[,] array, string value) : base(ExpressionTokenType.Array, value)
        {
            Guard.ThrowExceptionIfNull(array, "array");
            this.array = array;
        }
    }
}
