﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions.Parser
{
	internal class ExpressionTokenReader
	{
		#region Fields

		private readonly string input;

        private int position;

		#endregion


        #region Properties

        public bool EndOfFile
        {
            get
            {
                return this.position >= this.input.Length;
            }
        }

        public int Position
        {
            get
            {
                return this.position;
            }
        }
        #endregion


        #region Constructors

        public ExpressionTokenReader(string input)
		{
			Guard.ThrowExceptionIfNull(input, "input");
            this.input = input;
		}

		#endregion


		#region Methods

		public int Peek()
		{
            if (this.EndOfFile)
            {
                return -1;
            }
            
            return this.input[this.position];
		}

		public int Read()
		{
            if (this.EndOfFile)
            {
                return -1;
            }
            
            return this.input[this.position++];
		}
        
		#endregion
	}
}