﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions.Parser
{
    internal class FormulaSelectionExpressionLexer : ExpressionLexerBase
    {
        public FormulaSelectionExpressionLexer(string input, SpreadsheetCultureHelper cultureInfo)
            :base(input, cultureInfo)
        {
            this.RegisterModificationHandler(ExpressionTokenType.A1CellReference, CellReferenceRangeHandler);
        }

        protected override bool ShouldBreakOnResult(ParseResult result)
        {
            return false;
        }

        public IEnumerable<ExpressionToken> GetTokens()
        {
            ExpressionToken token;
            this.Read(out token);
            while (token != null)
            {
                yield return token;
                this.Read(out token);
            }
        }
    }
}
