﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions.Parser
{
    internal class WorksheetDependentExpressionToken : ExpressionToken
    {
        #region Fields

        private readonly string worksheetName;
        private readonly string cellOrName;

        #endregion


        #region Properties

        public string WorksheetName
        {
            get
            {
                return this.worksheetName;
            }
        }

        public string CellOrName
        {
            get
            {
                return this.cellOrName;
            }
        }

        #endregion


        #region Constructors

        public WorksheetDependentExpressionToken(ExpressionTokenType expressionTokenType, string worksheetName, string cellOrVariableName)
            : base(expressionTokenType, string.IsNullOrEmpty(worksheetName) ? cellOrVariableName : worksheetName + "!" + cellOrVariableName)
        {
            Guard.ThrowExceptionIfNull(worksheetName, "worksheetName");
            Guard.ThrowExceptionIfNullOrEmpty(cellOrVariableName, "cellOrVariableName");

            this.worksheetName = worksheetName;
            this.cellOrName = cellOrVariableName;
        }

        #endregion
    }
}
