﻿using Telerik.Windows.Documents.Spreadsheet.Expressions.Functions;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions
{
    /// <summary>
    /// Abstract class providing methods and properties for using StringBinaryOperatorExpression.
    /// </summary>
    public abstract class StringBinaryOperatorExpression : BinaryOperatorExpression<string>
    {
        #region Properties

        /// <summary>
        /// Gets the type of the operands.
        /// </summary>
        /// <returns>The type of the operands as ArgumentType.</returns>
        /// <value>The type of the operands.</value>
        public override ArgumentType OperandsType
        {
            get
            {
                return ArgumentType.Text;
            }
        }

        #endregion


        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="StringBinaryOperatorExpression" /> class.
        /// </summary>
        /// <param name="left">The left.</param>
        /// <param name="right">The right.</param>
        protected StringBinaryOperatorExpression(RadExpression left, RadExpression right)
            : base(left, right)
		{
		}

		#endregion
    }
}
