﻿using System.Text;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Expressions
{
    /// <summary>
    /// Provides methods and properties for using StringExpression.
    /// </summary>
    public class StringExpression : ConstantExpression<string>
    {
		#region Constants

        /// <summary>
        /// The Empty StringExpression.
        /// </summary>
		public static readonly StringExpression Empty = new StringExpression(string.Empty);

		#endregion


		#region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="StringExpression" /> class.
        /// </summary>
        /// <param name="value">The value.</param>
        public StringExpression(string value) : base(value)
		{
			Guard.ThrowExceptionIfNull(value, "value");
		}

		#endregion


        #region Methods

        internal override string ToString(SpreadsheetCultureHelper cultureInfo)
        {
            StringBuilder builder = new StringBuilder();

            builder.Append(SpreadsheetCultureHelper.DoubleQuote);
            builder.Append(base.ToString(cultureInfo).Replace(SpreadsheetCultureHelper.DoubleQuote, 
                SpreadsheetCultureHelper.DoubleQuote + SpreadsheetCultureHelper.DoubleQuote));
            builder.Append(SpreadsheetCultureHelper.DoubleQuote);

            return builder.ToString();
        }

        #endregion
    }
}