﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.Contexts
{
    /// <summary>
    /// Describes merged cells.
    /// </summary>
    public class MergedCellInfo
    {
        #region Fields

        private CellRange cellRange;

        #endregion


        #region Properties

        /// <summary>
        /// Gets or sets the cell range.
        /// </summary>
        /// <value>The cell range.</value>
        public CellRange CellRange
        {
            get
            {
                return this.cellRange;
            }
            set
            {
                Guard.ThrowExceptionIfNull(value, "value");
                this.cellRange = value;
            }
        }
        
        #endregion


        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="MergedCellInfo" /> class.
        /// </summary>
        public MergedCellInfo()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="MergedCellInfo" /> class.
        /// </summary>
        /// <param name="cellRange">The cell range.</param>
        public MergedCellInfo(CellRange cellRange)
        {
            this.CellRange = cellRange;
        }

        #endregion
    }
}