﻿using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders
{
    /// <summary>
    /// Represents binary workbook format provider.
    /// </summary>
    public interface IBinaryWorkbookFormatProvider : IWorkbookFormatProvider
    {
        /// <summary>
        /// Imports the specified input.
        /// </summary>
        /// <param name="input">The input.</param>
        /// <returns>The workbook.</returns>
        Workbook Import(byte[] input);

        /// <summary>
        /// Exports the specified workbook.
        /// </summary>
        /// <param name="workbook">The workbook.</param>
        /// <returns>The result byte array.</returns>
        byte[] Export(Workbook workbook);
    }
}