﻿using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders
{
    /// <summary>
    /// Represents text based workbook format provider.
    /// </summary>
    public interface ITextBasedWorkbookFormatProvider : IWorkbookFormatProvider
    {
        /// <summary>
        /// Imports the specified input.
        /// </summary>
        /// <param name="input">The input.</param>
        /// <returns>The workbook.</returns>
        Workbook Import(string input);

        /// <summary>
        /// Exports the specified workbook.
        /// </summary>
        /// <param name="workbook">The workbook.</param>
        /// <returns>The result string.</returns>
        string Export(Workbook workbook);
    }
}