﻿using System.Linq;
using Telerik.Windows.Documents.Licensing;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.TextBased.Core;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders
{
    internal static class LicenseCheck
    {
        public static void Validate(CsvWriter writer)
        {
            LicensingMode licensingMode = TelerikLicense.GetLicensingMode();
            string message;
            switch (licensingMode)
            {
                case LicensingMode.Trial:
                    message = TrialMessages.DocumentProcessingTrialMessage;
                    break;
                case LicensingMode.Unlicensed:
                    message = TrialMessages.DocumentProcessingUnlicencedMessage;
                    break;
                default:
                    message = null;
                    break;
            }

            if (message != null)
            {
                writer.WriteRecord(Enumerable.Repeat(message, 1));
            }
        }
    }
}