﻿using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.TextBased.Core
{
    internal class CsvToken
    {
        #region Fields

        private readonly CsvTokenType tokenType;
        private readonly string value;

        #endregion


        #region Properties

        public CsvTokenType TokenType
        {
            get
            {
                return this.tokenType;
            }
        }

        public string Value
        {
            get
            {
                return this.value;
            }
        }

        #endregion


        #region Constructors

        public CsvToken(CsvTokenType tokenType, string value)
        {
            Guard.ThrowExceptionIfNullOrEmpty(value, "value");

            this.tokenType = tokenType;
            this.value = value;
        }

        #endregion
    }
}