﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders
{
    /// <summary>
    /// Represents unsupported file format exception.
    /// </summary>
    public class UnsupportedFileFormatException : LocalizableException
    {
        private readonly string message;

        /// <summary>
        /// Provides COM objects with version-independent access to the <see cref="P:System.Exception.Message" />
        /// property.
        /// </summary>
        /// <value>The error message that explains the reason for the exception, or an
        /// empty string("").</value>
        public override string Message
        {
            get
            {
                return this.message;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="UnsupportedFileFormatException" /> class.
        /// </summary>
        /// <param name="extension">The extension.</param>
        public UnsupportedFileFormatException(string extension) 
            : base(string.Format("File format \"{0}\" is not supported.", extension),
            "Spreadsheet_ErrorExpressions_FormatNotSupported",
            new string[] {extension})
        {
            this.message = string.Format("File format \"{0}\" is not supported.", extension);
        }
    }
}