﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Telerik.Windows.Documents.Spreadsheet.Formatting.FormatStrings.Builders
{
    /// <summary>
    /// Represents the number format string builder class.
    /// </summary>
    public static class NumberFormatStringBuilder
    {
        #region Public Methods

        /// <summary>
        /// Builds the format strings.
        /// </summary>
        /// <param name="decimalPlaces">The decimal places.</param>
        /// <param name="useThousandSeparator">The use thousand separator.</param>
        /// <returns></returns>
        public static List<string> BuildFormatStrings(int decimalPlaces, bool useThousandSeparator)
        {
            return BuildersHelper.GetCurrencyStringsForCurrentCulture(FormatHelper.DefaultSpreadsheetCulture.CultureInfo,
                   string.Empty, decimalPlaces, useThousandSeparator);
        }

        #endregion
    }
}