﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Formatting.FormatStrings
{
    /// <summary>
    /// Represents the cell value format result item.
    /// </summary>
    public class CellValueFormatResultItem
    {
        #region Fields

        private readonly string text;
        private readonly bool isTransparent;
        private readonly bool shouldExpand;
        private readonly bool applyFormat;

        #endregion


        #region Properties

        /// <summary>
        /// Gets the text.
        /// </summary>
        /// <value>The text.</value>
        public string Text 
        {
            get 
            {
                return this.text;
            }
        }

        /// <summary>
        /// Gets the is transparent.
        /// </summary>
        /// <value>The is transparent.</value>
        public bool IsTransparent
        {
            get 
            {
                return this.isTransparent;
            }
        }

        /// <summary>
        /// Gets the should expand.
        /// </summary>
        /// <value>The should expand.</value>
        public bool ShouldExpand
        {
            get 
            {
                return this.shouldExpand;
            }
        }

        /// <summary>
        /// Gets the apply format.
        /// </summary>
        /// <value>The apply format.</value>
        public bool ApplyFormat
        {
            get
            {
                return this.applyFormat;
            }
        }

        #endregion


        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="CellValueFormatResultItem" /> class.
        /// </summary>
        /// <param name="text">The text.</param>
        /// <param name="isTransparent">The is transparent.</param>
        /// <param name="shouldExpand">The should expand.</param>
        /// <param name="applyFormat">The apply format.</param>
        public CellValueFormatResultItem(string text, bool isTransparent, bool shouldExpand, bool applyFormat)
        {
            this.text = text;
            this.isTransparent = isTransparent;
            this.shouldExpand = shouldExpand;
            this.applyFormat = applyFormat;
        }

        #endregion
    }
}