﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Telerik.Windows.Documents.Spreadsheet.Formatting.FormatStrings
{
    internal class FormatDescriptorItemComposite : FormatDescriptorItem
    {
        #region Fields

        private readonly Func<double?, string, IEnumerable<FormatDescriptorItem>> getCompositeItems;
        private readonly string startSequence;

        #endregion


        #region Constructors

        public FormatDescriptorItemComposite(Func<double?, string, IEnumerable<FormatDescriptorItem>> getItems, string startSequence)
            : base(string.Empty, false)
        {
            this.getCompositeItems = getItems;
            this.startSequence = startSequence;
        }

        #endregion


        #region Methods

        public override IEnumerable<FormatDescriptorItem> GetItems(double? doubleValue)
        {
            return this.getCompositeItems(doubleValue, this.startSequence);
        }

        #endregion
    }
}
