﻿namespace Telerik.Windows.Documents.Spreadsheet.Formatting.FormatStrings
{
    /// <summary>
    /// Represents the format string category.
    /// </summary>
    public enum FormatStringCategory
    {
        /// <summary>
        /// General format string category.
        /// </summary>
        General,

        /// <summary>
        /// Number format string category.
        /// </summary>
        Number,

        /// <summary>
        /// Currency format string category.
        /// </summary>
        Currency,

        /// <summary>
        /// Accounting format string category.
        /// </summary>
        Accounting,

        /// <summary>
        /// Date format string category.
        /// </summary>
        Date,

        /// <summary>
        /// Time format string category.
        /// </summary>
        Time,

        /// <summary>
        /// Percentage format string category.
        /// </summary>
        Percentage,

        /// <summary>
        /// Fraction format string category.
        /// </summary>
        Fraction,

        /// <summary>
        /// Scientific format string category.
        /// </summary>
        Scientific,

        /// <summary>
        /// Text format string category.
        /// </summary>
        Text,

        /// <summary>
        /// Special format string category.
        /// </summary>
        Special,

        /// <summary>
        /// Custom format string category.
        /// </summary>
        Custom
    }
}