﻿namespace Telerik.Windows.Documents.Spreadsheet.Formatting.FormatStrings
{
    /// <summary>
    /// Represents the format string info class.
    /// </summary>
    public class FormatStringInfo
    {
        // REFAC: These properties should be readonly.
        
        /// <summary>
        /// Gets or sets the type of the format.
        /// </summary>
        /// <value>The type of the format.</value>
        public FormatStringType? FormatType { get; internal set; }

        /// <summary>
        /// Gets or sets the category.
        /// </summary>
        /// <value>The category.</value>
        public FormatStringCategory Category { get; internal set; }

        internal bool HasDateChars { get; set; }
        internal bool HasTimeChars { get; set; }

        internal FormatStringInfo(FormatStringType? formatType, FormatStringCategory category, bool hasDateChars, bool hasTimeChars)
        {
            this.FormatType = formatType;
            this.HasDateChars = hasDateChars;
            this.HasTimeChars = hasTimeChars;
            this.Category = category;
        }
    }
}