﻿using System;
using System.Collections.Generic;
using System.Globalization;

namespace Telerik.Windows.Documents.Spreadsheet.Formatting.FormatStrings
{
    internal static class LocaleCodeToCultureInfoResolver
    {
        #region Fields

        private static readonly Dictionary<string, CultureInfo> keyToCultureInfo;

        #endregion


        #region Properties

        public static Dictionary<string, CultureInfo> LocaleCodeToCultureInfo
        {
            get
            {
                return keyToCultureInfo;
            }
        }

        #endregion


        #region Constructors

        static LocaleCodeToCultureInfoResolver()
        {
            keyToCultureInfo = new Dictionary<string, CultureInfo>();
            AddCulture("$-409", "en-US");
            AddCulture("$-436", "af");
            AddCulture("$-10484", "gsw");
            AddCulture("$-1045E", "am");
            AddCulture("$-2010000", "ar-DZ");
            AddCulture("$-2170000", "ar-SA");
            AddCulture("$-42B", "hy");
            AddCulture("$-1044D", "as");
            AddCulture("$-82C", "az-Cyrl");
            AddCulture("$-42C", "az-Latn");
            AddCulture("$-1046D", "ba");
            AddCulture("$-42D", "eu");
            AddCulture("$-FC23", "be");
            AddCulture("$-845", "bn-BD");
            AddCulture("$-445", "bn-IN");
            AddCulture("$-1201A", "bs-Cyrl");
            AddCulture("$-1141A", "bs-Latn");
            AddCulture("$-1047E", "br");
            AddCulture("$-402", "bg");
            AddCulture("$-403", "ca");
            AddCulture("$-C04", "zh-HK");
            AddCulture("$-1404", "zh-MO");
            AddCulture("$-804", "zh-CN");
            AddCulture("$-1004", "zh-SG");
            AddCulture("$-404", "zh-TW");
            AddCulture("$-10483", "co");
            AddCulture("$-1101A", "hr-BA");
            AddCulture("$-41A", "hr-HR");
            AddCulture("$-405", "cs");
            AddCulture("$-406", "da");
            AddCulture("$-6048C", "prs-AF");
            AddCulture("$-1060465", "dv");
            AddCulture("$-813", "nl-BE");
            AddCulture("$-413", "nl-NL");
            AddCulture("$-C09", "en-AU");
            AddCulture("$-2809", "en-BZ");
            AddCulture("$-1009", "en-CA");
            AddCulture("$-2409", "en-029");
            AddCulture("$-14009", "en-IN");
            AddCulture("$-1809", "en-IE");
            AddCulture("$-2009", "en-JM");
            AddCulture("$-14409", "en-MY");
            AddCulture("$-1409", "en-NZ");
            AddCulture("$-3409", "en-PH");
            AddCulture("$-14809", "en-SG");
            AddCulture("$-1C09", "en-ZA");
            AddCulture("$-2C09", "en-TT");
            AddCulture("$-809", "en-GB");
            AddCulture("$-3009", "en-ZW");
            AddCulture("$-425", "et");
            AddCulture("$-438", "fo");
            AddCulture("$-10464", "fil");
            AddCulture("$-40B", "fi");
            AddCulture("$-80C", "fr-BE");
            AddCulture("$-C0C", "fr-CA");
            AddCulture("$-40C", "fr-FR");
            AddCulture("$-140C", "fr-LU");
            AddCulture("$-180C", "fr-MC");
            AddCulture("$-100C", "fr-CH");
            AddCulture("$-10462", "fy");
            AddCulture("$-456", "gl");
            AddCulture("$-437", "ka");
            AddCulture("$-C07", "de-AT");
            AddCulture("$-407", "de-DE");
            AddCulture("$-1407", "de-LI");
            AddCulture("$-1007", "de-LU");
            AddCulture("$-807", "de-CH");
            AddCulture("$-408", "el");
            AddCulture("$-1046F", "kl");
            AddCulture("$-447", "gu");
            AddCulture("$-10468", "ha");
            AddCulture("$-101040D", "he");
            AddCulture("$-1010439", "hi");
            AddCulture("$-4010000", "hi");
            AddCulture("$-4010439", "hi");
            AddCulture("$-1010409", "hi");
            AddCulture("$-40E", "hu");
            AddCulture("$-40F", "is");
            AddCulture("$-10470", "ig");
            AddCulture("$-421", "id");
            AddCulture("$-1085D", "iu-Latn");
            AddCulture("$-1045D", "iu-Cans");
            AddCulture("$-1083C", "ga");
            AddCulture("$-10434", "xh");
            AddCulture("$-10435", "zu");
            AddCulture("$-410", "it-IT");
            AddCulture("$-810", "it-CH");
            AddCulture("$-411", "ja");
            AddCulture("$-44B", "kn");
            AddCulture("$-43F", "kk");
            AddCulture("$-10453", "km");
            AddCulture("$-10486", "qut");
            AddCulture("$-10487", "rw");
            AddCulture("$-457", "kok");
            AddCulture("$-412", "ko");
            AddCulture("$-440", "ky");
            AddCulture("$-10454", "lo");
            AddCulture("$-426", "lv");
            AddCulture("$-427", "lt");
            AddCulture("$-1082E", "dsb");
            AddCulture("$-1046E", "lb");
            AddCulture("$-42F", "mk");
            AddCulture("$-83E", "ms-BN");
            AddCulture("$-43E", "ms-MY");
            AddCulture("$-44C", "ml");
            AddCulture("$-C00044C", "ml");
            AddCulture("$-1043A", "mt");
            AddCulture("$-10481", "mi");
            AddCulture("$-1047A", "arn");
            AddCulture("$-44E", "mr");
            AddCulture("$-1047C", "moh");
            AddCulture("$-450", "mn-Cyrl");
            AddCulture("$-10850", "mn-Mong-CN");
            AddCulture("$-10461", "ne");
            AddCulture("$-414", "nb");
            AddCulture("$-814", "nn");
            AddCulture("$-10482", "oc");
            AddCulture("$-10448", "or");
            AddCulture("$-60463", "ps");
            AddCulture("$-30C0000", "fa");
            AddCulture("$-10C0000", "fa");
            AddCulture("$-415", "pl");
            AddCulture("$-416", "pt-BR");
            AddCulture("$-816", "pt-PT");
            AddCulture("$-6000446", "pa");
            AddCulture("$-446", "pa");
            AddCulture("$-1046B", "quz-BO");
            AddCulture("$-1086B", "quz-EC");
            AddCulture("$-10C6B", "quz-PE");
            AddCulture("$-418", "ro");
            AddCulture("$-10417", "rm");
            AddCulture("$-419", "ru");
            AddCulture("$-FC19", "ru");
            AddCulture("$-10485", "sah-RU");
            AddCulture("$-1243B", "smn-FI");
            AddCulture("$-1103B", "smj-NO");
            AddCulture("$-1143B", "smj-SE");
            AddCulture("$-10C3B", "se-FI");
            AddCulture("$-1043B", "se-NO");
            AddCulture("$-1083B", "se-SE");
            AddCulture("$-1203B", "sms-FI");
            AddCulture("$-1183B", "sma-NO");
            AddCulture("$-11C3B", "sma-SE");
            AddCulture("$-44F", "sa");
            AddCulture("$-10491", "gd-GB");
            AddCulture("$-1C1A", "sr-Cyrl-BA");
            AddCulture("$-C1A", "sr-Cyrl-ME");
            AddCulture("$-1181A", "sr-Latn-BA");
            AddCulture("$-81A", "sr-Latn-ME");
            AddCulture("$-1046C", "nso");
            AddCulture("$-10432", "tn");
            AddCulture("$-1045B", "si");
            AddCulture("$-41B", "sk");
            AddCulture("$-424", "sl");
            AddCulture("$-2C0A", "es-AR");
            AddCulture("$-400A", "es-BO");
            AddCulture("$-340A", "es-CL");
            AddCulture("$-240A", "es-CO");
            AddCulture("$-140A", "es-CR");
            AddCulture("$-1C0A", "es-DO");
            AddCulture("$-300A", "es-EC");
            AddCulture("$-440A", "es-SV");
            AddCulture("$-100A", "es-GT");
            AddCulture("$-480A", "es-HN");
            AddCulture("$-80A", "es-MX");
            AddCulture("$-4C0A", "es-NI");
            AddCulture("$-180A", "es-PA");
            AddCulture("$-3C0A", "es-PY");
            AddCulture("$-280A", "es-PE");
            AddCulture("$-500A", "es-PR");
            AddCulture("$-40A", "es-ES_tradnl");
            AddCulture("$-1540A", "es-US");
            AddCulture("$-380A", "es-UY");
            AddCulture("$-200A", "es-VE");
            AddCulture("$-441", "sw");
            AddCulture("$-81D", "sv-FI");
            AddCulture("$-41D", "sv-SE");
            AddCulture("$-45A", "syr");
            AddCulture("$-10428", "tg");
            AddCulture("$-1085F", "tzm-Latn-DZ");
            AddCulture("$-9000449", "ta");
            AddCulture("$-449", "ta");
            AddCulture("$-444", "tt");
            AddCulture("$-A00044A", "te");
            AddCulture("$-44A", "te");
            AddCulture("$-107041E", "th");
            AddCulture("$-D07041E", "th");
            AddCulture("$-D070000", "th");
            AddCulture("$-1070000", "th");
            AddCulture("$-1070409", "th");
            AddCulture("$-10451", "bo-CN");
            AddCulture("$-41F", "tr");
            AddCulture("$-10442", "tk");
            AddCulture("$-FC22", "uk");
            AddCulture("$-1042E", "hsb");
            AddCulture("$-420", "ur");
            AddCulture("$-10480", "ug");
            AddCulture("$-843", "uz-Cyrl");
            AddCulture("$-443", "uz-Latn");
            AddCulture("$-101040C", "vi");
            AddCulture("$-101042A", "vi");
            AddCulture("$-10452", "cy");
            AddCulture("$-10488", "wo");
            AddCulture("$-10478", "ii-CN");
            AddCulture("$-1046A", "yo");
        }

        #endregion


        #region Methods

        public static CultureInfo GetCulture(string key)
        {
            CultureInfo info;
            if (keyToCultureInfo.TryGetValue(key, out info))
            {
                return info;
            }

            return null;
        }

        public static CultureInfo GetCultureOrDefault(string key)
        {
            CultureInfo info;
            if (keyToCultureInfo.TryGetValue(key, out info))
            {
                return info;
            }

            return new CultureInfo("en-US");
        }

        private static void AddCulture(string key, string cultureCode)
        {
            try
            {
                keyToCultureInfo.Add(key, new CultureInfo(cultureCode));
            }
            catch (CultureNotFoundException)
            { }
        }

        #endregion
    }
}
