﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Formatting.FormatStrings
{
    /// <summary>
    /// Represents the special format info.
    /// </summary>
    public class SpecialFormatInfo
    {
        #region Fields

        private readonly string name;
        private readonly string formatString;

        #endregion


        #region Properties

        /// <summary>
        /// Gets the name.
        /// </summary>
        /// <value>The name.</value>
        public string Name
        {
            get
            {
                return this.name;
            }
        }

        /// <summary>
        /// Gets the format string.
        /// </summary>
        /// <value>The format string.</value>
        public string FormatString
        {
            get
            {
                return this.formatString;
            }
        }

        #endregion


        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="SpecialFormatInfo" /> class.
        /// </summary>
        /// <param name="name">The name.</param>
        /// <param name="formatString">The format string.</param>
        public SpecialFormatInfo(string name, string formatString)
        {
            Guard.ThrowExceptionIfNullOrEmpty(name, "name");
            Guard.ThrowExceptionIfNullOrEmpty(formatString, "formatString");

            this.name = name;
            this.formatString = formatString;
        }

        #endregion
    }
}