﻿using System;
using System.Collections.Generic;

namespace Telerik.Windows.Documents.Spreadsheet.History
{
	internal class WorkbookChangesCollection
	{
		#region Fields

		private readonly Stack<Tuple<int, Stack<WorkbookChange>>> cahngesLevels;

        #endregion


        #region Properties

        public bool IsEmpty
        {
            get
            {
                return this.cahngesLevels.Count == 0;
            }
        }

        #endregion


        #region Constructors

		public WorkbookChangesCollection()
        {
			this.cahngesLevels = new Stack<Tuple<int, Stack<WorkbookChange>>>();
        }

        #endregion


        #region Methdos

		public void Add(int undoGroupLevel, WorkbookChange change)
        {
            // If this is a new undo group level.
            if (this.IsEmpty || this.cahngesLevels.Peek().Item1 < undoGroupLevel)
            {
				this.cahngesLevels.Push(new Tuple<int, Stack<WorkbookChange>>(undoGroupLevel, new Stack<WorkbookChange>()));
            }

            this.cahngesLevels.Peek().Item2.Push(change);
        }

		public IEnumerable<WorkbookChange> PopChangesFromUndoGroupLevel(int undoGroupLevel)
        {
			List<WorkbookChange> result = new List<WorkbookChange>();
            while (!this.IsEmpty && this.cahngesLevels.Peek().Item1 >= undoGroupLevel)
            {
                result.AddRange(this.cahngesLevels.Pop().Item2);
            }

            // The changes should be in reversed order by their add.
            result.Reverse();

            return result;
        }

        #endregion
	}
}