﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.History
{
    /// <summary>
    /// Arguments for the events raised when the workbook history is changed.
    /// </summary>
    public class WorkbookHistoryEventArgs : EventArgs
    {
		#region Properties

        /// <summary>
        /// Gets the history action.
        /// </summary>
        /// <value>The history action.</value>
        public WorkbookHistoryAction HistoryAction { get; private set; }

        #endregion


        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="WorkbookHistoryEventArgs" /> class.
        /// </summary>
        /// <param name="historyAction">The history action.</param>
        public WorkbookHistoryEventArgs(WorkbookHistoryAction historyAction)
        {
            Guard.ThrowExceptionIfNull(historyAction, "historyAction");
            this.HistoryAction = historyAction;
        }

        #endregion
	}
}