﻿namespace Telerik.Windows.Documents.Spreadsheet.History
{
    /// <summary>
    /// Arguments for the RecordExecuted event.
    /// </summary>
    public class WorkbookHistoryRecordExecutedEventArgs : WorkbookHistoryEventArgs
    {
		#region Properties

        /// <summary>
        /// Gets or sets the record is merged.
        /// </summary>
        /// <value>The merged state.</value>
        public bool IsMerged { get; private set; }

        #endregion


        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="WorkbookHistoryRecordExecutedEventArgs" /> class.
        /// </summary>
        /// <param name="historyAction">The history action.</param>
        /// <param name="isMerged">This parameter is not used and is reserved for future use.</param>
        public WorkbookHistoryRecordExecutedEventArgs(WorkbookHistoryAction historyAction, bool isMerged) 
            : base(historyAction)
        {
            this.IsMerged = isMerged;
        }

        #endregion
	}
}