﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Telerik.Windows.Documents.Spreadsheet.Layout.Layers
{
    internal abstract class ColumnBasedLayerBase : BoxBasedLayerBase<ColumnLayoutBox>
    {
        protected override IEnumerable<ColumnLayoutBox> GetVisibleBoxes(ViewportPaneType viewportPaneType, WorksheetRenderUpdateContext updateContext)
        {
            return ColumnBasedLayerBase.GetVisibleBoxesInternal(viewportPaneType, updateContext);
        }

        internal static IEnumerable<ColumnLayoutBox> GetVisibleBoxesInternal(ViewportPaneType viewportPaneType, WorksheetRenderUpdateContext updateContext)
        {
            var viewportPane = updateContext.SheetViewport[viewportPaneType];
            var cellRange = viewportPane.VisibleRange;

            if (viewportPane.IsEmpty)
            {
                return Enumerable.Empty<ColumnLayoutBox>();
            }

            return updateContext.VisibleColumnBoxes.Where(x =>
                x.ColumnIndex >= cellRange.FromIndex.ColumnIndex &&
                x.ColumnIndex <= cellRange.ToIndex.ColumnIndex);
        }
    }
}
