﻿using System;
using System.Collections.Generic;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;
#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Spreadsheet.Theming;
#else
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Spreadsheet.Layout.Layers
{
    internal class PatternFillRenderable : IRenderable
    {
        private readonly List<Rect> visibleBoxes;

        public PatternFillRenderable()
        {
            this.visibleBoxes = new List<Rect>();
        }

        public PatternFill PatternFill { get; set; }
        public ThemeColorScheme ColorScheme { get; set; }

        public IEnumerable<Rect> VisibleBoxes
        {
            get
            {
                return this.visibleBoxes;
            }
        }

        public void AddVisibleBox(Rect rectangle)
        {
            this.visibleBoxes.Add(rectangle);
        }

        public void AddVisibleBoxes(IEnumerable<Rect> rectangles)
        {
            this.visibleBoxes.AddRange(rectangles);
        }

        public void ClearVisibleBoxes()
        {
            this.visibleBoxes.Clear();
        }

        public override string ToString()
        {
            System.Text.StringBuilder builder = new System.Text.StringBuilder();
            foreach (Rect box in this.VisibleBoxes)
            {
                builder.AppendLine();
                builder.AppendFormat("({0})", box);
            }

            return String.Format("PatternFillRenderable: PatternType={0}, VisibleBoxes:{1}", this.PatternFill.PatternType, builder);
        }
    }
}
