﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Layout.Layers
{
    internal abstract class PrintWorksheetLayerBase : LayerBase
    {
        protected override sealed void UpdateRenderOverride(RenderUpdateContext updateContext)
        {
            this.UpdateRenderOverride(updateContext as PrintWorksheetRenderUpdateContext);
        }

        protected override sealed void TranslateAndScale(RenderUpdateContext updateContext)
        {
            this.TranslateAndScale(updateContext as PrintWorksheetRenderUpdateContext);
        }

        protected virtual void UpdateRenderOverride(PrintWorksheetRenderUpdateContext worksheetUpdateContext)
        {
            Guard.ThrowExceptionIfNull(worksheetUpdateContext, "worksheetUpdateContext");
        }

        protected virtual void TranslateAndScale(PrintWorksheetRenderUpdateContext worksheetUpdateContext)
        {
            Guard.ThrowExceptionIfNull(worksheetUpdateContext, "worksheetUpdateContext");
        }
    }
}
