﻿using System;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Layout.Layers
{
    internal class PrintWorksheetRenderUpdateContext : WorksheetRenderUpdateContext
    {
        private readonly HeaderFooterRenderContext headerFooterContext;

        internal PrintWorksheetRenderUpdateContext(RadWorksheetLayout worksheetLayout, SheetViewport sheetViewport, Size scaleFactor, HeaderFooterRenderContext headerFooterContext)
            : base(worksheetLayout, sheetViewport, scaleFactor)
        {
            Guard.ThrowExceptionIfNull(headerFooterContext, "headerFooterContext");

            this.headerFooterContext = headerFooterContext;
        }

        public HeaderFooterRenderContext HeaderFooterContext
        {
            get
            {
                return this.headerFooterContext;
            }
        }
    }
}
