﻿using System;
using System.Windows.Media;
using Telerik.Windows.Documents.Spreadsheet.Measurement;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Layout.Layers
{
    internal static class RenderHelper
    {
        private static readonly FontFamily SpaceFont = new FontFamily("Arial");
        private static readonly double SpaceFactor;
        private static readonly string SpaceChar = "+";

        static RenderHelper()
        {
            double measureFontSize = 100;
            var info = RadTextMeasurer.Measure(RenderHelper.SpaceChar, new FontProperties(RenderHelper.SpaceFont, measureFontSize, false));

            RenderHelper.SpaceFactor = measureFontSize / info.Size.Width;
        }

        public static RunRenderable CreateSpaceRun(double gapWidth)
        {
            RunRenderable run = new RunRenderable();

            run.Text = RenderHelper.SpaceChar;
            run.FontFamily = RenderHelper.SpaceFont;
            run.FontSize = gapWidth * RenderHelper.SpaceFactor;
            run.Foreground = new SolidColorBrush(Colors.Transparent);

            return run;
        }
    }
}
