﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Telerik.Windows.Documents.Spreadsheet.Layout.Layers
{
    internal abstract class RowBasedLayerBase : BoxBasedLayerBase<RowLayoutBox>
    {
        protected override IEnumerable<RowLayoutBox> GetVisibleBoxes(ViewportPaneType viewportPaneType, WorksheetRenderUpdateContext updateContext)
        {
            return RowBasedLayerBase.GetVisibleBoxesInternal(viewportPaneType, updateContext);
        }

        internal static IEnumerable<RowLayoutBox> GetVisibleBoxesInternal(ViewportPaneType viewportPaneType, WorksheetRenderUpdateContext updateContext)
        {
            var viewportPane = updateContext.SheetViewport[viewportPaneType];
            var cellRange = viewportPane.VisibleRange;

            if (viewportPane.IsEmpty)
            {
                return Enumerable.Empty<RowLayoutBox>();
            }

            return updateContext.VisibleRowBoxes.Where(x =>
                x.RowIndex >= cellRange.FromIndex.RowIndex &&
                x.RowIndex <= cellRange.ToIndex.RowIndex);
        }
    }
}
