﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;

namespace Telerik.Windows.Documents.Spreadsheet.Layout.Layers
{
    internal class ShapeSourceFactory
    {
        private readonly IShapeSourceFactory<FloatingImage> imageSourceCache;
#if !SILVERLIGHT
        private readonly IShapeSourceFactory<FloatingChartShape> chartSourceCache;
#endif

#if !SILVERLIGHT
        public ShapeSourceFactory(IShapeSourceFactory<FloatingImage> imageSourceCache, IShapeSourceFactory<FloatingChartShape> chartSourceCache)
        {
            this.imageSourceCache = imageSourceCache;
            this.chartSourceCache = chartSourceCache;
        }
#else
        public ShapeSourceFactory(IShapeSourceFactory<FloatingImage> imageSourceCache)
        {
            this.imageSourceCache = imageSourceCache;
        }
#endif

        public IShapeSource GetImageSource(FloatingImage image)
        {
            return this.imageSourceCache.GetShapeSource(image);
        }

#if !SILVERLIGHT
        public IShapeSource GetChartSource(FloatingChartShape chart)
        {
            return this.chartSourceCache.GetShapeSource(chart);
        }
#endif
    }
}
