﻿using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Layout.Layers
{
    internal abstract class WorksheetLayerBase : LayerBase
    {
        protected override sealed void UpdateRenderOverride(RenderUpdateContext updateContext)
        {
            this.UpdateRenderOverride(updateContext as WorksheetRenderUpdateContext);
        }

        protected override sealed void TranslateAndScale(RenderUpdateContext updateContext)
        {
            this.TranslateAndScale(updateContext as WorksheetRenderUpdateContext);
        }

        protected virtual void UpdateRenderOverride(WorksheetRenderUpdateContext worksheetUpdateContext)
        {
            Guard.ThrowExceptionIfNull(worksheetUpdateContext, "worksheetUpdateContext");
        }

        protected virtual void TranslateAndScale(WorksheetRenderUpdateContext worksheetUpdateContext)
        {
            Guard.ThrowExceptionIfNull(worksheetUpdateContext, "worksheetUpdateContext");
        }
    }
}
