namespace Telerik.Windows.Documents.Spreadsheet.Maths
{
    /// <summary>
    /// Enumeration of supported area units.
    /// </summary>
    internal enum AreaUnit
    {
        /// <summary>
        /// International acre "uk_acre" 
        /// </summary>
        InternationalAcre,
        /// <summary>
        /// U.S. survey/statute acre "us_acre" 
        /// </summary>
        USSurveyAcre,
        /// <summary>
        /// Square angstrom "ang2" or ang^2" 
        /// </summary>
        SquareAngstrom,
        /// <summary>
        /// Are "ar" 
        /// </summary>
        Are,
        /// <summary>
        /// Square feet "ft2" or "ft^2" 
        /// </summary>
        SquareFeet,
        /// <summary>
        /// Hectare "ha" 
        /// </summary>
        Hectare,
        /// <summary>
        /// Square inches "in2" or "in^2" 
        /// </summary>
        SquareInches,
        /// <summary>
        /// Square light-year "ly2" or "ly^2" 
        /// </summary>
        SquareLightYear,
        /// <summary>
        /// Square meters "m2" or "m^2" 
        /// </summary>
        SquareMeters,
        /// <summary>
        /// Morgen "Morgen" 
        /// </summary>
        Morgen,
        /// <summary>
        /// Square miles "mi2" or "mi^2" 
        /// </summary>
        SquareMiles,
        /// <summary>
        /// Square nautical miles "Nmi2" or "Nmi^2" 
        /// </summary>
        SquareNauticalMiles,
        /// <summary>
        /// Square Pica "Picapt2", "Pica2", "Pica^2" or "Picapt^2" 
        /// </summary>
        SquarePica,
        /// <summary>
        /// Square yards "yd2" or "yd^2" 
        /// </summary>
        SquareYards
    }
}