namespace Telerik.Windows.Documents.Spreadsheet.Maths
{
    /// <summary>
    /// Enumeration of supported distance units.
    /// </summary>
    internal enum DistanceUnit
    {
        /// <summary>
        /// 	"m"
        /// </summary>
        Meter,
        /// <summary>
        /// "mi"
        /// </summary>
        StatuteMile,
        /// <summary>
        /// "Nmi"
        /// </summary>
        NauticalMile,
        /// <summary>
        /// "in"
        /// </summary>
        Inch,
        /// <summary>
        /// "ft"
        /// </summary>
        Foot,
        /// <summary>
        /// "yd"
        /// </summary>
        Yard,
        /// <summary>
        /// "ang"
        /// </summary>
        Angstrom,
        /// <summary>
        /// "ell"
        /// </summary>
        Ell,
        /// <summary>
        /// "ly"
        /// </summary>
        LightYear,
        /// <summary>
        /// "parsec" or "pc"
        /// </summary>
        Parsec,
        /// <summary>
        /// (1/72 inch)	"Picapt" or "Pica"
        /// </summary>
        Pica72,
        /// <summary>
        /// (1/6 inch)	"pica"
        /// </summary>
        Pica6,
        ///
        ///U.S survey mile (statute mile)	 "survey_mi"
        ///  
        SurveyMile
    }
}