namespace Telerik.Windows.Documents.Spreadsheet.Maths
{
    /// <summary>
    /// Enumeration of supported energy units.
    /// </summary>
    internal enum EnergyUnit
    {
        /// <summary>
        /// Joule "J"
        /// </summary>
        Joule,
        /// <summary>
        /// Erg "e"
        /// </summary>
        Erg,
        /// <summary>
        /// Thermodynamic calorie "c"
        /// </summary>
        ThermodynamicCalorie,
        /// <summary>
        /// IT calorie "cal"
        /// </summary>
        ITCalorie,
        /// <summary>
        /// Electron volt "eV" or "ev"
        /// </summary>
        ElectronVolt,
        /// <summary>
        /// Horse power per hour "HPh" or "hh"
        /// </summary>
        HorsePowerPerHour,
        /// <summary>
        /// Watt per hour "Wh" or "wh"
        /// </summary>
        WattPerHour,
        /// <summary>
        /// Foot pound "flb"
        /// </summary>
        FootPound,
        /// <summary>
        /// British thermal unit "BTU" or "btu"
        /// </summary>
        BTU
    }
}