﻿namespace Telerik.Windows.Documents.Spreadsheet.Maths
{
    /// <summary>
    /// Enumeration of supported mass units.
    /// </summary>
    internal enum MassUnit
    {
        /// <summary>
        /// Gram "g".
        /// </summary>
        Gram,

        /// <summary>
        /// Slug "sg".
        /// </summary>
        Slug,

        /// <summary>
        /// Pound mass (avoirdupois) "lbm".
        /// </summary>
        Pound,

        /// <summary>
        /// Atomic mass unit "u".
        /// </summary>
        AtomicMassUnit,

        /// <summary>
        /// Ounce mass (avoirdupois) "ozm".
        /// </summary>
        Ounce,

        /// <summary>
        /// Grain 'grain".
        /// </summary>
        Grain,

        /// <summary>
        /// U.S. (short) undredweight "cwt" or "shweight".
        /// </summary>
        ShortWeight,

        /// <summary>
        /// Imperial hundredweight "uk_cwt" or "lcwt" or "hweight".
        /// </summary>
        ImperialWeight,

        /// <summary>
        /// Stone "stone".
        /// </summary>
        Stone,

        /// <summary>
        /// Ton "ton".
        /// </summary>
        Ton,

        /// <summary>
        /// Imperial ton "uk_ton" or "LTON" or "brton".
        /// </summary>
        ImperialTon
    }
}