namespace Telerik.Windows.Documents.Spreadsheet.Maths
{
    /// <summary>
    /// Enumeration of supported pressure units.
    /// </summary>
    internal enum PressureUnit
    {
        /// <summary>
        /// Pascal "pa" or "p"
        /// </summary>
        Pascal,
        /// <summary>
        /// Atmosphere "atm" or "at"
        /// </summary>
        Atmosphere,
        /// <summary>
        /// Millimeters or mercury "mmHg"
        /// </summary>
        Mercury,
        /// <summary>
        /// Pounds per square inch "psi"
        /// </summary>
        PSI,
        /// <summary>
        /// Torricelli unit "Torr"
        /// </summary>
        Torr
    }
}