namespace Telerik.Windows.Documents.Spreadsheet.Maths
{
    /// <summary>
    /// Enumeration of supported speed units.
    /// </summary>
    internal enum SpeedUnit
    {
        /// <summary>
        /// The admirality knot "admkn"
        /// </summary>
        AdmiralityKnot,
        /// <summary>
        /// The knot "kn"
        /// </summary>
        Knot,
        /// <summary>
        /// Meters per hour "m/h" or "m/hr"
        /// </summary>
        MetersPerHour,
        /// <summary>
        /// Meters per second "m/s" or "m/sec"
        /// </summary>
        MetersPerSecond,
        /// <summary>
        /// Miles per hour "mph"
        /// </summary>
        MilesPerHour
    }
}