﻿using Telerik.Windows.Documents.Spreadsheet.Expressions;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Represents the value of a cell which contains a true or false value.
    /// </summary>
    public class BooleanCellValue : CellValueBase<bool>, IExpressionAwareCellValue
    {
        #region Fields

        private RadExpression expression;

        #endregion


        #region Properties

        /// <summary>
        /// Gets the type of the value.
        /// </summary>
        /// <value>The type of the value.</value>
        public override CellValueType ValueType
        {
			get
			{
				return CellValueType.Boolean;
			}
		}

		#endregion


		#region Constructors

		internal BooleanCellValue(bool value)
			: base(value)
		{
		}

		#endregion


		#region Methods

        /// <summary>
        /// Gets the value as string override.
        /// </summary>
        /// <param name="format">The format.</param>
        /// <returns></returns>
        protected override string GetValueAsStringOverride(CellValueFormat format)
        {
			return this.Value.ToString().ToUpper();
		}

        RadExpression IExpressionAwareCellValue.GetCellExpressionOrNull()
        {
            if (this.expression == null)
            {
                this.expression = this.Value ? BooleanExpression.True : BooleanExpression.False;
            }

            return this.expression;
        }

        #endregion
    }
}