﻿namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Describes the types of cells.
    /// </summary>
    public enum CellValueType
    {
        /// <summary>
        /// Empty cell value type.
        /// </summary>
		Empty,

        /// <summary>
        /// Number cell value type.
        /// </summary>
		Number,

        /// <summary>
        /// Boolean cell value type.
        /// </summary>
		Boolean,

        /// <summary>
        /// Formula cell value type.
        /// </summary>
		Formula,

        /// <summary>
        /// Text cell value type.
        /// </summary>
		Text,

        /// <summary>
        /// RichText cell value type.
        /// </summary>
        RichText,

        /// <summary>
        /// Error cell value type.
        /// </summary>
        Error
	}
}