﻿namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Defines members for the cell value types.
    /// </summary>
    public interface ICellValue
    {
        /// <summary>
        /// Gets the raw value.
        /// </summary>
        /// <value>The raw value.</value>
        string RawValue { get; }

        /// <summary>
        /// Gets the type of the value.
        /// </summary>
        /// <value>The type of the value.</value>
        CellValueType ValueType { get; }

        /// <summary>
        /// Gets the type of the result value.
        /// </summary>
        /// <value>The type of the result value.</value>
        CellValueType ResultValueType { get; }

        /// <summary>
        /// Gets the value as string.
        /// </summary>
        /// <param name="format">The format.</param>
        /// <returns></returns>
        string GetValueAsString(CellValueFormat format);

        /// <summary>
        /// Gets the result value as string.
        /// </summary>
        /// <param name="format">The format.</param>
        /// <returns></returns>
        string GetResultValueAsString(CellValueFormat format);
    }
}