﻿using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Represents a column width value.
    /// </summary>
    public class ColumnWidth : WidthHeightBase
    {
        #region Properties

        internal bool IsAutoFit
        {
            get
            {
                return !this.IsCustom && this.Value != SpreadsheetDefaultValues.DefaultColumnWidth;
            }
        }

        #endregion


        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="ColumnWidth" /> class.
        /// </summary>
        /// <param name="value">The value.</param>
        /// <param name="isCustom">The is custom.</param>
        public ColumnWidth(double value, bool isCustom)
            : base(value, isCustom)
        {
            Guard.ThrowExceptionIfInvalidColumnWidth(value);
        }

        #endregion
    }
}