﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Spreadsheet.Model.DataValidation
{
    /// <summary>
    /// Represents a number data validation rule context.
    /// </summary>
    public class NumberDataValidationRuleContext : SingleArgumentDataValidationRuleContext
    {
        /// <summary>
        /// Gets or sets the comparison operator.
        /// </summary>
        /// <value>The comparison operator.</value>
        public ComparisonOperator ComparisonOperator { get; set; }

        /// <summary>
        /// Gets or sets the second argument.
        /// </summary>
        /// <value>The second argument.</value>
        public string Argument2 { get; set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="NumberDataValidationRuleContext" /> class.
        /// </summary>
        /// <param name="worksheet">The worksheet.</param>
        /// <param name="rowIndex">Index of the row.</param>
        /// <param name="columnIndex">Index of the column.</param>
        public NumberDataValidationRuleContext(Worksheet worksheet, int rowIndex, int columnIndex)
            : this(worksheet, new CellIndex(rowIndex, columnIndex))
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NumberDataValidationRuleContext" /> class.
        /// </summary>
        /// <param name="worksheet">The worksheet.</param>
        /// <param name="cellIndex">Index of the cell.</param>
        public NumberDataValidationRuleContext(Worksheet worksheet, CellIndex cellIndex)
            : base(worksheet, cellIndex)
        {
        }
    }
}