﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model.DataValidation
{
    /// <summary>
    /// Represents any data validation rule.
    /// </summary>
    public sealed class AnyValueDataValidationRule : DataValidationRuleBase
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AnyValueDataValidationRule" /> class.
        /// </summary>
        /// <param name="context">The context.</param>
        public AnyValueDataValidationRule(AnyValueDataValidationRuleContext context) 
            : base((DataValidationRuleContextBase)context)
        {
            Guard.ThrowExceptionIfNull(context, "context");
        }

        /// <summary>
        /// Evaluates the data validation rule.
        /// </summary>
        /// <param name="worksheet">The worksheet.</param>
        /// <param name="rowIndex">Index of the row.</param>
        /// <param name="columnIndex">Index of the column.</param>
        /// <param name="cellValue">The cell value.</param>
        /// <returns>Retrurns True if the rule is satisfied, else returns False.</returns>
        protected override bool EvaluateOverride(Worksheet worksheet, int rowIndex, int columnIndex, ICellValue cellValue)
        {
            return true;
        }
    }
}