﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Spreadsheet.Model.DataValidation
{
    /// <summary>
    /// Represents a whole number data validation rule.
    /// </summary>
    public sealed class WholeNumberDataValidationRule : NumberDataValidationRuleBase
    {
        /// <summary>
        /// Gets a value indicating if the rule requires whole numbers as a result of the expressions.
        /// </summary>
        /// <value>
        /// The value indicating if the rule requires whole numbers as a result of the expressions.
        /// </value>
        protected override bool RequireWholeNumbers
        {
            get
            {
                return true;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="WholeNumberDataValidationRule" /> class.
        /// </summary>
        /// <param name="context">The context.</param>
        public WholeNumberDataValidationRule(NumberDataValidationRuleContext context)
            : base(context)
        {
        }
    }
}