﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.PropertySystem;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Filtering
{
    /// <summary>
    /// Provides a base class for the filter classes which hide or show the cells based on the cell value.
    /// </summary>
    public abstract class CellValuesFilterBase : FilterBase<ICellValue>
    {
        /// <summary>
        /// Gets the property definition for the value which will be retrieved by the GetValue method.
        /// </summary>
        /// <value>The property definition.</value>
        protected override IPropertyDefinition<ICellValue> PropertyDefinition
        {
            get
            {
                return CellPropertyDefinitions.ValueProperty;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="CellValuesFilterBase" /> class.
        /// </summary>
        /// <param name="relativeColumnIndex">The relative index of the column.</param>
        protected CellValuesFilterBase(int relativeColumnIndex) : base(relativeColumnIndex)
        {
        }
    }
}