﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Filtering
{
    /// <summary>
    /// Defines the possible options for the grouping type of the DateGroupItem. 
    /// </summary>
    public enum DateTimeGroupingType
    {
        /// <summary>
        /// Year date time grouping type.
        /// </summary>
        Year,

        /// <summary>
        /// Month date time grouping type.
        /// </summary>
        Month,

        /// <summary>
        /// Day date time grouping type.
        /// </summary>
        Day,

        /// <summary>
        /// Hour date time grouping type.
        /// </summary>
        Hour,

        /// <summary>
        /// Minute date time grouping type.
        /// </summary>
        Minute,

        /// <summary>
        /// Second date time grouping type.
        /// </summary>
        Second
    }
}
