﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Filtering
{
    /// <summary>
    /// Defines the possible options for the type of the dynamic filter.
    /// </summary>
    public enum DynamicFilterType
    {
        /// <summary>
        /// None dynamic filter type.
        /// </summary>
        None,

        /// <summary>
        /// AboveAverage dynamic filter type.
        /// </summary>
		AboveAverage,

        /// <summary>
        /// BelowAverage dynamic filter type.
        /// </summary>
		BelowAverage,

        /// <summary>
        /// Tomorrow dynamic filter type.
        /// </summary>
		Tomorrow,

        /// <summary>
        /// Today dynamic filter type.
        /// </summary>
		Today,

        /// <summary>
        /// Yesterday dynamic filter type.
        /// </summary>
		Yesterday,

        /// <summary>
        /// NextWeek dynamic filter type.
        /// </summary>
		NextWeek,

        /// <summary>
        /// ThisWeek dynamic filter type.
        /// </summary>
		ThisWeek,

        /// <summary>
        /// LastWeek dynamic filter type.
        /// </summary>
		LastWeek,

        /// <summary>
        /// NextMonth dynamic filter type.
        /// </summary>
		NextMonth,

        /// <summary>
        /// ThisMonth dynamic filter type.
        /// </summary>
		ThisMonth,

        /// <summary>
        /// LastMonth dynamic filter type.
        /// </summary>
		LastMonth,

        /// <summary>
        /// NextQuarter dynamic filter type.
        /// </summary>
		NextQuarter,

        /// <summary>
        /// ThisQuarter dynamic filter type.
        /// </summary>
		ThisQuarter,

        /// <summary>
        /// LastQuarter dynamic filter type.
        /// </summary>
		LastQuarter,

        /// <summary>
        /// NextYear dynamic filter type.
        /// </summary>
		NextYear,

        /// <summary>
        /// ThisYear dynamic filter type.
        /// </summary>
		ThisYear,
        /// <summary>
        /// LastYear dynamic filter type.
        /// </summary>
		LastYear,

        /// <summary>
        /// YearToDate dynamic filter type.
        /// </summary>
		YearToDate,

        /// <summary>
        /// Quarter1 dynamic filter type.
        /// </summary>
		Quarter1,

        /// <summary>
        /// Quarter2 dynamic filter type.
        /// </summary>
		Quarter2,

        /// <summary>
        /// Quarter3 dynamic filter type.
        /// </summary>
		Quarter3,

        /// <summary>
        /// Quarter4 dynamic filter type.
        /// </summary>
		Quarter4,

        /// <summary>
        /// January dynamic filter type.
        /// </summary>
		January,

        /// <summary>
        /// February dynamic filter type.
        /// </summary>
		February,

        /// <summary>
        /// March dynamic filter type.
        /// </summary>
		March,

        /// <summary>
        /// April dynamic filter type.
        /// </summary>
		April,

        /// <summary>
        /// May dynamic filter type.
        /// </summary>
		May,

        /// <summary>
        /// June dynamic filter type.
        /// </summary>
		June,

        /// <summary>
        /// July dynamic filter type.
        /// </summary>
		July,

        /// <summary>
        /// August dynamic filter type.
        /// </summary>
		August,

        /// <summary>
        /// September dynamic filter type.
        /// </summary>
		September,

        /// <summary>
        /// October dynamic filter type.
        /// </summary>
		October,

        /// <summary>
        /// November dynamic filter type.
        /// </summary>
		November,

        /// <summary>
        /// December dynamic filter type.
        /// </summary>
        December
    }
}
