﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Filtering
{  
    /// <summary>
    /// Represents a filtering exception.
    /// </summary>
    public class FilteringException : LocalizableException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FilteringException" /> class.
        /// </summary>
        public FilteringException() 
            : base()
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="FilteringException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public FilteringException(string message) 
            : base(message)
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="FilteringException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="key">The key.</param>
        public FilteringException(string message, string key) 
            : base(message, key)
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="FilteringException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public FilteringException(string message, Exception innerException) 
            : base(message, innerException)
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="FilteringException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        /// <param name="key">The key.</param>
        public FilteringException(string message, Exception innerException, string key)
            : base(message, innerException, key)
        {
 		}
    }
}
