﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Contains properties related to the grouping functionality.
    /// </summary>
    public class GroupingProperties
    {
        /// <summary>
        /// Gets or sets value indicating whether the grouping summary row is placed below or above the group.
        /// </summary>
        /// <value>The summary row is below.</value>
        public bool SummaryRowIsBelow { get; set; }

        /// <summary>
        /// Gets or sets value indicating whether the grouping summary column is placed to the right or to the left of the group.
        /// </summary>
        /// <value>The summary column is to the right.</value>
        public bool SummaryColumnIsToRight { get; set; }

        internal GroupingProperties()
        {
            this.SummaryRowIsBelow = true;
            this.SummaryColumnIsToRight = true;
        }

        internal void CopyFrom(GroupingProperties fromGroupingProperties)
        {
            this.SummaryColumnIsToRight = fromGroupingProperties.SummaryColumnIsToRight;
            this.SummaryRowIsBelow = fromGroupingProperties.SummaryRowIsBelow;
        }
    }
}