﻿using System.Windows;
using System.Windows.Media;
#if NETCORE || NETSTANDARD
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Defines members for the FontProperties class.
    /// </summary>
    public interface IFontProperties
    {
        /// <summary>
        /// Gets the font family.
        /// </summary>
        /// <value>The font family.</value>
        FontFamily FontFamily { get; }

        /// <summary>
        /// Gets the size of the font.
        /// </summary>
        /// <value>The size of the font.</value>
        double FontSize { get; }

        /// <summary>
        /// Gets a value indicating whether the font is bold.
        /// </summary>
        /// <value>The value indicating whether the font is bold.</value>
        bool IsBold { get; }

        /// <summary>
        /// Gets a value indicating whether the font is italic.
        /// </summary>
        /// <value>The value indicating whether the font is italic.</value>
        bool IsItalic { get; }

        /// <summary>
        /// Gets the underline.
        /// </summary>
        /// <value>The underline.</value>
        UnderlineType Underline { get; }

        /// <summary>
        /// Gets the font color.
        /// </summary>
        /// <value>The font color.</value>
        ThemableColor ForeColor { get; }

        /// <summary>
        /// Gets the font weight.
        /// </summary>
        /// <value>The font weight.</value>
        FontWeight FontWeight { get; }

        /// <summary>
        /// Gets the font style.
        /// </summary>
        /// <value>The font style.</value>
        FontStyle FontStyle { get; }

        /// <summary>
        /// Gets a value indicating whether the text is monospaced.
        /// </summary>
        /// <value>The value indicating whether the text is monospaced.</value>
        bool IsMonospaced { get; }
    }
}
