﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Represents the sheet editor.
    /// </summary>
    public interface ISheetEditor
    {
        /// <summary>
        /// Gets or sets the sheet.
        /// </summary>
        /// <value>The sheet.</value>
        Sheet Sheet { get; set; }

        /// <summary>
        /// Occurs just before the sheet changing begins.
        /// </summary>
        event EventHandler PreviewSheetChanging;

        /// <summary>
        /// Occurs when the sheet is changing.
        /// </summary>
        event EventHandler SheetChanging;

        /// <summary>
        /// Occurs just before the sheet changing ends.
        /// </summary>
        event EventHandler PreviewSheetChanged;

        /// <summary>
        /// Occurs when the sheet is changed.
        /// </summary>
        event EventHandler SheetChanged;
    }
}