﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Arguments for the MergedCellRangesChanged event.
    /// </summary>
    public class MergedCellRangesChangedEventArgs : EventArgs
    {
		#region Fields

		private readonly CellRange cellRange;

		#endregion


		#region Properties

        /// <summary>
        /// Gets the cell range.
        /// </summary>
        /// <value>The cell range.</value>
        public CellRange CellRange
        {
			get
			{
				return this.cellRange;
			}
		}

		#endregion


		#region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="MergedCellRangesChangedEventArgs" /> class.
        /// </summary>
        /// <param name="cellRange">The cell range.</param>
        public MergedCellRangesChangedEventArgs(CellRange cellRange)
        {
			Guard.ThrowExceptionIfNull(cellRange, "cellRange");
			this.cellRange = cellRange;
		}

		#endregion
	}
}