﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Defines members for the spreadsheet names classes.
    /// </summary>
    public interface ISpreadsheetName
    {
        /// <summary>
        /// Gets the name.
        /// </summary>
        /// <value>The name.</value>
        string Name { get; }

        /// <summary>
        /// Gets the scope of the name.
        /// </summary>
        /// <value>The scope.</value>
        SpreadsheetNameCollectionScope Scope { get; }

        /// <summary>
        /// Gets the comment.
        /// </summary>
        /// <value>The comment.</value>
        string Comment { get; }

        /// <summary>
        /// Gets the string representation of the object the name refers to.
        /// </summary>
        /// <value>The string representation of the object the name refers to.</value>
        string RefersTo { get; }

        /// <summary>
        /// Gets the value.
        /// </summary>
        /// <value>The value.</value>
        string Value { get; }

        /// <summary>
        /// Gets the value indicating whether the name is visible to the user.
        /// </summary>
        /// <value>The value indicating whether the name is visible to the user.</value>
        bool IsVisible { get; }
    }
}
