﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Exception related to the spreadsheet names.
    /// </summary>
    public class SpreadsheetNameException : LocalizableException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SpreadsheetNameException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public SpreadsheetNameException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SpreadsheetNameException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="key">The key.</param>
        public SpreadsheetNameException(string message, string key)
            : base(message, key)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SpreadsheetNameException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public SpreadsheetNameException(string message, Exception innerException) 
            : base(message, innerException)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SpreadsheetNameException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        /// <param name="key">The key.</param>
        public SpreadsheetNameException(string message, Exception innerException, string key)
            : base(message, innerException, key)
        {
        }
    }
}
