﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Inheritor of System.Exception used when a string cannot be parsed as a CellValue.
    /// </summary>
    public class ParseException : LocalizableException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ParseException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public ParseException(string message) 
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ParseException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public ParseException(string message, Exception innerException) 
            : base(message, innerException)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ParseException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        /// <param name="key">The key.</param>
        /// <param name="formatStringArguments">The format string arguments.</param>
        public ParseException(string message, Exception innerException, string key, string[] formatStringArguments) : base(message, innerException, key, formatStringArguments)
        {
        }
    }
}
