﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Describes a paste result.
    /// </summary>
    public class PasteResult : CopyPasteResultBase
    {
        private readonly bool shouldDisableHistory;

        internal bool ShouldDisableHistory
        {
            get
            {
                return this.shouldDisableHistory;
            }
        }

        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="PasteResult" /> class.
        /// </summary>
        /// <param name="success">The success.</param>
        /// <param name="errorMessage">The error message.</param>
        public PasteResult(bool success, string errorMessage = "")
            : this(success, errorMessage, string.Empty)
        {
        }

        internal PasteResult(bool success, string errorMessage = "", string errorMessageLocalizationKey = "", bool shouldDisableHistory = false)
            :base(success, errorMessage, errorMessageLocalizationKey)
        {
            this.shouldDisableHistory = shouldDisableHistory;
        }

        #endregion
    }
}
