﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Describes the paste types.
    /// </summary>
    public enum PasteType
    {
        /// <summary>
        /// All paste type.
        /// </summary>
        All,

        /// <summary>
        /// Formulas paste type.
        /// </summary>
        Formulas,

        /// <summary>
        /// Values paste type.
        /// </summary>
        Values,

        /// <summary>
        /// Formats paste type.
        /// </summary>
        Formats,

        /// <summary>
        /// ColumnWidths paste type.
        /// </summary>
        ColumnWidths,

        /// <summary>
        /// FormulasAndNumberFormats paste type.
        /// </summary>
        FormulasAndNumberFormats,

        /// <summary>
        /// ValuesAndNumberFormats paste type.
        /// </summary>
        ValuesAndNumberFormats
    }
}