﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Printing
{
    /// <summary>
    /// Represents errors that occur during printing.
    /// </summary>
    public class PrintingException : LocalizableException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PrintingException" /> class.
        /// </summary>
        public PrintingException() 
            : base()
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="PrintingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public PrintingException(string message) 
            : base(message)
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="PrintingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="key">The key.</param>
        public PrintingException(string message, string key)
            : base(message, key)
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="PrintingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public PrintingException(string message, Exception innerException) 
            : base(message, innerException)
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="PrintingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        /// <param name="key">The key.</param>
        public PrintingException(string message, Exception innerException, string key)
            : base(message, innerException, key)
        {
 		}
    }
}