﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Printing
{
    /// <summary>
    /// Represents a base class for page setup.
    /// </summary>
    /// <typeparam name="T">The type of the T.</typeparam>
    public abstract class SheetPageSetup<T> : SheetPageSetupBase
        where T : SheetPrintOptionsBase
    {
        /// <summary>
        /// Gets the print options.
        /// </summary>
        /// <value>The print options.</value>
        public abstract T PrintOptions { get; }

        /// <summary>
        /// Initializes a new instance of the <see cref="SheetPageSetup{T}" /> class.
        /// </summary>
        /// <param name="sheet">The sheet.</param>
        protected SheetPageSetup(Sheet sheet) 
            : base(sheet)
        {
        }
    }
}