﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Protection
{
    /// <summary>
    /// Inheritor of System.Exception used when an ProtectionException needs to be thrown.
    /// </summary>
    public class ProtectionException : LocalizableException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProtectionException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public ProtectionException(string message) 
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ProtectionException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="key">The key.</param>
        public ProtectionException(string message, string key) 
            : base(message, key)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ProtectionException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public ProtectionException(string message, Exception innerException) 
            : base(message, innerException)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ProtectionException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        /// <param name="key">The key.</param>
        public ProtectionException(string message, Exception innerException, string key)
            : base(message, innerException, key)
        {
        }
    }
}
