﻿namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Describes the types of horizontal alignments.
    /// </summary>
    public enum RadHorizontalAlignment
    {
        /// <summary>
        /// General horizontal alignment.
        /// </summary>
		General,

        /// <summary>
        /// Left horizontal alignment.
        /// </summary>
		Left,

        /// <summary>
        /// Center horizontal alignment.
        /// </summary>
		Center,

        /// <summary>
        /// Right horizontal alignment.
        /// </summary>
		Right,

        /// <summary>
        /// Justify horizontal alignment.
        /// </summary>
		Justify,

        /// <summary>
        /// Fill horizontal alignment.
        /// </summary>
		Fill,

        /// <summary>
        /// CenterContinuous horizontal alignment.
        /// </summary>
		CenterContinuous,

        /// <summary>
        /// Distributed horizontal alignment.
        /// </summary>
		Distributed
	}
}