﻿using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// Represents a row height value.
    /// </summary>
    public class RowHeight : WidthHeightBase
    {
        #region Constants

        /// <summary>
        /// Represents a row height value containing the default row height for the RadSpreadsheet.
        /// </summary>
        public static readonly RowHeight AutoFit = new RowHeight(SpreadsheetDefaultValues.DefaultRowHeight, false);

        #endregion


        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="RowHeight" /> class.
        /// </summary>
        /// <param name="value">The value.</param>
        /// <param name="isCustom">The value indicating whether the row height is custom.</param>
        public RowHeight(double value, bool isCustom) 
            : base(value, isCustom)
        {
            Guard.ThrowExceptionIfInvalidRowHeight(value);
        }

        #endregion
    }
}