﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.Model
{
    /// <summary>
    /// The arguments for the RowHeightChangedEvent.
    /// </summary>
    public class RowHeightChangedEventArgs : EventArgs
    {
		#region Properties
        /// <summary>
        /// Gets the start index.
        /// </summary>
        /// <value>The start index.</value>
        public int FromIndex { get; private set; }

        /// <summary>
        /// Gets the end index.
        /// </summary>
        /// <value>The end index.</value>
        public int ToIndex { get; private set; }

		#endregion


		#region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="RowHeightChangedEventArgs" /> class.
        /// </summary>
        /// <param name="fromIndex">From index.</param>
        /// <param name="toIndex">To index.</param>
        public RowHeightChangedEventArgs(int fromIndex, int toIndex)
        {
			this.FromIndex = fromIndex;
			this.ToIndex = toIndex;
		}

		#endregion
	}
}