﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Media;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Shapes
{
    internal struct FloatingPosition
    {
        private Point topLeft;

        public Point TopLeft
        {
            get
            {
                return this.topLeft;
            }
            set
            {
                if (value.X < 0 || value.Y < 0)
                {
                    throw new ArgumentOutOfRangeException("value", "The coordinates must be greater than or equal to 0.");
                }

                this.topLeft = value;
            }
        }

        public FloatingPosition(Point topLeft)
        {
            this.topLeft = topLeft;
        }
    }
}
