﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Sorting
{
    internal class FillColorComparer : IComparer<SortValue>
    {
        private readonly IFill fill;
        private readonly SortOrder sortOrder;

        public FillColorComparer(IFill fill, SortOrder sortOrder)
        {
            this.fill = fill;
            this.sortOrder = sortOrder;
        }

        public int Compare(SortValue x, SortValue y)
        {
            IFill fill1 = x.Value as IFill;
            IFill fill2 = y.Value as IFill;

            int result = 0;
            if (!TelerikHelper.EqualsOfT(fill1, fill2))
            {
                if (fill1 != null && fill2 != null)
                {
                    if (fill1.Equals(this.fill))
                    {
                        result = -1;
                    }
                    else if (fill2.Equals(this.fill))
                    {
                        result = 1;
                    }
                }
            }

            result = (sortOrder == SortOrder.Ascending) ? result : result * -1;
            result = (result == 0) ? x.Index.CompareTo(y.Index) : result;

            return result;
        }
    }
}