﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Utilities;
#if NETCORE || NETSTANDARD
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Spreadsheet.Model.Sorting
{
    internal class ForeColorComparer : IComparer<SortValue>
    {
        private readonly ThemableColor color;
        private readonly SortOrder sortOrder;

        public ForeColorComparer(ThemableColor color, SortOrder sortOrder)
        {
            this.color = color;
            this.sortOrder = sortOrder;
        }

        public int Compare(SortValue x, SortValue y)
        {
            ThemableColor color1 = x.Value as ThemableColor;
            ThemableColor color2 = y.Value as ThemableColor;

            int result = 0;
            if (!TelerikHelper.EqualsOfT(color1, color2))
            {
                if (color1 != null && color2 != null)
                {
                    if (color1 == this.color)
                    {
                        result = -1;
                    }
                    else if (color2 == this.color)
                    {
                        result = 1;
                    }
                }
            }

            result = (this.sortOrder == SortOrder.Ascending) ? result : result * -1;
            result = (result == 0) ? x.Index.CompareTo(y.Index) : result;

            return result;
        }
    }
}