﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Sorting
{
    internal class ValuesSortConditionComparer : ValuesSortConditionComparerBase
    {
        private readonly bool isInverted;

        public ValuesSortConditionComparer(bool isInverted)
        {
            this.isInverted = isInverted;
        }

        public override int Compare(SortValue x, SortValue y)
        {
            int result = base.Compare(x, y);

            if (this.isInverted &&
                !(x.Value is EmptyCellValue) && !(y.Value is EmptyCellValue))
            {
                result = result * -1;
            }

            if (result == 0)
            {
                result = x.Index.CompareTo(y.Index);
            }

            return result;
        }
    }
}