﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Sorting
{
    /// <summary>
    /// Represents a base class for sorting values.
    /// </summary>
    public abstract class ValuesSortConditionComparerBase : IComparer<SortValue>
    {
        /// <summary>
        /// Compares the specified x and y.
        /// </summary>
        /// <param name="x">The x.</param>
        /// <param name="y">The y.</param>
        /// <returns>Less than zero if x is less y, zero if x is equal y, greated than zero if x is greater y.</returns>
        public virtual int Compare(SortValue x, SortValue y)
        {
            ICellValue value1 = x.Value as ICellValue;
            ICellValue value2 = y.Value as ICellValue;

            Guard.ThrowExceptionIfNull(value1, "value1");
            Guard.ThrowExceptionIfNull(value2, "value2");

            int result = value1.CompareTo(value2);

            return result;
        }
    }
}