﻿using System;
using System.Linq;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Sorting
{
    /// <summary>
    /// Represents a value and its index before sorting.
    /// </summary>
    public class SortValue
    {
        #region Fields

        private readonly object value;
        private readonly int index;

        #endregion


        #region Properties

        /// <summary>
        /// Gets the index of the value before sorting.
        /// </summary>
        /// <value>The index of the value before sorting.</value>
        public int Index
        {
            get
            {
                return index;
            }
        }

        /// <summary>
        /// Gets the value.
        /// </summary>
        /// <value>The value.</value>
        public object Value
        {
            get
            {
                return this.value;
            }
        }

        #endregion


        #region Constructors

        internal SortValue(int index, object value)
        {
            this.index = index;
            this.value = value;
        }

        #endregion
    }
}