﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Model.Sorting
{
    /// <summary>
    /// Represents sorting exception.
    /// </summary>
    public class SortingException : LocalizableException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SortingException" /> class.
        /// </summary>
        public SortingException() : base()
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="SortingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public SortingException(string message) : base(message)
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="SortingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="key">The key.</param>
        public SortingException(string message, string key) : base(message, key)
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="SortingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public SortingException(string message, Exception innerException) : base(message, innerException)
        {
 		}

        /// <summary>
        /// Initializes a new instance of the <see cref="SortingException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        /// <param name="key">The key.</param>
        public SortingException(string message, Exception innerException, string key) : base(message, innerException, key)
        {
 		}
    }
}