﻿using Telerik.Windows.Documents.Spreadsheet.Core.DataStructures;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.PropertySystem
{
	internal class ColumnsPropertyBag : RowColumnPropertyBagBase
	{
		#region Property Definitions

		public static readonly IPropertyDefinition<ColumnWidth> WidthProperty =
            new PropertyDefinition<ColumnWidth>("ColumnWidth", true, StylePropertyGroup.None, new ColumnWidth(SpreadsheetDefaultValues.DefaultColumnWidth, false));

        private static readonly ColumnWidth HiddenWidth = new ColumnWidth(0, true);

		#endregion


		#region Properties

        protected override WidthHeightBase HiddenSize
        {
            get 
            {
                return HiddenWidth;
            }
        }

		protected override long ToItemIndex
		{
			get
			{
				return SpreadsheetDefaultValues.ColumnCount - 1;
			}
		}

		#endregion


		#region Constructors

		public ColumnsPropertyBag()
		{
			base.RegisterProperty(ColumnsPropertyBag.WidthProperty);
		}

		#endregion


		#region Methods

        internal override int GetRowColumnIndex(int rowIndex, int columnIndex)
        {
            return columnIndex;
        }

		public void CopyPropertiesFrom(ColumnsPropertyBag fromProperties, long fromIndex, long toIndex)
		{
			base.CopyPropertiesFrom(fromProperties, fromIndex, toIndex);
		}

        public ICompressedList<ColumnWidth> GetColumnWidthPropertyValueRespectingHidden()
        {
            return base.GetSizePropertyValueRespectingHidden<ColumnWidth>(WidthProperty);
        }

		#endregion
	}
}