﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.PropertySystem
{
    /// <summary>
    /// Represents style changed event arguments.
    /// </summary>
    public class StyleChangedEventArgs : EventArgs
    {
        #region Fields

        private readonly IEnumerable<IPropertyDefinition> changedProperties;

        #endregion


        #region Properties

        /// <summary>
        /// Gets the changed properties.
        /// </summary>
        /// <value>The changed properties.</value>
        public IEnumerable<IPropertyDefinition> ChangedProperties
        {
            get
            {
                return this.changedProperties;
            }
        }

        #endregion


        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="StyleChangedEventArgs" /> class.
        /// </summary>
        /// <param name="changedProperties">The changed properties.</param>
        public StyleChangedEventArgs(IEnumerable<IPropertyDefinition> changedProperties)
        {
            Guard.ThrowExceptionIfNull(changedProperties, "changedProperties");
            this.changedProperties = changedProperties;
        }

        #endregion
    }
}