﻿namespace Telerik.Windows.Documents.Spreadsheet.PropertySystem
{
    /// <summary>
    /// Describes the style property groups.
    /// </summary>
    public enum StylePropertyGroup
    {
        /// <summary>
        /// None style property group.
        /// </summary>
        None,

        /// <summary>
        /// Number style property group.
        /// </summary>
        Number,

        /// <summary>
        /// Alignment style property group.
        /// </summary>
        Alignment,

        /// <summary>
        /// Font style property group.
        /// </summary>
        Font,

        /// <summary>
        /// Border style property group.
        /// </summary>
        Border,

        /// <summary>
        /// Fill style property group.
        /// </summary>
        Fill,

        /// <summary>
        /// Protection style property group.
        /// </summary>
        Protection
    }
}