﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Utilities
{
    /// <summary>
    /// Represents header name rendering converter context.
    /// </summary>
    public class HeaderNameRenderingConverterContext
    {
        private readonly Worksheet worksheet;
        private readonly CellRange visibleRange;

        /// <summary>
        /// Gets the worksheet.
        /// </summary>
        /// <value>The worksheet.</value>
        public Worksheet Worksheet
        {
            get
            {
                return this.worksheet;
            }
        }

        /// <summary>
        /// Gets the visible range.
        /// </summary>
        /// <value>The visible range.</value>
        public CellRange VisibleRange
        {
            get
            {
                return this.visibleRange;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="HeaderNameRenderingConverterContext" /> class.
        /// </summary>
        /// <param name="worksheet">The worksheet.</param>
        /// <param name="visibleRange">The visible range.</param>
        internal HeaderNameRenderingConverterContext(Worksheet worksheet, CellRange visibleRange)
        {
            this.worksheet = worksheet;
            this.visibleRange = visibleRange;
        }
    }
}