﻿using System;
using System.IO;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace Telerik.Windows.Documents.Spreadsheet.Utilities
{
    internal static class SLWPFBridge
    {
        #region TextBlock

        public static double GetWidth(this TextBlock block)
        {
            return GetSize(block).Width;
        }

        public static double GetHeight(this TextBlock block)
        {
            return GetSize(block).Height;
        }

        internal static double GetBaselineOffset(this TextBlock textBlock)
        {
#if WPF
            textBlock.Measure(new Size(double.PositiveInfinity, double.PositiveInfinity));
#endif
            return textBlock.BaselineOffset;
        }

        internal static Size GetSize(this TextBlock block)
        {
#if SILVERLIGHT
            return new Size(block.ActualWidth, block.ActualHeight);
#endif

#if WPF
            block.Measure(new Size(double.PositiveInfinity, double.PositiveInfinity));
            return block.DesiredSize;
#endif
        }
        
        #endregion


        #region GlyphTypeface

        internal static string GetFontFileName(this GlyphTypeface typeFace)
        {
#if WPF
            return Path.GetFileName(typeFace.FontUri.AbsolutePath);
#else
            return typeFace.FontFileName;
#endif
        }

        #endregion
    }
}