﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Formatting;

namespace Telerik.Windows.Documents.Spreadsheet.Utilities
{
    /// <summary>
    /// Represents the spreadsheet culture info.
    /// </summary>
    public static class SpreadsheetCultureInfo
    {

        private static SpreadsheetCultureHelper SpreadsheetCultureHelper
        {
            get
            {
                return FormatHelper.DefaultSpreadsheetCulture;
            }
        }

        /// <summary>
        /// Gets the number decimal separator.
        /// </summary>
        /// <value>The number decimal separator.</value>
        public static string NumberDecimalSeparator
        {
            get
            {
                return SpreadsheetCultureHelper.NumberDecimalSeparator;
            }
        }

        /// <summary>
        /// Gets the number group separator.
        /// </summary>
        /// <value>The number group separator.</value>
        public static string NumberGroupSeparator
        {
            get
            {
                return SpreadsheetCultureHelper.NumberGroupSeparator;
            }
        }

        /// <summary>
        /// Gets the currency decimal separator.
        /// </summary>
        /// <value>The currency decimal separator.</value>
        public static string CurrencyDecimalSeparator
        {
            get
            {
                return SpreadsheetCultureHelper.CurrencyDecimalSeparator;
            }
        }

        /// <summary>
        /// Gets the currency group separator.
        /// </summary>
        /// <value>The currency group separator.</value>
        public static string CurrencyGroupSeparator
        {
            get
            {
                return SpreadsheetCultureHelper.CurrencyGroupSeparator;
            }
        }

        /// <summary>
        /// Gets the list separator.
        /// </summary>
        /// <value>The list separator.</value>
        public static string ListSeparator
        {
            get
            {
                return SpreadsheetCultureHelper.ListSeparator;
            }
        }

        /// <summary>
        /// Gets the array list separator.
        /// </summary>
        /// <value>The array list separator.</value>
        public static string ArrayListSeparator
        {
            get
            {
                return SpreadsheetCultureHelper.ArrayListSeparator;
            }
        }

        /// <summary>
        /// Gets the array row separator.
        /// </summary>
        /// <value>The array row separator.</value>
        public static string ArrayRowSeparator
        {
            get
            {
                return SpreadsheetCultureHelper.ArrayRowSeparator;
            }
        }

        /// <summary>
        /// Gets the text qualifier.
        /// </summary>
        /// <value>The text qualifier.</value>
        public static string TextQualifier
        {
            get
            {
                return SpreadsheetCultureHelper.TextQualifier;
            }
        }

        /// <summary>
        /// Gets the time separator.
        /// </summary>
        /// <value>The time separator.</value>
        public static string TimeSeparator
        {
            get
            {
                return SpreadsheetCultureHelper.TimeSeparator;
            }
        }

        /// <summary>
        /// Gets the date separator.
        /// </summary>
        /// <value>The date separator.</value>
        public static string DateSeparator
        {
            get
            {
                return SpreadsheetCultureHelper.DateSeparator;
            }
        }
    }
}
