﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.Contexts;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Contexts;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Data
{
    public class DataWorksheet
    {
        public const int Rows = 10000;
        public const int Columns = 10;

        private readonly ICellValue[,] store = new ICellValue[Rows, Columns];

        public ICellValue this[int row, int column]
        {
            get
            {
                return this.store[row, column];
            }
            set
            {
                this.store[row, column] = value;
            }
        }

        public int No { get; set; }

        internal IEnumerable<RowInfo> GetNonEmptyRows()
        {
            for (int i = 0; i < Rows; i++)
            {
                RowInfo ri = new RowInfo();
                ri.RowIndex = i;

                yield return ri;
            }
        }

        internal IEnumerable<CellInfo> GetNonEmptyCellsInRow(int rowIndex)
        {
            for (int j = 0; j < Columns; j++)
            {
                CellInfo cellInfo = new CellInfo();
                cellInfo.CellValue = this.store[rowIndex, j];
                cellInfo.CellIndex = new CellIndex(rowIndex, j);

                yield return cellInfo;
            }
        }

        public string Name { get; set; }
    }
}
