﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Contexts
{
    internal struct ColumnInfo
    {
        public ColumnInfo(double defaultColumnWidth)
            : this()
        {
            this.Width = defaultColumnWidth;
        }

        public bool BestFit { get; set; }
        
        public bool IsCustom { get; set; }

        public double Width { get; set; }

        public bool Hidden { get; set; }

        public int OutlineLevel { get; set; }

        public int StyleIndex { get; set; }

        public override bool Equals(object obj)
        {
            ColumnInfo other = (ColumnInfo)obj;

            return this.BestFit == other.BestFit &&
                this.IsCustom == other.IsCustom &&
                this.Width == other.Width &&
                this.Hidden == other.Hidden &&
                this.OutlineLevel == other.OutlineLevel &&
                this.StyleIndex == other.StyleIndex;
        }

        public override int GetHashCode()
        {
            return TelerikHelper.CombineHashCodes(this.BestFit.GetHashCode(),
                this.IsCustom.GetHashCode(),
                this.Width.GetHashCode(),
                this.Hidden.GetHashCode(),
                this.OutlineLevel.GetHashCode(),
                this.StyleIndex.GetHashCode());
        }
    }
}