﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Model;
#if NETCORE || NETSTANDARD
using Telerik.Documents.Common.Model;
#endif

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Contexts
{
    internal class DifferentialFormatsImportContext
    {
        private readonly List<object> formats;

        public DifferentialFormatsImportContext()
        {
            this.formats = new List<object>();
        }

        public int Count
        {
            get
            {
                return this.formats.Count;
            }
        }

        public void RegisterFill(IFill fill)
        {
            this.formats.Add(fill);
        }

        public void RegisterFont(FontInfo info)
        {
            this.formats.Add(info);
        }

        public IFill GetFillById(int index)
        {
            IFill fill = this.formats[index] as IFill;
            if (fill != null && fill is NoneFill)
            {
                return PatternFill.Default;
            }

            return fill;
        }

        public ThemableColor GetColorById(int index)
        {
            FontInfo? info = this.formats[index] as FontInfo?;
            if (info != null)
            {
                return ((FontInfo)info).ForeColor;
            }

            return null;
        }
    }
}
