﻿using System;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.Contexts;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Contexts
{
    internal class ReferenceCounter
    {
        private int lastCellColumn;
        private int rowIndex = -1;
        private bool isNewRow = true;

        public void GetCellIndex(CellInfo cellInfo, out int rowIndex, out int columnIndex)
        {
            if (cellInfo.IsCellIndexKnown)
            {
                rowIndex = cellInfo.RowIndex;
                columnIndex = cellInfo.ColumnIndex;
            }
            else
            {
                if (!this.isNewRow)
                {
                    columnIndex = this.lastCellColumn + 1;
                }
                else
                {
                    columnIndex = 0;
                }

                rowIndex = this.rowIndex;
            }

            if (this.isNewRow)
            {
                this.isNewRow = false;
            }

            this.lastCellColumn = columnIndex;
        }

        public int GetRow(RowInfo rowInfo)
        {
            int newRowIndex;

            if (rowInfo.RowIndex.HasValue)
            {
                newRowIndex = rowInfo.RowIndex.Value;
            }
            else
            {
                newRowIndex = this.rowIndex + 1;

                if (newRowIndex >= SpreadsheetDefaultValues.RowCount)
                {
                    throw new InvalidOperationException("The total number of rows is greater than the allowed maximum.");
                }
            }

            this.isNewRow = true;
            this.rowIndex = newRowIndex;

            return newRowIndex;
        }
    }
}
