﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Contexts
{
    internal class SharedFormulaInfo
    {
        private readonly CellRange range;
        private readonly FormulaCellValue formulaCellValue;

        public SharedFormulaInfo(Ref reference, FormulaCellValue formulaCellValue)
        {
            Guard.ThrowExceptionIfNull(reference, "reference");
            Guard.ThrowExceptionIfNull(formulaCellValue, "formulaCellValue");

            this.range = reference.ToCellRange();
            this.formulaCellValue = formulaCellValue;
        }

        public CellRange Range
        {
            get
            {
                return this.range;
            }
        }

        public FormulaCellValue FormulaCellValue
        {
            get
            {
                return this.formulaCellValue;
            }
        }
    }
}
