﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Contexts
{
    internal class TextSharedString : SharedString
    {
        private readonly string text;

        public TextSharedString(string text)
        {
            Guard.ThrowExceptionIfNull(text, "text");

            this.text = text;
        }

        public override SharedStringType Type
        {
            get
            {
                return SharedStringType.Text;
            }
        }

        public string Text
        {
            get
            {
                return this.text;
            }
        }

        public override int GetHashCode()
        {
            unchecked
            {
                int result = 17;
                result = (result * 23) + ((text != null) ? this.text.GetHashCode() : 0);
                
                return result;
            }
        }

        public override bool Equals(object obj)
        {
            TextSharedString other = obj as TextSharedString;
            if (obj == null)
            {
                return false;
            }
          
            return this.Text == other.Text;
        }
    }
}
