﻿using System;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Common
{
    internal abstract class BoolValueElementBase : XlsxElementBase
    {
        private readonly BoolOpenXmlAttribute value;

        public BoolValueElementBase(XlsxPartsManager partsManager)
            : base(partsManager)
        {
            this.value = this.RegisterAttribute(new BoolOpenXmlAttribute("val", true, isRequired: false));
        }

        public bool Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }

        public override bool AlwaysExport
        {
            get
            {
                return true;
            }
        }
    }
}