﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Common
{
    internal abstract class RequiredValueElementBase<T> : XlsxElementBase
    {
        private readonly OpenXmlAttribute<T> value;

        public RequiredValueElementBase(XlsxPartsManager partsManager)
            : base(partsManager)
        {
            this.value = this.RegisterAttribute<T>("val", true);
        }

        public T Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }

        public override bool AlwaysExport
        {
            get
            {
                return true;
            }
        }
    }
}