﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Common
{
    internal class UnderlineElement : XlsxElementBase
    {
        private readonly OpenXmlAttribute<string> value;

        public UnderlineElement(XlsxPartsManager partsManager)
            : base(partsManager)
        {
            this.value = this.RegisterAttribute<string>("val", UnderlineValues.Single);
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.UnderlineElementName;
            }
        }

        public string Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }

        public override bool AlwaysExport
        {
            get
            {
                return true;
            }
        }
    }
}