﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Parts;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Export;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Common;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Parts;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Drawing
{
    internal class WorksheetDrawingElement : XlsxPartRootElementBase
    {
        public WorksheetDrawingElement(XlsxPartsManager partsManager, OpenXmlPartBase part) 
            : base(partsManager, part)
        {
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.WorksheetDrawingElementName;
            }
        }

        public override OpenXmlNamespace Namespace
        {
            get
            {
                return OpenXmlNamespaces.SpreadsheetDrawingMLNamespace;
            }
        }

        public override IEnumerable<OpenXmlNamespace> Namespaces
        {
            get
            {
                yield return OpenXmlNamespaces.DrawingMLNamespace;
            }
        }

        protected override IEnumerable<OpenXmlElementBase> EnumerateChildElements(IXlsxWorkbookExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            IXlsxWorksheetExportContext worksheetContext = context.GetWorksheetContextFromDrawingPart((DrawingPart)this.Part);
            foreach (FloatingShapeBase shape in worksheetContext.Shapes)
            {
                TwoCellAnchorElement twoCellAnchorElement = this.CreateElement<TwoCellAnchorElement>(XlsxElementNames.TwoCellAnchorElementName);
                twoCellAnchorElement.CopyPropertiesFrom(worksheetContext, shape);

                yield return twoCellAnchorElement;
            }

            yield break;
        }
    }
}
