﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Common;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.SharedStrings
{
    internal class RichTextRunElement : XlsxElementBase
    {
        private readonly OpenXmlChildElement<TextElement> text;

        public RichTextRunElement(XlsxPartsManager partsManager)
            : base(partsManager)
        {
            this.text = this.RegisterChildElement<TextElement>(XlsxElementNames.TextElementName, XlsxElementUniquePoolIds.TextElementUniquePoolId);
        }

        public TextElement TextElement
        {
            get
            {
                return this.text.Element;
            }
            set
            {
                this.text.Element = value;
            }
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.RichTextRunElementName;
            }
        }
    }
}