﻿using System;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Contexts;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Export;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.SharedStrings
{
    internal class TextElement : SharedStringElementBase
    {
        private readonly SpaceAttribute space;

        public TextElement(XlsxPartsManager partsManager)
            : base(partsManager)
        {
            this.space = this.RegisterSpaceAttribute();
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.TextElementName;
            }
        }

        public string Space
        {
            get
            {
                return this.space.Value;
            }
            set
            {
                this.space.Value = value;
            }
        }

        public void CopyPropertiesFrom(IXlsxWorkbookExportContext context, TextSharedString textSharedString)
        {
            Guard.ThrowExceptionIfNull(context, "context");
            Guard.ThrowExceptionIfNull(textSharedString, "textSharedString");

            this.InnerText = textSharedString.Text;
        }

        protected override bool ShouldExport(IXlsxWorkbookExportContext context)
        {
            return true;
        }
    }
}