﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.StyleSheet
{
    internal class RgbColorElement : StyleSheetElementBase
    {
        private readonly ConvertedOpenXmlAttribute<UnsignedIntHex> rgb;

        public RgbColorElement(XlsxPartsManager partsManager) 
            : base(partsManager)
        {
            this.rgb = this.RegisterAttribute(new ConvertedOpenXmlAttribute<UnsignedIntHex>("rgb", Converters.UnsignedIntHexConverter));
        }

        public UnsignedIntHex Rgb
        {
            get
            {
                return this.rgb.Value;
            }
            set
            {
                this.rgb.Value = value;
            }
        }

        public override string ElementName
        {
            get { return XlsxElementNames.RgbColorElementName; }
        }

        protected override void OnAfterRead(Import.IXlsxWorkbookImportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            context.StyleSheet.IndexedColorTable.Add(this.Rgb.Color);
        }
    }
}