﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Export;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Import;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Workbooks
{
    internal class BookViewsElement : WorkbookElementBase
    {
        private readonly OpenXmlChildElement<WorkbookViewElement> workbookViewElement;

        public BookViewsElement(XlsxPartsManager partsManager)
            : base(partsManager)
        {
            this.workbookViewElement = this.RegisterChildElement<WorkbookViewElement>(XlsxElementNames.WorkbookViewElementName);
        }

        public WorkbookViewElement WorkbookViewElement
        {
            get
            {
                return this.workbookViewElement.Element;
            }
            set
            {
                this.workbookViewElement.Element = value;
            }
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.BookViewsElementName;
            }
        }

        protected override bool ShouldExport(IXlsxWorkbookExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            return context.GetActiveTabIndex() > 0;
        }

        protected override void OnBeforeWrite(IXlsxWorkbookExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            this.CreateElement(this.workbookViewElement);
        }

        protected override void OnAfterRead(IXlsxWorkbookImportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            this.ReleaseElement(this.workbookViewElement);
        }
    }
}