﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Export;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Workbooks
{
    internal class SheetsElement : WorkbookElementBase
    {
        public SheetsElement(XlsxPartsManager partsManager)
            : base(partsManager)
        {
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.SheetsElementName;
            }
        }

        protected override bool ShouldExport(IXlsxWorkbookExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            return context.WorksheetContexts.Any() || base.ShouldExport(context);
        }

        protected override IEnumerable<OpenXmlElementBase> EnumerateChildElements(IXlsxWorkbookExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            int sheetId = 1;
            foreach (IXlsxWorksheetExportContext exportContext in context.WorksheetContexts)
            {
                SheetElement sheetElement = this.CreateElement<SheetElement>(XlsxElementNames.SheetElementName);
                sheetElement.CopyPropertiesFrom(context, exportContext, sheetId++);

                yield return sheetElement;
            }
        }
    }
}