﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Export;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Import;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Workbooks
{
    internal class WorkbookViewElement : WorkbookElementBase
    {
        private readonly IntOpenXmlAttribute activeTab;

        public WorkbookViewElement(XlsxPartsManager partsManager)
            : base(partsManager)
        {
            this.activeTab = this.RegisterAttribute(new IntOpenXmlAttribute("activeTab", 0));
        }

        public int ActiveTab
        {
            get
            {
                return this.activeTab.Value;
            }
            set
            {
                this.activeTab.Value = value;
            }
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.WorkbookViewElementName;
            }
        }

        protected override void OnAfterRead(IXlsxWorkbookImportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            context.SetActiveTabIndex(this.ActiveTab);
        }

        protected override void OnBeforeWrite(IXlsxWorkbookExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            this.ActiveTab = context.GetActiveTabIndex();
        }
    }
}