﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Core.DataStructures;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Contexts;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Export;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Common;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Worksheets
{
    internal class ColumnsElement : WorksheetElementBase
    {
        public ColumnsElement(XlsxPartsManager partsManager) 
            : base(partsManager)
        {
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.ColumnsElementName;
            }
        }

        protected override bool ShouldExport(IXlsxWorksheetExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            return context.GetNonEmptyColumns().Any() || base.ShouldExport(context);
        }

        protected override IEnumerable<XlsxElementBase> EnumerateChildElements(IXlsxWorksheetExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            foreach (Range<long, ColumnInfo> column in context.GetNonEmptyColumns())
            {
                ColumnElement columnElement = this.CreateElement<ColumnElement>(XlsxElementNames.ColumnElementName);
                columnElement.CopyPropertiesFrom(context, column);

                yield return columnElement;
            }
        }
    }
}