﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Contexts;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Worksheets
{
    internal class CustomFilterElement : WorksheetElementBase
    {
        private readonly ConvertedOpenXmlAttribute<ComparisonOperator> filterOperator;
        private readonly OpenXmlAttribute<string> value;

        public CustomFilterElement(XlsxPartsManager partsManager) 
            : base(partsManager)
        {
            this.filterOperator = this.RegisterAttribute(new ConvertedOpenXmlAttribute<ComparisonOperator>("operator", null, XlsxConverters.ComparisonOperatorConverter, ComparisonOperatorConverter.DefaultExportComparisonOperator));
            this.value = this.RegisterAttribute<string>("val", isRequired: true);
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.CustomFilterElementName;
            }
        }

        public ComparisonOperator FilterOperator
        {
            get
            {
                return this.filterOperator.Value;
            }
            set
            {
                this.filterOperator.Value = value;
            }
        }

        public string Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }

        internal void CopyPropertiesFrom(CustomFilterCriteriaInfo customFilterInfo)
        {
            this.FilterOperator = customFilterInfo.FilterOperator;
            this.Value = customFilterInfo.FilterValue;
        }
    }
}
