﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Worksheets
{
    internal class FilterElement : WorksheetElementBase
    {
        private readonly OpenXmlAttribute<string> value;

        public FilterElement(XlsxPartsManager partsManager) 
            : base(partsManager)
        {
            this.value = this.RegisterAttribute<string>("val", true);
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.FilterElementName;
            }
        }

        public string Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }

        internal void CopyPropertiesFrom(string value)
        {
            this.Value = value;
        }
    }
}
