﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Common;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Worksheets
{
    internal class FutureFeatureDataStorageAreaElement : XlsxElementBase
    {
        public FutureFeatureDataStorageAreaElement(XlsxPartsManager partsManager)
            : base(partsManager)
        {
        }

        public override string ElementName
        {
            get
            {
                return OpenXmlElementNames.FutureFeatureDataStorageAreaElementName;
            }
        }

        protected override OpenXmlElementBase CreateElement(string elementName)
        {
            if (elementName == OpenXmlElementNames.ExtentsElementName &&
                this.Part.Name == XlsxPartNames.WorksheetPartName)
            {
                return new ExtensionElement(this.PartsManager)
                    {
                        Part = this.Part
                    };
            }

            return base.CreateElement(elementName);
        }
    }
}