﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Export;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Common;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Worksheets
{
    internal class HyperlinksElement : WorksheetElementBase
    {
        public HyperlinksElement(XlsxPartsManager partsManager)
            : base(partsManager)
        {
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.HyperlinksElementName;
            }
        }

        protected override bool ShouldExport(IXlsxWorksheetExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            return context.Hyperlinks.Any() || base.ShouldExport(context);
        }

        protected override IEnumerable<XlsxElementBase> EnumerateChildElements(IXlsxWorksheetExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            foreach (SpreadsheetHyperlink hyperlink in context.Hyperlinks)
            {
                HyperlinkElement hyperlinkElement = this.CreateElement<HyperlinkElement>(XlsxElementNames.HyperlinkElementName);
                hyperlinkElement.CopyPropertiesFrom(context, hyperlink);

                yield return hyperlinkElement;
            }
        }
    }
}
