﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.Contexts;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Export;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Common;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Worksheets
{
    internal class MergedCellsElement : WorksheetElementBase
    {
        public MergedCellsElement(XlsxPartsManager partsManager) 
            : base(partsManager)
        {
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.MergedCellsElementName;
            }
        }

        protected override bool ShouldExport(IXlsxWorksheetExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            return context.GetMergedCells().Any() || base.ShouldExport(context);
        }

        protected override IEnumerable<XlsxElementBase> EnumerateChildElements(IXlsxWorksheetExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            foreach (MergedCellInfo mergedCell in context.GetMergedCells())
            {
                MergedCellElement mergedCellElement = this.CreateElement<MergedCellElement>(XlsxElementNames.MergedCellElementName);
                mergedCellElement.CopyPropertiesFrom(context, mergedCell);

                yield return mergedCellElement;
            }
        }
    }
}