﻿using System;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.SharedStrings;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Worksheets
{
    internal class RichTextInlineElement : WorksheetElementBase
    {
        public RichTextInlineElement(XlsxPartsManager partsManager)
            : base(partsManager)
        {
        }

        public override string ElementName
        {
            get 
            {
                return XlsxElementNames.RichTextInlineElementName;
            }
        }

        public string ResultText { get; set; }

        protected override void OnAfterReadChildElement(Import.IXlsxWorksheetImportContext context, Documents.FormatProviders.OpenXml.Model.Elements.OpenXmlElementBase childElement)
        {
            if (this.ResultText == null)
            {
                this.ResultText = string.Empty;
            }

            RichTextRunElement richTextRunElementChild = childElement as RichTextRunElement;
            if (richTextRunElementChild != null)
            {
                this.ResultText += richTextRunElementChild.TextElement.InnerText;
            }

            TextElement textElementChild = childElement as TextElement;
            if (textElementChild != null)
            {
                this.ResultText += textElementChild.InnerText;
            }
        }

        protected override void ClearOverride()
        {
            this.ResultText = string.Empty;
        }
    }
}
