﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Core;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Export;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Import;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Worksheets
{
    internal class SheetViewsElement : WorksheetElementBase
    {
        private readonly OpenXmlChildElement<SheetViewElement> sheetViewElement;

        public SheetViewsElement(XlsxPartsManager partsManager)
            : base(partsManager)
        {
            this.sheetViewElement = this.RegisterChildElement<SheetViewElement>(XlsxElementNames.SheetViewElementName);
        }

        public SheetViewElement SheetViewElement
        {
            get
            {
                return this.sheetViewElement.Element;
            }
            set
            {
                this.sheetViewElement.Element = value;
            }
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.SheetViewsElementName;
            }
        }

        public override bool AlwaysExport
        {
            get
            {
                return true;
            }
        }

        protected override void OnBeforeWrite(IXlsxWorksheetExportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            this.CreateElement(this.sheetViewElement);
        }

        protected override void OnAfterRead(IXlsxWorksheetImportContext context)
        {
            Guard.ThrowExceptionIfNull(context, "context");

            this.ReleaseElement(this.sheetViewElement);
        }
    }
}