﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Export;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Drawing;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Parts
{
    internal class DrawingPart : XlsxPartBase
    {
        private readonly WorksheetDrawingElement worksheetDrawingElement;

        public DrawingPart(XlsxPartsManager partsManager, IXlsxWorksheetExportContext context)
            : this(partsManager, string.Format(XlsxPartNames.DrawingPartName, context.SheetNo))
        {
        }

        public DrawingPart(XlsxPartsManager partsManager, string partName)
            : base(partsManager, partName)
        {
            this.worksheetDrawingElement = new WorksheetDrawingElement(this.PartsManager, this);
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return this.worksheetDrawingElement;
            }
        }

        public override string ContentType
        {
            get
            {
                return XlsxContentTypeNames.DrawingContentType;
            }
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level6;
            }
        }
    }
}
