﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.SharedStrings;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Parts
{
    internal class SharedStringsPart : XlsxPartBase
    {
        private readonly SharedStringTableElement sharedStringTableElement;

        public SharedStringsPart(XlsxPartsManager partsManager)
            : base(partsManager, XlsxPartNames.SharedStringsPartName)
        {
            this.PartsManager.CreateWorkbookRelationship(this.Name, XlsxRelationshipTypes.SharedStringsRelationshipType);
            this.sharedStringTableElement = new SharedStringTableElement(this.PartsManager, this);
        }

        public SharedStringsPart(XlsxPartsManager partsManager, string partName)
            : base(partsManager, partName)
        {
            this.sharedStringTableElement = new SharedStringTableElement(this.PartsManager, this);
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return this.sharedStringTableElement;
            }
        }

        public override bool OverrideDefaultContentType
        {
            get
            {
                return true;
            }
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level3;
            }
        }

        public override string ContentType
        {
            get
            {
                return XlsxContentTypeNames.SharedStringsContentType;
            }
        }
    }
}
