﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.StyleSheet;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Parts
{
    internal class StylesPart : XlsxPartBase
    {
        private readonly StyleSheetElement stylesheet;

        public StylesPart(XlsxPartsManager partsManager)
            : base(partsManager, XlsxPartNames.StylesPartName)
        {
            this.PartsManager.CreateWorkbookRelationship(this.Name, XlsxRelationshipTypes.StylesRelationshipType);
            this.stylesheet = new StyleSheetElement(this.PartsManager, this);
        }

        public StylesPart(XlsxPartsManager partsManager, string partName)
            : base(partsManager, partName)
        {
            this.stylesheet = new StyleSheetElement(this.PartsManager, this);
        }

        public override string ContentType
        {
            get
            {
                return XlsxContentTypeNames.StylesContentType;
            }
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return this.stylesheet;
            }
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level3;
            }
        }
    }
}