﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Workbooks;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Parts
{
    internal class WorkbookPart : XlsxPartBase
    {
        private readonly WorkbookElement workbookElement;

        public WorkbookPart(XlsxPartsManager partsManager)
            : base(partsManager, XlsxPartNames.WorkbookPartName)
        {
            this.PartsManager.CreateApplicationRelationship(this.Name, XlsxRelationshipTypes.OfficeDocumentRelationshipType);
            this.workbookElement = new WorkbookElement(this.PartsManager, this);
        }

        public WorkbookPart(XlsxPartsManager partsManager, string partName)
            : base(partsManager, partName)
        {
            this.workbookElement = new WorkbookElement(this.PartsManager, this);
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return this.workbookElement;
            }
        }

        public override string ContentType
        {
            get
            {
                return XlsxContentTypeNames.WorkbookContentType;
            }
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level4;
            }
        }
    }
}