﻿using System;
using System.Linq;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Elements;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Export;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Elements.Worksheets;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Parts
{
    internal class WorksheetPart : SheetPartBase
    {
        private readonly WorksheetElement worksheetElement;

        public WorksheetPart(XlsxPartsManager partsManager, IXlsxWorksheetExportContext context)
            : this(partsManager, string.Format(XlsxPartNames.WorksheetPartName, context.SheetNo))
        {
        }

        public WorksheetPart(XlsxPartsManager partsManager, string partName)
            : base(partsManager, partName)
        {
            this.worksheetElement = new WorksheetElement(this.PartsManager, this);
        }

        public override string ContentType
        {
            get
            {
                return XlsxContentTypeNames.WorksheetContentType;
            }
        }

        public override OpenXmlElementBase RootElement
        {
            get
            {
                return worksheetElement;
            }
        }

        public override int Level
        {
            get
            {
                return OpenXmlPartLevel.Level5;
            }
        }

        public override SheetPartType SheetType
        {
            get
            {
                return SheetPartType.Worksheet;
            }
        }
    }
}