﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal static class BorderStyles
    {
        public static readonly string SlantDashDot = "slantDashDot";
        public static readonly string DashDot = "dashDot";
        public static readonly string DashDotDot = "dashDotDot";
        public static readonly string Dashed = "dashed";
        public static readonly string Double = "double";
        public static readonly string Dotted = "dotted";
        public static readonly string Hair = "hair";
        public static readonly string Medium = "medium";
        public static readonly string MediumDashDot = "mediumDashDot";
        public static readonly string MediumDashDotDot = "mediumDashDotDot";
        public static readonly string MediumDashed = "mediumDashed";
        public static readonly string None = "none";
        public static readonly string Thick = "thick";
        public static readonly string Thin = "thin";

        private static readonly ValueMapper<string, CellBorderStyle> nameToValueMapper;

        static BorderStyles()
        {
            nameToValueMapper = new ValueMapper<string, CellBorderStyle>(Thin, CellBorderStyle.Thin);

            nameToValueMapper.AddPair(DashDot, CellBorderStyle.DashDot);
            nameToValueMapper.AddPair(DashDotDot, CellBorderStyle.DashDotDot);
            nameToValueMapper.AddPair(Dashed, CellBorderStyle.Dashed);
            nameToValueMapper.AddPair(Dotted, CellBorderStyle.Dotted);
            nameToValueMapper.AddPair(Hair, CellBorderStyle.Hair);
            nameToValueMapper.AddPair(Medium, CellBorderStyle.Medium);
            nameToValueMapper.AddPair(MediumDashDot, CellBorderStyle.MediumDashDot);
            nameToValueMapper.AddPair(MediumDashDotDot, CellBorderStyle.MediumDashDotDot);
            nameToValueMapper.AddPair(MediumDashed, CellBorderStyle.MediumDashed);
            nameToValueMapper.AddPair(Thick, CellBorderStyle.Thick);
            nameToValueMapper.AddPair(Thin, CellBorderStyle.Thin);
            nameToValueMapper.AddPair(None, CellBorderStyle.None);
            nameToValueMapper.AddPair(SlantDashDot, CellBorderStyle.SlantDashDot);
            nameToValueMapper.AddPair(Double, CellBorderStyle.Double); 
        }

        public static string GetBorderStyleName(CellBorderStyle style)
        {
            return nameToValueMapper.GetFromValue(style);
        }

        public static CellBorderStyle GetBorderStyle(string name)
        {
            Guard.ThrowExceptionIfNullOrEmpty(name, "name");

            return nameToValueMapper.GetToValue(name);
        }
    }
}