﻿using System;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal class CellRefRangeConverter : IStringConverter<CellRefRange>
    {
        public CellRefRange ConvertFromString(string value)
        {
            CellRange cellRange;
            NameConverter.ConvertCellNameToCellRange(value, out cellRange);

            return new CellRefRange(cellRange);
        }

        public string ConvertToString(CellRefRange value)
        {
            CellIndex fromIndex = value.FromCell.ToCellIndex();
            CellIndex toIndex = value.ToCell.ToCellIndex();
            string resultString = string.Empty;

            if (fromIndex == toIndex)
            {
                resultString = value.FromCell.ToString();
            }
            else
            {
                resultString = NameConverter.ConvertCellRangeToName(fromIndex, toIndex);
            }

            return resultString;
        }
    }
}
