﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal class CellRefRangeSequence
    {
        private readonly List<CellRefRange> cellRangesSequences;

        public CellRefRangeSequence(string sequenceCellRefRanges)
        {
            this.cellRangesSequences = new List<CellRefRange>();

            this.InitializeCellRangeSequence(sequenceCellRefRanges.Trim());
        }

        public CellRefRangeSequence(IEnumerable<CellRefRange> cellRangesSequences)
        {
            this.cellRangesSequences = new List<CellRefRange>(cellRangesSequences);
        }

        public IEnumerable<CellRange> CellRanges
        {
            get
            {
                return this.GetCellRanges();
            }
        }

        private IEnumerable<CellRange> GetCellRanges()
        {
            foreach (var cellRefRange in this.cellRangesSequences)
            {
                yield return cellRefRange.ToCellRange();
            }
        }

        private void InitializeCellRangeSequence(string sequenceCellReffRanges)
        {
            string[] cellRefRanges = sequenceCellReffRanges.Split(' ');

            foreach (var cellRefRange in cellRefRanges)
            {
                this.cellRangesSequences.Add(new CellRefRange(cellRefRange));
            }
        }
    }
}