﻿using System;
using System.Collections.Generic;
using System.Text;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal class CellRefRangeSequenceConverter : IStringConverter<CellRefRangeSequence>
    {
        public CellRefRangeSequence ConvertFromString(string value)
        {
            List<CellRefRange> cellRangesSequences = new List<CellRefRange>();

            string[] cellRefRanges = value.Split(' ');

            foreach (var cellRefRange in cellRefRanges)
            {
                cellRangesSequences.Add(new CellRefRange(cellRefRange));
            }

            return new CellRefRangeSequence(cellRangesSequences);
        }

        public string ConvertToString(CellRefRangeSequence value)
        {
            StringBuilder result = new StringBuilder();

            foreach (var range in value.CellRanges)
            {
                var name = NameConverter.ConvertCellRangeToName(range.FromIndex, range.ToIndex);
                result.Append(name);
                result.Append(' ');
            }

            result.Remove(result.Length - 1, 1);
            return result.ToString();
        }
    }
}
