﻿using System;
using Telerik.Windows.Documents.Core.Data;
#if (WPF || SILVERLIGHT) && !NETCORE
using Telerik.Windows.Documents.Spreadsheet.Theming;
#else
using Telerik.Documents.Common.Model;
#endif
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal static class FontSchemes
    {
        public static readonly string MajorFont = "major";
        public static readonly string MinorFont = "minor";
        public static readonly string None = "none";

        private static readonly ValueMapper<string, ThemeFontType> nameToValueMapper;

        static FontSchemes()
        {
            nameToValueMapper = new ValueMapper<string, ThemeFontType>();
            nameToValueMapper.DefaultFromValue = new ValueBox<string>(FontSchemes.None);

            nameToValueMapper.AddPair(MajorFont, ThemeFontType.Major);
            nameToValueMapper.AddPair(MinorFont, ThemeFontType.Minor);
        }

        public static string GetFontSchemeName(ThemeFontType scheme)
        {
            return nameToValueMapper.GetFromValue(scheme);
        }

        public static ThemeFontType? GetFontScheme(string name)
        {
            Guard.ThrowExceptionIfNullOrEmpty(name, "name");

            if (name.Equals(None, StringComparison.OrdinalIgnoreCase))
            {
                return null;
            }

            return nameToValueMapper.GetToValue(name);
        }
    }
}