﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Contexts;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal static class GradientTypes
    {
        public static readonly string Linear = "linear";
        public static readonly string Path = "path";
        
        private static readonly ValueMapper<string, GradientInfoType> nameToValueMapper;

        static GradientTypes()
        {
            nameToValueMapper = new ValueMapper<string, GradientInfoType>();
            nameToValueMapper.AddPair(Linear, GradientInfoType.Linear);
            nameToValueMapper.AddPair(Path, GradientInfoType.Path);
        }

        public static string GetGradientTypeName(GradientInfoType gradient)
        {
            return nameToValueMapper.GetFromValue(gradient);
        }

        public static GradientInfoType GetGradientType(string name)
        {
            Guard.ThrowExceptionIfNullOrEmpty(name, "name");

            return nameToValueMapper.GetToValue(name);
        }
    }
}