﻿using System;
using System.Windows.Media;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal static class IndexedColors
    {
        private static readonly UnsignedIntHex[] indexedColors;

        static IndexedColors()
        {
            indexedColors = new UnsignedIntHex[66];

            RegisterIndexedColor(0, "FF000000");
            RegisterIndexedColor(1, "FFFFFFFF");
            RegisterIndexedColor(2, "FFFF0000");
            RegisterIndexedColor(3, "FF00FF00");
            RegisterIndexedColor(4, "FF0000FF");
            RegisterIndexedColor(5, "FFFFFF00");
            RegisterIndexedColor(6, "FFFF00FF");
            RegisterIndexedColor(7, "FF00FFFF");
            RegisterIndexedColor(8, "FF000000");
            RegisterIndexedColor(9, "FFFFFFFF");
            RegisterIndexedColor(10, "FFFF0000");
            RegisterIndexedColor(11, "FF00FF00");
            RegisterIndexedColor(12, "FF0000FF");
            RegisterIndexedColor(13, "FFFFFF00");
            RegisterIndexedColor(14, "FFFF00FF");
            RegisterIndexedColor(15, "FF00FFFF");
            RegisterIndexedColor(16, "FF800000");
            RegisterIndexedColor(17, "FF008000");
            RegisterIndexedColor(18, "FF000080");
            RegisterIndexedColor(19, "FF808000");
            RegisterIndexedColor(20, "FF800080");
            RegisterIndexedColor(21, "FF008080");
            RegisterIndexedColor(22, "FFC0C0C0");
            RegisterIndexedColor(23, "FF808080");
            RegisterIndexedColor(24, "FF9999FF");
            RegisterIndexedColor(25, "FF993366");
            RegisterIndexedColor(26, "FFFFFFCC");
            RegisterIndexedColor(27, "FFCCFFFF");
            RegisterIndexedColor(28, "FF660066");
            RegisterIndexedColor(29, "FFFF8080");
            RegisterIndexedColor(30, "FF0066CC");
            RegisterIndexedColor(31, "FFCCCCFF");
            RegisterIndexedColor(32, "FF000080");
            RegisterIndexedColor(33, "FFFF00FF");
            RegisterIndexedColor(34, "FFFFFF00");
            RegisterIndexedColor(35, "FF00FFFF");
            RegisterIndexedColor(36, "FF800080");
            RegisterIndexedColor(37, "FF800000");
            RegisterIndexedColor(38, "FF008080");
            RegisterIndexedColor(39, "FF0000FF");
            RegisterIndexedColor(40, "FF00CCFF");
            RegisterIndexedColor(41, "FFCCFFFF");
            RegisterIndexedColor(42, "FFCCFFCC");
            RegisterIndexedColor(43, "FFFFFF99");
            RegisterIndexedColor(44, "FF99CCFF");
            RegisterIndexedColor(45, "FFFF99CC");
            RegisterIndexedColor(46, "FFCC99FF");
            RegisterIndexedColor(47, "FFFFCC99");
            RegisterIndexedColor(48, "FF3366FF");
            RegisterIndexedColor(49, "FF33CCCC");
            RegisterIndexedColor(50, "FF99CC00");
            RegisterIndexedColor(51, "FFFFCC00");
            RegisterIndexedColor(52, "FFFF9900");
            RegisterIndexedColor(53, "FFFF6600");
            RegisterIndexedColor(54, "FF666699");
            RegisterIndexedColor(55, "FF969696");
            RegisterIndexedColor(56, "FF003366");
            RegisterIndexedColor(57, "FF339966");
            RegisterIndexedColor(58, "FF003300");
            RegisterIndexedColor(59, "FF333300");
            RegisterIndexedColor(60, "FF993300");
            RegisterIndexedColor(61, "FF993366");
            RegisterIndexedColor(62, "FF333399");
            RegisterIndexedColor(63, "FF333333");

            RegisterIndexedColor(64, Colors.Black);
            RegisterIndexedColor(65, Colors.White);
        }

        public static int PredefinedIndexedColorsCount
        {
            get
            {
                return indexedColors.Length;
            }
        }

        public static UnsignedIntHex[] PredefinedIndexedColors
        {
            get
            {
                return indexedColors;
            }
        }

        private static void RegisterIndexedColor(int index, string color)
        {
            indexedColors[index] = new UnsignedIntHex(color);
        }

        private static void RegisterIndexedColor(int index, Color color)
        {
            indexedColors[index] = new UnsignedIntHex(color);
        }
    }
}
