﻿using System;
using System.Collections.Generic;
using System.Windows.Media;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal static class PresetColors
    {
        private static readonly Dictionary<string, Color> presetColors;

        static PresetColors()
        {
            presetColors = new Dictionary<string, Color>();

            RegisterPresetColor("aliceBlue", Color.FromArgb(255, 240, 248, 255));
            RegisterPresetColor("antiqueWhite", Color.FromArgb(255, 250, 235, 215));
            RegisterPresetColor("aqua", Color.FromArgb(255, 0, 255, 255));
            RegisterPresetColor("aquamarine", Color.FromArgb(255, 127, 255, 212));
            RegisterPresetColor("azure", Color.FromArgb(255, 240, 255, 255));
            RegisterPresetColor("beige", Color.FromArgb(255, 245, 245, 220));
            RegisterPresetColor("bisque", Color.FromArgb(255, 255, 228, 196));
            RegisterPresetColor("black", Color.FromArgb(255, 0, 0, 0));
            RegisterPresetColor("blanchedAlmond", Color.FromArgb(255, 255, 235, 205));
            RegisterPresetColor("blue", Color.FromArgb(255, 0, 0, 255));
            RegisterPresetColor("blueViolet", Color.FromArgb(255, 138, 43, 226));
            RegisterPresetColor("brown", Color.FromArgb(255, 165, 42, 42));
            RegisterPresetColor("burlyWood", Color.FromArgb(255, 222, 184, 135));
            RegisterPresetColor("cadetBlue", Color.FromArgb(255, 95, 158, 160));
            RegisterPresetColor("chartreuse", Color.FromArgb(255, 127, 255, 0));
            RegisterPresetColor("chocolate", Color.FromArgb(255, 210, 105, 30));
            RegisterPresetColor("coral", Color.FromArgb(255, 255, 127, 80));
            RegisterPresetColor("cornflowerBlue", Color.FromArgb(255, 100, 149, 237));
            RegisterPresetColor("cornsilk", Color.FromArgb(255, 255, 248, 220));
            RegisterPresetColor("crimson", Color.FromArgb(255, 220, 20, 60));
            RegisterPresetColor("cyan", Color.FromArgb(255, 0, 255, 255));
            RegisterPresetColor("deepPink", Color.FromArgb(255, 255, 20, 147));
            RegisterPresetColor("deepSkyBlue", Color.FromArgb(255, 0, 191, 255));
            RegisterPresetColor("dimGray", Color.FromArgb(255, 105, 105, 105));
            RegisterPresetColor("dkBlue", Color.FromArgb(255, 0, 0, 139));
            RegisterPresetColor("dkCyan", Color.FromArgb(255, 0, 139, 139));
            RegisterPresetColor("dkGoldenrod", Color.FromArgb(255, 184, 134, 11));
            RegisterPresetColor("dkGray", Color.FromArgb(255, 169, 169, 169));
            RegisterPresetColor("dkGreen", Color.FromArgb(255, 0, 100, 0));
            RegisterPresetColor("dkKhaki", Color.FromArgb(255, 189, 183, 107));
            RegisterPresetColor("dkMagenta", Color.FromArgb(255, 139, 0, 139));
            RegisterPresetColor("dkOliveGreen", Color.FromArgb(255, 85, 107, 47));
            RegisterPresetColor("dkOrange", Color.FromArgb(255, 255, 140, 0));
            RegisterPresetColor("dkOrchid", Color.FromArgb(255, 153, 50, 204));
            RegisterPresetColor("dkRed", Color.FromArgb(255, 139, 0, 0));
            RegisterPresetColor("dkSalmon", Color.FromArgb(255, 233, 150, 122));
            RegisterPresetColor("dkSeaGreen", Color.FromArgb(255, 143, 188, 139));
            RegisterPresetColor("dkSlateBlue", Color.FromArgb(255, 72, 61, 139));
            RegisterPresetColor("dkSlateGray", Color.FromArgb(255, 47, 79, 79));
            RegisterPresetColor("dkTurquoise", Color.FromArgb(255, 0, 206, 209));
            RegisterPresetColor("dkViolet", Color.FromArgb(255, 148, 0, 211));
            RegisterPresetColor("dodgerBlue", Color.FromArgb(255, 30, 144, 255));
            RegisterPresetColor("firebrick", Color.FromArgb(255, 178, 34, 34));
            RegisterPresetColor("floralWhite", Color.FromArgb(255, 255, 250, 240));
            RegisterPresetColor("forestGreen", Color.FromArgb(255, 34, 139, 34));
            RegisterPresetColor("fuchsia", Color.FromArgb(255, 255, 0, 255));
            RegisterPresetColor("gainsboro", Color.FromArgb(255, 220, 220, 220));
            RegisterPresetColor("ghostWhite", Color.FromArgb(255, 248, 248, 255));
            RegisterPresetColor("gold", Color.FromArgb(255, 255, 215, 0));
            RegisterPresetColor("goldenrod", Color.FromArgb(255, 218, 165, 32));
            RegisterPresetColor("gray", Color.FromArgb(255, 128, 128, 128));
            RegisterPresetColor("green", Color.FromArgb(255, 0, 128, 0));
            RegisterPresetColor("greenYellow", Color.FromArgb(255, 173, 255, 47));
            RegisterPresetColor("honeydew", Color.FromArgb(255, 240, 255, 240));
            RegisterPresetColor("hotPink", Color.FromArgb(255, 255, 105, 180));
            RegisterPresetColor("indianRed", Color.FromArgb(255, 205, 92, 92));
            RegisterPresetColor("indigo", Color.FromArgb(255, 75, 0, 130));
            RegisterPresetColor("ivory", Color.FromArgb(255, 255, 255, 240));
            RegisterPresetColor("khaki", Color.FromArgb(255, 240, 230, 140));
            RegisterPresetColor("lavender", Color.FromArgb(255, 230, 230, 250));
            RegisterPresetColor("lavenderBlush", Color.FromArgb(255, 255, 240, 245));
            RegisterPresetColor("lawnGreen", Color.FromArgb(255, 124, 252, 0));
            RegisterPresetColor("lemonChiffon", Color.FromArgb(255, 255, 250, 205));
            RegisterPresetColor("lime", Color.FromArgb(255, 0, 255, 0));
            RegisterPresetColor("limeGreen", Color.FromArgb(255, 50, 205, 50));
            RegisterPresetColor("linen", Color.FromArgb(255, 250, 240, 230));
            RegisterPresetColor("ltBlue", Color.FromArgb(255, 173, 216, 230));
            RegisterPresetColor("ltCoral", Color.FromArgb(255, 240, 128, 128));
            RegisterPresetColor("ltCyan", Color.FromArgb(255, 224, 255, 255));
            RegisterPresetColor("ltGoldenrodYellow", Color.FromArgb(255, 250, 250, 120));
            RegisterPresetColor("ltGray", Color.FromArgb(255, 211, 211, 211));
            RegisterPresetColor("ltGreen", Color.FromArgb(255, 144, 238, 144));
            RegisterPresetColor("ltPink", Color.FromArgb(255, 255, 182, 193));
            RegisterPresetColor("ltSalmon", Color.FromArgb(255, 255, 160, 122));
            RegisterPresetColor("ltSeaGreen", Color.FromArgb(255, 32, 178, 170));
            RegisterPresetColor("ltSkyBlue", Color.FromArgb(255, 135, 206, 250));
            RegisterPresetColor("ltSlateGray", Color.FromArgb(255, 119, 136, 153));
            RegisterPresetColor("ltSteelBlue", Color.FromArgb(255, 176, 196, 222));
            RegisterPresetColor("ltYellow", Color.FromArgb(255, 255, 255, 224));
            RegisterPresetColor("magenta", Color.FromArgb(255, 255, 0, 255));
            RegisterPresetColor("maroon", Color.FromArgb(255, 128, 0, 0));
            RegisterPresetColor("medAquamarine", Color.FromArgb(255, 102, 205, 170));
            RegisterPresetColor("medBlue", Color.FromArgb(255, 0, 0, 205));
            RegisterPresetColor("medOrchid", Color.FromArgb(255, 186, 85, 211));
            RegisterPresetColor("medPurple", Color.FromArgb(255, 147, 112, 219));
            RegisterPresetColor("medSeaGreen", Color.FromArgb(255, 60, 179, 113));
            RegisterPresetColor("medSlateBlue", Color.FromArgb(255, 123, 104, 238));
            RegisterPresetColor("medSpringGreen", Color.FromArgb(255, 0, 250, 154));
            RegisterPresetColor("medTurquoise", Color.FromArgb(255, 72, 209, 204));
            RegisterPresetColor("medVioletRed", Color.FromArgb(255, 199, 21, 133));
            RegisterPresetColor("midnightBlue", Color.FromArgb(255, 25, 25, 112));
            RegisterPresetColor("mintCream", Color.FromArgb(255, 245, 255, 250));
            RegisterPresetColor("mistyRose", Color.FromArgb(255, 255, 228, 225));
            RegisterPresetColor("moccasin", Color.FromArgb(255, 255, 228, 181));
            RegisterPresetColor("navajoWhite", Color.FromArgb(255, 255, 222, 173));
            RegisterPresetColor("navy", Color.FromArgb(255, 0, 0, 128));
            RegisterPresetColor("oldLace", Color.FromArgb(255, 253, 245, 230));
            RegisterPresetColor("olive", Color.FromArgb(255, 128, 128, 0));
            RegisterPresetColor("oliveDrab", Color.FromArgb(255, 107, 142, 35));
            RegisterPresetColor("orange", Color.FromArgb(255, 255, 165, 0));
            RegisterPresetColor("orangeRed", Color.FromArgb(255, 255, 69, 0));
            RegisterPresetColor("orchid", Color.FromArgb(255, 218, 112, 214));
            RegisterPresetColor("paleGoldenrod", Color.FromArgb(255, 238, 232, 170));
            RegisterPresetColor("paleGreen", Color.FromArgb(255, 152, 251, 152));
            RegisterPresetColor("paleTurquoise", Color.FromArgb(255, 175, 238, 238));
            RegisterPresetColor("paleVioletRed", Color.FromArgb(255, 219, 112, 147));
            RegisterPresetColor("papayaWhip", Color.FromArgb(255, 255, 239, 213));
            RegisterPresetColor("peachPuff", Color.FromArgb(255, 255, 218, 185));
            RegisterPresetColor("peru", Color.FromArgb(255, 205, 133, 63));
            RegisterPresetColor("pink", Color.FromArgb(255, 255, 192, 203));
            RegisterPresetColor("plum", Color.FromArgb(255, 221, 160, 221));
            RegisterPresetColor("powderBlue", Color.FromArgb(255, 176, 224, 230));
            RegisterPresetColor("purple", Color.FromArgb(255, 128, 0, 128));
            RegisterPresetColor("red", Color.FromArgb(255, 255, 0, 0));
            RegisterPresetColor("rosyBrown", Color.FromArgb(255, 188, 143, 143));
            RegisterPresetColor("royalBlue", Color.FromArgb(255, 65, 105, 225));
            RegisterPresetColor("saddleBrown", Color.FromArgb(255, 139, 69, 19));
            RegisterPresetColor("salmon", Color.FromArgb(255, 250, 128, 114));
            RegisterPresetColor("sandyBrown", Color.FromArgb(255, 244, 164, 96));
            RegisterPresetColor("seaGreen", Color.FromArgb(255, 46, 139, 87));
            RegisterPresetColor("seaShell", Color.FromArgb(255, 255, 245, 238));
            RegisterPresetColor("sienna", Color.FromArgb(255, 160, 82, 45));
            RegisterPresetColor("silver", Color.FromArgb(255, 192, 192, 192));
            RegisterPresetColor("skyBlue", Color.FromArgb(255, 135, 206, 235));
            RegisterPresetColor("slateBlue", Color.FromArgb(255, 106, 90, 205));
            RegisterPresetColor("slateGray", Color.FromArgb(255, 112, 128, 144));
            RegisterPresetColor("snow", Color.FromArgb(255, 255, 250, 250));
            RegisterPresetColor("springGreen", Color.FromArgb(255, 0, 255, 127));
            RegisterPresetColor("steelBlue", Color.FromArgb(255, 70, 130, 180));
            RegisterPresetColor("tan", Color.FromArgb(255, 210, 180, 140));
            RegisterPresetColor("teal", Color.FromArgb(255, 0, 128, 128));
            RegisterPresetColor("thistle", Color.FromArgb(255, 216, 191, 216));
            RegisterPresetColor("tomato", Color.FromArgb(255, 255, 99, 71));
            RegisterPresetColor("turquoise", Color.FromArgb(255, 64, 224, 208));
            RegisterPresetColor("violet", Color.FromArgb(255, 238, 130, 238));
            RegisterPresetColor("wheat", Color.FromArgb(255, 245, 222, 179));
            RegisterPresetColor("white", Color.FromArgb(255, 255, 255, 255));
            RegisterPresetColor("whiteSmoke", Color.FromArgb(255, 245, 245, 245));
            RegisterPresetColor("yellow", Color.FromArgb(255, 255, 255, 0));
            RegisterPresetColor("yellowGreen", Color.FromArgb(255, 154, 205, 50));
        }

        private static void RegisterPresetColor(string name, Color color)
        {
            presetColors[name] = color;
        }
    }
}
