﻿using System;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Model.Types;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal class RefConverter : IStringConverter<Ref>
    {
        public Ref ConvertFromString(string value)
        {
            Guard.ThrowExceptionIfNullOrEmpty(value, "value");

            string[] rangeParts = value.Split(new string[] { SpreadsheetCultureHelper.Colon }, StringSplitOptions.RemoveEmptyEntries);
            
            CellRef startCellRef = new CellRef(rangeParts[0]);
            CellRef endCellRef = rangeParts.Length > 1 ? new CellRef(rangeParts[1]) : new CellRef(rangeParts[0]);

            return new Ref(startCellRef, endCellRef);
        }

        public string ConvertToString(Ref value)
        {
            return NameConverter.ConvertCellRangeToName(value.StartCellRef.ToCellIndex(), value.EndCellRef.ToCellIndex());
        }
    }
}
