﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Spreadsheet.Layout;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal static class TypeMappers
    {
        static TypeMappers()
        {
            InitializeSheetVisibilityMapper();
            InitializeViewportTypeMapper();
            InitializeViewportStateMapper();
        }

        public static ValueMapper<string, SheetVisibility> SheetVisibilityMapper { get; private set; }

        public static ValueMapper<string, ViewportPaneType> ViewportTypeMapper { get; private set; }

        public static ValueMapper<string, PaneState> ViewportStateMapper { get; private set; }

        private static void InitializeSheetVisibilityMapper()
        {
            SheetVisibilityMapper = new ValueMapper<string, SheetVisibility>("visible", SheetVisibility.Visible);
            SheetVisibilityMapper.AddPair("hidden", SheetVisibility.Hidden);
            SheetVisibilityMapper.AddPair("veryHidden", SheetVisibility.VeryHidden);
        }

        private static void InitializeViewportTypeMapper()
        {
            ViewportTypeMapper = new ValueMapper<string, ViewportPaneType>("topLeft", ViewportPaneType.Fixed);
            ViewportTypeMapper.AddPair("bottomRight", ViewportPaneType.Scrollable);
            ViewportTypeMapper.AddPair("topRight", ViewportPaneType.HorizontalScrollable);
            ViewportTypeMapper.AddPair("bottomLeft", ViewportPaneType.VerticalScrollable);
        }

        private static void InitializeViewportStateMapper()
        {
            ViewportStateMapper = new ValueMapper<string, PaneState>("frozen", PaneState.Frozen);
        }
    }
}