﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal static class UnderlineValues
    {
        public static readonly string Double = "double";
        public static readonly string DoubleAccounting = "doubleAccounting";
        public static readonly string None = "none";
        public static readonly string Single = "single";
        public static readonly string SingleAccounting = "singleAccounting";
        
        private static readonly ValueMapper<string, UnderlineType> nameToValueMapper;

        static UnderlineValues()
        {
            nameToValueMapper = new ValueMapper<string, UnderlineType>();

            nameToValueMapper.AddPair(Double, UnderlineType.Double);
            nameToValueMapper.AddPair(DoubleAccounting, UnderlineType.DoubleAccounting);
            nameToValueMapper.AddPair(Single, UnderlineType.Single);
            nameToValueMapper.AddPair(SingleAccounting, UnderlineType.SingleAccounting);
            nameToValueMapper.AddPair(None, UnderlineType.None);
        }

        public static string GetUnderlineValueName(UnderlineType underline)
        {
            return nameToValueMapper.GetFromValue(underline);
        }

        public static UnderlineType GetUnderlineValue(string name)
        {
            Guard.ThrowExceptionIfNullOrEmpty(name, "name");

            return nameToValueMapper.GetToValue(name);
        }
    }
}