﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal static class VerticalAlignments
    {
        public static readonly string Bottom = "bottom";
        public static readonly string Center = "center";
        public static readonly string Distributed = "distributed";
        public static readonly string Justify = "justify";
        public static readonly string Top = "top";

        private static readonly ValueMapper<string, RadVerticalAlignment> nameToValueMapper;

        static VerticalAlignments()
        {
            nameToValueMapper = new ValueMapper<string, RadVerticalAlignment>();
            nameToValueMapper.AddPair(Bottom, RadVerticalAlignment.Bottom);
            nameToValueMapper.AddPair(Center, RadVerticalAlignment.Center);
            nameToValueMapper.AddPair(Distributed, RadVerticalAlignment.Distributed);
            nameToValueMapper.AddPair(Justify, RadVerticalAlignment.Justify);
            nameToValueMapper.AddPair(Top, RadVerticalAlignment.Top);
        }

        public static string GetVerticalAlignmentName(RadVerticalAlignment verticalAlignment)
        {
            return nameToValueMapper.GetFromValue(verticalAlignment);
        }

        public static RadVerticalAlignment GetVerticalAlignment(string name)
        {
            Guard.ThrowExceptionIfNullOrEmpty(name, "name");

            return nameToValueMapper.GetToValue(name);
        }
    }
}