﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Layout;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal static class ViewportPaneHelper
    {
        public static ViewportPaneType GetActivePaneType(Pane contextPane)
        {
            int frozenRowIndex = contextPane.YSplit;
            int frozenColumnIndex = contextPane.XSplit;

            if (frozenRowIndex > 0 && frozenColumnIndex > 0)
            {
                return ViewportPaneType.Scrollable; // BottomRight
            }
            else if (frozenRowIndex == 0 && frozenColumnIndex > 0)
            {
                return ViewportPaneType.HorizontalScrollable; // TopRight
            }
            else
            {
                return ViewportPaneType.VerticalScrollable; // BottomLeft
            }
        }
    }
}