﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model.Types
{
    internal static class XlsxConverters
    {
        private static readonly ErrorsPrintStyleConverter errorsPrintStyleConverter;
        private static readonly PageOrderConverter pageOrderConverter;
        private static readonly PaperTypesConverter paperTypesConverter;
        private static readonly ComparisonOperatorConverter comparisonOperatorConverter;
        private static readonly DynamicFilterTypeConverter dynamicFilterTypeConverter;
        private static readonly DateTimeGroupingTypeConverter dateTimeGroupingTypeConverter;
        private static readonly CellRefConverter cellRefConverter;
        private static readonly CellRefRangeConverter cellRefRangeConverter;
        private static readonly RefConverter refConverter;
        private static readonly CellRefRangeSequenceConverter cellRefRangeSequenceConverter;
        private static readonly ErrorStyleConverter errorStyleConverter;
        private static readonly DataValidationRuleTypeConverter dataValidationRuleTypeConverter;

        static XlsxConverters()
        {
            errorsPrintStyleConverter = new ErrorsPrintStyleConverter();
            pageOrderConverter = new PageOrderConverter();
            paperTypesConverter = new PaperTypesConverter();
            comparisonOperatorConverter = new ComparisonOperatorConverter();
            dynamicFilterTypeConverter = new DynamicFilterTypeConverter();
            dateTimeGroupingTypeConverter = new DateTimeGroupingTypeConverter();
            cellRefConverter = new CellRefConverter();
            cellRefRangeConverter = new CellRefRangeConverter();
            refConverter = new RefConverter();
            cellRefRangeSequenceConverter = new CellRefRangeSequenceConverter();
            errorStyleConverter = new ErrorStyleConverter();
            dataValidationRuleTypeConverter = new DataValidationRuleTypeConverter();
        }

        public static ErrorsPrintStyleConverter ErrorsPrintStyleConverter
        {
            get
            {
                return errorsPrintStyleConverter;
            }
        }

        public static PageOrderConverter PageOrderConverter
        {
            get
            {
                return pageOrderConverter;
            }
        }

        public static PaperTypesConverter PaperTypesConverter
        {
            get
            {
                return paperTypesConverter;
            }
        }

        public static ComparisonOperatorConverter ComparisonOperatorConverter
        {
            get
            {
                return comparisonOperatorConverter;
            }
        }

        public static DynamicFilterTypeConverter DynamicFilterTypeConverter
        {
            get
            {
                return dynamicFilterTypeConverter;
            }
        }

        public static DateTimeGroupingTypeConverter DateTimeGroupingTypeConverter
        {
            get
            {
                return dateTimeGroupingTypeConverter;
            }
        }

        public static CellRefConverter CellRefConverter
        {
            get
            {
                return cellRefConverter;
            }
        }

        public static CellRefRangeConverter CellRefRangeConverter
        {
            get
            {
                return cellRefRangeConverter;
            }
        }

        public static RefConverter RefConverter
        {
            get
            {
                return refConverter;
            }
        }

        public static CellRefRangeSequenceConverter CellRefRangeSequenceConverter
        {
            get
            {
                return cellRefRangeSequenceConverter;
            }
        }

        public static ErrorStyleConverter ErrorStyleConverter
        {
            get
            {
                return errorStyleConverter;
            }
        }

        public static DataValidationRuleTypeConverter DataValidationRuleTypeConverter
        {
            get
            {
                return dataValidationRuleTypeConverter;
            }
        }
    }
}
