﻿using System;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model
{
    internal static class XlsxElementNames
    {
        public const string DefaultElementName = "Default";
        public const string OverrideElementName = "Override";
        public const string TypesElementName = "Types";
        public const string RelationshipElementName = "Relationship";
        public const string RelationshipsElementName = "Relationships";
        public const string SharedStringTableElementName = "sst";
        public const string StringItemElementName = "si";
        public const string TextElementName = "t";
        public const string RichTextRunElementName = "r";
        public const string UnderlineElementName = "u";
        public const string VerticalAlignmentElementName = "vertAlign";
        public const string AlignmentElementName = "alignment";
        public const string ProtectionElementName = "protection";
        public const string BackgroundColorElementName = "bgColor";
        public const string BoldElementName = "b";
        public const string BorderElementName = "border";
        public const string LeftBorderElementName = "left";
        public const string RightBorderElementName = "right";
        public const string TopBorderElementName = "top";
        public const string BottomBorderElementName = "bottom";
        public const string DiagonalBorderElementName = "diagonal";
        public const string BordersElementName = "borders";
        public const string ColorElementName = "color";
        public const string CellFormatsElementName = "cellXfs";
        public const string FormatElementName = "xf";
        public const string CellStyleElementName = "cellStyle";
        public const string CellStyleFormatsElementName = "cellStyleXfs";
        public const string CellStylesElementName = "cellStyles";
        public const string IndexedColorsElementName = "indexedColors";
        public const string MruColorsElementName = "mruColors";
        public const string GradientFillElementName = "gradientFill";
        public const string PatternFillElementName = "patternFill";
        public const string FillElementName = "fill";
        public const string FillsElementName = "fills";
        public const string FontNameElementName = "name";
        public const string FontFamilyElementName = "family";
        public const string ItalicElementName = "i";
        public const string FontSizeElementName = "sz";
        public const string SchemeElementName = "scheme";
        public const string FontElementName = "font";
        public const string FontsElementName = "fonts";
        public const string ForegroundColorElementName = "fgColor";
        public const string DifferentialFormatsElementName = "dxfs";
        public const string DifferentialFormatElementName = "dxf";
        public const string StopElementName = "stop";
        public const string RgbColorElementName = "rgbColor";
        public const string NumberFormatElementName = "numFmt";
        public const string NumberFormatsElementName = "numFmts";
        public const string StyleSheetElementName = "styleSheet";
        public const string ColorsElementName = "colors";
        public const string SheetElementName = "sheet";
        public const string SheetsElementName = "sheets";
        public const string BookViewsElementName = "bookViews";
        public const string WorkbookViewElementName = "workbookView";
        public const string DefinedNameElementName = "definedName";
        public const string DefinedNamesElementName = "definedNames";
        public const string WorkbookElementName = "workbook";
        public const string WorkbookProtectionElementName = "workbookProtection";
        public const string CellElementName = "c";
        public const string FormulaElementName = "f";
        public const string CellValueElementName = "v";
        public const string ColumnElementName = "col";
        public const string ColumnsElementName = "cols";
        public const string MergedCellElementName = "mergeCell";
        public const string MergedCellsElementName = "mergeCells";
        public const string RowElementName = "row";
        public const string SelectionElementName = "selection";
        public const string PaneElementName = "pane";
        public const string SheetViewsElementName = "sheetViews";
        public const string SheetViewElementName = "sheetView";
        public const string SheetPropertiesElementName = "sheetPr";
        public const string OutlinePropertiesElementName = "outlinePr";
        public const string SheetDataElementName = "sheetData";
        public const string PageMarginsElementName = "pageMargins";
        public const string PageSetupElementName = "pageSetup";
        public const string PageSetUpPropertiesElementName = "pageSetUpPr";
        public const string PrintOptionsElementName = "printOptions";
        public const string HeaderFooterElementName = "headerFooter";
        public const string OddHeaderElementName = "oddHeader";
        public const string OddFooterElementName = "oddFooter";
        public const string EvenHeaderElementName = "evenHeader";
        public const string EvenFooterElementName = "evenFooter";
        public const string FirstHeaderElementName = "firstHeader";
        public const string FirstFooterElementName = "firstFooter";
        public const string SheetProtectionElementName = "sheetProtection";
        public const string AutoFilterElementName = "autoFilter";
        public const string FilterColumnElementName = "filterColumn";
        public const string FiltersElementName = "filters";
        public const string DateGroupItemElementName = "dateGroupItem";
        public const string FilterElementName = "filter";
        public const string CustomFiltersElementName = "customFilters";
        public const string CustomFilterElementName = "customFilter";
        public const string ColorFilterElementName = "colorFilter";
        public const string Top10FilterElementName = "top10";
        public const string DynamicFilterElementName = "dynamicFilter";
        public const string WorksheetElementName = "worksheet";
        public const string SheetFormatPropertiesElementName = "sheetFormatPr";
        public const string ThemeElementName = "theme";
        public const string ThemeElementsElementName = "themeElements";
        public const string ColorSchemeElementName = "clrScheme";
        public const string HslColorModelElementName = "hslClr";
        public const string PresetColorElementName = "prstClr";
        public const string SchemeColorElementName = "schemeClr";
        public const string RgbColorModelElementName = "scrgbClr";
        public const string RgbHexColorModelElementName = "srgbClr";
        public const string Accent1ElementName = "accent1";
        public const string Accent2ElementName = "accent2";
        public const string Accent3ElementName = "accent3";
        public const string Accent4ElementName = "accent4";
        public const string Accent5ElementName = "accent5";
        public const string Accent6ElementName = "accent6";
        public const string Dark1ElementName = "dk1";
        public const string Dark2ElementName = "dk2";
        public const string FollowedHyperlinkElementName = "folHlink";
        public const string HlinkElementName = "hlink";
        public const string Light1ElementName = "lt1";
        public const string Light2ElementName = "lt2";
        public const string FontSchemeElementName = "fontScheme";
        public const string MajorFontElementName = "majorFont";
        public const string MinorFontElementName = "minorFont";
        public const string LatinFontElementName = "latin";
        public const string EastAsianFontElementName = "ea";
        public const string ComplexScriptFontElementName = "cs";
        public const string FormatSchemeElementName = "fmtScheme";
        public const string BackgroundFillStyleListElementName = "bgFillStyleLst";
        public const string FillStyleListElementName = "fillStyleLst";
        public const string NoFillElementName = "noFill";
        public const string EffectStyleListElementName = "effectStyleLst";
        public const string EffectStyleElementName = "effectStyle";
        public const string EffectContainerElementName = "effectLst";
        public const string LineStyleListElementName = "lnStyleLst";
        public const string OutlineElementName = "ln";
        public const string SystemColorElementName = "sysClr";
        public const string HyperlinksElementName = "hyperlinks";
        public const string HyperlinkElementName = "hyperlink";
        public const string WorksheetDrawingElementName = "wsDr";
        public const string TwoCellAnchorElementName = "twoCellAnchor";
        public const string DrawingElementName = "drawing";
        public const string OneCellAnchorElementName = "oneCellAnchor";
        public const string AbsoluteAnchorElementName = "absoluteAnchor";
        public const string RowBreaksElementName = "rowBreaks";
        public const string ColumnBreaksElementName = "colBreaks";
        public const string BreakElementName = "brk";
        public const string SortStateElementName = "sortState";
        public const string SortConditionElementName = "sortCondition";
        public const string DimensionElementName = "dimension";
        public const string RichTextInlineElementName = "is";
        public const string DataValidationsElementName = "dataValidations";
        public const string DataValidationElementName = "dataValidation";
        public const string Formula1ElementName = "formula1";
        public const string Formula2ElementName = "formula2";
        public const string SqRefElementName = "sqref";
        
        // Drawing
        public const string Column = "col";
        public const string ColumnOffset = "colOff";
        public const string Row = "row";
        public const string RowOffset = "rowOff";
        public const string From = "from";
        public const string To = "to";
        public const string Picture = "pic";
        public const string ClientData = "clientData";
        public const string BlipFill = "blipFill";
        public const string ShapePropertiesElementName = "spPr";
        public const string Position = "pos";
        public const string Extent = "ext";
    }
}
