﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Common.Model.Data;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Model;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx.Utilities
{
    internal static class XlsxHelper
    {
        private static readonly SpreadsheetCultureHelper cultureInfo;

        static XlsxHelper()
        {
            cultureInfo = new SpreadsheetCultureHelper(System.Globalization.CultureInfo.InvariantCulture);
        }

        public static SpreadsheetCultureHelper CultureInfo
        {
            get
            {
                return cultureInfo;
            }
        }

        public static double ConvertColumnPixelWidthToExcelWidth(Workbook workbook, double columnWidthInPixels)
        {
            Guard.ThrowExceptionIfNull(workbook, "workbook");

            double result = 0;
            
            // TODO: Remove the check when hidden columns are added
            if (columnWidthInPixels > 0)
            {
                result = UnitHelper.PixelWidthToExcelColumnWidth(workbook, columnWidthInPixels);
            }

            return result;
        }

        public static double ConvertColumnExcelWidthToPixelWidth(Workbook workbook, double excelWidth)
        {
            Guard.ThrowExceptionIfNull(workbook, "workbook");

            return UnitHelper.ExcelColumnWidthToPixelWidth(workbook, excelWidth);
        }

        public static string CreateResourceName(IResource resource)
        {
            return string.Format(XlsxPartNames.ResourcePartName, resource.Name);
        }
    }
}