﻿using System.Windows;
using System.Windows.Media.Imaging;
using Telerik.Windows.Documents.Fixed.Model.Editing;
using Telerik.Windows.Documents.Spreadsheet.Layout.Layers;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.Pdf.Export
{
    internal class DefaultPdfChartToImageRenderer : IPdfChartRenderer
    {
        private const int DpiHorizontal = 300;
        private const int DpiVertical = 300;

        private readonly IChartModelToImageConverter chartToImageConverter;

        public DefaultPdfChartToImageRenderer(IChartModelToImageConverter chartToImageConverter)
        {
            this.chartToImageConverter = chartToImageConverter;
        }

        public void RenderChart(FixedContentEditor editor, FloatingChartShape chart)
        {
            BitmapSource source = this.chartToImageConverter.GetBitmapSourceFromFloatingChartShape(chart, DpiHorizontal, DpiVertical);

            editor.DrawImage(SpreadsheetHelper.StreamFromBitmapSource(source), new Size(chart.Width, chart.Height));
        }
    }
}
