﻿using Telerik.Windows.Documents.Fixed.Model.Editing;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.Pdf.Export
{
    /// <summary>
    /// Defines members for classes which will be used to render charts when exporting a workbook to PDF.
    /// </summary>
    public interface IPdfChartRenderer
    {
        /// <summary>
        /// Renders the chart.
        /// </summary>
        /// <param name="editor">The editor which will render the chart.</param>
        /// <param name="chart">The chart to be rendered.</param>
        void RenderChart(FixedContentEditor editor, FloatingChartShape chart);
    }
}
