﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Editing;
using Telerik.Windows.Documents.Spreadsheet.Layout.Layers;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.Pdf.Export.Layers
{
    internal class CellBordersPdfLayer : PdfLayerBase
    {
        private readonly PdfLineRenderer lineRenderer;
        private readonly CellBordersLayer cellBordersLayer;
        
        public CellBordersPdfLayer()
        {
            this.lineRenderer = new PdfLineRenderer();
            this.cellBordersLayer = new CellBordersLayer(this.lineRenderer, true);
        }

        public override string Name
        {
            get
            {
                return WorksheetPredefinedPdfLayers.CellBorders;
            }
        }

        public override void UpdateRenderOverride(PdfPrintWorksheetRenderUpdateContext updateContext, FixedContentEditor editor)
        {
            this.lineRenderer.Editor = editor;
            this.cellBordersLayer.UpdateRender(updateContext);
        }
    }
}
