﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Editing;
using Telerik.Windows.Documents.Spreadsheet.Layout.Layers;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.Pdf.Export.Layers
{
    internal class CellValuesPdfLayer : PdfLayerBase
    {
        private readonly PdfTextRenderer textRenderer;
        private readonly CellValuesLayer cellValuesLayer;

        public CellValuesPdfLayer()
        {
            this.textRenderer = new PdfTextRenderer();
            this.cellValuesLayer = new CellValuesLayer(this.textRenderer);
        }

        public override string Name
        {
            get
            {
                return WorksheetPredefinedPdfLayers.CellValues;
            }
        }

        public override void UpdateRenderOverride(PdfPrintWorksheetRenderUpdateContext updateContext, FixedContentEditor editor)
        {
            this.textRenderer.Editor = editor;
            this.cellValuesLayer.UpdateRender(updateContext);
        }
    }
}
