﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Editing;
using Telerik.Windows.Documents.Spreadsheet.Layout.Layers;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.Pdf.Export.Layers
{
    internal class GridlinesOutlinePdfLayer : PdfLayerBase
    {
        private readonly PdfLineRenderer lineRenderer;
        private readonly GridlinesOutlinesLayer gridlinesOutlinesLayer;

        public GridlinesOutlinePdfLayer()
        {
            this.lineRenderer = new PdfLineRenderer();
            this.gridlinesOutlinesLayer = new GridlinesOutlinesLayer(this.lineRenderer);
        }

        public override string Name
        {
            get
            {
                return WorksheetPredefinedPdfLayers.GridlinesOutline;
            }
        }

        public override void UpdateRenderOverride(PdfPrintWorksheetRenderUpdateContext updateContext, FixedContentEditor editor)
        {
            this.lineRenderer.Editor = editor;
            this.gridlinesOutlinesLayer.UpdateRender(updateContext);
        }
    }
}
