﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Editing;
using Telerik.Windows.Documents.Spreadsheet.Layout.Layers;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.Pdf.Export.Layers
{
    internal class GridlinesPdfLayer : PdfLayerBase
    {
        private readonly PdfLineRenderer lineRenderer;
        private readonly GridlinesLayer gridlinesLayer;

        public GridlinesPdfLayer()
        {
            this.lineRenderer = new PdfLineRenderer();
            this.gridlinesLayer = new GridlinesLayer(this.lineRenderer);
        }

        public override string Name
        {
            get
            {
                return WorksheetPredefinedPdfLayers.Gridlines;
            }
        }

        public override void UpdateRenderOverride(PdfPrintWorksheetRenderUpdateContext updateContext, FixedContentEditor editor)
        {
            this.lineRenderer.Editor = editor;
            this.gridlinesLayer.UpdateRender(updateContext);
        }
    }
}
