﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Editing;
using Telerik.Windows.Documents.Spreadsheet.Layout.Layers;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.Pdf.Export.Layers
{
    internal class HeaderFooterPdfLayer : PdfLayerBase
    {
        private readonly PdfHeaderFooterSectionRenderer sectionRenderer;
        private readonly HeaderFooterLayer headerFooterLayer;

        public HeaderFooterPdfLayer()
        {
            this.sectionRenderer = new PdfHeaderFooterSectionRenderer();
            this.headerFooterLayer = new HeaderFooterLayer(this.sectionRenderer);
        }

        public override string Name
        {
            get
            {
                return WorksheetPredefinedPdfLayers.HeaderFooter;
            }
        }

        public override bool ClipToSheetViewport
        {
            get
            {
                return false;
            }
        }

        public override void UpdateRenderOverride(PdfPrintWorksheetRenderUpdateContext updateContext, FixedContentEditor editor)
        {
            this.sectionRenderer.Editor = editor;
            this.headerFooterLayer.UpdateRender(updateContext);
        }
    }
}
