﻿using System;
using System.Windows.Media;
using Telerik.Windows.Documents.Spreadsheet.Layout;
using Telerik.Windows.Documents.Spreadsheet.Layout.Layers;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.Pdf.Export.Layers
{
    internal abstract class PdfRenderer<T> : PdfRendererBase, IRenderer<T>
        where T : IRenderable
    {
        public void Render(T renderable, ViewportPaneType paneType)
        {
            Guard.ThrowExceptionIfNull(this.Editor, "Editor");

            Matrix oldEditorMatrix = this.Editor.PreserveStates();
            this.RenderOverride(renderable, paneType);
            this.Editor.RestoreStates(oldEditorMatrix);
        }

        public abstract void RenderOverride(T renderable, ViewportPaneType paneType);
    }
}
