﻿using System;
using Telerik.Windows.Documents.Fixed.Model.Editing;
using Telerik.Windows.Documents.Spreadsheet.Layout.Layers;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.Pdf.Export.Layers
{
    internal class ShapesPdfLayer : PdfLayerBase
    {
        private readonly PdfShapeRenderer shapeRenderer;
        private readonly ShapesLayer shapesLayer;

        public ShapesPdfLayer()
        {
            this.shapeRenderer = new PdfShapeRenderer();
#if !SILVERLIGHT
            ShapeSourceFactory cache = new ShapeSourceFactory(new ImageSourceCache(), new ChartPdfSourceFactory());
#else
            ShapeSourceFactory cache = new ShapeSourceFactory(new ImageSourceCache());
#endif
            this.shapesLayer = new ShapesLayer(this.shapeRenderer, cache);
        }

        public override string Name
        {
            get
            {
                return WorksheetPredefinedPdfLayers.Shapes;
            }
        }

        public override void UpdateRenderOverride(PdfPrintWorksheetRenderUpdateContext updateContext, FixedContentEditor editor)
        {
#if !SILVERLIGHT
            this.shapeRenderer.ChartRenderer = updateContext.ChartRenderer;
#endif
            this.shapeRenderer.Editor = editor;
            this.shapesLayer.UpdateRender(updateContext);
        }
    }
}
