﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Layout.Layers;

namespace Telerik.Windows.Documents.Spreadsheet.FormatProviders.Pdf.Export.Layers
{
    internal static class WorksheetPredefinedPdfLayers
    {
        #region Constants

        /// <summary>
        /// The name of the grid lines layer.
        /// </summary>
        public const string Gridlines = WorksheetPredefinedLayers.Gridlines;

        /// <summary>
        /// The name of the grid lines outline layer.
        /// </summary>
        public const string GridlinesOutline = WorksheetPredefinedLayers.GridlinesOutline;

        /// <summary>
        /// The name of the cell fill layer.
        /// </summary>
        public const string CellFill = WorksheetPredefinedLayers.CellFill;

        /// <summary>
        /// The name of the cell borders layer.
        /// </summary>
        public const string CellBorders = WorksheetPredefinedLayers.CellBorders;

        /// <summary>
        /// The name of the cell values layer.
        /// </summary>
        public const string CellValues = WorksheetPredefinedLayers.CellValues;

        /// <summary>
        /// The name of the shapes layer.
        /// </summary>
        public const string Shapes = WorksheetPredefinedLayers.Shapes;

        /// <summary>
        /// The name of the row heading margin layer.
        /// </summary>
        public const string RowHeadingMargin = WorksheetPredefinedLayers.RowHeadingMargin;

        /// <summary>
        /// The name of the column heading margin layer.
        /// </summary>
        public const string ColumnHeadingMargin = WorksheetPredefinedLayers.ColumnHeadingMargin;

        /// <summary>
        /// The name of the header/footer layer.
        /// </summary>
        public const string HeaderFooter = WorksheetPredefinedLayers.HeaderFooter;

        #endregion
    }
}
