﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Expressions;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests
{
	[TestClass]
	public class CellReferenceTests
	{
		#region Helper Methods

		public static Worksheet CreateWorksheet()
		{
			Workbook workbook = new Workbook();
			workbook.Sheets.Add(SheetType.Worksheet);
			return workbook.ActiveWorksheet;
		}

        //private static void AssertCellReference(CellReference cellReference,
        //    int expectedActualRowIndex, int expectedActualColumnIndex,
        //    bool expectedIsRowAbsolute, bool expectedIsColumnAbsolute,
        //    int expectedRowOffset = 0, int expectedColumnOffset = 0)
        //{
        //    Assert.AreEqual(expectedActualRowIndex, cellReference.ActualRowIndex);
        //    Assert.AreEqual(expectedActualColumnIndex, cellReference.ActualColumnIndex);
        //    Assert.AreEqual(expectedIsRowAbsolute, cellReference.IsRowAbsolute);
        //    Assert.AreEqual(expectedIsColumnAbsolute, cellReference.IsColumnAbsolute);

        //    Assert.AreEqual(expectedRowOffset, cellReference.RowOffset);
        //    Assert.AreEqual(expectedColumnOffset, cellReference.ColumnOffset);
        //}

        //private static void AssertCellReferenceRange(CellReferenceRange cellReferenceRange,
        //   int expectedActualRowIndex, int expectedActualColumnIndex,
        //   bool expectedIsRowAbsolute, bool expectedIsColumnAbsolute,
        //   int expectedRowOffset = 0, int expectedColumnOffset = 0)
        //{
        //    Assert.AreEqual(expectedActualRowIndex, cellReferenceRange.FromIndex.ActualRowIndex);
        //    Assert.AreEqual(expectedActualColumnIndex, cellReferenceRange.FromIndex.ActualColumnIndex);
        //    Assert.AreEqual(expectedIsRowAbsolute, cellReferenceRange.FromIndex.IsRowAbsolute);
        //    Assert.AreEqual(expectedIsColumnAbsolute, cellReferenceRange.FromIndex.IsColumnAbsolute);

        //    Assert.AreEqual(expectedRowOffset, cellReferenceRange.FromIndex.RowOffset);
        //    Assert.AreEqual(expectedColumnOffset, cellReferenceRange.FromIndex.ColumnOffset);

        //    Assert.AreEqual(expectedActualRowIndex, cellReferenceRange.ToIndex.ActualRowIndex);
        //    Assert.AreEqual(expectedActualColumnIndex, cellReferenceRange.ToIndex.ActualColumnIndex);
        //    Assert.AreEqual(expectedIsRowAbsolute, cellReferenceRange.ToIndex.IsRowAbsolute);
        //    Assert.AreEqual(expectedIsColumnAbsolute, cellReferenceRange.ToIndex.IsColumnAbsolute);

        //    Assert.AreEqual(expectedRowOffset, cellReferenceRange.ToIndex.RowOffset);
        //    Assert.AreEqual(expectedColumnOffset, cellReferenceRange.ToIndex.ColumnOffset);
        //}

        //private static void AssertCellReferenceRangeFromTo(CellReferenceRange cellReferenceRange, int expectedActualRowFromIndex, int expectedActualColumnFromIndex,
        //    bool expectedIsRowAbsoluteFrom, bool expectedIsColumnAbsoluteFrom, int expectedActualRowToIndex, int expectedActualColumnToIndex,
        //    bool expectedIsRowAbsoluteTo, bool expectedIsColumnAbsoluteTo)
        //{
        //    Assert.AreEqual(expectedActualRowFromIndex, cellReferenceRange.FromIndex.ActualRowIndex);
        //    Assert.AreEqual(expectedActualColumnFromIndex, cellReferenceRange.FromIndex.ActualColumnIndex);
        //    Assert.AreEqual(expectedIsRowAbsoluteFrom, cellReferenceRange.FromIndex.IsRowAbsolute);
        //    Assert.AreEqual(expectedIsColumnAbsoluteFrom, cellReferenceRange.FromIndex.IsColumnAbsolute);

        //    Assert.AreEqual(expectedActualRowToIndex, cellReferenceRange.ToIndex.ActualRowIndex);
        //    Assert.AreEqual(expectedActualColumnToIndex, cellReferenceRange.ToIndex.ActualColumnIndex);
        //    Assert.AreEqual(expectedIsRowAbsoluteTo, cellReferenceRange.ToIndex.IsRowAbsolute);
        //    Assert.AreEqual(expectedIsColumnAbsoluteTo, cellReferenceRange.ToIndex.IsColumnAbsolute);
        //}

		#endregion
              

		#region Test Methods

      


        //[TestMethod]
        //public void TestCellReferenceRangeCreation()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReferenceRange cellReferenceRange = CellReferenceRange.Create(worksheet, "B3");
        //    AssertCellReferenceRange(cellReferenceRange, 2, 1, false, false);

        //    cellReferenceRange = CellReferenceRange.Create(worksheet, "$B3");
        //    AssertCellReferenceRange(cellReferenceRange, 2, 1, false, true);

        //    cellReferenceRange = CellReferenceRange.Create(worksheet, "B$3");
        //    AssertCellReferenceRange(cellReferenceRange, 2, 1, true, false);

        //    cellReferenceRange = CellReferenceRange.Create(worksheet, "$B$3");
        //    AssertCellReferenceRange(cellReferenceRange, 2, 1, true, true);
        //}

        //[TestMethod]
        //public void TestCellReferenceWithInsertRow()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReferenceRange cellReferenceRange = CellReferenceRange.Create(worksheet, "B3");
        //    AssertCellReferenceRange(cellReferenceRange, 2, 1, false, false);

        //    // Before - affects.
        //    worksheet.Rows.Insert(1, 2);
        //    AssertCellReferenceRange(cellReferenceRange, 4, 1, false, false);

        //    // After - does not affect.
        //    worksheet.Rows.Insert(5, 2);
        //    AssertCellReferenceRange(cellReferenceRange, 4, 1, false, false);

        //    // Over - affects.
        //    worksheet.Rows.Insert(4, 2);
        //    AssertCellReferenceRange(cellReferenceRange, 6, 1, false, false);
        //}

        //[TestMethod]
        //public void TestCellReferenceRangeWithInsertRow()
        //{
        //    Worksheet worksheet = CreateWorksheet();

        //    RelativeCellIndex B3 = new RelativeCellIndex(false, 2, false, 1);
        //    RelativeCellIndex C5 = new RelativeCellIndex(false, 4, false, 2);
        //    CellReferenceRange cellReferenceRange = new CellReferenceRange(worksheet, B3, C5);

        //    AssertCellReferenceRangeFromTo(cellReferenceRange, 2, 1, false, false, 4, 2, false, false);

        //    // Before - affects.
        //    worksheet.Rows.Insert(1, 2);
        //    AssertCellReferenceRangeFromTo(cellReferenceRange, 4, 1, false, false, 6, 2, false, false);

        //    // In - affects only ToIndex
        //    worksheet.Rows.Insert(6, 2);
        //    AssertCellReferenceRangeFromTo(cellReferenceRange, 4, 1, false, false, 8, 2, false, false);

        //    // After - does not affect.
        //    worksheet.Rows.Insert(10, 2);
        //    AssertCellReferenceRangeFromTo(cellReferenceRange, 4, 1, false, false, 8, 2, false, false);
        //}

        //[TestMethod]
        //public void TestCellReferenceWithRemoveRow()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReferenceRange cellReferenceRange = CellReferenceRange.Create(worksheet, "B6");
        //    AssertCellReferenceRange(cellReferenceRange, 5, 1, false, false);

        //    // Before - affects.
        //    worksheet.Rows.Remove(1, 2);
        //    AssertCellReferenceRange(cellReferenceRange, 3, 1, false, false);

        //    // After - does not affect.
        //    worksheet.Rows.Remove(4, 2);
        //    AssertCellReferenceRange(cellReferenceRange, 3, 1, false, false);

        //    // TODO: OVER
        //}

        //[TestMethod]
        //public void TestCellReferenceWithRemoveRow()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReference cellReference = CellReference.Create(worksheet, "B6");
        //    AssertCellReference(cellReference, 5, 1, false, false);

        //    // Before - affects.
        //    worksheet.Rows.Remove(1, 2);
        //    AssertCellReference(cellReference, 3, 1, false, false);

        //    // After - does not affect.
        //    worksheet.Rows.Remove(4, 2);
        //    AssertCellReference(cellReference, 3, 1, false, false);

        //    // TODO: OVER
        //}

        //[TestMethod]
        //public void TestCellReferenceCreation()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReference cellReference = CellReference.Create(worksheet, "B3");
        //    AssertCellReference(cellReference, 2, 1, false, false);


        //    cellReference = CellReference.Create(worksheet, "$B3");
        //    AssertCellReference(cellReference, 2, 1, false, true);

        //    cellReference = CellReference.Create(worksheet, "B$3");
        //    AssertCellReference(cellReference, 2, 1, true, false);

        //    cellReference = CellReference.Create(worksheet, "$B$3");
        //    AssertCellReference(cellReference, 2, 1, true, true);
        //}


        //[TestMethod]
        //public void TestCellReferenceWithInsertRow()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReference cellReference = CellReference.Create(worksheet, "B3");
        //    AssertCellReference(cellReference, 2, 1, false, false);

        //    // Before - affects.
        //    worksheet.Rows.Insert(1, 2);
        //    AssertCellReference(cellReference, 4, 1, false, false);

        //    // After - does not affect.
        //    worksheet.Rows.Insert(5, 2);
        //    AssertCellReference(cellReference, 4, 1, false, false);

        //    // Over - affects.
        //    worksheet.Rows.Insert(4, 2);
        //    AssertCellReference(cellReference, 6, 1, false, false);
        //}

        //[TestMethod]
        //public void TestCellReferenceWithRemoveRow()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReference cellReference = CellReference.Create(worksheet, "B6");
        //    AssertCellReference(cellReference, 5, 1, false, false);

        //    // Before - affects.
        //    worksheet.Rows.Remove(1, 2);
        //    AssertCellReference(cellReference, 3, 1, false, false);

        //    // After - does not affect.
        //    worksheet.Rows.Remove(4, 2);
        //    AssertCellReference(cellReference, 3, 1, false, false);

        //    // TODO: OVER
        //}

        //[TestMethod]
        //public void TestCellReferenceWithInsertRowBetweenCellAndActualCell()
        //{
        //    Worksheet worksheet = CreateWorksheet();
			
        //    // B3 is the base cell E6 is the actual cell.
        //    CellReference cellReference = new CellReference(worksheet, false, 2, false, 1, 3, 3);
        //    AssertCellReference(cellReference, 5, 4, false, false, 3, 3);

        //    worksheet.Rows.Insert(4, 2);
        //    AssertCellReference(cellReference, 7, 4, false, false, 5, 3);

        //    cellReference = new CellReference(worksheet, false, 15, false, 5, -3, -3);
        //    AssertCellReference(cellReference, 12, 2, false, false, -3, -3);

        //    worksheet.Rows.Insert(13, 2);
        //    AssertCellReference(cellReference, 12, 2, false, false, -5, -3);
        //}

        //[TestMethod]
        //public void TestCellReferenceWithRemoveRowBetweenCellAndActualCell()
        //{
        //    Worksheet worksheet = CreateWorksheet();

        //    // B3 is the base cell E6 is the actual cell.
        //    CellReference cellReference = new CellReference(worksheet, false, 2, false, 1, 3, 3);
        //    AssertCellReference(cellReference, 5, 4, false, false, 3, 3);

        //    worksheet.Rows.Remove(3, 2);
        //    AssertCellReference(cellReference, 3, 4, false, false, 1, 3);

        //    cellReference = new CellReference(worksheet, false, 15, false, 5, -3, -3);
        //    AssertCellReference(cellReference, 12, 2, false, false, -3, -3);

        //    worksheet.Rows.Remove(13, 2);
        //    AssertCellReference(cellReference, 12, 2, false, false, -1, -3);
        //}


        //[TestMethod]
        //public void TestCellReferenceWithInsertColumn()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReference cellReference = CellReference.Create(worksheet, "B3");
        //    AssertCellReference(cellReference, 2, 1, false, false);

        //    worksheet.Columns.Insert(1, 2);
        //    AssertCellReference(cellReference, 2, 3, false, false);

        //    worksheet.Columns.Insert(5, 2);
        //    AssertCellReference(cellReference, 2, 3, false, false);

        //    worksheet.Columns.Insert(3, 2);
        //    AssertCellReference(cellReference, 2, 5, false, false);
        //}

        //[TestMethod]
        //public void TestCellReferenceWithRemoveColumn()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReference cellReference = CellReference.Create(worksheet, "E6");
        //    AssertCellReference(cellReference, 5, 4, false, false);

        //    // Before - affects.
        //    worksheet.Columns.Remove(1, 2);
        //    AssertCellReference(cellReference, 5, 2, false, false);

        //    // After - does not affect.
        //    worksheet.Columns.Remove(4, 2);
        //    AssertCellReference(cellReference, 5, 2, false, false);

        //    // TODO: OVER
        //}

        //[TestMethod]
        //public void TestCellReferenceWithInsertColumnBetweenCellAndActualCell()
        //{
        //    Worksheet worksheet = CreateWorksheet();

        //    // B3 is the base cell E6 is the actual cell.
        //    CellReference cellReference = new CellReference(worksheet, false, 2, false, 1, 3, 3);
        //    AssertCellReference(cellReference, 5, 4, false, false, 3, 3);

        //    worksheet.Columns.Insert(4, 2);
        //    AssertCellReference(cellReference, 5, 6, false, false, 3, 5);


        //    cellReference = new CellReference(worksheet, false, 15, false, 5, -3, -3);
        //    AssertCellReference(cellReference, 12, 2, false, false, -3, -3);

        //    worksheet.Columns.Insert(3, 2);
        //    AssertCellReference(cellReference, 12, 2, false, false, -3, -5);
        //}

        //[TestMethod]
        //public void TestCellReferenceWithRemoveColumnBetweenCellAndActualCell()
        //{
        //    Worksheet worksheet = CreateWorksheet();

        //    // B3 is the base cell E6 is the actual cell.
        //    CellReference cellReference = new CellReference(worksheet, false, 2, false, 1, 3, 3);
        //    AssertCellReference(cellReference, 5, 4, false, false, 3, 3);

        //    worksheet.Columns.Remove(2, 2);
        //    AssertCellReference(cellReference, 5, 2, false, false, 3, 1);

        //    cellReference = new CellReference(worksheet, false, 15, false, 5, -3, -3);
        //    AssertCellReference(cellReference, 12, 2, false, false, -3, -3);

        //    worksheet.Columns.Remove(3, 2);
        //    AssertCellReference(cellReference, 12, 2, false, false, -3, -1);
        //}


        //[TestMethod]
        //public void TestCellReferenceWithInsertCellsInRow()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReference cellReference = CellReference.Create(worksheet, "B3");
        //    AssertCellReference(cellReference, 2, 1, false, false);

        //    worksheet.Cells.Insert(1, 1, 1, InsertShiftType.Right);
        //    AssertCellReference(cellReference, 2, 1, false, false);

        //    worksheet.Cells.Insert(3, 1, 1, InsertShiftType.Right);
        //    AssertCellReference(cellReference, 2, 1, false, false);

        //    worksheet.Cells.Insert(2, 1, 1, InsertShiftType.Right);
        //    AssertCellReference(cellReference, 2, 2, false, false);

        //    worksheet.Cells.Insert(2, 1, 1, InsertShiftType.Right);
        //    AssertCellReference(cellReference, 2, 3, false, false);

        //    worksheet.Cells.Insert(5, 1, 1, InsertShiftType.Right);
        //    AssertCellReference(cellReference, 2, 3, false, false);
        //}

        //[TestMethod]
        //public void TestCellReferenceWithRemoveCellsInRow()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReference cellReference = CellReference.Create(worksheet, "F3");
        //    AssertCellReference(cellReference, 2, 5, false, false);

        //    worksheet.Cells.Remove(1, 1, 1, RemoveShiftType.Left);
        //    AssertCellReference(cellReference, 2, 5, false, false);

        //    worksheet.Cells.Remove(3, 1, 1, RemoveShiftType.Left);
        //    AssertCellReference(cellReference, 2, 5, false, false);

        //    worksheet.Cells.Remove(2, 1, 1, RemoveShiftType.Left);
        //    AssertCellReference(cellReference, 2, 4, false, false);			

        //    // TODO: OVER
        //}

        //[TestMethod]
        //public void TestCellReferenceWithInsertCellsInRowWithDifferentCellAndActualCell()
        //{
        //    Worksheet worksheet = CreateWorksheet();

        //    // B3 is the base cell E6 is the actual cell.
        //    CellReference cellReference = new CellReference(worksheet, false, 2, false, 1, 3, 3);
        //    AssertCellReference(cellReference, 5, 4, false, false, 3, 3);

        //    worksheet.Cells.Insert(5, 0, 1, InsertShiftType.Right);
        //    AssertCellReference(cellReference, 5, 5, false, false, 3, 4);

        //    worksheet.Cells.Insert(2, 0, 1, InsertShiftType.Right);
        //    AssertCellReference(cellReference, 5, 5, false, false, 3, 3);


        //    cellReference = new CellReference(worksheet, false, 15, false, 5, -3, -3);
        //    AssertCellReference(cellReference, 12, 2, false, false, -3, -3);

        //    worksheet.Cells.Insert(15, 0, 1, InsertShiftType.Right);
        //    AssertCellReference(cellReference, 12, 2, false, false, -3, -4);

        //    worksheet.Cells.Insert(12, 0, 1, InsertShiftType.Right);
        //    AssertCellReference(cellReference, 12, 3, false, false, -3, -3);


        //    worksheet.Cells.Insert(12, 4, 1, InsertShiftType.Right);
        //    AssertCellReference(cellReference, 12, 3, false, false, -3, -3);
        //}

        //[TestMethod]
        //public void TestCellReferenceWithRemoveCellsInRowWithDifferentCellAndActualCell()
        //{
        //    Worksheet worksheet = CreateWorksheet();

        //    // B3 is the base cell E6 is the actual cell.
        //    CellReference cellReference = new CellReference(worksheet, false, 2, false, 1, 3, 3);
        //    AssertCellReference(cellReference, 5, 4, false, false, 3, 3);

        //    worksheet.Cells.Remove(5, 0, 1, RemoveShiftType.Left);
        //    AssertCellReference(cellReference, 5, 3, false, false, 3, 2);

        //    worksheet.Cells.Remove(2, 0, 1, RemoveShiftType.Left);
        //    AssertCellReference(cellReference, 5, 3, false, false, 3, 3);


        //    cellReference = new CellReference(worksheet, false, 15, false, 5, -3, -3);
        //    AssertCellReference(cellReference, 12, 2, false, false, -3, -3);

        //    worksheet.Cells.Remove(12, 0, 1, RemoveShiftType.Left);
        //    AssertCellReference(cellReference, 12, 1, false, false, -3, -4);

        //    worksheet.Cells.Remove(15, 0, 1, RemoveShiftType.Left);
        //    AssertCellReference(cellReference, 12, 1, false, false, -3, -3);
        //}


        //[TestMethod]
        //public void TestCellReferenceWithInsertCellsInColumn()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReference cellReference = CellReference.Create(worksheet, "B3");
        //    AssertCellReference(cellReference, 2, 1, false, false);

        //    worksheet.Cells.Insert(2, 2, 1, InsertShiftType.Down);
        //    AssertCellReference(cellReference, 2, 1, false, false);

        //    worksheet.Cells.Insert(2, 0, 1, InsertShiftType.Down);
        //    AssertCellReference(cellReference, 2, 1, false, false);

        //    worksheet.Cells.Insert(2, 1, 1, InsertShiftType.Down);
        //    AssertCellReference(cellReference, 3, 1, false, false);

        //    worksheet.Cells.Insert(2, 1, 1, InsertShiftType.Down);
        //    AssertCellReference(cellReference, 4, 1, false, false);

        //    worksheet.Cells.Insert(3, 3, 1, InsertShiftType.Down);
        //    AssertCellReference(cellReference, 4, 1, false, false);
        //}

        //[TestMethod]
        //public void TestCellReferenceWithRemoveCellsInColumn()
        //{
        //    Worksheet worksheet = CreateWorksheet();
        //    CellReference cellReference = CellReference.Create(worksheet, "F3");
        //    AssertCellReference(cellReference, 2, 5, false, false);

        //    worksheet.Cells.Remove(1, 1, 1, RemoveShiftType.Up);
        //    AssertCellReference(cellReference, 2, 5, false, false);

        //    worksheet.Cells.Remove(3, 1, 1, RemoveShiftType.Up);
        //    AssertCellReference(cellReference, 2, 5, false, false);

        //    worksheet.Cells.Remove(1, 5, 1, RemoveShiftType.Up);
        //    AssertCellReference(cellReference, 1, 5, false, false);

        //    // TODO: OVER
        //}

        //[TestMethod]
        //public void TestCellReferenceWithInsertCellsInColumnWithDifferentCellAndActualCell()
        //{
        //    Worksheet worksheet = CreateWorksheet();

        //    // B3 is the base cell E6 is the actual cell.
        //    CellReference cellReference = new CellReference(worksheet, false, 2, false, 1, 3, 3);
        //    AssertCellReference(cellReference, 5, 4, false, false, 3, 3);

        //    worksheet.Cells.Insert(0, 4, 1, InsertShiftType.Down);
        //    AssertCellReference(cellReference, 6, 4, false, false, 4, 3);

        //    worksheet.Cells.Insert(2, 1, 1, InsertShiftType.Down);
        //    AssertCellReference(cellReference, 6, 4, false, false, 3, 3);


        //    cellReference = new CellReference(worksheet, false, 15, false, 5, -3, -3);
        //    AssertCellReference(cellReference, 12, 2, false, false, -3, -3);

        //    worksheet.Cells.Insert(15, 5, 1, InsertShiftType.Down);
        //    AssertCellReference(cellReference, 12, 2, false, false, -4, -3);

        //    worksheet.Cells.Insert(11, 2, 1, InsertShiftType.Down);
        //    AssertCellReference(cellReference, 13, 2, false, false, -3, -3);


        //    worksheet.Cells.Insert(12, 4, 1, InsertShiftType.Down);
        //    AssertCellReference(cellReference, 13, 2, false, false, -3, -3);
        //}

        //[TestMethod]
        //public void TestCellReferenceWithRemoveCellsInColumnWithDifferentCellAndActualCell()
        //{
        //    Worksheet worksheet = CreateWorksheet();

        //    // B3 is the base cell E6 is the actual cell.
        //    CellReference cellReference = new CellReference(worksheet, false, 2, false, 1, 3, 3);
        //    AssertCellReference(cellReference, 5, 4, false, false, 3, 3);

        //    worksheet.Cells.Remove(0, 4, 1, RemoveShiftType.Up);
        //    AssertCellReference(cellReference, 4, 4, false, false, 2, 3);

        //    worksheet.Cells.Remove(1, 1, 1, RemoveShiftType.Up);
        //    AssertCellReference(cellReference, 4, 4, false, false, 3, 3);


        //    cellReference = new CellReference(worksheet, false, 15, false, 5, -3, -3);
        //    AssertCellReference(cellReference, 12, 2, false, false, -3, -3);

        //    worksheet.Cells.Remove(14, 5, 1, RemoveShiftType.Up);
        //    AssertCellReference(cellReference, 12, 2, false, false, -2, -3);

        //    worksheet.Cells.Remove(11, 2, 1, RemoveShiftType.Up);
        //    AssertCellReference(cellReference, 11, 2, false, false, -3, -3);


        //    worksheet.Cells.Remove(12, 4, 1, RemoveShiftType.Up);
        //    AssertCellReference(cellReference, 11, 2, false, false, -3, -3);
        //}

		#endregion
	}
}