﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Model.Drawing.Charts;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Shapes;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ChartsTests
{
    [TestClass]
    public class ScatterStylePropertyTests
    {
        [TestMethod]
        public void AssertScatterStyleProperty()
        {
            Workbook workbook = TestHelper.GetWorkbookFromFile("AllScatterStyles.xlsx");

            Worksheet worksheet = workbook.ActiveWorksheet;

            List<FloatingChartShape> charts = worksheet.Shapes.Charts.ToList();

            DocumentChart chart1 = charts[0].Chart;
            SeriesGroup group1 = chart1.SeriesGroups.Single();
            SeriesBase series1 = group1.Series.First();

            Assert.AreEqual(ScatterStyle.Marker, ((ScatterSeries)series1).ScatterStyle);

            DocumentChart chart2 = charts[1].Chart;
            SeriesGroup group2 = chart2.SeriesGroups.Single();
            SeriesBase series2 = group2.Series.First();

            Assert.AreEqual(ScatterStyle.SmoothMarker, ((ScatterSeries)series2).ScatterStyle);

            DocumentChart chart3 = charts[2].Chart;
            SeriesGroup group3 = chart3.SeriesGroups.Single();
            SeriesBase series3 = group3.Series.First();

            Assert.AreEqual(ScatterStyle.Smooth, ((ScatterSeries)series3).ScatterStyle);

            DocumentChart chart4 = charts[3].Chart;
            SeriesGroup group4 = chart4.SeriesGroups.Single();
            SeriesBase series4 = group4.Series.First();

            Assert.AreEqual(ScatterStyle.LineMarker, ((ScatterSeries)series4).ScatterStyle);

            DocumentChart chart5 = charts[4].Chart;
            SeriesGroup group5 = chart5.SeriesGroups.Single();
            SeriesBase series5 = group5.Series.First();

            Assert.AreEqual(ScatterStyle.Line, ((ScatterSeries)series5).ScatterStyle);
        }
    }
}
