﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.FillSeriesTests
{
    public static class ExtensionMethods
    {
        public static CellPropertiesValues GetFormatProperties(this CellSelection sourceCells)
        {
            CellPropertiesValues values = new CellPropertiesValues();

            values.Borders = sourceCells.GetBorders();
            values.Fill = sourceCells.GetFill().Value;
            values.FontFamily = sourceCells.GetFontFamily().Value;
            values.FontSize = sourceCells.GetFontSize().Value;
            values.ForeColor = sourceCells.GetForeColor().Value;
            values.Format = sourceCells.GetFormat().Value;
            values.HorizontalAlignment = sourceCells.GetHorizontalAlignment().Value;
            values.Indent = sourceCells.GetIndent().Value;
            values.IsBold = sourceCells.GetIsBold().Value;
            values.IsItalic = sourceCells.GetIsItalic().Value;
            values.IsWrapped = sourceCells.GetIsWrapped().Value;
            values.StyleName = sourceCells.GetStyleName().Value;
            values.Underline = sourceCells.GetUnderline().Value;
            values.VerticalAlignment = sourceCells.GetVerticalAlignment().Value;

            return values;
        }

        public static void SetProperties(this CellSelection destinationCells, CellPropertiesValues values)
        {
            destinationCells.SetStyleName(values.StyleName);
            destinationCells.SetBorders(values.Borders);
            if (values.Fill != PatternFill.Default)
            {
                destinationCells.SetFill(values.Fill);
            }
            destinationCells.SetFontFamily(values.FontFamily);
            destinationCells.SetFontSize(values.FontSize);
            destinationCells.SetForeColor(values.ForeColor);
            destinationCells.SetFormat(values.Format);
            destinationCells.SetIndent(values.Indent);
            destinationCells.SetHorizontalAlignment(values.HorizontalAlignment);

            destinationCells.SetIsBold(values.IsBold);
            destinationCells.SetIsItalic(values.IsItalic);
            destinationCells.SetIsWrapped(values.IsWrapped);
            destinationCells.SetUnderline(values.Underline);
            destinationCells.SetVerticalAlignment(values.VerticalAlignment);

            destinationCells.SetValue(values.Value);
        }
    }
}