﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class ArrayExpressionTests : ImportExportTestClassBase
    {
        public override Workbook ArrangeWorkbook()
        {
            Workbook workbook = TestHelper.CreateNonEmptyWorkbook();
            Worksheet activeWorksheet = workbook.Worksheets["Sheet1"];

            activeWorksheet.Cells[0, 0].SetValue("={1{als}2{als}3}".ReplaceCultureDependentSeparators());

            return workbook;
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Worksheet worksheet = workbook.Worksheets["Sheet1"];

            Assert.AreEqual("={1{als}2{als}3}".ReplaceCultureDependentSeparators(), worksheet.Cells[0, 0].GetValue().Value.RawValue);
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportArrayExpressionTest()
        {
            ImportFileAndAssert("ImportExportArrayExpressionTestDocument.xlsx");
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ExportAndImportArrayExpressionTest()
        {
            ArrangeWorkbookExportImportAssert();
        }
    }
}