﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class BooleanValuesTests : ImportExportTestClassBase
    {
        public override Workbook ArrangeWorkbook()
        {
            return null;
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Cells cells = workbook.ActiveWorksheet.Cells;

            AssertCellRawValue("TRUE", cells, new CellIndex(0, 0));
            AssertCellRawValue("TRUE", cells, new CellIndex(0, 1));

            AssertCellRawValue("FALSE", cells, new CellIndex(1, 0));
            AssertCellRawValue("FALSE", cells, new CellIndex(1, 1));
        }

        private static void AssertCellRawValue(string expectedResult, Cells cells, CellIndex cellIndex)
        {
            string cellValue = cells[cellIndex].GetValue().Value.GetResultValueAsString(CellValueFormat.GeneralFormat);
            Assert.AreEqual(expectedResult, cellValue);
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportBooleanValuesTest()
        {
            ImportFileAndAssert("ImportBooleanTestDocument.xlsx");
        }
    }
}