﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Model.Drawing.Charts;
using Telerik.Windows.Documents.Model.Drawing.Theming;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;
using Telerik.Windows.Documents.Spreadsheet.Theming;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests.Charts
{
    [TestClass]
    public class ImportExportBubbleChartsTests : ImportExportTestClassBase
    {
        public override Workbook ArrangeWorkbook()
        {
            Workbook workbook = TestHelper.GetWorkbookFromFile("ChartTemplate.xlsx");

            Worksheet worksheet = workbook.ActiveWorksheet;

            // Default bubble
            Model.Shapes.FloatingChartShape chart = worksheet.Shapes.AddChart(
                new CellIndex(0, 0),
                new CellRange(1, 6, 12, 8),
                ChartType.Bubble);

            Model.Shapes.FloatingChartShape chart1 = worksheet.Shapes.AddChart(
                new CellIndex(1, 1),
                new CellRange(1, 6, 12, 8),
                ChartType.Bubble);

            foreach (SeriesGroup group in chart1.Chart.SeriesGroups)
            {
                foreach (SeriesBase series in group.Series)
                {
                    BubbleSeries bubbleSeries = series as BubbleSeries;
                    if (bubbleSeries != null)
                    {
                        series.Outline.Fill = new SolidFill(new ThemableColor(ThemeColorType.Accent1));
                    }
                }
            }

            Model.Shapes.FloatingChartShape chart2 = worksheet.Shapes.AddChart(
                new CellIndex(2, 2),
                new CellRange(1, 6, 12, 8),
                ChartType.Bubble);

            foreach (SeriesGroup group in chart2.Chart.SeriesGroups)
            {
                foreach (SeriesBase series in group.Series)
                {
                    BubbleSeries bubbleSeries = series as BubbleSeries;
                    if (bubbleSeries != null)
                    {
                        series.Outline.Fill = new SolidFill(new ThemableColor(ThemeColorType.Accent1));
                        series.Outline.Width = 15;
                    }
                }
            }

            Model.Shapes.FloatingChartShape chart3 = worksheet.Shapes.AddChart(
                new CellIndex(3, 3),
                new CellRange(1, 6, 12, 8),
                ChartType.Bubble);

            foreach (SeriesGroup group in chart3.Chart.SeriesGroups)
            {
                foreach (SeriesBase series in group.Series)
                {
                    BubbleSeries bubbleSeries = series as BubbleSeries;
                    if (bubbleSeries != null)
                    {
                        series.Outline.Fill = new NoFill();
                    }
                }
            }

            Model.Shapes.FloatingChartShape chart4 = worksheet.Shapes.AddChart(
                new CellIndex(4, 4),
                new CellRange(1, 6, 12, 6),
                ChartType.Bubble);

            return workbook;
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            throw new NotImplementedException();
        }

        [TestMethod]
        public void AssertImportExportBubbleCharts()
        {
            base.ArrangeWorkbookExportImportAssert();
        }
    }
}
