﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.DataValidation;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests.DataValidationTests
{
    [TestClass]
    public class DataValidationExportPerformanceTest
    {
        [TestMethod]
        public void DataValidationExportPerformance_ToXlsxFormat()
        {
            Workbook workbook = new Workbook();
            workbook.Worksheets.Add();

            Worksheet worksheet = workbook.Worksheets[0];

            CellIndex cellIndex = new CellIndex(0, 0);
            NumberDataValidationRuleContext context = new NumberDataValidationRuleContext(worksheet, cellIndex);
            context.Argument1 = "1";
            context.Argument2 = "2";
            context.ComparisonOperator = ComparisonOperator.Between;
            context.IgnoreBlank = true;
            WholeNumberDataValidationRule rule = new WholeNumberDataValidationRule(context);

            worksheet.Cells[SpreadsheetDefaultValues.RowCount - 1, SpreadsheetDefaultValues.ColumnCount - 1].SetDataValidationRule(rule);

            var ranges = worksheet.UsedCellRange;

            XlsxFormatProvider provider = new XlsxFormatProvider();

            DateTime startTime = DateTime.Now;

            provider.Export(workbook);

            double timePassed = (DateTime.Now - startTime).TotalMilliseconds;
            Assert.IsTrue(timePassed <= 3000); // 3 seconds
        }
    }
}
