﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests.FilteringTests
{
    [TestClass]
    public class IconFilterImportTests : ImportExportTestClassBase
    {
        public override Workbook ArrangeWorkbook()
        {
            throw new NotImplementedException();
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Worksheet sheet1 = workbook.Worksheets[0];

            for (int i = 0; i < 10; i++)
            {
                NumberCellValue valueA = (NumberCellValue)sheet1.Cells[i, 0].GetValue().Value;
                Assert.AreEqual(i + 1, valueA.Value);

                NumberCellValue valueB = (NumberCellValue)sheet1.Cells[i, 1].GetValue().Value;
                Assert.AreEqual(10 - i, valueB.Value);
            }
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportTop10FilterTest()
        {
            ImportFileAndAssert("ImportIconFilterTest.xlsx");
        }
    }
}
