﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class ImportCellsAndRowsWithNoReferences : ImportExportTestClassBase
    {
        public override Workbook ArrangeWorkbook()
        {
            throw new NotImplementedException();
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Worksheet worksheet = workbook.Worksheets["Sheet1"];

            string a1 = worksheet.Cells[0, 0, 0, 0].GetValue().Value.RawValue;
            Assert.AreEqual("1", a1);

            string c1 = worksheet.Cells[0, 2, 0, 2].GetValue().Value.RawValue;
            Assert.AreEqual("2", c1);

            string d1 = worksheet.Cells[0, 3, 0, 3].GetValue().Value.RawValue;
            Assert.AreEqual("3", d1);

            string xfd1 = worksheet.Cells[0, SpreadsheetDefaultValues.ColumnCount - 1, 0, SpreadsheetDefaultValues.ColumnCount - 1].GetValue().Value.RawValue;
            Assert.AreEqual("4", xfd1);

            string a3 = worksheet.Cells[2, 0, 2, 0].GetValue().Value.RawValue;
            Assert.AreEqual("5", a3);

            string b3 = worksheet.Cells[2, 1, 2, 1].GetValue().Value.RawValue;
            Assert.AreEqual("6", b3);

            string a4 = worksheet.Cells[3, 0, 3, 0].GetValue().Value.RawValue;
            Assert.AreEqual("7", a4);
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportCellsAndRowsWithNoReferencesTest()
        {
            ImportFileAndAssert("ImportCellsAndRowsWithNoReferences.xlsx");
        }
    }
}
