﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class ImportCsvFormattedValuesTests : ImportExportTestClassBase
    {
        public override Workbook ArrangeWorkbook()
        {
            throw new NotImplementedException();
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Worksheet worksheet = workbook.Worksheets[0];

            CellValueFormat firstFormat = worksheet.Cells[0, 0, 0, 0].GetFormat().Value;
            Assert.AreEqual(new CellValueFormat("0.00%"), firstFormat);

            CellValueFormat secondFormat = worksheet.Cells[1, 0, 1, 0].GetFormat().Value;
            Assert.AreEqual(new CellValueFormat("\"$\"#,##0.00_);[Red](\"$\"#,##0.00)"), secondFormat);

            CellValueFormat thirdFormat = worksheet.Cells[2, 0, 2, 0].GetFormat().Value;
            Assert.AreEqual(new CellValueFormat("m/d/yyyy"), thirdFormat);
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportCsvFormattedValuesTest()
        {
            ImportFileAndAssert("ImportCsvFormattedValuesTestDocument.csv");
        }
    }
}
