﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class ImportEmptySharedStringTests : ImportExportTestClassBase
    {
        #region Fields

        Dictionary<CellIndex, string> worksheetContent = new Dictionary<CellIndex, string>();

        #endregion


        #region Constructors

        public ImportEmptySharedStringTests()
        {
            this.worksheetContent.Add(new CellIndex(0, 0), "asd");
            this.worksheetContent.Add(new CellIndex(1, 0), string.Empty); 
        }

        #endregion


        #region Methods

        public override Workbook ArrangeWorkbook()
        {
            throw new NotImplementedException();
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Workbook newWorkbook = TestHelper.CreateNonEmptyWorkbook();
            Worksheet worksheet = newWorkbook.Worksheets["Sheet1"];

            foreach (KeyValuePair<CellIndex, string> pair in worksheetContent)
            {
                worksheet.Cells[pair.Key].SetValue(pair.Value);
            }

            Workbook expectedWorkbook = newWorkbook;

            TestHelper.AssertWorkbooksAreEqual(expectedWorkbook, workbook);
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportEmptySharedStringTest()
        {
            ImportFileAndAssert("ImportEmptySharedStringDocument.xlsx");
        }

        #endregion
    }
}
