﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class ImportExportCombinedGroupingAndRowHeightTests : ImportExportTestClassBase
    {
        public override Workbook ArrangeWorkbook()
        {
            Workbook workbook = TestHelper.CreateNonEmptyWorkbook();
            Worksheet worksheet = workbook.Worksheets["Sheet1"];

            worksheet.Rows[1].SetHeight(new RowHeight(30, true));
            worksheet.Rows[3].SetOutlineLevel(1);
            worksheet.Rows[5].SetHeight(new RowHeight(30, true));

            return workbook;
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            //throw new NotImplementedException();
        }

        internal override void AssertExportedBookImportedSpecificValuesCorrectly(Workbook workbook)
        {
            Worksheet worksheet = workbook.Worksheets["Sheet1"];

            RowHeight expectedHeight = new RowHeight(30, true);
            int expectedOutlineLevel = 1;

            RowHeight row1Height = worksheet.Rows[1].GetHeight().Value;
            int row3OutlineLevel = worksheet.Rows[3].GetOutlineLevel().Value;
            RowHeight row5Height = worksheet.Rows[5].GetHeight().Value;

            Assert.AreEqual(expectedHeight, row1Height);
            Assert.AreEqual(expectedHeight, row5Height);
            Assert.AreEqual(expectedOutlineLevel, row3OutlineLevel);
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ExportAndImportCombinedGroupingAndRowHeightTest()
        {
            ArrangeWorkbookExportImportAssert();
        }
    }
}
