﻿using System;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    public static class ImportExportTestHelper
    {
        public static void TestImportCorrectness(string workbookPath, Action<Workbook> fillExpectedWorkbook)
        {
            Workbook expectedWorkbook = TestHelper.CreateNonEmptyWorkbook();
            expectedWorkbook.Worksheets.Add();
            expectedWorkbook.Worksheets.Add();

            fillExpectedWorkbook(expectedWorkbook);

            Workbook workbook = TestHelper.GetWorkbookFromFile(workbookPath);
            TestHelper.AssertWorkbooksAreEqual(expectedWorkbook, workbook);
        }
    }
}