﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class ImportInlineStringTests : ImportExportTestClassBase
    {
        #region Fields

        Dictionary<CellIndex, string> worksheetContent = new Dictionary<CellIndex, string>();

        #endregion


        #region Constructors

        public ImportInlineStringTests()
        {
            this.worksheetContent.Add(new CellIndex(0, 0), "Name");
            this.worksheetContent.Add(new CellIndex(1, 0), "First");
            this.worksheetContent.Add(new CellIndex(2, 0), "Second");

            this.worksheetContent.Add(new CellIndex(0, 1), "Col 1");
            this.worksheetContent.Add(new CellIndex(1, 1), "1");
            this.worksheetContent.Add(new CellIndex(2, 1), "2");

            this.worksheetContent.Add(new CellIndex(0, 2), "Col 2");
            this.worksheetContent.Add(new CellIndex(1, 2), "4");
            this.worksheetContent.Add(new CellIndex(2, 2), "8");
        }

        #endregion


        #region Methods

        public override Workbook ArrangeWorkbook()
        {
            throw new NotImplementedException();
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Workbook newWorkbook = TestHelper.CreateNonEmptyWorkbook();
            Worksheet worksheet = newWorkbook.Worksheets["Sheet1"];

            foreach (KeyValuePair<CellIndex, string> pair in worksheetContent)
            {
                worksheet.Cells[pair.Key].SetValue(pair.Value);
            }

            Workbook expectedWorkbook = newWorkbook;

            TestHelper.AssertWorkbooksAreEqual(expectedWorkbook, workbook);
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportInlineStringsTest()
        {
            ImportFileAndAssert("ImportInlineStringTestDocument.xlsx");
        }

        #endregion
    }
}
