﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class ImportMacroEnabledWorkbookTests : ImportExportTestClassBase
    {
        [TestInitialize]
        public void AddCustomFormatprovider()
        {
            WorkbookFormatProvidersManager.RegisterFormatProvider(new XlsmTestFormatProvider());
        }

        public override Workbook ArrangeWorkbook()
        {
            throw new NotImplementedException();
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Worksheet worksheet = workbook.Worksheets["Sheet1"];

            string retrievedValue = worksheet.Cells[2, 1, 2, 1].GetValue().Value.RawValue;
            Assert.AreEqual("test", retrievedValue);
        }

        [TestMethod]
        public void ImportMacroEnabledWorkbookTest()
        {
            ImportFileAndAssert("ImportMacroEnabledWorkbook.xlsm");
        }
    }
}
