﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class ImportNumberValuesWithExponent : ImportExportTestClassBase
    {
        private string valueOfA1 = "1{ds}23456789456789E+23".ReplaceCultureDependentSeparators();
        private string valueOfA2 = "9{ds}87654321987123E+29".ReplaceCultureDependentSeparators();

        public override Workbook ArrangeWorkbook()
        {
            Workbook workbook = new Workbook();
            Worksheet worksheet = workbook.Worksheets.Add();

            worksheet.Cells[0, 0].SetValue(valueOfA1);
            worksheet.Cells[1, 0].SetValue(valueOfA2);

            return workbook;
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Worksheet worksheet = workbook.ActiveWorksheet;
            
            NumberCellValue value = worksheet.Cells[0, 0].GetValue().Value as NumberCellValue;
            Assert.IsNotNull(value);
            Assert.AreEqual(valueOfA1, value.RawValue);

            value = worksheet.Cells[1, 0].GetValue().Value as NumberCellValue;
            Assert.IsNotNull(value);
            Assert.AreEqual(valueOfA2, value.RawValue);
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportNumberValuesWithExponentTest()
        {
            ImportFileAndAssert("ImportNumberValuesWithExponent.xlsx");
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ExportAndImportNumberValuesWithExponentTest()
        {
            ArrangeWorkbookExportImportAssert();
        }
    }
}