﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Printing;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class ImportPageBreakValueAboveMaxRowColumnIndex : ImportExportTestClassBase
    {
        public override Workbook ArrangeWorkbook()
        {
            throw new NotImplementedException();
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Worksheet worksheet = workbook.Worksheets[0];
            PageBreak pageBreak = worksheet.WorksheetPageSetup.PageBreaks.HorizontalPageBreaks.First();

            Assert.AreEqual(0, pageBreak.FromIndex);
            Assert.AreEqual(31, pageBreak.Index);
            Assert.AreEqual(65535, pageBreak.ToIndex);
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportPageBreakValueAboveMaxRowColumnIndexTest()
        {
            ImportFileAndAssert("ImportPageBreakValueAboveMaxRowColumnIndex.xlsx");
        }
    }
}