﻿using System;
using System.Windows.Media;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class IndexedColorsTests : ImportExportTestClassBase
    {
        public override Workbook ArrangeWorkbook()
        {
            return null;
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Cells cells = workbook.ActiveWorksheet.Cells;

            PatternFill fill = cells[0, 0].GetFill().Value as PatternFill;
            Assert.AreEqual(Colors.White, fill.PatternColor.GetActualValue(workbook.Theme));
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportIndexedColorsTest()
        {
            ImportFileAndAssert("ImportIndexedColorsDocument.xlsx");
        }
    }
}
