﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Windows;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Printing;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests.PrintingTests
{
    [TestClass]
    public class ScaleFactorTests : ImportExportTestClassBase
    {
        public override Workbook ArrangeWorkbook()
        {
            Workbook workbook = new Workbook();
            workbook.Worksheets.Add().WorksheetPageSetup.ScaleFactor = new Size(4, 4);

            return workbook;
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            WorksheetPageSetup pageSetup1 = workbook.Worksheets[0].WorksheetPageSetup;
            Assert.AreEqual(pageSetup1.ScaleFactor, new Size(SpreadsheetDefaultValues.MinScaleFactor, SpreadsheetDefaultValues.MinScaleFactor));
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportWorkbookScaleFactorTest()
        {
            ImportFileAndAssert("ImportExportWorksheetPageSetupsScaleFactor.xlsx");
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ExportAndImportWorkbookScaleFactorTest()
        {
            base.ArrangeWorkbookExportImportAssert();
        }
    }
}
