﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class ProtectionWorkbookTests : ImportExportTestClassBase
    {
        private const string Password = "qwerty";

        public override Workbook ArrangeWorkbook()
        {
            Workbook workbook = TestHelper.CreateNonEmptyWorkbook();

            workbook.Protect(Password);

            return workbook;
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Assert.IsTrue(workbook.IsProtected);

            bool unprotected = workbook.Unprotect(Password);

            Assert.IsTrue(unprotected);
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportProtectedWorkbookTest()
        {
            ImportFileAndAssert("ImportExportProtectedWorkbook2013.xlsx");
            ImportFileAndAssert("ImportExportProtectedWorkbook2010.xlsx");
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ExportAndImportProtectedWorkbookTest()
        {
            ArrangeWorkbookExportImportAssert();
        }
    }
}
