﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class RenameReorderSheetsTests : ImportExportTestClassBase
    {
        #region Fields

        private static readonly string[] sheetNames = new string[] { "Sheet3", "Test1", "Sheet1" };

        #endregion


        #region Methods

        public override Workbook ArrangeWorkbook()
        {
            Workbook workbook = new Workbook();

            for (int i = 0; i < sheetNames.Length; i++)
            {
                workbook.Sheets.Add(SheetType.Worksheet);
                Worksheet worksheet = workbook.Worksheets[i];
                worksheet.Name = sheetNames[i];
                worksheet.Cells[0, 0].SetValue(sheetNames[i]);
            }

            return workbook;
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            for (int i = 0; i < sheetNames.Length; i++)
            {
                Worksheet firstWorksheet = workbook.Worksheets[0];
                Assert.IsNotNull(firstWorksheet);
                Assert.AreEqual("Sheet3", firstWorksheet.Name);
                Assert.AreEqual("Sheet3", firstWorksheet.Cells[0, 0].GetValue().Value.GetValueAsString(CellValueFormat.GeneralFormat));
            }
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportRenamedReorderdSheetsTest()
        {
            ImportFileAndAssert("ImportRenameReorderSheetsTestDocument.xlsx");
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ExportAndImportRenamedReorderdSheetsTest()
        {
            ArrangeWorkbookExportImportAssert();
        }

        #endregion
    }
}
