﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class SheetVisibilityTests : ImportExportTestClassBase
    {
        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportVisibilityTest()
        {
            ImportFileAndAssert("ImportSheetVisibility.xlsx");
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ExportImportVisibilityTest()
        {
            ArrangeWorkbookExportImportAssert();
        }

        public override Workbook ArrangeWorkbook()
        {
            Workbook workbook = new Workbook();
            workbook.Sheets.Add(SheetType.Worksheet);
            workbook.Sheets.Add(SheetType.Worksheet).Visibility = SheetVisibility.Visible;
            workbook.Sheets.Add(SheetType.Worksheet).Visibility = SheetVisibility.Hidden;
            workbook.Sheets.Add(SheetType.Worksheet).Visibility = SheetVisibility.VeryHidden;

            return workbook;
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Sheet sheet;

            sheet = workbook.Sheets["Sheet1"];
            Assert.AreEqual(SheetVisibility.Visible, sheet.Visibility);

            sheet = workbook.Sheets["Sheet2"];
            Assert.AreEqual(SheetVisibility.Visible, sheet.Visibility);

            sheet = workbook.Sheets["Sheet3"];
            Assert.AreEqual(SheetVisibility.Hidden, sheet.Visibility);

            sheet = workbook.Sheets["Sheet4"];
            Assert.AreEqual(SheetVisibility.VeryHidden, sheet.Visibility);
        }
    }
}