﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests.SortingTests
{
    [TestClass]
    public class IconSortTests : ImportExportTestClassBase
    {
        private readonly int[] values = new int[] { 9, 10, 8, 1, 2, 3, 4, 5, 6, 7 };

        public override Workbook ArrangeWorkbook()
        {
            throw new NotImplementedException();
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Worksheet sheet1 = workbook.Worksheets[0];

            for (int i = 0; i < 10; i++)
            {
                NumberCellValue valueA = (NumberCellValue)sheet1.Cells[i, 0].GetValue().Value;
                Assert.AreEqual(values[i], valueA.Value);

                NumberCellValue valueB = (NumberCellValue)sheet1.Cells[i, 1].GetValue().Value;
                Assert.AreEqual(values[i], valueB.Value);
            }
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportIconSortTest()
        {
            ImportFileAndAssert("ImportIconSortTest.xlsx");
        }
    }
}