﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class WhitespaceTests : ImportExportTestClassBase
    {
        public override Workbook ArrangeWorkbook()
        {
            Workbook workbook = TestHelper.CreateNonEmptyWorkbook();
            Worksheet activeWorksheet = workbook.Worksheets["Sheet1"];

            activeWorksheet.Cells[0, 0].SetValue("  ");
            activeWorksheet.Cells[1, 0].SetValue("   ");

            return workbook;
        }

        public override void AssertWorkbookImportedCorrectly(Workbook workbook)
        {
            Worksheet worksheet = workbook.Worksheets["Sheet1"];

            Assert.AreEqual("  ", worksheet.Cells[0, 0].GetValue().Value.RawValue);
            Assert.AreEqual("   ", worksheet.Cells[1, 0].GetValue().Value.RawValue);
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void ImportWhitespaceTest()
        {
            ImportFileAndAssert("ImportWhitespaceDocument.xlsx");
        }

        // TODO:
        //[TestMethod]
        //public void ExportAndImportFontPropertiesTest()
        //{
        //    ArrangeWorkbookExportImportAssert();
        //}
    }
}