﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.TextBased.Csv;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.TextBased.Txt;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.ImportExportTests
{
    [TestClass]
    public class WorkbookFormatProvidersManagerTests
    {
        [TestMethod]
        [TestCategory("ImportExport")]
        public void RegisterXlsxFormatProviderTest()
        {
            WorkbookFormatProvidersManager.RegisterFormatProvider(new XlsxFormatProvider());

            IWorkbookFormatProvider provider = WorkbookFormatProvidersManager.GetProviderByName("XlsxFormatProvider");
            Assert.IsNotNull(provider);
        }

        private static object lockTest = new object();

        [TestMethod]
        [TestCategory("ImportExport")]
        public void UnregisterXlsxFormatProviderTest()
        {
            lock (lockTest)
            {
                WorkbookFormatProvidersManager.RegisterFormatProvider(new XlsxFormatProvider());
                WorkbookFormatProvidersManager.UnregisterFormatProvider(new XlsxFormatProvider());

                IWorkbookFormatProvider provider = WorkbookFormatProvidersManager.GetProviderByName("XlsxFormatProvider");

                Assert.IsNull(provider);

                WorkbookFormatProvidersManager.RegisterFormatProvider(new XlsxFormatProvider());
            }
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void UnregisterCsvFormatProviderTest()
        {
            WorkbookFormatProvidersManager.UnregisterFormatProvider(new CsvFormatProvider());

            IWorkbookFormatProvider provider = WorkbookFormatProvidersManager.GetProviderByName("CsvFormatProvider");
            Assert.IsNull(provider);
        }
    }
}
