﻿using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.Utilities.Charts
{
    internal class BarSeriesGroupEqualityConverter : SeriesGroupEqualityComparer<BarSeriesGroup>
    {
        public BarSeriesGroupEqualityConverter()
        {
            RegisterComparerFunction("AxisGroupName", this.CompareAxisGroupName);
            RegisterComparerFunction("Grouping", this.CompareGrouping);
            RegisterComparerFunction("BarDirection", this.CompareBarDirection);
        }

        private bool CompareBarDirection(BarSeriesGroup arg1, BarSeriesGroup arg2)
        {
            bool result = arg1.BarDirection == arg2.BarDirection;

#if DEBUG
            System.Diagnostics.Debug.Assert(result);
#endif

            return result;
        }

        private bool CompareGrouping(BarSeriesGroup arg1, BarSeriesGroup arg2)
        {
            bool result = arg1.Grouping == arg2.Grouping;

#if DEBUG
            System.Diagnostics.Debug.Assert(result);
#endif

            return result;
        }

        private bool CompareAxisGroupName(BarSeriesGroup arg1, BarSeriesGroup arg2)
        {
            bool result = arg1.AxisGroupName == arg2.AxisGroupName;

#if DEBUG
            System.Diagnostics.Debug.Assert(result);
#endif

            return result;
        }
    }
}
