﻿using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.Utilities.Charts
{
    internal abstract class CategorySeriesBaseEqualityComparer<T> : SeriesBaseEqualityComparer<T>
        where T : CategorySeriesBase
    {
        static CategorySeriesBaseEqualityComparer()
        {
            RegisterComparerFunction("Values", CompareValues);
            RegisterComparerFunction("Categories", CompareCategories);
        }

        private static bool CompareValues(CategorySeriesBase series1, CategorySeriesBase series2)
        {
            IChartData value1 = series1.Values;
            IChartData value2 = series2.Values;

            return SeriesBaseEqualityComparer<T>.CompareIChartData(value1, value2);
        }

        private static bool CompareCategories(CategorySeriesBase series1, CategorySeriesBase series2)
        {
            IChartData value1 = series1.Categories;
            IChartData value2 = series2.Categories;

            return SeriesBaseEqualityComparer<T>.CompareIChartData(value1, value2);
        }
    }
}
