﻿using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.Utilities.Charts
{
    internal abstract class FormulaChartDataEqualityComparerBase<T> : SafeEqualityComparerBase<T>
        where T : FormulaChartData
    {
        static FormulaChartDataEqualityComparerBase()
        {
            RegisterComparerFunction("ChartDataType", CompareChartDataType);
            RegisterComparerFunction("Formula", CompareFormula);
        }

        private static bool CompareChartDataType(FormulaChartData arg1, FormulaChartData arg2)
        {
            bool result = arg1.ChartDataType == arg2.ChartDataType;

#if DEBUG
            System.Diagnostics.Debug.Assert(result);
#endif
            return result;
        }

        private static bool CompareFormula(FormulaChartData arg1, FormulaChartData arg2)
        {
            bool result = arg1.Formula == arg2.Formula;

#if DEBUG
            System.Diagnostics.Debug.Assert(result);
#endif

            return result;
        }
    }
}
