﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.Utilities.Charts
{
    internal class FormulaTitleEqualityComparer : TitleEqualityComparerBase<FormulaTitle>
    {
        private static readonly IEqualityComparer<FormulaChartData> equalityComparer = new GenericFormulaChartDataEqualityComparer();

        static FormulaTitleEqualityComparer()
        {
            RegisterComparerFunction("Formula", CompareFormula);
        }

        private static bool CompareFormula(FormulaTitle arg1, FormulaTitle arg2)
        {
            FormulaChartData value1 = arg1.Formula;
            FormulaChartData value2 = arg2.Formula;

            return equalityComparer.Equals(value1, value2);
        }
    }
}
