﻿using System;
using System.Collections;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.Utilities.Charts
{
    internal class LineSeriesEqualityComparer : CategorySeriesBaseEqualityComparer<LineSeries>
    {
        private static readonly IEqualityComparer markerEqualityComparer = new MarkerEqualityComparer();
        static LineSeriesEqualityComparer()
        {
            RegisterComparerFunction("Marker", CompareMarker);
            RegisterComparerFunction("IsSmooth", CompareIsSmooth);
        }

        private static bool CompareIsSmooth(LineSeries arg1, LineSeries arg2)
        {
            return arg1.IsSmooth == arg2.IsSmooth;
        }

        private static bool CompareMarker(LineSeries series1, LineSeries series2)
        {
            Marker value1 = series1.Marker;
            Marker value2 = series2.Marker;

            if (value1 == null && value2 == null)
            {
                return true;
            }

            if (value1 == null || value2 == null)
            {
#if DEBUG
                System.Diagnostics.Debug.Assert(false);
#endif

                return false;
            }

            return markerEqualityComparer.Equals(value1, value2);
        }
    }
}
