﻿using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.Utilities.Charts
{
    internal class NumericChartDataEqualityComparer : SafeEqualityComparerBase<NumericChartData>
    {
        static NumericChartDataEqualityComparer()
        {
            RegisterComparerFunction("ChartDataType", CompareChartDataType);
            RegisterComparerFunction("NumericLiterals", CompareNumericLiterals);
        }

        private static bool CompareNumericLiterals(NumericChartData arg1, NumericChartData arg2)
        {
            if (arg1.NumericLiterals == null && arg2.NumericLiterals == null)
            {
                return true;
            }

            if (arg1.NumericLiterals == null || arg2.NumericLiterals == null)
            {
#if DEBUG
                System.Diagnostics.Debug.Assert(false);
#endif
                return false;
            }

            List<double> values1 = arg1.NumericLiterals.ToList();
            List<double> values2 = arg2.NumericLiterals.ToList();

            if (values1.Count != values2.Count)
            {
#if DEBUG
                System.Diagnostics.Debug.Assert(false);
#endif
                return false;
            }

            for (int i = 0; i < values1.Count; i++)
            {
                if (values1[i] != values2[i])
                {
#if DEBUG
                    System.Diagnostics.Debug.Assert(false);
#endif

                    return false;
                }
            }

            return true;
        }

        private static bool CompareChartDataType(NumericChartData arg1, NumericChartData arg2)
        {
            return arg1.ChartDataType == arg2.ChartDataType;
        }
    }
}
