﻿using System;
using System.Collections;
using Telerik.Windows.Documents.Model.Drawing.Theming;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.Utilities.Charts
{
    internal class OutlineEqualityComparer : SafeEqualityComparerBase<Outline>
    {
        private static readonly IEqualityComparer fillEqualityComparer = new FillEqualityComparer();
        static OutlineEqualityComparer()
        {
            RegisterComparerFunction("Fill", CompareFill);
            RegisterComparerFunction("Width", CompareWidth);
        }

        private static bool CompareFill(Outline outline1, Outline outline2)
        {
            Fill value1 = outline1.Fill;
            Fill value2 = outline2.Fill;

            return fillEqualityComparer.Equals(value1, value2);
        }

        private static bool CompareWidth(Outline outline1, Outline outline2)
        {
            bool result = outline1.Width == outline2.Width;

#if DEBUG
            System.Diagnostics.Debug.Assert(result);
#endif

            return result;
        }
    }
}
