﻿using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.Utilities.Charts
{
    internal abstract class PointSeriesBaseEqualityComparer<T> : SeriesBaseEqualityComparer<T>
        where T : PointSeriesBase
    {
        static PointSeriesBaseEqualityComparer()
        {
            RegisterComparerFunction("XValues", CompareXValues);
            RegisterComparerFunction("YValues", CompareYValues);
        }

        private static bool CompareXValues(PointSeriesBase series1, PointSeriesBase series2)
        {
            IChartData value1 = series1.XValues;
            IChartData value2 = series2.XValues;

            return SeriesBaseEqualityComparer<T>.CompareIChartData(value1, value2);
        }

        private static bool CompareYValues(PointSeriesBase series1, PointSeriesBase series2)
        {
            IChartData value1 = series1.YValues;
            IChartData value2 = series2.YValues;

            return SeriesBaseEqualityComparer<T>.CompareIChartData(value1, value2);
        }
    }
}
