﻿using System;
using System.Collections;
using Telerik.Windows.Documents.Model.Drawing.Charts;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.Utilities.Charts
{
    internal class ScatterSeriesEqualityComparer : PointSeriesBaseEqualityComparer<ScatterSeries>
    {
        private static readonly IEqualityComparer markerEqualityComparer = new MarkerEqualityComparer();
        static ScatterSeriesEqualityComparer()
        {
            RegisterComparerFunction("IsSmooth", CompareIsSmooth);
            RegisterComparerFunction("Marker", CompareMarker);
            RegisterComparerFunction("ScatterStyle", CompareScatterStyle);
        }

        private static bool CompareScatterStyle(ScatterSeries series1, ScatterSeries series2)
        {
            bool result = series1.ScatterStyle == series2.ScatterStyle;

#if DEBUG
            System.Diagnostics.Debug.Assert(result);
#endif

            return result;
        }

        private static bool CompareIsSmooth(ScatterSeries series1, ScatterSeries series2)
        {
            bool result = series1.IsSmooth == series2.IsSmooth;

#if DEBUG
            System.Diagnostics.Debug.Assert(result);
#endif

            return result;
        }

        private static bool CompareMarker(ScatterSeries series1, ScatterSeries series2)
        {
            Marker value1 = series1.Marker;
            Marker value2 = series2.Marker;

            if (value1 == null && value2 == null)
            {
                return true;
            }

            if (value1 == null || value2 == null)
            {
#if DEBUG
                System.Diagnostics.Debug.Assert(false);
#endif

                return false;
            }

            return markerEqualityComparer.Equals(value1, value2);
        }
    }
}
