﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.Utilities
{
    public static class FilterTestHelper
    {
        public static void SetValuesToWorksheetColumn(Worksheet worksheet, int startRow, int startColumn, List<object> values)
        {
            for (int i = 0; i < values.Count(); i++)
            {
                int row = i + startRow;
                object value = values[i];
                SetValueToWorksheet(worksheet, row, startColumn, value);
            }
        }

        private static void SetValueToWorksheet(Worksheet worksheet, int row, int column, object value)
        {
            double? doubleValue = value as double?;
            if (doubleValue.HasValue)
            {
                worksheet.Cells[row, column, row, column].SetValue(doubleValue.Value);
                return;
            }

            bool? boolValue = value as bool?;
            if (boolValue.HasValue)
            {
                worksheet.Cells[row, column, row, column].SetValue(boolValue.Value);
                return;
            }

            DateTime? dateValue = value as DateTime?;
            if (dateValue.HasValue)
            {
                worksheet.Cells[row, column, row, column].SetValue(dateValue.Value);
                return;
            }

            string stringValue = value as string;
            if (stringValue != null)
            {
                worksheet.Cells[row, column, row, column].SetValue(stringValue);
                return;
            }

            throw new InvalidOperationException();
        }
    }
}
