﻿using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.Tests.Utilities
{
	internal static class NameGenerator
	{
		#region Fields

		private static List<string> allColumnNames;

		#endregion


		#region Methods

		public static List<string> GetAllColumnNames()
		{
			if (allColumnNames != null)
			{
				return allColumnNames;
			}

			allColumnNames = new List<string>();
			const int LatinAlphabetLettersCount = ('Z' - 'A' + 1);

			int columnIndex = 0;
			// From nothing to Z.
			for (int i = 0; i <= LatinAlphabetLettersCount; i++)
			{
				// From (nothing or A) to Z.
				for (int j = ((i == 0) ? 0 : 1); j <= LatinAlphabetLettersCount; j++)
				{
					// From A to Z.
					for (int k = 1; k <= LatinAlphabetLettersCount; k++)
					{
						string expectedName = string.Empty;
						if (i != 0)
						{
							expectedName += (char)('A' + (i - 1));
						}

						if (j != 0)
						{
							expectedName += (char)('A' + (j - 1));
						}

						expectedName += (char)('A' + (k - 1));
						allColumnNames.Add(expectedName);

						columnIndex++;
						if (columnIndex == SpreadsheetDefaultValues.ColumnCount)
						{
							return allColumnNames;
						}
					}
				}
			}

			return allColumnNames;
		}

		#endregion
	}
}