﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.CellReferenceRanges
{
    [TestClass]
    public class RowColumnReferenceCreationTests
    {
        [TestMethod]
        public void CreateAbsoluteRowColumnReferenceToIndex0()
        {
            int index = 0;
            RowColumnReference referenceTo0 = RowColumnReference.CreateAbsoluteRowColumnReference(index);

            Assert.IsTrue(referenceTo0.IsAbsolute);
            Assert.AreEqual(index, referenceTo0.ActualIndex);
        }

        [TestMethod]
        public void CreateAbsoluteRowColumnReferenceToIndex100()
        {
            int index = 100;
            RowColumnReference referenceTo0 = RowColumnReference.CreateAbsoluteRowColumnReference(index);

            Assert.IsTrue(referenceTo0.IsAbsolute);
            Assert.AreEqual(index, referenceTo0.ActualIndex);
        }

        [TestMethod]
        public void CreateRelativeRowColumnReferenceOffset0()
        {
            int index = 5;
            int offset = 0;
            RowColumnReference referenceTo0 = RowColumnReference.CreateRelativeRowColumnReference(index, offset);

            Assert.IsFalse(referenceTo0.IsAbsolute);
            Assert.AreEqual(index + offset, referenceTo0.ActualIndex);
        }

        [TestMethod]
        public void CreateRelativeRowColumnReferenceOffset2()
        {
            int index = 0;
            int offset = 2;
            RowColumnReference referenceTo0 = RowColumnReference.CreateRelativeRowColumnReference(index, offset);

            Assert.IsFalse(referenceTo0.IsAbsolute);
            Assert.AreEqual(index + offset, referenceTo0.ActualIndex);
        }

        [TestMethod]
        public void CreateRelativeRowColumnReferenceOffsetMinus2()
        {
            int index = 10;
            int offset = -2;
            RowColumnReference referenceTo0 = RowColumnReference.CreateRelativeRowColumnReference(index, offset);

            Assert.IsFalse(referenceTo0.IsAbsolute);
            Assert.AreEqual(index + offset, referenceTo0.ActualIndex);
        }
    }
}
