﻿using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Core.DataStructures;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.CompressedLists.AATreeClassTests
{
    internal class AATreeBuilder<T> where T : IComparable<T>
    {
        private readonly List<T> nodes;

        internal AATreeBuilder()
        {
            nodes = new List<T>();
        }

        public AATreeBuilder<T> WithNodes(params T[] nodes)
        {
            this.nodes.AddRange(nodes);
            return this;
        }

        public AATree<T> Build()
        {
            AATree<T> tree = new AATree<T>();

            for (int i = 0; i < nodes.Count; i++)
            {
                tree.Add(nodes[i]);
            }

            return tree;
        }
    }
}
