﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.CompressedLists.AATreeClassTests
{
    [TestClass]
    public class AATree_Add_Should
    {
        [TestMethod]
        public void ReturnTrueWhenANodeIsAddedSuccessfully()
        {
            var sut = new AATreeBuilder<int>().Build();
            bool isNodeAdded = sut.Add(1);
            Assert.IsTrue(isNodeAdded, "The node was not added successfully to the AATree");
        }

        [TestMethod]
        public void ReturnFalseWhenANodeIsNotAddedSuccessfully()
        {
            var sut = new AATreeBuilder<int>().WithNodes(1).Build();

            bool isNodeAdded = sut.Add(1);
            Assert.IsFalse(isNodeAdded, "The node was added to the AATree");
        }

        [TestMethod]
        public void ReturnTrueForAddingMultipleNodesWithDifferentValues()
        {
            var sut = new AATreeBuilder<int>().Build();

            for (int i = 0; i < 10; i++)
            {
                bool isNodeAdded = sut.Add(i);
                Assert.IsTrue(isNodeAdded, "The node was not added successfully to the AATree");
            }
        }
    }
}
