﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.CompressedLists.AATreeClassTests
{
    [TestClass]
    public class AATree_Contains_Should
    {
        [TestMethod]
        public void ReturnTrueWhenTheTreeContainsTheValue()
        {
            var sut = new AATreeBuilder<int>().WithNodes(1, 2, 3).Build();

            bool containsNode = sut.Contains(2);

            Assert.IsTrue(containsNode, "The tree does not contain the node");
        }

        [TestMethod]
        public void ReturnFalseWhenTheTreeDoesNotContainTheValue()
        {
            var sut = new AATreeBuilder<int>().WithNodes(1, 2, 3).Build();

            bool containsNode = sut.Contains(4);

            Assert.IsFalse(containsNode, "The tree contains the node");
        }

        [TestMethod]
        public void ReturnFalseWhenTheTreeIsEmpty()
        {
            var sut = new AATreeBuilder<int>().Build();

            bool containsNode = sut.Contains(1);

            Assert.IsFalse(containsNode, "The tree contains the node");
        }
    }
}
