﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.CompressedLists.AATreeClassTests
{
    [TestClass]
    public class AATree_Delete_Should
    {
        [TestMethod]
        public void ReturnTrueWhenANodeIsDeleted()
        {
            var sut = new AATreeBuilder<int>().WithNodes(1).Build();
            
            bool isNodeDeleted = sut.Delete(1);
            
            Assert.IsTrue(isNodeDeleted, "The node was not deleted successfully");
        }

        [TestMethod]
        public void ReturnFalseWhenANodeIsNotContainedInTheTree()
        {
            var sut = new AATreeBuilder<int>().WithNodes(2, 3).Build();

            bool isNodeDeleted = sut.Delete(1);

            Assert.IsFalse(isNodeDeleted, "The node was deleted successfully");
        }
    }
}
