﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.CompressedLists.CompressedListTests
{
    [TestClass]
    public class ClearValue_Should
    {
        [TestMethod]
        public void ClearTheValueOfSingleIndex()
        {
            var sut = new CompressedListBuilder<string>(0, 2).Build();
            string value = "newValue";
            sut.SetValue(0, 2, value);

            sut.ClearValue(1);

            string[] expectedValues = new[] { value, default(string), value };
            CompressedListBuilder<string>.AssertValueCorrectness(sut, 0, expectedValues);
        }

        [TestMethod]
        public void ClearTheValueOfMultipleIndexes()
        {
            var sut = new CompressedListBuilder<string>(0, 2).Build();
            string value = "newValue";
            sut.SetValue(0, 2, value);

            sut.ClearValue(0, 2);

            string[] expectedValues = new[] { default(string), default(string), default(string) };
            CompressedListBuilder<string>.AssertValueCorrectness(sut, 0, expectedValues);
        }

        [TestMethod]
        public void ClearTheValueOfSingleIndexToACustomDefaultValue()
        {
            var sut = new CompressedListBuilder<string>(0, 2).WithDefaultValue("defaultValue").Build();
            string value = "newValue";
            sut.SetValue(0, 2, value);

            sut.ClearValue(1);

            string[] expectedValues = new[] { value, "defaultValue", value };
            CompressedListBuilder<string>.AssertValueCorrectness(sut, 0, expectedValues);
        }
    }
}
