﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.CompressedLists.CompressedListTests
{
    [TestClass]
    public class Offset_Should
    {
        [TestMethod]
        public void OffsetListWithPositiveDelta()
        {
            string[] values = new[] { "string0", "string1", "string2", "string3", "string4", };

            var sut = new CompressedListBuilder<string>(0, 4).Build();
            sut.SetValue(0, values);
         
            var result = sut.Offset(2);

            CompressedListBuilder<string>.AssertValueCorrectness(result, 2, values);
        }

        [TestMethod]
        public void OffsetListWithNegativeDelta()
        {
            string[] values = new[] { "string0", "string1", "string2", "string3", "string4", };

            var sut = new CompressedListBuilder<string>(10, 14).Build();
            sut.SetValue(10, values);

            var result = sut.Offset(-2);

            CompressedListBuilder<string>.AssertValueCorrectness(result, 8, values);
        }

        [TestMethod]
        public void ReturnIdenticalListWhenDeltaIsZero()
        {
            string[] values = new[] { "string0", "string1", "string2", "string3", "string4", };

            var sut = new CompressedListBuilder<string>(0, 4).Build();
            sut.SetValue(0, values);

            var result = sut.Offset(0);

            CompressedListBuilder<string>.AssertValueCorrectness(result, 0, values);
        }
    }
}
