﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Core.DataStructures;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.CompressedLists.CompressedListTests
{
    [TestClass]
    public class SetDefaultValue_Should
    {
        [TestMethod]
        public void SetNewDefaultValueToEmptyCompressedList()
        {
            CompressedList<string> sut = new CompressedListBuilder<string>(0, 5).Build();
            string newDefaultValue = "newDefaultValue";

            sut.SetDefaultValue(newDefaultValue);

            for (int i = (int)sut.FromIndex; i <= sut.ToIndex; i++)
            {
                string defaultValue = sut.GetValue(i);
                Assert.AreEqual(defaultValue, newDefaultValue, false);
            }
        }

        [TestMethod]
        public void SetNewDefaultValueToNonEmptyCompressedList()
        {
            CompressedList<string> sut = new CompressedListBuilder<string>(0, 5).Build();
            sut.SetValue(1, 4, "value");
            string newDefaultValue = "newDefaultValue";

            sut.SetDefaultValue(newDefaultValue);
 
            string defaultValue = sut.GetValue(0);
            Assert.AreEqual(defaultValue, newDefaultValue, false);

            defaultValue = sut.GetValue(5);
            Assert.AreEqual(defaultValue, newDefaultValue, false);
        }
    }
}
