﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.CompressedLists.RangeClassTests
{
    [TestClass]
    public class Range_IntersectsWith_Should
    {
        [TestMethod]
        public void ReturnTrueWhenTheRangesCoincide()
        {
            var sut = new RangeBuilder<long, int>().Build(5, 10);

            var range = new RangeBuilder<long, int>().Build(5, 10);
            bool intersectsWith = sut.IntersectsWith(range);

            Assert.IsTrue(intersectsWith, "The Range does not intersect with the specified range");
        }

        [TestMethod]
        public void ReturnTrueWhenTheParameterRangeIsContained()
        {
            var sut = new RangeBuilder<long, int>().Build(5, 10);

            var range = new RangeBuilder<long, int>().Build(6, 7);
            bool intersectsWith = sut.IntersectsWith(range);

            Assert.IsTrue(intersectsWith, "The Range does not intersect with the specified range");
        }

        [TestMethod]
        public void ReturnFalseWhenTheRangesDoNotIntersect()
        {
            var sut = new RangeBuilder<long, int>().Build(5, 10);

            var range = new RangeBuilder<long, int>().Build(11, 15);
            bool intersectsWith = sut.IntersectsWith(range);

            Assert.IsFalse(intersectsWith, "The Range intersects with the specified range");
        }
    }
}
