﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.DataValidation;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.DataValidation
{
    [TestClass]
    public class CustomRuleDataValidationTests
    {
        [TestMethod]
        [TestCategory("DataValidation")]
        public void TestCustomValidationRuleWithSimpleSumFormula()
        {
            var workbook = TestHelper.CreateNonEmptyWorkbook();
            var worksheet = workbook.Worksheets[0];
            CellIndex cellIndex = new CellIndex(2, 0);

            worksheet.Cells[0, 0].SetValue(1);
            worksheet.Cells[1, 0].SetValue(5);

            SingleArgumentDataValidationRuleContext context = new SingleArgumentDataValidationRuleContext(worksheet, cellIndex);
            context.Argument1 = "=A3=Sum(A1, A2)";

            CustomDataValidationRule rule = new CustomDataValidationRule(context);

            bool result = rule.Evaluate(worksheet, cellIndex, "1");
            Assert.IsFalse(result);

            result = rule.Evaluate(worksheet, cellIndex, "6");
            Assert.IsTrue(result);
        }
    }
}