﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.DataValidation;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.DataValidation
{
    [TestClass]
    public class TextLengthDataValidationTests
    {
        [TestMethod]
        [TestCategory("DataValidation")]
        public void TextLengthRuleOnCellFormatedAsText()
        {
            Workbook workbook = new Workbook();
            Worksheet worksheet = workbook.Worksheets.Add();

            worksheet.Cells[0, 0].SetValue("test");
            worksheet.Cells[1, 0].SetValue("Test");
            worksheet.Cells[2, 0].SetValue("ala bala");
            worksheet.Cells[3, 0].SetValue("bala");
            worksheet.Cells[4, 0].SetValue("tralalaa");

            worksheet.Cells[0, 0, 4, 0].SetFormat(new CellValueFormat("@"));

            NumberDataValidationRuleContext context = new NumberDataValidationRuleContext(worksheet, 0, 0);
            context.Argument1 = "1";
            context.Argument2 = "5";
            context.ComparisonOperator = ComparisonOperator.Between;
            TextLengthDataValidationRule rule = new TextLengthDataValidationRule(context);

            var result = rule.Evaluate(worksheet, 0, 0);
            Assert.IsTrue(result);

            result = rule.Evaluate(worksheet, 1, 0);
            Assert.IsTrue(result);

            result = rule.Evaluate(worksheet, 2, 0);
            Assert.IsFalse(result);

            result = rule.Evaluate(worksheet, 3, 0);
            Assert.IsTrue(result);

            result = rule.Evaluate(worksheet, 4, 0);
            Assert.IsFalse(result);
        }
    }
}