﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Expressions;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.DefinedNameTests
{
    [TestClass]
    public class DefinedName_Create_Should
    {
        [TestMethod]
        public void ReturnNull_IfNameIsNotValid()
        {
            Worksheet worksheet = TestHelper.CreateWorksheet();
            CellIndex cellIndex = new CellIndex(0, 0);

            SpreadsheetNameCollectionScope owner = new SpreadsheetNameCollectionScope(worksheet);
            FormulaCellValue formulaCellValue = new FormulaCellValue(new InputStringCollection(), EmptyExpression.Empty, cellIndex);

            Assert.IsNull(DefinedName.Create("42", owner, formulaCellValue, string.Empty, true));
        }

        [TestMethod]
        public void ReturnDefinedName_IfNameIsValid()
        {
            Worksheet worksheet = TestHelper.CreateWorksheet();
            CellIndex cellIndex = new CellIndex(0, 0);

            SpreadsheetNameCollectionScope owner = new SpreadsheetNameCollectionScope(worksheet);
            FormulaCellValue formulaCellValue = new FormulaCellValue(new InputStringCollection(), EmptyExpression.Empty, cellIndex);

            DefinedName result = DefinedName.Create("name", owner, formulaCellValue, string.Empty, true);
            
            Assert.IsNotNull(result);
        }
    }
}
