﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Filtering;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;
using Telerik.Windows.Documents.Spreadsheet.TestsInternal.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.Filtering
{
    [TestClass]
    public class CustomFilterTests
    {
        private static readonly string numberCriteria = "10";

        //TODO:
        // The equals operator works with equating strings, unlike the comparison operators
        // e.g: if you have 1, 100%, and 1.1.1900 only the first one will show on CustomFilter("equals", 1), but all will on CustomFilter("less than", 2);
        //[TestMethod]
        //public void CustomFilterTestEqualsDifferentFormats()
        //{
        //    Worksheet worksheet = TestHelper.CreateWorksheet();
        //    FilterInternalTestHelper.SetValuesToWorksheetColumn(worksheet, 6, 5, new List<object>() {10d, 10d, 10d, 10d});
        //    worksheet.Cells[6, 5, 6, 5].SetFormat(CellValueFormat.GeneralFormat);
        //    worksheet.Cells[7, 5, 7, 5].SetFormat(new CellValueFormat("0%"));
        //    worksheet.Cells[8, 5, 8, 5].SetFormat(new CellValueFormat("0.00"));
        //    worksheet.Cells[9, 5, 9, 5].SetFormat(new CellValueFormat("dd/mm/yyyy"));


        //    worksheet.Filter.FilterRange = FilterInternalTestHelper.DefaultCellRange;
        //    IFilter filter = new CustomFilter(new CustomFilterCriteria(ComparisonOperator.EqualsTo, numberCriteria));
        //    worksheet.Filter.SetFilter(0, filter);

        //    FilterInternalTestHelper.AssertCorrectRowsHidden(worksheet, new Dictionary<int, bool>()
        //    {
        //        {6, false},
        //        {7, true},
        //        {8, true},
        //        {9, true},
        //    });
        //}

        [TestMethod]
        public void CustomFilterTestGreaterThanOrEqualsDifferentFormats()
        {
            Worksheet worksheet = TestHelper.CreateWorksheet();
            FilterTestHelperInternal.SetValuesToWorksheetColumn(worksheet, 6, 5, new List<object>() {10d, 10d, 10d, 10d});
            worksheet.Cells[6, 5, 6, 5].SetFormat(CellValueFormat.GeneralFormat);
            worksheet.Cells[7, 5, 7, 5].SetFormat(new CellValueFormat("0%"));
            worksheet.Cells[8, 5, 8, 5].SetFormat(new CellValueFormat("0.00"));
            worksheet.Cells[9, 5, 9, 5].SetFormat(new CellValueFormat("dd/mm/yyyy"));


            worksheet.Filter.FilterRange = FilterTestHelperInternal.DefaultCellRange;
            IFilter filter = new CustomFilter(0, new CustomFilterCriteria(ComparisonOperator.GreaterThanOrEqualsTo, numberCriteria));
            worksheet.Filter.SetFilter(filter);

            FilterTestHelperInternal.AssertCorrectRowsHidden(worksheet, new Dictionary<int, bool>()
            {
                {6, false},
                {7, false},
                {8, false},
                {9, false},
            });
        }
    }
}
