﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.TextBased.Core;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.FormatProviders
{
    [TestClass]
    public class CsvParserTests : CsvTestClassBase
    {
        [TestMethod]
        public void BaseCases()
        {
            ParseAndCompareFiles("BaseCasesTest.csv", "BaseCasesResult.txt");
        }

        [TestMethod]
        public void ValuesWithQuotes()
        {
            ParseAndCompareFiles("ValuesWithQuotesTest.csv", "ValuesWithQuotesResult.txt");
        }

        [TestMethod]
        public void ValuesWithSingleQuotes()
        {
            ParseAndCompareFiles("ValuesWithSingleQuotesTest.csv", "ValuesWithSingleQuotesResult.txt", settings: new CsvSettings() { Quote = '\'' });
        }

        [TestMethod]
        public void TabDelimiter()
        {
            ParseAndCompareFiles("TabDelimiterTest.csv", "BaseCasesResult.txt", settings: new CsvSettings() { Delimiter = '\t' });
        }

        [TestMethod]
        public void MultilineValues()
        {
            ParseAndCompareFiles("MultilineValuesTest.csv", "MultilineValuesResult.txt", endOfLine: '*');
        }

        [TestMethod]
        public void MultilineValuesSpaceDelimiter()
        {
            ParseAndCompareFiles("MultilineValuesSpaceDelimiterTest.csv", "MultilineValuesSpaceDelimiterResult.txt",
                settings: new CsvSettings() { Delimiter = ' ' }, endOfLine: '*');
        }
    }
}
