﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Expressions.Functions;
using Telerik.Windows.Documents.Spreadsheet.TestsInternal.Expressions;
using Telerik.Windows.Documents.Spreadsheet.Expressions;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.Functions.FunctionHelperClassTests
{
    [TestClass]
    public class ArrayArgumentConversion
    {
        [TestMethod]
        public void ConvertArrayExpressionUseFirstElementToNumber()
        {
            ArgumentConversionRules rules = new ArgumentConversionRules(numberIndirectArgument: ArgumentInterpretation.UseAsIs,
                arrayArgument: ArrayArgumentInterpretation.UseFirstElement);
            ArrayExpression expression = new ArrayExpression(new RadExpression[,] { { NumberExpression.E, NumberExpression.PI } });

            FunctionsTestHelper.AssertConversionCorrectness(expression, rules, ArgumentType.Number, null, 1, Math.E);
        }

        [TestMethod]
        public void ConvertArrayExpressionUseAllElementsToNumber()
        {
            ArgumentConversionRules rules = new ArgumentConversionRules(numberIndirectArgument: ArgumentInterpretation.UseAsIs, 
                arrayArgument: ArrayArgumentInterpretation.UseAllElements);
            ArrayExpression expression = new ArrayExpression(new RadExpression[,] { { NumberExpression.E, NumberExpression.PI } });

            FunctionsTestHelper.AssertConversionCorrectness(expression, rules, ArgumentType.Number, null, 2, Math.E, Math.PI);
        }

        [TestMethod]
        public void ConvertArrayExpressionIgnoreAllElementsToNumber()
        {
            ArgumentConversionRules rules = new ArgumentConversionRules(numberIndirectArgument: ArgumentInterpretation.UseAsIs,
                arrayArgument: ArrayArgumentInterpretation.IgnoreAllElements);
            ArrayExpression expression = new ArrayExpression(new RadExpression[,] { { NumberExpression.E, NumberExpression.PI } });

            FunctionsTestHelper.AssertConversionCorrectness(expression, rules, ArgumentType.Number, null, 0);
        }
    }
}
