﻿using System;
using System.IO;
using System.Threading.Tasks;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;
using Telerik.Windows.Documents.Spreadsheet.TestsInternal.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.ImportExport
{
    public abstract class MultiCulturalImportExportTestClassBase : MultiCulturalTestClassBase
    {
        public abstract Workbook ArrangeWorkbook();

        public abstract void AssertWorkbookImportedCorrectly(Workbook workbook);

        public void ImportXlsxFileAndAssert(string fileName)
        {
            RunTestInMultipleCultures(() =>
            {
                Workbook workbook = TestHelperInternal.GetWorkbookFromFile(fileName);
                AssertWorkbookImportedCorrectly(workbook);
            });
        }

        public void ArrangeWorkbookExportImportAssert()
        {
            RunTestInMultipleCultures(() =>
            {
                Workbook expectedWorkbook = this.ArrangeWorkbook();

                Test(expectedWorkbook);

                Task.WaitAll(Task.Factory.StartNew(() => { Test(expectedWorkbook); }));
            });
        }

        private void Test(Workbook expectedWorkbook)
        {
            using (Stream stream = new MemoryStream())
            {
                XlsxFormatProvider provider = new XlsxFormatProvider();
                provider.Export(expectedWorkbook, stream);

                Workbook actualWorkbook = provider.Import(stream);

                TestHelper.AssertWorkbooksAreEqual(expectedWorkbook, actualWorkbook);
            }
        }
    }
}
