﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Expressions;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.TestsInternal.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.ImportExport
{
    [TestClass]
    public class NamesTests
    {
        [TestMethod]
        [TestCategory("ImportExport")]
        public void AssertNamesForNameBoxCorrectness()
        {
            Workbook workbook = TestHelperInternal.GetWorkbookFromFile("ImportNamesForNameBoxError.xlsx");
            
            for (int i = 0; i < workbook.Worksheets.Count; i++)
            {
                workbook.NameManager.GetOrderedNameBoxDefinedNames(workbook.Worksheets[i]);
            }
        }

        [TestMethod]
        [TestCategory("ImportExport")]
        public void AssertNamesToNonExistingSheetsImportedCorrectly()
        {
            Workbook workbook = TestHelperInternal.GetWorkbookFromFile("ImportNamesToNonExistingSheet.xlsx");

            Cells cells = workbook.Worksheets[0].Cells;

            string actualValue = cells[1, 1].GetValue().Value.GetResultValueAsString(CellValueFormat.GeneralFormat);
            Assert.AreEqual("42", actualValue);

            for (int i = 2; i <= 4; i++)
            {
                actualValue = cells[1, i].GetValue().Value.GetResultValueAsString(CellValueFormat.GeneralFormat);
                Assert.AreEqual(ErrorExpressions.ReferenceError.Value, actualValue);
            }
        }
    }
}
