﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Model.Protection;
using Telerik.Windows.Documents.Spreadsheet.Tests.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.ImportExport.ProtectionTests
{
    [TestClass]
    public class ProtectionWorksheetTests 
    {
        private const string Sheet1Password = "qwerty";
        private const string Sheet2Password = "";

        [TestMethod]
        [TestCategory("ImportExport")]
        public void WhenProtectingWorksheet_WithMissingAlgorithmName_ShouldNotThrowAnException()
        {
            Workbook workbook = TestHelper.GetWorkbookFromFile("ImportAndProtectWorkSheetWithNullAlgorithmName.xlsx");

            Worksheet sheet = workbook.Worksheets[1];

            Assert.AreEqual(string.Empty, sheet.ProtectionData.AlgorithmName);

            sheet.Protect(Sheet1Password, Model.Protection.WorksheetProtectionOptions.Default);

            Assert.AreEqual(ProtectionData.DefaultProtectionAlgorithm, sheet.ProtectionData.AlgorithmName);
        }

    }
}
