﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.Utilities;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.InsertRemoveCells
{
    public class CellsInsertRemoveEventAsserter
    {
        private readonly Cells cells;
        private int cellRangeInsertedRemovedCount;
        private CellRangeInsertedOrRemovedEventArgs args;

        public int CellRangeInsertedRemovedCount
        {
            get
            {
                return this.cellRangeInsertedRemovedCount;
            }
        }

        public CellsInsertRemoveEventAsserter(Cells cells)
        {
            Guard.ThrowExceptionIfNull(cells, "cells");
            this.cells = cells;
            this.cellRangeInsertedRemovedCount = 0;
            this.cells.CellRangeInsertedOrRemoved += Cells_CellRangeInsertedOrRemoved;
        }

        private void Cells_CellRangeInsertedOrRemoved(object sender, CellRangeInsertedOrRemovedEventArgs e)
        {
            this.args = e;
            this.cellRangeInsertedRemovedCount++;
        }

        public void AssertCellsInsertedRemoved(int expectedChangedCount, CellRange range, bool isRemove)
        {
            Assert.AreEqual(expectedChangedCount, this.CellRangeInsertedRemovedCount);
            Assert.AreEqual(range, this.args.Range);
            Assert.AreEqual(isRemove, this.args.IsRemove);
        }
    }
}
