﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Layout;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.LayoutTests
{
    [TestClass]
    public class PageLayoutTests
    {
        [TestMethod]
        [TestCategory("PageLayoutTests")]
        public void AssertLongTextInLastCellGoesToNextPage()
        {
            Workbook workbook = new Workbook();
            Worksheet worksheet = workbook.Worksheets.Add();

            worksheet.Cells[0, 0].SetValue("test");
            worksheet.Cells[0, 1].SetValue("test1");
            worksheet.Cells[0, 2].SetValue("test2");
            worksheet.Cells[0, 3].SetValue("test3");
            worksheet.Cells[0, 4].SetValue("test4");
            worksheet.Cells[0, 5].SetValue("test5");

            worksheet.Cells[0, 6].SetValue("test1 test2 test3 test4 test5 test6 test7 test8 test9 test10 test11 test12 test13 test14 test15 test16 test17 test18");

            PageLayout pageLayout = new PageLayout();
            pageLayout.PreparePages(worksheet, false);

            Assert.AreEqual(2, pageLayout.Pages.Count());
        }
    }
}
