﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Core.DataStructures;

namespace Telerik.Windows.Documents.Spreadsheet.TestsInternal.Utilities
{
    internal static class CompressedListTestHelper
    {
        public static CompressedList<int> CreateCompressedListWithDifferentValues(int size)
        {
            CompressedList<int> compressedList = new CompressedList<int>(0, size, 0);
            for (int i = 0; i < size; i++)
            {
                compressedList.SetValue(i, i);
            }

            return compressedList;
        }

        public static CompressedList<int> CreateCompressedListWithSameValue(int size, int value)
        {
            CompressedList<int> compressedList = new CompressedList<int>(0, size, 0);
            for (int i = 0; i < size; i++)
            {
                compressedList.SetValue(i, value);
            }

            return compressedList;
        }

        public static CompressedList<int> CreateCompressedListWithRanges(int size, int rangeSize)
        {
            CompressedList<int> compressedList = new CompressedList<int>(0, size, 0);
            int ranges = size / rangeSize;
            size = ranges * rangeSize;
            for (int i = 0; i < size; i++)
            {
                compressedList.SetValue(i, i / ranges);
            }

            return compressedList;
        }
    }
}
