﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Model;

namespace Telerik.Documents.SpreadsheetStreaming
{
    /// <summary>
    /// Defines members used to export a cell.
    /// </summary>
    public interface ICellExporter : IDisposable
    {
        /// <summary>
        /// Sets string as cell value.
        /// </summary>
        /// <param name="value">The string value.</param>
        void SetValue(string value);

        /// <summary>
        /// Sets double as cell value.
        /// </summary>
        /// <param name="value">The double value.</param>
        void SetValue(double value);

        /// <summary>
        /// Sets a boolean cell value.
        /// </summary>
        /// <param name="value">The boolean value.</param>
        void SetValue(bool value);

        /// <summary>
        /// Sets DateTime as cell value.
        /// </summary>
        /// <param name="value">The DateTime value.</param>
        void SetValue(DateTime value);

        /// <summary>
        /// Sets formula value.
        /// </summary>
        /// <param name="value">The formula value.</param>
        void SetFormula(string value);

        /// <summary>
        /// Sets the cell format.
        /// </summary>
        /// <param name="cellFormat">The cell format.</param>
        void SetFormat(SpreadCellFormat cellFormat);
    }
}