﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming
{
    /// <summary>
    /// Defines members used to export a column.
    /// </summary>
    public interface IColumnExporter : IDisposable
    {
        /// <summary>
        /// Sets the column width in pixels.
        /// </summary>
        /// <param name="value">The width value in pixels.</param>
        void SetWidthInPixels(double value);

        /// <summary>
        /// Sets the column width in characters count.
        /// </summary>
        /// <param name="count">The count of the characters.</param>
        void SetWidthInCharacters(double count);

        /// <summary>
        /// Sets the column outline level.
        /// </summary>
        /// <param name="value">The outline level value.</param>
        void SetOutlineLevel(int value);

        /// <summary>
        /// Sets a value indicating whether the column should be hidden.
        /// </summary>
        /// <param name="value">True for hidden; otherwise false.</param>
        void SetHidden(bool value);
    }
}