﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming
{
    /// <summary>
    /// Defines members used to import a worksheet.
    /// </summary>
    internal interface IWorksheetImporter : IDisposable
    {
        /// <summary>
        /// Gets the name of the worksheet.
        /// </summary>
        /// <value>The name.</value>
        string Name { get; }

        /// <summary>
        /// Gets the columns.
        /// </summary>
        /// <value>The columns.</value>
        IEnumerable<IColumnImporter> Columns { get; }

        /// <summary>
        /// Gets the rows.
        /// </summary>
        /// <value>The rows.</value>
        IEnumerable<IRowImporter> Rows { get; }
    }
}