﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes
{
    internal class MappedOpenXmlAttribute<T> : OpenXmlAttributeBase<T>
    {
        private readonly ValueMapper<string, T> mapper;

        public MappedOpenXmlAttribute(string name, OpenXmlNamespace ns, ValueMapper<string, T> mapper, bool isRequired = false)
            : base(name, ns, isRequired)
        {
            this.mapper = mapper;
            if (this.mapper.DefaultToValue != null)
            {
                this.DefaultValue = mapper.DefaultToValue.Value;
            }
        }

        public override string GetValueAsString()
        {
            return this.mapper.GetFromValue(this.Value);
        }

        protected override void SetStringValueOverride(string value)
        {
            this.Value = this.mapper.GetToValue(value);
        }
    }
}