﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core
{
    internal abstract class ConsecutivePartWriterBase<T> : PartBase<T>
        where T : ConsecutiveElementBase, new()
    {
        public ConsecutivePartWriterBase(PartContext context)
            : base(context)
        {
            this.BeginWrite();
        }

        internal override void CompleteWriteOverride()
        {
            this.EndWrite();
            base.CompleteWriteOverride();
        }

        private void BeginWrite()
        {
            this.RootElement.BeginWriteElement();
        }

        private void EndWrite()
        {
            this.RootElement.EnsureWritingEnded();
        }
    }
}