﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core
{
    internal static class OpenXmlHelper
    {
        private static readonly Dictionary<string, string> contentTypeDefinitions;

        static OpenXmlHelper()
        {
            contentTypeDefinitions = new Dictionary<string, string>()
            {
                { "xml", "application/xml" },
                { "jpg", "image/jpeg" },
                { "jpeg", "image/jpeg" },
                { "png", "image/png" },
                { "bmp", "image/bitmap" },
                { "tiff", "image/tiff" },
                { "tif", "image/tiff" },
                { "gif", "image/gif" },
                { "icon", "image/x-icon" },
                { "wmf", "application/x-msmetafile" },
                { "emf", "application/x-msmetafile" },
                { "rels", XlsxContentTypeNames.RelationshipContentType }
            };
        }

        public static bool TryGetContentTypeByExtension(string extension, out string contentType)
        {
            return contentTypeDefinitions.TryGetValue(extension, out contentType);
        }

        public static string GetExtension(string partName)
        {
            return partName.Substring(partName.LastIndexOf('.') + 1).ToLowerInvariant();
        }

        public static string CreateRelationshipId(int id)
        {
            return string.Format("rId{0}", id);
        }

        public static int GetRelationshipId(string id)
        {
            return int.Parse(id.Replace("rId", string.Empty));
        }
    }
}