﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Model;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Types
{
    internal static class BorderStylesMapper
    {
        public static readonly string SlantDashDot = "slantDashDot";
        public static readonly string DashDot = "dashDot";
        public static readonly string DashDotDot = "dashDotDot";
        public static readonly string Dashed = "dashed";
        public static readonly string Double = "double";
        public static readonly string Dotted = "dotted";
        public static readonly string Hair = "hair";
        public static readonly string Medium = "medium";
        public static readonly string MediumDashDot = "mediumDashDot";
        public static readonly string MediumDashDotDot = "mediumDashDotDot";
        public static readonly string MediumDashed = "mediumDashed";
        public static readonly string None = "none";
        public static readonly string Thick = "thick";
        public static readonly string Thin = "thin";

        private static readonly ValueMapper<string, SpreadBorderStyle> nameToValueMapper;

        static BorderStylesMapper()
        {
            nameToValueMapper = new ValueMapper<string, SpreadBorderStyle>(Thin, SpreadBorderStyle.Thin);

            nameToValueMapper.AddPair(DashDot, SpreadBorderStyle.DashDot);
            nameToValueMapper.AddPair(DashDotDot, SpreadBorderStyle.DashDotDot);
            nameToValueMapper.AddPair(Dashed, SpreadBorderStyle.Dashed);
            nameToValueMapper.AddPair(Dotted, SpreadBorderStyle.Dotted);
            nameToValueMapper.AddPair(Hair, SpreadBorderStyle.Hair);
            nameToValueMapper.AddPair(Medium, SpreadBorderStyle.Medium);
            nameToValueMapper.AddPair(MediumDashDot, SpreadBorderStyle.MediumDashDot);
            nameToValueMapper.AddPair(MediumDashDotDot, SpreadBorderStyle.MediumDashDotDot);
            nameToValueMapper.AddPair(MediumDashed, SpreadBorderStyle.MediumDashed);
            nameToValueMapper.AddPair(Thick, SpreadBorderStyle.Thick);
            nameToValueMapper.AddPair(Thin, SpreadBorderStyle.Thin);
            nameToValueMapper.AddPair(None, SpreadBorderStyle.None);
            nameToValueMapper.AddPair(SlantDashDot, SpreadBorderStyle.SlantDashDot);
            nameToValueMapper.AddPair(Double, SpreadBorderStyle.Double);
        }

        public static string GetBorderStyleName(SpreadBorderStyle style)
        {
            return nameToValueMapper.GetFromValue(style);
        }

        public static SpreadBorderStyle GetBorderStyle(string name)
        {
            return nameToValueMapper.GetToValue(name);
        }
    }
}