﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Types
{
    internal class CellRef
    {
        private readonly int rowIndex;
        private readonly int columnIndex;

        public CellRef(int rowIndex, int columnIndex)
        {
            this.rowIndex = rowIndex;
            this.columnIndex = columnIndex;
        }

        public CellRef(string cellRef)
        {
            NameConverter.ConvertCellNameToIndex(cellRef, out this.rowIndex, out this.columnIndex);
        }

        public int RowIndex
        {
            get
            {
                return this.rowIndex;
            }
        }

        public int ColumnIndex
        {
            get
            {
                return this.columnIndex;
            }
        }

        public override string ToString()
        {
            return NameConverter.ConvertCellIndexToName(this.rowIndex, this.columnIndex);
        }
    }
}