﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Model;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Types
{
    internal class CellRefRange
    {
        private readonly CellRef fromCell;
        private readonly CellRef toCell;

        public CellRefRange(SpreadCellRange range)
            : this(new CellRef(range.FromRowIndex, range.FromColumnIndex), new CellRef(range.ToRowIndex, range.ToColumnIndex))
        {
        }

        public CellRefRange(CellRef fromCell, CellRef toCell)
        {
            this.fromCell = fromCell;
            this.toCell = toCell;
        }

        public CellRefRange(string cellRefRange)
        {
            SpreadCellRange cellRange;
            NameConverter.ConvertCellNameToCellRange(cellRefRange, out cellRange);

            this.fromCell = new CellRef(cellRange.FromRowIndex, cellRange.FromColumnIndex);
            this.toCell = new CellRef(cellRange.ToRowIndex, cellRange.ToColumnIndex);
        }

        public CellRef FromCell
        {
            get
            {
                return this.fromCell;
            }
        }

        public CellRef ToCell
        {
            get
            {
                return this.toCell;
            }
        }

        public SpreadCellRange ToCellRange()
        {
            return new SpreadCellRange(this.FromCell.RowIndex, this.fromCell.ColumnIndex, this.ToCell.RowIndex, this.ToCell.ColumnIndex);
        }
    }
}