﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Types
{
    internal static class Converters
    {
        private static IntConverter intValueConverter;
        private static BoolConverter boolValueConverter;
        private static UnsignedIntHexConverter unsignedIntHexConverter;
        private static NullableIntConverter nullableIntValueConverter;
        private static CellRefConverter cellRefConverter;
        private static RefConverter refConverter;
        private static CellRefRangeSequenceConverter cellRefRangeSequenceConverter;

        public static IntConverter IntValueConverter
        {
            get
            {
                if (intValueConverter == null)
                {
                    intValueConverter = new IntConverter();
                }

                return intValueConverter;
            }
        }

        public static BoolConverter BoolValueConverter
        {
            get
            {
                if (boolValueConverter == null)
                {
                    boolValueConverter = new BoolConverter();
                }

                return boolValueConverter;
            }
        }

        public static UnsignedIntHexConverter UnsignedIntHexConverter
        {
            get
            {
                if (unsignedIntHexConverter == null)
                {
                    unsignedIntHexConverter = new UnsignedIntHexConverter();
                }

                return unsignedIntHexConverter;
            }
        }

        public static NullableIntConverter NullableIntValueConverter
        {
            get
            {
                if (nullableIntValueConverter == null)
                {
                    nullableIntValueConverter = new NullableIntConverter();
                }

                return nullableIntValueConverter;
            }
        }

        public static CellRefConverter CellRefConverter
        {
            get
            {
                if (cellRefConverter == null)
                {
                    cellRefConverter = new CellRefConverter();
                }

                return cellRefConverter;
            }
        }

        public static RefConverter RefConverter
        {
            get
            {
                if (refConverter == null)
                {
                    refConverter = new RefConverter();
                }

                return refConverter;
            }
        }

        public static CellRefRangeSequenceConverter CellRefRangeSequenceConverter
        {
            get
            {
                if (cellRefRangeSequenceConverter == null)
                {
                    cellRefRangeSequenceConverter = new CellRefRangeSequenceConverter();
                }

                return cellRefRangeSequenceConverter;
            }
        }
    }
}