﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Types
{
    internal static class GradientTypes
    {
        public static readonly string Linear = "linear";
        public static readonly string Path = "path";

        private static readonly ValueMapper<string, GradientInfoType> nameToValueMapper;

        static GradientTypes()
        {
            nameToValueMapper = new ValueMapper<string, GradientInfoType>();
            nameToValueMapper.AddPair(Linear, GradientInfoType.Linear);
            nameToValueMapper.AddPair(Path, GradientInfoType.Path);
        }

        public static string GetGradientTypeName(GradientInfoType gradient)
        {
            return nameToValueMapper.GetFromValue(gradient);
        }

        internal static GradientInfoType? GetGradientTypeValue(string name)
        {
            return nameToValueMapper.GetToValue(name);
        }
    }
}