﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Model;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Types
{
    internal static class HorizontalAlignmentsMapper
    {
        public static readonly string Center = "center";
        public static readonly string CenterContinuous = "centerContinuous";
        public static readonly string Distributed = "distributed";
        public static readonly string Fill = "fill";
        public static readonly string General = "general";
        public static readonly string Justify = "justify";
        public static readonly string Left = "left";
        public static readonly string Right = "right";

        private static readonly ValueMapper<string, SpreadHorizontalAlignment> nameToValueMapper;

        static HorizontalAlignmentsMapper()
        {
            nameToValueMapper = new ValueMapper<string, SpreadHorizontalAlignment>();
            nameToValueMapper.AddPair(Center, SpreadHorizontalAlignment.Center);
            nameToValueMapper.AddPair(CenterContinuous, SpreadHorizontalAlignment.CenterContinuous);
            nameToValueMapper.AddPair(Distributed, SpreadHorizontalAlignment.Distributed);
            nameToValueMapper.AddPair(Fill, SpreadHorizontalAlignment.Fill);
            nameToValueMapper.AddPair(General, SpreadHorizontalAlignment.General);
            nameToValueMapper.AddPair(Justify, SpreadHorizontalAlignment.Justify);
            nameToValueMapper.AddPair(Left, SpreadHorizontalAlignment.Left);
            nameToValueMapper.AddPair(Right, SpreadHorizontalAlignment.Right);
        }

        public static string GetHorizontalAlignmentName(SpreadHorizontalAlignment horizontalAlignment)
        {
            return nameToValueMapper.GetFromValue(horizontalAlignment);
        }

        public static SpreadHorizontalAlignment GetHorizontalAlignmentValue(string name)
        {
            return nameToValueMapper.GetToValue(name);
        }
    }
}