﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Types
{
    internal class RefConverter : IStringConverter<Ref>
    {
        public Ref ConvertFromString(string value)
        {
            string[] rangeParts = value.Split(new string[] { SpreadsheetCultureHelper.Colon }, StringSplitOptions.RemoveEmptyEntries);

            CellRef startCellRef = new CellRef(rangeParts[0]);
            CellRef endCellRef = rangeParts.Length > 1 ? new CellRef(rangeParts[1]) : new CellRef(rangeParts[0]);

            return new Ref(startCellRef, endCellRef);
        }

        public string ConvertToString(Ref value)
        {
            return NameConverter.ConvertCellRangeToName(value.StartCellRef.RowIndex, value.StartCellRef.ColumnIndex, value.EndCellRef.RowIndex, value.EndCellRef.ColumnIndex);
        }
    }
}