﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Types
{
    internal static class UnderlineValuesMapper
    {
        public static readonly string Double = "double";
        public static readonly string DoubleAccounting = "doubleAccounting";
        public static readonly string None = "none";
        public static readonly string Single = "single";
        public static readonly string SingleAccounting = "singleAccounting";

        private static readonly ValueMapper<string, SpreadUnderlineType> nameToValueMapper;

        static UnderlineValuesMapper()
        {
            nameToValueMapper = new ValueMapper<string, SpreadUnderlineType>();

            nameToValueMapper.AddPair(Double, SpreadUnderlineType.Double);
            nameToValueMapper.AddPair(DoubleAccounting, SpreadUnderlineType.DoubleAccounting);
            nameToValueMapper.AddPair(Single, SpreadUnderlineType.Single);
            nameToValueMapper.AddPair(SingleAccounting, SpreadUnderlineType.SingleAccounting);
            nameToValueMapper.AddPair(None, SpreadUnderlineType.None);
        }

        public static string GetUnderlineValueName(SpreadUnderlineType underline)
        {
            return nameToValueMapper.GetFromValue(underline);
        }

        public static SpreadUnderlineType GetUnderlineValue(string name)
        {
            return nameToValueMapper.GetToValue(name);
        }
    }
}