﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Model;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Types
{
    internal static class VerticalAlignmentsMapper
    {
        public static readonly string Bottom = "bottom";
        public static readonly string Center = "center";
        public static readonly string Distributed = "distributed";
        public static readonly string Justify = "justify";
        public static readonly string Top = "top";

        private static readonly ValueMapper<string, SpreadVerticalAlignment> nameToValueMapper;

        static VerticalAlignmentsMapper()
        {
            nameToValueMapper = new ValueMapper<string, SpreadVerticalAlignment>();
            nameToValueMapper.AddPair(Bottom, SpreadVerticalAlignment.Bottom);
            nameToValueMapper.AddPair(Center, SpreadVerticalAlignment.Center);
            nameToValueMapper.AddPair(Distributed, SpreadVerticalAlignment.Distributed);
            nameToValueMapper.AddPair(Justify, SpreadVerticalAlignment.Justify);
            nameToValueMapper.AddPair(Top, SpreadVerticalAlignment.Top);
        }

        public static string GetVerticalAlignmentName(SpreadVerticalAlignment verticalAlignment)
        {
            return nameToValueMapper.GetFromValue(verticalAlignment);
        }

        public static SpreadVerticalAlignment? GetVerticalAlignmentValue(string name)
        {
            return nameToValueMapper.GetToValue(name);
        }
    }
}