﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Core
{
    internal class ValueBox<T>
    {
        private readonly T value;

        public ValueBox(T value)
        {
            this.value = value;
        }

        public T Value
        {
            get
            {
                return this.value;
            }
        }

        public override int GetHashCode()
        {
            return this.value.GetHashCode();
        }

        public override bool Equals(object obj)
        {
            ValueBox<T> other = obj as ValueBox<T>;
            return other != null && ObjectExtensions.Equals(this.value, other.value);
        }

        public override string ToString()
        {
            if (this.value == null) 
            {
                return "null";
            }

            return this.value.ToString();
        }
    }
}