﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model
{
    internal class CellStyleInfo
    {
        internal CellStyleInfo()
        {
        }

        internal CellStyleInfo(string name, int formattingRecordId, int? builtInId = null)
        {
            this.Name = name;
            this.FormattingRecordId = formattingRecordId;
            this.BuiltInId = builtInId;
        }

        public string Name { get; internal set; }
        public int FormattingRecordId { get; internal set; }
        public int? BuiltInId { get; internal set; }

        public override bool Equals(object obj)
        {
            CellStyleInfo other = obj as CellStyleInfo;

            if (other == null)
            {
                return false;
            }

            return ObjectExtensions.EqualsOfT(this.Name, other.Name) &&
                ObjectExtensions.EqualsOfT(this.FormattingRecordId, other.FormattingRecordId) &&
                ObjectExtensions.EqualsOfT(this.BuiltInId, other.BuiltInId);
        }

        public override int GetHashCode()
        {
            return ObjectExtensions.CombineHashCodes(
                this.Name.GetHashCodeOrZero(),
                this.FormattingRecordId.GetHashCodeOrZero(),
                this.BuiltInId.GetHashCodeOrZero());
        }
    }
}