﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model
{
    internal class DiferentialFormat
    {
        public int? BorderId { get; set; }
        public int? FillId { get; set; }
        public int? FontId { get; set; }
        public int? NumFmtId { get; set; }
        public int? FormatId { get; set; }
        public bool? ApplyAlignment { get; set; }
        public bool? ApplyBorder { get; set; }
        public bool? ApplyFill { get; set; }
        public bool? ApplyFont { get; set; }
        public bool? ApplyNumberFormat { get; set; }
        public bool? ApplyProtection { get; set; }
        public SpreadHorizontalAlignment? HorizontalAlignment { get; set; }
        public SpreadVerticalAlignment? VerticalAlignment { get; set; }
        public int? Indent { get; set; }
        public bool? WrapText { get; set; }
        public bool? IsLocked { get; set; }

        public override bool Equals(object obj)
        {
            DiferentialFormat other = obj as DiferentialFormat;

            if (other == null)
            {
                return false;
            }

            return ObjectExtensions.EqualsOfT(this.BorderId, other.BorderId) &&
                ObjectExtensions.EqualsOfT(this.FillId, other.FillId) &&
                ObjectExtensions.EqualsOfT(this.FontId, other.FontId) &&
                ObjectExtensions.EqualsOfT(this.NumFmtId, other.NumFmtId) &&
                ObjectExtensions.EqualsOfT(this.FormatId, other.FormatId) &&
                ObjectExtensions.EqualsOfT(this.ApplyAlignment, other.ApplyAlignment) &&
                ObjectExtensions.EqualsOfT(this.ApplyBorder, other.ApplyBorder) &&
                ObjectExtensions.EqualsOfT(this.ApplyFill, other.ApplyFill) &&
                ObjectExtensions.EqualsOfT(this.ApplyFont, other.ApplyFont) &&
                ObjectExtensions.EqualsOfT(this.ApplyNumberFormat, other.ApplyNumberFormat) &&
                ObjectExtensions.EqualsOfT(this.ApplyProtection, other.ApplyProtection) &&
                ObjectExtensions.EqualsOfT(this.HorizontalAlignment, other.HorizontalAlignment) &&
                ObjectExtensions.EqualsOfT(this.VerticalAlignment, other.VerticalAlignment) &&
                ObjectExtensions.EqualsOfT(this.Indent, other.Indent) &&
                ObjectExtensions.EqualsOfT(this.WrapText, other.WrapText) &&
                ObjectExtensions.EqualsOfT(this.IsLocked, other.IsLocked);
        }

        public override int GetHashCode()
        {
            return ObjectExtensions.CombineHashCodes(
                this.BorderId.GetHashCodeOrZero(),
                this.FillId.GetHashCodeOrZero(),
                this.FontId.GetHashCodeOrZero(),
                this.NumFmtId.GetHashCodeOrZero(),
                this.FormatId.GetHashCodeOrZero(),
                this.ApplyAlignment.GetHashCodeOrZero(),
                this.ApplyBorder.GetHashCodeOrZero(),
                this.ApplyFill.GetHashCodeOrZero(),
                this.ApplyFont.GetHashCodeOrZero(),
                this.ApplyNumberFormat.GetHashCodeOrZero(),
                this.ApplyProtection.GetHashCodeOrZero(),
                this.HorizontalAlignment.GetHashCodeOrZero(),
                this.VerticalAlignment.GetHashCodeOrZero(),
                this.Indent.GetHashCodeOrZero(),
                this.WrapText.GetHashCodeOrZero(),
                this.IsLocked.GetHashCodeOrZero());
        }
    }
}