﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements
{
    internal abstract class BoolValueElementBase : DirectElementBase<bool>
    {
        private readonly BoolOpenXmlAttribute value;

        public BoolValueElementBase()
        {
            this.value = this.RegisterAttribute(new BoolOpenXmlAttribute("val", true, isRequired: false));
        }

        private bool Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(bool value)
        {
            this.Value = value;
        }

        protected override void CopyAttributesOverride(ref bool value)
        {
            value = this.Value;
        }

        protected override void WriteChildElementsOverride(bool value)
        {
        }
    }
}