﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;
using Telerik.Documents.SpreadsheetStreaming.Model.ContentTypes;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements
{
    internal class DefaultElement : DirectElementBase<DefaultContentType>
    {
        private readonly OpenXmlAttribute<string> extension;
        private readonly OpenXmlAttribute<string> contentType;

        public DefaultElement()
        {
            this.extension = this.RegisterAttribute<string>("Extension", true);
            this.contentType = this.RegisterAttribute<string>("ContentType", true);
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.DefaultElementName;
            }
        }

        private string Extension
        {
            get
            {
                return this.extension.Value;
            }
            set
            {
                this.extension.Value = value;
            }
        }

        private string ContentType
        {
            get
            {
                return this.contentType.Value;
            }
            set
            {
                this.contentType.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(DefaultContentType value)
        {
            this.Extension = value.Extension;
            this.ContentType = value.ContentType;
        }

        protected override void WriteChildElementsOverride(DefaultContentType value)
        {
        }

        protected override void CopyAttributesOverride(ref DefaultContentType value)
        {
            value.Extension = this.Extension;
            value.ContentType = this.ContentType;
        }
    }
}