﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;
using Telerik.Documents.SpreadsheetStreaming.Model.ContentTypes;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Writers
{
    internal class OverrideElement : DirectElementBase<OverrideContentType>
    {
        private readonly OpenXmlAttribute<string> partName;
        private readonly OpenXmlAttribute<string> contentType;

        public OverrideElement()
        {
            this.partName = this.RegisterAttribute<string>("PartName", true);
            this.contentType = this.RegisterAttribute<string>("ContentType", true);
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.OverrideElementName;
            }
        }

        private string PartName
        {
            get
            {
                return this.partName.Value;
            }
            set
            {
                this.partName.Value = value;
            }
        }

        private string ContentType
        {
            get
            {
                return this.contentType.Value;
            }
            set
            {
                this.contentType.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(OverrideContentType value)
        {
            this.PartName = value.Path;
            this.ContentType = value.ContentType;
        }

        protected override void CopyAttributesOverride(ref OverrideContentType value)
        {
            value.Path = this.PartName;
            value.ContentType = this.ContentType;
        }

        protected override void WriteChildElementsOverride(OverrideContentType value)
        {
        }
    }
}