﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.Model.Relations;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Writers
{
    internal class RelationshipsElement : DirectElementBase<Relationships>
    {
        public override string ElementName
        {
            get
            {
                return XlsxElementNames.RelationshipsElementName;
            }
        }

        public override OpenXmlNamespace Namespace
        {
            get
            {
                return OpenXmlNamespaces.RelationshipsNamespace;
            }
        }

        protected override void InitializeAttributesOverride(Relationships value)
        {
        }

        protected override void WriteChildElementsOverride(Relationships value)
        {
            foreach (Relationship relationship in value)
            {
                RelationshipElement relationshipElement = this.CreateChildElement<RelationshipElement>();
                relationshipElement.Write(relationship);
            }
        }

        protected override void CopyAttributesOverride(ref Relationships value)
        {
        }

        protected override void ReadChildElementOverride(ElementBase element, ref Relationships value)
        {
            RelationshipElement relationshipElement = element as RelationshipElement;
            Relationship relationship = null;
            relationshipElement.Read(ref relationship);
            value.AddRelationship(relationship);
        }
    }
}