﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements
{
    internal abstract class RequiredValueElementBase<T> : DirectElementBase<T>
    {
        private readonly OpenXmlAttribute<T> value;

        public RequiredValueElementBase()
        {
            this.value = this.RegisterAttribute<T>("val", true);
        }

        protected T Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(T value)
        {
            this.Value = value;
        }

        protected override void CopyAttributesOverride(ref T value)
        {
            if (this.value.HasValue)
            {
                value = this.Value;
            }
        }

        protected override void WriteChildElementsOverride(T value)
        {
        }
    }
}