﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;
using Telerik.Documents.SpreadsheetStreaming.Model.Relations;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements
{
    internal class SheetElement : DirectElementBase<Relationship>
    {
        private readonly IntOpenXmlAttribute sheetId;
        private readonly OpenXmlAttribute<string> name;
        private readonly OpenXmlAttribute<string> relationId;

        // TODO: Visibility
        //// private readonly MappedOpenXmlAttribute<SheetVisibility> state;

        public SheetElement()
        {
            this.sheetId = this.RegisterAttribute(new IntOpenXmlAttribute("sheetId", true));
            this.name = this.RegisterAttribute<string>("name", true);
            ////this.state = this.RegisterAttribute(new MappedOpenXmlAttribute<SheetVisibility>("state", null, TypeMappers.SheetVisibilityMapper));
            this.relationId = this.RegisterAttribute(new OpenXmlAttribute<string>("id", OpenXmlNamespaces.OfficeDocumentRelationshipsNamespace, true));
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.SheetElementName;
            }
        }

        private int SheetId
        {
            get
            {
                return this.sheetId.Value;
            }
            set
            {
                this.sheetId.Value = value;
            }
        }

        private string Name
        {
            get
            {
                return this.name.Value;
            }
            set
            {
                this.name.Value = value;
            }
        }

        private string RelationId
        {
            get
            {
                return this.relationId.Value;
            }
            set
            {
                this.relationId.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(Relationship value)
        {
            this.Name = value.Name;
            this.SheetId = value.Id;
            this.RelationId = value.RelationshipId;
        }

        protected override void WriteChildElementsOverride(Relationship value)
        {
        }

        protected override void CopyAttributesOverride(ref Relationship value)
        {
            value = new Relationship(this.Name, this.SheetId, this.RelationId, null);
        }

        protected override void ReadChildElementOverride(ElementBase element, ref Relationship value)
        {
        }
    }
}