﻿using System;
using System.Collections.Generic;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.Model.Relations;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements
{
    internal class SheetsElement : DirectElementBase<List<Relationship>>
    {
        private int currentIndex;

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.SheetsElementName;
            }
        }

        protected override void InitializeAttributesOverride(List<Relationship> value)
        {
        }

        protected override void WriteChildElementsOverride(List<Relationship> value)
        {
            foreach (Relationship worksheetRelationship in value)
            {
                SheetElement sheetElement = this.CreateChildElement<SheetElement>();
                sheetElement.Write(worksheetRelationship);
            }
        }

        protected override void CopyAttributesOverride(ref List<Relationship> value)
        {
        }

        protected override void ReadChildElementOverride(ElementBase element, ref List<Relationship> value)
        {
            SheetElement sheet = element as SheetElement;
            Relationship relationship = null;
            sheet.Read(ref relationship);

            if (relationship != null)
            {
                relationship.Index = this.currentIndex++;
                value.Add(relationship);
            }
        }
    }
}