﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;
using Telerik.Documents.SpreadsheetStreaming.Model.Formatting;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Styles
{
    internal class BordersElement : DirectElementBase<List<SpreadCellBorders>>
    {
        private readonly OpenXmlCountAttribute count;

        public BordersElement()
        {
            this.count = this.RegisterCountAttribute();
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.BordersElementName;
            }
        }

        public int Count
        {
            set
            {
                this.count.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(List<SpreadCellBorders> value)
        {
            this.Count = value.Count;
        }

        protected override void WriteChildElementsOverride(List<SpreadCellBorders> value)
        {
            for (int i = 0; i < value.Count; i++)
            {
                SpreadCellBorders borders = value[i];
                BorderElement borderElement = this.CreateChildElement<BorderElement>();
                borderElement.Write(borders);
            }
        }

        protected override void CopyAttributesOverride(ref List<SpreadCellBorders> value)
        {
        }

        protected override void ReadChildElementOverride(ElementBase element, ref List<SpreadCellBorders> value)
        {
            BorderElement borderElement = element as BorderElement;
            SpreadCellBorders borders = new SpreadCellBorders();

            borderElement.Read(ref borders);

            value.Add(borders);
        }
    }
}