﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Styles
{
    internal abstract class CellFormatsElementBase : DirectElementBase<List<DiferentialFormat>>
    {
        private readonly OpenXmlCountAttribute count;

        public CellFormatsElementBase()
        {
            this.count = this.RegisterCountAttribute();
        }

        private int Count
        {
            set
            {
                this.count.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(List<DiferentialFormat> value)
        {
            this.Count = value.Count;
        }

        protected override void WriteChildElementsOverride(List<DiferentialFormat> value)
        {
            for (int i = 0; i < value.Count; i++)
            {
                DiferentialFormat format = value[i];
                FormatElement formatElement = this.CreateChildElement<FormatElement>();
                formatElement.Write(format);
            }
        }

        protected override void CopyAttributesOverride(ref List<DiferentialFormat> value)
        {
        }

        protected override void ReadChildElementOverride(ElementBase element, ref List<DiferentialFormat> value)
        {
            FormatElement formatElement = element as FormatElement;
            DiferentialFormat format = new DiferentialFormat();
            formatElement.Read(ref format);

            value.Add(format);
        }
    }
}