﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Writers.Worksheet.Styles;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Styles
{
    internal class CellStylesElement : DirectElementBase<List<CellStyleInfo>>
    {
        private readonly OpenXmlCountAttribute count;

        public CellStylesElement()
        {
            this.count = this.RegisterCountAttribute();
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.CellStylesElementName;
            }
        }

        private int Count
        {
            set
            {
                this.count.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(List<CellStyleInfo> value)
        {
            this.Count = value.Count;
        }

        protected override void WriteChildElementsOverride(List<CellStyleInfo> value)
        {
            for (int i = 0; i < value.Count; i++)
            {
                CellStyleInfo cellStyle = value[i];
                CellStyleElement cellStyleElement = this.CreateChildElement<CellStyleElement>();
                cellStyleElement.Write(cellStyle);
            }
        }

        protected override void CopyAttributesOverride(ref List<CellStyleInfo> value)
        {
        }

        protected override void ReadChildElementOverride(ElementBase element, ref List<CellStyleInfo> value)
        {
            CellStyleElement cellStyleElement = element as CellStyleElement;
            CellStyleInfo info = new CellStyleInfo();

            cellStyleElement.Read(ref info);

            value.Add(info);
        }
    }
}