﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Writers.Worksheet.Styles;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Styles
{
    internal class FillElement : DirectElementBase<ISpreadFill>
    {
        public override string ElementName
        {
            get
            {
                return XlsxElementNames.FillElementName;
            }
        }

        protected override void InitializeAttributesOverride(ISpreadFill value)
        {
        }

        protected override void WriteChildElementsOverride(ISpreadFill value)
        {
            SpreadPatternFill patternFill = value as SpreadPatternFill;
            if (patternFill != null)
            {
                PatternFillElement patternFillElement = this.CreateChildElement<PatternFillElement>();
                patternFillElement.Write(patternFill);

                return;
            }

            SpreadGradientFill gradientFill = value as SpreadGradientFill;
            if (gradientFill != null)
            {
                GradientFillElement gradientFillElement = this.CreateChildElement<GradientFillElement>();
                gradientFillElement.Write(gradientFill);

                return;
            }

            NoneFill noneFill = value as NoneFill;
            if (noneFill != null)
            {
                PatternFillElement patternFillElement = this.CreateChildElement<PatternFillElement>();
                patternFillElement.Write(noneFill);

                return;
            }
        }

        protected override void CopyAttributesOverride(ref ISpreadFill value)
        {
        }

        protected override void ReadChildElementOverride(ElementBase element, ref ISpreadFill value)
        {
            switch (element.ElementName)
            {
                case XlsxElementNames.PatternFillElementName:
                    {
                        PatternFillElement patternFillElement = element as PatternFillElement;
                        patternFillElement.Read(ref value);
                    }
                    break;

                case XlsxElementNames.GradientFillElementName:
                    {
                        GradientFillElement gradientFillElement = element as GradientFillElement;
                        gradientFillElement.Read(ref value);
                    }
                    break;

                default:
                    throw new InvalidOperationException();
            }
        }
    }
}