﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Styles
{
    internal class FillsElement : DirectElementBase<List<ISpreadFill>>
    {
        private readonly OpenXmlCountAttribute count;

        public FillsElement()
        {
            this.count = this.RegisterCountAttribute();
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.FillsElementName;
            }
        }

        private int Count
        {
            set
            {
                this.count.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(List<ISpreadFill> value)
        {
            this.Count = value.Count;
        }

        protected override void WriteChildElementsOverride(List<ISpreadFill> value)
        {
            for (int i = 0; i < value.Count; i++)
            {
                FillElement fillElement = this.CreateChildElement<FillElement>();
                fillElement.Write(value[i]);
            }
        }

        protected override void CopyAttributesOverride(ref List<ISpreadFill> value)
        {
        }

        protected override void ReadChildElementOverride(ElementBase element, ref List<ISpreadFill> value)
        {
            FillElement fillElement = element as FillElement;

            ISpreadFill fill = null;
            fillElement.Read(ref fill);

            value.Add(fill);
        }
    }
}