﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Styles
{
    internal class FontsElement : DirectElementBase<List<FontProperties>>
    {
        private readonly OpenXmlCountAttribute count;

        public FontsElement()
        {
            this.count = this.RegisterCountAttribute();
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.FontsElementName;
            }
        }

        private int Count
        {
            set
            {
                this.count.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(List<FontProperties> value)
        {
            this.Count = value.Count;
        }

        protected override void WriteChildElementsOverride(List<FontProperties> value)
        {
            for (int i = 0; i < value.Count; i++)
            {
                FontElement font = this.CreateChildElement<FontElement>();
                font.Write(value[i]);
            }
        }

        protected override void CopyAttributesOverride(ref List<FontProperties> value)
        {
        }

        protected override void ReadChildElementOverride(ElementBase element, ref List<FontProperties> value)
        {
            FontElement fontElement = element as FontElement;
            FontProperties font = new FontProperties();

            fontElement.Read(ref font);

            value.Add(font);
        }
    }
}