﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Styles
{
    internal class NumberFormatElement : DirectElementBase<NumberFormat>
    {
        private readonly OpenXmlAttribute<string> formatCode;
        private readonly IntOpenXmlAttribute formatId;

        public NumberFormatElement()
        {
            this.formatCode = this.RegisterAttribute<string>("formatCode", true);
            this.formatId = this.RegisterAttribute(new IntOpenXmlAttribute("numFmtId", true));
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.NumberFormatElementName;
            }
        }

        private string FormatCode
        {
            get
            {
                return this.formatCode.Value;
            }
            set
            {
                this.formatCode.Value = value;
            }
        }

        private int FormatId
        {
            get
            {
                return this.formatId.Value;
            }
            set
            {
                this.formatId.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(NumberFormat value)
        {
            this.FormatCode = value.NumberFormatString;
            if (value.NumberFormatId.HasValue)
            {
                this.FormatId = value.NumberFormatId.Value;
            }
        }

        protected override void CopyAttributesOverride(ref NumberFormat value)
        {
            value.NumberFormatString = this.FormatCode;
            if (this.formatId.HasValue)
            {
                value.NumberFormatId = this.FormatId;
            }
        }

        protected override void WriteChildElementsOverride(NumberFormat value)
        {
        }

        protected override void ReadChildElementOverride(ElementBase element, ref NumberFormat value)
        {
        }
    }
}