﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Styles
{
    internal class NumberFormatsElement : DirectElementBase<List<NumberFormat>>
    {
        private readonly OpenXmlCountAttribute count;

        public NumberFormatsElement()
        {
            this.count = this.RegisterCountAttribute();
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.NumberFormatsElementName;
            }
        }

        private int Count
        {
            set
            {
                this.count.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(List<NumberFormat> value)
        {
            this.Count = value.Count;
        }

        protected override void CopyAttributesOverride(ref List<NumberFormat> value)
        {
        }

        protected override void WriteChildElementsOverride(List<NumberFormat> value)
        {
            foreach (NumberFormat element in value)
            {
                NumberFormatElement numberFormatElement = this.CreateChildElement<NumberFormatElement>();
                numberFormatElement.Write(element);
            }
        }

        protected override void ReadChildElementOverride(ElementBase element, ref List<NumberFormat> value)
        {
            NumberFormatElement numberFormatElement = element as NumberFormatElement;
            NumberFormat format = new NumberFormat();

            numberFormatElement.Read(ref format);

            value.Add(format);
        }
    }
}