﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Styles
{
    internal class ProtectionElement : DirectElementBase<DiferentialFormat>
    {
        private readonly BoolOpenXmlAttribute locked;

        public ProtectionElement()
        {
            this.locked = this.RegisterAttribute(new BoolOpenXmlAttribute("locked"));
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.ProtectionElementName;
            }
        }

        protected override bool AlwaysExport
        {
            get
            {
                return false;
            }
        }

        private bool Locked
        {
            get
            {
                return this.locked.Value;
            }
            set
            {
                this.locked.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(DiferentialFormat value)
        {
            if (value.IsLocked.HasValue)
            {
                this.Locked = value.IsLocked.Value;
            }
        }

        protected override void CopyAttributesOverride(ref DiferentialFormat value)
        {
            if (this.locked.HasValue)
            {
                value.IsLocked = this.Locked;
            }
        }

        protected override void WriteChildElementsOverride(DiferentialFormat value)
        {
        }
    }
}