﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Types;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Styles
{
    internal class UnderlineElement : DirectElementBase<string>
    {
        private readonly OpenXmlAttribute<string> value;

        public UnderlineElement()
        {
            this.value = this.RegisterAttribute<string>("val", UnderlineValuesMapper.Single);
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.UnderlineElementName;
            }
        }

        private string Value
        {
            get
            {
                return this.value.Value;
            }
            set
            {
                this.value.Value = value;
            }
        }

        protected override void InitializeAttributesOverride(string value)
        {
            this.Value = value;
        }

        protected override void CopyAttributesOverride(ref string value)
        {
            value = this.Value;
        }

        protected override void WriteChildElementsOverride(string value)
        {
        }
    }
}