﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Worksheet
{
    internal class ColumnsElement : ConsecutiveElementBase
    {
        public ColumnsElement()
        {
            this.RegisterChildElement<ColumnElement>();
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.ColumnsElementName;
            }
        }

        public IEnumerable<ColumnElement> Columns
        {
            get
            {
                while (this.ReadToElement<ColumnElement>())
                {
                    ColumnElement columnElement = this.CreateChildElement<ColumnElement>();

                    yield return columnElement;
                }

                yield break;
            }
        }

        public ColumnElement CreateColumnElementWriter()
        {
            return this.CreateChildElement<ColumnElement>();
        }
    }
}