﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements.Worksheet
{
    internal class SheetDataElement : ConsecutiveElementBase
    {
        public SheetDataElement()
        {
            this.RegisterChildElement<RowElement>();
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.SheetDataElementName;
            }
        }

        public IEnumerable<RowElement> Rows
        {
            get
            {
                while (this.ReadToElement<RowElement>())
                {
                    RowElement rowElement = this.CreateChildElement<RowElement>();
                    rowElement.BeginReadElement();

                    yield return rowElement;

                    rowElement.EndReadElement();
                }

                yield break;
            }
        }

        public RowElement CreateRowElementWriter()
        {
            return this.CreateChildElement<RowElement>();
        }
    }
}