﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Elements;
using Telerik.Documents.SpreadsheetStreaming.Model.Relations;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Writers
{
    internal class WorkbookElementWriter : DirectElementBase<List<Relationship>>
    {
        public override OpenXmlNamespace Namespace
        {
            get
            {
                return OpenXmlNamespaces.SpreadsheetMLNamespace;
            }
        }

        public override IEnumerable<OpenXmlNamespace> Namespaces
        {
            get
            {
                yield return OpenXmlNamespaces.OfficeDocumentRelationshipsNamespace;
            }
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.WorkbookElementName;
            }
        }

        protected override void InitializeAttributesOverride(List<Relationship> value)
        {
        }

        protected override void WriteChildElementsOverride(List<Relationship> value)
        {
            SheetsElement sheets = this.CreateChildElement<SheetsElement>();
            sheets.Write(value);
        }

        protected override void CopyAttributesOverride(ref List<Relationship> value)
        {
        }

        protected override void ReadChildElementOverride(ElementBase element, ref List<Relationship> value)
        {
            SheetsElement sheetsElement = element as SheetsElement;
            sheetsElement.Read(ref value);
        }
    }
}