﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Attributes;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core.Types;

namespace Telerik.Documents.SpreadsheetStreaming.ImportExport.Model.Writers.Worksheet
{
    internal class MergedCellElementWriter : ConsecutiveElementBase
    {
        private readonly ConvertedOpenXmlAttribute<Ref> reference;

        public MergedCellElementWriter()
        {
            this.reference = this.RegisterAttribute(new ConvertedOpenXmlAttribute<Ref>("ref", Converters.RefConverter, true));
        }

        public override string ElementName
        {
            get
            {
                return XlsxElementNames.MergedCellElementName;
            }
        }

        private Ref Reference
        {
            set
            {
                this.reference.Value = value;
            }
        }

        public void Write(int fromRowIndex, int fromColumnIndex, int toRowIndex, int toColumnIndex)
        {
            this.Reference = new Ref(fromRowIndex, fromColumnIndex, toRowIndex, toColumnIndex);
            this.EnsureWritingStarted();
            this.EnsureWritingEnded();
        }
    }
}