﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.Model
{
    internal class ColumnRange
    {
        public ColumnRange(int columnNumber)
        {
            this.FirstColumnNumber = columnNumber;
            this.LastColumnNumber = columnNumber;
        }

        public int FirstColumnNumber { get; private set; }

        public int LastColumnNumber { get; set; }

        public bool? CustomWidth { get; set; }

        public double? Width { get; set; }

        public int? OutlineLevel { get; set; }

        public bool? Hidden { get; set; }

        public bool HasEqualColumnProperties(ColumnRange other)
        {
            return ObjectExtensions.EqualsOfT(this.CustomWidth, other.CustomWidth) &&
                ObjectExtensions.EqualsOfT(this.Width, other.Width) &&
                ObjectExtensions.EqualsOfT(this.OutlineLevel, other.OutlineLevel) &&
                ObjectExtensions.EqualsOfT(this.Hidden, other.Hidden);
        }

        public void MergeWith(ColumnRange other)
        {
            this.FirstColumnNumber = Math.Min(this.FirstColumnNumber, other.FirstColumnNumber);
            this.LastColumnNumber = Math.Max(this.LastColumnNumber, other.LastColumnNumber);
        }
    }
}