﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.ImportExport.Core;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.Model.ContentTypes
{
    internal class DefaultContentType
    {
        private string extension;

        public DefaultContentType(string extension, string contentType)
        {
            this.Extension = extension;
            this.ContentType = contentType;
        }

        public DefaultContentType()
        {
        }

        public string Extension
        {
            get
            {
                return this.extension;
            }
            set
            {
                this.extension = value;

                string contentType;
                if (OpenXmlHelper.TryGetContentTypeByExtension(this.Extension, out contentType))
                {
                    this.ContentType = contentType;
                }
            }
        }

        public string ContentType { get; set; }

        public override bool Equals(object obj)
        {
            DefaultContentType other = obj as DefaultContentType;

            if (other == null)
            {
                return false;
            }

            return ObjectExtensions.EqualsOfT(this.Extension, other.Extension) &&
                ObjectExtensions.EqualsOfT(this.ContentType, other.ContentType);
        }

        public override int GetHashCode()
        {
            return ObjectExtensions.CombineHashCodes(
                this.Extension.GetHashCodeOrZero(),
                this.ContentType.GetHashCodeOrZero());
        }
    }
}