﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.Model.ContentTypes
{
    internal class OverrideContentType
    {
        public OverrideContentType()
        {
        }

        public OverrideContentType(string path, string contentType)
        {
            this.Path = path;
            this.ContentType = contentType;
        }

        public string Path { get; set; }

        public string ContentType { get; set; }

        public override bool Equals(object obj)
        {
            OverrideContentType other = obj as OverrideContentType;

            if (other == null)
            {
                return false;
            }

            return ObjectExtensions.EqualsOfT(this.Path, other.Path) &&
                ObjectExtensions.EqualsOfT(this.ContentType, other.ContentType);
        }

        public override int GetHashCode()
        {
            return ObjectExtensions.CombineHashCodes(
                this.Path.GetHashCodeOrZero(),
                this.ContentType.GetHashCodeOrZero());
        }
    }
}