﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.Model.Formatting
{
    internal class SpreadCellBorders
    {
        public SpreadBorder Left { get; set; }
        public SpreadBorder Right { get; set; }
        public SpreadBorder Top { get; set; }
        public SpreadBorder Bottom { get; set; }
        public SpreadBorder DiagonalUp { get; set; }
        public SpreadBorder DiagonalDown { get; set; }

        public override bool Equals(object obj)
        {
            SpreadCellBorders other = obj as SpreadCellBorders;

            if (other == null)
            {
                return false;
            }

            return ObjectExtensions.EqualsOfT(this.Left, other.Left) &&
                ObjectExtensions.EqualsOfT(this.Right, other.Right) &&
                ObjectExtensions.EqualsOfT(this.Top, other.Top) &&
                ObjectExtensions.EqualsOfT(this.Bottom, other.Bottom) &&
                ObjectExtensions.EqualsOfT(this.DiagonalUp, other.DiagonalUp) &&
                ObjectExtensions.EqualsOfT(this.DiagonalDown, other.DiagonalDown);
        }

        public override int GetHashCode()
        {
            return ObjectExtensions.CombineHashCodes(
                this.Left.GetHashCodeOrZero(),
                this.Right.GetHashCodeOrZero(),
                this.Top.GetHashCodeOrZero(),
                this.Bottom.GetHashCodeOrZero(),
                this.DiagonalUp.GetHashCodeOrZero(),
                this.DiagonalDown.GetHashCodeOrZero());
        }
    }
}