﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming.Model
{
    internal class Pane
    {
        private int topLeftCellRowIndex;
        private int topLeftCellColumnIndex;

        public int? XSplit { get; private set; }

        public int? YSplit { get; private set; }

        public SpreadPane? ActivePane { get; private set; }

        public PaneState? State { get; private set; }

        internal void GetTopLeftCell(out int rowIndex, out int columnIndex)
        {
            rowIndex = this.topLeftCellRowIndex;
            columnIndex = this.topLeftCellColumnIndex;
        }

        internal void SetTopLeftRowIndex(int rowIndex)
        {
            this.topLeftCellRowIndex = rowIndex;
        }

        internal void SetTopLeftColumnIndex(int columnIndex)
        {
            this.topLeftCellColumnIndex = columnIndex;
        }

        internal void SetTopLeftCell(int rowIndex, int columnIndex)
        {
            this.topLeftCellRowIndex = rowIndex;
            this.topLeftCellColumnIndex = columnIndex;
        }

        internal void SetSplitOffset(int rowOffset, int columnOffset)
        {
            this.XSplit = columnOffset;
            this.YSplit = rowOffset;
            this.State = PaneState.Frozen;
        }

        internal void SetActivePane(SpreadPane spreadPane)
        {
            this.ActivePane = spreadPane;
        }
    }
}