﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Core;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.Model.Themes
{
    internal class SpreadTheme : NamedObjectBase
    {
        private readonly SpreadThemeColorScheme colorScheme;
        private readonly SpreadThemeFontScheme fontScheme;

        public SpreadTheme(string name, SpreadThemeColorScheme colorScheme, SpreadThemeFontScheme fontScheme)
            : base(name)
        {
            this.colorScheme = colorScheme;
            this.fontScheme = fontScheme;
        }

        public SpreadThemeColorScheme ColorScheme
        {
            get
            {
                return this.colorScheme;
            }
        }

        public SpreadThemeFontScheme FontScheme
        {
            get
            {
                return this.fontScheme;
            }
        }

        public override bool Equals(object obj)
        {
            SpreadTheme other = obj as SpreadTheme;

            if (other == null)
            {
                return false;
            }

            return this.Name.Equals(other.Name) &&
                this.ColorScheme.Equals(other.ColorScheme) &&
                this.FontScheme.Equals(other.FontScheme);
        }

        public override int GetHashCode()
        {
            return ObjectExtensions.CombineHashCodes(this.Name.GetHashCode(), this.ColorScheme.GetHashCode(), this.FontScheme.GetHashCode());
        }
    }
}