﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.Model.Themes
{
    internal class SpreadThemeColor
    {
        private readonly SpreadThemeColorType themeColorType;
        private readonly SpreadColor color;

        public SpreadThemeColor(SpreadColor color, SpreadThemeColorType themeColorType)
        {
            this.color = color;
            this.themeColorType = themeColorType;
        }

        public SpreadColor Color
        {
            get
            {
                return this.color;
            }
        }

        public override bool Equals(object obj)
        {
            SpreadThemeColor other = obj as SpreadThemeColor;
            if (other == null)
            {
                return false;
            }

            return this.color == other.color &&
                this.themeColorType == other.themeColorType;
        }

        public override int GetHashCode()
        {
            return ObjectExtensions.CombineHashCodes(this.color.GetHashCode(), this.themeColorType.GetHashCode());
        }
    }
}