﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.Model.Themes
{
    internal class SpreadThemeFont
    {
        private readonly string fontFamily;
        private readonly SpreadFontLanguageType fontLanguageType;

        public SpreadThemeFont(string fontFamily, SpreadFontLanguageType fontLanguageType)
        {
            this.fontFamily = fontFamily;
            this.fontLanguageType = fontLanguageType;
        }

        public string FontFamily
        {
            get
            {
                return this.fontFamily;
            }
        }

        public override bool Equals(object obj)
        {
            SpreadThemeFont other = obj as SpreadThemeFont;
            if (other == null)
            {
                return false;
            }

            return ObjectExtensions.EqualsOfT(this.fontFamily, other.fontFamily) &&
                this.fontLanguageType == other.fontLanguageType;
        }

        public override int GetHashCode()
        {
            return ObjectExtensions.CombineHashCodes(this.fontFamily.GetHashCode(), this.fontLanguageType.GetHashCode());
        }
    }
}