﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming
{
    /// <summary>
    /// Describes the possible types for the style of the border.
    /// </summary>
    public enum SpreadBorderStyle
    {
        /// <summary>
        /// None border style.
        /// </summary>
        None,

        /// <summary>
        /// Hair border style.
        /// </summary>
        Hair,

        /// <summary>
        /// Dotted border style.
        /// </summary>
        Dotted,

        /// <summary>
        /// DashDotDot border style.
        /// </summary>
        DashDotDot,

        /// <summary>
        /// DashDot border style.
        /// </summary>
        DashDot,

        /// <summary>
        /// Dashed border style.
        /// </summary>
        Dashed,

        /// <summary>
        /// Thin border style.
        /// </summary>
        Thin,

        /// <summary>
        /// MediumDashDotDot border style.
        /// </summary>
        MediumDashDotDot,

        /// <summary>
        /// MediumDashDot border style.
        /// </summary>
        MediumDashDot,

        /// <summary>
        /// MediumDashed border style.
        /// </summary>
        MediumDashed,

        /// <summary>
        /// Double border style.
        /// </summary>
        Double,

        /// <summary>
        /// Medium border style.
        /// </summary>
        Medium,

        /// <summary>
        /// SlantDashDot border style.
        /// </summary>
        SlantDashDot,

        /// <summary>
        /// Thick border style.
        /// </summary>
        Thick
    }
}