﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming
{
    /// <summary>
    /// Describes the possible types of gradients.
    /// </summary>
    public enum SpreadGradientType
    {
        /// <summary>
        /// Horizontal gradient type.
        /// </summary>
        Horizontal,

        /// <summary>
        /// HorizontalReversed gradient type.
        /// </summary>
        HorizontalReversed,

        /// <summary>
        /// HorizontalRepeated gradient type.
        /// </summary>
        HorizontalRepeated,

        /// <summary>
        /// Vertical gradient type.
        /// </summary>
        Vertical,

        /// <summary>
        /// VerticalReversed gradient type.
        /// </summary>
        VerticalReversed,

        /// <summary>
        /// VerticalRepeated gradient type.
        /// </summary>
        VerticalRepeated,

        /// <summary>
        /// DiagonalUp gradient type.
        /// </summary>
        DiagonalUp,

        /// <summary>
        /// DiagonalUpReversed gradient type.
        /// </summary>
        DiagonalUpReversed,

        /// <summary>
        /// DiagonalUpRepeated gradient type.
        /// </summary>
        DiagonalUpRepeated,

        /// <summary>
        /// DiagonalDown gradient type.
        /// </summary>
        DiagonalDown,

        /// <summary>
        /// DiagonalDownReversed gradient type.
        /// </summary>
        DiagonalDownReversed,

        /// <summary>
        /// DiagonalDownRepeated gradient type.
        /// </summary>
        DiagonalDownRepeated,

        /// <summary>
        /// FromTopLeftCorner gradient type.
        /// </summary>
        FromTopLeftCorner,

        /// <summary>
        /// FromTopRightCorner gradient type.
        /// </summary>
        FromTopRightCorner,

        /// <summary>
        /// FromBottomLeftCorner gradient type.
        /// </summary>
        FromBottomLeftCorner,

        /// <summary>
        /// FromBottomRightCorner gradient type.
        /// </summary>
        FromBottomRightCorner,

        /// <summary>
        /// FromCenter gradient type.
        /// </summary>
        FromCenter
    }
}