﻿using System;
using System.IO;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Importers;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming
{
    /// <summary>
    /// Represents an entry point to import a spreadsheet.
    /// </summary>
    internal static class SpreadImporter
    {
        /// <summary>
        /// Creates the workbook importer.
        /// </summary>
        /// <param name="documentFormat">The document format.</param>
        /// <param name="stream">The stream.</param>
        /// <returns></returns>
        public static IWorkbookImporter CreateWorkbookImporter(SpreadDocumentFormat documentFormat, Stream stream)
        {
            Guard.ThrowExceptionIfNull(stream, "stream");

            switch (documentFormat)
            {
                case SpreadDocumentFormat.Xlsx:
                    return new XlsxWorkbookImporter(stream);
                case SpreadDocumentFormat.Csv:
                    // return new CsvWorkbookImporter(stream);
                default:
                    throw new NotSupportedException();
            }
        }
    }
}