﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming
{
    /// <summary>
    /// Describes the possible types of patterns.
    /// </summary>
    public enum SpreadPatternType
    {
        /// <summary>
        /// Solid pattern type.
        /// </summary>
        Solid,

        /// <summary>
        /// Gray75Percent pattern type.
        /// </summary>
        Gray75Percent,

        /// <summary>
        /// Gray50Percent pattern type.
        /// </summary>
        Gray50Percent,

        /// <summary>
        /// Gray25Percent pattern type.
        /// </summary>
        Gray25Percent,

        /// <summary>
        /// Gray12Percent pattern type.
        /// </summary>
        Gray12Percent,

        /// <summary>
        /// Gray6Percent pattern type.
        /// </summary>
        Gray6Percent,

        /// <summary>
        /// HorizontalStripe pattern type.
        /// </summary>
        HorizontalStripe,

        /// <summary>
        /// VerticalStripe pattern type.
        /// </summary>
        VerticalStripe,

        /// <summary>
        /// ReverseDiagonalStripe pattern type.
        /// </summary>
        ReverseDiagonalStripe,

        /// <summary>
        /// DiagonalStripe pattern type.
        /// </summary>
        DiagonalStripe,

        /// <summary>
        /// DiagonalCrosshatch pattern type.
        /// </summary>
        DiagonalCrosshatch,

        /// <summary>
        /// ThickDiagonalCrosshatch pattern type.
        /// </summary>
        ThickDiagonalCrosshatch,

        /// <summary>
        /// ThinHorizontalStripe pattern type.
        /// </summary>
        ThinHorizontalStripe,

        /// <summary>
        /// ThinVerticalStripe pattern type.
        /// </summary>
        ThinVerticalStripe,

        /// <summary>
        /// ThinReverseDiagonalStripe pattern type.
        /// </summary>
        ThinReverseDiagonalStripe,

        /// <summary>
        /// ThinDiagonalStripe pattern type.
        /// </summary>
        ThinDiagonalStripe,

        /// <summary>
        /// ThinHorizontalCrossHatch pattern type.
        /// </summary>
        ThinHorizontalCrossHatch,

        /// <summary>
        /// ThinDiagonalCrosshatch pattern type.
        /// </summary>
        ThinDiagonalCrosshatch
    }
}