﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming
{
    /// <summary>
    /// Describes the possible types of underline.
    /// </summary>
    public enum SpreadUnderlineType
    {
        /// <summary>
        /// None underline type.
        /// </summary>
        None,

        /// <summary>
        /// Single underline type.
        /// </summary>
        Single,

        /// <summary>
        /// Double underline type.
        /// </summary>
        Double,

        /// <summary>
        /// Single accounting underline type. The underline should be drawn under the lower part of characters such as g and p.
        /// </summary>
        SingleAccounting,

        /// <summary>
        /// Double accounting underline type. The underline should be drawn under the lower part of characters such as g and p.
        /// </summary>
        DoubleAccounting,
    }
}