﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming
{
    /// <summary>
    /// Describes the possible types of vertical alignments.
    /// </summary>
    public enum SpreadVerticalAlignment
    {
        /// <summary>
        /// Specifies that the text should align with the bottom edge of the cell.
        /// </summary>
        Bottom,

        /// <summary>
        /// Specifies that the text should be centered across the height of the cell.
        /// </summary>
        Center,

        /// <summary>
        /// Specifies that the text should align with the top edge of the cell.
        /// </summary>
        Top,

        /// <summary>
        /// Specifies that the text should be justified across the height of the cell.
        /// </summary>
        Justify,

        /// <summary>
        /// Specifies that the text should be evenly distributed across the height of the cell.
        /// </summary>
        Distributed,
    }
}