﻿using System;
using System.Linq;

namespace Telerik.Documents.SpreadsheetStreaming.Utilities
{
    internal class MathUtilities
    {
        public static double Clamp(double value, double minimum, double maximum, int precision)
        {
            double clampedValue = 0;

            if (value > maximum)
            {
                clampedValue = maximum;
            }
            else
            {
                clampedValue = value;
            }

            if (clampedValue < minimum)
            {
                clampedValue = minimum;
            }

            return Math.Round(clampedValue, precision);
        }

        public static double CustomMod(double number)
        {
            if (number > 0)
            {
                return number - Math.Floor(number);
            }
            else if (number < 0)
            {
                double abs = Math.Abs(number);

                return 1 - (abs - Math.Floor(abs));
            }

            return 0;
        }
    }
}