﻿using Telerik.Documents.SpreadsheetStreaming.Model;
using Telerik.Documents.SpreadsheetStreaming.Utilities;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.CommonWrappers
{
    internal class CellRangeWrapper
    {
        private readonly int fromRowIndex;
        private readonly int fromColumnIndex;
        private readonly int toRowIndex;
        private readonly int toColumnIndex;

        public CellRangeWrapper(SpreadCellRange cellRange)
            : this(cellRange.FromRowIndex, cellRange.FromColumnIndex, cellRange.ToRowIndex, cellRange.ToColumnIndex)
        {
        }

        public CellRangeWrapper(int fromRowIndex, int fromColumnIndex, int toRowIndex, int toColumnIndex)
        {
            this.fromRowIndex = fromRowIndex;
            this.fromColumnIndex = fromColumnIndex;
            this.toRowIndex = toRowIndex;
            this.toColumnIndex = toColumnIndex;
        }

        public int FromRowIndex
        {
            get
            {
                return this.fromRowIndex;
            }
        }

        public int FromColumnIndex
        {
            get
            {
                return this.fromColumnIndex;
            }
        }

        public int ToRowIndex
        {
            get
            {
                return this.toRowIndex;
            }
        }

        public int ToColumnIndex
        {
            get
            {
                return this.toColumnIndex;
            }
        }

        public override bool Equals(object obj)
        {
            CellRangeWrapper other = obj as CellRangeWrapper;

            if (other == null)
            {
                return false;
            }

            return this.FromRowIndex == other.FromRowIndex &&
                this.FromColumnIndex == other.FromColumnIndex &&
                this.ToRowIndex == other.ToRowIndex &&
                this.ToColumnIndex == other.ToColumnIndex;
        }

        public override int GetHashCode()
        {
            return ObjectExtensions.CombineHashCodes(
                this.FromRowIndex.GetHashCode(),
                this.FromColumnIndex.GetHashCode(),
                this.ToRowIndex.GetHashCode(),
                this.ToColumnIndex.GetHashCode());
        }
    }
}