﻿using System;
using System.Linq;
using Microsoft.Office.Interop.Excel;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class BordersWrapper
    {
        private readonly Borders instance;

        public BordersWrapper(Borders borders)
        {
            this.instance = borders;
        }

        public bool HasDefaultBorders
        {
            get
            {
                return this.DiagonalDown.HasDefaultLineStyle &&
                    this.DiagonalUp.HasDefaultLineStyle &&
                    this.Bottom.HasDefaultLineStyle &&
                    this.Left.HasDefaultLineStyle &&
                    this.Right.HasDefaultLineStyle &&
                    this.Top.HasDefaultLineStyle;
            }
        }

        public BorderWrapper InsideHorizontal
        {
            get
            {
                return new BorderWrapper(this.instance[XlBordersIndex.xlInsideHorizontal]);
            }
        }

        public BorderWrapper InsideVertical
        {
            get
            {
                return new BorderWrapper(this.instance[XlBordersIndex.xlInsideVertical]);
            }
        }

        public BorderWrapper DiagonalDown
        {
            get
            {
                return new BorderWrapper(this.instance[XlBordersIndex.xlDiagonalDown]);
            }
        }

        public BorderWrapper DiagonalUp
        {
            get
            {
                return new BorderWrapper(this.instance[XlBordersIndex.xlDiagonalUp]);
            }
        }

        public BorderWrapper Bottom
        {
            get
            {                
                return new BorderWrapper(this.instance[XlBordersIndex.xlEdgeBottom]);
            }
        }

        public BorderWrapper Left
        {
            get
            {
                return new BorderWrapper(this.instance[XlBordersIndex.xlEdgeLeft]);
            }
        }

        public BorderWrapper Right
        {
            get
            {
                return new BorderWrapper(this.instance[XlBordersIndex.xlEdgeRight]);
            }
        }

        public BorderWrapper Top
        {
            get
            {
                return new BorderWrapper(this.instance[XlBordersIndex.xlEdgeTop]);
            }
        }
    }
}