﻿using Microsoft.Office.Interop.Excel;
using Telerik.Documents.SpreadsheetStreaming.Tests.Utils;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class CellWrapper
    {
        private readonly Range instance;

        public CellWrapper(Range cell)
        {
            this.instance = cell;
        }

        public string Value
        {
            get
            {
                if (this.instance.Value == null)
                {
                    return null;
                }

                return this.instance.Value.ToString();
            }
        }

        public BordersWrapper Borders
        {
            get
            {
                return new BordersWrapper(this.instance.Borders);
            }
        }

        public SpreadPatternFill PatternFill
        {
            get
            {
                var interior = this.instance.Interior;
                return interior.ToPatternFill();
            }
        }

        public string NumberFormat
        {
            get
            {
                return this.instance.NumberFormat;
            }
        }

        public TextPropertiesWrapper TextProperties
        {
            get
            {
                return new TextPropertiesWrapper(this.instance);
            }
        }

        public CellStyleWrapper CellStyle
        {
            get
            {
                var cellStyleName = this.instance.Style;
                return new CellStyleWrapper(cellStyleName);
            }
        }
    }
}