﻿using Microsoft.Office.Interop.Excel;
using Telerik.Documents.SpreadsheetStreaming.Tests.CommonWrappers;
using Telerik.Documents.SpreadsheetStreaming.Tests.Utils;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class CellsWrapper
    {
        private readonly Range cells;
        private readonly CellRangeWrapper range;

        public CellsWrapper(Range cells)
        {
            this.cells = cells;

            this.range = this.cells.ToCellRange();
        }

        public CellWrapper this[int rowIndex, int columnIndex]
        {
            get
            {
                return new CellWrapper(this.cells[rowIndex + 1, columnIndex + 1]);
            }
        }

        internal CellRangeWrapper Range
        {
            get
            {
                return this.range;
            }
        }
    }
}