﻿using System;
using System.Linq;
using Microsoft.Office.Interop.Excel;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class ColumnWrapper
    {
        private readonly Range column;

        public ColumnWrapper(Range column)
        {
            this.column = column;
        }

        public double WidthInCharacters
        {
            get
            {
                return this.column.ColumnWidth;
            }
        }

        public bool IsHidden
        {
            get
            {
                return this.column.EntireColumn.Hidden;
            }
        }

        public double OutlineLevel
        {
            get
            {
                return this.column.Columns.OutlineLevel - 1;
            }
        }
    }
}