﻿using System;
using System.Linq;
using Microsoft.Office.Interop.Excel;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class RowWrapper
    {
        private readonly Range row;

        public RowWrapper(Range row)
        {
            this.row = row;
        }

        public double HeightInPoints
        {
            get
            {
                return this.row.RowHeight;
            }
        }

        public bool IsHidden
        {
            get
            {
                return this.row.EntireRow.Hidden;
            }
        }

        public double OutlineLevel
        {
            get
            {
                return this.row.Rows.OutlineLevel - 1;
            }
        }
    }
}