﻿using System;
using System.Linq;
using Microsoft.Office.Interop.Excel;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class WorksheetWrapper
    {
        private readonly Worksheet instance;

        public WorksheetWrapper(Worksheet worksheet)
        {
            this.instance = worksheet;
        }

        public string Name
        {
            get
            {
                return this.instance.Name;
            }
        }

        public CellsWrapper Cells
        {
            get
            {
                return new CellsWrapper(this.instance.Cells);
            }
        }

        public ColumnsWrapper Columns
        {
            get
            {
                return new ColumnsWrapper(this.instance);
            }
        }

        public RowsWrapper Rows
        {
            get
            {
                return new RowsWrapper(this.instance);
            }
        }

        public MergedCellsWrapper MergedCells
        {
            get
            {
                return new MergedCellsWrapper(this.instance);
            }
        }

        public ViewStateWrapper ViewState
        {
            get
            {
                return new ViewStateWrapper(this.instance);
            }
        }
    }
}