﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Tests.Utils;
using Telerik.Documents.SpreadsheetStreaming;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class BorderWrapper
    {
        private readonly CellBorder instance;
        private static readonly Dictionary<CellBorderStyle, SpreadBorderStyle> borderMapper;

        static BorderWrapper()
        {
            borderMapper = new Dictionary<CellBorderStyle, SpreadBorderStyle>();
            borderMapper.Add(CellBorderStyle.DashDot, SpreadBorderStyle.DashDot);
            borderMapper.Add(CellBorderStyle.DashDotDot, SpreadBorderStyle.DashDotDot);
            borderMapper.Add(CellBorderStyle.Dashed, SpreadBorderStyle.Dashed);
            borderMapper.Add(CellBorderStyle.Dotted, SpreadBorderStyle.Dotted);
            borderMapper.Add(CellBorderStyle.Double, SpreadBorderStyle.Double);
            borderMapper.Add(CellBorderStyle.Hair, SpreadBorderStyle.Hair);
            borderMapper.Add(CellBorderStyle.Medium, SpreadBorderStyle.Medium);
            borderMapper.Add(CellBorderStyle.MediumDashDot, SpreadBorderStyle.MediumDashDot);
            borderMapper.Add(CellBorderStyle.MediumDashDotDot, SpreadBorderStyle.MediumDashDotDot);
            borderMapper.Add(CellBorderStyle.MediumDashed, SpreadBorderStyle.MediumDashed);
            borderMapper.Add(CellBorderStyle.None, SpreadBorderStyle.None);
            borderMapper.Add(CellBorderStyle.SlantDashDot, SpreadBorderStyle.SlantDashDot);
            borderMapper.Add(CellBorderStyle.Thick, SpreadBorderStyle.Thick);
            borderMapper.Add(CellBorderStyle.Thin, SpreadBorderStyle.Thin);
        }

        public BorderWrapper(CellBorder instance)
        {
            this.instance = instance;
        }

        public bool HasDefaultLineStyle
        {
            get
            {
                return borderMapper[this.instance.Style] == TestsHelper.DefaultBorderLineStyle;
            }
        }

        public SpreadBorderStyle Style
        {
            get
            {
                return borderMapper[this.instance.Style];
            }
        }

        public SpreadThemableColor Color
        {
            get
            {
                return this.instance.Color.SpreadColorToThemableColor();
            }
        }
    }
}