﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class BordersWrapper
    {
        private readonly CellBorders instance;

        public BordersWrapper(CellBorders borders)
        {
            this.instance = borders;
        }

        public bool HasDefaultBorders
        {
            get
            {
                return this.DiagonalDown.HasDefaultLineStyle &&
                    this.DiagonalUp.HasDefaultLineStyle &&
                    this.Bottom.HasDefaultLineStyle &&
                    this.Left.HasDefaultLineStyle &&
                    this.Right.HasDefaultLineStyle &&
                    this.Top.HasDefaultLineStyle;
            }
        }

        public BorderWrapper DiagonalDown
        {
            get
            {
                return new BorderWrapper(this.instance.DiagonalDown);
            }
        }

        public BorderWrapper DiagonalUp
        {
            get
            {
                return new BorderWrapper(this.instance.DiagonalUp);
            }
        }

        public BorderWrapper Bottom
        {
            get
            {
                return new BorderWrapper(this.instance.Bottom);
            }
        }

        public BorderWrapper Left
        {
            get
            {
                return new BorderWrapper(this.instance.Left);
            }
        }

        public BorderWrapper Right
        {
            get
            {
                return new BorderWrapper(this.instance.Right);
            }
        }

        public BorderWrapper Top
        {
            get
            {
                return new BorderWrapper(this.instance.Top);
            }
        }
    }
}