﻿using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Tests.CommonWrappers;
using Telerik.Documents.SpreadsheetStreaming.Tests.Utils;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class CellsWrapper
    {
        private readonly CellSelection cells;
        private readonly CellRangeWrapper range;

        public CellsWrapper(CellSelection cells)
        {
            this.cells = cells;

            this.range = this.cells.CellRanges.First().ToCellRange();
        }

        public CellWrapper this[int rowIndex, int columnIndex]
        {
            get
            {
                return new CellWrapper(cells.Worksheet.Cells[rowIndex, columnIndex]);
            }
        }

        internal CellRangeWrapper Range
        {
            get
            {
                return this.range;
            }
        }
    }
}