﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Utilities;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class ColumnWrapper
    {
        private readonly ColumnSelection columns;

        public ColumnWrapper(ColumnSelection columns)
        {
            this.columns = columns;
        }

        public double WidthInCharacters
        {
            get
            {
                double widthInPixels = this.columns.GetWidth().Value.Value;
                if (widthInPixels == 0)
                {
                    double marginPixels = DefaultValues.LeftCellMargin + DefaultValues.RightCellMargin;
                    widthInPixels += marginPixels;
                }
                return UnitHelper.PixelsToCharacterCount(widthInPixels);
            }
        }

        public int OutlineLevel
        {
            get
            {
                return this.columns.GetOutlineLevel().Value;
            }
        }


        public bool IsHidden
        {
            get
            {
                return this.columns.GetHidden().Value;
            }
        }
    }
}