﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class MergedCellsWrapper : IEnumerable<CellsWrapper>
    {
        private readonly Worksheet instance;

        public MergedCellsWrapper(Worksheet instance)
        {
            this.instance = instance;
        }

        private IEnumerable<CellsWrapper> GetMergedCells()
        {
            foreach (CellRange range in instance.Cells.GetMergedCellRanges())
            {
                yield return new CellsWrapper(this.instance.Cells[range]);
            }
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }

        public IEnumerator<CellsWrapper> GetEnumerator()
        {
            return this.GetMergedCells().GetEnumerator();
        }
    }
}