﻿using System;
using System.Linq;
using Telerik.Documents.SpreadsheetStreaming.Utilities;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class RowWrapper
    {
        private readonly RowSelection rows;

        public RowWrapper(RowSelection rows)
        {
            this.rows = rows;
        }

        public double HeightInPoints
        {
            get
            {
                double widthInPixels = this.rows.GetHeight().Value.Value;
                return UnitHelper.DipToPoint(widthInPixels);
            }
        }

        public int OutlineLevel
        {
            get
            {
                return this.rows.GetOutlineLevel().Value;
            }
        }


        public bool IsHidden
        {
            get
            {
                return this.rows.GetHidden().Value;
            }
        }
    }
}