﻿using System;
using System.Linq;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers
{
    public class WorksheetWrapper
    {
        private readonly Worksheet instance;

        public WorksheetWrapper(Worksheet worksheet)
        {
            this.instance = worksheet;
        }

        public object Name
        {
            get
            {
                return this.instance.Name;
            }
        }

        public ViewStateWrapper ViewState
        {
            get
            {
                return new ViewStateWrapper(this.instance.ViewState);
            }
        }

        public CellsWrapper Cells
        {
            get
            {
                return new CellsWrapper(this.instance.Cells[0, 0, SpreadsheetDefaultValues.RowCount - 1, SpreadsheetDefaultValues.ColumnCount - 1]);
            }
        }

        public ColumnsWrapper Columns
        {
            get
            {
                return new ColumnsWrapper(this.instance.Columns);
            }
        }

        public RowsWrapper Rows
        {
            get
            {
                return new RowsWrapper(this.instance.Rows);
            }
        }

        public MergedCellsWrapper MergedCells
        {
            get
            {
                return new MergedCellsWrapper(this.instance);
            }
        }
    }
}