﻿using System;
using System.Linq;

#if VISUAL
using System.IO;
using Telerik.Documents.SpreadsheetStreaming.VisualTests.Utils;
using Telerik.Windows.Documents.Fixed.Tests.Integration;
using Microsoft.VisualStudio.TestTools.UnitTesting;

#endif

namespace Telerik.Documents.SpreadsheetStreaming.Tests
{
#if VISUAL

    [TestClass]
    public abstract class StreamFormatProvidersTestBase : IntegrationTestClassBase
    {
        protected abstract string FileExtenssion { get; }

        [TestInitialize]
        public void TestInitialize()
        {
            var defaultRectangle = new System.Drawing.Rectangle(13, 148, 30, 180);
            this.VisualTestHelper.DefaultRectangle = defaultRectangle;
        }

        public void AssertAreVisualyEqual(byte[] data)
        {
            var defaultRectangle = new System.Drawing.Rectangle(13, 148, 30, 180);
            AssertVisual.AssertAreVisuallyEqual(this.VisualTestHelper, this.FileExtenssion, data);
        }

        public void AssertTestVisual(byte[] data)
        {
            AssertVisual.AssertAreVisuallyEqual(this.VisualTestHelper, this.FileExtenssion, data);
        }

        public void AssertTestVisual(Stream stream)
        {
            AssertVisual.AssertAreVisuallyEqual(this.VisualTestHelper, this.FileExtenssion, ReadFully(stream));
        }

        public void AssertTestVisual(Stream stream, Action action)
        {
            AssertVisual.AssertAreVisuallyEqual(this.VisualTestHelper, this.FileExtenssion, action, ReadFully(stream));
        }


        private static byte[] ReadFully(Stream input)
        {
            input.Seek(0, SeekOrigin.Begin);
            byte[] buffer = new byte[input.Length];
            using (MemoryStream ms = new MemoryStream())
            {
                int read;
                while ((read = input.Read(buffer, 0, buffer.Length)) > 0)
                {
                    ms.Write(buffer, 0, read);
                }
                return ms.ToArray();
            }
        }
    }
#else
    public abstract class StreamFormatProvidersTestBase
    {
        protected abstract string FileExtenssion { get; }
    }
#endif
}