﻿#if EXCEL || SPREAD
#endif
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Documents.SpreadsheetStreaming.Tests;
using Telerik.Documents.SpreadsheetStreaming.Tests.Utils;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using Telerik.Documents.SpreadsheetStreaming;

#if SPREAD
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.TextBased.Csv;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx;
#endif

namespace Telerik.Documents.SpreadsheetStreaming.Tests.ExportBase
{
    public abstract class ExportTestBase : StreamFormatProvidersTestBase
    {
        protected abstract SpreadDocumentFormat SpreadDocumentFormat
        {
            get;
        }

        protected abstract string TestCategory
        {
            get;
        }

        protected override string FileExtenssion
        {
            get
            {
                return this.GetFileFormat();
            }
        }

        protected string GetFileFormat()
        {
            return "." + this.SpreadDocumentFormat.ToString().ToLower();
        }

        protected void AssertStreamRead(Stream stream)
        {
            Assert.IsTrue(stream.CanSeek);
            Assert.IsTrue(stream.CanRead);
        }
    }
}
