﻿#if EXCEL || SPREAD
using Telerik.Documents.SpreadsheetStreaming.Tests.Wrappers;
using Telerik.Documents.SpreadsheetStreaming.Tests.Utils;
#endif
using System.IO;
using Telerik.Documents.SpreadsheetStreaming;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.ExportBase
{
    public abstract class WorkbookTestBase : ExportTestBase
    {
        protected void CreateMoreThanOneWorkbookWithTheSameStream()
        {
            MemoryStream stream = null;
            string firstWorksheetName = "First";
            string secondWorksheetName = "Second";

            using (stream = new MemoryStream())
            {
                using (IWorkbookExporter workbook = SpreadExporter.CreateWorkbookExporter(this.SpreadDocumentFormat, stream))
                {
                    using (IWorksheetExporter worksheet = workbook.CreateWorksheetExporter(firstWorksheetName))
                    {
                        using (worksheet.CreateRowExporter())
                        {
                        }
                    }
                }

                using (IWorkbookExporter workbook = SpreadExporter.CreateWorkbookExporter(this.SpreadDocumentFormat, stream))
                {
                    using (IWorksheetExporter worksheet = workbook.CreateWorksheetExporter(secondWorksheetName))
                    {
                        using (IRowExporter row = worksheet.CreateRowExporter())
                        {
                            using (ICellExporter cell = row.CreateCellExporter())
                            {
                                cell.SetValue("test");
                            }
                        }
                    }
                }

#if VISUAL
                this.AssertTestVisual(stream);
#else
                using (WorkbookWrapper workbookWraper = WorkbookWrapper.Open(stream, this.SpreadDocumentFormat))
                {
                    WorksheetWrapper worksheet = workbookWraper.Worksheets[0];

                    Assert.IsTrue(workbookWraper.Worksheets.WorksheetsCount == 1);
                    Assert.AreEqual("Second", worksheet.Name);
                }
#endif
            }
        }

#if SPREAD
        protected void CreateEmptyWorkbook()
        {
            MemoryStream stream = null;
            using (stream = new MemoryStream())
            {
                using (IWorkbookExporter workbook = SpreadExporter.CreateWorkbookExporter(this.SpreadDocumentFormat, stream))
                {
                }
            }
        }
#endif
    }
}
