﻿#if EXCEL || SPREAD
using Telerik.Documents.SpreadsheetStreaming.Tests.ExcelWrappers;
#endif

using System;
using System.IO;
using Telerik.Documents.SpreadsheetStreaming.Tests.Utils;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Documents.SpreadsheetStreaming;
using Telerik.Documents.SpreadsheetStreaming.Model;
using Telerik.Documents.SpreadsheetStreaming.VisualTests.Tests.CellValuesBaseTest;

namespace Telerik.Documents.SpreadsheetStreaming.Tests.Tests
{
    [TestClass]
    public class CellValueXlsxTests : CellValuesBaseTest
    {
        protected override SpreadDocumentFormat SpreadDocumentFormat
        {
            get
            {
                return SpreadDocumentFormat.Xlsx;
            }
        }

        protected override string TestCategory
        {
            get
            {
                return SpreadsheetStreamingCategory.XlsxExport;
            }
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetTextCellValueTest()
        {
            this.SetTextToCellAndAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetTextToCellWithNumberFormattingTest()
        {
            this.SetTextToCellWithNumberFormattingAndAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetNumberAsStringToCellWithNumberFormattingTest()
        {
            this.SetNumberAsStringToCellWithNumberFormattingAndAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetNumeberValueToACellWithoutFormattingTest()
        {
            this.SetNumeberToACellWithoutFormattingAndAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetNumeberValueToACellWithNumberFormatting()
        {
            this.SetNumeberToACellWithNumberFormattingAndAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetNumeberToACellWithNumberFormattingTest()
        {
            this.SetNumeberToACellWithNumberFormattingAndAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        [TestCategory(SpreadsheetStreamingCategory.Bug)]
        public void SetDateValueWtihDateFormattingTest()
        {
            this.SetDateValueWtihDateFormattingAndVerifyTheData();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        [TestCategory(SpreadsheetStreamingCategory.Bug)]
        public void SetDateValueWithoutFormattingTest()
        {
            this.SetDateValueWithoutFormattingAndVerifyDocument();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetBooleanValueTest()
        {
            this.SetBooleanValueAndVerifyDocument();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetFormatToACellAfterSettingValue()
        {
            this.SetFormatToACellAfterSettingValueAndAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetFormatToACellBeforeSettingValueTest()
        {
            this.SetFormatToACellBeforeSettingValueAndAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetMultipleCellValuesWithFormatTest()
        {
            this.SetMultipleCellValuesWithFormatsAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetAllCellBordersTest()
        {
            this.SetAllCellBordersAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetAllCellsPatternTypesTest()
        {
            this.SetAllCellsPatternTypesAndAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SkipCellsTest()
        {
            this.SkipCellsAndAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetMultipleValuesToASingleCellTest()
        {
            this.SetMultipleValuesToASingleCellAndVerifyTheDocument();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.CellValue)]
        public void SetMultipleFormatsToASingleCellTest()
        {
            this.SetMultipleFormatsToASingleCellAndAssert();
        }
    }
}