﻿#if EXCEL || SPREAD
#endif
using Telerik.Documents.SpreadsheetStreaming.Tests;
using Telerik.Documents.SpreadsheetStreaming.VisualTests.Tests;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Telerik.Documents.SpreadsheetStreaming.Tests.Utils;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using Telerik.Documents.SpreadsheetStreaming;

namespace Telerik.Documents.SpreadsheetStreaming.ExcelInteropTests.Tests
{
    [TestClass]
    public class ElementsExportOrderXlsxTests : ElementsOrderTestBase
    {
        protected override SpreadDocumentFormat SpreadDocumentFormat
        {
            get
            {
                return SpreadDocumentFormat.Xlsx;
            }
        }

        protected override string TestCategory
        {
            get
            {
                return SpreadsheetStreamingCategory.SpreadsheetStreaming;
            }
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(InvalidOperationException))]
        public void ColumnsExportOrderIsBeforeRows()
        {
            this.AddRowsExportBeforeColumnsExport();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(InvalidOperationException))]
        public void ColumnsExportOrderCannotBeAddedAfterRowExportOrderTest()
        {
            this.ExportColumnBeforeAndAfterRowExportOrder();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(InvalidOperationException))]
        public void MergeCellsOrderIsNotBeforeColumnExportTest()
        {
            this.MergeCellsBeforeColumnExport();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(InvalidOperationException))]
        public void MergeCellsOrderIsAfterColumnsExportOrderTest()
        {
            this.MergeCellsAfterColumnsExport();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(InvalidOperationException))]
        public void ColumnsExportOrderCannotBeWithinRowExportOrderTest()
        {
            this.ExportColumnWithinRow();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void SkipCellsCannotAcceptNegativeNumberTest()
        {
            this.SkipCellsCannotAcceptNegativeNumberAndAssert();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void SkipRowsCannotAcceptNegativeValueTest()
        {
            this.SkipRowsCannotAcceptNegativeNumber();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void SkipColumnsCannotAcceptNegativeNumberTest()
        {
            this.SkipColumnsCannotAcceptNegativeNumber();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(InvalidOperationException))]
        public void RowsExportOrderCannotBeWithinColumnExportTest()
        {
            this.ExportRowsWithinColumns();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(InvalidOperationException))]
        public void MergingCellsWithoutCreatingRowExportAndAfterColumnExportTest()
        {
            this.MergeCellsAfterColumnExportWithoutCreatingRowsAndVerifyDocumentIsValid();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(InvalidOperationException))]
        public void MergingCellsOrderIsNotWithinColumnExportTest()
        {
            this.MergeCellsWithinColumnExport();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(InvalidOperationException))]
        public void MergingCellsOrderIsNotBeforeRowExporterTest()
        {
            this.MergingCellsBeforeRowExporter();
        }

        [TestMethod]
        [TestCategory(SpreadsheetStreamingCategory.SpreadsheetStreaming)]
        [TestCategory(SpreadsheetStreamingCategory.XlsxExport)]
        [TestCategory(SpreadsheetStreamingCategory.ElementsExportOrder)]
        [ExpectedException(typeof(InvalidOperationException))]
        public void MergingCellsOrderIsNotWithinRowExporterTest()
        {
            this.MergingCellsOrderIsNotWithinRowExporter();
        }
    }
}
