﻿using System;

#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Interface which must be implemented by all implementations of the checksum algorithm.
    /// </summary>
    internal interface IChecksumAlgorithm
    {
        /// <summary>
        /// Calculate checksum for the specified region of the input byte array.
        /// </summary>
        /// <param name="checksum">Checksum to update.</param>
        /// <param name="buffer">The input for which to compute the checksum.</param>
        /// <param name="offset">The offset into the input byte array from which to begin using data.</param>
        /// <param name="length">The number of bytes in the input byte array to use as data.</param>
        /// <returns>Updated checksum.</returns>
        uint UpdateChecksum(uint checksum, byte[] buffer, int offset, int length);
    }
}
