﻿#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Represents a state of current block.
    /// </summary>
    internal enum DeflateBlockState
    {
        /// <summary>
        /// Block is not completed, need more input or more output.
        /// </summary>
        NeedMore = 0,

        /// <summary>
        /// Block flush performed.
        /// </summary>
        BlockDone,

        /// <summary>
        /// Finish started, need only more output at next deflate.
        /// </summary>
        FinishStarted,

        /// <summary>
        /// Finish done, accept no more input or output.
        /// </summary>
        FinishDone
    }
}
