﻿#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Represents constants for deflate compression.
    /// </summary>
    internal static class DeflateConstants
    {
        /// <summary>
        /// Z-lib header: the deflate compression method.
        /// </summary>
        public const int HeaderDeflated = 8;

        public const int MaxBits = 15;
        public const int BitLengthCodes = 19;
        public const int DynamicCodes = 30;
        public const int Literals = 256;
        public const int CodesLength = 29;
        public const int LiteralCodes = Literals + 1 + CodesLength;
        public const int EndOfBlockCode = 256;
        public const int MaxDistanceTreeElements = 32;
        public const int MaxLiteralTreeElements = 288;

        /// <summary>
        /// Bit length codes must not exceed MaxBitLengthBits bits.
        /// </summary>
        public const int MaxBitLengthBits = 7;

        /// <summary>
        /// Repeat previous bit length 3-6 times (2 bits of repeat count).
        /// </summary>
        public const int Repeat3To6 = 16;

        /// <summary>
        /// Repeat a zero length 3-10 times (3 bits of repeat count).
        /// </summary>
        public const int RepeatZero3To10 = 17;

        /// <summary>
        /// Repeat a zero length 11-138 times (7 bits of repeat count).
        /// </summary>
        public const int RepeatZero11To138 = 18;
    }
}
