﻿using System;
using System.Collections.ObjectModel;
using System.IO;

#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Represents base class for Deflate compression and decompression functionality.
    /// </summary>
    internal abstract class DeflateTransformBase : CompressionTransformBase
    {
        /// <summary>
        /// Initializes a new instance of the DeflateTransformBase class.
        /// </summary>
        /// <param name="settings">Deflate settings.</param>
        public DeflateTransformBase(DeflateSettings settings)
        {
            this.Settings = settings;
        }

        protected DeflateSettings Settings
        {
            get;
            private set;
        }
    }
}
