﻿#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    internal class LzmaLengthTableEncoder : LzmaLengthEncoder
    {
        private uint[] prices = new uint[LzmaTransformBase.LengthSymbolsNumber << LzmaTransformBase.PosStatesBitsEncodingMax];
        private uint tableSize;
        private uint[] counters = new uint[LzmaTransformBase.PosStatesEncodingMax];

        public void SetTableSize(uint size)
        {
            this.tableSize = size;
        }

        public uint GetPrice(uint symbol, uint posState)
        {
            return this.prices[(posState * LzmaTransformBase.LengthSymbolsNumber) + symbol];
        }

        public void UpdateTable(uint posState)
        {
            this.SetPrices(posState, tableSize, this.prices, posState * LzmaTransformBase.LengthSymbolsNumber);
            this.counters[posState] = tableSize;
        }

        public void UpdateTables(uint posStates)
        {
            for (uint posState = 0; posState < posStates; posState++)
            {
                this.UpdateTable(posState);
            }
        }

        public new void Encode(LzmaRangeEncoder rangeEncoder, uint symbol, uint posState)
        {
            base.Encode(rangeEncoder, symbol, posState);

            if (--counters[posState] == 0)
            {
                this.UpdateTable(posState);
            }
        }
    }
}
