﻿#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Represents LZMA state for compressing and for decompressing.
    /// </summary>
    internal struct LzmaState
    {
        public uint Index
        {
            get;
            private set;
        }

        public static uint GetLenToPosState(uint length)
        {
            length -= LzmaTransformBase.MatchMinLength;
            if (length < LzmaTransformBase.LengthToPosStates)
            {
                return length;
            }

            return (uint)(LzmaTransformBase.LengthToPosStates - 1);
        }

        public void UpdateChar()
        {
            if (this.Index < 4)
            {
                this.Index = 0;
            }
            else if (this.Index < 10)
            {
                this.Index -= 3;
            }
            else
            {
                this.Index -= 6;
            }
        }

        public void UpdateMatch()
        {
            this.Index = (uint)(this.Index < 7 ? 7 : 10);
        }

        public void UpdateRep()
        {
            this.Index = (uint)(this.Index < 7 ? 8 : 11);
        }

        public void UpdateShortRep()
        {
            this.Index = (uint)(this.Index < 7 ? 9 : 11);
        }

        public bool IsCharState()
        {
            return this.Index < 7;
        }
    }
}
