﻿using System;

#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Class which implements Store (no compression) algorithm.
    /// </summary>
    internal class StoreAlgorithm : ICompressionAlgorithm
    {
        /// <summary>
        /// Creates a compressor object. 
        /// </summary>
        /// <returns>A compressor object.</returns>
        public IBlockTransform CreateCompressor()
        {
            return new StoreCompressor();
        }

        /// <summary>
        /// Creates a decompressor object.
        /// </summary>
        /// <returns>A decompressor object.</returns>
        public IBlockTransform CreateDecompressor()
        {
            return new StoreDecompressor();
        }

        /// <summary>
        /// Initialize compression algorithm using given compression settings.
        /// </summary>
        /// <param name="settings">Compression settings.</param>
        public void Initialize(CompressionSettings settings)
        {
        }
    }
}
