﻿using System;

#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Specifies values that indicate compression method.
    /// </summary>
    [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1027:MarkEnumsWithFlags")]
    public enum CompressionMethod
    {
        /// <summary>
        /// The file is stored (no compression).
        /// </summary>
        Stored = 0,

        /// <summary>
        /// The file is Deflated.
        /// </summary>
        Deflate = 8,

        /// <summary>
        /// The file is compressed using LZMA algorithm.
        /// </summary>
        Lzma = 14
    }
}
