﻿using System;

#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Encryption settings for the default cryptographic provider (traditional PKWARE encryption.
    /// </summary>
    public class DefaultEncryptionSettings : EncryptionSettings
    {
        private string password = null;

        /// <summary>
        /// Initializes a new instance of the DefaultEncryptionSettings class.
        /// </summary>
        public DefaultEncryptionSettings()
        {
            this.Algorithm = "DEFAULT";
        }

        /// <summary>
        /// Gets or sets password will be used for encryption/decryption.
        /// </summary>
        public string Password
        {
            get
            {
                return this.password;
            }

            set
            {
                this.password = value;
                this.OnPropertyChanged("Password");
            }
        }

        /// <summary>
        /// Gets or sets last modification file date and time.
        /// </summary>
        internal uint FileTime
        {
            get;
            set;
        }
    }
}
