﻿using System;
using System.ComponentModel;

#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Base class for the encryption settings.
    /// </summary>
    public class EncryptionSettings : INotifyPropertyChanged 
    {
        private string algorithm = null;

        /// <summary>
        /// Occurs when a property value changes.
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;

        /// <summary>
        /// Gets name of the algorithm will be used for encryption/decryption.
        /// </summary>
        public string Algorithm
        {
            get
            {
                return this.algorithm;
            }

            protected set
            {
                this.algorithm = value;
                this.OnPropertyChanged("Algorithm");
            }
        }

        /// <summary>
        /// Called when property value is changed.
        /// </summary>
        /// <param name="propertyName">Property name.</param>
        protected void OnPropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
