﻿using System;
using System.IO;

#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Common interface for the data structures defined in the ZIP File Format Specification.
    /// </summary>
    internal interface ISpecData
    {
        /// <summary>
        /// Read data from the binary reader.
        /// </summary>
        /// <param name="reader">Binary reader to read data from.</param>
        /// <returns>true if success, otherwise false.</returns>
        bool TryReadBlock(BinaryReader reader);

        /// <summary>
        /// Write data to the binary writer.
        /// </summary>
        /// <param name="writer">Binary writer to write data to.</param>
        void WriteBlock(BinaryWriter writer);
    }
}
