﻿using System;
using System.ComponentModel;
using System.IO;

namespace Telerik.Windows.Zip
{
    /// <summary>
    /// Represents a stream that can read from a compressed stream.
    /// </summary>
    [Obsolete("This class has been deprecated. Use CompressedStream instead of ZipInputStream.")]
    [EditorBrowsable(EditorBrowsableState.Never)]
    public class ZipInputStream : CompressedStream
    {
        private byte[] rb = new byte[1];

        /// <summary>
        /// Initializes a new instance of the ZipInputStream class.
        /// </summary>
        /// <param name="baseStream">
        /// The stream that will be decompressed.
        /// </param>
        public ZipInputStream(Stream baseStream)
            : base(baseStream, StreamOperationMode.Read, new DeflateSettings(), false, null)
        {
        }

        /// <summary>
        /// The stream that is decompressed.
        /// </summary>
        public new Stream BaseStream
        {
            get
            {
                return base.BaseStream;
            }
        }

        /// <summary>
        /// Gets the uncompressed size of the stream.
        /// </summary>
        public int UncompressedSize
        {
            get
            {
                return (int)this.TotalPlainCount;
            }
        }

        /// <summary>
        /// Reads a byte from the stream and advances the position within the stream
        /// by one byte, or returns -1 if at the end of the stream.</summary>
        /// <returns>The unsigned byte cast to an 32-bit integer, or -1 if at the end of the stream.
        /// </returns>
        public override int ReadByte()
        {
            if (this.Read(this.rb, 0, 1) != 0)
            {
                return this.rb[0];
            }

            return -1;
        }
    }
}
