﻿using System;
using System.ComponentModel;
using System.IO;

namespace Telerik.Windows.Zip
{
    /// <summary>
    /// Represents the ZipPackageEntry class.
    /// </summary>
    [Obsolete("This class has been deprecated. Use ZipArchiveEntry instead.")]
    [EditorBrowsable(EditorBrowsableState.Never)]
    public class ZipPackageEntry
    {
        private ZipArchiveEntry entry;

        /// <summary>
        /// Initializes a new instance of the ZipPackageEntry class.
        /// </summary>
        /// <param name="entry">ZipArchiveEntry.</param>
        internal ZipPackageEntry(ZipArchiveEntry entry)
        {
            this.entry = entry;
        }

        /// <summary>
        /// Gets the file attributes for the entry.
        /// </summary>
        public FileAttributes Attributes
        {
            get
            {
                return (FileAttributes)this.entry.ExternalAttributes;
            }
        }

        /// <summary>
        /// Gets the compressed size for the entry.
        /// </summary>
        public int CompressedSize
        {
            get
            {
                return (int)this.entry.CompressedLength;
            }
        }

        /// <summary>
        /// Gets the file name in the ZipPackage for the entry.
        /// </summary>
        public string FileNameInZip
        {
            get
            {
                return this.entry.FullName;
            }
        }

        /// <summary>
        /// Gets the uncompressed size for the entry.
        /// </summary>
        public int UncompressedSize
        {
            get
            {
                return (int)this.entry.Length;
            }
        }

        /// <summary>
        /// Opens the entry from the zip archive.
        /// </summary>
        /// <returns>The stream that represents the contents of the entry.</returns>
        public Stream OpenInputStream()
        {
            Stream stream = this.entry.Open();
            return stream;
        }

        /// <summary>
        /// Deletes the entry.
        /// </summary>
        internal void Delete()
        {
            this.entry.Delete();
        }
    }
}
