﻿using System;

#if PORTABLE
namespace Telerik.Zip.Tests
#else
namespace Telerik.Windows.Zip.Tests
#endif
{
	/// <summary>
	/// A work item for tests to use which will call the delegate when the work 
	/// item is executed.
	/// </summary>
	public class AsyncCallbackWorkItem : AsyncWorkItem
	{
		/// <summary>
		/// Stored void delegate.
		/// </summary>
		private Action action;

		/// <summary>
		/// Create a new Callback work item.
		/// </summary>
		/// <param name="callback">Action to execute on Invoke.</param>
		public AsyncCallbackWorkItem(Action callback)
			: base()
		{
			this.action = callback;
		}

		/// <summary>
		/// Execute the callback.
		/// </summary>
		public override void Invoke()
		{
			this.action();

			this.IsComplete = true;
		}
	}
}