﻿using System;

#if PORTABLE
namespace Telerik.Zip.Tests
#else
namespace Telerik.Windows.Zip.Tests
#endif
{
	/// <summary>
	/// A test work item that is complete once the condition is asserted.
	/// </summary>
	public class AsyncConditionalWorkItem : AsyncWorkItem
	{
		/// <summary>
		/// The conditional delegate.
		/// </summary>
		private Func<bool> conditionDelegate;

		/// <summary>
		/// Construct a new conditional work item.
		/// </summary>
		/// <param name="conditionalDelegate">Conditional delegate.</param>
		public AsyncConditionalWorkItem(Func<bool> conditionalDelegate)
			: base()
		{
			this.conditionDelegate = conditionalDelegate;
		}

		/// <summary>
		/// Invoke the condition, will continue invoking until 
		/// the condition is false.
		/// </summary>
		public override void Invoke()
		{
			if (this.conditionDelegate() == true)
			{
				this.IsComplete = true;
			}
		}
	}
}
