﻿using System.Diagnostics;
using System.Threading;
using System.Windows;
using System.Windows.Threading;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Telerik.Windows.Zip.Tests
{
	public class WindowTest
	{
		public Window Window
		{
			[DebuggerStepThrough]
			get;
			private set;
		}

		public void Pause()
		{
			this.Window.Activate();
			Dispatcher.Run();
		}

		public static void DoEvents()
		{
			DispatcherFrame f = new DispatcherFrame();
			Dispatcher.CurrentDispatcher.BeginInvoke(DispatcherPriority.Background,
			(SendOrPostCallback)delegate(object arg)
			{
				DispatcherFrame fr = (DispatcherFrame)arg;
				fr.Continue = false;
			}, f);
			Dispatcher.PushFrame(f);
		}

		[TestInitialize]
		public void InitializeWindow()
		{
			this.Window = new Window();
			this.Window.Closed += ((sender, e) => Dispatcher.CurrentDispatcher.InvokeShutdown());
		}

		[TestCleanup]
		public void CleanupWindow()
		{
			this.Window.Close();
		}
	}
}
