﻿using System.Diagnostics;
using System.Windows;
using Microsoft.VisualStudio.TestTools.UnitTesting;
#if SILVERLIGHT
using Microsoft.Silverlight.Testing;
#endif

namespace Telerik.Windows.Zip.Tests
{
	public class WindowedTest<T> :
#if WPF
 WindowTest
#elif SILVERLIGHT
		SilverlightTest
#endif
 where T : FrameworkElement, new()
	{
		public T TestElement
		{
			[DebuggerStepThrough]
			get;
			protected set;
		}

		public void ForceApplyTemplates(UIElement target)
		{
			target.Measure(new Size(double.PositiveInfinity, double.PositiveInfinity));
		}

		[TestInitialize]
		public void LocalInitialize()
		{
			this.TestInitialize();
		}

		[TestCleanup]
		public void LocalCleanup()
		{
			this.TestCleanup();
		}

		public virtual void TestInitialize()
		{
			this.TestElement = new T();

#if WPF
			this.Window.Content = this.TestElement;
#endif

#if SILVERLIGHT
			this.TestPanel.Width = 800;
			this.TestPanel.Height = 600;
			this.TestPanel.HorizontalAlignment = HorizontalAlignment.Left;
			this.TestPanel.VerticalAlignment = VerticalAlignment.Top;
#endif
		}

		public virtual void TestCleanup()
		{
			this.TestElement = null;
		}

		public virtual void Show()
		{
#if WPF
			this.Window.Show();
#endif
		}
	}
}
