﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

#if NETCORE
namespace Telerik.Zip.Tests
#else
namespace Telerik.Windows.Zip.Tests
#endif
{
    public class EntryData
    {
        public FileAttributes Attributes
        {
            get;
            set;
        }

        public int CompressedLength
        {
            get;
            set;
        }

        public string FullName
        {
            get;
            set;
        }

        public int Length
        {
            get;
            set;
        }

        public void CompareToZipArchiveEntry(ZipArchiveEntry entry)
        {
            Assert.AreEqual<int>((int)this.Attributes,
                entry.ExternalAttributes,
                "File attributes of entry are incorrect.");

            Assert.AreEqual<long>(this.CompressedLength,
                entry.CompressedLength,
                "Compressed size of entry is incorrect.");

            Assert.AreEqual<string>(this.FullName,
                entry.FullName,
                "File name of entry is incorrect.");

            Assert.AreEqual<long>(this.Length,
                entry.Length,
                "Uncompressed size of entry is incorrect.");
        }

#if !NETCORE
#pragma warning disable 618
        public void CompareToZipPackageEntry(ZipPackageEntry entry)
        {
            Assert.AreEqual<FileAttributes>(this.Attributes,
                entry.Attributes,
                "File attributes of entry are incorrect.");

            Assert.AreEqual<int>(this.CompressedLength,
                entry.CompressedSize,
                "Compressed size of entry is incorrect.");

            Assert.AreEqual<string>(this.FullName,
                entry.FileNameInZip,
                "File name of entry is incorrect.");

            Assert.AreEqual<int>(this.Length,
                entry.UncompressedSize,
                "Uncompressed size of entry is incorrect.");
        }
#pragma warning restore 618
#endif
    }
}
