﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Telerik.Windows.Zip.Extensions
{
    /// <summary>
    /// Type of the temporary stream.
    /// </summary>
    public enum TemporaryStreamType
    {
        /// <summary>
        /// The temporary stream represents temporary file in the file system.
        /// </summary>
        /// <remarks>It allows manipulations with large archives and minimize memory consumption.</remarks>
        File,

        /// <summary>
        /// The temporary stream represents data in the memory.
        /// </summary>
        /// <remarks>It is the fastest way of the data manipulation.</remarks>
        Memory
    }
}
