﻿using System;

#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Represents general purpose bit flag for Methods 8 and 9 - Deflating 
    /// ZIP File Format Specification v6.3.3, #4.4.4.
    /// </summary>
    [Flags]
    internal enum DeflatingFlags : ushort
    {
        /// <summary>
        /// Bit 2  Bit 1
        ///     0      0    Normal (-en) compression option was used.
        /// </summary>
        Normal = 0x0000,

        /// <summary>
        /// Bit 2  Bit 1
        ///     0      1    Maximum (-exx/-ex) compression option was used.
        /// </summary>
        Maximum = 0x0002,

        /// <summary>
        /// Bit 2  Bit 1
        ///     1      0    Fast (-ef) compression option was used.
        /// </summary>
        Fast = 0x0004,

        /// <summary>
        /// Bit 2  Bit 1
        ///     1      1    Super Fast (-es) compression option was used.
        /// </summary>
        SuperFast = 0x0006
    }
}
