﻿using System;
using System.Collections.Generic;
using System.Text;

#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Represents extra field type (Header ID) described in the
    /// ZIP File Format Specification v6.3.3, #4.5.2.
    /// </summary>
    internal enum ExtraFieldType
    {
        /// <summary>
        /// Unknown extra field type.
        /// </summary>
        Unknown = -1,

        /// <summary>
        /// Zip64 extra field type.
        /// </summary>
        Zip64 = 0x01,

        /// <summary>
        /// Ntfs extra field type.
        /// </summary>
        Ntfs = 0x0A,

        /// <summary>
        /// StrongEncryption extra field type.
        /// </summary>
        StrongEncryption = 0x17,

        /// <summary>
        /// UnixTime extra field type.
        /// </summary>
        UnixTime = 0x5455,

        /// <summary>
        /// AesEncryption extra field type.
        /// </summary>
        AesEncryption = 0x9901
    }
}
