﻿using System;
using System.Linq;

#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    internal abstract class FileHeaderInfoBase
    {
        public FileHeaderInfoBase(FileHeaderBase localFileHeader)
        {
            this.ExtraFieldsData = localFileHeader.ExtraFieldsData;
            this.UncompressedSizeOverflow = localFileHeader.UncompressedSize == uint.MaxValue;
            this.CompressedSizeOverflow = localFileHeader.CompressedSize == uint.MaxValue;
        }

        public byte[] ExtraFieldsData { get; private set; }

        public bool UncompressedSizeOverflow { get; private set; }

        public bool CompressedSizeOverflow { get; private set; }
    }
}