﻿using System;

#if NETSTANDARD
namespace Telerik.Zip
#else
namespace Telerik.Windows.Zip
#endif
{
    /// <summary>
    /// Represents general purpose bit flag for the Method 14 - LZMA 
    /// ZIP File Format Specification v6.3.3, #4.4.4.
    /// </summary>
    internal enum LZMAFlags : ushort
    {
        /// <summary>
        /// Bit 1: If the compression method used was type 14,
        /// LZMA, then this bit, if set, indicates
        /// an end-of-stream (EOS) marker is used to
        /// mark the end of the compressed data stream.
        /// If clear, then an EOS marker is not present
        /// and the compressed data size must be known
        /// to extract.
        /// </summary>
        UseEndOfStreamMarker = 0x0002
    }
}
