﻿using Telerik.Windows.Documents.Core.Data;
using Telerik.Windows.Documents.Core.PostScript.Data;

namespace Telerik.Windows.Documents.Fixed.Model.Fonts.Encoding
{
    internal static class AdobeGlyphList
    {
        private static readonly ValueMapper<string, char> mapper;

        static AdobeGlyphList()
        {
            mapper = new ValueMapper<string, char>();

            Initialize();
        }

        private static void Initialize()
        {
            RegisterPair("A", '\u0041');
            RegisterPair("AE", '\u00C6');
            RegisterPair("AEacute", '\u01FC');
            RegisterPair("AEmacron", '\u01E2');
            RegisterPair("AEsmall", '\uF7E6');
            RegisterPair("Aacute", '\u00C1');
            RegisterPair("Aacutesmall", '\uF7E1');
            RegisterPair("Abreve", '\u0102');
            RegisterPair("Abreveacute", '\u1EAE');
            RegisterPair("Abrevecyrillic", '\u04D0');
            RegisterPair("Abrevedotbelow", '\u1EB6');
            RegisterPair("Abrevegrave", '\u1EB0');
            RegisterPair("Abrevehookabove", '\u1EB2');
            RegisterPair("Abrevetilde", '\u1EB4');
            RegisterPair("Acaron", '\u01CD');
            RegisterPair("Acircle", '\u24B6');
            RegisterPair("Acircumflex", '\u00C2');
            RegisterPair("Acircumflexacute", '\u1EA4');
            RegisterPair("Acircumflexdotbelow", '\u1EAC');
            RegisterPair("Acircumflexgrave", '\u1EA6');
            RegisterPair("Acircumflexhookabove", '\u1EA8');
            RegisterPair("Acircumflexsmall", '\uF7E2');
            RegisterPair("Acircumflextilde", '\u1EAA');
            RegisterPair("Acute", '\uF6C9');
            RegisterPair("Acutesmall", '\uF7B4');
            RegisterPair("Acyrillic", '\u0410');
            RegisterPair("Adblgrave", '\u0200');
            RegisterPair("Adieresis", '\u00C4');
            RegisterPair("Adieresiscyrillic", '\u04D2');
            RegisterPair("Adieresismacron", '\u01DE');
            RegisterPair("Adieresissmall", '\uF7E4');
            RegisterPair("Adotbelow", '\u1EA0');
            RegisterPair("Adotmacron", '\u01E0');
            RegisterPair("Agrave", '\u00C0');
            RegisterPair("Agravesmall", '\uF7E0');
            RegisterPair("Ahookabove", '\u1EA2');
            RegisterPair("Aiecyrillic", '\u04D4');
            RegisterPair("Ainvertedbreve", '\u0202');
            RegisterPair("Alpha", '\u0391');
            RegisterPair("Alphatonos", '\u0386');
            RegisterPair("Amacron", '\u0100');
            RegisterPair("Amonospace", '\uFF21');
            RegisterPair("Aogonek", '\u0104');
            RegisterPair("Aring", '\u00C5');
            RegisterPair("Aringacute", '\u01FA');
            RegisterPair("Aringbelow", '\u1E00');
            RegisterPair("Aringsmall", '\uF7E5');
            RegisterPair("Asmall", '\uF761');
            RegisterPair("Atilde", '\u00C3');
            RegisterPair("Atildesmall", '\uF7E3');
            RegisterPair("Aybarmenian", '\u0531');
            RegisterPair("B", '\u0042');
            RegisterPair("Bcircle", '\u24B7');
            RegisterPair("Bdotaccent", '\u1E02');
            RegisterPair("Bdotbelow", '\u1E04');
            RegisterPair("Becyrillic", '\u0411');
            RegisterPair("Benarmenian", '\u0532');
            RegisterPair("Beta", '\u0392');
            RegisterPair("Bhook", '\u0181');
            RegisterPair("Blinebelow", '\u1E06');
            RegisterPair("Bmonospace", '\uFF22');
            RegisterPair("Brevesmall", '\uF6F4');
            RegisterPair("Bsmall", '\uF762');
            RegisterPair("Btopbar", '\u0182');
            RegisterPair("C", '\u0043');
            RegisterPair("Caarmenian", '\u053E');
            RegisterPair("Cacute", '\u0106');
            RegisterPair("Caron", '\uF6CA');
            RegisterPair("Caronsmall", '\uF6F5');
            RegisterPair("Ccaron", '\u010C');
            RegisterPair("Ccedilla", '\u00C7');
            RegisterPair("Ccedillaacute", '\u1E08');
            RegisterPair("Ccedillasmall", '\uF7E7');
            RegisterPair("Ccircle", '\u24B8');
            RegisterPair("Ccircumflex", '\u0108');
            RegisterPair("Cdot", '\u010A');
            RegisterPair("Cdotaccent", '\u010A');
            RegisterPair("Cedillasmall", '\uF7B8');
            RegisterPair("Chaarmenian", '\u0549');
            RegisterPair("Cheabkhasiancyrillic", '\u04BC');
            RegisterPair("Checyrillic", '\u0427');
            RegisterPair("Chedescenderabkhasiancyrillic", '\u04BE');
            RegisterPair("Chedescendercyrillic", '\u04B6');
            RegisterPair("Chedieresiscyrillic", '\u04F4');
            RegisterPair("Cheharmenian", '\u0543');
            RegisterPair("Chekhakassiancyrillic", '\u04CB');
            RegisterPair("Cheverticalstrokecyrillic", '\u04B8');
            RegisterPair("Chi", '\u03A7');
            RegisterPair("Chook", '\u0187');
            RegisterPair("Circumflexsmall", '\uF6F6');
            RegisterPair("Cmonospace", '\uFF23');
            RegisterPair("Coarmenian", '\u0551');
            RegisterPair("Csmall", '\uF763');
            RegisterPair("D", '\u0044');
            RegisterPair("DZ", '\u01F1');
            RegisterPair("DZcaron", '\u01C4');
            RegisterPair("Daarmenian", '\u0534');
            RegisterPair("Dafrican", '\u0189');
            RegisterPair("Dcaron", '\u010E');
            RegisterPair("Dcedilla", '\u1E10');
            RegisterPair("Dcircle", '\u24B9');
            RegisterPair("Dcircumflexbelow", '\u1E12');
            RegisterPair("Dcroat", '\u0110');
            RegisterPair("Ddotaccent", '\u1E0A');
            RegisterPair("Ddotbelow", '\u1E0C');
            RegisterPair("Decyrillic", '\u0414');
            RegisterPair("Deicoptic", '\u03EE');
            RegisterPair("Delta", '\u2206');
            RegisterPair("Deltagreek", '\u0394');
            RegisterPair("Dhook", '\u018A');
            RegisterPair("Dieresis", '\uF6CB');
            RegisterPair("DieresisAcute", '\uF6CC');
            RegisterPair("DieresisGrave", '\uF6CD');
            RegisterPair("Dieresissmall", '\uF7A8');
            RegisterPair("Digammagreek", '\u03DC');
            RegisterPair("Djecyrillic", '\u0402');
            RegisterPair("Dlinebelow", '\u1E0E');
            RegisterPair("Dmonospace", '\uFF24');
            RegisterPair("Dotaccentsmall", '\uF6F7');
            RegisterPair("Dslash", '\u0110');
            RegisterPair("Dsmall", '\uF764');
            RegisterPair("Dtopbar", '\u018B');
            RegisterPair("Dz", '\u01F2');
            RegisterPair("Dzcaron", '\u01C5');
            RegisterPair("Dzeabkhasiancyrillic", '\u04E0');
            RegisterPair("Dzecyrillic", '\u0405');
            RegisterPair("Dzhecyrillic", '\u040F');
            RegisterPair("E", '\u0045');
            RegisterPair("Eacute", '\u00C9');
            RegisterPair("Eacutesmall", '\uF7E9');
            RegisterPair("Ebreve", '\u0114');
            RegisterPair("Ecaron", '\u011A');
            RegisterPair("Ecedillabreve", '\u1E1C');
            RegisterPair("Echarmenian", '\u0535');
            RegisterPair("Ecircle", '\u24BA');
            RegisterPair("Ecircumflex", '\u00CA');
            RegisterPair("Ecircumflexacute", '\u1EBE');
            RegisterPair("Ecircumflexbelow", '\u1E18');
            RegisterPair("Ecircumflexdotbelow", '\u1EC6');
            RegisterPair("Ecircumflexgrave", '\u1EC0');
            RegisterPair("Ecircumflexhookabove", '\u1EC2');
            RegisterPair("Ecircumflexsmall", '\uF7EA');
            RegisterPair("Ecircumflextilde", '\u1EC4');
            RegisterPair("Ecyrillic", '\u0404');
            RegisterPair("Edblgrave", '\u0204');
            RegisterPair("Edieresis", '\u00CB');
            RegisterPair("Edieresissmall", '\uF7EB');
            RegisterPair("Edot", '\u0116');
            RegisterPair("Edotaccent", '\u0116');
            RegisterPair("Edotbelow", '\u1EB8');
            RegisterPair("Efcyrillic", '\u0424');
            RegisterPair("Egrave", '\u00C8');
            RegisterPair("Egravesmall", '\uF7E8');
            RegisterPair("Eharmenian", '\u0537');
            RegisterPair("Ehookabove", '\u1EBA');
            RegisterPair("Eightroman", '\u2167');
            RegisterPair("Einvertedbreve", '\u0206');
            RegisterPair("Eiotifiedcyrillic", '\u0464');
            RegisterPair("Elcyrillic", '\u041B');
            RegisterPair("Elevenroman", '\u216A');
            RegisterPair("Emacron", '\u0112');
            RegisterPair("Emacronacute", '\u1E16');
            RegisterPair("Emacrongrave", '\u1E14');
            RegisterPair("Emcyrillic", '\u041C');
            RegisterPair("Emonospace", '\uFF25');
            RegisterPair("Encyrillic", '\u041D');
            RegisterPair("Endescendercyrillic", '\u04A2');
            RegisterPair("Eng", '\u014A');
            RegisterPair("Enghecyrillic", '\u04A4');
            RegisterPair("Enhookcyrillic", '\u04C7');
            RegisterPair("Eogonek", '\u0118');
            RegisterPair("Eopen", '\u0190');
            RegisterPair("Epsilon", '\u0395');
            RegisterPair("Epsilontonos", '\u0388');
            RegisterPair("Ercyrillic", '\u0420');
            RegisterPair("Ereversed", '\u018E');
            RegisterPair("Ereversedcyrillic", '\u042D');
            RegisterPair("Escyrillic", '\u0421');
            RegisterPair("Esdescendercyrillic", '\u04AA');
            RegisterPair("Esh", '\u01A9');
            RegisterPair("Esmall", '\uF765');
            RegisterPair("Eta", '\u0397');
            RegisterPair("Etarmenian", '\u0538');
            RegisterPair("Etatonos", '\u0389');
            RegisterPair("Eth", '\u00D0');
            RegisterPair("Ethsmall", '\uF7F0');
            RegisterPair("Etilde", '\u1EBC');
            RegisterPair("Etildebelow", '\u1E1A');
            RegisterPair("Euro", '\u20AC');
            RegisterPair("Ezh", '\u01B7');
            RegisterPair("Ezhcaron", '\u01EE');
            RegisterPair("Ezhreversed", '\u01B8');
            RegisterPair("F", '\u0046');
            RegisterPair("Fcircle", '\u24BB');
            RegisterPair("Fdotaccent", '\u1E1E');
            RegisterPair("Feharmenian", '\u0556');
            RegisterPair("Feicoptic", '\u03E4');
            RegisterPair("Fhook", '\u0191');
            RegisterPair("Fitacyrillic", '\u0472');
            RegisterPair("Fiveroman", '\u2164');
            RegisterPair("Fmonospace", '\uFF26');
            RegisterPair("Fourroman", '\u2163');
            RegisterPair("Fsmall", '\uF766');
            RegisterPair("G", '\u0047');
            RegisterPair("GBsquare", '\u3387');
            RegisterPair("Gacute", '\u01F4');
            RegisterPair("Gamma", '\u0393');
            RegisterPair("Gammaafrican", '\u0194');
            RegisterPair("Gangiacoptic", '\u03EA');
            RegisterPair("Gbreve", '\u011E');
            RegisterPair("Gcaron", '\u01E6');
            RegisterPair("Gcedilla", '\u0122');
            RegisterPair("Gcircle", '\u24BC');
            RegisterPair("Gcircumflex", '\u011C');
            RegisterPair("Gcommaaccent", '\u0122');
            RegisterPair("Gdot", '\u0120');
            RegisterPair("Gdotaccent", '\u0120');
            RegisterPair("Gecyrillic", '\u0413');
            RegisterPair("Ghadarmenian", '\u0542');
            RegisterPair("Ghemiddlehookcyrillic", '\u0494');
            RegisterPair("Ghestrokecyrillic", '\u0492');
            RegisterPair("Gheupturncyrillic", '\u0490');
            RegisterPair("Ghook", '\u0193');
            RegisterPair("Gimarmenian", '\u0533');
            RegisterPair("Gjecyrillic", '\u0403');
            RegisterPair("Gmacron", '\u1E20');
            RegisterPair("Gmonospace", '\uFF27');
            RegisterPair("Grave", '\uF6CE');
            RegisterPair("Gravesmall", '\uF760');
            RegisterPair("Gsmall", '\uF767');
            RegisterPair("Gsmallhook", '\u029B');
            RegisterPair("Gstroke", '\u01E4');
            RegisterPair("H", '\u0048');
            RegisterPair("H18533", '\u25CF');
            RegisterPair("H18543", '\u25AA');
            RegisterPair("H18551", '\u25AB');
            RegisterPair("H22073", '\u25A1');
            RegisterPair("HPsquare", '\u33CB');
            RegisterPair("Haabkhasiancyrillic", '\u04A8');
            RegisterPair("Hadescendercyrillic", '\u04B2');
            RegisterPair("Hardsigncyrillic", '\u042A');
            RegisterPair("Hbar", '\u0126');
            RegisterPair("Hbrevebelow", '\u1E2A');
            RegisterPair("Hcedilla", '\u1E28');
            RegisterPair("Hcircle", '\u24BD');
            RegisterPair("Hcircumflex", '\u0124');
            RegisterPair("Hdieresis", '\u1E26');
            RegisterPair("Hdotaccent", '\u1E22');
            RegisterPair("Hdotbelow", '\u1E24');
            RegisterPair("Hmonospace", '\uFF28');
            RegisterPair("Hoarmenian", '\u0540');
            RegisterPair("Horicoptic", '\u03E8');
            RegisterPair("Hsmall", '\uF768');
            RegisterPair("Hungarumlaut", '\uF6CF');
            RegisterPair("Hungarumlautsmall", '\uF6F8');
            RegisterPair("Hzsquare", '\u3390');
            RegisterPair("I", '\u0049');
            RegisterPair("IAcyrillic", '\u042F');
            RegisterPair("IJ", '\u0132');
            RegisterPair("IUcyrillic", '\u042E');
            RegisterPair("Iacute", '\u00CD');
            RegisterPair("Iacutesmall", '\uF7ED');
            RegisterPair("Ibreve", '\u012C');
            RegisterPair("Icaron", '\u01CF');
            RegisterPair("Icircle", '\u24BE');
            RegisterPair("Icircumflex", '\u00CE');
            RegisterPair("Icircumflexsmall", '\uF7EE');
            RegisterPair("Icyrillic", '\u0406');
            RegisterPair("Idblgrave", '\u0208');
            RegisterPair("Idieresis", '\u00CF');
            RegisterPair("Idieresisacute", '\u1E2E');
            RegisterPair("Idieresiscyrillic", '\u04E4');
            RegisterPair("Idieresissmall", '\uF7EF');
            RegisterPair("Idot", '\u0130');
            RegisterPair("Idotaccent", '\u0130');
            RegisterPair("Idotbelow", '\u1ECA');
            RegisterPair("Iebrevecyrillic", '\u04D6');
            RegisterPair("Iecyrillic", '\u0415');
            RegisterPair("Ifraktur", '\u2111');
            RegisterPair("Igrave", '\u00CC');
            RegisterPair("Igravesmall", '\uF7EC');
            RegisterPair("Ihookabove", '\u1EC8');
            RegisterPair("Iicyrillic", '\u0418');
            RegisterPair("Iinvertedbreve", '\u020A');
            RegisterPair("Iishortcyrillic", '\u0419');
            RegisterPair("Imacron", '\u012A');
            RegisterPair("Imacroncyrillic", '\u04E2');
            RegisterPair("Imonospace", '\uFF29');
            RegisterPair("Iniarmenian", '\u053B');
            RegisterPair("Iocyrillic", '\u0401');
            RegisterPair("Iogonek", '\u012E');
            RegisterPair("Iota", '\u0399');
            RegisterPair("Iotaafrican", '\u0196');
            RegisterPair("Iotadieresis", '\u03AA');
            RegisterPair("Iotatonos", '\u038A');
            RegisterPair("Ismall", '\uF769');
            RegisterPair("Istroke", '\u0197');
            RegisterPair("Itilde", '\u0128');
            RegisterPair("Itildebelow", '\u1E2C');
            RegisterPair("Izhitsacyrillic", '\u0474');
            RegisterPair("Izhitsadblgravecyrillic", '\u0476');
            RegisterPair("J", '\u004A');
            RegisterPair("Jaarmenian", '\u0541');
            RegisterPair("Jcircle", '\u24BF');
            RegisterPair("Jcircumflex", '\u0134');
            RegisterPair("Jecyrillic", '\u0408');
            RegisterPair("Jheharmenian", '\u054B');
            RegisterPair("Jmonospace", '\uFF2A');
            RegisterPair("Jsmall", '\uF76A');
            RegisterPair("K", '\u004B');
            RegisterPair("KBsquare", '\u3385');
            RegisterPair("KKsquare", '\u33CD');
            RegisterPair("Kabashkircyrillic", '\u04A0');
            RegisterPair("Kacute", '\u1E30');
            RegisterPair("Kacyrillic", '\u041A');
            RegisterPair("Kadescendercyrillic", '\u049A');
            RegisterPair("Kahookcyrillic", '\u04C3');
            RegisterPair("Kappa", '\u039A');
            RegisterPair("Kastrokecyrillic", '\u049E');
            RegisterPair("Kaverticalstrokecyrillic", '\u049C');
            RegisterPair("Kcaron", '\u01E8');
            RegisterPair("Kcedilla", '\u0136');
            RegisterPair("Kcircle", '\u24C0');
            RegisterPair("Kcommaaccent", '\u0136');
            RegisterPair("Kdotbelow", '\u1E32');
            RegisterPair("Keharmenian", '\u0554');
            RegisterPair("Kenarmenian", '\u053F');
            RegisterPair("Khacyrillic", '\u0425');
            RegisterPair("Kheicoptic", '\u03E6');
            RegisterPair("Khook", '\u0198');
            RegisterPair("Kjecyrillic", '\u040C');
            RegisterPair("Klinebelow", '\u1E34');
            RegisterPair("Kmonospace", '\uFF2B');
            RegisterPair("Koppacyrillic", '\u0480');
            RegisterPair("Koppagreek", '\u03DE');
            RegisterPair("Ksicyrillic", '\u046E');
            RegisterPair("Ksmall", '\uF76B');
            RegisterPair("L", '\u004C');
            RegisterPair("LJ", '\u01C7');
            RegisterPair("LL", '\uF6BF');
            RegisterPair("Lacute", '\u0139');
            RegisterPair("Lambda", '\u039B');
            RegisterPair("Lcaron", '\u013D');
            RegisterPair("Lcedilla", '\u013B');
            RegisterPair("Lcircle", '\u24C1');
            RegisterPair("Lcircumflexbelow", '\u1E3C');
            RegisterPair("Lcommaaccent", '\u013B');
            RegisterPair("Ldot", '\u013F');
            RegisterPair("Ldotaccent", '\u013F');
            RegisterPair("Ldotbelow", '\u1E36');
            RegisterPair("Ldotbelowmacron", '\u1E38');
            RegisterPair("Liwnarmenian", '\u053C');
            RegisterPair("Lj", '\u01C8');
            RegisterPair("Ljecyrillic", '\u0409');
            RegisterPair("Llinebelow", '\u1E3A');
            RegisterPair("Lmonospace", '\uFF2C');
            RegisterPair("Lslash", '\u0141');
            RegisterPair("Lslashsmall", '\uF6F9');
            RegisterPair("Lsmall", '\uF76C');
            RegisterPair("M", '\u004D');
            RegisterPair("MBsquare", '\u3386');
            RegisterPair("Macron", '\uF6D0');
            RegisterPair("Macronsmall", '\uF7AF');
            RegisterPair("Macute", '\u1E3E');
            RegisterPair("Mcircle", '\u24C2');
            RegisterPair("Mdotaccent", '\u1E40');
            RegisterPair("Mdotbelow", '\u1E42');
            RegisterPair("Menarmenian", '\u0544');
            RegisterPair("Mmonospace", '\uFF2D');
            RegisterPair("Msmall", '\uF76D');
            RegisterPair("Mturned", '\u019C');
            RegisterPair("Mu", '\u039C');
            RegisterPair("N", '\u004E');
            RegisterPair("NJ", '\u01CA');
            RegisterPair("Nacute", '\u0143');
            RegisterPair("Ncaron", '\u0147');
            RegisterPair("Ncedilla", '\u0145');
            RegisterPair("Ncircle", '\u24C3');
            RegisterPair("Ncircumflexbelow", '\u1E4A');
            RegisterPair("Ncommaaccent", '\u0145');
            RegisterPair("Ndotaccent", '\u1E44');
            RegisterPair("Ndotbelow", '\u1E46');
            RegisterPair("Nhookleft", '\u019D');
            RegisterPair("Nineroman", '\u2168');
            RegisterPair("Nj", '\u01CB');
            RegisterPair("Njecyrillic", '\u040A');
            RegisterPair("Nlinebelow", '\u1E48');
            RegisterPair("Nmonospace", '\uFF2E');
            RegisterPair("Nowarmenian", '\u0546');
            RegisterPair("Nsmall", '\uF76E');
            RegisterPair("Ntilde", '\u00D1');
            RegisterPair("Ntildesmall", '\uF7F1');
            RegisterPair("Nu", '\u039D');
            RegisterPair("O", '\u004F');
            RegisterPair("OE", '\u0152');
            RegisterPair("OEsmall", '\uF6FA');
            RegisterPair("Oacute", '\u00D3');
            RegisterPair("Oacutesmall", '\uF7F3');
            RegisterPair("Obarredcyrillic", '\u04E8');
            RegisterPair("Obarreddieresiscyrillic", '\u04EA');
            RegisterPair("Obreve", '\u014E');
            RegisterPair("Ocaron", '\u01D1');
            RegisterPair("Ocenteredtilde", '\u019F');
            RegisterPair("Ocircle", '\u24C4');
            RegisterPair("Ocircumflex", '\u00D4');
            RegisterPair("Ocircumflexacute", '\u1ED0');
            RegisterPair("Ocircumflexdotbelow", '\u1ED8');
            RegisterPair("Ocircumflexgrave", '\u1ED2');
            RegisterPair("Ocircumflexhookabove", '\u1ED4');
            RegisterPair("Ocircumflexsmall", '\uF7F4');
            RegisterPair("Ocircumflextilde", '\u1ED6');
            RegisterPair("Ocyrillic", '\u041E');
            RegisterPair("Odblacute", '\u0150');
            RegisterPair("Odblgrave", '\u020C');
            RegisterPair("Odieresis", '\u00D6');
            RegisterPair("Odieresiscyrillic", '\u04E6');
            RegisterPair("Odieresissmall", '\uF7F6');
            RegisterPair("Odotbelow", '\u1ECC');
            RegisterPair("Ogoneksmall", '\uF6FB');
            RegisterPair("Ograve", '\u00D2');
            RegisterPair("Ogravesmall", '\uF7F2');
            RegisterPair("Oharmenian", '\u0555');
            RegisterPair("Ohm", '\u2126');
            RegisterPair("Ohookabove", '\u1ECE');
            RegisterPair("Ohorn", '\u01A0');
            RegisterPair("Ohornacute", '\u1EDA');
            RegisterPair("Ohorndotbelow", '\u1EE2');
            RegisterPair("Ohorngrave", '\u1EDC');
            RegisterPair("Ohornhookabove", '\u1EDE');
            RegisterPair("Ohorntilde", '\u1EE0');
            RegisterPair("Ohungarumlaut", '\u0150');
            RegisterPair("Oi", '\u01A2');
            RegisterPair("Oinvertedbreve", '\u020E');
            RegisterPair("Omacron", '\u014C');
            RegisterPair("Omacronacute", '\u1E52');
            RegisterPair("Omacrongrave", '\u1E50');
            RegisterPair("Omega", '\u2126');
            RegisterPair("Omegacyrillic", '\u0460');
            RegisterPair("Omegagreek", '\u03A9');
            RegisterPair("Omegaroundcyrillic", '\u047A');
            RegisterPair("Omegatitlocyrillic", '\u047C');
            RegisterPair("Omegatonos", '\u038F');
            RegisterPair("Omicron", '\u039F');
            RegisterPair("Omicrontonos", '\u038C');
            RegisterPair("Omonospace", '\uFF2F');
            RegisterPair("Oneroman", '\u2160');
            RegisterPair("Oogonek", '\u01EA');
            RegisterPair("Oogonekmacron", '\u01EC');
            RegisterPair("Oopen", '\u0186');
            RegisterPair("Oslash", '\u00D8');
            RegisterPair("Oslashacute", '\u01FE');
            RegisterPair("Oslashsmall", '\uF7F8');
            RegisterPair("Osmall", '\uF76F');
            RegisterPair("Ostrokeacute", '\u01FE');
            RegisterPair("Otcyrillic", '\u047E');
            RegisterPair("Otilde", '\u00D5');
            RegisterPair("Otildeacute", '\u1E4C');
            RegisterPair("Otildedieresis", '\u1E4E');
            RegisterPair("Otildesmall", '\uF7F5');
            RegisterPair("P", '\u0050');
            RegisterPair("Pacute", '\u1E54');
            RegisterPair("Pcircle", '\u24C5');
            RegisterPair("Pdotaccent", '\u1E56');
            RegisterPair("Pecyrillic", '\u041F');
            RegisterPair("Peharmenian", '\u054A');
            RegisterPair("Pemiddlehookcyrillic", '\u04A6');
            RegisterPair("Phi", '\u03A6');
            RegisterPair("Phook", '\u01A4');
            RegisterPair("Pi", '\u03A0');
            RegisterPair("Piwrarmenian", '\u0553');
            RegisterPair("Pmonospace", '\uFF30');
            RegisterPair("Psi", '\u03A8');
            RegisterPair("Psicyrillic", '\u0470');
            RegisterPair("Psmall", '\uF770');
            RegisterPair("Q", '\u0051');
            RegisterPair("Qcircle", '\u24C6');
            RegisterPair("Qmonospace", '\uFF31');
            RegisterPair("Qsmall", '\uF771');
            RegisterPair("R", '\u0052');
            RegisterPair("Raarmenian", '\u054C');
            RegisterPair("Racute", '\u0154');
            RegisterPair("Rcaron", '\u0158');
            RegisterPair("Rcedilla", '\u0156');
            RegisterPair("Rcircle", '\u24C7');
            RegisterPair("Rcommaaccent", '\u0156');
            RegisterPair("Rdblgrave", '\u0210');
            RegisterPair("Rdotaccent", '\u1E58');
            RegisterPair("Rdotbelow", '\u1E5A');
            RegisterPair("Rdotbelowmacron", '\u1E5C');
            RegisterPair("Reharmenian", '\u0550');
            RegisterPair("Rfraktur", '\u211C');
            RegisterPair("Rho", '\u03A1');
            RegisterPair("Ringsmall", '\uF6FC');
            RegisterPair("Rinvertedbreve", '\u0212');
            RegisterPair("Rlinebelow", '\u1E5E');
            RegisterPair("Rmonospace", '\uFF32');
            RegisterPair("Rsmall", '\uF772');
            RegisterPair("Rsmallinverted", '\u0281');
            RegisterPair("Rsmallinvertedsuperior", '\u02B6');
            RegisterPair("S", '\u0053');
            RegisterPair("SF010000", '\u250C');
            RegisterPair("SF020000", '\u2514');
            RegisterPair("SF030000", '\u2510');
            RegisterPair("SF040000", '\u2518');
            RegisterPair("SF050000", '\u253C');
            RegisterPair("SF060000", '\u252C');
            RegisterPair("SF070000", '\u2534');
            RegisterPair("SF080000", '\u251C');
            RegisterPair("SF090000", '\u2524');
            RegisterPair("SF100000", '\u2500');
            RegisterPair("SF110000", '\u2502');
            RegisterPair("SF190000", '\u2561');
            RegisterPair("SF200000", '\u2562');
            RegisterPair("SF210000", '\u2556');
            RegisterPair("SF220000", '\u2555');
            RegisterPair("SF230000", '\u2563');
            RegisterPair("SF240000", '\u2551');
            RegisterPair("SF250000", '\u2557');
            RegisterPair("SF260000", '\u255D');
            RegisterPair("SF270000", '\u255C');
            RegisterPair("SF280000", '\u255B');
            RegisterPair("SF360000", '\u255E');
            RegisterPair("SF370000", '\u255F');
            RegisterPair("SF380000", '\u255A');
            RegisterPair("SF390000", '\u2554');
            RegisterPair("SF400000", '\u2569');
            RegisterPair("SF410000", '\u2566');
            RegisterPair("SF420000", '\u2560');
            RegisterPair("SF430000", '\u2550');
            RegisterPair("SF440000", '\u256C');
            RegisterPair("SF450000", '\u2567');
            RegisterPair("SF460000", '\u2568');
            RegisterPair("SF470000", '\u2564');
            RegisterPair("SF480000", '\u2565');
            RegisterPair("SF490000", '\u2559');
            RegisterPair("SF500000", '\u2558');
            RegisterPair("SF510000", '\u2552');
            RegisterPair("SF520000", '\u2553');
            RegisterPair("SF530000", '\u256B');
            RegisterPair("SF540000", '\u256A');
            RegisterPair("Sacute", '\u015A');
            RegisterPair("Sacutedotaccent", '\u1E64');
            RegisterPair("Sampigreek", '\u03E0');
            RegisterPair("Scaron", '\u0160');
            RegisterPair("Scarondotaccent", '\u1E66');
            RegisterPair("Scaronsmall", '\uF6FD');
            RegisterPair("Scedilla", '\u015E');
            RegisterPair("Schwa", '\u018F');
            RegisterPair("Schwacyrillic", '\u04D8');
            RegisterPair("Schwadieresiscyrillic", '\u04DA');
            RegisterPair("Scircle", '\u24C8');
            RegisterPair("Scircumflex", '\u015C');
            RegisterPair("Scommaaccent", '\u0218');
            RegisterPair("Sdotaccent", '\u1E60');
            RegisterPair("Sdotbelow", '\u1E62');
            RegisterPair("Sdotbelowdotaccent", '\u1E68');
            RegisterPair("Seharmenian", '\u054D');
            RegisterPair("Sevenroman", '\u2166');
            RegisterPair("Shaarmenian", '\u0547');
            RegisterPair("Shacyrillic", '\u0428');
            RegisterPair("Shchacyrillic", '\u0429');
            RegisterPair("Sheicoptic", '\u03E2');
            RegisterPair("Shhacyrillic", '\u04BA');
            RegisterPair("Shimacoptic", '\u03EC');
            RegisterPair("Sigma", '\u03A3');
            RegisterPair("Sixroman", '\u2165');
            RegisterPair("Smonospace", '\uFF33');
            RegisterPair("Softsigncyrillic", '\u042C');
            RegisterPair("Ssmall", '\uF773');
            RegisterPair("Stigmagreek", '\u03DA');
            RegisterPair("T", '\u0054');
            RegisterPair("Tau", '\u03A4');
            RegisterPair("Tbar", '\u0166');
            RegisterPair("Tcaron", '\u0164');
            RegisterPair("Tcedilla", '\u0162');
            RegisterPair("Tcircle", '\u24C9');
            RegisterPair("Tcircumflexbelow", '\u1E70');
            RegisterPair("Tcommaaccent", '\u0162');
            RegisterPair("Tdotaccent", '\u1E6A');
            RegisterPair("Tdotbelow", '\u1E6C');
            RegisterPair("Tecyrillic", '\u0422');
            RegisterPair("Tedescendercyrillic", '\u04AC');
            RegisterPair("Tenroman", '\u2169');
            RegisterPair("Tetsecyrillic", '\u04B4');
            RegisterPair("Theta", '\u0398');
            RegisterPair("Thook", '\u01AC');
            RegisterPair("Thorn", '\u00DE');
            RegisterPair("Thornsmall", '\uF7FE');
            RegisterPair("Threeroman", '\u2162');
            RegisterPair("Tildesmall", '\uF6FE');
            RegisterPair("Tiwnarmenian", '\u054F');
            RegisterPair("Tlinebelow", '\u1E6E');
            RegisterPair("Tmonospace", '\uFF34');
            RegisterPair("Toarmenian", '\u0539');
            RegisterPair("Tonefive", '\u01BC');
            RegisterPair("Tonesix", '\u0184');
            RegisterPair("Tonetwo", '\u01A7');
            RegisterPair("Tretroflexhook", '\u01AE');
            RegisterPair("Tsecyrillic", '\u0426');
            RegisterPair("Tshecyrillic", '\u040B');
            RegisterPair("Tsmall", '\uF774');
            RegisterPair("Twelveroman", '\u216B');
            RegisterPair("Tworoman", '\u2161');
            RegisterPair("U", '\u0055');
            RegisterPair("Uacute", '\u00DA');
            RegisterPair("Uacutesmall", '\uF7FA');
            RegisterPair("Ubreve", '\u016C');
            RegisterPair("Ucaron", '\u01D3');
            RegisterPair("Ucircle", '\u24CA');
            RegisterPair("Ucircumflex", '\u00DB');
            RegisterPair("Ucircumflexbelow", '\u1E76');
            RegisterPair("Ucircumflexsmall", '\uF7FB');
            RegisterPair("Ucyrillic", '\u0423');
            RegisterPair("Udblacute", '\u0170');
            RegisterPair("Udblgrave", '\u0214');
            RegisterPair("Udieresis", '\u00DC');
            RegisterPair("Udieresisacute", '\u01D7');
            RegisterPair("Udieresisbelow", '\u1E72');
            RegisterPair("Udieresiscaron", '\u01D9');
            RegisterPair("Udieresiscyrillic", '\u04F0');
            RegisterPair("Udieresisgrave", '\u01DB');
            RegisterPair("Udieresismacron", '\u01D5');
            RegisterPair("Udieresissmall", '\uF7FC');
            RegisterPair("Udotbelow", '\u1EE4');
            RegisterPair("Ugrave", '\u00D9');
            RegisterPair("Ugravesmall", '\uF7F9');
            RegisterPair("Uhookabove", '\u1EE6');
            RegisterPair("Uhorn", '\u01AF');
            RegisterPair("Uhornacute", '\u1EE8');
            RegisterPair("Uhorndotbelow", '\u1EF0');
            RegisterPair("Uhorngrave", '\u1EEA');
            RegisterPair("Uhornhookabove", '\u1EEC');
            RegisterPair("Uhorntilde", '\u1EEE');
            RegisterPair("Uhungarumlaut", '\u0170');
            RegisterPair("Uhungarumlautcyrillic", '\u04F2');
            RegisterPair("Uinvertedbreve", '\u0216');
            RegisterPair("Ukcyrillic", '\u0478');
            RegisterPair("Umacron", '\u016A');
            RegisterPair("Umacroncyrillic", '\u04EE');
            RegisterPair("Umacrondieresis", '\u1E7A');
            RegisterPair("Umonospace", '\uFF35');
            RegisterPair("Uogonek", '\u0172');
            RegisterPair("Upsilon", '\u03A5');
            RegisterPair("Upsilon1", '\u03D2');
            RegisterPair("Upsilonacutehooksymbolgreek", '\u03D3');
            RegisterPair("Upsilonafrican", '\u01B1');
            RegisterPair("Upsilondieresis", '\u03AB');
            RegisterPair("Upsilondieresishooksymbolgreek", '\u03D4');
            RegisterPair("Upsilonhooksymbol", '\u03D2');
            RegisterPair("Upsilontonos", '\u038E');
            RegisterPair("Uring", '\u016E');
            RegisterPair("Ushortcyrillic", '\u040E');
            RegisterPair("Usmall", '\uF775');
            RegisterPair("Ustraightcyrillic", '\u04AE');
            RegisterPair("Ustraightstrokecyrillic", '\u04B0');
            RegisterPair("Utilde", '\u0168');
            RegisterPair("Utildeacute", '\u1E78');
            RegisterPair("Utildebelow", '\u1E74');
            RegisterPair("V", '\u0056');
            RegisterPair("Vcircle", '\u24CB');
            RegisterPair("Vdotbelow", '\u1E7E');
            RegisterPair("Vecyrillic", '\u0412');
            RegisterPair("Vewarmenian", '\u054E');
            RegisterPair("Vhook", '\u01B2');
            RegisterPair("Vmonospace", '\uFF36');
            RegisterPair("Voarmenian", '\u0548');
            RegisterPair("Vsmall", '\uF776');
            RegisterPair("Vtilde", '\u1E7C');
            RegisterPair("W", '\u0057');
            RegisterPair("Wacute", '\u1E82');
            RegisterPair("Wcircle", '\u24CC');
            RegisterPair("Wcircumflex", '\u0174');
            RegisterPair("Wdieresis", '\u1E84');
            RegisterPair("Wdotaccent", '\u1E86');
            RegisterPair("Wdotbelow", '\u1E88');
            RegisterPair("Wgrave", '\u1E80');
            RegisterPair("Wmonospace", '\uFF37');
            RegisterPair("Wsmall", '\uF777');
            RegisterPair("X", '\u0058');
            RegisterPair("Xcircle", '\u24CD');
            RegisterPair("Xdieresis", '\u1E8C');
            RegisterPair("Xdotaccent", '\u1E8A');
            RegisterPair("Xeharmenian", '\u053D');
            RegisterPair("Xi", '\u039E');
            RegisterPair("Xmonospace", '\uFF38');
            RegisterPair("Xsmall", '\uF778');
            RegisterPair("Y", '\u0059');
            RegisterPair("Yacute", '\u00DD');
            RegisterPair("Yacutesmall", '\uF7FD');
            RegisterPair("Yatcyrillic", '\u0462');
            RegisterPair("Ycircle", '\u24CE');
            RegisterPair("Ycircumflex", '\u0176');
            RegisterPair("Ydieresis", '\u0178');
            RegisterPair("Ydieresissmall", '\uF7FF');
            RegisterPair("Ydotaccent", '\u1E8E');
            RegisterPair("Ydotbelow", '\u1EF4');
            RegisterPair("Yericyrillic", '\u042B');
            RegisterPair("Yerudieresiscyrillic", '\u04F8');
            RegisterPair("Ygrave", '\u1EF2');
            RegisterPair("Yhook", '\u01B3');
            RegisterPair("Yhookabove", '\u1EF6');
            RegisterPair("Yiarmenian", '\u0545');
            RegisterPair("Yicyrillic", '\u0407');
            RegisterPair("Yiwnarmenian", '\u0552');
            RegisterPair("Ymonospace", '\uFF39');
            RegisterPair("Ysmall", '\uF779');
            RegisterPair("Ytilde", '\u1EF8');
            RegisterPair("Yusbigcyrillic", '\u046A');
            RegisterPair("Yusbigiotifiedcyrillic", '\u046C');
            RegisterPair("Yuslittlecyrillic", '\u0466');
            RegisterPair("Yuslittleiotifiedcyrillic", '\u0468');
            RegisterPair("Z", '\u005A');
            RegisterPair("Zaarmenian", '\u0536');
            RegisterPair("Zacute", '\u0179');
            RegisterPair("Zcaron", '\u017D');
            RegisterPair("Zcaronsmall", '\uF6FF');
            RegisterPair("Zcircle", '\u24CF');
            RegisterPair("Zcircumflex", '\u1E90');
            RegisterPair("Zdot", '\u017B');
            RegisterPair("Zdotaccent", '\u017B');
            RegisterPair("Zdotbelow", '\u1E92');
            RegisterPair("Zecyrillic", '\u0417');
            RegisterPair("Zedescendercyrillic", '\u0498');
            RegisterPair("Zedieresiscyrillic", '\u04DE');
            RegisterPair("Zeta", '\u0396');
            RegisterPair("Zhearmenian", '\u053A');
            RegisterPair("Zhebrevecyrillic", '\u04C1');
            RegisterPair("Zhecyrillic", '\u0416');
            RegisterPair("Zhedescendercyrillic", '\u0496');
            RegisterPair("Zhedieresiscyrillic", '\u04DC');
            RegisterPair("Zlinebelow", '\u1E94');
            RegisterPair("Zmonospace", '\uFF3A');
            RegisterPair("Zsmall", '\uF77A');
            RegisterPair("Zstroke", '\u01B5');
            RegisterPair("a", '\u0061');
            RegisterPair("aabengali", '\u0986');
            RegisterPair("aacute", '\u00E1');
            RegisterPair("aadeva", '\u0906');
            RegisterPair("aagujarati", '\u0A86');
            RegisterPair("aagurmukhi", '\u0A06');
            RegisterPair("aamatragurmukhi", '\u0A3E');
            RegisterPair("aarusquare", '\u3303');
            RegisterPair("aavowelsignbengali", '\u09BE');
            RegisterPair("aavowelsigndeva", '\u093E');
            RegisterPair("aavowelsigngujarati", '\u0ABE');
            RegisterPair("abbreviationmarkarmenian", '\u055F');
            RegisterPair("abbreviationsigndeva", '\u0970');
            RegisterPair("abengali", '\u0985');
            RegisterPair("abopomofo", '\u311A');
            RegisterPair("abreve", '\u0103');
            RegisterPair("abreveacute", '\u1EAF');
            RegisterPair("abrevecyrillic", '\u04D1');
            RegisterPair("abrevedotbelow", '\u1EB7');
            RegisterPair("abrevegrave", '\u1EB1');
            RegisterPair("abrevehookabove", '\u1EB3');
            RegisterPair("abrevetilde", '\u1EB5');
            RegisterPair("acaron", '\u01CE');
            RegisterPair("acircle", '\u24D0');
            RegisterPair("acircumflex", '\u00E2');
            RegisterPair("acircumflexacute", '\u1EA5');
            RegisterPair("acircumflexdotbelow", '\u1EAD');
            RegisterPair("acircumflexgrave", '\u1EA7');
            RegisterPair("acircumflexhookabove", '\u1EA9');
            RegisterPair("acircumflextilde", '\u1EAB');
            RegisterPair("acute", '\u00B4');
            RegisterPair("acutebelowcmb", '\u0317');
            RegisterPair("acutecmb", '\u0301');
            RegisterPair("acutecomb", '\u0301');
            RegisterPair("acutedeva", '\u0954');
            RegisterPair("acutelowmod", '\u02CF');
            RegisterPair("acutetonecmb", '\u0341');
            RegisterPair("acyrillic", '\u0430');
            RegisterPair("adblgrave", '\u0201');
            RegisterPair("addakgurmukhi", '\u0A71');
            RegisterPair("adeva", '\u0905');
            RegisterPair("adieresis", '\u00E4');
            RegisterPair("adieresiscyrillic", '\u04D3');
            RegisterPair("adieresismacron", '\u01DF');
            RegisterPair("adotbelow", '\u1EA1');
            RegisterPair("adotmacron", '\u01E1');
            RegisterPair("ae", '\u00E6');
            RegisterPair("aeacute", '\u01FD');
            RegisterPair("aekorean", '\u3150');
            RegisterPair("aemacron", '\u01E3');
            RegisterPair("afii00208", '\u2015');
            RegisterPair("afii08941", '\u20A4');
            RegisterPair("afii10017", '\u0410');
            RegisterPair("afii10018", '\u0411');
            RegisterPair("afii10019", '\u0412');
            RegisterPair("afii10020", '\u0413');
            RegisterPair("afii10021", '\u0414');
            RegisterPair("afii10022", '\u0415');
            RegisterPair("afii10023", '\u0401');
            RegisterPair("afii10024", '\u0416');
            RegisterPair("afii10025", '\u0417');
            RegisterPair("afii10026", '\u0418');
            RegisterPair("afii10027", '\u0419');
            RegisterPair("afii10028", '\u041A');
            RegisterPair("afii10029", '\u041B');
            RegisterPair("afii10030", '\u041C');
            RegisterPair("afii10031", '\u041D');
            RegisterPair("afii10032", '\u041E');
            RegisterPair("afii10033", '\u041F');
            RegisterPair("afii10034", '\u0420');
            RegisterPair("afii10035", '\u0421');
            RegisterPair("afii10036", '\u0422');
            RegisterPair("afii10037", '\u0423');
            RegisterPair("afii10038", '\u0424');
            RegisterPair("afii10039", '\u0425');
            RegisterPair("afii10040", '\u0426');
            RegisterPair("afii10041", '\u0427');
            RegisterPair("afii10042", '\u0428');
            RegisterPair("afii10043", '\u0429');
            RegisterPair("afii10044", '\u042A');
            RegisterPair("afii10045", '\u042B');
            RegisterPair("afii10046", '\u042C');
            RegisterPair("afii10047", '\u042D');
            RegisterPair("afii10048", '\u042E');
            RegisterPair("afii10049", '\u042F');
            RegisterPair("afii10050", '\u0490');
            RegisterPair("afii10051", '\u0402');
            RegisterPair("afii10052", '\u0403');
            RegisterPair("afii10053", '\u0404');
            RegisterPair("afii10054", '\u0405');
            RegisterPair("afii10055", '\u0406');
            RegisterPair("afii10056", '\u0407');
            RegisterPair("afii10057", '\u0408');
            RegisterPair("afii10058", '\u0409');
            RegisterPair("afii10059", '\u040A');
            RegisterPair("afii10060", '\u040B');
            RegisterPair("afii10061", '\u040C');
            RegisterPair("afii10062", '\u040E');
            RegisterPair("afii10063", '\uF6C4');
            RegisterPair("afii10064", '\uF6C5');
            RegisterPair("afii10065", '\u0430');
            RegisterPair("afii10066", '\u0431');
            RegisterPair("afii10067", '\u0432');
            RegisterPair("afii10068", '\u0433');
            RegisterPair("afii10069", '\u0434');
            RegisterPair("afii10070", '\u0435');
            RegisterPair("afii10071", '\u0451');
            RegisterPair("afii10072", '\u0436');
            RegisterPair("afii10073", '\u0437');
            RegisterPair("afii10074", '\u0438');
            RegisterPair("afii10075", '\u0439');
            RegisterPair("afii10076", '\u043A');
            RegisterPair("afii10077", '\u043B');
            RegisterPair("afii10078", '\u043C');
            RegisterPair("afii10079", '\u043D');
            RegisterPair("afii10080", '\u043E');
            RegisterPair("afii10081", '\u043F');
            RegisterPair("afii10082", '\u0440');
            RegisterPair("afii10083", '\u0441');
            RegisterPair("afii10084", '\u0442');
            RegisterPair("afii10085", '\u0443');
            RegisterPair("afii10086", '\u0444');
            RegisterPair("afii10087", '\u0445');
            RegisterPair("afii10088", '\u0446');
            RegisterPair("afii10089", '\u0447');
            RegisterPair("afii10090", '\u0448');
            RegisterPair("afii10091", '\u0449');
            RegisterPair("afii10092", '\u044A');
            RegisterPair("afii10093", '\u044B');
            RegisterPair("afii10094", '\u044C');
            RegisterPair("afii10095", '\u044D');
            RegisterPair("afii10096", '\u044E');
            RegisterPair("afii10097", '\u044F');
            RegisterPair("afii10098", '\u0491');
            RegisterPair("afii10099", '\u0452');
            RegisterPair("afii10100", '\u0453');
            RegisterPair("afii10101", '\u0454');
            RegisterPair("afii10102", '\u0455');
            RegisterPair("afii10103", '\u0456');
            RegisterPair("afii10104", '\u0457');
            RegisterPair("afii10105", '\u0458');
            RegisterPair("afii10106", '\u0459');
            RegisterPair("afii10107", '\u045A');
            RegisterPair("afii10108", '\u045B');
            RegisterPair("afii10109", '\u045C');
            RegisterPair("afii10110", '\u045E');
            RegisterPair("afii10145", '\u040F');
            RegisterPair("afii10146", '\u0462');
            RegisterPair("afii10147", '\u0472');
            RegisterPair("afii10148", '\u0474');
            RegisterPair("afii10192", '\uF6C6');
            RegisterPair("afii10193", '\u045F');
            RegisterPair("afii10194", '\u0463');
            RegisterPair("afii10195", '\u0473');
            RegisterPair("afii10196", '\u0475');
            RegisterPair("afii10831", '\uF6C7');
            RegisterPair("afii10832", '\uF6C8');
            RegisterPair("afii10846", '\u04D9');
            RegisterPair("afii299", '\u200E');
            RegisterPair("afii300", '\u200F');
            RegisterPair("afii301", '\u200D');
            RegisterPair("afii57381", '\u066A');
            RegisterPair("afii57388", '\u060C');
            RegisterPair("afii57392", '\u0660');
            RegisterPair("afii57393", '\u0661');
            RegisterPair("afii57394", '\u0662');
            RegisterPair("afii57395", '\u0663');
            RegisterPair("afii57396", '\u0664');
            RegisterPair("afii57397", '\u0665');
            RegisterPair("afii57398", '\u0666');
            RegisterPair("afii57399", '\u0667');
            RegisterPair("afii57400", '\u0668');
            RegisterPair("afii57401", '\u0669');
            RegisterPair("afii57403", '\u061B');
            RegisterPair("afii57407", '\u061F');
            RegisterPair("afii57409", '\u0621');
            RegisterPair("afii57410", '\u0622');
            RegisterPair("afii57411", '\u0623');
            RegisterPair("afii57412", '\u0624');
            RegisterPair("afii57413", '\u0625');
            RegisterPair("afii57414", '\u0626');
            RegisterPair("afii57415", '\u0627');
            RegisterPair("afii57416", '\u0628');
            RegisterPair("afii57417", '\u0629');
            RegisterPair("afii57418", '\u062A');
            RegisterPair("afii57419", '\u062B');
            RegisterPair("afii57420", '\u062C');
            RegisterPair("afii57421", '\u062D');
            RegisterPair("afii57422", '\u062E');
            RegisterPair("afii57423", '\u062F');
            RegisterPair("afii57424", '\u0630');
            RegisterPair("afii57425", '\u0631');
            RegisterPair("afii57426", '\u0632');
            RegisterPair("afii57427", '\u0633');
            RegisterPair("afii57428", '\u0634');
            RegisterPair("afii57429", '\u0635');
            RegisterPair("afii57430", '\u0636');
            RegisterPair("afii57431", '\u0637');
            RegisterPair("afii57432", '\u0638');
            RegisterPair("afii57433", '\u0639');
            RegisterPair("afii57434", '\u063A');
            RegisterPair("afii57440", '\u0640');
            RegisterPair("afii57441", '\u0641');
            RegisterPair("afii57442", '\u0642');
            RegisterPair("afii57443", '\u0643');
            RegisterPair("afii57444", '\u0644');
            RegisterPair("afii57445", '\u0645');
            RegisterPair("afii57446", '\u0646');
            RegisterPair("afii57448", '\u0648');
            RegisterPair("afii57449", '\u0649');
            RegisterPair("afii57450", '\u064A');
            RegisterPair("afii57451", '\u064B');
            RegisterPair("afii57452", '\u064C');
            RegisterPair("afii57453", '\u064D');
            RegisterPair("afii57454", '\u064E');
            RegisterPair("afii57455", '\u064F');
            RegisterPair("afii57456", '\u0650');
            RegisterPair("afii57457", '\u0651');
            RegisterPair("afii57458", '\u0652');
            RegisterPair("afii57470", '\u0647');
            RegisterPair("afii57505", '\u06A4');
            RegisterPair("afii57506", '\u067E');
            RegisterPair("afii57507", '\u0686');
            RegisterPair("afii57508", '\u0698');
            RegisterPair("afii57509", '\u06AF');
            RegisterPair("afii57511", '\u0679');
            RegisterPair("afii57512", '\u0688');
            RegisterPair("afii57513", '\u0691');
            RegisterPair("afii57514", '\u06BA');
            RegisterPair("afii57519", '\u06D2');
            RegisterPair("afii57534", '\u06D5');
            RegisterPair("afii57636", '\u20AA');
            RegisterPair("afii57645", '\u05BE');
            RegisterPair("afii57658", '\u05C3');
            RegisterPair("afii57664", '\u05D0');
            RegisterPair("afii57665", '\u05D1');
            RegisterPair("afii57666", '\u05D2');
            RegisterPair("afii57667", '\u05D3');
            RegisterPair("afii57668", '\u05D4');
            RegisterPair("afii57669", '\u05D5');
            RegisterPair("afii57670", '\u05D6');
            RegisterPair("afii57671", '\u05D7');
            RegisterPair("afii57672", '\u05D8');
            RegisterPair("afii57673", '\u05D9');
            RegisterPair("afii57674", '\u05DA');
            RegisterPair("afii57675", '\u05DB');
            RegisterPair("afii57676", '\u05DC');
            RegisterPair("afii57677", '\u05DD');
            RegisterPair("afii57678", '\u05DE');
            RegisterPair("afii57679", '\u05DF');
            RegisterPair("afii57680", '\u05E0');
            RegisterPair("afii57681", '\u05E1');
            RegisterPair("afii57682", '\u05E2');
            RegisterPair("afii57683", '\u05E3');
            RegisterPair("afii57684", '\u05E4');
            RegisterPair("afii57685", '\u05E5');
            RegisterPair("afii57686", '\u05E6');
            RegisterPair("afii57687", '\u05E7');
            RegisterPair("afii57688", '\u05E8');
            RegisterPair("afii57689", '\u05E9');
            RegisterPair("afii57690", '\u05EA');
            RegisterPair("afii57694", '\uFB2A');
            RegisterPair("afii57695", '\uFB2B');
            RegisterPair("afii57700", '\uFB4B');
            RegisterPair("afii57705", '\uFB1F');
            RegisterPair("afii57716", '\u05F0');
            RegisterPair("afii57717", '\u05F1');
            RegisterPair("afii57718", '\u05F2');
            RegisterPair("afii57723", '\uFB35');
            RegisterPair("afii57793", '\u05B4');
            RegisterPair("afii57794", '\u05B5');
            RegisterPair("afii57795", '\u05B6');
            RegisterPair("afii57796", '\u05BB');
            RegisterPair("afii57797", '\u05B8');
            RegisterPair("afii57798", '\u05B7');
            RegisterPair("afii57799", '\u05B0');
            RegisterPair("afii57800", '\u05B2');
            RegisterPair("afii57801", '\u05B1');
            RegisterPair("afii57802", '\u05B3');
            RegisterPair("afii57803", '\u05C2');
            RegisterPair("afii57804", '\u05C1');
            RegisterPair("afii57806", '\u05B9');
            RegisterPair("afii57807", '\u05BC');
            RegisterPair("afii57839", '\u05BD');
            RegisterPair("afii57841", '\u05BF');
            RegisterPair("afii57842", '\u05C0');
            RegisterPair("afii57929", '\u02BC');
            RegisterPair("afii61248", '\u2105');
            RegisterPair("afii61289", '\u2113');
            RegisterPair("afii61352", '\u2116');
            RegisterPair("afii61573", '\u202C');
            RegisterPair("afii61574", '\u202D');
            RegisterPair("afii61575", '\u202E');
            RegisterPair("afii61664", '\u200C');
            RegisterPair("afii63167", '\u066D');
            RegisterPair("afii64937", '\u02BD');
            RegisterPair("agrave", '\u00E0');
            RegisterPair("agujarati", '\u0A85');
            RegisterPair("agurmukhi", '\u0A05');
            RegisterPair("ahiragana", '\u3042');
            RegisterPair("ahookabove", '\u1EA3');
            RegisterPair("aibengali", '\u0990');
            RegisterPair("aibopomofo", '\u311E');
            RegisterPair("aideva", '\u0910');
            RegisterPair("aiecyrillic", '\u04D5');
            RegisterPair("aigujarati", '\u0A90');
            RegisterPair("aigurmukhi", '\u0A10');
            RegisterPair("aimatragurmukhi", '\u0A48');
            RegisterPair("ainarabic", '\u0639');
            RegisterPair("ainfinalarabic", '\uFECA');
            RegisterPair("aininitialarabic", '\uFECB');
            RegisterPair("ainmedialarabic", '\uFECC');
            RegisterPair("ainvertedbreve", '\u0203');
            RegisterPair("aivowelsignbengali", '\u09C8');
            RegisterPair("aivowelsigndeva", '\u0948');
            RegisterPair("aivowelsigngujarati", '\u0AC8');
            RegisterPair("akatakana", '\u30A2');
            RegisterPair("akatakanahalfwidth", '\uFF71');
            RegisterPair("akorean", '\u314F');
            RegisterPair("alef", '\u05D0');
            RegisterPair("alefarabic", '\u0627');
            RegisterPair("alefdageshhebrew", '\uFB30');
            RegisterPair("aleffinalarabic", '\uFE8E');
            RegisterPair("alefhamzaabovearabic", '\u0623');
            RegisterPair("alefhamzaabovefinalarabic", '\uFE84');
            RegisterPair("alefhamzabelowarabic", '\u0625');
            RegisterPair("alefhamzabelowfinalarabic", '\uFE88');
            RegisterPair("alefhebrew", '\u05D0');
            RegisterPair("aleflamedhebrew", '\uFB4F');
            RegisterPair("alefmaddaabovearabic", '\u0622');
            RegisterPair("alefmaddaabovefinalarabic", '\uFE82');
            RegisterPair("alefmaksuraarabic", '\u0649');
            RegisterPair("alefmaksurafinalarabic", '\uFEF0');
            RegisterPair("alefmaksurainitialarabic", '\uFEF3');
            RegisterPair("alefmaksuramedialarabic", '\uFEF4');
            RegisterPair("alefpatahhebrew", '\uFB2E');
            RegisterPair("alefqamatshebrew", '\uFB2F');
            RegisterPair("aleph", '\u2135');
            RegisterPair("allequal", '\u224C');
            RegisterPair("alpha", '\u03B1');
            RegisterPair("alphatonos", '\u03AC');
            RegisterPair("amacron", '\u0101');
            RegisterPair("amonospace", '\uFF41');
            RegisterPair("ampersand", '\u0026');
            RegisterPair("ampersandmonospace", '\uFF06');
            RegisterPair("ampersandsmall", '\uF726');
            RegisterPair("amsquare", '\u33C2');
            RegisterPair("anbopomofo", '\u3122');
            RegisterPair("angbopomofo", '\u3124');
            RegisterPair("angkhankhuthai", '\u0E5A');
            RegisterPair("angle", '\u2220');
            RegisterPair("angbracketleft", '\u3008');
            RegisterPair("anglebracketleft", '\u3008');
            RegisterPair("anglebracketleftvertical", '\uFE3F');
            RegisterPair("angbracketright", '\u3009');
            RegisterPair("anglebracketright", '\u3009');
            RegisterPair("anglebracketrightvertical", '\uFE40');
            RegisterPair("angleleft", '\u2329');
            RegisterPair("angleright", '\u232A');
            RegisterPair("angstrom", '\u212B');
            RegisterPair("anoteleia", '\u0387');
            RegisterPair("anudattadeva", '\u0952');
            RegisterPair("anusvarabengali", '\u0982');
            RegisterPair("anusvaradeva", '\u0902');
            RegisterPair("anusvaragujarati", '\u0A82');
            RegisterPair("aogonek", '\u0105');
            RegisterPair("apaatosquare", '\u3300');
            RegisterPair("aparen", '\u249C');
            RegisterPair("apostrophearmenian", '\u055A');
            RegisterPair("apostrophemod", '\u02BC');
            RegisterPair("apple", '\uF8FF');
            RegisterPair("approaches", '\u2250');
            RegisterPair("approxequal", '\u2248');
            RegisterPair("approxequalorimage", '\u2252');
            RegisterPair("approximatelyequal", '\u2245');
            RegisterPair("araeaekorean", '\u318E');
            RegisterPair("araeakorean", '\u318D');
            RegisterPair("arc", '\u2312');
            RegisterPair("arighthalfring", '\u1E9A');
            RegisterPair("aring", '\u00E5');
            RegisterPair("aringacute", '\u01FB');
            RegisterPair("aringbelow", '\u1E01');
            RegisterPair("arrowboth", '\u2194');
            RegisterPair("arrowdashdown", '\u21E3');
            RegisterPair("arrowdashleft", '\u21E0');
            RegisterPair("arrowdashright", '\u21E2');
            RegisterPair("arrowdashup", '\u21E1');
            RegisterPair("arrowdblboth", '\u21D4');
            RegisterPair("arrowdbldown", '\u21D3');
            RegisterPair("arrowdblleft", '\u21D0');
            RegisterPair("arrowdblright", '\u21D2');
            RegisterPair("arrowdblup", '\u21D1');
            RegisterPair("arrowdown", '\u2193');
            RegisterPair("arrowdownleft", '\u2199');
            RegisterPair("arrowdownright", '\u2198');
            RegisterPair("arrowdownwhite", '\u21E9');
            RegisterPair("arrowheaddownmod", '\u02C5');
            RegisterPair("arrowheadleftmod", '\u02C2');
            RegisterPair("arrowheadrightmod", '\u02C3');
            RegisterPair("arrowheadupmod", '\u02C4');
            RegisterPair("arrowhorizex", '\uF8E7');
            RegisterPair("arrowleft", '\u2190');
            RegisterPair("arrowleftdbl", '\u21D0');
            RegisterPair("arrowleftdblstroke", '\u21CD');
            RegisterPair("arrowleftoverright", '\u21C6');
            RegisterPair("arrowleftwhite", '\u21E6');
            RegisterPair("arrowright", '\u2192');
            RegisterPair("arrowrightdblstroke", '\u21CF');
            RegisterPair("arrowrightheavy", '\u279E');
            RegisterPair("arrowrightoverleft", '\u21C4');
            RegisterPair("arrowrightwhite", '\u21E8');
            RegisterPair("arrowtableft", '\u21E4');
            RegisterPair("arrowtabright", '\u21E5');
            RegisterPair("arrowup", '\u2191');
            RegisterPair("arrowupdn", '\u2195');
            RegisterPair("arrowupdnbse", '\u21A8');
            RegisterPair("arrowupdownbase", '\u21A8');
            RegisterPair("arrowupleft", '\u2196');
            RegisterPair("arrowupleftofdown", '\u21C5');
            RegisterPair("arrowupright", '\u2197');
            RegisterPair("arrowupwhite", '\u21E7');
            RegisterPair("arrowvertex", '\uF8E6');
            RegisterPair("asciicircum", '\u005E');
            RegisterPair("asciicircummonospace", '\uFF3E');
            RegisterPair("asciitilde", '\u007E');
            RegisterPair("asciitildemonospace", '\uFF5E');
            RegisterPair("ascript", '\u0251');
            RegisterPair("ascriptturned", '\u0252');
            RegisterPair("asmallhiragana", '\u3041');
            RegisterPair("asmallkatakana", '\u30A1');
            RegisterPair("asmallkatakanahalfwidth", '\uFF67');
            RegisterPair("asterisk", '\u002A');
            RegisterPair("asteriskaltonearabic", '\u066D');
            RegisterPair("asteriskarabic", '\u066D');
            RegisterPair("asteriskmath", '\u2217');
            RegisterPair("asteriskmonospace", '\uFF0A');
            RegisterPair("asterisksmall", '\uFE61');
            RegisterPair("asterism", '\u2042');
            RegisterPair("asuperior", '\uF6E9');
            RegisterPair("asymptoticallyequal", '\u2243');
            RegisterPair("at", '\u0040');
            RegisterPair("atilde", '\u00E3');
            RegisterPair("atmonospace", '\uFF20');
            RegisterPair("atsmall", '\uFE6B');
            RegisterPair("aturned", '\u0250');
            RegisterPair("aubengali", '\u0994');
            RegisterPair("aubopomofo", '\u3120');
            RegisterPair("audeva", '\u0914');
            RegisterPair("augujarati", '\u0A94');
            RegisterPair("augurmukhi", '\u0A14');
            RegisterPair("aulengthmarkbengali", '\u09D7');
            RegisterPair("aumatragurmukhi", '\u0A4C');
            RegisterPair("auvowelsignbengali", '\u09CC');
            RegisterPair("auvowelsigndeva", '\u094C');
            RegisterPair("auvowelsigngujarati", '\u0ACC');
            RegisterPair("avagrahadeva", '\u093D');
            RegisterPair("aybarmenian", '\u0561');
            RegisterPair("ayin", '\u05E2');
            RegisterPair("ayinaltonehebrew", '\uFB20');
            RegisterPair("ayinhebrew", '\u05E2');
            RegisterPair("b", '\u0062');
            RegisterPair("babengali", '\u09AC');
            RegisterPair("backslash", '\u005C');
            RegisterPair("backslashmonospace", '\uFF3C');
            RegisterPair("badeva", '\u092C');
            RegisterPair("bagujarati", '\u0AAC');
            RegisterPair("bagurmukhi", '\u0A2C');
            RegisterPair("bahiragana", '\u3070');
            RegisterPair("bahtthai", '\u0E3F');
            RegisterPair("bakatakana", '\u30D0');
            RegisterPair("bar", '\u007C');
            RegisterPair("barmonospace", '\uFF5C');
            RegisterPair("bbopomofo", '\u3105');
            RegisterPair("bcircle", '\u24D1');
            RegisterPair("bdotaccent", '\u1E03');
            RegisterPair("bdotbelow", '\u1E05');
            RegisterPair("beamedsixteenthnotes", '\u266C');
            RegisterPair("because", '\u2235');
            RegisterPair("becyrillic", '\u0431');
            RegisterPair("beharabic", '\u0628');
            RegisterPair("behfinalarabic", '\uFE90');
            RegisterPair("behinitialarabic", '\uFE91');
            RegisterPair("behiragana", '\u3079');
            RegisterPair("behmedialarabic", '\uFE92');
            RegisterPair("behmeeminitialarabic", '\uFC9F');
            RegisterPair("behmeemisolatedarabic", '\uFC08');
            RegisterPair("behnoonfinalarabic", '\uFC6D');
            RegisterPair("bekatakana", '\u30D9');
            RegisterPair("benarmenian", '\u0562');
            RegisterPair("bet", '\u05D1');
            RegisterPair("beta", '\u03B2');
            RegisterPair("betasymbolgreek", '\u03D0');
            RegisterPair("betdagesh", '\uFB31');
            RegisterPair("betdageshhebrew", '\uFB31');
            RegisterPair("bethebrew", '\u05D1');
            RegisterPair("betrafehebrew", '\uFB4C');
            RegisterPair("bhabengali", '\u09AD');
            RegisterPair("bhadeva", '\u092D');
            RegisterPair("bhagujarati", '\u0AAD');
            RegisterPair("bhagurmukhi", '\u0A2D');
            RegisterPair("bhook", '\u0253');
            RegisterPair("bihiragana", '\u3073');
            RegisterPair("bikatakana", '\u30D3');
            RegisterPair("bilabialclick", '\u0298');
            RegisterPair("bindigurmukhi", '\u0A02');
            RegisterPair("birusquare", '\u3331');
            RegisterPair("blackcircle", '\u25CF');
            RegisterPair("blackdiamond", '\u25C6');
            RegisterPair("blackdownpointingtriangle", '\u25BC');
            RegisterPair("blackleftpointingpointer", '\u25C4');
            RegisterPair("blackleftpointingtriangle", '\u25C0');
            RegisterPair("blacklenticularbracketleft", '\u3010');
            RegisterPair("blacklenticularbracketleftvertical", '\uFE3B');
            RegisterPair("blacklenticularbracketright", '\u3011');
            RegisterPair("blacklenticularbracketrightvertical", '\uFE3C');
            RegisterPair("blacklowerlefttriangle", '\u25E3');
            RegisterPair("blacklowerrighttriangle", '\u25E2');
            RegisterPair("blackrectangle", '\u25AC');
            RegisterPair("blackrightpointingpointer", '\u25BA');
            RegisterPair("blackrightpointingtriangle", '\u25B6');
            RegisterPair("blacksmallsquare", '\u25AA');
            RegisterPair("blacksmilingface", '\u263B');
            RegisterPair("blacksquare", '\u25A0');
            RegisterPair("blackstar", '\u2605');
            RegisterPair("blackupperlefttriangle", '\u25E4');
            RegisterPair("blackupperrighttriangle", '\u25E5');
            RegisterPair("blackuppointingsmalltriangle", '\u25B4');
            RegisterPair("blackuppointingtriangle", '\u25B2');
            RegisterPair("blank", '\u2423');
            RegisterPair("blinebelow", '\u1E07');
            RegisterPair("block", '\u2588');
            RegisterPair("bmonospace", '\uFF42');
            RegisterPair("bobaimaithai", '\u0E1A');
            RegisterPair("bohiragana", '\u307C');
            RegisterPair("bokatakana", '\u30DC');
            RegisterPair("bparen", '\u249D');
            RegisterPair("bqsquare", '\u33C3');
            RegisterPair("braceex", '\uF8F4');
            RegisterPair("braceleft", '\u007B');
            RegisterPair("braceleftbt", '\uF8F3');
            RegisterPair("braceleftmid", '\uF8F2');
            RegisterPair("braceleftmonospace", '\uFF5B');
            RegisterPair("braceleftsmall", '\uFE5B');
            RegisterPair("bracelefttp", '\uF8F1');
            RegisterPair("braceleftvertical", '\uFE37');
            RegisterPair("braceright", '\u007D');
            RegisterPair("bracerightbt", '\uF8FE');
            RegisterPair("bracerightmid", '\uF8FD');
            RegisterPair("bracerightmonospace", '\uFF5D');
            RegisterPair("bracerightsmall", '\uFE5C');
            RegisterPair("bracerighttp", '\uF8FC');
            RegisterPair("bracerightvertical", '\uFE38');
            RegisterPair("bracketleft", '\u005B');
            RegisterPair("bracketleftbt", '\uF8F0');
            RegisterPair("bracketleftex", '\uF8EF');
            RegisterPair("bracketleftmonospace", '\uFF3B');
            RegisterPair("bracketlefttp", '\uF8EE');
            RegisterPair("bracketright", '\u005D');
            RegisterPair("bracketrightbt", '\uF8FB');
            RegisterPair("bracketrightex", '\uF8FA');
            RegisterPair("bracketrightmonospace", '\uFF3D');
            RegisterPair("bracketrighttp", '\uF8F9');
            RegisterPair("breve", '\u02D8');
            RegisterPair("brevebelowcmb", '\u032E');
            RegisterPair("brevecmb", '\u0306');
            RegisterPair("breveinvertedbelowcmb", '\u032F');
            RegisterPair("breveinvertedcmb", '\u0311');
            RegisterPair("breveinverteddoublecmb", '\u0361');
            RegisterPair("bridgebelowcmb", '\u032A');
            RegisterPair("bridgeinvertedbelowcmb", '\u033A');
            RegisterPair("brokenbar", '\u00A6');
            RegisterPair("bstroke", '\u0180');
            RegisterPair("bsuperior", '\uF6EA');
            RegisterPair("btopbar", '\u0183');
            RegisterPair("buhiragana", '\u3076');
            RegisterPair("bukatakana", '\u30D6');
            RegisterPair("bullet", '\u2022');
            RegisterPair("bulletinverse", '\u25D8');
            RegisterPair("bulletoperator", '\u2219');
            RegisterPair("bullseye", '\u25CE');
            RegisterPair("c", '\u0063');
            RegisterPair("caarmenian", '\u056E');
            RegisterPair("cabengali", '\u099A');
            RegisterPair("cacute", '\u0107');
            RegisterPair("cadeva", '\u091A');
            RegisterPair("cagujarati", '\u0A9A');
            RegisterPair("cagurmukhi", '\u0A1A');
            RegisterPair("calsquare", '\u3388');
            RegisterPair("candrabindubengali", '\u0981');
            RegisterPair("candrabinducmb", '\u0310');
            RegisterPair("candrabindudeva", '\u0901');
            RegisterPair("candrabindugujarati", '\u0A81');
            RegisterPair("capslock", '\u21EA');
            RegisterPair("careof", '\u2105');
            RegisterPair("caron", '\u02C7');
            RegisterPair("caronbelowcmb", '\u032C');
            RegisterPair("caroncmb", '\u030C');
            RegisterPair("carriagereturn", '\u21B5');
            RegisterPair("cbopomofo", '\u3118');
            RegisterPair("ccaron", '\u010D');
            RegisterPair("ccedilla", '\u00E7');
            RegisterPair("ccedillaacute", '\u1E09');
            RegisterPair("ccircle", '\u24D2');
            RegisterPair("ccircumflex", '\u0109');
            RegisterPair("ccurl", '\u0255');
            RegisterPair("cdot", '\u010B');
            RegisterPair("cdotaccent", '\u010B');
            RegisterPair("cdsquare", '\u33C5');
            RegisterPair("cedilla", '\u00B8');
            RegisterPair("cedillacmb", '\u0327');
            RegisterPair("cent", '\u00A2');
            RegisterPair("centigrade", '\u2103');
            RegisterPair("centinferior", '\uF6DF');
            RegisterPair("centmonospace", '\uFFE0');
            RegisterPair("centoldstyle", '\uF7A2');
            RegisterPair("centsuperior", '\uF6E0');
            RegisterPair("chaarmenian", '\u0579');
            RegisterPair("chabengali", '\u099B');
            RegisterPair("chadeva", '\u091B');
            RegisterPair("chagujarati", '\u0A9B');
            RegisterPair("chagurmukhi", '\u0A1B');
            RegisterPair("chbopomofo", '\u3114');
            RegisterPair("cheabkhasiancyrillic", '\u04BD');
            RegisterPair("checkmark", '\u2713');
            RegisterPair("checyrillic", '\u0447');
            RegisterPair("chedescenderabkhasiancyrillic", '\u04BF');
            RegisterPair("chedescendercyrillic", '\u04B7');
            RegisterPair("chedieresiscyrillic", '\u04F5');
            RegisterPair("cheharmenian", '\u0573');
            RegisterPair("chekhakassiancyrillic", '\u04CC');
            RegisterPair("cheverticalstrokecyrillic", '\u04B9');
            RegisterPair("chi", '\u03C7');
            RegisterPair("chieuchacirclekorean", '\u3277');
            RegisterPair("chieuchaparenkorean", '\u3217');
            RegisterPair("chieuchcirclekorean", '\u3269');
            RegisterPair("chieuchkorean", '\u314A');
            RegisterPair("chieuchparenkorean", '\u3209');
            RegisterPair("chochangthai", '\u0E0A');
            RegisterPair("chochanthai", '\u0E08');
            RegisterPair("chochingthai", '\u0E09');
            RegisterPair("chochoethai", '\u0E0C');
            RegisterPair("chook", '\u0188');
            RegisterPair("cieucacirclekorean", '\u3276');
            RegisterPair("cieucaparenkorean", '\u3216');
            RegisterPair("cieuccirclekorean", '\u3268');
            RegisterPair("cieuckorean", '\u3148');
            RegisterPair("cieucparenkorean", '\u3208');
            RegisterPair("cieucuparenkorean", '\u321C');
            RegisterPair("circle", '\u25CB');
            RegisterPair("circlemultiply", '\u2297');
            RegisterPair("circleot", '\u2299');
            RegisterPair("circleplus", '\u2295');
            RegisterPair("circlepostalmark", '\u3036');
            RegisterPair("circlewithlefthalfblack", '\u25D0');
            RegisterPair("circlewithrighthalfblack", '\u25D1');
            RegisterPair("circumflex", '\u02C6');
            RegisterPair("circumflexbelowcmb", '\u032D');
            RegisterPair("circumflexcmb", '\u0302');
            RegisterPair("clear", '\u2327');
            RegisterPair("clickalveolar", '\u01C2');
            RegisterPair("clickdental", '\u01C0');
            RegisterPair("clicklateral", '\u01C1');
            RegisterPair("clickretroflex", '\u01C3');
            RegisterPair("club", '\u2663');
            RegisterPair("clubsuitblack", '\u2663');
            RegisterPair("clubsuitwhite", '\u2667');
            RegisterPair("cmcubedsquare", '\u33A4');
            RegisterPair("cmonospace", '\uFF43');
            RegisterPair("cmsquaredsquare", '\u33A0');
            RegisterPair("coarmenian", '\u0581');
            RegisterPair("colon", '\u003A');
            RegisterPair("colonmonetary", '\u20A1');
            RegisterPair("colonmonospace", '\uFF1A');
            RegisterPair("colonsign", '\u20A1');
            RegisterPair("colonsmall", '\uFE55');
            RegisterPair("colontriangularhalfmod", '\u02D1');
            RegisterPair("colontriangularmod", '\u02D0');
            RegisterPair("comma", '\u002C');
            RegisterPair("commaabovecmb", '\u0313');
            RegisterPair("commaaboverightcmb", '\u0315');
            RegisterPair("commaaccent", '\uF6C3');
            RegisterPair("commaarabic", '\u060C');
            RegisterPair("commaarmenian", '\u055D');
            RegisterPair("commainferior", '\uF6E1');
            RegisterPair("commamonospace", '\uFF0C');
            RegisterPair("commareversedabovecmb", '\u0314');
            RegisterPair("commareversedmod", '\u02BD');
            RegisterPair("commasmall", '\uFE50');
            RegisterPair("commasuperior", '\uF6E2');
            RegisterPair("commaturnedabovecmb", '\u0312');
            RegisterPair("commaturnedmod", '\u02BB');
            RegisterPair("compass", '\u263C');
            RegisterPair("congruent", '\u2245');
            RegisterPair("contourintegral", '\u222E');
            RegisterPair("control", '\u2303');
            RegisterPair("controlACK", '\u0006');
            RegisterPair("controlBEL", '\u0007');
            RegisterPair("controlBS", '\u0008');
            RegisterPair("controlCAN", '\u0018');
            RegisterPair("controlCR", '\u000D');
            RegisterPair("controlDC1", '\u0011');
            RegisterPair("controlDC2", '\u0012');
            RegisterPair("controlDC3", '\u0013');
            RegisterPair("controlDC4", '\u0014');
            RegisterPair("controlDEL", '\u007F');
            RegisterPair("controlDLE", '\u0010');
            RegisterPair("controlEM", '\u0019');
            RegisterPair("controlENQ", '\u0005');
            RegisterPair("controlEOT", '\u0004');
            RegisterPair("controlESC", '\u001B');
            RegisterPair("controlETB", '\u0017');
            RegisterPair("controlETX", '\u0003');
            RegisterPair("controlFF", '\u000C');
            RegisterPair("controlFS", '\u001C');
            RegisterPair("controlGS", '\u001D');
            RegisterPair("controlHT", '\u0009');
            RegisterPair("controlLF", '\u000A');
            RegisterPair("controlNAK", '\u0015');
            RegisterPair("controlRS", '\u001E');
            RegisterPair("controlSI", '\u000F');
            RegisterPair("controlSO", '\u000E');
            RegisterPair("controlSOT", '\u0002');
            RegisterPair("controlSTX", '\u0001');
            RegisterPair("controlSUB", '\u001A');
            RegisterPair("controlSYN", '\u0016');
            RegisterPair("controlUS", '\u001F');
            RegisterPair("controlVT", '\u000B');
            RegisterPair("copyright", '\u00A9');
            RegisterPair("copyrightsans", '\uF8E9');
            RegisterPair("copyrightserif", '\uF6D9');
            RegisterPair("cornerbracketleft", '\u300C');
            RegisterPair("cornerbracketlefthalfwidth", '\uFF62');
            RegisterPair("cornerbracketleftvertical", '\uFE41');
            RegisterPair("cornerbracketright", '\u300D');
            RegisterPair("cornerbracketrighthalfwidth", '\uFF63');
            RegisterPair("cornerbracketrightvertical", '\uFE42');
            RegisterPair("corporationsquare", '\u337F');
            RegisterPair("cosquare", '\u33C7');
            RegisterPair("coverkgsquare", '\u33C6');
            RegisterPair("cparen", '\u249E');
            RegisterPair("cruzeiro", '\u20A2');
            RegisterPair("cstretched", '\u0297');
            RegisterPair("curlyand", '\u22CF');
            RegisterPair("curlyor", '\u22CE');
            RegisterPair("currency", '\u00A4');
            RegisterPair("cyrBreve", '\uF6D1');
            RegisterPair("cyrFlex", '\uF6D2');
            RegisterPair("cyrbreve", '\uF6D4');
            RegisterPair("cyrflex", '\uF6D5');
            RegisterPair("d", '\u0064');
            RegisterPair("daarmenian", '\u0564');
            RegisterPair("dabengali", '\u09A6');
            RegisterPair("dadarabic", '\u0636');
            RegisterPair("dadeva", '\u0926');
            RegisterPair("dadfinalarabic", '\uFEBE');
            RegisterPair("dadinitialarabic", '\uFEBF');
            RegisterPair("dadmedialarabic", '\uFEC0');
            RegisterPair("dagesh", '\u05BC');
            RegisterPair("dageshhebrew", '\u05BC');
            RegisterPair("dagger", '\u2020');
            RegisterPair("daggerdbl", '\u2021');
            RegisterPair("dagujarati", '\u0AA6');
            RegisterPair("dagurmukhi", '\u0A26');
            RegisterPair("dahiragana", '\u3060');
            RegisterPair("dakatakana", '\u30C0');
            RegisterPair("dalarabic", '\u062F');
            RegisterPair("dalet", '\u05D3');
            RegisterPair("daletdagesh", '\uFB33');
            RegisterPair("daletdageshhebrew", '\uFB33');
            //RegisterPair("dalethatafpatah", '\u05D3\u05B2');
            //RegisterPair("dalethatafpatahhebrew", '\u05D3\u05B2');
            //RegisterPair("dalethatafsegol", '\u05D3\u05B1');
            //RegisterPair("dalethatafsegolhebrew", '\u05D3\u05B1');
            RegisterPair("dalethebrew", '\u05D3');
            //RegisterPair("dalethiriq", '\u05D3\u05B4');
            //RegisterPair("dalethiriqhebrew", '\u05D3\u05B4');
            //RegisterPair("daletholam", '\u05D3\u05B9');
            //RegisterPair("daletholamhebrew", '\u05D3\u05B9');
            //RegisterPair("daletpatah", '\u05D3\u05B7');
            //RegisterPair("daletpatahhebrew", '\u05D3\u05B7');
            //RegisterPair("daletqamats", '\u05D3\u05B8');
            //RegisterPair("daletqamatshebrew", '\u05D3\u05B8');
            //RegisterPair("daletqubuts", '\u05D3\u05BB');
            //RegisterPair("daletqubutshebrew", '\u05D3\u05BB');
            //RegisterPair("daletsegol", '\u05D3\u05B6');
            //RegisterPair("daletsegolhebrew", '\u05D3\u05B6');
            //RegisterPair("daletsheva", '\u05D3\u05B0');
            //RegisterPair("daletshevahebrew", '\u05D3\u05B0');
            //RegisterPair("dalettsere", '\u05D3\u05B5');
            //RegisterPair("dalettserehebrew", '\u05D3\u05B5');
            RegisterPair("dalfinalarabic", '\uFEAA');
            RegisterPair("dammaarabic", '\u064F');
            RegisterPair("dammalowarabic", '\u064F');
            RegisterPair("dammatanaltonearabic", '\u064C');
            RegisterPair("dammatanarabic", '\u064C');
            RegisterPair("danda", '\u0964');
            RegisterPair("dargahebrew", '\u05A7');
            RegisterPair("dargalefthebrew", '\u05A7');
            RegisterPair("dasiapneumatacyrilliccmb", '\u0485');
            RegisterPair("dblGrave", '\uF6D3');
            RegisterPair("dblanglebracketleft", '\u300A');
            RegisterPair("dblanglebracketleftvertical", '\uFE3D');
            RegisterPair("dblanglebracketright", '\u300B');
            RegisterPair("dblanglebracketrightvertical", '\uFE3E');
            RegisterPair("dblarchinvertedbelowcmb", '\u032B');
            RegisterPair("dblarrowleft", '\u21D4');
            RegisterPair("dblarrowright", '\u21D2');
            RegisterPair("dbldanda", '\u0965');
            RegisterPair("dblgrave", '\uF6D6');
            RegisterPair("dblgravecmb", '\u030F');
            RegisterPair("dblintegral", '\u222C');
            RegisterPair("dbllowline", '\u2017');
            RegisterPair("dbllowlinecmb", '\u0333');
            RegisterPair("dbloverlinecmb", '\u033F');
            RegisterPair("dblprimemod", '\u02BA');
            RegisterPair("dblverticalbar", '\u2016');
            RegisterPair("dblverticallineabovecmb", '\u030E');
            RegisterPair("dbopomofo", '\u3109');
            RegisterPair("dbsquare", '\u33C8');
            RegisterPair("dcaron", '\u010F');
            RegisterPair("dcedilla", '\u1E11');
            RegisterPair("dcircle", '\u24D3');
            RegisterPair("dcircumflexbelow", '\u1E13');
            RegisterPair("dcroat", '\u0111');
            RegisterPair("ddabengali", '\u09A1');
            RegisterPair("ddadeva", '\u0921');
            RegisterPair("ddagujarati", '\u0AA1');
            RegisterPair("ddagurmukhi", '\u0A21');
            RegisterPair("ddalarabic", '\u0688');
            RegisterPair("ddalfinalarabic", '\uFB89');
            RegisterPair("dddhadeva", '\u095C');
            RegisterPair("ddhabengali", '\u09A2');
            RegisterPair("ddhadeva", '\u0922');
            RegisterPair("ddhagujarati", '\u0AA2');
            RegisterPair("ddhagurmukhi", '\u0A22');
            RegisterPair("ddotaccent", '\u1E0B');
            RegisterPair("ddotbelow", '\u1E0D');
            RegisterPair("decimalseparatorarabic", '\u066B');
            RegisterPair("decimalseparatorpersian", '\u066B');
            RegisterPair("decyrillic", '\u0434');
            RegisterPair("degree", '\u00B0');
            RegisterPair("dehihebrew", '\u05AD');
            RegisterPair("dehiragana", '\u3067');
            RegisterPair("deicoptic", '\u03EF');
            RegisterPair("dekatakana", '\u30C7');
            RegisterPair("deleteleft", '\u232B');
            RegisterPair("deleteright", '\u2326');
            RegisterPair("delta", '\u03B4');
            RegisterPair("deltaturned", '\u018D');
            RegisterPair("denominatorminusonenumeratorbengali", '\u09F8');
            RegisterPair("dezh", '\u02A4');
            RegisterPair("dhabengali", '\u09A7');
            RegisterPair("dhadeva", '\u0927');
            RegisterPair("dhagujarati", '\u0AA7');
            RegisterPair("dhagurmukhi", '\u0A27');
            RegisterPair("dhook", '\u0257');
            RegisterPair("dialytikatonos", '\u0385');
            RegisterPair("dialytikatonoscmb", '\u0344');
            RegisterPair("diamond", '\u2666');
            RegisterPair("diamondsuitwhite", '\u2662');
            RegisterPair("dieresis", '\u00A8');
            RegisterPair("dieresisacute", '\uF6D7');
            RegisterPair("dieresisbelowcmb", '\u0324');
            RegisterPair("dieresiscmb", '\u0308');
            RegisterPair("dieresisgrave", '\uF6D8');
            RegisterPair("dieresistonos", '\u0385');
            RegisterPair("dihiragana", '\u3062');
            RegisterPair("dikatakana", '\u30C2');
            RegisterPair("dittomark", '\u3003');
            RegisterPair("divide", '\u00F7');
            RegisterPair("divides", '\u2223');
            RegisterPair("divisionslash", '\u2215');
            RegisterPair("djecyrillic", '\u0452');
            RegisterPair("dkshade", '\u2593');
            RegisterPair("dlinebelow", '\u1E0F');
            RegisterPair("dlsquare", '\u3397');
            RegisterPair("dmacron", '\u0111');
            RegisterPair("dmonospace", '\uFF44');
            RegisterPair("dnblock", '\u2584');
            RegisterPair("dochadathai", '\u0E0E');
            RegisterPair("dodekthai", '\u0E14');
            RegisterPair("dohiragana", '\u3069');
            RegisterPair("dokatakana", '\u30C9');
            RegisterPair("dollar", '\u0024');
            RegisterPair("dollarinferior", '\uF6E3');
            RegisterPair("dollarmonospace", '\uFF04');
            RegisterPair("dollaroldstyle", '\uF724');
            RegisterPair("dollarsmall", '\uFE69');
            RegisterPair("dollarsuperior", '\uF6E4');
            RegisterPair("dong", '\u20AB');
            RegisterPair("dorusquare", '\u3326');
            RegisterPair("dotaccent", '\u02D9');
            RegisterPair("dotaccentcmb", '\u0307');
            RegisterPair("dotbelowcmb", '\u0323');
            RegisterPair("dotbelowcomb", '\u0323');
            RegisterPair("dotkatakana", '\u30FB');
            RegisterPair("dotlessi", '\u0131');
            RegisterPair("dotlessj", '\uF6BE');
            RegisterPair("dotlessjstrokehook", '\u0284');
            RegisterPair("dotmath", '\u22C5');
            RegisterPair("dottedcircle", '\u25CC');
            RegisterPair("doubleyodpatah", '\uFB1F');
            RegisterPair("doubleyodpatahhebrew", '\uFB1F');
            RegisterPair("downtackbelowcmb", '\u031E');
            RegisterPair("downtackmod", '\u02D5');
            RegisterPair("dparen", '\u249F');
            RegisterPair("dsuperior", '\uF6EB');
            RegisterPair("dtail", '\u0256');
            RegisterPair("dtopbar", '\u018C');
            RegisterPair("duhiragana", '\u3065');
            RegisterPair("dukatakana", '\u30C5');
            RegisterPair("dz", '\u01F3');
            RegisterPair("dzaltone", '\u02A3');
            RegisterPair("dzcaron", '\u01C6');
            RegisterPair("dzcurl", '\u02A5');
            RegisterPair("dzeabkhasiancyrillic", '\u04E1');
            RegisterPair("dzecyrillic", '\u0455');
            RegisterPair("dzhecyrillic", '\u045F');
            RegisterPair("e", '\u0065');
            RegisterPair("eacute", '\u00E9');
            RegisterPair("earth", '\u2641');
            RegisterPair("ebengali", '\u098F');
            RegisterPair("ebopomofo", '\u311C');
            RegisterPair("ebreve", '\u0115');
            RegisterPair("ecandradeva", '\u090D');
            RegisterPair("ecandragujarati", '\u0A8D');
            RegisterPair("ecandravowelsigndeva", '\u0945');
            RegisterPair("ecandravowelsigngujarati", '\u0AC5');
            RegisterPair("ecaron", '\u011B');
            RegisterPair("ecedillabreve", '\u1E1D');
            RegisterPair("echarmenian", '\u0565');
            RegisterPair("echyiwnarmenian", '\u0587');
            RegisterPair("ecircle", '\u24D4');
            RegisterPair("ecircumflex", '\u00EA');
            RegisterPair("ecircumflexacute", '\u1EBF');
            RegisterPair("ecircumflexbelow", '\u1E19');
            RegisterPair("ecircumflexdotbelow", '\u1EC7');
            RegisterPair("ecircumflexgrave", '\u1EC1');
            RegisterPair("ecircumflexhookabove", '\u1EC3');
            RegisterPair("ecircumflextilde", '\u1EC5');
            RegisterPair("ecyrillic", '\u0454');
            RegisterPair("edblgrave", '\u0205');
            RegisterPair("edeva", '\u090F');
            RegisterPair("edieresis", '\u00EB');
            RegisterPair("edot", '\u0117');
            RegisterPair("edotaccent", '\u0117');
            RegisterPair("edotbelow", '\u1EB9');
            RegisterPair("eegurmukhi", '\u0A0F');
            RegisterPair("eematragurmukhi", '\u0A47');
            RegisterPair("efcyrillic", '\u0444');
            RegisterPair("egrave", '\u00E8');
            RegisterPair("egujarati", '\u0A8F');
            RegisterPair("eharmenian", '\u0567');
            RegisterPair("ehbopomofo", '\u311D');
            RegisterPair("ehiragana", '\u3048');
            RegisterPair("ehookabove", '\u1EBB');
            RegisterPair("eibopomofo", '\u311F');
            RegisterPair("eight", '\u0038');
            RegisterPair("eightarabic", '\u0668');
            RegisterPair("eightbengali", '\u09EE');
            RegisterPair("eightcircle", '\u2467');
            RegisterPair("eightcircleinversesansserif", '\u2791');
            RegisterPair("eightdeva", '\u096E');
            RegisterPair("eighteencircle", '\u2471');
            RegisterPair("eighteenparen", '\u2485');
            RegisterPair("eighteenperiod", '\u2499');
            RegisterPair("eightgujarati", '\u0AEE');
            RegisterPair("eightgurmukhi", '\u0A6E');
            RegisterPair("eighthackarabic", '\u0668');
            RegisterPair("eighthangzhou", '\u3028');
            RegisterPair("eighthnotebeamed", '\u266B');
            RegisterPair("eightideographicparen", '\u3227');
            RegisterPair("eightinferior", '\u2088');
            RegisterPair("eightmonospace", '\uFF18');
            RegisterPair("eightoldstyle", '\uF738');
            RegisterPair("eightparen", '\u247B');
            RegisterPair("eightperiod", '\u248F');
            RegisterPair("eightpersian", '\u06F8');
            RegisterPair("eightroman", '\u2177');
            RegisterPair("eightsuperior", '\u2078');
            RegisterPair("eightthai", '\u0E58');
            RegisterPair("einvertedbreve", '\u0207');
            RegisterPair("eiotifiedcyrillic", '\u0465');
            RegisterPair("ekatakana", '\u30A8');
            RegisterPair("ekatakanahalfwidth", '\uFF74');
            RegisterPair("ekonkargurmukhi", '\u0A74');
            RegisterPair("ekorean", '\u3154');
            RegisterPair("elcyrillic", '\u043B');
            RegisterPair("element", '\u2208');
            RegisterPair("elevencircle", '\u246A');
            RegisterPair("elevenparen", '\u247E');
            RegisterPair("elevenperiod", '\u2492');
            RegisterPair("elevenroman", '\u217A');
            RegisterPair("ellipsis", '\u2026');
            RegisterPair("ellipsisvertical", '\u22EE');
            RegisterPair("emacron", '\u0113');
            RegisterPair("emacronacute", '\u1E17');
            RegisterPair("emacrongrave", '\u1E15');
            RegisterPair("emcyrillic", '\u043C');
            RegisterPair("emdash", '\u2014');
            RegisterPair("emdashvertical", '\uFE31');
            RegisterPair("emonospace", '\uFF45');
            RegisterPair("emphasismarkarmenian", '\u055B');
            RegisterPair("emptyset", '\u2205');
            RegisterPair("enbopomofo", '\u3123');
            RegisterPair("encyrillic", '\u043D');
            RegisterPair("endash", '\u2013');
            RegisterPair("endashvertical", '\uFE32');
            RegisterPair("endescendercyrillic", '\u04A3');
            RegisterPair("eng", '\u014B');
            RegisterPair("engbopomofo", '\u3125');
            RegisterPair("enghecyrillic", '\u04A5');
            RegisterPair("enhookcyrillic", '\u04C8');
            RegisterPair("enspace", '\u2002');
            RegisterPair("eogonek", '\u0119');
            RegisterPair("eokorean", '\u3153');
            RegisterPair("eopen", '\u025B');
            RegisterPair("eopenclosed", '\u029A');
            RegisterPair("eopenreversed", '\u025C');
            RegisterPair("eopenreversedclosed", '\u025E');
            RegisterPair("eopenreversedhook", '\u025D');
            RegisterPair("eparen", '\u24A0');
            RegisterPair("epsilon", '\u03B5');
            RegisterPair("epsilontonos", '\u03AD');
            RegisterPair("equal", '\u003D');
            RegisterPair("equalmonospace", '\uFF1D');
            RegisterPair("equalsmall", '\uFE66');
            RegisterPair("equalsuperior", '\u207C');
            RegisterPair("equivalence", '\u2261');
            RegisterPair("erbopomofo", '\u3126');
            RegisterPair("ercyrillic", '\u0440');
            RegisterPair("ereversed", '\u0258');
            RegisterPair("ereversedcyrillic", '\u044D');
            RegisterPair("escyrillic", '\u0441');
            RegisterPair("esdescendercyrillic", '\u04AB');
            RegisterPair("esh", '\u0283');
            RegisterPair("eshcurl", '\u0286');
            RegisterPair("eshortdeva", '\u090E');
            RegisterPair("eshortvowelsigndeva", '\u0946');
            RegisterPair("eshreversedloop", '\u01AA');
            RegisterPair("eshsquatreversed", '\u0285');
            RegisterPair("esmallhiragana", '\u3047');
            RegisterPair("esmallkatakana", '\u30A7');
            RegisterPair("esmallkatakanahalfwidth", '\uFF6A');
            RegisterPair("estimated", '\u212E');
            RegisterPair("esuperior", '\uF6EC');
            RegisterPair("eta", '\u03B7');
            RegisterPair("etarmenian", '\u0568');
            RegisterPair("etatonos", '\u03AE');
            RegisterPair("eth", '\u00F0');
            RegisterPair("etilde", '\u1EBD');
            RegisterPair("etildebelow", '\u1E1B');
            RegisterPair("etnahtafoukhhebrew", '\u0591');
            RegisterPair("etnahtafoukhlefthebrew", '\u0591');
            RegisterPair("etnahtahebrew", '\u0591');
            RegisterPair("etnahtalefthebrew", '\u0591');
            RegisterPair("eturned", '\u01DD');
            RegisterPair("eukorean", '\u3161');
            RegisterPair("euro", '\u20AC');
            RegisterPair("evowelsignbengali", '\u09C7');
            RegisterPair("evowelsigndeva", '\u0947');
            RegisterPair("evowelsigngujarati", '\u0AC7');
            RegisterPair("exclam", '\u0021');
            RegisterPair("exclamarmenian", '\u055C');
            RegisterPair("exclamdbl", '\u203C');
            RegisterPair("exclamdown", '\u00A1');
            RegisterPair("exclamdownsmall", '\uF7A1');
            RegisterPair("exclammonospace", '\uFF01');
            RegisterPair("exclamsmall", '\uF721');
            RegisterPair("existential", '\u2203');
            RegisterPair("ezh", '\u0292');
            RegisterPair("ezhcaron", '\u01EF');
            RegisterPair("ezhcurl", '\u0293');
            RegisterPair("ezhreversed", '\u01B9');
            RegisterPair("ezhtail", '\u01BA');
            RegisterPair("f", '\u0066');
            RegisterPair("fadeva", '\u095E');
            RegisterPair("fagurmukhi", '\u0A5E');
            RegisterPair("fahrenheit", '\u2109');
            RegisterPair("fathaarabic", '\u064E');
            RegisterPair("fathalowarabic", '\u064E');
            RegisterPair("fathatanarabic", '\u064B');
            RegisterPair("fbopomofo", '\u3108');
            RegisterPair("fcircle", '\u24D5');
            RegisterPair("fdotaccent", '\u1E1F');
            RegisterPair("feharabic", '\u0641');
            RegisterPair("feharmenian", '\u0586');
            RegisterPair("fehfinalarabic", '\uFED2');
            RegisterPair("fehinitialarabic", '\uFED3');
            RegisterPair("fehmedialarabic", '\uFED4');
            RegisterPair("feicoptic", '\u03E5');
            RegisterPair("female", '\u2640');
            RegisterPair("ff", '\uFB00');
            RegisterPair("ffi", '\uFB03');
            RegisterPair("ffl", '\uFB04');
            RegisterPair("fi", '\uFB01');
            RegisterPair("fifteencircle", '\u246E');
            RegisterPair("fifteenparen", '\u2482');
            RegisterPair("fifteenperiod", '\u2496');
            RegisterPair("figuredash", '\u2012');
            RegisterPair("filledbox", '\u25A0');
            RegisterPair("filledrect", '\u25AC');
            RegisterPair("finalkaf", '\u05DA');
            RegisterPair("finalkafdagesh", '\uFB3A');
            RegisterPair("finalkafdageshhebrew", '\uFB3A');
            RegisterPair("finalkafhebrew", '\u05DA');
            //RegisterPair("finalkafqamats", '\u05DA\u05B8');
            //RegisterPair("finalkafqamatshebrew", '\u05DA\u05B8');
            //RegisterPair("finalkafsheva", '\u05DA\u05B0');
            //RegisterPair("finalkafshevahebrew", '\u05DA\u05B0');
            RegisterPair("finalmem", '\u05DD');
            RegisterPair("finalmemhebrew", '\u05DD');
            RegisterPair("finalnun", '\u05DF');
            RegisterPair("finalnunhebrew", '\u05DF');
            RegisterPair("finalpe", '\u05E3');
            RegisterPair("finalpehebrew", '\u05E3');
            RegisterPair("finaltsadi", '\u05E5');
            RegisterPair("finaltsadihebrew", '\u05E5');
            RegisterPair("firsttonechinese", '\u02C9');
            RegisterPair("fisheye", '\u25C9');
            RegisterPair("fitacyrillic", '\u0473');
            RegisterPair("five", '\u0035');
            RegisterPair("fivearabic", '\u0665');
            RegisterPair("fivebengali", '\u09EB');
            RegisterPair("fivecircle", '\u2464');
            RegisterPair("fivecircleinversesansserif", '\u278E');
            RegisterPair("fivedeva", '\u096B');
            RegisterPair("fiveeighths", '\u215D');
            RegisterPair("fivegujarati", '\u0AEB');
            RegisterPair("fivegurmukhi", '\u0A6B');
            RegisterPair("fivehackarabic", '\u0665');
            RegisterPair("fivehangzhou", '\u3025');
            RegisterPair("fiveideographicparen", '\u3224');
            RegisterPair("fiveinferior", '\u2085');
            RegisterPair("fivemonospace", '\uFF15');
            RegisterPair("fiveoldstyle", '\uF735');
            RegisterPair("fiveparen", '\u2478');
            RegisterPair("fiveperiod", '\u248C');
            RegisterPair("fivepersian", '\u06F5');
            RegisterPair("fiveroman", '\u2174');
            RegisterPair("fivesuperior", '\u2075');
            RegisterPair("fivethai", '\u0E55');
            RegisterPair("fl", '\uFB02');
            RegisterPair("florin", '\u0192');
            RegisterPair("fmonospace", '\uFF46');
            RegisterPair("fmsquare", '\u3399');
            RegisterPair("fofanthai", '\u0E1F');
            RegisterPair("fofathai", '\u0E1D');
            RegisterPair("fongmanthai", '\u0E4F');
            RegisterPair("forall", '\u2200');
            RegisterPair("four", '\u0034');
            RegisterPair("fourarabic", '\u0664');
            RegisterPair("fourbengali", '\u09EA');
            RegisterPair("fourcircle", '\u2463');
            RegisterPair("fourcircleinversesansserif", '\u278D');
            RegisterPair("fourdeva", '\u096A');
            RegisterPair("fourgujarati", '\u0AEA');
            RegisterPair("fourgurmukhi", '\u0A6A');
            RegisterPair("fourhackarabic", '\u0664');
            RegisterPair("fourhangzhou", '\u3024');
            RegisterPair("fourideographicparen", '\u3223');
            RegisterPair("fourinferior", '\u2084');
            RegisterPair("fourmonospace", '\uFF14');
            RegisterPair("fournumeratorbengali", '\u09F7');
            RegisterPair("fouroldstyle", '\uF734');
            RegisterPair("fourparen", '\u2477');
            RegisterPair("fourperiod", '\u248B');
            RegisterPair("fourpersian", '\u06F4');
            RegisterPair("fourroman", '\u2173');
            RegisterPair("foursuperior", '\u2074');
            RegisterPair("fourteencircle", '\u246D');
            RegisterPair("fourteenparen", '\u2481');
            RegisterPair("fourteenperiod", '\u2495');
            RegisterPair("fourthai", '\u0E54');
            RegisterPair("fourthtonechinese", '\u02CB');
            RegisterPair("fparen", '\u24A1');
            RegisterPair("fraction", '\u2044');
            RegisterPair("franc", '\u20A3');
            RegisterPair("g", '\u0067');
            RegisterPair("gabengali", '\u0997');
            RegisterPair("gacute", '\u01F5');
            RegisterPair("gadeva", '\u0917');
            RegisterPair("gafarabic", '\u06AF');
            RegisterPair("gaffinalarabic", '\uFB93');
            RegisterPair("gafinitialarabic", '\uFB94');
            RegisterPair("gafmedialarabic", '\uFB95');
            RegisterPair("gagujarati", '\u0A97');
            RegisterPair("gagurmukhi", '\u0A17');
            RegisterPair("gahiragana", '\u304C');
            RegisterPair("gakatakana", '\u30AC');
            RegisterPair("gamma", '\u03B3');
            RegisterPair("gammalatinsmall", '\u0263');
            RegisterPair("gammasuperior", '\u02E0');
            RegisterPair("gangiacoptic", '\u03EB');
            RegisterPair("gbopomofo", '\u310D');
            RegisterPair("gbreve", '\u011F');
            RegisterPair("gcaron", '\u01E7');
            RegisterPair("gcedilla", '\u0123');
            RegisterPair("gcircle", '\u24D6');
            RegisterPair("gcircumflex", '\u011D');
            RegisterPair("gcommaaccent", '\u0123');
            RegisterPair("gdot", '\u0121');
            RegisterPair("gdotaccent", '\u0121');
            RegisterPair("gecyrillic", '\u0433');
            RegisterPair("gehiragana", '\u3052');
            RegisterPair("gekatakana", '\u30B2');
            RegisterPair("geometricallyequal", '\u2251');
            RegisterPair("gereshaccenthebrew", '\u059C');
            RegisterPair("gereshhebrew", '\u05F3');
            RegisterPair("gereshmuqdamhebrew", '\u059D');
            RegisterPair("germandbls", '\u00DF');
            RegisterPair("gershayimaccenthebrew", '\u059E');
            RegisterPair("gershayimhebrew", '\u05F4');
            RegisterPair("getamark", '\u3013');
            RegisterPair("ghabengali", '\u0998');
            RegisterPair("ghadarmenian", '\u0572');
            RegisterPair("ghadeva", '\u0918');
            RegisterPair("ghagujarati", '\u0A98');
            RegisterPair("ghagurmukhi", '\u0A18');
            RegisterPair("ghainarabic", '\u063A');
            RegisterPair("ghainfinalarabic", '\uFECE');
            RegisterPair("ghaininitialarabic", '\uFECF');
            RegisterPair("ghainmedialarabic", '\uFED0');
            RegisterPair("ghemiddlehookcyrillic", '\u0495');
            RegisterPair("ghestrokecyrillic", '\u0493');
            RegisterPair("gheupturncyrillic", '\u0491');
            RegisterPair("ghhadeva", '\u095A');
            RegisterPair("ghhagurmukhi", '\u0A5A');
            RegisterPair("ghook", '\u0260');
            RegisterPair("ghzsquare", '\u3393');
            RegisterPair("gihiragana", '\u304E');
            RegisterPair("gikatakana", '\u30AE');
            RegisterPair("gimarmenian", '\u0563');
            RegisterPair("gimel", '\u05D2');
            RegisterPair("gimeldagesh", '\uFB32');
            RegisterPair("gimeldageshhebrew", '\uFB32');
            RegisterPair("gimelhebrew", '\u05D2');
            RegisterPair("gjecyrillic", '\u0453');
            RegisterPair("glottalinvertedstroke", '\u01BE');
            RegisterPair("glottalstop", '\u0294');
            RegisterPair("glottalstopinverted", '\u0296');
            RegisterPair("glottalstopmod", '\u02C0');
            RegisterPair("glottalstopreversed", '\u0295');
            RegisterPair("glottalstopreversedmod", '\u02C1');
            RegisterPair("glottalstopreversedsuperior", '\u02E4');
            RegisterPair("glottalstopstroke", '\u02A1');
            RegisterPair("glottalstopstrokereversed", '\u02A2');
            RegisterPair("gmacron", '\u1E21');
            RegisterPair("gmonospace", '\uFF47');
            RegisterPair("gohiragana", '\u3054');
            RegisterPair("gokatakana", '\u30B4');
            RegisterPair("gparen", '\u24A2');
            RegisterPair("gpasquare", '\u33AC');
            RegisterPair("gradient", '\u2207');
            RegisterPair("grave", '\u0060');
            RegisterPair("gravebelowcmb", '\u0316');
            RegisterPair("gravecmb", '\u0300');
            RegisterPair("gravecomb", '\u0300');
            RegisterPair("gravedeva", '\u0953');
            RegisterPair("gravelowmod", '\u02CE');
            RegisterPair("gravemonospace", '\uFF40');
            RegisterPair("gravetonecmb", '\u0340');
            RegisterPair("greater", '\u003E');
            RegisterPair("greaterequal", '\u2265');
            RegisterPair("greaterequalorless", '\u22DB');
            RegisterPair("greatermonospace", '\uFF1E');
            RegisterPair("greaterorequivalent", '\u2273');
            RegisterPair("greaterorless", '\u2277');
            RegisterPair("greateroverequal", '\u2267');
            RegisterPair("greatersmall", '\uFE65');
            RegisterPair("gscript", '\u0261');
            RegisterPair("gstroke", '\u01E5');
            RegisterPair("guhiragana", '\u3050');
            RegisterPair("guillemotleft", '\u00AB');
            RegisterPair("guillemotright", '\u00BB');
            RegisterPair("guilsinglleft", '\u2039');
            RegisterPair("guilsinglright", '\u203A');
            RegisterPair("gukatakana", '\u30B0');
            RegisterPair("guramusquare", '\u3318');
            RegisterPair("gysquare", '\u33C9');
            RegisterPair("h", '\u0068');
            RegisterPair("haabkhasiancyrillic", '\u04A9');
            RegisterPair("haaltonearabic", '\u06C1');
            RegisterPair("habengali", '\u09B9');
            RegisterPair("hadescendercyrillic", '\u04B3');
            RegisterPair("hadeva", '\u0939');
            RegisterPair("hagujarati", '\u0AB9');
            RegisterPair("hagurmukhi", '\u0A39');
            RegisterPair("haharabic", '\u062D');
            RegisterPair("hahfinalarabic", '\uFEA2');
            RegisterPair("hahinitialarabic", '\uFEA3');
            RegisterPair("hahiragana", '\u306F');
            RegisterPair("hahmedialarabic", '\uFEA4');
            RegisterPair("haitusquare", '\u332A');
            RegisterPair("hakatakana", '\u30CF');
            RegisterPair("hakatakanahalfwidth", '\uFF8A');
            RegisterPair("halantgurmukhi", '\u0A4D');
            RegisterPair("hamzaarabic", '\u0621');
            //RegisterPair("hamzadammaarabic", '\u0621\u064F');
            //RegisterPair("hamzadammatanarabic", '\u0621\u064C');
            //RegisterPair("hamzafathaarabic", '\u0621\u064E');
            //RegisterPair("hamzafathatanarabic", '\u0621\u064B');
            RegisterPair("hamzalowarabic", '\u0621');
            //RegisterPair("hamzalowkasraarabic", '\u0621\u0650');
            //RegisterPair("hamzalowkasratanarabic", '\u0621\u064D');
            //RegisterPair("hamzasukunarabic", '\u0621\u0652');
            RegisterPair("hangulfiller", '\u3164');
            RegisterPair("hardsigncyrillic", '\u044A');
            RegisterPair("harpoonleftbarbup", '\u21BC');
            RegisterPair("harpoonrightbarbup", '\u21C0');
            RegisterPair("hasquare", '\u33CA');
            RegisterPair("hatafpatah", '\u05B2');
            RegisterPair("hatafpatah16", '\u05B2');
            RegisterPair("hatafpatah23", '\u05B2');
            RegisterPair("hatafpatah2f", '\u05B2');
            RegisterPair("hatafpatahhebrew", '\u05B2');
            RegisterPair("hatafpatahnarrowhebrew", '\u05B2');
            RegisterPair("hatafpatahquarterhebrew", '\u05B2');
            RegisterPair("hatafpatahwidehebrew", '\u05B2');
            RegisterPair("hatafqamats", '\u05B3');
            RegisterPair("hatafqamats1b", '\u05B3');
            RegisterPair("hatafqamats28", '\u05B3');
            RegisterPair("hatafqamats34", '\u05B3');
            RegisterPair("hatafqamatshebrew", '\u05B3');
            RegisterPair("hatafqamatsnarrowhebrew", '\u05B3');
            RegisterPair("hatafqamatsquarterhebrew", '\u05B3');
            RegisterPair("hatafqamatswidehebrew", '\u05B3');
            RegisterPair("hatafsegol", '\u05B1');
            RegisterPair("hatafsegol17", '\u05B1');
            RegisterPair("hatafsegol24", '\u05B1');
            RegisterPair("hatafsegol30", '\u05B1');
            RegisterPair("hatafsegolhebrew", '\u05B1');
            RegisterPair("hatafsegolnarrowhebrew", '\u05B1');
            RegisterPair("hatafsegolquarterhebrew", '\u05B1');
            RegisterPair("hatafsegolwidehebrew", '\u05B1');
            RegisterPair("hbar", '\u0127');
            RegisterPair("hbopomofo", '\u310F');
            RegisterPair("hbrevebelow", '\u1E2B');
            RegisterPair("hcedilla", '\u1E29');
            RegisterPair("hcircle", '\u24D7');
            RegisterPair("hcircumflex", '\u0125');
            RegisterPair("hdieresis", '\u1E27');
            RegisterPair("hdotaccent", '\u1E23');
            RegisterPair("hdotbelow", '\u1E25');
            RegisterPair("he", '\u05D4');
            RegisterPair("heart", '\u2665');
            RegisterPair("heartsuitblack", '\u2665');
            RegisterPair("heartsuitwhite", '\u2661');
            RegisterPair("hedagesh", '\uFB34');
            RegisterPair("hedageshhebrew", '\uFB34');
            RegisterPair("hehaltonearabic", '\u06C1');
            RegisterPair("heharabic", '\u0647');
            RegisterPair("hehebrew", '\u05D4');
            RegisterPair("hehfinalaltonearabic", '\uFBA7');
            RegisterPair("hehfinalalttwoarabic", '\uFEEA');
            RegisterPair("hehfinalarabic", '\uFEEA');
            RegisterPair("hehhamzaabovefinalarabic", '\uFBA5');
            RegisterPair("hehhamzaaboveisolatedarabic", '\uFBA4');
            RegisterPair("hehinitialaltonearabic", '\uFBA8');
            RegisterPair("hehinitialarabic", '\uFEEB');
            RegisterPair("hehiragana", '\u3078');
            RegisterPair("hehmedialaltonearabic", '\uFBA9');
            RegisterPair("hehmedialarabic", '\uFEEC');
            RegisterPair("heiseierasquare", '\u337B');
            RegisterPair("hekatakana", '\u30D8');
            RegisterPair("hekatakanahalfwidth", '\uFF8D');
            RegisterPair("hekutaarusquare", '\u3336');
            RegisterPair("henghook", '\u0267');
            RegisterPair("herutusquare", '\u3339');
            RegisterPair("het", '\u05D7');
            RegisterPair("hethebrew", '\u05D7');
            RegisterPair("hhook", '\u0266');
            RegisterPair("hhooksuperior", '\u02B1');
            RegisterPair("hieuhacirclekorean", '\u327B');
            RegisterPair("hieuhaparenkorean", '\u321B');
            RegisterPair("hieuhcirclekorean", '\u326D');
            RegisterPair("hieuhkorean", '\u314E');
            RegisterPair("hieuhparenkorean", '\u320D');
            RegisterPair("hihiragana", '\u3072');
            RegisterPair("hikatakana", '\u30D2');
            RegisterPair("hikatakanahalfwidth", '\uFF8B');
            RegisterPair("hiriq", '\u05B4');
            RegisterPair("hiriq14", '\u05B4');
            RegisterPair("hiriq21", '\u05B4');
            RegisterPair("hiriq2d", '\u05B4');
            RegisterPair("hiriqhebrew", '\u05B4');
            RegisterPair("hiriqnarrowhebrew", '\u05B4');
            RegisterPair("hiriqquarterhebrew", '\u05B4');
            RegisterPair("hiriqwidehebrew", '\u05B4');
            RegisterPair("hlinebelow", '\u1E96');
            RegisterPair("hmonospace", '\uFF48');
            RegisterPair("hoarmenian", '\u0570');
            RegisterPair("hohipthai", '\u0E2B');
            RegisterPair("hohiragana", '\u307B');
            RegisterPair("hokatakana", '\u30DB');
            RegisterPair("hokatakanahalfwidth", '\uFF8E');
            RegisterPair("holam", '\u05B9');
            RegisterPair("holam19", '\u05B9');
            RegisterPair("holam26", '\u05B9');
            RegisterPair("holam32", '\u05B9');
            RegisterPair("holamhebrew", '\u05B9');
            RegisterPair("holamnarrowhebrew", '\u05B9');
            RegisterPair("holamquarterhebrew", '\u05B9');
            RegisterPair("holamwidehebrew", '\u05B9');
            RegisterPair("honokhukthai", '\u0E2E');
            RegisterPair("hookabovecomb", '\u0309');
            RegisterPair("hookcmb", '\u0309');
            RegisterPair("hookpalatalizedbelowcmb", '\u0321');
            RegisterPair("hookretroflexbelowcmb", '\u0322');
            RegisterPair("hoonsquare", '\u3342');
            RegisterPair("horicoptic", '\u03E9');
            RegisterPair("horizontalbar", '\u2015');
            RegisterPair("horncmb", '\u031B');
            RegisterPair("hotsprings", '\u2668');
            RegisterPair("house", '\u2302');
            RegisterPair("hparen", '\u24A3');
            RegisterPair("hsuperior", '\u02B0');
            RegisterPair("hturned", '\u0265');
            RegisterPair("huhiragana", '\u3075');
            RegisterPair("huiitosquare", '\u3333');
            RegisterPair("hukatakana", '\u30D5');
            RegisterPair("hukatakanahalfwidth", '\uFF8C');
            RegisterPair("hungarumlaut", '\u02DD');
            RegisterPair("hungarumlautcmb", '\u030B');
            RegisterPair("hv", '\u0195');
            RegisterPair("hyphen", '\u002D');
            RegisterPair("hypheninferior", '\uF6E5');
            RegisterPair("hyphenmonospace", '\uFF0D');
            RegisterPair("hyphensmall", '\uFE63');
            RegisterPair("hyphensuperior", '\uF6E6');
            RegisterPair("hyphentwo", '\u2010');
            RegisterPair("i", '\u0069');
            RegisterPair("iacute", '\u00ED');
            RegisterPair("iacyrillic", '\u044F');
            RegisterPair("ibengali", '\u0987');
            RegisterPair("ibopomofo", '\u3127');
            RegisterPair("ibreve", '\u012D');
            RegisterPair("icaron", '\u01D0');
            RegisterPair("icircle", '\u24D8');
            RegisterPair("icircumflex", '\u00EE');
            RegisterPair("icyrillic", '\u0456');
            RegisterPair("idblgrave", '\u0209');
            RegisterPair("ideographearthcircle", '\u328F');
            RegisterPair("ideographfirecircle", '\u328B');
            RegisterPair("ideographicallianceparen", '\u323F');
            RegisterPair("ideographiccallparen", '\u323A');
            RegisterPair("ideographiccentrecircle", '\u32A5');
            RegisterPair("ideographicclose", '\u3006');
            RegisterPair("ideographiccomma", '\u3001');
            RegisterPair("ideographiccommaleft", '\uFF64');
            RegisterPair("ideographiccongratulationparen", '\u3237');
            RegisterPair("ideographiccorrectcircle", '\u32A3');
            RegisterPair("ideographicearthparen", '\u322F');
            RegisterPair("ideographicenterpriseparen", '\u323D');
            RegisterPair("ideographicexcellentcircle", '\u329D');
            RegisterPair("ideographicfestivalparen", '\u3240');
            RegisterPair("ideographicfinancialcircle", '\u3296');
            RegisterPair("ideographicfinancialparen", '\u3236');
            RegisterPair("ideographicfireparen", '\u322B');
            RegisterPair("ideographichaveparen", '\u3232');
            RegisterPair("ideographichighcircle", '\u32A4');
            RegisterPair("ideographiciterationmark", '\u3005');
            RegisterPair("ideographiclaborcircle", '\u3298');
            RegisterPair("ideographiclaborparen", '\u3238');
            RegisterPair("ideographicleftcircle", '\u32A7');
            RegisterPair("ideographiclowcircle", '\u32A6');
            RegisterPair("ideographicmedicinecircle", '\u32A9');
            RegisterPair("ideographicmetalparen", '\u322E');
            RegisterPair("ideographicmoonparen", '\u322A');
            RegisterPair("ideographicnameparen", '\u3234');
            RegisterPair("ideographicperiod", '\u3002');
            RegisterPair("ideographicprintcircle", '\u329E');
            RegisterPair("ideographicreachparen", '\u3243');
            RegisterPair("ideographicrepresentparen", '\u3239');
            RegisterPair("ideographicresourceparen", '\u323E');
            RegisterPair("ideographicrightcircle", '\u32A8');
            RegisterPair("ideographicsecretcircle", '\u3299');
            RegisterPair("ideographicselfparen", '\u3242');
            RegisterPair("ideographicsocietyparen", '\u3233');
            RegisterPair("ideographicspace", '\u3000');
            RegisterPair("ideographicspecialparen", '\u3235');
            RegisterPair("ideographicstockparen", '\u3231');
            RegisterPair("ideographicstudyparen", '\u323B');
            RegisterPair("ideographicsunparen", '\u3230');
            RegisterPair("ideographicsuperviseparen", '\u323C');
            RegisterPair("ideographicwaterparen", '\u322C');
            RegisterPair("ideographicwoodparen", '\u322D');
            RegisterPair("ideographiczero", '\u3007');
            RegisterPair("ideographmetalcircle", '\u328E');
            RegisterPair("ideographmooncircle", '\u328A');
            RegisterPair("ideographnamecircle", '\u3294');
            RegisterPair("ideographsuncircle", '\u3290');
            RegisterPair("ideographwatercircle", '\u328C');
            RegisterPair("ideographwoodcircle", '\u328D');
            RegisterPair("ideva", '\u0907');
            RegisterPair("idieresis", '\u00EF');
            RegisterPair("idieresisacute", '\u1E2F');
            RegisterPair("idieresiscyrillic", '\u04E5');
            RegisterPair("idotbelow", '\u1ECB');
            RegisterPair("iebrevecyrillic", '\u04D7');
            RegisterPair("iecyrillic", '\u0435');
            RegisterPair("ieungacirclekorean", '\u3275');
            RegisterPair("ieungaparenkorean", '\u3215');
            RegisterPair("ieungcirclekorean", '\u3267');
            RegisterPair("ieungkorean", '\u3147');
            RegisterPair("ieungparenkorean", '\u3207');
            RegisterPair("igrave", '\u00EC');
            RegisterPair("igujarati", '\u0A87');
            RegisterPair("igurmukhi", '\u0A07');
            RegisterPair("ihiragana", '\u3044');
            RegisterPair("ihookabove", '\u1EC9');
            RegisterPair("iibengali", '\u0988');
            RegisterPair("iicyrillic", '\u0438');
            RegisterPair("iideva", '\u0908');
            RegisterPair("iigujarati", '\u0A88');
            RegisterPair("iigurmukhi", '\u0A08');
            RegisterPair("iimatragurmukhi", '\u0A40');
            RegisterPair("iinvertedbreve", '\u020B');
            RegisterPair("iishortcyrillic", '\u0439');
            RegisterPair("iivowelsignbengali", '\u09C0');
            RegisterPair("iivowelsigndeva", '\u0940');
            RegisterPair("iivowelsigngujarati", '\u0AC0');
            RegisterPair("ij", '\u0133');
            RegisterPair("ikatakana", '\u30A4');
            RegisterPair("ikatakanahalfwidth", '\uFF72');
            RegisterPair("ikorean", '\u3163');
            RegisterPair("ilde", '\u02DC');
            RegisterPair("iluyhebrew", '\u05AC');
            RegisterPair("imacron", '\u012B');
            RegisterPair("imacroncyrillic", '\u04E3');
            RegisterPair("imageorapproximatelyequal", '\u2253');
            RegisterPair("imatragurmukhi", '\u0A3F');
            RegisterPair("imonospace", '\uFF49');
            RegisterPair("increment", '\u2206');
            RegisterPair("infinity", '\u221E');
            RegisterPair("iniarmenian", '\u056B');
            RegisterPair("integral", '\u222B');
            RegisterPair("integralbottom", '\u2321');
            RegisterPair("integralbt", '\u2321');
            RegisterPair("integralex", '\uF8F5');
            RegisterPair("integraltop", '\u2320');
            RegisterPair("integraltp", '\u2320');
            RegisterPair("intersection", '\u2229');
            RegisterPair("intisquare", '\u3305');
            RegisterPair("invbullet", '\u25D8');
            RegisterPair("invcircle", '\u25D9');
            RegisterPair("invsmileface", '\u263B');
            RegisterPair("iocyrillic", '\u0451');
            RegisterPair("iogonek", '\u012F');
            RegisterPair("iota", '\u03B9');
            RegisterPair("iotadieresis", '\u03CA');
            RegisterPair("iotadieresistonos", '\u0390');
            RegisterPair("iotalatin", '\u0269');
            RegisterPair("iotatonos", '\u03AF');
            RegisterPair("iparen", '\u24A4');
            RegisterPair("irigurmukhi", '\u0A72');
            RegisterPair("ismallhiragana", '\u3043');
            RegisterPair("ismallkatakana", '\u30A3');
            RegisterPair("ismallkatakanahalfwidth", '\uFF68');
            RegisterPair("issharbengali", '\u09FA');
            RegisterPair("istroke", '\u0268');
            RegisterPair("isuperior", '\uF6ED');
            RegisterPair("iterationhiragana", '\u309D');
            RegisterPair("iterationkatakana", '\u30FD');
            RegisterPair("itilde", '\u0129');
            RegisterPair("itildebelow", '\u1E2D');
            RegisterPair("iubopomofo", '\u3129');
            RegisterPair("iucyrillic", '\u044E');
            RegisterPair("ivowelsignbengali", '\u09BF');
            RegisterPair("ivowelsigndeva", '\u093F');
            RegisterPair("ivowelsigngujarati", '\u0ABF');
            RegisterPair("izhitsacyrillic", '\u0475');
            RegisterPair("izhitsadblgravecyrillic", '\u0477');
            RegisterPair("j", '\u006A');
            RegisterPair("jaarmenian", '\u0571');
            RegisterPair("jabengali", '\u099C');
            RegisterPair("jadeva", '\u091C');
            RegisterPair("jagujarati", '\u0A9C');
            RegisterPair("jagurmukhi", '\u0A1C');
            RegisterPair("jbopomofo", '\u3110');
            RegisterPair("jcaron", '\u01F0');
            RegisterPair("jcircle", '\u24D9');
            RegisterPair("jcircumflex", '\u0135');
            RegisterPair("jcrossedtail", '\u029D');
            RegisterPair("jdotlessstroke", '\u025F');
            RegisterPair("jecyrillic", '\u0458');
            RegisterPair("jeemarabic", '\u062C');
            RegisterPair("jeemfinalarabic", '\uFE9E');
            RegisterPair("jeeminitialarabic", '\uFE9F');
            RegisterPair("jeemmedialarabic", '\uFEA0');
            RegisterPair("jeharabic", '\u0698');
            RegisterPair("jehfinalarabic", '\uFB8B');
            RegisterPair("jhabengali", '\u099D');
            RegisterPair("jhadeva", '\u091D');
            RegisterPair("jhagujarati", '\u0A9D');
            RegisterPair("jhagurmukhi", '\u0A1D');
            RegisterPair("jheharmenian", '\u057B');
            RegisterPair("jis", '\u3004');
            RegisterPair("jmonospace", '\uFF4A');
            RegisterPair("jparen", '\u24A5');
            RegisterPair("jsuperior", '\u02B2');
            RegisterPair("k", '\u006B');
            RegisterPair("kabashkircyrillic", '\u04A1');
            RegisterPair("kabengali", '\u0995');
            RegisterPair("kacute", '\u1E31');
            RegisterPair("kacyrillic", '\u043A');
            RegisterPair("kadescendercyrillic", '\u049B');
            RegisterPair("kadeva", '\u0915');
            RegisterPair("kaf", '\u05DB');
            RegisterPair("kafarabic", '\u0643');
            RegisterPair("kafdagesh", '\uFB3B');
            RegisterPair("kafdageshhebrew", '\uFB3B');
            RegisterPair("kaffinalarabic", '\uFEDA');
            RegisterPair("kafhebrew", '\u05DB');
            RegisterPair("kafinitialarabic", '\uFEDB');
            RegisterPair("kafmedialarabic", '\uFEDC');
            RegisterPair("kafrafehebrew", '\uFB4D');
            RegisterPair("kagujarati", '\u0A95');
            RegisterPair("kagurmukhi", '\u0A15');
            RegisterPair("kahiragana", '\u304B');
            RegisterPair("kahookcyrillic", '\u04C4');
            RegisterPair("kakatakana", '\u30AB');
            RegisterPair("kakatakanahalfwidth", '\uFF76');
            RegisterPair("kappa", '\u03BA');
            RegisterPair("kappasymbolgreek", '\u03F0');
            RegisterPair("kapyeounmieumkorean", '\u3171');
            RegisterPair("kapyeounphieuphkorean", '\u3184');
            RegisterPair("kapyeounpieupkorean", '\u3178');
            RegisterPair("kapyeounssangpieupkorean", '\u3179');
            RegisterPair("karoriisquare", '\u330D');
            RegisterPair("kashidaautoarabic", '\u0640');
            RegisterPair("kashidaautonosidebearingarabic", '\u0640');
            RegisterPair("kasmallkatakana", '\u30F5');
            RegisterPair("kasquare", '\u3384');
            RegisterPair("kasraarabic", '\u0650');
            RegisterPair("kasratanarabic", '\u064D');
            RegisterPair("kastrokecyrillic", '\u049F');
            RegisterPair("katahiraprolongmarkhalfwidth", '\uFF70');
            RegisterPair("kaverticalstrokecyrillic", '\u049D');
            RegisterPair("kbopomofo", '\u310E');
            RegisterPair("kcalsquare", '\u3389');
            RegisterPair("kcaron", '\u01E9');
            RegisterPair("kcedilla", '\u0137');
            RegisterPair("kcircle", '\u24DA');
            RegisterPair("kcommaaccent", '\u0137');
            RegisterPair("kdotbelow", '\u1E33');
            RegisterPair("keharmenian", '\u0584');
            RegisterPair("kehiragana", '\u3051');
            RegisterPair("kekatakana", '\u30B1');
            RegisterPair("kekatakanahalfwidth", '\uFF79');
            RegisterPair("kenarmenian", '\u056F');
            RegisterPair("kesmallkatakana", '\u30F6');
            RegisterPair("kgreenlandic", '\u0138');
            RegisterPair("khabengali", '\u0996');
            RegisterPair("khacyrillic", '\u0445');
            RegisterPair("khadeva", '\u0916');
            RegisterPair("khagujarati", '\u0A96');
            RegisterPair("khagurmukhi", '\u0A16');
            RegisterPair("khaharabic", '\u062E');
            RegisterPair("khahfinalarabic", '\uFEA6');
            RegisterPair("khahinitialarabic", '\uFEA7');
            RegisterPair("khahmedialarabic", '\uFEA8');
            RegisterPair("kheicoptic", '\u03E7');
            RegisterPair("khhadeva", '\u0959');
            RegisterPair("khhagurmukhi", '\u0A59');
            RegisterPair("khieukhacirclekorean", '\u3278');
            RegisterPair("khieukhaparenkorean", '\u3218');
            RegisterPair("khieukhcirclekorean", '\u326A');
            RegisterPair("khieukhkorean", '\u314B');
            RegisterPair("khieukhparenkorean", '\u320A');
            RegisterPair("khokhaithai", '\u0E02');
            RegisterPair("khokhonthai", '\u0E05');
            RegisterPair("khokhuatthai", '\u0E03');
            RegisterPair("khokhwaithai", '\u0E04');
            RegisterPair("khomutthai", '\u0E5B');
            RegisterPair("khook", '\u0199');
            RegisterPair("khorakhangthai", '\u0E06');
            RegisterPair("khzsquare", '\u3391');
            RegisterPair("kihiragana", '\u304D');
            RegisterPair("kikatakana", '\u30AD');
            RegisterPair("kikatakanahalfwidth", '\uFF77');
            RegisterPair("kiroguramusquare", '\u3315');
            RegisterPair("kiromeetorusquare", '\u3316');
            RegisterPair("kirosquare", '\u3314');
            RegisterPair("kiyeokacirclekorean", '\u326E');
            RegisterPair("kiyeokaparenkorean", '\u320E');
            RegisterPair("kiyeokcirclekorean", '\u3260');
            RegisterPair("kiyeokkorean", '\u3131');
            RegisterPair("kiyeokparenkorean", '\u3200');
            RegisterPair("kiyeoksioskorean", '\u3133');
            RegisterPair("kjecyrillic", '\u045C');
            RegisterPair("klinebelow", '\u1E35');
            RegisterPair("klsquare", '\u3398');
            RegisterPair("kmcubedsquare", '\u33A6');
            RegisterPair("kmonospace", '\uFF4B');
            RegisterPair("kmsquaredsquare", '\u33A2');
            RegisterPair("kohiragana", '\u3053');
            RegisterPair("kohmsquare", '\u33C0');
            RegisterPair("kokaithai", '\u0E01');
            RegisterPair("kokatakana", '\u30B3');
            RegisterPair("kokatakanahalfwidth", '\uFF7A');
            RegisterPair("kooposquare", '\u331E');
            RegisterPair("koppacyrillic", '\u0481');
            RegisterPair("koreanstandardsymbol", '\u327F');
            RegisterPair("koroniscmb", '\u0343');
            RegisterPair("kparen", '\u24A6');
            RegisterPair("kpasquare", '\u33AA');
            RegisterPair("ksicyrillic", '\u046F');
            RegisterPair("ktsquare", '\u33CF');
            RegisterPair("kturned", '\u029E');
            RegisterPair("kuhiragana", '\u304F');
            RegisterPair("kukatakana", '\u30AF');
            RegisterPair("kukatakanahalfwidth", '\uFF78');
            RegisterPair("kvsquare", '\u33B8');
            RegisterPair("kwsquare", '\u33BE');
            RegisterPair("l", '\u006C');
            RegisterPair("labengali", '\u09B2');
            RegisterPair("lacute", '\u013A');
            RegisterPair("ladeva", '\u0932');
            RegisterPair("lagujarati", '\u0AB2');
            RegisterPair("lagurmukhi", '\u0A32');
            RegisterPair("lakkhangyaothai", '\u0E45');
            RegisterPair("lamaleffinalarabic", '\uFEFC');
            RegisterPair("lamalefhamzaabovefinalarabic", '\uFEF8');
            RegisterPair("lamalefhamzaaboveisolatedarabic", '\uFEF7');
            RegisterPair("lamalefhamzabelowfinalarabic", '\uFEFA');
            RegisterPair("lamalefhamzabelowisolatedarabic", '\uFEF9');
            RegisterPair("lamalefisolatedarabic", '\uFEFB');
            RegisterPair("lamalefmaddaabovefinalarabic", '\uFEF6');
            RegisterPair("lamalefmaddaaboveisolatedarabic", '\uFEF5');
            RegisterPair("lamarabic", '\u0644');
            RegisterPair("lambda", '\u03BB');
            RegisterPair("lambdastroke", '\u019B');
            RegisterPair("lamed", '\u05DC');
            RegisterPair("lameddagesh", '\uFB3C');
            RegisterPair("lameddageshhebrew", '\uFB3C');
            RegisterPair("lamedhebrew", '\u05DC');
            //RegisterPair("lamedholam", '\u05DC\u05B9');
            //RegisterPair("lamedholamdagesh", '\u05DC\u05B9\u05BC');
            //RegisterPair("lamedholamdageshhebrew", '\u05DC\u05B9\u05BC');
            //RegisterPair("lamedholamhebrew", '\u05DC\u05B9');
            RegisterPair("lamfinalarabic", '\uFEDE');
            RegisterPair("lamhahinitialarabic", '\uFCCA');
            RegisterPair("laminitialarabic", '\uFEDF');
            RegisterPair("lamjeeminitialarabic", '\uFCC9');
            RegisterPair("lamkhahinitialarabic", '\uFCCB');
            RegisterPair("lamlamhehisolatedarabic", '\uFDF2');
            RegisterPair("lammedialarabic", '\uFEE0');
            RegisterPair("lammeemhahinitialarabic", '\uFD88');
            RegisterPair("lammeeminitialarabic", '\uFCCC');
            //RegisterPair("lammeemjeeminitialarabic", '\uFEDF\uFEE4\uFEA0');
            //RegisterPair("lammeemkhahinitialarabic", '\uFEDF\uFEE4\uFEA8');
            RegisterPair("largecircle", '\u25EF');
            RegisterPair("lbar", '\u019A');
            RegisterPair("lbelt", '\u026C');
            RegisterPair("lbopomofo", '\u310C');
            RegisterPair("lcaron", '\u013E');
            RegisterPair("lcedilla", '\u013C');
            RegisterPair("lcircle", '\u24DB');
            RegisterPair("lcircumflexbelow", '\u1E3D');
            RegisterPair("lcommaaccent", '\u013C');
            RegisterPair("ldot", '\u0140');
            RegisterPair("ldotaccent", '\u0140');
            RegisterPair("ldotbelow", '\u1E37');
            RegisterPair("ldotbelowmacron", '\u1E39');
            RegisterPair("leftangleabovecmb", '\u031A');
            RegisterPair("lefttackbelowcmb", '\u0318');
            RegisterPair("less", '\u003C');
            RegisterPair("lessequal", '\u2264');
            RegisterPair("lessequalorgreater", '\u22DA');
            RegisterPair("lessmonospace", '\uFF1C');
            RegisterPair("lessorequivalent", '\u2272');
            RegisterPair("lessorgreater", '\u2276');
            RegisterPair("lessoverequal", '\u2266');
            RegisterPair("lesssmall", '\uFE64');
            RegisterPair("lezh", '\u026E');
            RegisterPair("lfblock", '\u258C');
            RegisterPair("lhookretroflex", '\u026D');
            RegisterPair("lira", '\u20A4');
            RegisterPair("liwnarmenian", '\u056C');
            RegisterPair("lj", '\u01C9');
            RegisterPair("ljecyrillic", '\u0459');
            RegisterPair("ll", '\uF6C0');
            RegisterPair("lladeva", '\u0933');
            RegisterPair("llagujarati", '\u0AB3');
            RegisterPair("llinebelow", '\u1E3B');
            RegisterPair("llladeva", '\u0934');
            RegisterPair("llvocalicbengali", '\u09E1');
            RegisterPair("llvocalicdeva", '\u0961');
            RegisterPair("llvocalicvowelsignbengali", '\u09E3');
            RegisterPair("llvocalicvowelsigndeva", '\u0963');
            RegisterPair("lmiddletilde", '\u026B');
            RegisterPair("lmonospace", '\uFF4C');
            RegisterPair("lmsquare", '\u33D0');
            RegisterPair("lochulathai", '\u0E2C');
            RegisterPair("logicaland", '\u2227');
            RegisterPair("logicalnot", '\u00AC');
            RegisterPair("logicalnotreversed", '\u2310');
            RegisterPair("logicalor", '\u2228');
            RegisterPair("lolingthai", '\u0E25');
            RegisterPair("longs", '\u017F');
            RegisterPair("lowlinecenterline", '\uFE4E');
            RegisterPair("lowlinecmb", '\u0332');
            RegisterPair("lowlinedashed", '\uFE4D');
            RegisterPair("lozenge", '\u25CA');
            RegisterPair("lparen", '\u24A7');
            RegisterPair("lslash", '\u0142');
            RegisterPair("lsquare", '\u2113');
            RegisterPair("lsuperior", '\uF6EE');
            RegisterPair("ltshade", '\u2591');
            RegisterPair("luthai", '\u0E26');
            RegisterPair("lvocalicbengali", '\u098C');
            RegisterPair("lvocalicdeva", '\u090C');
            RegisterPair("lvocalicvowelsignbengali", '\u09E2');
            RegisterPair("lvocalicvowelsigndeva", '\u0962');
            RegisterPair("lxsquare", '\u33D3');
            RegisterPair("m", '\u006D');
            RegisterPair("mabengali", '\u09AE');
            RegisterPair("macron", '\u00AF');
            RegisterPair("macronbelowcmb", '\u0331');
            RegisterPair("macroncmb", '\u0304');
            RegisterPair("macronlowmod", '\u02CD');
            RegisterPair("macronmonospace", '\uFFE3');
            RegisterPair("macute", '\u1E3F');
            RegisterPair("madeva", '\u092E');
            RegisterPair("magujarati", '\u0AAE');
            RegisterPair("magurmukhi", '\u0A2E');
            RegisterPair("mahapakhhebrew", '\u05A4');
            RegisterPair("mahapakhlefthebrew", '\u05A4');
            RegisterPair("mahiragana", '\u307E');
            RegisterPair("maichattawalowleftthai", '\uF895');
            RegisterPair("maichattawalowrightthai", '\uF894');
            RegisterPair("maichattawathai", '\u0E4B');
            RegisterPair("maichattawaupperleftthai", '\uF893');
            RegisterPair("maieklowleftthai", '\uF88C');
            RegisterPair("maieklowrightthai", '\uF88B');
            RegisterPair("maiekthai", '\u0E48');
            RegisterPair("maiekupperleftthai", '\uF88A');
            RegisterPair("maihanakatleftthai", '\uF884');
            RegisterPair("maihanakatthai", '\u0E31');
            RegisterPair("maitaikhuleftthai", '\uF889');
            RegisterPair("maitaikhuthai", '\u0E47');
            RegisterPair("maitholowleftthai", '\uF88F');
            RegisterPair("maitholowrightthai", '\uF88E');
            RegisterPair("maithothai", '\u0E49');
            RegisterPair("maithoupperleftthai", '\uF88D');
            RegisterPair("maitrilowleftthai", '\uF892');
            RegisterPair("maitrilowrightthai", '\uF891');
            RegisterPair("maitrithai", '\u0E4A');
            RegisterPair("maitriupperleftthai", '\uF890');
            RegisterPair("maiyamokthai", '\u0E46');
            RegisterPair("makatakana", '\u30DE');
            RegisterPair("makatakanahalfwidth", '\uFF8F');
            RegisterPair("male", '\u2642');
            RegisterPair("mansyonsquare", '\u3347');
            RegisterPair("maqafhebrew", '\u05BE');
            RegisterPair("mars", '\u2642');
            RegisterPair("masoracirclehebrew", '\u05AF');
            RegisterPair("masquare", '\u3383');
            RegisterPair("mbopomofo", '\u3107');
            RegisterPair("mbsquare", '\u33D4');
            RegisterPair("mcircle", '\u24DC');
            RegisterPair("mcubedsquare", '\u33A5');
            RegisterPair("mdotaccent", '\u1E41');
            RegisterPair("mdotbelow", '\u1E43');
            RegisterPair("meemarabic", '\u0645');
            RegisterPair("meemfinalarabic", '\uFEE2');
            RegisterPair("meeminitialarabic", '\uFEE3');
            RegisterPair("meemmedialarabic", '\uFEE4');
            RegisterPair("meemmeeminitialarabic", '\uFCD1');
            RegisterPair("meemmeemisolatedarabic", '\uFC48');
            RegisterPair("meetorusquare", '\u334D');
            RegisterPair("mehiragana", '\u3081');
            RegisterPair("meizierasquare", '\u337E');
            RegisterPair("mekatakana", '\u30E1');
            RegisterPair("mekatakanahalfwidth", '\uFF92');
            RegisterPair("mem", '\u05DE');
            RegisterPair("memdagesh", '\uFB3E');
            RegisterPair("memdageshhebrew", '\uFB3E');
            RegisterPair("memhebrew", '\u05DE');
            RegisterPair("menarmenian", '\u0574');
            RegisterPair("merkhahebrew", '\u05A5');
            RegisterPair("merkhakefulahebrew", '\u05A6');
            RegisterPair("merkhakefulalefthebrew", '\u05A6');
            RegisterPair("merkhalefthebrew", '\u05A5');
            RegisterPair("mhook", '\u0271');
            RegisterPair("mhzsquare", '\u3392');
            RegisterPair("middledotkatakanahalfwidth", '\uFF65');
            RegisterPair("middot", '\u00B7');
            RegisterPair("mieumacirclekorean", '\u3272');
            RegisterPair("mieumaparenkorean", '\u3212');
            RegisterPair("mieumcirclekorean", '\u3264');
            RegisterPair("mieumkorean", '\u3141');
            RegisterPair("mieumpansioskorean", '\u3170');
            RegisterPair("mieumparenkorean", '\u3204');
            RegisterPair("mieumpieupkorean", '\u316E');
            RegisterPair("mieumsioskorean", '\u316F');
            RegisterPair("mihiragana", '\u307F');
            RegisterPair("mikatakana", '\u30DF');
            RegisterPair("mikatakanahalfwidth", '\uFF90');
            RegisterPair("hyphen", '-');
            RegisterPair("minus", '\u2212');
            RegisterPair("minusbelowcmb", '\u0320');
            RegisterPair("minuscircle", '\u2296');
            RegisterPair("minusmod", '\u02D7');
            RegisterPair("minusplus", '\u2213');
            RegisterPair("minute", '\u2032');
            RegisterPair("miribaarusquare", '\u334A');
            RegisterPair("mirisquare", '\u3349');
            RegisterPair("mlonglegturned", '\u0270');
            RegisterPair("mlsquare", '\u3396');
            RegisterPair("mmcubedsquare", '\u33A3');
            RegisterPair("mmonospace", '\uFF4D');
            RegisterPair("mmsquaredsquare", '\u339F');
            RegisterPair("mohiragana", '\u3082');
            RegisterPair("mohmsquare", '\u33C1');
            RegisterPair("mokatakana", '\u30E2');
            RegisterPair("mokatakanahalfwidth", '\uFF93');
            RegisterPair("molsquare", '\u33D6');
            RegisterPair("momathai", '\u0E21');
            RegisterPair("moverssquare", '\u33A7');
            RegisterPair("moverssquaredsquare", '\u33A8');
            RegisterPair("mparen", '\u24A8');
            RegisterPair("mpasquare", '\u33AB');
            RegisterPair("mssquare", '\u33B3');
            RegisterPair("msuperior", '\uF6EF');
            RegisterPair("mturned", '\u026F');
            RegisterPair("mu", '\u00B5');
            RegisterPair("mu1", '\u00B5');
            RegisterPair("muasquare", '\u3382');
            RegisterPair("muchgreater", '\u226B');
            RegisterPair("muchless", '\u226A');
            RegisterPair("mufsquare", '\u338C');
            RegisterPair("mugreek", '\u03BC');
            RegisterPair("mugsquare", '\u338D');
            RegisterPair("muhiragana", '\u3080');
            RegisterPair("mukatakana", '\u30E0');
            RegisterPair("mukatakanahalfwidth", '\uFF91');
            RegisterPair("mulsquare", '\u3395');
            RegisterPair("multiply", '\u00D7');
            RegisterPair("mumsquare", '\u339B');
            RegisterPair("munahhebrew", '\u05A3');
            RegisterPair("munahlefthebrew", '\u05A3');
            RegisterPair("musicalnote", '\u266A');
            RegisterPair("musicalnotedbl", '\u266B');
            RegisterPair("musicflatsign", '\u266D');
            RegisterPair("musicsharpsign", '\u266F');
            RegisterPair("mussquare", '\u33B2');
            RegisterPair("muvsquare", '\u33B6');
            RegisterPair("muwsquare", '\u33BC');
            RegisterPair("mvmegasquare", '\u33B9');
            RegisterPair("mvsquare", '\u33B7');
            RegisterPair("mwmegasquare", '\u33BF');
            RegisterPair("mwsquare", '\u33BD');
            RegisterPair("n", '\u006E');
            RegisterPair("nabengali", '\u09A8');
            RegisterPair("nabla", '\u2207');
            RegisterPair("nacute", '\u0144');
            RegisterPair("nadeva", '\u0928');
            RegisterPair("nagujarati", '\u0AA8');
            RegisterPair("nagurmukhi", '\u0A28');
            RegisterPair("nahiragana", '\u306A');
            RegisterPair("nakatakana", '\u30CA');
            RegisterPair("nakatakanahalfwidth", '\uFF85');
            RegisterPair("napostrophe", '\u0149');
            RegisterPair("nasquare", '\u3381');
            RegisterPair("nbopomofo", '\u310B');
            RegisterPair("nbspace", '\u00A0');
            RegisterPair("ncaron", '\u0148');
            RegisterPair("ncedilla", '\u0146');
            RegisterPair("ncircle", '\u24DD');
            RegisterPair("ncircumflexbelow", '\u1E4B');
            RegisterPair("ncommaaccent", '\u0146');
            RegisterPair("ndotaccent", '\u1E45');
            RegisterPair("ndotbelow", '\u1E47');
            RegisterPair("nehiragana", '\u306D');
            RegisterPair("nekatakana", '\u30CD');
            RegisterPair("nekatakanahalfwidth", '\uFF88');
            RegisterPair("newsheqelsign", '\u20AA');
            RegisterPair("nfsquare", '\u338B');
            RegisterPair("ngabengali", '\u0999');
            RegisterPair("ngadeva", '\u0919');
            RegisterPair("ngagujarati", '\u0A99');
            RegisterPair("ngagurmukhi", '\u0A19');
            RegisterPair("ngonguthai", '\u0E07');
            RegisterPair("nhiragana", '\u3093');
            RegisterPair("nhookleft", '\u0272');
            RegisterPair("nhookretroflex", '\u0273');
            RegisterPair("nieunacirclekorean", '\u326F');
            RegisterPair("nieunaparenkorean", '\u320F');
            RegisterPair("nieuncieuckorean", '\u3135');
            RegisterPair("nieuncirclekorean", '\u3261');
            RegisterPair("nieunhieuhkorean", '\u3136');
            RegisterPair("nieunkorean", '\u3134');
            RegisterPair("nieunpansioskorean", '\u3168');
            RegisterPair("nieunparenkorean", '\u3201');
            RegisterPair("nieunsioskorean", '\u3167');
            RegisterPair("nieuntikeutkorean", '\u3166');
            RegisterPair("nihiragana", '\u306B');
            RegisterPair("nikatakana", '\u30CB');
            RegisterPair("nikatakanahalfwidth", '\uFF86');
            RegisterPair("nikhahitleftthai", '\uF899');
            RegisterPair("nikhahitthai", '\u0E4D');
            RegisterPair("nine", '\u0039');
            RegisterPair("ninearabic", '\u0669');
            RegisterPair("ninebengali", '\u09EF');
            RegisterPair("ninecircle", '\u2468');
            RegisterPair("ninecircleinversesansserif", '\u2792');
            RegisterPair("ninedeva", '\u096F');
            RegisterPair("ninegujarati", '\u0AEF');
            RegisterPair("ninegurmukhi", '\u0A6F');
            RegisterPair("ninehackarabic", '\u0669');
            RegisterPair("ninehangzhou", '\u3029');
            RegisterPair("nineideographicparen", '\u3228');
            RegisterPair("nineinferior", '\u2089');
            RegisterPair("ninemonospace", '\uFF19');
            RegisterPair("nineoldstyle", '\uF739');
            RegisterPair("nineparen", '\u247C');
            RegisterPair("nineperiod", '\u2490');
            RegisterPair("ninepersian", '\u06F9');
            RegisterPair("nineroman", '\u2178');
            RegisterPair("ninesuperior", '\u2079');
            RegisterPair("nineteencircle", '\u2472');
            RegisterPair("nineteenparen", '\u2486');
            RegisterPair("nineteenperiod", '\u249A');
            RegisterPair("ninethai", '\u0E59');
            RegisterPair("nj", '\u01CC');
            RegisterPair("njecyrillic", '\u045A');
            RegisterPair("nkatakana", '\u30F3');
            RegisterPair("nkatakanahalfwidth", '\uFF9D');
            RegisterPair("nlegrightlong", '\u019E');
            RegisterPair("nlinebelow", '\u1E49');
            RegisterPair("nmonospace", '\uFF4E');
            RegisterPair("nmsquare", '\u339A');
            RegisterPair("nnabengali", '\u09A3');
            RegisterPair("nnadeva", '\u0923');
            RegisterPair("nnagujarati", '\u0AA3');
            RegisterPair("nnagurmukhi", '\u0A23');
            RegisterPair("nnnadeva", '\u0929');
            RegisterPair("nohiragana", '\u306E');
            RegisterPair("nokatakana", '\u30CE');
            RegisterPair("nokatakanahalfwidth", '\uFF89');
            RegisterPair("nonbreakingspace", '\u00A0');
            RegisterPair("nonenthai", '\u0E13');
            RegisterPair("nonuthai", '\u0E19');
            RegisterPair("noonarabic", '\u0646');
            RegisterPair("noonfinalarabic", '\uFEE6');
            RegisterPair("noonghunnaarabic", '\u06BA');
            RegisterPair("noonghunnafinalarabic", '\uFB9F');
            //RegisterPair("noonhehinitialarabic", '\uFEE7\uFEEC');
            RegisterPair("nooninitialarabic", '\uFEE7');
            RegisterPair("noonjeeminitialarabic", '\uFCD2');
            RegisterPair("noonjeemisolatedarabic", '\uFC4B');
            RegisterPair("noonmedialarabic", '\uFEE8');
            RegisterPair("noonmeeminitialarabic", '\uFCD5');
            RegisterPair("noonmeemisolatedarabic", '\uFC4E');
            RegisterPair("noonnoonfinalarabic", '\uFC8D');
            RegisterPair("notcontains", '\u220C');
            RegisterPair("notelement", '\u2209');
            RegisterPair("notelementof", '\u2209');
            RegisterPair("notequal", '\u2260');
            RegisterPair("notgreater", '\u226F');
            RegisterPair("notgreaternorequal", '\u2271');
            RegisterPair("notgreaternorless", '\u2279');
            RegisterPair("notidentical", '\u2262');
            RegisterPair("notless", '\u226E');
            RegisterPair("notlessnorequal", '\u2270');
            RegisterPair("notparallel", '\u2226');
            RegisterPair("notprecedes", '\u2280');
            RegisterPair("notsubset", '\u2284');
            RegisterPair("notsucceeds", '\u2281');
            RegisterPair("notsuperset", '\u2285');
            RegisterPair("nowarmenian", '\u0576');
            RegisterPair("nparen", '\u24A9');
            RegisterPair("nssquare", '\u33B1');
            RegisterPair("nsuperior", '\u207F');
            RegisterPair("ntilde", '\u00F1');
            RegisterPair("nu", '\u03BD');
            RegisterPair("nuhiragana", '\u306C');
            RegisterPair("nukatakana", '\u30CC');
            RegisterPair("nukatakanahalfwidth", '\uFF87');
            RegisterPair("nuktabengali", '\u09BC');
            RegisterPair("nuktadeva", '\u093C');
            RegisterPair("nuktagujarati", '\u0ABC');
            RegisterPair("nuktagurmukhi", '\u0A3C');
            RegisterPair("numbersign", '\u0023');
            RegisterPair("numbersignmonospace", '\uFF03');
            RegisterPair("numbersignsmall", '\uFE5F');
            RegisterPair("numeralsigngreek", '\u0374');
            RegisterPair("numeralsignlowergreek", '\u0375');
            RegisterPair("numero", '\u2116');
            RegisterPair("nun", '\u05E0');
            RegisterPair("nundagesh", '\uFB40');
            RegisterPair("nundageshhebrew", '\uFB40');
            RegisterPair("nunhebrew", '\u05E0');
            RegisterPair("nvsquare", '\u33B5');
            RegisterPair("nwsquare", '\u33BB');
            RegisterPair("nyabengali", '\u099E');
            RegisterPair("nyadeva", '\u091E');
            RegisterPair("nyagujarati", '\u0A9E');
            RegisterPair("nyagurmukhi", '\u0A1E');
            RegisterPair("o", '\u006F');
            RegisterPair("oacute", '\u00F3');
            RegisterPair("oangthai", '\u0E2D');
            RegisterPair("obarred", '\u0275');
            RegisterPair("obarredcyrillic", '\u04E9');
            RegisterPair("obarreddieresiscyrillic", '\u04EB');
            RegisterPair("obengali", '\u0993');
            RegisterPair("obopomofo", '\u311B');
            RegisterPair("obreve", '\u014F');
            RegisterPair("ocandradeva", '\u0911');
            RegisterPair("ocandragujarati", '\u0A91');
            RegisterPair("ocandravowelsigndeva", '\u0949');
            RegisterPair("ocandravowelsigngujarati", '\u0AC9');
            RegisterPair("ocaron", '\u01D2');
            RegisterPair("ocircle", '\u24DE');
            RegisterPair("ocircumflex", '\u00F4');
            RegisterPair("ocircumflexacute", '\u1ED1');
            RegisterPair("ocircumflexdotbelow", '\u1ED9');
            RegisterPair("ocircumflexgrave", '\u1ED3');
            RegisterPair("ocircumflexhookabove", '\u1ED5');
            RegisterPair("ocircumflextilde", '\u1ED7');
            RegisterPair("ocyrillic", '\u043E');
            RegisterPair("odblacute", '\u0151');
            RegisterPair("odblgrave", '\u020D');
            RegisterPair("odeva", '\u0913');
            RegisterPair("odieresis", '\u00F6');
            RegisterPair("odieresiscyrillic", '\u04E7');
            RegisterPair("odotbelow", '\u1ECD');
            RegisterPair("oe", '\u0153');
            RegisterPair("oekorean", '\u315A');
            RegisterPair("ogonek", '\u02DB');
            RegisterPair("ogonekcmb", '\u0328');
            RegisterPair("ograve", '\u00F2');
            RegisterPair("ogujarati", '\u0A93');
            RegisterPair("oharmenian", '\u0585');
            RegisterPair("ohiragana", '\u304A');
            RegisterPair("ohookabove", '\u1ECF');
            RegisterPair("ohorn", '\u01A1');
            RegisterPair("ohornacute", '\u1EDB');
            RegisterPair("ohorndotbelow", '\u1EE3');
            RegisterPair("ohorngrave", '\u1EDD');
            RegisterPair("ohornhookabove", '\u1EDF');
            RegisterPair("ohorntilde", '\u1EE1');
            RegisterPair("ohungarumlaut", '\u0151');
            RegisterPair("oi", '\u01A3');
            RegisterPair("oinvertedbreve", '\u020F');
            RegisterPair("okatakana", '\u30AA');
            RegisterPair("okatakanahalfwidth", '\uFF75');
            RegisterPair("okorean", '\u3157');
            RegisterPair("olehebrew", '\u05AB');
            RegisterPair("omacron", '\u014D');
            RegisterPair("omacronacute", '\u1E53');
            RegisterPair("omacrongrave", '\u1E51');
            RegisterPair("omdeva", '\u0950');
            RegisterPair("omega", '\u03C9');
            RegisterPair("omega1", '\u03D6');
            RegisterPair("omegacyrillic", '\u0461');
            RegisterPair("omegalatinclosed", '\u0277');
            RegisterPair("omegaroundcyrillic", '\u047B');
            RegisterPair("omegatitlocyrillic", '\u047D');
            RegisterPair("omegatonos", '\u03CE');
            RegisterPair("omgujarati", '\u0AD0');
            RegisterPair("omicron", '\u03BF');
            RegisterPair("omicrontonos", '\u03CC');
            RegisterPair("omonospace", '\uFF4F');
            RegisterPair("one", '\u0031');
            RegisterPair("onearabic", '\u0661');
            RegisterPair("onebengali", '\u09E7');
            RegisterPair("onecircle", '\u2460');
            RegisterPair("onecircleinversesansserif", '\u278A');
            RegisterPair("onedeva", '\u0967');
            RegisterPair("onedotenleader", '\u2024');
            RegisterPair("oneeighth", '\u215B');
            RegisterPair("onefitted", '\uF6DC');
            RegisterPair("onegujarati", '\u0AE7');
            RegisterPair("onegurmukhi", '\u0A67');
            RegisterPair("onehackarabic", '\u0661');
            RegisterPair("onehalf", '\u00BD');
            RegisterPair("onehangzhou", '\u3021');
            RegisterPair("oneideographicparen", '\u3220');
            RegisterPair("oneinferior", '\u2081');
            RegisterPair("onemonospace", '\uFF11');
            RegisterPair("onenumeratorbengali", '\u09F4');
            RegisterPair("oneoldstyle", '\uF731');
            RegisterPair("oneparen", '\u2474');
            RegisterPair("oneperiod", '\u2488');
            RegisterPair("onepersian", '\u06F1');
            RegisterPair("onequarter", '\u00BC');
            RegisterPair("oneroman", '\u2170');
            RegisterPair("onesuperior", '\u00B9');
            RegisterPair("onethai", '\u0E51');
            RegisterPair("onethird", '\u2153');
            RegisterPair("oogonek", '\u01EB');
            RegisterPair("oogonekmacron", '\u01ED');
            RegisterPair("oogurmukhi", '\u0A13');
            RegisterPair("oomatragurmukhi", '\u0A4B');
            RegisterPair("oopen", '\u0254');
            RegisterPair("oparen", '\u24AA');
            RegisterPair("openbullet", '\u25E6');
            RegisterPair("option", '\u2325');
            RegisterPair("ordfeminine", '\u00AA');
            RegisterPair("ordmasculine", '\u00BA');
            RegisterPair("orthogonal", '\u221F');
            RegisterPair("oshortdeva", '\u0912');
            RegisterPair("oshortvowelsigndeva", '\u094A');
            RegisterPair("oslash", '\u00F8');
            RegisterPair("oslashacute", '\u01FF');
            RegisterPair("osmallhiragana", '\u3049');
            RegisterPair("osmallkatakana", '\u30A9');
            RegisterPair("osmallkatakanahalfwidth", '\uFF6B');
            RegisterPair("ostrokeacute", '\u01FF');
            RegisterPair("osuperior", '\uF6F0');
            RegisterPair("otcyrillic", '\u047F');
            RegisterPair("otilde", '\u00F5');
            RegisterPair("otildeacute", '\u1E4D');
            RegisterPair("otildedieresis", '\u1E4F');
            RegisterPair("oubopomofo", '\u3121');
            RegisterPair("overline", '\u203E');
            RegisterPair("overlinecenterline", '\uFE4A');
            RegisterPair("overlinecmb", '\u0305');
            RegisterPair("overlinedashed", '\uFE49');
            RegisterPair("overlinedblwavy", '\uFE4C');
            RegisterPair("overlinewavy", '\uFE4B');
            RegisterPair("overscore", '\u00AF');
            RegisterPair("ovowelsignbengali", '\u09CB');
            RegisterPair("ovowelsigndeva", '\u094B');
            RegisterPair("ovowelsigngujarati", '\u0ACB');
            RegisterPair("p", '\u0070');
            RegisterPair("paampssquare", '\u3380');
            RegisterPair("paasentosquare", '\u332B');
            RegisterPair("pabengali", '\u09AA');
            RegisterPair("pacute", '\u1E55');
            RegisterPair("padeva", '\u092A');
            RegisterPair("pagedown", '\u21DF');
            RegisterPair("pageup", '\u21DE');
            RegisterPair("pagujarati", '\u0AAA');
            RegisterPair("pagurmukhi", '\u0A2A');
            RegisterPair("pahiragana", '\u3071');
            RegisterPair("paiyannoithai", '\u0E2F');
            RegisterPair("pakatakana", '\u30D1');
            RegisterPair("palatalizationcyrilliccmb", '\u0484');
            RegisterPair("palochkacyrillic", '\u04C0');
            RegisterPair("pansioskorean", '\u317F');
            RegisterPair("paragraph", '\u00B6');
            RegisterPair("parallel", '\u2225');
            RegisterPair("parenleft", '\u0028');
            RegisterPair("parenleftaltonearabic", '\uFD3E');
            RegisterPair("parenleftbt", '\uF8ED');
            RegisterPair("parenleftex", '\uF8EC');
            RegisterPair("parenleftinferior", '\u208D');
            RegisterPair("parenleftmonospace", '\uFF08');
            RegisterPair("parenleftsmall", '\uFE59');
            RegisterPair("parenleftsuperior", '\u207D');
            RegisterPair("parenlefttp", '\uF8EB');
            RegisterPair("parenleftvertical", '\uFE35');
            RegisterPair("parenright", '\u0029');
            RegisterPair("parenrightaltonearabic", '\uFD3F');
            RegisterPair("parenrightbt", '\uF8F8');
            RegisterPair("parenrightex", '\uF8F7');
            RegisterPair("parenrightinferior", '\u208E');
            RegisterPair("parenrightmonospace", '\uFF09');
            RegisterPair("parenrightsmall", '\uFE5A');
            RegisterPair("parenrightsuperior", '\u207E');
            RegisterPair("parenrighttp", '\uF8F6');
            RegisterPair("parenrightvertical", '\uFE36');
            RegisterPair("partialdiff", '\u2202');
            RegisterPair("paseqhebrew", '\u05C0');
            RegisterPair("pashtahebrew", '\u0599');
            RegisterPair("pasquare", '\u33A9');
            RegisterPair("patah", '\u05B7');
            RegisterPair("patah11", '\u05B7');
            RegisterPair("patah1d", '\u05B7');
            RegisterPair("patah2a", '\u05B7');
            RegisterPair("patahhebrew", '\u05B7');
            RegisterPair("patahnarrowhebrew", '\u05B7');
            RegisterPair("patahquarterhebrew", '\u05B7');
            RegisterPair("patahwidehebrew", '\u05B7');
            RegisterPair("pazerhebrew", '\u05A1');
            RegisterPair("pbopomofo", '\u3106');
            RegisterPair("pcircle", '\u24DF');
            RegisterPair("pdotaccent", '\u1E57');
            RegisterPair("pe", '\u05E4');
            RegisterPair("pecyrillic", '\u043F');
            RegisterPair("pedagesh", '\uFB44');
            RegisterPair("pedageshhebrew", '\uFB44');
            RegisterPair("peezisquare", '\u333B');
            RegisterPair("pefinaldageshhebrew", '\uFB43');
            RegisterPair("peharabic", '\u067E');
            RegisterPair("peharmenian", '\u057A');
            RegisterPair("pehebrew", '\u05E4');
            RegisterPair("pehfinalarabic", '\uFB57');
            RegisterPair("pehinitialarabic", '\uFB58');
            RegisterPair("pehiragana", '\u307A');
            RegisterPair("pehmedialarabic", '\uFB59');
            RegisterPair("pekatakana", '\u30DA');
            RegisterPair("pemiddlehookcyrillic", '\u04A7');
            RegisterPair("perafehebrew", '\uFB4E');
            RegisterPair("percent", '\u0025');
            RegisterPair("percentarabic", '\u066A');
            RegisterPair("percentmonospace", '\uFF05');
            RegisterPair("percentsmall", '\uFE6A');
            RegisterPair("period", '\u002E');
            RegisterPair("periodarmenian", '\u0589');
            RegisterPair("periodcentered", '\u00B7');
            RegisterPair("periodhalfwidth", '\uFF61');
            RegisterPair("periodinferior", '\uF6E7');
            RegisterPair("periodmonospace", '\uFF0E');
            RegisterPair("periodsmall", '\uFE52');
            RegisterPair("periodsuperior", '\uF6E8');
            RegisterPair("perispomenigreekcmb", '\u0342');
            RegisterPair("perpendicular", '\u22A5');
            RegisterPair("perthousand", '\u2030');
            RegisterPair("peseta", '\u20A7');
            RegisterPair("pfsquare", '\u338A');
            RegisterPair("phabengali", '\u09AB');
            RegisterPair("phadeva", '\u092B');
            RegisterPair("phagujarati", '\u0AAB');
            RegisterPair("phagurmukhi", '\u0A2B');
            RegisterPair("phi", '\u03C6');
            RegisterPair("phi1", '\u03D5');
            RegisterPair("phieuphacirclekorean", '\u327A');
            RegisterPair("phieuphaparenkorean", '\u321A');
            RegisterPair("phieuphcirclekorean", '\u326C');
            RegisterPair("phieuphkorean", '\u314D');
            RegisterPair("phieuphparenkorean", '\u320C');
            RegisterPair("philatin", '\u0278');
            RegisterPair("phinthuthai", '\u0E3A');
            RegisterPair("phisymbolgreek", '\u03D5');
            RegisterPair("phook", '\u01A5');
            RegisterPair("phophanthai", '\u0E1E');
            RegisterPair("phophungthai", '\u0E1C');
            RegisterPair("phosamphaothai", '\u0E20');
            RegisterPair("pi", '\u03C0');
            RegisterPair("pieupacirclekorean", '\u3273');
            RegisterPair("pieupaparenkorean", '\u3213');
            RegisterPair("pieupcieuckorean", '\u3176');
            RegisterPair("pieupcirclekorean", '\u3265');
            RegisterPair("pieupkiyeokkorean", '\u3172');
            RegisterPair("pieupkorean", '\u3142');
            RegisterPair("pieupparenkorean", '\u3205');
            RegisterPair("pieupsioskiyeokkorean", '\u3174');
            RegisterPair("pieupsioskorean", '\u3144');
            RegisterPair("pieupsiostikeutkorean", '\u3175');
            RegisterPair("pieupthieuthkorean", '\u3177');
            RegisterPair("pieuptikeutkorean", '\u3173');
            RegisterPair("pihiragana", '\u3074');
            RegisterPair("pikatakana", '\u30D4');
            RegisterPair("pisymbolgreek", '\u03D6');
            RegisterPair("piwrarmenian", '\u0583');
            RegisterPair("plus", '\u002B');
            RegisterPair("plusbelowcmb", '\u031F');
            RegisterPair("pluscircle", '\u2295');
            RegisterPair("plusminus", '\u00B1');
            RegisterPair("plusmod", '\u02D6');
            RegisterPair("plusmonospace", '\uFF0B');
            RegisterPair("plussmall", '\uFE62');
            RegisterPair("plussuperior", '\u207A');
            RegisterPair("pmonospace", '\uFF50');
            RegisterPair("pmsquare", '\u33D8');
            RegisterPair("pohiragana", '\u307D');
            RegisterPair("pointingindexdownwhite", '\u261F');
            RegisterPair("pointingindexleftwhite", '\u261C');
            RegisterPair("pointingindexrightwhite", '\u261E');
            RegisterPair("pointingindexupwhite", '\u261D');
            RegisterPair("pokatakana", '\u30DD');
            RegisterPair("poplathai", '\u0E1B');
            RegisterPair("postalmark", '\u3012');
            RegisterPair("postalmarkface", '\u3020');
            RegisterPair("pparen", '\u24AB');
            RegisterPair("precedes", '\u227A');
            RegisterPair("prescription", '\u211E');
            RegisterPair("primemod", '\u02B9');
            RegisterPair("primereversed", '\u2035');
            RegisterPair("product", '\u220F');
            RegisterPair("projective", '\u2305');
            RegisterPair("prolongedkana", '\u30FC');
            RegisterPair("propellor", '\u2318');
            RegisterPair("propersubset", '\u2282');
            RegisterPair("propersuperset", '\u2283');
            RegisterPair("proportion", '\u2237');
            RegisterPair("proportional", '\u221D');
            RegisterPair("psi", '\u03C8');
            RegisterPair("psicyrillic", '\u0471');
            RegisterPair("psilipneumatacyrilliccmb", '\u0486');
            RegisterPair("pssquare", '\u33B0');
            RegisterPair("puhiragana", '\u3077');
            RegisterPair("pukatakana", '\u30D7');
            RegisterPair("pvsquare", '\u33B4');
            RegisterPair("pwsquare", '\u33BA');
            RegisterPair("q", '\u0071');
            RegisterPair("qadeva", '\u0958');
            RegisterPair("qadmahebrew", '\u05A8');
            RegisterPair("qafarabic", '\u0642');
            RegisterPair("qaffinalarabic", '\uFED6');
            RegisterPair("qafinitialarabic", '\uFED7');
            RegisterPair("qafmedialarabic", '\uFED8');
            RegisterPair("qamats", '\u05B8');
            RegisterPair("qamats10", '\u05B8');
            RegisterPair("qamats1a", '\u05B8');
            RegisterPair("qamats1c", '\u05B8');
            RegisterPair("qamats27", '\u05B8');
            RegisterPair("qamats29", '\u05B8');
            RegisterPair("qamats33", '\u05B8');
            RegisterPair("qamatsde", '\u05B8');
            RegisterPair("qamatshebrew", '\u05B8');
            RegisterPair("qamatsnarrowhebrew", '\u05B8');
            RegisterPair("qamatsqatanhebrew", '\u05B8');
            RegisterPair("qamatsqatannarrowhebrew", '\u05B8');
            RegisterPair("qamatsqatanquarterhebrew", '\u05B8');
            RegisterPair("qamatsqatanwidehebrew", '\u05B8');
            RegisterPair("qamatsquarterhebrew", '\u05B8');
            RegisterPair("qamatswidehebrew", '\u05B8');
            RegisterPair("qarneyparahebrew", '\u059F');
            RegisterPair("qbopomofo", '\u3111');
            RegisterPair("qcircle", '\u24E0');
            RegisterPair("qhook", '\u02A0');
            RegisterPair("qmonospace", '\uFF51');
            RegisterPair("qof", '\u05E7');
            RegisterPair("qofdagesh", '\uFB47');
            RegisterPair("qofdageshhebrew", '\uFB47');
            //RegisterPair("qofhatafpatah", '\u05E7\u05B2');
            //RegisterPair("qofhatafpatahhebrew", '\u05E7\u05B2');
            //RegisterPair("qofhatafsegol", '\u05E7\u05B1');
            //RegisterPair("qofhatafsegolhebrew", '\u05E7\u05B1');
            //RegisterPair("qofhebrew", '\u05E7');
            //RegisterPair("qofhiriq", '\u05E7\u05B4');
            //RegisterPair("qofhiriqhebrew", '\u05E7\u05B4');
            //RegisterPair("qofholam", '\u05E7\u05B9');
            //RegisterPair("qofholamhebrew", '\u05E7\u05B9');
            //RegisterPair("qofpatah", '\u05E7\u05B7');
            //RegisterPair("qofpatahhebrew", '\u05E7\u05B7');
            //RegisterPair("qofqamats", '\u05E7\u05B8');
            //RegisterPair("qofqamatshebrew", '\u05E7\u05B8');
            //RegisterPair("qofqubuts", '\u05E7\u05BB');
            //RegisterPair("qofqubutshebrew", '\u05E7\u05BB');
            //RegisterPair("qofsegol", '\u05E7\u05B6');
            //RegisterPair("qofsegolhebrew", '\u05E7\u05B6');
            //RegisterPair("qofsheva", '\u05E7\u05B0');
            //RegisterPair("qofshevahebrew", '\u05E7\u05B0');
            //RegisterPair("qoftsere", '\u05E7\u05B5');
            //RegisterPair("qoftserehebrew", '\u05E7\u05B5');
            RegisterPair("qparen", '\u24AC');
            RegisterPair("quarternote", '\u2669');
            RegisterPair("qubuts", '\u05BB');
            RegisterPair("qubuts18", '\u05BB');
            RegisterPair("qubuts25", '\u05BB');
            RegisterPair("qubuts31", '\u05BB');
            RegisterPair("qubutshebrew", '\u05BB');
            RegisterPair("qubutsnarrowhebrew", '\u05BB');
            RegisterPair("qubutsquarterhebrew", '\u05BB');
            RegisterPair("qubutswidehebrew", '\u05BB');
            RegisterPair("question", '\u003F');
            RegisterPair("questionarabic", '\u061F');
            RegisterPair("questionarmenian", '\u055E');
            RegisterPair("questiondown", '\u00BF');
            RegisterPair("questiondownsmall", '\uF7BF');
            RegisterPair("questiongreek", '\u037E');
            RegisterPair("questionmonospace", '\uFF1F');
            RegisterPair("questionsmall", '\uF73F');
            RegisterPair("quotedbl", '\u0022');
            RegisterPair("quotedblbase", '\u201E');
            RegisterPair("quotedblleft", '\u201C');
            RegisterPair("quotedblmonospace", '\uFF02');
            RegisterPair("quotedblprime", '\u301E');
            RegisterPair("quotedblprimereversed", '\u301D');
            RegisterPair("quotedblright", '\u201D');
            RegisterPair("quoteleft", '\u2018');
            RegisterPair("quoteleftreversed", '\u201B');
            RegisterPair("quotereversed", '\u201B');
            RegisterPair("quoteright", '\u2019');
            RegisterPair("quoterightn", '\u0149');
            RegisterPair("quotesinglbase", '\u201A');
            RegisterPair("quotesingle", '\u0027');
            RegisterPair("quotesinglemonospace", '\uFF07');
            RegisterPair("r", '\u0072');
            RegisterPair("raarmenian", '\u057C');
            RegisterPair("rabengali", '\u09B0');
            RegisterPair("racute", '\u0155');
            RegisterPair("radeva", '\u0930');
            RegisterPair("radical", '\u221A');
            RegisterPair("radicalex", '\uF8E5');
            RegisterPair("radoverssquare", '\u33AE');
            RegisterPair("radoverssquaredsquare", '\u33AF');
            RegisterPair("radsquare", '\u33AD');
            RegisterPair("rafe", '\u05BF');
            RegisterPair("rafehebrew", '\u05BF');
            RegisterPair("ragujarati", '\u0AB0');
            RegisterPair("ragurmukhi", '\u0A30');
            RegisterPair("rahiragana", '\u3089');
            RegisterPair("rakatakana", '\u30E9');
            RegisterPair("rakatakanahalfwidth", '\uFF97');
            RegisterPair("ralowerdiagonalbengali", '\u09F1');
            RegisterPair("ramiddlediagonalbengali", '\u09F0');
            RegisterPair("ramshorn", '\u0264');
            RegisterPair("ratio", '\u2236');
            RegisterPair("rbopomofo", '\u3116');
            RegisterPair("rcaron", '\u0159');
            RegisterPair("rcedilla", '\u0157');
            RegisterPair("rcircle", '\u24E1');
            RegisterPair("rcommaaccent", '\u0157');
            RegisterPair("rdblgrave", '\u0211');
            RegisterPair("rdotaccent", '\u1E59');
            RegisterPair("rdotbelow", '\u1E5B');
            RegisterPair("rdotbelowmacron", '\u1E5D');
            RegisterPair("referencemark", '\u203B');
            RegisterPair("reflexsubset", '\u2286');
            RegisterPair("reflexsuperset", '\u2287');
            RegisterPair("registered", '\u00AE');
            RegisterPair("registersans", '\uF8E8');
            RegisterPair("registerserif", '\uF6DA');
            RegisterPair("reharabic", '\u0631');
            RegisterPair("reharmenian", '\u0580');
            RegisterPair("rehfinalarabic", '\uFEAE');
            RegisterPair("rehiragana", '\u308C');
            //RegisterPair("rehyehaleflamarabic", '\u0631\uFEF3\uFE8E\u0644');
            RegisterPair("rekatakana", '\u30EC');
            RegisterPair("rekatakanahalfwidth", '\uFF9A');
            RegisterPair("resh", '\u05E8');
            RegisterPair("reshdageshhebrew", '\uFB48');
            //RegisterPair("reshhatafpatah", '\u05E8\u05B2');
            //RegisterPair("reshhatafpatahhebrew", '\u05E8\u05B2');
            //RegisterPair("reshhatafsegol", '\u05E8\u05B1');
            //RegisterPair("reshhatafsegolhebrew", '\u05E8\u05B1');
            RegisterPair("reshhebrew", '\u05E8');
            //RegisterPair("reshhiriq", '\u05E8\u05B4');
            //RegisterPair("reshhiriqhebrew", '\u05E8\u05B4');
            //RegisterPair("reshholam", '\u05E8\u05B9');
            //RegisterPair("reshholamhebrew", '\u05E8\u05B9');
            //RegisterPair("reshpatah", '\u05E8\u05B7');
            //RegisterPair("reshpatahhebrew", '\u05E8\u05B7');
            //RegisterPair("reshqamats", '\u05E8\u05B8');
            //RegisterPair("reshqamatshebrew", '\u05E8\u05B8');
            //RegisterPair("reshqubuts", '\u05E8\u05BB');
            //RegisterPair("reshqubutshebrew", '\u05E8\u05BB');
            //RegisterPair("reshsegol", '\u05E8\u05B6');
            //RegisterPair("reshsegolhebrew", '\u05E8\u05B6');
            //RegisterPair("reshsheva", '\u05E8\u05B0');
            //RegisterPair("reshshevahebrew", '\u05E8\u05B0');
            //RegisterPair("reshtsere", '\u05E8\u05B5');
            //RegisterPair("reshtserehebrew", '\u05E8\u05B5');
            RegisterPair("reversedtilde", '\u223D');
            RegisterPair("reviahebrew", '\u0597');
            RegisterPair("reviamugrashhebrew", '\u0597');
            RegisterPair("revlogicalnot", '\u2310');
            RegisterPair("rfishhook", '\u027E');
            RegisterPair("rfishhookreversed", '\u027F');
            RegisterPair("rhabengali", '\u09DD');
            RegisterPair("rhadeva", '\u095D');
            RegisterPair("rho", '\u03C1');
            RegisterPair("rhook", '\u027D');
            RegisterPair("rhookturned", '\u027B');
            RegisterPair("rhookturnedsuperior", '\u02B5');
            RegisterPair("rhosymbolgreek", '\u03F1');
            RegisterPair("rhotichookmod", '\u02DE');
            RegisterPair("rieulacirclekorean", '\u3271');
            RegisterPair("rieulaparenkorean", '\u3211');
            RegisterPair("rieulcirclekorean", '\u3263');
            RegisterPair("rieulhieuhkorean", '\u3140');
            RegisterPair("rieulkiyeokkorean", '\u313A');
            RegisterPair("rieulkiyeoksioskorean", '\u3169');
            RegisterPair("rieulkorean", '\u3139');
            RegisterPair("rieulmieumkorean", '\u313B');
            RegisterPair("rieulpansioskorean", '\u316C');
            RegisterPair("rieulparenkorean", '\u3203');
            RegisterPair("rieulphieuphkorean", '\u313F');
            RegisterPair("rieulpieupkorean", '\u313C');
            RegisterPair("rieulpieupsioskorean", '\u316B');
            RegisterPair("rieulsioskorean", '\u313D');
            RegisterPair("rieulthieuthkorean", '\u313E');
            RegisterPair("rieultikeutkorean", '\u316A');
            RegisterPair("rieulyeorinhieuhkorean", '\u316D');
            RegisterPair("rightangle", '\u221F');
            RegisterPair("righttackbelowcmb", '\u0319');
            RegisterPair("righttriangle", '\u22BF');
            RegisterPair("rihiragana", '\u308A');
            RegisterPair("rikatakana", '\u30EA');
            RegisterPair("rikatakanahalfwidth", '\uFF98');
            RegisterPair("ring", '\u02DA');
            RegisterPair("ringbelowcmb", '\u0325');
            RegisterPair("ringcmb", '\u030A');
            RegisterPair("ringhalfleft", '\u02BF');
            RegisterPair("ringhalfleftarmenian", '\u0559');
            RegisterPair("ringhalfleftbelowcmb", '\u031C');
            RegisterPair("ringhalfleftcentered", '\u02D3');
            RegisterPair("ringhalfright", '\u02BE');
            RegisterPair("ringhalfrightbelowcmb", '\u0339');
            RegisterPair("ringhalfrightcentered", '\u02D2');
            RegisterPair("rinvertedbreve", '\u0213');
            RegisterPair("rittorusquare", '\u3351');
            RegisterPair("rlinebelow", '\u1E5F');
            RegisterPair("rlongleg", '\u027C');
            RegisterPair("rlonglegturned", '\u027A');
            RegisterPair("rmonospace", '\uFF52');
            RegisterPair("rohiragana", '\u308D');
            RegisterPair("rokatakana", '\u30ED');
            RegisterPair("rokatakanahalfwidth", '\uFF9B');
            RegisterPair("roruathai", '\u0E23');
            RegisterPair("rparen", '\u24AD');
            RegisterPair("rrabengali", '\u09DC');
            RegisterPair("rradeva", '\u0931');
            RegisterPair("rragurmukhi", '\u0A5C');
            RegisterPair("rreharabic", '\u0691');
            RegisterPair("rrehfinalarabic", '\uFB8D');
            RegisterPair("rrvocalicbengali", '\u09E0');
            RegisterPair("rrvocalicdeva", '\u0960');
            RegisterPair("rrvocalicgujarati", '\u0AE0');
            RegisterPair("rrvocalicvowelsignbengali", '\u09C4');
            RegisterPair("rrvocalicvowelsigndeva", '\u0944');
            RegisterPair("rrvocalicvowelsigngujarati", '\u0AC4');
            RegisterPair("rsuperior", '\uF6F1');
            RegisterPair("rtblock", '\u2590');
            RegisterPair("rturned", '\u0279');
            RegisterPair("rturnedsuperior", '\u02B4');
            RegisterPair("ruhiragana", '\u308B');
            RegisterPair("rukatakana", '\u30EB');
            RegisterPair("rukatakanahalfwidth", '\uFF99');
            RegisterPair("rupeemarkbengali", '\u09F2');
            RegisterPair("rupeesignbengali", '\u09F3');
            RegisterPair("rupiah", '\uF6DD');
            RegisterPair("ruthai", '\u0E24');
            RegisterPair("rvocalicbengali", '\u098B');
            RegisterPair("rvocalicdeva", '\u090B');
            RegisterPair("rvocalicgujarati", '\u0A8B');
            RegisterPair("rvocalicvowelsignbengali", '\u09C3');
            RegisterPair("rvocalicvowelsigndeva", '\u0943');
            RegisterPair("rvocalicvowelsigngujarati", '\u0AC3');
            RegisterPair("s", '\u0073');
            RegisterPair("sabengali", '\u09B8');
            RegisterPair("sacute", '\u015B');
            RegisterPair("sacutedotaccent", '\u1E65');
            RegisterPair("sadarabic", '\u0635');
            RegisterPair("sadeva", '\u0938');
            RegisterPair("sadfinalarabic", '\uFEBA');
            RegisterPair("sadinitialarabic", '\uFEBB');
            RegisterPair("sadmedialarabic", '\uFEBC');
            RegisterPair("sagujarati", '\u0AB8');
            RegisterPair("sagurmukhi", '\u0A38');
            RegisterPair("sahiragana", '\u3055');
            RegisterPair("sakatakana", '\u30B5');
            RegisterPair("sakatakanahalfwidth", '\uFF7B');
            RegisterPair("sallallahoualayhewasallamarabic", '\uFDFA');
            RegisterPair("samekh", '\u05E1');
            RegisterPair("samekhdagesh", '\uFB41');
            RegisterPair("samekhdageshhebrew", '\uFB41');
            RegisterPair("samekhhebrew", '\u05E1');
            RegisterPair("saraaathai", '\u0E32');
            RegisterPair("saraaethai", '\u0E41');
            RegisterPair("saraaimaimalaithai", '\u0E44');
            RegisterPair("saraaimaimuanthai", '\u0E43');
            RegisterPair("saraamthai", '\u0E33');
            RegisterPair("saraathai", '\u0E30');
            RegisterPair("saraethai", '\u0E40');
            RegisterPair("saraiileftthai", '\uF886');
            RegisterPair("saraiithai", '\u0E35');
            RegisterPair("saraileftthai", '\uF885');
            RegisterPair("saraithai", '\u0E34');
            RegisterPair("saraothai", '\u0E42');
            RegisterPair("saraueeleftthai", '\uF888');
            RegisterPair("saraueethai", '\u0E37');
            RegisterPair("saraueleftthai", '\uF887');
            RegisterPair("sarauethai", '\u0E36');
            RegisterPair("sarauthai", '\u0E38');
            RegisterPair("sarauuthai", '\u0E39');
            RegisterPair("sbopomofo", '\u3119');
            RegisterPair("scaron", '\u0161');
            RegisterPair("scarondotaccent", '\u1E67');
            RegisterPair("scedilla", '\u015F');
            RegisterPair("schwa", '\u0259');
            RegisterPair("schwacyrillic", '\u04D9');
            RegisterPair("schwadieresiscyrillic", '\u04DB');
            RegisterPair("schwahook", '\u025A');
            RegisterPair("scircle", '\u24E2');
            RegisterPair("scircumflex", '\u015D');
            RegisterPair("scommaaccent", '\u0219');
            RegisterPair("sdotaccent", '\u1E61');
            RegisterPair("sdotbelow", '\u1E63');
            RegisterPair("sdotbelowdotaccent", '\u1E69');
            RegisterPair("seagullbelowcmb", '\u033C');
            RegisterPair("second", '\u2033');
            RegisterPair("secondtonechinese", '\u02CA');
            RegisterPair("section", '\u00A7');
            RegisterPair("seenarabic", '\u0633');
            RegisterPair("seenfinalarabic", '\uFEB2');
            RegisterPair("seeninitialarabic", '\uFEB3');
            RegisterPair("seenmedialarabic", '\uFEB4');
            RegisterPair("segol", '\u05B6');
            RegisterPair("segol13", '\u05B6');
            RegisterPair("segol1f", '\u05B6');
            RegisterPair("segol2c", '\u05B6');
            RegisterPair("segolhebrew", '\u05B6');
            RegisterPair("segolnarrowhebrew", '\u05B6');
            RegisterPair("segolquarterhebrew", '\u05B6');
            RegisterPair("segoltahebrew", '\u0592');
            RegisterPair("segolwidehebrew", '\u05B6');
            RegisterPair("seharmenian", '\u057D');
            RegisterPair("sehiragana", '\u305B');
            RegisterPair("sekatakana", '\u30BB');
            RegisterPair("sekatakanahalfwidth", '\uFF7E');
            RegisterPair("semicolon", '\u003B');
            RegisterPair("semicolonarabic", '\u061B');
            RegisterPair("semicolonmonospace", '\uFF1B');
            RegisterPair("semicolonsmall", '\uFE54');
            RegisterPair("semivoicedmarkkana", '\u309C');
            RegisterPair("semivoicedmarkkanahalfwidth", '\uFF9F');
            RegisterPair("sentisquare", '\u3322');
            RegisterPair("sentosquare", '\u3323');
            RegisterPair("seven", '\u0037');
            RegisterPair("sevenarabic", '\u0667');
            RegisterPair("sevenbengali", '\u09ED');
            RegisterPair("sevencircle", '\u2466');
            RegisterPair("sevencircleinversesansserif", '\u2790');
            RegisterPair("sevendeva", '\u096D');
            RegisterPair("seveneighths", '\u215E');
            RegisterPair("sevengujarati", '\u0AED');
            RegisterPair("sevengurmukhi", '\u0A6D');
            RegisterPair("sevenhackarabic", '\u0667');
            RegisterPair("sevenhangzhou", '\u3027');
            RegisterPair("sevenideographicparen", '\u3226');
            RegisterPair("seveninferior", '\u2087');
            RegisterPair("sevenmonospace", '\uFF17');
            RegisterPair("sevenoldstyle", '\uF737');
            RegisterPair("sevenparen", '\u247A');
            RegisterPair("sevenperiod", '\u248E');
            RegisterPair("sevenpersian", '\u06F7');
            RegisterPair("sevenroman", '\u2176');
            RegisterPair("sevensuperior", '\u2077');
            RegisterPair("seventeencircle", '\u2470');
            RegisterPair("seventeenparen", '\u2484');
            RegisterPair("seventeenperiod", '\u2498');
            RegisterPair("seventhai", '\u0E57');
            RegisterPair("sfthyphen", '\u00AD');
            RegisterPair("shaarmenian", '\u0577');
            RegisterPair("shabengali", '\u09B6');
            RegisterPair("shacyrillic", '\u0448');
            RegisterPair("shaddaarabic", '\u0651');
            RegisterPair("shaddadammaarabic", '\uFC61');
            RegisterPair("shaddadammatanarabic", '\uFC5E');
            RegisterPair("shaddafathaarabic", '\uFC60');
            //RegisterPair("shaddafathatanarabic", '\u0651\u064B');
            RegisterPair("shaddakasraarabic", '\uFC62');
            RegisterPair("shaddakasratanarabic", '\uFC5F');
            RegisterPair("shade", '\u2592');
            RegisterPair("shadedark", '\u2593');
            RegisterPair("shadelight", '\u2591');
            RegisterPair("shademedium", '\u2592');
            RegisterPair("shadeva", '\u0936');
            RegisterPair("shagujarati", '\u0AB6');
            RegisterPair("shagurmukhi", '\u0A36');
            RegisterPair("shalshelethebrew", '\u0593');
            RegisterPair("shbopomofo", '\u3115');
            RegisterPair("shchacyrillic", '\u0449');
            RegisterPair("sheenarabic", '\u0634');
            RegisterPair("sheenfinalarabic", '\uFEB6');
            RegisterPair("sheeninitialarabic", '\uFEB7');
            RegisterPair("sheenmedialarabic", '\uFEB8');
            RegisterPair("sheicoptic", '\u03E3');
            RegisterPair("sheqel", '\u20AA');
            RegisterPair("sheqelhebrew", '\u20AA');
            RegisterPair("sheva", '\u05B0');
            RegisterPair("sheva115", '\u05B0');
            RegisterPair("sheva15", '\u05B0');
            RegisterPair("sheva22", '\u05B0');
            RegisterPair("sheva2e", '\u05B0');
            RegisterPair("shevahebrew", '\u05B0');
            RegisterPair("shevanarrowhebrew", '\u05B0');
            RegisterPair("shevaquarterhebrew", '\u05B0');
            RegisterPair("shevawidehebrew", '\u05B0');
            RegisterPair("shhacyrillic", '\u04BB');
            RegisterPair("shimacoptic", '\u03ED');
            RegisterPair("shin", '\u05E9');
            RegisterPair("shindagesh", '\uFB49');
            RegisterPair("shindageshhebrew", '\uFB49');
            RegisterPair("shindageshshindot", '\uFB2C');
            RegisterPair("shindageshshindothebrew", '\uFB2C');
            RegisterPair("shindageshsindot", '\uFB2D');
            RegisterPair("shindageshsindothebrew", '\uFB2D');
            RegisterPair("shindothebrew", '\u05C1');
            RegisterPair("shinhebrew", '\u05E9');
            RegisterPair("shinshindot", '\uFB2A');
            RegisterPair("shinshindothebrew", '\uFB2A');
            RegisterPair("shinsindot", '\uFB2B');
            RegisterPair("shinsindothebrew", '\uFB2B');
            RegisterPair("shook", '\u0282');
            RegisterPair("sigma", '\u03C3');
            RegisterPair("sigma1", '\u03C2');
            RegisterPair("sigmafinal", '\u03C2');
            RegisterPair("sigmalunatesymbolgreek", '\u03F2');
            RegisterPair("sihiragana", '\u3057');
            RegisterPair("sikatakana", '\u30B7');
            RegisterPair("sikatakanahalfwidth", '\uFF7C');
            RegisterPair("siluqhebrew", '\u05BD');
            RegisterPair("siluqlefthebrew", '\u05BD');
            RegisterPair("similar", '\u223C');
            RegisterPair("sindothebrew", '\u05C2');
            RegisterPair("siosacirclekorean", '\u3274');
            RegisterPair("siosaparenkorean", '\u3214');
            RegisterPair("sioscieuckorean", '\u317E');
            RegisterPair("sioscirclekorean", '\u3266');
            RegisterPair("sioskiyeokkorean", '\u317A');
            RegisterPair("sioskorean", '\u3145');
            RegisterPair("siosnieunkorean", '\u317B');
            RegisterPair("siosparenkorean", '\u3206');
            RegisterPair("siospieupkorean", '\u317D');
            RegisterPair("siostikeutkorean", '\u317C');
            RegisterPair("six", '\u0036');
            RegisterPair("sixarabic", '\u0666');
            RegisterPair("sixbengali", '\u09EC');
            RegisterPair("sixcircle", '\u2465');
            RegisterPair("sixcircleinversesansserif", '\u278F');
            RegisterPair("sixdeva", '\u096C');
            RegisterPair("sixgujarati", '\u0AEC');
            RegisterPair("sixgurmukhi", '\u0A6C');
            RegisterPair("sixhackarabic", '\u0666');
            RegisterPair("sixhangzhou", '\u3026');
            RegisterPair("sixideographicparen", '\u3225');
            RegisterPair("sixinferior", '\u2086');
            RegisterPair("sixmonospace", '\uFF16');
            RegisterPair("sixoldstyle", '\uF736');
            RegisterPair("sixparen", '\u2479');
            RegisterPair("sixperiod", '\u248D');
            RegisterPair("sixpersian", '\u06F6');
            RegisterPair("sixroman", '\u2175');
            RegisterPair("sixsuperior", '\u2076');
            RegisterPair("sixteencircle", '\u246F');
            RegisterPair("sixteencurrencydenominatorbengali", '\u09F9');
            RegisterPair("sixteenparen", '\u2483');
            RegisterPair("sixteenperiod", '\u2497');
            RegisterPair("sixthai", '\u0E56');
            RegisterPair("slash", '\u002F');
            RegisterPair("slashmonospace", '\uFF0F');
            RegisterPair("slong", '\u017F');
            RegisterPair("slongdotaccent", '\u1E9B');
            RegisterPair("smileface", '\u263A');
            RegisterPair("smonospace", '\uFF53');
            RegisterPair("sofpasuqhebrew", '\u05C3');
            RegisterPair("softhyphen", '\u00AD');
            RegisterPair("softsigncyrillic", '\u044C');
            RegisterPair("sohiragana", '\u305D');
            RegisterPair("sokatakana", '\u30BD');
            RegisterPair("sokatakanahalfwidth", '\uFF7F');
            RegisterPair("soliduslongoverlaycmb", '\u0338');
            RegisterPair("solidusshortoverlaycmb", '\u0337');
            RegisterPair("sorusithai", '\u0E29');
            RegisterPair("sosalathai", '\u0E28');
            RegisterPair("sosothai", '\u0E0B');
            RegisterPair("sosuathai", '\u0E2A');
            RegisterPair("space", '\u0020');
            RegisterPair("spade", '\u2660');
            RegisterPair("spadesuitblack", '\u2660');
            RegisterPair("spadesuitwhite", '\u2664');
            RegisterPair("sparen", '\u24AE');
            RegisterPair("squarebelowcmb", '\u033B');
            RegisterPair("squarecc", '\u33C4');
            RegisterPair("squarecm", '\u339D');
            RegisterPair("squarediagonalcrosshatchfill", '\u25A9');
            RegisterPair("squarehorizontalfill", '\u25A4');
            RegisterPair("squarekg", '\u338F');
            RegisterPair("squarekm", '\u339E');
            RegisterPair("squarekmcapital", '\u33CE');
            RegisterPair("squareln", '\u33D1');
            RegisterPair("squarelog", '\u33D2');
            RegisterPair("squaremg", '\u338E');
            RegisterPair("squaremil", '\u33D5');
            RegisterPair("squaremm", '\u339C');
            RegisterPair("squaremsquared", '\u33A1');
            RegisterPair("squareorthogonalcrosshatchfill", '\u25A6');
            RegisterPair("squareupperlefttolowerrightfill", '\u25A7');
            RegisterPair("squareupperrighttolowerleftfill", '\u25A8');
            RegisterPair("squareverticalfill", '\u25A5');
            RegisterPair("squarewhitewithsmallblack", '\u25A3');
            RegisterPair("srsquare", '\u33DB');
            RegisterPair("ssabengali", '\u09B7');
            RegisterPair("ssadeva", '\u0937');
            RegisterPair("ssagujarati", '\u0AB7');
            RegisterPair("ssangcieuckorean", '\u3149');
            RegisterPair("ssanghieuhkorean", '\u3185');
            RegisterPair("ssangieungkorean", '\u3180');
            RegisterPair("ssangkiyeokkorean", '\u3132');
            RegisterPair("ssangnieunkorean", '\u3165');
            RegisterPair("ssangpieupkorean", '\u3143');
            RegisterPair("ssangsioskorean", '\u3146');
            RegisterPair("ssangtikeutkorean", '\u3138');
            RegisterPair("ssuperior", '\uF6F2');
            RegisterPair("sterling", '\u00A3');
            RegisterPair("sterlingmonospace", '\uFFE1');
            RegisterPair("strokelongoverlaycmb", '\u0336');
            RegisterPair("strokeshortoverlaycmb", '\u0335');
            RegisterPair("subset", '\u2282');
            RegisterPair("subsetnotequal", '\u228A');
            RegisterPair("subsetorequal", '\u2286');
            RegisterPair("succeeds", '\u227B');
            RegisterPair("suchthat", '\u220B');
            RegisterPair("suhiragana", '\u3059');
            RegisterPair("sukatakana", '\u30B9');
            RegisterPair("sukatakanahalfwidth", '\uFF7D');
            RegisterPair("sukunarabic", '\u0652');
            RegisterPair("summation", '\u2211');
            RegisterPair("sun", '\u263C');
            RegisterPair("superset", '\u2283');
            RegisterPair("supersetnotequal", '\u228B');
            RegisterPair("supersetorequal", '\u2287');
            RegisterPair("svsquare", '\u33DC');
            RegisterPair("syouwaerasquare", '\u337C');
            RegisterPair("t", '\u0074');
            RegisterPair("tabengali", '\u09A4');
            RegisterPair("tackdown", '\u22A4');
            RegisterPair("tackleft", '\u22A3');
            RegisterPair("tadeva", '\u0924');
            RegisterPair("tagujarati", '\u0AA4');
            RegisterPair("tagurmukhi", '\u0A24');
            RegisterPair("taharabic", '\u0637');
            RegisterPair("tahfinalarabic", '\uFEC2');
            RegisterPair("tahinitialarabic", '\uFEC3');
            RegisterPair("tahiragana", '\u305F');
            RegisterPair("tahmedialarabic", '\uFEC4');
            RegisterPair("taisyouerasquare", '\u337D');
            RegisterPair("takatakana", '\u30BF');
            RegisterPair("takatakanahalfwidth", '\uFF80');
            RegisterPair("tatweelarabic", '\u0640');
            RegisterPair("tau", '\u03C4');
            RegisterPair("tav", '\u05EA');
            RegisterPair("tavdages", '\uFB4A');
            RegisterPair("tavdagesh", '\uFB4A');
            RegisterPair("tavdageshhebrew", '\uFB4A');
            RegisterPair("tavhebrew", '\u05EA');
            RegisterPair("tbar", '\u0167');
            RegisterPair("tbopomofo", '\u310A');
            RegisterPair("tcaron", '\u0165');
            RegisterPair("tccurl", '\u02A8');
            RegisterPair("tcedilla", '\u0163');
            RegisterPair("tcheharabic", '\u0686');
            RegisterPair("tchehfinalarabic", '\uFB7B');
            RegisterPair("tchehinitialarabic", '\uFB7C');
            RegisterPair("tchehmedialarabic", '\uFB7D');
            //RegisterPair("tchehmeeminitialarabic", '\uFB7C\uFEE4');
            RegisterPair("tcircle", '\u24E3');
            RegisterPair("tcircumflexbelow", '\u1E71');
            RegisterPair("tcommaaccent", '\u0163');
            RegisterPair("tdieresis", '\u1E97');
            RegisterPair("tdotaccent", '\u1E6B');
            RegisterPair("tdotbelow", '\u1E6D');
            RegisterPair("tecyrillic", '\u0442');
            RegisterPair("tedescendercyrillic", '\u04AD');
            RegisterPair("teharabic", '\u062A');
            RegisterPair("tehfinalarabic", '\uFE96');
            RegisterPair("tehhahinitialarabic", '\uFCA2');
            RegisterPair("tehhahisolatedarabic", '\uFC0C');
            RegisterPair("tehinitialarabic", '\uFE97');
            RegisterPair("tehiragana", '\u3066');
            RegisterPair("tehjeeminitialarabic", '\uFCA1');
            RegisterPair("tehjeemisolatedarabic", '\uFC0B');
            RegisterPair("tehmarbutaarabic", '\u0629');
            RegisterPair("tehmarbutafinalarabic", '\uFE94');
            RegisterPair("tehmedialarabic", '\uFE98');
            RegisterPair("tehmeeminitialarabic", '\uFCA4');
            RegisterPair("tehmeemisolatedarabic", '\uFC0E');
            RegisterPair("tehnoonfinalarabic", '\uFC73');
            RegisterPair("tekatakana", '\u30C6');
            RegisterPair("tekatakanahalfwidth", '\uFF83');
            RegisterPair("telephone", '\u2121');
            RegisterPair("telephoneblack", '\u260E');
            RegisterPair("telishagedolahebrew", '\u05A0');
            RegisterPair("telishaqetanahebrew", '\u05A9');
            RegisterPair("tencircle", '\u2469');
            RegisterPair("tenideographicparen", '\u3229');
            RegisterPair("tenparen", '\u247D');
            RegisterPair("tenperiod", '\u2491');
            RegisterPair("tenroman", '\u2179');
            RegisterPair("tesh", '\u02A7');
            RegisterPair("tet", '\u05D8');
            RegisterPair("tetdagesh", '\uFB38');
            RegisterPair("tetdageshhebrew", '\uFB38');
            RegisterPair("tethebrew", '\u05D8');
            RegisterPair("tetsecyrillic", '\u04B5');
            RegisterPair("tevirhebrew", '\u059B');
            RegisterPair("tevirlefthebrew", '\u059B');
            RegisterPair("thabengali", '\u09A5');
            RegisterPair("thadeva", '\u0925');
            RegisterPair("thagujarati", '\u0AA5');
            RegisterPair("thagurmukhi", '\u0A25');
            RegisterPair("thalarabic", '\u0630');
            RegisterPair("thalfinalarabic", '\uFEAC');
            RegisterPair("thanthakhatlowleftthai", '\uF898');
            RegisterPair("thanthakhatlowrightthai", '\uF897');
            RegisterPair("thanthakhatthai", '\u0E4C');
            RegisterPair("thanthakhatupperleftthai", '\uF896');
            RegisterPair("theharabic", '\u062B');
            RegisterPair("thehfinalarabic", '\uFE9A');
            RegisterPair("thehinitialarabic", '\uFE9B');
            RegisterPair("thehmedialarabic", '\uFE9C');
            RegisterPair("thereexists", '\u2203');
            RegisterPair("therefore", '\u2234');
            RegisterPair("theta", '\u03B8');
            RegisterPair("theta1", '\u03D1');
            RegisterPair("thetasymbolgreek", '\u03D1');
            RegisterPair("thieuthacirclekorean", '\u3279');
            RegisterPair("thieuthaparenkorean", '\u3219');
            RegisterPair("thieuthcirclekorean", '\u326B');
            RegisterPair("thieuthkorean", '\u314C');
            RegisterPair("thieuthparenkorean", '\u320B');
            RegisterPair("thirteencircle", '\u246C');
            RegisterPair("thirteenparen", '\u2480');
            RegisterPair("thirteenperiod", '\u2494');
            RegisterPair("thonangmonthothai", '\u0E11');
            RegisterPair("thook", '\u01AD');
            RegisterPair("thophuthaothai", '\u0E12');
            RegisterPair("thorn", '\u00FE');
            RegisterPair("thothahanthai", '\u0E17');
            RegisterPair("thothanthai", '\u0E10');
            RegisterPair("thothongthai", '\u0E18');
            RegisterPair("thothungthai", '\u0E16');
            RegisterPair("thousandcyrillic", '\u0482');
            RegisterPair("thousandsseparatorarabic", '\u066C');
            RegisterPair("thousandsseparatorpersian", '\u066C');
            RegisterPair("three", '\u0033');
            RegisterPair("threearabic", '\u0663');
            RegisterPair("threebengali", '\u09E9');
            RegisterPair("threecircle", '\u2462');
            RegisterPair("threecircleinversesansserif", '\u278C');
            RegisterPair("threedeva", '\u0969');
            RegisterPair("threeeighths", '\u215C');
            RegisterPair("threegujarati", '\u0AE9');
            RegisterPair("threegurmukhi", '\u0A69');
            RegisterPair("threehackarabic", '\u0663');
            RegisterPair("threehangzhou", '\u3023');
            RegisterPair("threeideographicparen", '\u3222');
            RegisterPair("threeinferior", '\u2083');
            RegisterPair("threemonospace", '\uFF13');
            RegisterPair("threenumeratorbengali", '\u09F6');
            RegisterPair("threeoldstyle", '\uF733');
            RegisterPair("threeparen", '\u2476');
            RegisterPair("threeperiod", '\u248A');
            RegisterPair("threepersian", '\u06F3');
            RegisterPair("threequarters", '\u00BE');
            RegisterPair("threequartersemdash", '\uF6DE');
            RegisterPair("threeroman", '\u2172');
            RegisterPair("threesuperior", '\u00B3');
            RegisterPair("threethai", '\u0E53');
            RegisterPair("thzsquare", '\u3394');
            RegisterPair("tihiragana", '\u3061');
            RegisterPair("tikatakana", '\u30C1');
            RegisterPair("tikatakanahalfwidth", '\uFF81');
            RegisterPair("tikeutacirclekorean", '\u3270');
            RegisterPair("tikeutaparenkorean", '\u3210');
            RegisterPair("tikeutcirclekorean", '\u3262');
            RegisterPair("tikeutkorean", '\u3137');
            RegisterPair("tikeutparenkorean", '\u3202');
            RegisterPair("tilde", '\u02DC');
            RegisterPair("tildebelowcmb", '\u0330');
            RegisterPair("tildecmb", '\u0303');
            RegisterPair("tildecomb", '\u0303');
            RegisterPair("tildedoublecmb", '\u0360');
            RegisterPair("tildeoperator", '\u223C');
            RegisterPair("tildeoverlaycmb", '\u0334');
            RegisterPair("tildeverticalcmb", '\u033E');
            RegisterPair("timescircle", '\u2297');
            RegisterPair("tipehahebrew", '\u0596');
            RegisterPair("tipehalefthebrew", '\u0596');
            RegisterPair("tippigurmukhi", '\u0A70');
            RegisterPair("titlocyrilliccmb", '\u0483');
            RegisterPair("tiwnarmenian", '\u057F');
            RegisterPair("tlinebelow", '\u1E6F');
            RegisterPair("tmonospace", '\uFF54');
            RegisterPair("toarmenian", '\u0569');
            RegisterPair("tohiragana", '\u3068');
            RegisterPair("tokatakana", '\u30C8');
            RegisterPair("tokatakanahalfwidth", '\uFF84');
            RegisterPair("tonebarextrahighmod", '\u02E5');
            RegisterPair("tonebarextralowmod", '\u02E9');
            RegisterPair("tonebarhighmod", '\u02E6');
            RegisterPair("tonebarlowmod", '\u02E8');
            RegisterPair("tonebarmidmod", '\u02E7');
            RegisterPair("tonefive", '\u01BD');
            RegisterPair("tonesix", '\u0185');
            RegisterPair("tonetwo", '\u01A8');
            RegisterPair("tonos", '\u0384');
            RegisterPair("tonsquare", '\u3327');
            RegisterPair("topatakthai", '\u0E0F');
            RegisterPair("tortoiseshellbracketleft", '\u3014');
            RegisterPair("tortoiseshellbracketleftsmall", '\uFE5D');
            RegisterPair("tortoiseshellbracketleftvertical", '\uFE39');
            RegisterPair("tortoiseshellbracketright", '\u3015');
            RegisterPair("tortoiseshellbracketrightsmall", '\uFE5E');
            RegisterPair("tortoiseshellbracketrightvertical", '\uFE3A');
            RegisterPair("totaothai", '\u0E15');
            RegisterPair("tpalatalhook", '\u01AB');
            RegisterPair("tparen", '\u24AF');
            RegisterPair("trademark", '\u2122');
            RegisterPair("trademarksans", '\uF8EA');
            RegisterPair("trademarkserif", '\uF6DB');
            RegisterPair("tretroflexhook", '\u0288');
            RegisterPair("triagdn", '\u25BC');
            RegisterPair("triaglf", '\u25C4');
            RegisterPair("triagrt", '\u25BA');
            RegisterPair("triagup", '\u25B2');
            RegisterPair("ts", '\u02A6');
            RegisterPair("tsadi", '\u05E6');
            RegisterPair("tsadidagesh", '\uFB46');
            RegisterPair("tsadidageshhebrew", '\uFB46');
            RegisterPair("tsadihebrew", '\u05E6');
            RegisterPair("tsecyrillic", '\u0446');
            RegisterPair("tsere", '\u05B5');
            RegisterPair("tsere12", '\u05B5');
            RegisterPair("tsere1e", '\u05B5');
            RegisterPair("tsere2b", '\u05B5');
            RegisterPair("tserehebrew", '\u05B5');
            RegisterPair("tserenarrowhebrew", '\u05B5');
            RegisterPair("tserequarterhebrew", '\u05B5');
            RegisterPair("tserewidehebrew", '\u05B5');
            RegisterPair("tshecyrillic", '\u045B');
            RegisterPair("tsuperior", '\uF6F3');
            RegisterPair("ttabengali", '\u099F');
            RegisterPair("ttadeva", '\u091F');
            RegisterPair("ttagujarati", '\u0A9F');
            RegisterPair("ttagurmukhi", '\u0A1F');
            RegisterPair("tteharabic", '\u0679');
            RegisterPair("ttehfinalarabic", '\uFB67');
            RegisterPair("ttehinitialarabic", '\uFB68');
            RegisterPair("ttehmedialarabic", '\uFB69');
            RegisterPair("tthabengali", '\u09A0');
            RegisterPair("tthadeva", '\u0920');
            RegisterPair("tthagujarati", '\u0AA0');
            RegisterPair("tthagurmukhi", '\u0A20');
            RegisterPair("tturned", '\u0287');
            RegisterPair("tuhiragana", '\u3064');
            RegisterPair("tukatakana", '\u30C4');
            RegisterPair("tukatakanahalfwidth", '\uFF82');
            RegisterPair("tusmallhiragana", '\u3063');
            RegisterPair("tusmallkatakana", '\u30C3');
            RegisterPair("tusmallkatakanahalfwidth", '\uFF6F');
            RegisterPair("twelvecircle", '\u246B');
            RegisterPair("twelveparen", '\u247F');
            RegisterPair("twelveperiod", '\u2493');
            RegisterPair("twelveroman", '\u217B');
            RegisterPair("twentycircle", '\u2473');
            RegisterPair("twentyhangzhou", '\u5344');
            RegisterPair("twentyparen", '\u2487');
            RegisterPair("twentyperiod", '\u249B');
            RegisterPair("two", '\u0032');
            RegisterPair("twoarabic", '\u0662');
            RegisterPair("twobengali", '\u09E8');
            RegisterPair("twocircle", '\u2461');
            RegisterPair("twocircleinversesansserif", '\u278B');
            RegisterPair("twodeva", '\u0968');
            RegisterPair("twodotenleader", '\u2025');
            RegisterPair("twodotleader", '\u2025');
            RegisterPair("twodotleadervertical", '\uFE30');
            RegisterPair("twogujarati", '\u0AE8');
            RegisterPair("twogurmukhi", '\u0A68');
            RegisterPair("twohackarabic", '\u0662');
            RegisterPair("twohangzhou", '\u3022');
            RegisterPair("twoideographicparen", '\u3221');
            RegisterPair("twoinferior", '\u2082');
            RegisterPair("twomonospace", '\uFF12');
            RegisterPair("twonumeratorbengali", '\u09F5');
            RegisterPair("twooldstyle", '\uF732');
            RegisterPair("twoparen", '\u2475');
            RegisterPair("twoperiod", '\u2489');
            RegisterPair("twopersian", '\u06F2');
            RegisterPair("tworoman", '\u2171');
            RegisterPair("twostroke", '\u01BB');
            RegisterPair("twosuperior", '\u00B2');
            RegisterPair("twothai", '\u0E52');
            RegisterPair("twothirds", '\u2154');
            RegisterPair("u", '\u0075');
            RegisterPair("uacute", '\u00FA');
            RegisterPair("ubar", '\u0289');
            RegisterPair("ubengali", '\u0989');
            RegisterPair("ubopomofo", '\u3128');
            RegisterPair("ubreve", '\u016D');
            RegisterPair("ucaron", '\u01D4');
            RegisterPair("ucircle", '\u24E4');
            RegisterPair("ucircumflex", '\u00FB');
            RegisterPair("ucircumflexbelow", '\u1E77');
            RegisterPair("ucyrillic", '\u0443');
            RegisterPair("udattadeva", '\u0951');
            RegisterPair("udblacute", '\u0171');
            RegisterPair("udblgrave", '\u0215');
            RegisterPair("udeva", '\u0909');
            RegisterPair("udieresis", '\u00FC');
            RegisterPair("udieresisacute", '\u01D8');
            RegisterPair("udieresisbelow", '\u1E73');
            RegisterPair("udieresiscaron", '\u01DA');
            RegisterPair("udieresiscyrillic", '\u04F1');
            RegisterPair("udieresisgrave", '\u01DC');
            RegisterPair("udieresismacron", '\u01D6');
            RegisterPair("udotbelow", '\u1EE5');
            RegisterPair("ugrave", '\u00F9');
            RegisterPair("ugujarati", '\u0A89');
            RegisterPair("ugurmukhi", '\u0A09');
            RegisterPair("uhiragana", '\u3046');
            RegisterPair("uhookabove", '\u1EE7');
            RegisterPair("uhorn", '\u01B0');
            RegisterPair("uhornacute", '\u1EE9');
            RegisterPair("uhorndotbelow", '\u1EF1');
            RegisterPair("uhorngrave", '\u1EEB');
            RegisterPair("uhornhookabove", '\u1EED');
            RegisterPair("uhorntilde", '\u1EEF');
            RegisterPair("uhungarumlaut", '\u0171');
            RegisterPair("uhungarumlautcyrillic", '\u04F3');
            RegisterPair("uinvertedbreve", '\u0217');
            RegisterPair("ukatakana", '\u30A6');
            RegisterPair("ukatakanahalfwidth", '\uFF73');
            RegisterPair("ukcyrillic", '\u0479');
            RegisterPair("ukorean", '\u315C');
            RegisterPair("umacron", '\u016B');
            RegisterPair("umacroncyrillic", '\u04EF');
            RegisterPair("umacrondieresis", '\u1E7B');
            RegisterPair("umatragurmukhi", '\u0A41');
            RegisterPair("umonospace", '\uFF55');
            RegisterPair("underscore", '\u005F');
            RegisterPair("underscoredbl", '\u2017');
            RegisterPair("underscoremonospace", '\uFF3F');
            RegisterPair("underscorevertical", '\uFE33');
            RegisterPair("underscorewavy", '\uFE4F');
            RegisterPair("union", '\u222A');
            RegisterPair("universal", '\u2200');
            RegisterPair("uogonek", '\u0173');
            RegisterPair("uparen", '\u24B0');
            RegisterPair("upblock", '\u2580');
            RegisterPair("upperdothebrew", '\u05C4');
            RegisterPair("upsilon", '\u03C5');
            RegisterPair("upsilondieresis", '\u03CB');
            RegisterPair("upsilondieresistonos", '\u03B0');
            RegisterPair("upsilonlatin", '\u028A');
            RegisterPair("upsilontonos", '\u03CD');
            RegisterPair("uptackbelowcmb", '\u031D');
            RegisterPair("uptackmod", '\u02D4');
            RegisterPair("uragurmukhi", '\u0A73');
            RegisterPair("uring", '\u016F');
            RegisterPair("ushortcyrillic", '\u045E');
            RegisterPair("usmallhiragana", '\u3045');
            RegisterPair("usmallkatakana", '\u30A5');
            RegisterPair("usmallkatakanahalfwidth", '\uFF69');
            RegisterPair("ustraightcyrillic", '\u04AF');
            RegisterPair("ustraightstrokecyrillic", '\u04B1');
            RegisterPair("utilde", '\u0169');
            RegisterPair("utildeacute", '\u1E79');
            RegisterPair("utildebelow", '\u1E75');
            RegisterPair("uubengali", '\u098A');
            RegisterPair("uudeva", '\u090A');
            RegisterPair("uugujarati", '\u0A8A');
            RegisterPair("uugurmukhi", '\u0A0A');
            RegisterPair("uumatragurmukhi", '\u0A42');
            RegisterPair("uuvowelsignbengali", '\u09C2');
            RegisterPair("uuvowelsigndeva", '\u0942');
            RegisterPair("uuvowelsigngujarati", '\u0AC2');
            RegisterPair("uvowelsignbengali", '\u09C1');
            RegisterPair("uvowelsigndeva", '\u0941');
            RegisterPair("uvowelsigngujarati", '\u0AC1');
            RegisterPair("v", '\u0076');
            RegisterPair("vadeva", '\u0935');
            RegisterPair("vagujarati", '\u0AB5');
            RegisterPair("vagurmukhi", '\u0A35');
            RegisterPair("vakatakana", '\u30F7');
            RegisterPair("vav", '\u05D5');
            RegisterPair("vavdagesh", '\uFB35');
            RegisterPair("vavdagesh65", '\uFB35');
            RegisterPair("vavdageshhebrew", '\uFB35');
            RegisterPair("vavhebrew", '\u05D5');
            RegisterPair("vavholam", '\uFB4B');
            RegisterPair("vavholamhebrew", '\uFB4B');
            RegisterPair("vavvavhebrew", '\u05F0');
            RegisterPair("vavyodhebrew", '\u05F1');
            RegisterPair("vcircle", '\u24E5');
            RegisterPair("vdotbelow", '\u1E7F');
            RegisterPair("vecyrillic", '\u0432');
            RegisterPair("veharabic", '\u06A4');
            RegisterPair("vehfinalarabic", '\uFB6B');
            RegisterPair("vehinitialarabic", '\uFB6C');
            RegisterPair("vehmedialarabic", '\uFB6D');
            RegisterPair("vekatakana", '\u30F9');
            RegisterPair("venus", '\u2640');
            RegisterPair("verticalbar", '\u007C');
            RegisterPair("verticallineabovecmb", '\u030D');
            RegisterPair("verticallinebelowcmb", '\u0329');
            RegisterPair("verticallinelowmod", '\u02CC');
            RegisterPair("verticallinemod", '\u02C8');
            RegisterPair("vewarmenian", '\u057E');
            RegisterPair("vhook", '\u028B');
            RegisterPair("vikatakana", '\u30F8');
            RegisterPair("viramabengali", '\u09CD');
            RegisterPair("viramadeva", '\u094D');
            RegisterPair("viramagujarati", '\u0ACD');
            RegisterPair("visargabengali", '\u0983');
            RegisterPair("visargadeva", '\u0903');
            RegisterPair("visargagujarati", '\u0A83');
            RegisterPair("vmonospace", '\uFF56');
            RegisterPair("voarmenian", '\u0578');
            RegisterPair("voicediterationhiragana", '\u309E');
            RegisterPair("voicediterationkatakana", '\u30FE');
            RegisterPair("voicedmarkkana", '\u309B');
            RegisterPair("voicedmarkkanahalfwidth", '\uFF9E');
            RegisterPair("vokatakana", '\u30FA');
            RegisterPair("vparen", '\u24B1');
            RegisterPair("vtilde", '\u1E7D');
            RegisterPair("vturned", '\u028C');
            RegisterPair("vuhiragana", '\u3094');
            RegisterPair("vukatakana", '\u30F4');
            RegisterPair("w", '\u0077');
            RegisterPair("wacute", '\u1E83');
            RegisterPair("waekorean", '\u3159');
            RegisterPair("wahiragana", '\u308F');
            RegisterPair("wakatakana", '\u30EF');
            RegisterPair("wakatakanahalfwidth", '\uFF9C');
            RegisterPair("wakorean", '\u3158');
            RegisterPair("wasmallhiragana", '\u308E');
            RegisterPair("wasmallkatakana", '\u30EE');
            RegisterPair("wattosquare", '\u3357');
            RegisterPair("wavedash", '\u301C');
            RegisterPair("wavyunderscorevertical", '\uFE34');
            RegisterPair("wawarabic", '\u0648');
            RegisterPair("wawfinalarabic", '\uFEEE');
            RegisterPair("wawhamzaabovearabic", '\u0624');
            RegisterPair("wawhamzaabovefinalarabic", '\uFE86');
            RegisterPair("wbsquare", '\u33DD');
            RegisterPair("wcircle", '\u24E6');
            RegisterPair("wcircumflex", '\u0175');
            RegisterPair("wdieresis", '\u1E85');
            RegisterPair("wdotaccent", '\u1E87');
            RegisterPair("wdotbelow", '\u1E89');
            RegisterPair("wehiragana", '\u3091');
            RegisterPair("weierstrass", '\u2118');
            RegisterPair("wekatakana", '\u30F1');
            RegisterPair("wekorean", '\u315E');
            RegisterPair("weokorean", '\u315D');
            RegisterPair("wgrave", '\u1E81');
            RegisterPair("whitebullet", '\u25E6');
            RegisterPair("whitecircle", '\u25CB');
            RegisterPair("whitecircleinverse", '\u25D9');
            RegisterPair("whitecornerbracketleft", '\u300E');
            RegisterPair("whitecornerbracketleftvertical", '\uFE43');
            RegisterPair("whitecornerbracketright", '\u300F');
            RegisterPair("whitecornerbracketrightvertical", '\uFE44');
            RegisterPair("whitediamond", '\u25C7');
            RegisterPair("whitediamondcontainingblacksmalldiamond", '\u25C8');
            RegisterPair("whitedownpointingsmalltriangle", '\u25BF');
            RegisterPair("whitedownpointingtriangle", '\u25BD');
            RegisterPair("whiteleftpointingsmalltriangle", '\u25C3');
            RegisterPair("whiteleftpointingtriangle", '\u25C1');
            RegisterPair("whitelenticularbracketleft", '\u3016');
            RegisterPair("whitelenticularbracketright", '\u3017');
            RegisterPair("whiterightpointingsmalltriangle", '\u25B9');
            RegisterPair("whiterightpointingtriangle", '\u25B7');
            RegisterPair("whitesmallsquare", '\u25AB');
            RegisterPair("whitesmilingface", '\u263A');
            RegisterPair("whitesquare", '\u25A1');
            RegisterPair("whitestar", '\u2606');
            RegisterPair("whitetelephone", '\u260F');
            RegisterPair("whitetortoiseshellbracketleft", '\u3018');
            RegisterPair("whitetortoiseshellbracketright", '\u3019');
            RegisterPair("whiteuppointingsmalltriangle", '\u25B5');
            RegisterPair("whiteuppointingtriangle", '\u25B3');
            RegisterPair("wihiragana", '\u3090');
            RegisterPair("wikatakana", '\u30F0');
            RegisterPair("wikorean", '\u315F');
            RegisterPair("wmonospace", '\uFF57');
            RegisterPair("wohiragana", '\u3092');
            RegisterPair("wokatakana", '\u30F2');
            RegisterPair("wokatakanahalfwidth", '\uFF66');
            RegisterPair("won", '\u20A9');
            RegisterPair("wonmonospace", '\uFFE6');
            RegisterPair("wowaenthai", '\u0E27');
            RegisterPair("wparen", '\u24B2');
            RegisterPair("wring", '\u1E98');
            RegisterPair("wsuperior", '\u02B7');
            RegisterPair("wturned", '\u028D');
            RegisterPair("wynn", '\u01BF');
            RegisterPair("x", '\u0078');
            RegisterPair("xabovecmb", '\u033D');
            RegisterPair("xbopomofo", '\u3112');
            RegisterPair("xcircle", '\u24E7');
            RegisterPair("xdieresis", '\u1E8D');
            RegisterPair("xdotaccent", '\u1E8B');
            RegisterPair("xeharmenian", '\u056D');
            RegisterPair("xi", '\u03BE');
            RegisterPair("xmonospace", '\uFF58');
            RegisterPair("xparen", '\u24B3');
            RegisterPair("xsuperior", '\u02E3');
            RegisterPair("y", '\u0079');
            RegisterPair("yaadosquare", '\u334E');
            RegisterPair("yabengali", '\u09AF');
            RegisterPair("yacute", '\u00FD');
            RegisterPair("yadeva", '\u092F');
            RegisterPair("yaekorean", '\u3152');
            RegisterPair("yagujarati", '\u0AAF');
            RegisterPair("yagurmukhi", '\u0A2F');
            RegisterPair("yahiragana", '\u3084');
            RegisterPair("yakatakana", '\u30E4');
            RegisterPair("yakatakanahalfwidth", '\uFF94');
            RegisterPair("yakorean", '\u3151');
            RegisterPair("yamakkanthai", '\u0E4E');
            RegisterPair("yasmallhiragana", '\u3083');
            RegisterPair("yasmallkatakana", '\u30E3');
            RegisterPair("yasmallkatakanahalfwidth", '\uFF6C');
            RegisterPair("yatcyrillic", '\u0463');
            RegisterPair("ycircle", '\u24E8');
            RegisterPair("ycircumflex", '\u0177');
            RegisterPair("ydieresis", '\u00FF');
            RegisterPair("ydotaccent", '\u1E8F');
            RegisterPair("ydotbelow", '\u1EF5');
            RegisterPair("yeharabic", '\u064A');
            RegisterPair("yehbarreearabic", '\u06D2');
            RegisterPair("yehbarreefinalarabic", '\uFBAF');
            RegisterPair("yehfinalarabic", '\uFEF2');
            RegisterPair("yehhamzaabovearabic", '\u0626');
            RegisterPair("yehhamzaabovefinalarabic", '\uFE8A');
            RegisterPair("yehhamzaaboveinitialarabic", '\uFE8B');
            RegisterPair("yehhamzaabovemedialarabic", '\uFE8C');
            RegisterPair("yehinitialarabic", '\uFEF3');
            RegisterPair("yehmedialarabic", '\uFEF4');
            RegisterPair("yehmeeminitialarabic", '\uFCDD');
            RegisterPair("yehmeemisolatedarabic", '\uFC58');
            RegisterPair("yehnoonfinalarabic", '\uFC94');
            RegisterPair("yehthreedotsbelowarabic", '\u06D1');
            RegisterPair("yekorean", '\u3156');
            RegisterPair("yen", '\u00A5');
            RegisterPair("yenmonospace", '\uFFE5');
            RegisterPair("yeokorean", '\u3155');
            RegisterPair("yeorinhieuhkorean", '\u3186');
            RegisterPair("yerahbenyomohebrew", '\u05AA');
            RegisterPair("yerahbenyomolefthebrew", '\u05AA');
            RegisterPair("yericyrillic", '\u044B');
            RegisterPair("yerudieresiscyrillic", '\u04F9');
            RegisterPair("yesieungkorean", '\u3181');
            RegisterPair("yesieungpansioskorean", '\u3183');
            RegisterPair("yesieungsioskorean", '\u3182');
            RegisterPair("yetivhebrew", '\u059A');
            RegisterPair("ygrave", '\u1EF3');
            RegisterPair("yhook", '\u01B4');
            RegisterPair("yhookabove", '\u1EF7');
            RegisterPair("yiarmenian", '\u0575');
            RegisterPair("yicyrillic", '\u0457');
            RegisterPair("yikorean", '\u3162');
            RegisterPair("yinyang", '\u262F');
            RegisterPair("yiwnarmenian", '\u0582');
            RegisterPair("ymonospace", '\uFF59');
            RegisterPair("yod", '\u05D9');
            RegisterPair("yoddagesh", '\uFB39');
            RegisterPair("yoddageshhebrew", '\uFB39');
            RegisterPair("yodhebrew", '\u05D9');
            RegisterPair("yodyodhebrew", '\u05F2');
            RegisterPair("yodyodpatahhebrew", '\uFB1F');
            RegisterPair("yohiragana", '\u3088');
            RegisterPair("yoikorean", '\u3189');
            RegisterPair("yokatakana", '\u30E8');
            RegisterPair("yokatakanahalfwidth", '\uFF96');
            RegisterPair("yokorean", '\u315B');
            RegisterPair("yosmallhiragana", '\u3087');
            RegisterPair("yosmallkatakana", '\u30E7');
            RegisterPair("yosmallkatakanahalfwidth", '\uFF6E');
            RegisterPair("yotgreek", '\u03F3');
            RegisterPair("yoyaekorean", '\u3188');
            RegisterPair("yoyakorean", '\u3187');
            RegisterPair("yoyakthai", '\u0E22');
            RegisterPair("yoyingthai", '\u0E0D');
            RegisterPair("yparen", '\u24B4');
            RegisterPair("ypogegrammeni", '\u037A');
            RegisterPair("ypogegrammenigreekcmb", '\u0345');
            RegisterPair("yr", '\u01A6');
            RegisterPair("yring", '\u1E99');
            RegisterPair("ysuperior", '\u02B8');
            RegisterPair("ytilde", '\u1EF9');
            RegisterPair("yturned", '\u028E');
            RegisterPair("yuhiragana", '\u3086');
            RegisterPair("yuikorean", '\u318C');
            RegisterPair("yukatakana", '\u30E6');
            RegisterPair("yukatakanahalfwidth", '\uFF95');
            RegisterPair("yukorean", '\u3160');
            RegisterPair("yusbigcyrillic", '\u046B');
            RegisterPair("yusbigiotifiedcyrillic", '\u046D');
            RegisterPair("yuslittlecyrillic", '\u0467');
            RegisterPair("yuslittleiotifiedcyrillic", '\u0469');
            RegisterPair("yusmallhiragana", '\u3085');
            RegisterPair("yusmallkatakana", '\u30E5');
            RegisterPair("yusmallkatakanahalfwidth", '\uFF6D');
            RegisterPair("yuyekorean", '\u318B');
            RegisterPair("yuyeokorean", '\u318A');
            RegisterPair("yyabengali", '\u09DF');
            RegisterPair("yyadeva", '\u095F');
            RegisterPair("z", '\u007A');
            RegisterPair("zaarmenian", '\u0566');
            RegisterPair("zacute", '\u017A');
            RegisterPair("zadeva", '\u095B');
            RegisterPair("zagurmukhi", '\u0A5B');
            RegisterPair("zaharabic", '\u0638');
            RegisterPair("zahfinalarabic", '\uFEC6');
            RegisterPair("zahinitialarabic", '\uFEC7');
            RegisterPair("zahiragana", '\u3056');
            RegisterPair("zahmedialarabic", '\uFEC8');
            RegisterPair("zainarabic", '\u0632');
            RegisterPair("zainfinalarabic", '\uFEB0');
            RegisterPair("zakatakana", '\u30B6');
            RegisterPair("zaqefgadolhebrew", '\u0595');
            RegisterPair("zaqefqatanhebrew", '\u0594');
            RegisterPair("zarqahebrew", '\u0598');
            RegisterPair("zayin", '\u05D6');
            RegisterPair("zayindagesh", '\uFB36');
            RegisterPair("zayindageshhebrew", '\uFB36');
            RegisterPair("zayinhebrew", '\u05D6');
            RegisterPair("zbopomofo", '\u3117');
            RegisterPair("zcaron", '\u017E');
            RegisterPair("zcircle", '\u24E9');
            RegisterPair("zcircumflex", '\u1E91');
            RegisterPair("zcurl", '\u0291');
            RegisterPair("zdot", '\u017C');
            RegisterPair("zdotaccent", '\u017C');
            RegisterPair("zdotbelow", '\u1E93');
            RegisterPair("zecyrillic", '\u0437');
            RegisterPair("zedescendercyrillic", '\u0499');
            RegisterPair("zedieresiscyrillic", '\u04DF');
            RegisterPair("zehiragana", '\u305C');
            RegisterPair("zekatakana", '\u30BC');
            RegisterPair("zero", '\u0030');
            RegisterPair("zeroarabic", '\u0660');
            RegisterPair("zerobengali", '\u09E6');
            RegisterPair("zerodeva", '\u0966');
            RegisterPair("zerogujarati", '\u0AE6');
            RegisterPair("zerogurmukhi", '\u0A66');
            RegisterPair("zerohackarabic", '\u0660');
            RegisterPair("zeroinferior", '\u2080');
            RegisterPair("zeromonospace", '\uFF10');
            RegisterPair("zerooldstyle", '\uF730');
            RegisterPair("zeropersian", '\u06F0');
            RegisterPair("zerosuperior", '\u2070');
            RegisterPair("zerothai", '\u0E50');
            RegisterPair("zerowidthjoiner", '\uFEFF');
            RegisterPair("zerowidthnonjoiner", '\u200C');
            RegisterPair("zerowidthspace", '\u200B');
            RegisterPair("zeta", '\u03B6');
            RegisterPair("zhbopomofo", '\u3113');
            RegisterPair("zhearmenian", '\u056A');
            RegisterPair("zhebrevecyrillic", '\u04C2');
            RegisterPair("zhecyrillic", '\u0436');
            RegisterPair("zhedescendercyrillic", '\u0497');
            RegisterPair("zhedieresiscyrillic", '\u04DD');
            RegisterPair("zihiragana", '\u3058');
            RegisterPair("zikatakana", '\u30B8');
            RegisterPair("zinorhebrew", '\u05AE');
            RegisterPair("zlinebelow", '\u1E95');
            RegisterPair("zmonospace", '\uFF5A');
            RegisterPair("zohiragana", '\u305E');
            RegisterPair("zokatakana", '\u30BE');
            RegisterPair("zparen", '\u24B5');
            RegisterPair("zretroflexhook", '\u0290');
            RegisterPair("zstroke", '\u01B6');
            RegisterPair("zuhiragana", '\u305A');
            RegisterPair("zukatakana", '\u30BA');
        }

        public static string GetName(char ch)
        {
            if (mapper.ContainsToValue(ch))
            {
                return mapper.GetFromValue(ch);
            }

            return PostScriptConstants.NotDef;
        }

        public static bool IsSupportedPdfName(string name)
        {
            return mapper.ContainsFromValue(name);
        }

        //To map a glyph name to a character string:
        //Step 1: drop all the characters from the glyph name starting with the first occurrence of a period (U+002E FULL STOP), if any.
        //Step 2: split the remaining string into a sequence of components, using underscore (U+005F LOW LINE) as the delimiter.
        //Step 3: map each component to a character string according to the procedure below, and concatenate those strings; the result is the character string to which the glyph name is mapped.
        //if the font is Zapf Dingbats (PostScript FontName ZapfDingbats), and the component is in the ZapfDingbats list, then map it to the corresponding character in that list.
        //otherwise, if the component is in the Adobe Glyph List, then map it to the corresponding character in that list.
        //otherwise, if the component is of the form "uni" (U+0075 U+006E U+0069) followed by a sequence of uppercase hexadecimal digits (0 .. 9, A .. F, i.e. U+0030 .. U+0039, U+0041 .. U+0046), the length of that sequence is a multiple of four, and each group of four digits represents a number in the set {0x0000 .. 0xD7FF, 0xE000 .. 0xFFFF}, then interpret each such number as a Unicode scalar value and map the component to the string made of those scalar values. Note that the range and digit length restrictions mean that the "uni" prefix can be used only with Unicode values from the Basic Multilingual Plane (BMP).
        //otherwise, if the component is of the form "u" (U+0075) followed by a sequence of four to six uppercase hexadecimal digits {0 .. 9, A .. F} (U+0030 .. U+0039, U+0041 .. U+0046), and those digits represent a number in {0x0000 .. 0xD7FF, 0xE000 .. 0x10FFFF}, then interpret this number as a Unicode scalar value and map the component to the string made of this scalar value.
        //otherwise, map the component to the empty string
        public static char GetUnicode(string names)
        {
            if (names == null)
            {
                return Characters.NotDef;
            }
            int ind = names.IndexOf('.');
            if (ind > 0)
            {
                names = names.Substring(0, ind);
            }
            string[] n = names.Split('_');
            if (n.Length > 0)
            {
                return GetUnicodeForName(n[0]);
            }
            return Characters.NotDef;
        }

        private static char ParseHex(string hex)
        {
            int c;
            try
            {
                c = int.Parse(hex, System.Globalization.NumberStyles.HexNumber);
                return (char)c;
            }
            catch
            {
                return Characters.NotDef;
            }
        }

        private static char GetUnicodeForName(string name)
        {
            if (mapper.ContainsFromValue(name))
            {
                return mapper.GetToValue(name);
            }

            if (name.StartsWith("uni"))
            {
                int ind = 0;
                name = name.Substring(3);
                if (ind + 4 <= name.Length)
                {
                    return ParseHex(name.Substring(ind, 4));
                }
                return Characters.NotDef;
            }
            else if (name.StartsWith("u"))
            {
                return ParseHex(name.Substring(1, name.Length - 1));
            }
            throw new System.ArgumentException("The encoding is not supported.");
        }

        private static void RegisterPair(string name, char ch)
        {
            mapper.AddPair(name, ch);
        }
    }
}
